#ifndef __DATA_ENTRY_H__
#define __DATA_ENTRY_H__

#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include "gtkinput.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define DATA_ENTRY(obj)          GTK_CHECK_CAST (obj, data_entry_get_type (), DataEntry)
#define DATA_ENTRY_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, data_entry_get_type (), DataEntryClass)
#define GTK_IS_DATA_ENTRY(obj)       GTK_CHECK_TYPE (obj, data_entry_get_type ())


typedef struct _DataEntry       DataEntry;
typedef struct _DataEntryClass  DataEntryClass;

struct _DataEntry
{
  GtkWindow window;

  GtkWidget *main_box;
  GtkWidget *top_box;
  GtkWidget *separator;
  GtkWidget *btn_box;

  GtkWidget *quit_btn;

  int	num_fields, num_buttons, current_focus;
  int   table_spacing;
};

struct _DataEntryClass
{
  GtkWindowClass parent_class;
};

#define BUTTON_NORMAL  0
#define BUTTON_DEFAULT 1
#define BUTTON_QUIT    2
#define BUTTON_TOGGLE  4

guint      data_entry_get_type       (void);
GtkWidget* data_entry_new            (gchar *name, guint x, guint y, guint h, guint w);
GtkWidget* data_entry_add_button (DataEntry *data_entry, gint id, GtkWidget *button, GtkSignalFunc func, 
				gint flag);
GtkWidget* data_entry_add_label_button (DataEntry *data_entry, gint id, gchar *button, GtkSignalFunc func, 
				gint flag);
GtkWidget* data_entry_add_field (DataEntry *data_entry, gint id, gchar *label, guint length, gint flags,
			guint x, guint y, guint spanx, guint spany);
GtkWidget* data_entry_add_widget (DataEntry *data_entry, gint id, GtkWidget *widget,
			guint x, guint y, guint spanx, guint spany);
GtkPixmap* data_entry_add_image (DataEntry *data_entry, gint id, char *filename,
			guint x, guint y, guint spanx, guint spany);
GtkWidget* data_entry_add_radio_hbox (DataEntry *data_entry, gint id, 
			guint x, guint y, guint spanx, guint spany);
GtkWidget* data_entry_add_radio_vbox (DataEntry *data_entry, gint id, 
			guint x, guint y, guint spanx, guint spany);
GtkWidget* data_entry_add_to_radio (DataEntry *data_entry, GtkWidget *radio_box, 
			gchar *user_data, gchar *label);

gchar* data_entry_get_radio_value (DataEntry *data_entry, gint id);
void data_entry_set_radio_value (DataEntry *data_entry, gint id, gchar *new_value);

gpointer data_entry_get_widget (DataEntry *data_entry, gint id);

gint	data_entry_get_widget_id (DataEntry *data_entry, GtkWidget *widget);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __DATAENTRY_H__ */
