#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "data_entry.h"
#include <unistd.h>
#include <libpq-fe.h>
#include <gdk/gdkkeysyms.h>
#include "pizza_utils.h"

DataEntry *maint_item_data_entry = NULL;

/*----------------------------------------------------------------------------------------------------
::item_maintenance functions
----------------------------------------------------------------------------------------------------*/

/*----
	<search cats>
	<search name>

	[list of items      ]

	<cat> [code]
	[desc]
	[price]    <changeable>  <print qty>

	<ins> <delete> <update> <quit>

-----*/

enum {
	MAINT_ITEM_SEARCH_CAT,
	MAINT_ITEM_SEARCH_ITEM,
	MAINT_ITEM_SEARCH_BTN,
	MAINT_ITEM_LIST,
	MAINT_ITEM_CAT,
	MAINT_ITEM_CODE,
	MAINT_ITEM_DESC,
	MAINT_ITEM_PRICE,
	MAINT_ITEM_CHANGE_PRICE,
	MAINT_ITEM_PRINT_QTY,

	MAINT_ITEM_INS_BTN,
	MAINT_ITEM_DEL_BTN,
	MAINT_ITEM_MOD_BTN,
	MAINT_ITEM_QUIT_BTN
};

static void item_list_populate (DataEntry *, GtkCList *item_list);

// focus in on the code field - set default btn to update
static void maint_item_code_focus_in (GtkWidget *widget, GdkEventFocus *event, gpointer data)
{
	DataEntry *data_entry;

	data_entry = (DataEntry *) data;

	gtk_widget_grab_default (data_entry_get_widget (data_entry, MAINT_ITEM_MOD_BTN));
}

// focus in on the search item field - set default btn to search
static void maint_item_search_focus_in (GtkWidget *widget, GdkEventFocus *event, gpointer data)
{
	DataEntry *data_entry;

	data_entry = (DataEntry *) data;

	gtk_widget_grab_default (data_entry_get_widget (data_entry, MAINT_ITEM_SEARCH_BTN));
}

// focus in on the search cat field - set default btn to search, and do a search
static void maint_item_search_cat_toggled (GtkToggleButton *widget, gpointer data)
{
	DataEntry *data_entry;

	data_entry = (DataEntry *) data;

	gtk_widget_grab_default (data_entry_get_widget (data_entry, MAINT_ITEM_SEARCH_BTN));
	if (widget->active)
		item_list_populate (data_entry, data_entry_get_widget (data_entry, MAINT_ITEM_LIST));
}

static void maint_item_callback (GtkWidget *widget, gpointer data)
{
	DataEntry *data_entry;
	GtkInput *code, *desc, *price, *search_item;
	GtkToggleButton *change_price, *print_qty;
	GtkToggleButton *insert_btn;
	GtkCList *item_list;
	int btn_num;
	char command[255];

	data_entry = (DataEntry *) data;
	btn_num = data_entry_get_widget_id (data_entry, widget);

	item_list = GTK_CLIST(data_entry_get_widget (data_entry, MAINT_ITEM_LIST));
	code = GTK_INPUT(data_entry_get_widget (data_entry, MAINT_ITEM_CODE));
	desc = GTK_INPUT(data_entry_get_widget (data_entry, MAINT_ITEM_DESC));
	price = GTK_INPUT(data_entry_get_widget (data_entry, MAINT_ITEM_PRICE));
	change_price = GTK_TOGGLE_BUTTON(data_entry_get_widget (data_entry, MAINT_ITEM_CHANGE_PRICE));
	print_qty = GTK_TOGGLE_BUTTON(data_entry_get_widget (data_entry, MAINT_ITEM_PRINT_QTY));
	insert_btn = GTK_TOGGLE_BUTTON(data_entry_get_widget (data_entry, MAINT_ITEM_INS_BTN));

	switch (btn_num)
	{
		case MAINT_ITEM_SEARCH_BTN:
			search_item = GTK_INPUT(data_entry_get_widget (data_entry, MAINT_ITEM_SEARCH_ITEM));
			gtk_input_set_text (code, "");
			gtk_input_set_text (desc, "");
			gtk_input_set_text (price, "");
			gtk_toggle_button_set_state (change_price, FALSE);
			gtk_toggle_button_set_state (print_qty, FALSE);
			gtk_widget_grab_focus (GTK_WIDGET(search_item));
			gtk_toggle_button_set_state (insert_btn, FALSE);
			item_list_populate (data_entry, item_list);

			//printf ("search cat = %s\n", data_entry_get_radio_value (data_entry, MAINT_ITEM_SEARCH_CAT));
			break;
			
		case MAINT_ITEM_MOD_BTN:
			if (insert_btn->active)
			{
				sprintf (command, "insert into items values ('%s','%s','%s',%f,'%c','%c')",
					data_entry_get_radio_value (data_entry, MAINT_ITEM_CAT),
					gtk_input_get_text (code),
					gtk_input_get_text (desc),
					atof(gtk_input_get_text (price)),
					(change_price->active) ? 't' : 'f',
					(print_qty->active) ? 't' : 'f');
			}
			else // modify
			{
				sprintf (command, "update items set category = '%s', code = '%s', description = '%s',"
						"price = %f,change_price = '%c',print_qty = '%c' where code = '%s'",
					data_entry_get_radio_value (data_entry, MAINT_ITEM_CAT),
					gtk_input_get_text (code),
					gtk_input_get_text (desc),
					atof(gtk_input_get_text (price)),
					(change_price->active) ? 't' : 'f',
					(print_qty->active) ? 't' : 'f',
					(char *) gtk_object_get_user_data (GTK_OBJECT(code)));

			}
			printf ("Command = '%s'\n", command);
			res = PQexec (conn, command);
			PQclear (res);
			gtk_input_set_text (code, "");
			gtk_input_set_text (desc, "");
			gtk_input_set_text (price, "");
			gtk_toggle_button_set_state (change_price, FALSE);
			gtk_toggle_button_set_state (print_qty, FALSE);
			gtk_widget_grab_focus (GTK_WIDGET(item_list));
			gtk_toggle_button_set_state (insert_btn, FALSE);
			item_list_populate (data_entry, item_list);
			break;

		case MAINT_ITEM_INS_BTN:
			gtk_widget_grab_focus (GTK_WIDGET(code));
			break;

		case MAINT_ITEM_DEL_BTN:
			// delete the selected record
			sprintf (command, "delete from items where code = '%s'", 
				gtk_input_get_text (code));
			//printf ("Command = '%s'\n", command);
			res = PQexec (conn, command);
			PQclear (res);
			item_list_populate (data_entry, item_list);
			gtk_input_set_text (code, "");
			gtk_input_set_text (desc, "");
			gtk_input_set_text (price, "");
			gtk_toggle_button_set_state (change_price, FALSE);
			gtk_toggle_button_set_state (print_qty, FALSE);
			gtk_widget_grab_focus (GTK_WIDGET(item_list));
			gtk_toggle_button_set_state (insert_btn, FALSE);
			break;

		case MAINT_ITEM_QUIT_BTN:
			gtk_widget_hide (GTK_WIDGET(data_entry));
			break;
	}
}

static void item_list_populate (DataEntry *data_entry, GtkCList *item_list)
{
	int i, nTuples;
	char *item_list_row[4];
	char command[256];
	gchar *cat;
	gchar *pattern;
	GtkInput *search_pattern;

	gtk_clist_freeze (item_list);
	gtk_clist_clear (item_list);

		cat = data_entry_get_radio_value (data_entry, MAINT_ITEM_SEARCH_CAT);
		search_pattern = GTK_INPUT(data_entry_get_widget (data_entry, MAINT_ITEM_SEARCH_ITEM));
		pattern = gtk_input_get_text (search_pattern);
		if (*cat == ' ')
		{
			if (!strlen (pattern))
    			sprintf (command, "select category,code,description,price from items "
						"order by category,code");
			else
    			sprintf (command, "select category,code,description,price from items where "
						"(code like '%%%s%%' or upper(description) like '%%%s%%') "
						"order by category,code", pattern, pattern);
		}
		else
		{
			if (!strlen (pattern))
    			sprintf (command, "select category,code,description,price from items where "
						 "category = '%s' order by code", cat);
			else
    			sprintf (command, "select category,code,description,price from items where "
						"(code like '%%%s%%' or upper(description) like '%%%s%%') "
						"and category = '%s' order by code", pattern, pattern, cat);
		}

	//printf ("Command = '%s'\n", command);
    res = PQexec(conn, command);
    if (PQresultStatus(res) != PGRES_TUPLES_OK)
    {
        fprintf(stderr, "\nSelect didn't return tuples properly\n");
        PQclear(res);
        exit_nicely(conn);
    }

	nTuples = PQntuples (res);
	for (i = 0; i < nTuples; i++)
	{
		item_list_row[0] = PQgetvalue (res, i, 0);
		item_list_row[1] = PQgetvalue (res, i, 1);
		item_list_row[2] = PQgetvalue (res, i, 2);
		item_list_row[3] = PQgetvalue (res, i, 3);
		gtk_clist_append (GTK_CLIST(item_list), item_list_row);
	}
	gtk_clist_thaw (item_list);
	PQclear (res);
}

static void maint_item_list_select (GtkWidget *widget, gint row, gint col, GdkEventButton *event, gpointer data)
{
	DataEntry *data_entry;
	GtkInput *code, *desc, *price;
	GtkToggleButton *change_price, *print_qty;
	GtkToggleButton *insert_btn;
	gchar *text, *text1;
	char command[128];

	g_return_if_fail (widget);
	g_return_if_fail (data);
	data_entry = DATA_ENTRY (data);

	code = GTK_INPUT(data_entry_get_widget (data_entry, MAINT_ITEM_CODE));
	desc = GTK_INPUT(data_entry_get_widget (data_entry, MAINT_ITEM_DESC));
	price = GTK_INPUT(data_entry_get_widget (data_entry, MAINT_ITEM_PRICE));
	change_price = GTK_TOGGLE_BUTTON(data_entry_get_widget (data_entry, MAINT_ITEM_CHANGE_PRICE));
	print_qty = GTK_TOGGLE_BUTTON(data_entry_get_widget (data_entry, MAINT_ITEM_PRINT_QTY));
	insert_btn = GTK_TOGGLE_BUTTON(data_entry_get_widget (data_entry, MAINT_ITEM_INS_BTN));

	gtk_clist_get_text (GTK_CLIST(widget), row, 0, &text);
	//printf ("Setting cat to %s\n", text);
	data_entry_set_radio_value (data_entry, MAINT_ITEM_CAT, text);

	gtk_clist_get_text (GTK_CLIST(widget), row, 1, &text1);
	gtk_input_set_text (code, text1);
	gtk_object_set_user_data (GTK_OBJECT(code), text1);

	sprintf (command, "select description,price,change_price,print_qty from items where category = '%s' and code = '%s'", text, text1);

	res = PQexec (conn, command);
	gtk_input_set_text (desc, PQgetvalue (res, 0, 0));
	gtk_input_set_text (price, PQgetvalue (res, 0, 1));
	gtk_toggle_button_set_state (change_price, *(PQgetvalue (res, 0, 2)) == 't');
	gtk_toggle_button_set_state (print_qty, *(PQgetvalue (res, 0, 3)) == 't');

	PQclear (res);

	gtk_widget_grab_focus (GTK_WIDGET(code));

	gtk_toggle_button_set_state (insert_btn, FALSE);
}

void maint_items (GtkWidget *widget, gpointer data)
{
	DataEntry *data_entry;
	static GtkWidget *search_cat, *search_item, *search_btn;
	static GtkWidget *item_list, *cat, *code, *desc, *price;
	GtkWidget *radio_btn;
	GtkAcceleratorTable *accel;
	GtkWidget *delbtn;
	int nTuples,i;
	static char *titles[] = 
	{
		"Cat","Code","Description","Price"
	};

	if (!maint_item_data_entry)
	{
		maint_item_data_entry = DATA_ENTRY(data_entry_new ("Items", 10, 60, 0,0));
		data_entry = maint_item_data_entry;

		accel = gtk_accelerator_table_new ();
		gtk_window_add_accelerator_table (GTK_WINDOW(data_entry), accel);

		// create and populate the radiobutii from SQL database
		search_cat = data_entry_add_radio_hbox (data_entry, MAINT_ITEM_SEARCH_CAT, 0,0,10,1);
		radio_btn = data_entry_add_to_radio (data_entry, search_cat, " ", "All");
			gtk_signal_connect (GTK_OBJECT (radio_btn), "toggled", 
				(GtkSignalFunc) maint_item_search_cat_toggled, data_entry);

    	res = PQexec(conn, "select code,description from category");
		nTuples = PQntuples (res);
		for (i = 0; i < nTuples; i++)
		{
			radio_btn = data_entry_add_to_radio (data_entry, search_cat, 
				PQgetvalue(res, i, 0), PQgetvalue (res, i, 1));
			gtk_signal_connect (GTK_OBJECT (radio_btn), "toggled", 
				(GtkSignalFunc) maint_item_search_cat_toggled, data_entry);
		}
		PQclear (res);		// How cool is that little loop ?

		search_item = data_entry_add_field (data_entry, MAINT_ITEM_SEARCH_ITEM, "Item:",
			16, INPUT_UPPER, 1,1,1,1);
		gtk_signal_connect (GTK_OBJECT (search_item), "focus_in_event", 
			(GtkSignalFunc) maint_item_search_focus_in, data_entry);

		search_btn = gtk_button_new_with_label ("Search");
		GTK_WIDGET_SET_FLAGS (search_btn, GTK_CAN_DEFAULT);
		gtk_signal_connect (GTK_OBJECT(search_btn), "clicked",
				GTK_SIGNAL_FUNC(maint_item_callback), data_entry);

		data_entry_add_widget (data_entry, MAINT_ITEM_SEARCH_BTN, search_btn, 2,1,1,1);

		item_list = gtk_clist_new_with_titles (4, titles);
		gtk_clist_set_column_width (GTK_CLIST(item_list), 0, 50);
		gtk_clist_set_column_width (GTK_CLIST(item_list), 1, 150);
		gtk_clist_set_column_width (GTK_CLIST(item_list), 2, 350);
		gtk_clist_set_column_width (GTK_CLIST(item_list), 3, 150);
		gtk_widget_set_usize (GTK_WIDGET(item_list), 700, 200);
		gtk_signal_connect (GTK_OBJECT (item_list), "select_row", 
			(GtkSignalFunc) maint_item_list_select, data_entry);

		data_entry_add_widget (data_entry, MAINT_ITEM_LIST, item_list, 0,2,10,1);

		data_entry_add_label_button (data_entry, MAINT_ITEM_INS_BTN, "Insert", 
				GTK_SIGNAL_FUNC(maint_item_callback), BUTTON_NORMAL | BUTTON_TOGGLE);

		delbtn = data_entry_add_label_button (data_entry, MAINT_ITEM_DEL_BTN, "Delete", 
				GTK_SIGNAL_FUNC(maint_item_callback), BUTTON_NORMAL);
		gtk_accelerator_table_install (accel, GTK_OBJECT(delbtn), "clicked", '', 0);

		data_entry_add_label_button (data_entry, MAINT_ITEM_MOD_BTN, "Update", 
				GTK_SIGNAL_FUNC(maint_item_callback), BUTTON_DEFAULT);
		data_entry_add_label_button (data_entry, MAINT_ITEM_QUIT_BTN, "Quit", 
				GTK_SIGNAL_FUNC(maint_item_callback), BUTTON_QUIT);

		// now add the fields
		cat = data_entry_add_radio_hbox (data_entry, MAINT_ITEM_CAT, 0,12,10,1);

    	res = PQexec(conn, "select code,description from category");
		nTuples = PQntuples (res);
		for (i = 0; i < nTuples; i++)
		{
			data_entry_add_to_radio (data_entry, cat, 
				PQgetvalue(res, i, 0), PQgetvalue (res, i, 1));
		}
		PQclear (res);	

		code = data_entry_add_field (data_entry, MAINT_ITEM_CODE, "Code:", 
				8, INPUT_UPPER, 1,13,2,1);
		gtk_signal_connect (GTK_OBJECT (code), "focus_in_event", 
			(GtkSignalFunc) maint_item_code_focus_in, data_entry);

		desc = data_entry_add_field (data_entry, MAINT_ITEM_DESC, "Description:",
				48, INPUT_NORMAL, 1,14,5,1);
		price = data_entry_add_field (data_entry, MAINT_ITEM_PRICE, "Price:",
				48, INPUT_NORMAL, 1,15,1,1);
		data_entry_add_widget (data_entry, MAINT_ITEM_CHANGE_PRICE, 
				gtk_check_button_new_with_label ("Change Price ?"),
				2,15,1,1);
		data_entry_add_widget (data_entry, MAINT_ITEM_PRINT_QTY,
				gtk_check_button_new_with_label ("Print Qty ?"),
				3,15,1,1);

		gtk_widget_grab_focus (code);
	}

	if (!GTK_WIDGET_VISIBLE(maint_item_data_entry))
		gtk_widget_show (GTK_WIDGET(maint_item_data_entry));
	item_list_populate (maint_item_data_entry, GTK_CLIST(item_list));

}
