#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "data_entry.h"
#include <unistd.h>
#include <libpq-fe.h>
#include <gdk/gdkkeysyms.h>
#include "pizza_utils.h"
#include "select_screen.h"
#include "cust_details.h"

DataEntry *select_cust = NULL;

static GtkCList *cust_list;

/*----------------------------------------------------------------------------------------------------
::select cust screen
----------------------------------------------------------------------------------------------------*/
enum {
	SELECT_CUST_LIST,

	SELECT_CUST_QUIT_BTN
};

static void select_cust_populate (PGresult *cust_res)
{
	int i, nTuples;
	char *cust_list_row[6];

	gtk_clist_freeze (cust_list);
	gtk_clist_clear (cust_list);

	nTuples = PQntuples (res);
	for (i = 0; i < nTuples; i++)
	{
		cust_list_row[0] = PQgetvalue (res, i, 0);
		cust_list_row[1] = PQgetvalue (res, i, 1);
		cust_list_row[2] = PQgetvalue (res, i, 2);
		cust_list_row[3] = PQgetvalue (res, i, 3);
		cust_list_row[4] = PQgetvalue (res, i, 4);
		cust_list_row[5] = nice_date (PQgetvalue (res, i, 5));
		gtk_clist_append (GTK_CLIST(cust_list), cust_list_row);
	}
	gtk_clist_thaw (cust_list);

	// do NOT clear the result set here - twas passed in elsewhere !
}

static void select_cust_list_select (GtkWidget *widget, gint row, gint col, 
			GdkEventButton *event, gpointer data)
{
	gchar *text;
	int the_cust_id;

    gtk_clist_get_text (GTK_CLIST(widget), row, 0, &text);
	the_cust_id = atoi(text);

	printf ("call up customer maint with id %d\n", the_cust_id);

	do_cust_details (the_cust_id, NULL, NULL, FALSE);
	gtk_widget_hide (GTK_WIDGET(select_cust));
}

static void select_cust_quit_callback (GtkWidget *widget, gpointer data)
{
	gtk_widget_hide (GTK_WIDGET(select_cust));
	select_screen_redisplay ();
}

void do_select_cust (PGresult *cust_res)
{
	DataEntry *data_entry;
	GtkWidget *window;
	static char *titles[] =
	{
        "ID","Name","Address","Phone","Suburb","Last Date"
	};

	if (!select_cust)
	{
		data_entry = DATA_ENTRY(data_entry_new ("Select Customer", 20, 20, 0,0));
		window = (GtkWidget *) data_entry;
		gtk_widget_realize (window);

		data_entry_add_label_button (data_entry, SELECT_CUST_QUIT_BTN, "Quit", 
				GTK_SIGNAL_FUNC(select_cust_quit_callback), BUTTON_QUIT);

        cust_list = gtk_clist_new_with_titles (6, titles);
        // TODO - set the correct colun widths
        gtk_clist_set_column_width (GTK_CLIST(cust_list), 0, 40);
        gtk_clist_set_column_width (GTK_CLIST(cust_list), 1, 120);
        gtk_clist_set_column_width (GTK_CLIST(cust_list), 2, 150);
        gtk_clist_set_column_width (GTK_CLIST(cust_list), 3, 90);
        gtk_clist_set_column_width (GTK_CLIST(cust_list), 4, 110);
        gtk_clist_set_column_width (GTK_CLIST(cust_list), 5, 160);

        gtk_widget_set_usize (GTK_WIDGET(cust_list), 750, 400);
        gtk_signal_connect (GTK_OBJECT (cust_list), "select_row",
            (GtkSignalFunc) select_cust_list_select, data_entry);

        data_entry_add_widget (data_entry, SELECT_CUST_LIST, GTK_WIDGET(cust_list), 0,0,10,1);
  
		select_cust = data_entry;
	}

	if (!GTK_WIDGET_VISIBLE (select_cust))
		gtk_widget_show (GTK_WIDGET(select_cust));

	select_cust_populate (cust_res);
}
