\connect - postgres
CREATE TABLE stores (id int2, store_name text, address text, suburb text, postcode int4, phone text, manager text, modem text, update_hour int4, update_minute int4, is_branch bool, next_custnum int4, next_ordernum int4);
\connect - postgres
CREATE TABLE users (username text, passwd text, maint_menu bool, change_order bool, change_cust bool, training bool);
\connect - postgres
CREATE TABLE employee (emp_code text, emp_name text, address text, suburb text, phone text, comments text, rate float8, tax_num text);
\connect - postgres
CREATE TABLE emp_times (emp_code text, store_id int2, the_date date, start_time time, end_time time, hours int2, minutes int2, rate float8, pay float8, paid bool);
\connect - postgres
CREATE TABLE emp_pay (emp_code text, date_from date, date_to date, total_hours int2, total_mins int2, rate float8, bonus float8, tax float8, super float8, cash bool, cheque_num text);
\connect - postgres
CREATE TABLE customers (custnum int4, custname text, address text, phone text, suburb text, ubd text, comments text, lastorder_num int4, lastorder_date abstime, bad_cust bool, discount int4);
\connect - postgres
CREATE TABLE category (code char, description text, allow_discount bool);
\connect - postgres
CREATE TABLE items (category char, code text, description text, price float8, change_price bool, print_qty bool);
\connect - postgres
CREATE TABLE suburbs (suburb text, postcode int4, min_order float8, ubd text, store_id int2);
\connect - postgres
CREATE TABLE suburb_min (store_id int2, suburb text, min_order float8);
\connect - postgres
CREATE TABLE orders (ordernum int4, store_id int2, is_pickup bool, custnum int4, pickup_name text, pickup_time text, order_date abstime, total_price float8, comments text);
\connect - postgres
CREATE TABLE ordet (ordernum int4, seq_num int4, item_code text, description text, qty float8, price float8, store_id int2);
\connect - postgres
CREATE TABLE ordhist (ordernum int4, seq_num int4, store_id int2, date abstime, item_code text, description text, qty float8, price float8);
\connect - postgres
CREATE FUNCTION custname (orders ) RETURNS text AS 'select custname from customers where custnum = $1.custnum' LANGUAGE 'SQL';
\connect - postgres
CREATE FUNCTION phone (orders ) RETURNS text AS 'select phone from customers where custnum = $1.custnum' LANGUAGE 'SQL';
\connect - postgres
CREATE FUNCTION address (orders ) RETURNS text AS 'select address from customers where custnum = $1.custnum' LANGUAGE 'SQL';
\connect - postgres
CREATE FUNCTION suburb (orders ) RETURNS text AS 'select suburb from customers where custnum = $1.custnum' LANGUAGE 'SQL';
\connect - postgres
CREATE FUNCTION total_spent (customers ) RETURNS float8 AS 'select sum(ordet.price) from ordet, orders where ordet.ordernum = orders.ordernum and orders.custnum = $1.custnum' LANGUAGE 'SQL';
\connect - postgres
CREATE FUNCTION total_order_price (orders ) RETURNS float8 AS 'select sum(price) from ordet where ordernum = $1.ordernum' LANGUAGE 'SQL';
COPY stores FROM stdin;
2	Modbury Dial a Pizza	Main Street	MODBURY	5200	8223 2222	Jack	82231711	7	0	t	3000	1000
3	Modbury Dial a Pizza #2	12 Modbury Avenue	MODBURY	5200	8223 3333	Jack	82231711	7	0	t	3000	10000
4	Modbury Dial a Pizza #3	Modbury Avenue	MODBURY	5200	8223 4444	Jack	82231711	7	0	t	3000	1000
1	SanGiorgio Rundle St	Cnr Rundle St & Frome Rd	ADELAIDE	5000	8223 1700	George	82231701	7	0	f	1741	2679
\.
COPY users FROM stdin;
SG	sg	\N	\N	\N	\N
JACK SPRAT	1234	\N	\N	\N	\N
TRAIN	train 12	\N	\N	\N	\N
\.
COPY employee FROM stdin;
\.
COPY emp_times FROM stdin;
\.
COPY emp_pay FROM stdin;
\.
COPY customers FROM stdin;
1	PAXUS	122 frome rd	82235100		118		1	epoch	f	0
2	COLES	rundle mall	82231000		118		3	epoch	f	0
6		78 STURT STREET	82215020	ADELAIDE			2443	Wed Mar 04 22:17:40 1998 CST	f	0
7		6 EDDY ST	82626591		106		0	epoch	f	0
8		139 FROME STREET	0411257300		118		0	epoch	f	0
9		3/58 BRIDGE STREET	84315680		119		0	epoch	f	0
10		4 MARTINDALE AVE	84315750		118		10	epoch	f	0
11		37-17 RIVER STREET	0419826664		107		0	epoch	f	0
12		UNIT 7/47 PARK STREET	0412357851		118		0	epoch	f	0
13		71 EAST ST	83519915		118		0	epoch	f	0
14		13 ELLIOT ST	83373592	CAMPBELLTOWN		$ 2.00 DELIVERY FEE	2646	Sun Mar 08 00:36:47 1998 CST	f	0
15		12 FRANCIS ST WEST	82672709		118		0	epoch	f	0
16		65 MARY ST	82719287	UNLEY			1601	Tue Feb 17 21:40:42 1998 CST	f	0
17		18 TUCKER STREET	82235937	ADELAIDE			2428	Wed Mar 04 20:00:57 1998 CST	f	0
18		UNIT 1/6 PLYMOUTH AVENUE	83469423	DEVON PK	118	GO TO UNITS WITH 4 ROLLER DOORS IN THE FRONT	2640	Sat Mar 07 22:14:44 1998 CST	f	0
19		7/9 HAYWARD AVENUE	83523191	TORRENSVILLE			2581	Sat Mar 07 00:09:15 1998 CST	f	0
20		3 FARNCOMB ROAD	83538492		118		0	epoch	f	0
21	82235937	UNIT 1/15 VINCENT PLACE	82236686	ADELAIDE			2396	Tue Mar 03 23:12:43 1998 CST	f	0
22		147 MAGILL ROAD	83628664	STEPNEY		AMEX 376040620183006 EXIR 0199\
MUSHROOM SAUCE IS ALWAYS IN A SEPERATE CONTAINER \
AND THIS MAN IS VERY ANGRY AND HAS HAD IT IN THE \
SAME  CONTAINER AS THE CHICKEN FILLETS AT LEAST \
TEN TIMES---NOT IMPRESSED-- PLEASE ALWAYS PUT ON\
THE ORDER FORM MUSHROOM SAUCE IN SEPERATE CONTAINER\
--MANAGEMENT--	2334	Mon Mar 02 20:49:48 1998 CST	f	0
23		27 JOHN STREET	82723904		118		0	epoch	f	0
24		30 CARDWELL STREET	82232704	ADELAIDE	118		1804	Sat Feb 21 18:27:49 1998 CST	f	0
25		21 OLIVE STREET	82725163		118		0	epoch	f	0
26		72 CREMORNE STREET	82723137	MALVERN	118	ENTER EAST OFF OF CAMBRIDGE TERRACE	1220	Tue Feb 10 19:05:18 1998 CST	f	0
27		UNIT 10/12 FAIRFORD STREET	82712098		118		0	epoch	f	0
28		8 ENTERPRISE ST	83629965	HYDE PK	118		0	epoch	f	0
29		249 ANGAS STREET	82320277	ADELAIDE			2422	Wed Mar 04 18:11:07 1998 CST	f	0
30		7 GEORGE COURT	82127595	ADELAIDE			1758	Fri Feb 20 21:28:54 1998 CST	f	0
31		27 GRANDVIEW GROVE	83329385		118		0	epoch	f	0
33		1-7 LEICESTER STREET	83595611		118	NEW BUILDING	0	epoch	f	0
34	CHESTER HOUSE	LEVEL 2 91 GRENFELL STREET	82049600		118	BIRTHS, DEATHS AND MARRIAGES	0	epoch	f	0
35		17 ROSEMONT STREET	83322821		118		0	epoch	f	0
36		128 WRIGHT STREET	0416356704		118		0	epoch	f	0
37		5-38 MITCHELL STREET	83730408	MILLSWOOD			2254	Sun Mar 01 03:39:16 1998 CST	f	0
38		12/317 PORTRUSH ROAD	83317135		118		0	epoch	f	0
39		60 FERGUSSON AVENUE	83792990		118		0	epoch	f	0
40		23 TREVELYAN STREET	82717608	WAYVILLE	118		275	Thu Jan 22 20:52:24 1998 CST	f	0
41		12 MARKET PLACE	83461802		118		0	epoch	f	0
42		81 PORTER STREET	82725745	PARKSIDE		OFF UNLEY ROAD	1697	Thu Feb 19 20:34:50 1998 CST	f	0
43		14 WESTBURY STREET	83629776	HACKNEY	118		1307	Thu Feb 12 18:48:03 1998 CST	f	0
44		15 HALLETT STREET	82323146		118		0	epoch	f	0
45		4/15 FRANCIS STREET EAST	82675764		118		0	epoch	f	0
46		29 POWER STREET	82322334		118		0	epoch	f	0
47	CLARENCE MOTEL	220 HUTT STREET	82233560	ADELAIDE		RM. 40\
	2080	Thu Feb 26 19:53:32 1998 CST	f	0
48		14/15-23 WINDSOR GARDENS	82614753		118	OPP PHONE BOX. YELLOW LIGHT	0	epoch	f	0
49		3 MCQUILLAN AVENUE	83404395		118		0	epoch	f	0
50		242 PIRIE STREET	82322277		118	UNDER BOOM GATE. PRESS GOULD	0	epoch	f	0
51		UNIT 6/18 WILLIAM STREET	84315173	NORWOOD			1813	Sat Feb 21 20:06:50 1998 CST	f	0
52		25 PIERSON STREET	84248070		118	BRAD. EXT 88070	0	epoch	f	0
53		17 LOUISA STREET	83579770		130		0	epoch	f	0
54		2 HAMPTON GROVE	83620579	NORWOOD			1442	Sat Feb 14 23:47:00 1998 CST	f	0
55		89 SWAINE AVENUE	83640912		118		0	epoch	f	0
56		17 WELLER STREET	82723562	GOODWOOD			2634	Sat Mar 07 20:09:50 1998 CST	f	0
57		4 HORROCKS STREET	83445020	WALKERVILLE			2384	Tue Mar 03 21:11:18 1998 CST	f	0
58		340 ANGAS STREET	82233875		118		0	epoch	f	0
59		35A HEWITT AVENUE	82317633		118		0	epoch	f	0
60		72 ORSMOND STREET	83469479	HINDMARSH			2077	Thu Feb 26 19:38:06 1998 CST	f	0
61		13/2 ANGAS STREET	83612593		118	OFF WHITE STREET	0	epoch	f	0
62		35 VICTORIA STREET	83578931		118		0	epoch	f	0
63		47 HAMPTON STREET	82726086	GOODWOOD			1692	Thu Feb 19 19:17:58 1998 CST	f	0
64		39 CAPPER STREET	83620563				0	epoch	f	0
65		49A MACLAREN STREET	82235972	ADELAIDE			2416	Wed Mar 04 03:51:19 1998 CST	f	0
66		13 GLENBROOK CLOSE	83625294	MARDEN	118	ENTRANCE FROM SIDE\
\
	1450	Sun Feb 15 01:24:45 1998 CST	f	0
67		4/58 BRIDGE STREET	83328514		118		0	epoch	f	0
68		13 HUME STREET	83592649	ADELAIDE			2568	Fri Mar 06 21:16:55 1998 CST	f	0
69		367 CARRINGTON STREET	0412361336		118		0	epoch	f	0
70		94 FOURTH AVENUE	83625310		118	NURSING HOME	0	epoch	f	0
71		2 ASHLEY PLACE	83402390	RIDLEYTON			1151	Mon Feb 09 00:12:04 1998 CST	f	0
72		UNIT 12 86 MELBOURNE STREET	83618468		118		0	epoch	f	0
73		232 HALIFAX STREET	82240125	ADELAIDE	118		1762	Fri Feb 20 22:45:48 1998 CST	f	0
74		UNIT 3/36 RUNDLE STREET	83622493	KENT TOWN			632	Fri Jan 30 17:18:00 1998 CST	f	0
75		UNIT 3 34 KW RD	0414440076	WAYVILLE			487	Mon Jan 26 22:55:52 1998 CST	f	0
76		2/6 BAILIMA COURT	83633327		118		0	epoch	f	0
77		KERMODE STREET	82673200		118	KERMODE STREET ENTRANCE. MEMORIAL HOSPITAL	0	epoch	f	0
78		1/38 ADELAIDE STREET	83644052		118		0	epoch	f	0
79		12 HARVEY STREET	82975355	MARLESTON			0	epoch	f	0
80		8/147 STE[JEM TERRACE	01465242		118		0	epoch	f	0
81		3/6 DAWSON STREET	83799923		118		0	epoch	f	0
82		30 BALFOUR STREET	018387627		118		0	epoch	f	0
83	AFFORDABLE COURIERS	420 KING WILLIAM STREET	84100883	ADELAIDE	118		371	Sat Jan 24 21:47:29 1998 CST	f	0
84		102 BROUGHAM PLACE	82673080	NTH ADELAIDE			2622	Sat Mar 07 18:32:14 1998 CST	f	0
85		242 PIRIE STREET	92322277		118		0	epoch	f	0
86		36 WARWICK STREET	83443209	WALKERVILLE		\
	2215	Sat Feb 28 21:09:40 1998 CST	f	0
87		28 HALLS PLACE	82317370		118		0	epoch	f	0
88	JANET	2 BURLEY GRIFFIN BLVD	83463463		117		0	epoch	f	0
89		42 PORTER STREET	82711162		118		0	epoch	f	0
90		45 A ROSE STREET	84437160	MILE END			1888	Sun Feb 22 21:07:43 1998 CST	f	0
91		356 FULLARTON ROAD	83795537		118		0	epoch	f	0
92		UNIT 14/142 CARRINGTON STREET	83592836	ADELAIDE			2076	Thu Feb 26 19:11:33 1998 CST	f	0
93		3/2 KENT ROAD	83512205	KESWICK			2435	Wed Mar 04 20:55:37 1998 CST	f	0
94		2/9 CUMMING STREET	84435514		117		0	epoch	f	0
95		12-380 MARION RD	83512396	PLYMPTON		THREE DOLLARS DELIVERY	1955	Mon Feb 23 23:29:54 1998 CST	f	0
96		UNIT 3/111 SYDENHAM ROAD	83613186		118		0	epoch	f	0
97		27 GREEN STREET	83324446	ST MORRIS	118		2234	Sun Mar 01 01:00:46 1998 CST	f	0
98		143 BURBRIDGE ROAD	0412203892		118		0	epoch	f	0
99		20 MOULDEN STREET	83622292		118		0	epoch	f	0
100		2-16 BARTLEY CRESCENT	83735895		118		0	epoch	f	0
101		UNIT 1/41 GUILFORD AVENUE	83420929		118		0	epoch	f	0
102		25 ST JOHN STREET	83592553	ADELAIDE	118		0	epoch	f	0
103		4 MILLER STREET	82714590		118		0	epoch	f	0
104		16 FILSELL STREET	83522235		118		0	epoch	f	0
105		2/102 SEAVIEW ROAD	83536368		118		0	epoch	f	0
106		UNIT 11/19 ELLEN STREET	83420567		118		0	epoch	f	0
107		20 TRIMMER TERRACE	82741606	UNLEY			1021	Fri Feb 06 22:48:25 1998 CST	f	0
108		22 WAKEFIELD STREET	83327571		118		0	epoch	f	0
109		1A/58 WILLIAM STREET	84319074		118		0	epoch	f	0
110		56 HURTLE SQUARE	83592269	ADELAIDE			2141	Fri Feb 27 20:49:14 1998 CST	f	0
111		11/60 VINCENT PLACE	82126625		118		0	epoch	f	0
112		1 NORTH TERRACE	84103008		118	CNR. HACKNEY ROAD	0	epoch	f	0
113		9 MANN TERRACE	82391143	NTH.ADEL			2441	Wed Mar 04 22:04:58 1998 CST	f	0
114		246 HALIFAX STREET	82150080	ADELAIDE			2249	Sun Mar 01 03:15:41 1998 CST	f	0
115		2/162 GOVER STREET	82672121		118		0	epoch	f	0
116		81 EDWARD STREET	83332659	NORWOOD			1934	Mon Feb 23 19:45:37 1998 CST	f	0
117		204 GRENFELL STREET	82322278		118		0	epoch	f	0
118		UNIVER SECURITY	0411733157		118	OFF NORTH TERRACE. NEXT TO ART GALLERY	0	epoch	f	0
119		68 GRENFELL STREET	82034495		118		0	epoch	f	0
120		338 CARRINGTON STREET	82232931	ADELAIDE	118		938	Thu Feb 05 18:45:33 1998 CST	f	0
121		64 STANLEY STREET	83618096		118		0	epoch	f	0
122		17 LOUISA STREET	83759770		118		0	epoch	f	0
123		20/12-26 WILCOX STREET	84100205	ADELAIDE			2421	Wed Mar 04 18:02:32 1998 CST	f	0
124		29A SURREY ROAD	82931231	KESWICK		\
	1991	Tue Feb 24 21:10:55 1998 CST	f	0
125		16 MURRAYS LANE	84100096		118		0	epoch	f	0
126		254 FRANKLIN STREET	82317771		118		0	epoch	f	0
127		28 VINCENT STREET	82321122	ADELAIDE	118		283	Thu Jan 22 22:29:58 1998 CST	f	0
128		6 MITCHELL STREET	83579246		118		0	epoch	f	0
129		28 CLAXTON STREET	82311886		118		0	epoch	f	0
130		6/502 FULLARTON ROAD	83791245		118		0	epoch	f	0
131		19 HENRY STREET	83317317		119		0	epoch	f	0
132		403 THE PARADE	84316837	KENSINGTON GARDENS		ONE DOLLAR DEL	2354	Tue Mar 03 01:09:48 1998 CST	f	0
133		10 CHATHAM STREET	82123727	ADELAIDE			1441	Sat Feb 14 23:15:50 1998 CST	f	0
134		88 FULLARTON ROAD	83626366				0	epoch	f	0
135		6 ASCOT AVENUE	82666748		118		0	epoch	f	0
136		15 EAST PARADE	82721292		118		0	epoch	f	0
137		381 FULLARTON ROAD	82725249		118		0	epoch	f	0
138	ADELAIDE WATCH HOUSE	NELSON STREET	82075241		118	PRESS BUZZER	0	epoch	f	0
139		77/17 RIVER STREET	83620674		118		0	epoch	f	0
140		3 GARDENER AVENUE	83313162		118		0	epoch	f	0
141		4MC GOWAN AVE	82725598	UNLEY			1805	Sat Feb 21 18:31:51 1998 CST	f	0
142		8 REGENT APTS. EDEN STREET	82248891		118	BETWEEN ANGAS AND CARRINGTON	0	epoch	f	0
143		13 KENT ROAD	018824427		118		0	epoch	f	0
144		5 BALLARA STREET	82342568	MILE END	118		1171	Mon Feb 09 20:03:49 1998 CST	f	0
145		10 WAKEHAM ST	82240232		118		0	epoch	f	0
146		20 OAK AVENUE	82720052		118		0	epoch	f	0
147		93 FINNISS STREET	82676350	NORTH ADELAIDE			2139	Fri Feb 27 20:43:25 1998 CST	f	0
148		89 EAST TERRACE	82326878	ADELAIDE			2074	Thu Feb 26 18:50:52 1998 CST	f	0
149		56-58 RUNDLE STREET	83622262		118		0	epoch	f	0
150		CORNER WAKEFIELD AND PULTENEY	82233551		118		0	epoch	f	0
151	JOHN MARTIN	CHARLES STREET	84052244		118	SECURITY	0	epoch	f	0
152	AYERS HOUSE	288 NORTH TERRACE	82240919		118	AT THE BACK	0	epoch	f	0
153		8 FERGUSON AVENUE	83791644		118		0	epoch	f	0
154		53/42 CHARLICK CIRCUIT	83592680	ADELAIDE			2022	Wed Feb 25 17:47:25 1998 CST	f	0
155		21 DAVIES ROAD	83370879		118		0	epoch	f	0
156		UNIT 4/257 PORTRUSH ROAD	83612559		119	BACK OF HOUSE IN PERCIFAL STREET	12	epoch	f	0
157		UNIT 7/2 WARWICK AVENUE	82332762		118		0	epoch	f	0
158		UNIT 3/55 ASHLEY STREET	017154542		118		0	epoch	f	0
159		42B SMITH STREET	84437730		118		0	epoch	f	0
160		404 CARRINGTON STREET	83592828		118		228	epoch	f	0
161		178 GROTE STREET	82314511	ADELAIDE		RING THE DOOR BELL	1977	Tue Feb 24 19:16:00 1998 CST	f	0
162	GREEK CLUB	405 MAGILL ROAD	84315344		118		0	epoch	f	0
163	NEW ALMA HOTEL	66 MAGILL ROAD	83621234	NORWOOD		\
	2609	Sat Mar 07 04:06:15 1998 CST	f	0
164	SASHA	67 PARK ST ...	83733652	HYDE PK			1917	Mon Feb 23 02:35:30 1998 CST	f	0
165		22 TYSON STREET	83713768		118		13	epoch	f	0
166		53 MCLAREN STREET	82320449	ADELAIDE			2246	Sun Mar 01 02:49:50 1998 CST	f	0
167		16 FREDERICK STREET	82311408		118		14	epoch	f	0
168		37 HARROW ROAD	83620482		118		0	epoch	f	0
169	RAQUETEERS CLUB	14 EAST TERRACE	82325111	ADELAIDE			2028	Wed Feb 25 19:14:17 1998 CST	f	0
170		29 LITTLE GILBERT STREET	82315596		118		0	epoch	f	0
171		43	82612272		118		0	epoch	f	0
172		43 BRIANT ROAD	83612272		118	CORNER HOUSE	0	epoch	f	0
173		9 AVENUE ROAD	0417822609	PROSPECT			1453	Sun Feb 15 01:55:26 1998 CST	f	0
174		6 MULLER STREET	83626282		118		0	epoch	f	0
175		UNIT 2/114 LIPSETT TERRACE	82343710		118		0	epoch	f	0
176		5 HAYWARD AVENUE	84436391	TORRENSVILLE			1903	Mon Feb 23 00:21:55 1998 CST	f	0
177		9/197 PROSPECT ROAD	82694430	PROSPECT			2190	Sat Feb 28 18:22:30 1998 CST	f	0
178		UNIT 4/7 WAKEFIELD STREET	0416116152		118		0	epoch	f	0
179		5 WELLER STREET	83736297	GOODWOOD	118		533	Wed Jan 28 17:42:13 1998 CST	f	0
180		1 EGMONT TERRACE	83317271		118		0	epoch	f	0
181		10 BENNETT STREET	83628768	MAYLANDS			2054	Thu Feb 26 00:39:35 1998 CST	f	0
182		2/179 HAMSTEAD ROAD	83692871		118		0	epoch	f	0
183		4 MOULDEN STRETT	83621421		118		0	epoch	f	0
184		2 WALL PLACE	83646550		118		0	epoch	f	0
185		12B MATILDA STREET	82694429	GILBERTON			403	Sun Jan 25 17:45:35 1998 CST	f	0
186		43 CHARLES STREET	014094684		118		0	epoch	f	0
187		UNIT 4/12-26 WILLCOX STREET	014040396		118		0	epoch	f	0
188		8 BURGAN STREET	82665532		118		0	epoch	f	0
189		30 BLYTH STREET	83732158	PARKSIDE			2148	Fri Feb 27 22:14:50 1998 CST	f	0
190		1 NORTH TERRACE	82318777	HACKNEY		REAR ENTRANCE UPSTAIRS\
	2598	Sat Mar 07 02:32:19 1998 CST	f	10
191		14 RUNDLE STREET	83621397		118		0	epoch	f	0
192		15 MEDINDIE LANE	82691137		118		0	epoch	f	0
193		114 FINNIS STREET	82390145	NORTH ADELAIDE	118		558	Wed Jan 28 22:50:01 1998 CST	f	0
194		8 WELLINGTON STREET	83327837		118		0	epoch	f	0
195		APT. D36 188 CARRINGTON STREET	82248876		118	4TH LEVEL	0	epoch	f	0
196		5 PARKER STREET	0418846230		118		0	epoch	f	0
197		1/2 DAVENPORT LANE	82718216		118		0	epoch	f	0
198		2/2B CUDMORE AVENUE	83310084	TOORAK GARDENS	118		1362	Fri Feb 13 20:58:38 1998 CST	f	0
199		113 GILBERT STREET	84006600		118	AT THE BACK. PRESS BUZZER	0	epoch	f	0
200		COCA-COLA 9 LIGHT TERRACE	0419030736		118	SECURITY GATE	0	epoch	f	0
201		136 BEULAH ROAD	83322197		118		0	epoch	f	0
202		1 WINHAM STREET	83420712		118		0	epoch	f	0
203		8/18 WILLIAM STREET	83330685		118		0	epoch	f	0
204		20 HALIFAX STREET	83519399	HILTON	118		692	Sat Jan 31 18:33:27 1998 CST	f	0
205		325 ANGAS STREET	83592570		118		0	epoch	f	0
206		49 ORMOND GROVE	83326078		118		0	epoch	f	0
207		32 BALLVILLE STREET	82691021		118		0	epoch	f	0
208		'WESTPAC' 25 PIERSON STREET	84248446		118		0	epoch	f	0
209		9/29 EVERARD AVENUE	83511723		118		0	epoch	f	0
210	LEADER COMP	216 WRIGHT STREET	82216222				196	epoch	f	0
211		UNIT 10/142 CARRINGTON STREET	82234909		118		0	epoch	f	0
212		F4/5 EDSALL STREET	83632939	NORWOOD			2561	Fri Mar 06 20:11:12 1998 CST	f	0
213		57 HAWSON AVENUE	82936061		118		0	epoch	f	0
214		164 WATTLE STREET	83734994		118	CORNER DUTHY AND WATTLE	0	epoch	f	0
215		1 FLORA STREET	83623256	STEPNEY	118		2579	Sat Mar 07 00:04:55 1998 CST	f	0
216		UNIT 6/24 LEHUNTE STREET	82725174		130		0	epoch	f	0
217		24 YOUNG STREET	82721808		118		0	epoch	f	0
218		17 L'ESTRANGE STREET	83790305		118		0	epoch	f	0
219		3/35 GRAY STREET	83622095	NORWOOD	118		821	Mon Feb 02 21:25:19 1998 CST	f	0
220		37 HAMPTON STREET SOUTH	82741429	GOODWOOD	118		944	Thu Feb 05 19:55:55 1998 CST	f	0
221		54 CARDNELL STREET	82233956		118		0	epoch	f	0
222		25 MANSFIELD STREET	82392710		118		0	epoch	f	0
223		10 ROYAL AVENUE	82325980	ADELAIDE	118	OFF GILLES STREET	2253	Sun Mar 01 03:36:51 1998 CST	f	0
224		245 CARRINGTON STREET	82324885	ADELAIDE		4546051141992335 11/98	2614	Sat Mar 07 17:38:33 1998 CST	f	0
225		78 STURT STREET	82215026		118		0	epoch	f	0
226		135A DRAYTON STREET	04118119657		118		0	epoch	f	0
227		8 WELLAND AVENUE	83461225		118		224	epoch	f	0
228	ELVIO	19 MARION STREET	82723480		118		0	epoch	f	0
229		15 OAKLEY STREET	82315456		118		0	epoch	f	0
230		316 HALIFAX STREET	82233548		118		0	epoch	f	0
231		4-6 FLEMINGTON STREET	83791719		118		0	epoch	f	0
232		UNIT 6/1A CLOSE STREET	83642502		118		0	epoch	f	0
233		10 HILL STREET	83645229		118		0	epoch	f	0
234		260 GILBERT STREET	82310670	ADELAIDE			2487	Thu Mar 05 18:57:35 1998 CST	f	0
235		2 WAKELIN STREET	83655736	GLYNDE		$1.00 DELIVERY FEE	2618	Sat Mar 07 18:19:56 1998 CST	f	0
236		33 CLARKE STREET	84310206		118		0	epoch	f	0
237		87A SOUTH TERRACE	82125211	ADELAIDE			2037	Wed Feb 25 20:34:08 1998 CST	f	0
238		2/161 MARIAN ROAD	83364581		118		0	epoch	f	0
239		82A FREDERICK STREET	82741290		118		0	epoch	f	0
240	SALVATION ARMY	62 HOCKING LAND	82122836		118	OFF WHITMORE SQUARE	0	epoch	f	0
241		8 FREDERICK STREET	0412301793	RICHMOND			2449	Wed Mar 04 23:33:52 1998 CST	f	0
242		5B STEPHENS AVENUE	83521235	TORRENSVILLE			2620	Sat Mar 07 18:22:29 1998 CST	f	0
243		101 FINNISS STREET	82671959	NORTH ADELAIDE			1764	Fri Feb 20 23:07:38 1998 CST	f	0
244		262 FRANKLIN STREET	82236818		118		0	epoch	f	0
245		78 STURT STREET	82215224		118		0	epoch	f	0
246		3/12 REDMOND STREET	83441270		118		0	epoch	f	0
247		29 STAMPFORD STREET	82728436		130		0	epoch	f	0
248		44 LEAH STREET	82936016	FORRESTVILLE			2007	Wed Feb 25 00:10:17 1998 CST	f	0
249		14 SCOTT STREET	83322350		118		0	epoch	f	0
250		75 PERCY STREET	83442738				195	epoch	f	0
251		13/237 FULLARTON ROAD	82723868		118		0	epoch	f	0
252		37 MARGARET STREET	82676012	ADELAIDE	118	SOUTHERN END	465	Mon Jan 26 18:53:36 1998 CST	f	0
253		12A KING WILLIAM ROAD	82718287	WAYVILLE		CORNER OF K.W.ST & YOUNG ST\
ENTRANCE OFF YOUNG ST	1570	Tue Feb 17 00:38:26 1998 CST	f	0
254		UNIT 4-52 RUSSELL STREET	82316301	ADELAIDE			2455	Thu Mar 05 00:49:25 1998 CST	f	0
255		19 EGMONT TERRACE	82723812	HAWTHORNE		$1.00 DELIVERY FEE	2446	Wed Mar 04 23:13:22 1998 CST	f	0
256		29 POWER STREET	82232334		118		0	epoch	f	0
257		14 MULLER STREET	83626634	NORWOOD	118		490	Mon Jan 26 23:09:53 1998 CST	f	0
258		93 HIGH STREET	83646871		118		0	epoch	f	0
259		15 RENTOUL AVENUE	83792495		118		0	epoch	f	0
260		3/13 SCOTT STREET	83453597		118		0	epoch	f	0
261		13/3 BLYTH STREET	82710476	PARKSIDE	118		577	Thu Jan 29 01:53:48 1998 CST	f	0
262		UNIT 2 PARK LANE	82724622	ADELAIDE	118		2075	Thu Feb 26 18:59:55 1998 CST	f	0
263		44 HUGHES STREET	84433969	MILE END			2092	Thu Feb 26 22:34:39 1998 CST	f	0
264		19 GEORGE STREET	82724527		118		0	epoch	f	0
265		61 CREMORNE STREET	82741757		118		0	epoch	f	0
266		237 GLYNBURN ROAD	84315759		118		0	epoch	f	0
267		28 ALFRED STREET	82717507		118		0	epoch	f	0
268		50 ALLINGA AVENUE	83797707		118		0	epoch	f	0
269		29 TOMSEY STREET	82323789	ADELAIDE	118		2323	Mon Mar 02 18:20:29 1998 CST	f	0
270		42 JOHN STREET	82711554		118		0	epoch	f	0
271		3/7 VINE LANE	83382147		118		0	epoch	f	0
272		216 ANGUS STREET	83592862	ADELAIDE			1864	Sun Feb 22 18:21:00 1998 CST	f	0
273		42A WILLIAM STREET	0412165766		118		0	epoch	f	0
274		22 ILLFORD STREET	83692681	VALE PARK	118		1602	Tue Feb 17 22:46:46 1998 CST	f	0
275		2 PALMERSTON PLACE	82712031		118		0	epoch	f	0
276		3 RUDDOCK AVENUE	84439543	HILTON	118		778	Sun Feb 01 22:00:41 1998 CST	f	0
278		25/10 COLLIN STREET	83421914		118		0	epoch	f	0
279		7 GOYDER PLACE	83401468	BROMPTON			2221	Sat Feb 28 22:44:11 1998 CST	f	0
280		35A HEWITT AVENUE	83317633	ROSE PARK			1799	Sat Feb 21 17:20:23 1998 CST	f	0
281		1-100 ROBSART STREET	83720229		118		0	epoch	f	0
282		UNIT 8/17 FLORENCE STREET	82716583		118		0	epoch	f	0
283		49 LEICESTER STREET	82722353	PARKSIDE			1899	Sun Feb 22 23:50:07 1998 CST	f	0
284		24 MACPHERSON STREET	82774397		118		0	epoch	f	0
285		45 MARGARET STREET	83313418	NORWOOD			2348	Tue Mar 03 00:34:05 1998 CST	f	0
286		1 ROCHESTER STREET	84315085		118		0	epoch	f	0
287		45 BATHAM RD	83621333		118		0	epoch	f	0
288		UNIT 2/130 LEICESTER STREET	82725157		118		0	epoch	f	0
289		33 BLYTHE STREET	82713232		118		0	epoch	f	0
290		29 STURDER STREET	8338113		118		0	epoch	f	0
291		7/2 WARWICK ST	83332762	TOORAK GARDENS	118		2057	Thu Feb 26 01:09:29 1998 CST	f	0
292		1/189 PROSPECT ROAD	83443475		118		0	epoch	f	0
293		70 MARY STREET	83734624		118		0	epoch	f	0
294		275 GILBERT STREET	82318223	ADELAIDE	118		2129	Fri Feb 27 19:38:33 1998 CST	f	0
295		3 FREDERICK STREET	0414912561		118		0	epoch	f	0
296	CHRISTINA HARNETEN	30 BALFOUR STREET	018387637	NAILSWORTH			1614	Wed Feb 18 00:50:08 1998 CST	f	0
297		27 WILLIAM STREET	83321413		118		0	epoch	f	0
298		136/UNIT 7 CROSS ROADS	82713192	HIGATE	118		2091	Thu Feb 26 22:18:46 1998 CST	f	0
299		69A ROSE TERRACE	82714254		118		0	epoch	f	0
300		16 CLOVELLY AVENUE	82931789		118		0	epoch	f	0
301		1 ETTRICK AVENUE	83443560		118		0	epoch	f	0
302		UNIT 10 49 EDWARD STREET	83612421		118		0	epoch	f	0
303		4/40 KEITH AVENUE	83710854		118		0	epoch	f	0
304		30 CURRIE STREET	84016421	ADELAIDE	118	GROUND FLOOR OF TELSTRA BUILDING	1542	Mon Feb 16 21:37:50 1998 CST	f	0
305		33 BRADFORD COURT	0414522352		118		0	epoch	f	0
306		15 ADA STREET	82726619	GOODWOOD			1296	Thu Feb 12 02:39:40 1998 CST	f	0
307		78 STURT STREET	82215393		118		0	epoch	f	0
308		6/40 BRIDGE STREET	83324496		118		0	epoch	f	0
309		30 FLINDERS STREET	82042377	ADELAIDE	118		883	Wed Feb 04 02:34:55 1998 CST	f	0
310		74 CHILDERS STREET	82671538	NTH.ADEL			2318	Mon Mar 02 04:02:37 1998 CST	f	0
311		8 WELLINGTON TERRACE	83799759		118		0	epoch	f	0
312		18 MELLOW COURT	014608672		118	OFF MELLOW COURT	0	epoch	f	0
313		39 RUNDLE STREET	83626354	KENT TOWN	118		651	Fri Jan 30 20:26:09 1998 CST	f	0
314		UNIT 4/12-26 WILLCOX STREET	82123738	ADELAIDE	118		777	Sun Feb 01 21:44:40 1998 CST	f	0
315		87 MARGARET STREET	82390062		118		0	epoch	f	0
316		UNIT 4/6 FLEMINGTON STREET	83799719	FREWVILLE	118		784	Sun Feb 01 23:05:00 1998 CST	f	0
317		111 LEADER STREET	82938762		118		0	epoch	f	0
318		121 FIFTH AVENUE	83624391		118		0	epoch	f	0
319		1/11 WAKEFIELD STREET	`83634331		118		0	epoch	f	0
320		58 EAST STREET	82348039	TORRENSVILLE	118		2299	Sun Mar 01 23:14:00 1998 CST	f	0
321		216 ANGUS STREET	0412351348		118		0	epoch	f	0
322		32 WHITMORE SQUARE	82215996		118		0	epoch	f	0
323		95 WRIGHT STREET	82215295	ADELAIDE	118		631	Fri Jan 30 04:16:10 1998 CST	f	0
324		36 LEHUNTE STREET	82729389		118		0	epoch	f	0
325		49 REYNELL AVENUE	84459571		118		0	epoch	f	0
326		UNIT 1/124 EDWARD STREET	83642736		118		0	epoch	f	0
327		8 ROKEBY AVENUE	83635015	ADELAIDE	118		1361	Fri Feb 13 20:44:11 1998 CST	f	0
328		33 STRANGEWAYS TERRACE	82675158	NORTH ADELAIDE	118		2127	Fri Feb 27 18:58:43 1998 CST	f	0
329		UNIT 21/11 DAVAAR PLACE	83592230	ADELAIDE	118		872	Wed Feb 04 00:11:30 1998 CST	f	0
330		100 HUTT STREET	83031808		118		0	epoch	f	0
331		UNIT 9/5 CAPPER STREET	83635845		118		0	epoch	f	0
332		37 DAREBIN STREET	82340616		118		0	epoch	f	0
333		15 BLACKBURN STREET	019670199		118		0	epoch	f	0
334	BLOCKBUSTER VIDEO	269 GLEN OSMOND ROAD	83796266		118		0	epoch	f	0
335		34 THE STRAND	83743756		118		0	epoch	f	0
336		47 GEORGE STREET	0412470467		118		0	epoch	f	0
337		12A ANGAS STREET	83643920		118		0	epoch	f	0
338		13 DIMORA COURT	82320116	ADELAIDE			2339	Mon Mar 02 22:52:52 1998 CST	f	0
339		UNIT 44/91 ROBSART STREET	82722534		118		0	epoch	f	0
340		34 WOOD STREET	82727846		118		0	epoch	f	0
341		16 DEVON STREET NORTH	82729096	GOODWOOD			769	Sun Feb 01 20:33:41 1998 CST	f	0
342		43 EDMUND AVENUE	82727194		118		0	epoch	f	0
343		10 MILNER ROAD	83518198		118		0	epoch	f	0
344		12 MORECOMBE ST	83623347	STEPNEY			1035	Sat Feb 07 01:24:03 1998 CST	f	0
345		20 BALIOL STREET	83625482		118		0	epoch	f	0
346		16 PORTER STREET	83735228		118		0	epoch	f	0
347		126 YOUNG STREET	82715406		118		0	epoch	f	0
348		11a Hume Street	82320938	ADELAIDE			2513	Thu Mar 05 22:28:59 1998 CST	f	0
349		torrens street	8768678678				0	epoch	f	0
350		35 flamington st	83383623				21	epoch	f	0
351		another address	83383624		120		23	epoch	f	0
352		unit 5 229 young street	82716616				25	epoch	f	0
353		FLAT 3/79 KENSINGTON ROAD	83326879		118		0	epoch	f	0
354		3 FINNISS STREET	82676344		118		0	epoch	f	0
355		21A GOODENOUGH STREET	83528319	MILE END			2524	Fri Mar 06 01:12:40 1998 CST	f	0
356		36 FISHER STREET	83635072		118		0	epoch	f	0
357		33 HARVEY STREET	83579073		118		0	epoch	f	0
358		3 WALSH STREET	83654451		118		0	epoch	f	0
359		11 HOPSON STREET	83540881		118		0	epoch	f	0
360		58 TREMBAR STREET	83404491		118		0	epoch	f	0
361		26 DUNKS STREET	83731192		118		0	epoch	f	0
362		51 AIRIE AVENUE	0411823919		118		0	epoch	f	0
363		269 GILLES STREET	82326223		118		0	epoch	f	0
364		11 ST JOHNS AVENUE	83460801		118		0	epoch	f	0
365		44 THE PARADE WEST	83624824	KENT TOWN			418	Sun Jan 25 20:29:32 1998 CST	f	0
366		18 TUCKER STREET	82235923		118		0	epoch	f	0
367	MOBILE STATION	CORNER OF FULLARTON & NTH TCE	83624349				0	epoch	f	0
368		33 FLINDERS ST`	83623984	KENT TOWN			1707	Thu Feb 19 23:02:11 1998 CST	f	0
369		U8-128 SIXTH AVE	83632750		118		0	epoch	f	0
370	DIRECTORS STUDIO HOTEL	259 GOUGER STREET	82313572	ADELAIDE		ROOM 414	2070	Thu Feb 26 18:24:16 1998 CST	f	0
371	CAR PARK	FROME STREET	83593305	ADELAIDE			2183	Sat Feb 28 04:13:54 1998 CST	f	0
372		U2/37 MCKINNON PARADE	82674742		118		0	epoch	f	0
373		UNIT 3/73 PHYLLIS STREET	83626788	MAYLANDS	118		1054	Sat Feb 07 18:25:24 1998 CST	f	0
374		22 B CLIFTON STREET	83624962		118		0	epoch	f	0
375		FLAT 5/1 WHITCOMBE STREET	84102771	ADELAIDE	118		857	Tue Feb 03 21:33:48 1998 CST	f	0
376		112/169 YOUNG STREET	83732397		118		0	epoch	f	0
377		UNIVERSITY OF S.A. NORTH TERRACE	83020371		118	CITY WEST CAMPUS. NORTH TCE ENTRANCE	0	epoch	f	0
378		18 RUTHVEN AVE	82126611				0	epoch	f	0
379		76 CHAPEL STREET	83521497		118		0	epoch	f	0
380		9 MARLBOROUGH  STREET	82723383	FULLARTON			2629	Sat Mar 07 19:24:27 1998 CST	f	0
381		3 THE GROVE	83646957		118		0	epoch	f	0
382		77 SWAINE AVE.	83328832	ROSEPARK			1693	Thu Feb 19 19:40:19 1998 CST	f	0
383		4 MCCLAREN STREET	83592581		118		0	epoch	f	0
384		145 RAILWAY TERRACE	83518422		118		0	epoch	f	0
385		123 GREENHILL ROAD	83725267		118		0	epoch	f	0
386		2A ROBERT STREET	83461280		118		0	epoch	f	0
387		30 ERSKINE STREET	82720667	ADELAIDE	118		661	Fri Jan 30 21:36:47 1998 CST	f	0
388		35 VICTORIA STREET	83578575	GOODWOOD	118		559	Wed Jan 28 22:59:00 1998 CST	f	0
389		12 MILNER ROAD	84433491		118		0	epoch	f	0
390		18A SEAVIEW STREET	83794916	FULLARTON			370	Sat Jan 24 21:38:51 1998 CST	f	0
391	VILLI'S	2-14 MANCHESTER STREET	82342642		118		0	epoch	f	0
392	CHESSER HOUSE	91-97 GRENFELL STREET	82049120		118		0	epoch	f	0
393		25 PIRIE STREET	82263868		118		0	epoch	f	0
394		33 CLARK ST	8430206				26	epoch	f	0
395		2 MALBOROUGH ST	83625409				28	epoch	f	0
396		281 FLINDERS ST	82321821			LAST ORDER DID NOT OPEN THE DOOR FOR THE DRIVER         	29	epoch	f	0
397		21A WILCOX ST	82316632	ADELAIDE			2547	Fri Mar 06 18:37:31 1998 CST	f	0
398		224 FROME ST	82322655	ADELAIDE			1987	Tue Feb 24 20:54:20 1998 CST	f	0
399		27 PRESCOTT AVE	83643296		118		0	epoch	f	0
400		10-61 WALKERVILLE TCE	83444435	GILBERTON			2026	Wed Feb 25 18:55:29 1998 CST	f	0
401	KARREN & GARRY	11 CRACE RD	83538065		118		0	epoch	f	0
402		88 JENNINGHAM ST	82672292		118		0	epoch	f	0
403		UNIT 4/23 QUEEN STREET	82234879		118		0	epoch	f	0
404		16 KINCARDINE AVENUE	83798749		118		0	epoch	f	0
405	ACADEMY CINEMA	HINDMARSH SQUARE	82235000		118		0	epoch	f	0
406		6 MATILDA STREET	82712163		118		0	epoch	f	0
407		263 WARD STREET	82671493		118		0	epoch	f	0
408		113 GILBERT STREET	131897		118		0	epoch	f	0
409		27 WILCOX STREET	82312887		118		0	epoch	f	0
410		34/53 KING WILLIAM ROAD	82711105	UNLEY			1607	Tue Feb 17 23:42:40 1998 CST	f	0
411		38 FISHER STREET	83626636	NORWOOD			1388	Sat Feb 14 01:07:20 1998 CST	f	0
412		31 LITTLE GILBERT STREET	84101497		118		0	epoch	f	0
413		3 SALISBURY AVENUE	83633346		118		0	epoch	f	0
414		159 MARGARET STREET NORTH	82390487				0	epoch	f	0
415		24 ROYAL AVENUE	82323705		118		0	epoch	f	0
416		20 WHITE AVENUE	82345596	LOCKLEYS	118	$1.00 DELIVERY FEE	1517	Mon Feb 16 02:19:00 1998 CST	f	0
417	RIDGEWAY APT.	APT.15 CHARLICK CIRCUIT BUILD.11	83592785		118		0	epoch	f	0
418		286 A CARRINGTON STREET	82324698		118		0	epoch	f	0
419		12 VINE STREET	83318046		118		0	epoch	f	0
420		28 ALBERMARLE AVENUE	83613409	TRINITY GARDENS		ONE DOLLAR DELIVERY	2185	Sat Feb 28 04:24:51 1998 CST	f	0
421		9 THOMAS STREET	83467979		118		0	epoch	f	0
422		FLAT 10/351 BURBRIDGE ROAD	82343769		118		0	epoch	f	0
423		64 GEORGE STREET	83521000	THEBARTON	118	\
	2072	Thu Feb 26 18:45:29 1998 CST	f	0
424	ELISHA	59A ALFRED STREET	82729514	PARKSIDE	118		1319	Thu Feb 12 21:50:13 1998 CST	f	0
425		UNIT 6/423 PAYNEHAM ROAD	83653083		118		0	epoch	f	0
426		10 PEPPER STREET	83644107		118		0	epoch	f	0
427		128A GROTE STREET	82126477		118		0	epoch	f	0
428		19 FIRST AVENUE	83633972		118		0	epoch	f	0
429	5AA	PULTNEY COURT	82231539	ADELAIDE	118		2557	Fri Mar 06 19:58:23 1998 CST	f	0
430		1-55 FIRST AVENUE	83632286	ST PETERS		GO DOWN DRIVEWAY - DOOR ON SIDE OF HOUSE	1265	Wed Feb 11 19:58:31 1998 CST	f	0
431		UNIT11/2 HECTORVILLE ROAD	83657339		118		0	epoch	f	0
432		10 BAGOT AVENUE	83522972	MILE END			2270	Sun Mar 01 18:58:09 1998 CST	f	0
433		15 BIRKS STREET	83735826		118		0	epoch	f	0
434		444 PROSPECT ROAD	82621554	KILBURN		$1.00 DEL.\
	2425	Wed Mar 04 19:15:17 1998 CST	f	0
435		17 DUNK STREET	83732471	PARKSIDE			2483	Thu Mar 05 18:21:45 1998 CST	f	0
436		347 ANGUS STREET	83592684		118		0	epoch	f	0
437	GOTHIC HOTEL	CNR. MORPHET ROAD AND WRIGHT ST.	82319388		118		0	epoch	f	0
438		UNIT 1/5A ROSE TERRACE	83737343		118		0	epoch	f	0
439		14 SCOTT STREET	83323350		118		0	epoch	f	0
440	CROWN AND SCEPTRE HOTEL	308 KING WILLIAM STREET	82124159	ADELAIDE		FOR STAFF\
\
\
\
	2230	Sun Mar 01 00:23:05 1998 CST	f	0
441		UNIT 6/30 COLLEGE ROAD	83633159	KENT TOWN	118		322	Fri Jan 23 22:09:10 1998 CST	f	0
442		27 WORSHOP AVENUE	82232751	ADELAIDE			2286	Sun Mar 01 20:31:31 1998 CST	f	0
443		7A CHARLOTTE PLACE	82240079	ADELAIDE			2040	Wed Feb 25 21:04:23 1998 CST	f	0
444		87 MARY STREET	82712027		118		0	epoch	f	0
445		53A HACKNEY ROAD	83631244	HACKNEY			1749	Fri Feb 20 19:56:08 1998 CST	f	0
446		14 WRIGHT COURT	82215405		118		0	epoch	f	0
447		UNIT2/26 COLLEGE ROAD	83624473	KENT TOWN			2510	Thu Mar 05 21:41:28 1998 CST	f	0
448		46 HOWARD STREET	83442358		118		0	epoch	f	0
449		8 SHIERLAW STREET	83523703	RICHMOND			2520	Fri Mar 06 00:44:11 1998 CST	f	0
450	RISING SUN INN	60 BRIDGE STREET	83330721	KENSINGTON	118		917	Wed Feb 04 23:52:52 1998 CST	f	0
451		95 HIGH STREET	84315240		118		0	epoch	f	0
452		3 TREVELYAN STREET	82578152		118		0	epoch	f	0
453		2 NORTH STREET	83799173	FREWVILLE			1487	Sun Feb 15 19:32:33 1998 CST	f	0
454		35 WARD ST	82671638	NTH.ADEL			2648	Sun Mar 08 00:54:01 1998 CST	f	0
455	APPARTMENT ON THE PARK	SOUTH TCE	82230599		118		0	epoch	f	0
456		6 LE HUNTE STREET	82623648		39		49	epoch	f	0
457		UNIT 5/6 VAILIMA COURT	83627965		118		0	epoch	f	0
458	SUN ALLIANCE	LEVEL 7 45 GRENFELL STREET	82316999		118		0	epoch	f	0
459		78 NORTH TERRACE	83634557		118		0	epoch	f	0
460		108 EAST STREET	83466843	BROMPTON			1843	Sun Feb 22 02:36:00 1998 CST	f	0
461		30 MITCHELL STREET	83730287	MILLSWOOD	118		1164	Mon Feb 09 17:58:59 1998 CST	f	0
462		18 TUCKER STREET	82235957		118		0	epoch	f	0
463		47/91 ROBSART STREET	0412211408		118		0	epoch	f	0
464		19 SHELDON STREET	83621490		118		0	epoch	f	0
465		3/33 GOVER STREET	82674602		118		0	epoch	f	0
466		2 NORTH STREET	83759173		118		0	epoch	f	0
467		17 KATHERINE STREET	83792197		118		0	epoch	f	0
468		UNIT 4/3 LEHUNTE STREET	83594227		118		0	epoch	f	0
469		14 BATTAMS STREET	83632646	STEPNEY			1892	Sun Feb 22 22:01:45 1998 CST	f	0
470		3/61 ROSE TERRACE	82716648		118		0	epoch	f	0
471		28 MITCHELL STREET	83579189		118		0	epoch	f	0
472		143 WEST TERRACE	82117319		118		0	epoch	f	0
473		81 VINE STREET	82692952		118		0	epoch	f	0
474		4 GRACE PLACE	82316455		118		0	epoch	f	0
475		33 BROAD STREET	83624521		118		0	epoch	f	0
476		UNIT 7/118 BROUGHAM PLACE	82672060		118		0	epoch	f	0
477		1 ASHBOURNE	82720285		118		0	epoch	f	0
478		21/12-26 WILLCOX STREET	82316260		118		0	epoch	f	0
479		15 MEDINDIE LANE	82691133	MEDINDIE			2081	Thu Feb 26 20:02:08 1998 CST	f	0
480		59 HOWARD STREET	83326873		118		0	epoch	f	0
481		12 CHURCHER STREET	83447398		118		0	epoch	f	0
482		13 WAKEHAM STREET	82240759		118		0	epoch	f	0
483		3 DOLLMAN STREET	82741696	GOODWOOD			2569	Fri Mar 06 21:37:39 1998 CST	f	0
484		21 BROUGHTON AVENUE	82976884		118		0	epoch	f	0
485		26 CLAXTON STREET	82122458		118		0	epoch	f	0
486		60 BRIDGE STREET	8330723		118		0	epoch	f	0
487		31 CLARKE STREET	83646914		118		0	epoch	f	0
488		32 HAMLEY STREET	84101691	ADELAIDE			2087	Thu Feb 26 21:05:48 1998 CST	f	0
490	NEW CUSTOMER	tynte street	82232001		120		0	epoch	f	0
492		69 HARROW ROAD	83621767	ST PETERS			2117	Fri Feb 27 17:28:13 1998 CST	f	0
493		1 CHILDERS COURT	82390218				0	epoch	f	0
494		UNIT 42/217 FROME STREET	83592385	ADELAIDE			2399	Tue Mar 03 23:39:36 1998 CST	f	0
495		24 GRAY STREET	82126404				0	epoch	f	0
496		101 YOUNG STREET	83579010	UNLEY		OFF GEORGE STREET	1924	Mon Feb 23 18:34:53 1998 CST	f	0
497		42 HARROW ROAD	83623553				0	epoch	f	0
498		51 ELMO AVENUE	82713226	WESTBOURNE PK		$1.00 DELIVERY	2211	Sat Feb 28 20:47:11 1998 CST	f	0
499	SAN GIORGIO'S PIZZERIA	217 RUNDLE ST	82231700				0	epoch	f	0
500		175 OG ROAD	83656605				0	epoch	f	0
501		13 GILLES STREET	83313399				0	epoch	f	0
502		22 LITTLE WAKEFIELD STREET	83622874	KENT TOWN			1689	Thu Feb 19 18:19:50 1998 CST	f	0
503		37 OSMOND STREET	83467973				0	epoch	f	0
504		10 SELBY STREET	82310673			OFF GOVER STREET	0	epoch	f	0
505		2A RUGBY STREET	83621895				0	epoch	f	0
506		LEVEL 2 187 RUNDLE STREET	82232288				0	epoch	f	0
507		3/24 WAKEFIELD STREET	83320404				0	epoch	f	0
508		102 CHILDERS STREET	82671978	NORTH ADELAIDE			1398	Sat Feb 14 02:22:59 1998 CST	f	0
509		51 GLEN OSMOND ROAD	82721222				0	epoch	f	0
510		29 RUNDLE STREET	83629969				0	epoch	f	0
511		18A MARION STREET	83593323				0	epoch	f	0
512		3/275 GOODWOOD ROAD	82722705				244	epoch	f	0
513		349 ANGAS STREET	83592265				0	epoch	f	0
514		6 BENNETT STREET	83519512	HILTON	118	VISA 4564150050195117  04/98	2502	Thu Mar 05 20:52:35 1998 CST	f	0
515		UNIT 2/155 WAYMOUTH STREET	82313192	ADELAIDE	118	FRONT DOOR\
	1285	Thu Feb 12 01:15:08 1998 CST	f	0
516		15 BLACKBURN STREET	82323350				0	epoch	f	0
517		56 CARDWELL STREET	83592554			RIPPED THE DRIVER OFF, THEY SAID THAT WE AGREED TO TEN DOLLARS WHEN THE VALUE OF THE PIZZA WAS $16.60	0	epoch	f	0
518		34 OLIVE STREET	82741694			RAISE ROLLER DOOR	0	epoch	f	0
519		210 GILLES STREET	82231153				0	epoch	f	0
520		3 SALTER STREET	83612141				0	epoch	f	0
521		6 STAMFORD STREET	83579050				0	epoch	f	0
522		78 STURT STREET	82215364				0	epoch	f	0
523		7/20 PORTER STREET	82710842				0	epoch	f	0
524		37 MYRTLE STREET	82693418				0	epoch	f	0
525		104 WATTLE STREET	83734209				0	epoch	f	0
526		UNIT 4/5 STURDEE STREET	82692004	BROADVIEW	118		1504	Sun Feb 15 22:54:26 1998 CST	f	0
527		17 LOCH STREET	83620944				0	epoch	f	0
528	ADELAIDE PARINGA MOTEL	15 HINDLEY ST	82311000	ADELAIDE		RM 104 ANN-MARIE\
	1715	Fri Feb 20 00:06:11 1998 CST	f	0
529		6B JANE STREET	82694345				0	epoch	f	0
530		284 CROSS ROAD	82719079				0	epoch	f	0
531		29 FIFESHIRE STREET	83384223				0	epoch	f	0
532	CROWN AND SEPTOR HOTEL	KING WILLIAM STREET	82124159				0	epoch	f	0
533		4 CLAREMONT STREET	83519571	MILE END	118		1503	Sun Feb 15 22:36:37 1998 CST	f	0
534		18/268 HALIFAX STREET	82322050	ADELAIDE			2350	Tue Mar 03 00:45:31 1998 CST	f	0
535		12 WHITE AVENUE	82721629				0	epoch	f	0
536		17 ARNOLD STREET	82726969	PARKSIDE			1197	Tue Feb 10 00:42:39 1998 CST	f	0
537		FLAT 3/63 CHURCHILL ROAD	83445632	PROSPECT			2315	Mon Mar 02 02:25:41 1998 CST	f	0
538		4-21 WAKEFIELD STREET	83631395				0	epoch	f	0
539		13A TOMSEY STREET	82321667				0	epoch	f	0
540		135 STANLEY STREET	82390169	NORTH ADELAIDE			2456	Thu Mar 05 00:51:03 1998 CST	f	0
541		107 MCKINNON PARADE	82672147				0	epoch	f	0
542		3/3 STEWART PLACE	82676434				0	epoch	f	0
543	RIVIERA BAKERY	96 HAYWOOD AVENUE	82340720				0	epoch	f	0
544		UNIT 2/355A ANGAS STREET	82150355	ADELAIDE	118		2542	Fri Mar 06 17:31:08 1998 CST	f	0
545		4 KIMBER TERRACE	82933515				0	epoch	f	0
546		6A FIRST AVENUE	83613629				0	epoch	f	0
547	SCALES FISH CAFE	119 WALKERVILLE TERRACE	83448311				0	epoch	f	0
548		5/6 KENT ROAD	83715274				0	epoch	f	0
549		180A GOODWOOD ROAD	82727798	GOODWOOD			2084	Thu Feb 26 20:17:48 1998 CST	f	0
550		7 HOWARD GROVE	83465147				0	epoch	f	0
551		1/189 PROSPECT ROAD	83445475				0	epoch	f	0
552		82 KING WILLIAM STREET	82318035				0	epoch	f	0
553		38/217 FROME STREET	82235074				0	epoch	f	0
554		16 MANSFIELD STREET	82672484	NORTH ADELAIDE	118		607	Thu Jan 29 22:19:53 1998 CST	f	0
555		32 WILSON AVENUE	833612639				0	epoch	f	0
556		55 PERCY STREET	82692124				0	epoch	f	0
557		110 FLINDERS STREET	83593336			SIDE DOOR	0	epoch	f	0
558		6/70 FINNIS STREET	82675980				0	epoch	f	0
559		20 MACLAREN STREET	82232164	ADELAIDE	118		813	Mon Feb 02 19:40:21 1998 CST	f	0
560		403 CARRINGTON STREET	82234081	ADELAIDE	118		2029	Wed Feb 25 19:17:16 1998 CST	f	0
561		31 GAGE STREET	83696331				0	epoch	f	0
562		21MANN TERRACE	82672785				0	epoch	f	0
563		11 ELLA STREET	82724620				0	epoch	f	0
564		47 ORMOND AVENUE	84315653				0	epoch	f	0
565		20 ELY PLACE	82321867				0	epoch	f	0
566		3/16 COTTON STREET	83447584	FITZROY	118		2088	Thu Feb 26 21:28:16 1998 CST	f	0
567		14 WINFRED STREET	82313524				0	epoch	f	0
568		78 STURT STREET	82117993				0	epoch	f	0
569		13 HUME STREET	83592669				0	epoch	f	0
570		24 YELTANA AVENUE	83318434				0	epoch	f	0
571		2-20 ROBERTS STREET	82741083				0	epoch	f	0
572		21 UNION STREET	83633370				0	epoch	f	0
573		28 ALBERMARLE AVENUE	83613405				0	epoch	f	0
574		18 TUCKER STREET	82235927				0	epoch	f	0
575		3-240 FLINDERS STREET	82328339				0	epoch	f	0
576		16 BLACKBURN STREET	82231318				0	epoch	f	0
577		13 ANGUS STREET	82715581				0	epoch	f	0
578		37 KINGSTON AVENUE	83528419				0	epoch	f	0
579		45 KINGSTON TERRACE	83618231				154	epoch	f	0
580		65 TENTH AVENUE	83633148	JOSLIN			2417	Wed Mar 04 17:24:43 1998 CST	f	0
581		12 MILNER ROAD	84433494				0	epoch	f	0
582		137 GRANGE ROAD	83402911				0	epoch	f	0
583		10A MILL STREET	83613656				0	epoch	f	0
584		53 HIGHFIELD AVENUE	83796724				0	epoch	f	0
585		11 STAFFORD STREET	82311285				0	epoch	f	0
586		UNIT 12/230 GOVER STREET	82672462	NTH.ADEL	118		2639	Sat Mar 07 22:11:28 1998 CST	f	0
587		237 PORTRUSH ROAD	83322820				0	epoch	f	0
588		9 WILLIS STREET	83625810				0	epoch	f	0
589		218 FLINDERS STREET	82322105				0	epoch	f	0
590		60 HENRI STREET	83468843				0	epoch	f	0
591		56 PARK STREET	82721024	HYDE PARK	118	KNOCK BECAUSE DOORBELL IS BROKEN	2149	Fri Feb 27 22:29:24 1998 CST	f	0
592		14 GAWLER AVENUE	83403126				0	epoch	f	0
593		UNIT 8/8-20 WAKEFIELD STREET	83612403				0	epoch	f	0
594		26 CHESSER STREET	82235013				0	epoch	f	0
595		44 BAGAT AVE	84435253				73	epoch	f	0
596		10 / 20 WHEATON ROAD	82779236		141		74	epoch	f	0
597		40 ARCHER ST	82675080				150	epoch	f	0
598		49A MACLAREN STREET	82235922				0	epoch	f	0
599	ADELAIDE BANK	90 KING WILLIAM STREET	83006355	ADELAIDE		AT DOOR PRESS BOTTOM BUZZER\
	2462	Thu Mar 05 01:28:31 1998 CST	f	0
600		9 BRAESIDE AVENUE	83383138				0	epoch	f	0
601		39 FARNHAM ROAD	82973219				0	epoch	f	0
602		3 HAMPSTEAD ROAD	83421354				0	epoch	f	0
603		220 FROM STREET	82322896				0	epoch	f	0
604		276 CARRINGTON STREET	82323765				0	epoch	f	0
605		3 TREVELYAN STREET	83578152	WAYVILLE			1659	Wed Feb 18 22:54:50 1998 CST	f	0
606		22 BYRON PLACE	82319336	ADELAIDE	118		1016	Fri Feb 06 21:23:16 1998 CST	f	0
607		5 FREE STREET	83625254				0	epoch	f	0
608	LOTTERIES	23 RUNDLE MALL	82055508				0	epoch	f	0
609		30 SHEFFIELD STREET	82716485				0	epoch	f	0
610		74 CRAIG STREET	84433938				0	epoch	f	0
611		U2/10 OXFORD STREET	83629974				0	epoch	f	0
612		11 HARE CRESCENT	82772048	PANORAMA	118	$ 4.00 DELIVERY FEE	1719	Fri Feb 20 00:42:25 1998 CST	f	0
613		4 SARAH COURT	84451718				0	epoch	f	0
614		119 SYDENHAM ROAD	84312111				0	epoch	f	0
615		11 HOBSONS PLACE	84102564				0	epoch	f	0
616		32 RICHMOND ROAD	82727969				0	epoch	f	0
617		60 KINGSTON TERRACE	83618587				0	epoch	f	0
618		4/5 FLINDERS STREET	83625547				0	epoch	f	0
619		1 NORTH TERRACE	83622722				0	epoch	f	0
620		4 CHELMSFORD	82977575				0	epoch	f	0
621		U2/161 BEULAH ROAD	83645408				190	epoch	f	0
622		U1/5 FIRST AVENUE	83714904				0	epoch	f	0
623		41 BARKER ROAD	83420167				0	epoch	f	0
624		121 DEVEREUX ROAD	83796561				0	epoch	f	0
625		4-3 GALWAY AVE	83511472				93	epoch	f	0
626		2-3 TRELOAR AVE	83324932	KENSINGTON GDNS		$ 1.00 DELIVERY FEE	1162	Mon Feb 09 03:34:19 1998 CST	f	0
627		11-17 MARY STREET	82727247	UNLEY			2161	Sat Feb 28 01:02:19 1998 CST	f	0
628		33 HUME LANE	0417820747				0	epoch	f	0
629		38 SCOTT STREET	82710718	PARKSIDE			2171	Sat Feb 28 02:26:01 1998 CST	f	0
630		2-7 LAMONT STREET	83403965	RENOWNE PK	118	$1.00 DELIVERY FEE\
	1909	Mon Feb 23 01:07:46 1998 CST	f	0
631		6-83 TUSMORE AVE	83328619				0	epoch	f	0
632		19 BLANDEN AVENUE	83632995				0	epoch	f	0
633		138 GILLES STREET	82313399	ADELAIDE		UP GILLES ST TOWARDS PULTENEY ST, TURN LEFT INTO STEPHENS BEHIND TONKINS	1921	Mon Feb 23 17:12:40 1998 CST	f	0
634		11A HUME STREET	82320935				0	epoch	f	0
635	GLENSIDE HOSPITAL	FULLARTON ROAD	83031111	EASTWOOD		EASTWOOD CLINIC 1ST BUILDING ON RIGHT\
FOR LUKE\
	1655	Wed Feb 18 22:20:46 1998 CST	f	0
636		22 DUNKS STREET	82719796				0	epoch	f	0
637		9/20 ADDISON ROAD	82979672	BLACKFOREST	118		0	epoch	f	0
638		6/195 YOUNG STREET	82741109	UNLEY		ON SALISBURY STREET - UPSTAIRS	1226	Tue Feb 10 21:14:42 1998 CST	f	0
639		24 COMMERCIAL ROAD	82729861				0	epoch	f	0
640		RUNDLE STREET	83592540	ADELAIDE	118	TOP BUZZER - DIAGONALLY ACROSS BOTTOM OF MURAL	2226	Sat Feb 28 23:45:33 1998 CST	f	0
641		252 GLEN OSMOND ROAD	83799455	FULLARTON			2362	Tue Mar 03 18:05:12 1998 CST	f	0
642		35 SECOND AVENUE	83622586	ST PETERS		WHEN THE DRIVER GOT TO THE HOUSE HE DIDN'T PAY THE CORRECT AMOUNT AND SAID THAT ROBYN AUTHORISED IT.\
\
	1177	Mon Feb 09 20:50:00 1998 CST	t	0
643		40 KINTORE STREET	83528079	MILE END			1902	Mon Feb 23 00:20:21 1998 CST	f	0
644		153 STRANGEWAYS TERRACE	82674331				0	epoch	f	0
645		15 CHARLOTTE STREET	83592560	ADELAIDE			2203	Sat Feb 28 19:51:39 1998 CST	f	0
646		104 FISHER STREET	82722948	FULLARTON			566	Thu Jan 29 00:10:46 1998 CST	f	0
647		26/41 HURTLE SQUARE	82233525				0	epoch	f	0
648		577 NORTH EAST ROAD	83655892				0	epoch	f	0
649		3/103 KING WILLIAM ROAD	82728678				0	epoch	f	0
650		28A NINTH AVENUE	83623965				0	epoch	f	0
651		11-17 MARY STREET	28277247				0	epoch	f	0
652		3/259 MARION ROAD	83511381				251	epoch	f	0
653		293 GILBERT STREET	82313562				0	epoch	f	0
654		U5/372 FULLARTON ROAD	83382339				0	epoch	f	0
655		U6/9 HOCKING COURT	82316045	ADELAIDE	118		554	Wed Jan 28 21:34:41 1998 CST	f	0
656		4 CHELMSFORD STREET	82977573				0	epoch	f	0
657	WAI	22 FAIRMONT AVENUE	0414551049	BLACK FOREST			1341	Fri Feb 13 02:21:56 1998 CST	f	0
658		44 north tce	83621291				100	epoch	f	0
659		unit 3/76 STURT STREET	84104255	ADELAIDE			1962	Tue Feb 24 00:56:20 1998 CST	f	0
660		UNIT16/388CARRINGTON STREET	82326746	ADELAIDE			2033	Wed Feb 25 20:08:51 1998 CST	f	0
661		221 WATTLE STREET	82722509				107	epoch	f	0
662		90 george st	83332311			she claimed that there was anc on pizza and then she wanted more credit	0	epoch	f	0
663		53 CUMMINGS ST	84435437				0	epoch	f	0
664		18 murray st	83670171	NORTH ADELAIDE			1847	Sun Feb 22 02:55:14 1998 CST	f	0
665		252 giles st	82320784				0	epoch	f	0
666		U1-2 JULIA CRT	83442874	ADELAIDE	118		1228	Tue Feb 10 22:12:30 1998 CST	f	0
667		105 CARLTON PDE	84433381				0	epoch	f	0
668	CORK AND CLEAVER RESTAURANT	2 BEVINGTON RD	83798091	GLENUNGA			2582	Sat Mar 07 00:38:46 1998 CST	f	0
669		9 HAWKER ST	83402172	BOWDEN			1193	Mon Feb 09 23:53:58 1998 CST	f	0
670		10-26 COMMERCIAL RD	82722075	HYDE PK			2274	Sun Mar 01 19:17:05 1998 CST	f	0
671		10-1 RIVER ST	83624371				117	epoch	f	0
672		ROYAL ADELAIDE HOSPITAL	82224569			WARD Q6	119	epoch	f	0
673		38 ROMALO AVE	83317308			$1.00 DELIVERY 	120	epoch	f	0
674		18 RUTHVEN AVE	82126001	ADELAIDE			2543	Fri Mar 06 17:49:24 1998 CST	f	0
675		16 TRIMMER ST	82741080				122	epoch	f	0
676		62 WATSON AVE	83646424	ROSE PK	118		1053	Sat Feb 07 18:21:45 1998 CST	f	0
677		9 STANDARD AVE	83468500			2 FREE GB NEXT TIME THEY ORDER DUE TO THE PIZZA ARRIVING IN 1 HOUR	0	epoch	f	0
678		246 HALIFAX ST	82510080				0	epoch	f	0
679		UNIT 8/355 ANGAS STREET	82233383	ADELAIDE			1139	Sun Feb 08 22:05:00 1998 CST	f	0
680		U8-88 HEWITT AVENUE	84310133		118		237	epoch	f	0
681	SASA	134 WAYMOUTH STREET	84104455	ADELAIDE	118	UPSTAIRS\
	0	epoch	f	0
682		69 WELLER STREET	83578127		118		0	epoch	f	0
683		18 MURRY STREET	83670177				0	epoch	f	0
684		UNIT 32/87 MARY STREET	82772027				0	epoch	f	0
685	HAVLOCK HOTEL	162 HUTT STREET	82233680				0	epoch	f	0
686		55 HAMPTON ROAD	82931432				0	epoch	f	0
687	WAKEFIELD HOSPITAL	WAKEFIELD STREET	84053440	ADELAIDE		TO EMERGENCY FOR STEVE	2229	Sun Mar 01 00:20:44 1998 CST	f	0
688		UNIT 5 42 BRIDGE STREET	83317274	KENSINGTON	118	TURN DOWN GROVE PLACE	659	Fri Jan 30 21:17:14 1998 CST	f	0
689		109 A KENSINGTON ROAD	83643592				191	epoch	f	0
690		1 CLIFTON ST	83620762				0	epoch	f	0
691		UNIT 2/210 GOVER STREET	82671395	ADELAIDE	118	DRIVE DOWN A LANE	1821	Sat Feb 21 21:38:33 1998 CST	f	0
692		UNIT 31/62 WILLIAM STREET	83322012	NORWOOD			2240	Sun Mar 01 01:57:29 1998 CST	f	0
693		4 DACOSTA AVENUE	83420475				0	epoch	f	0
694		FLAT 11/191 CARRINGTON STREET	82324773	ADELAIDE	118		1760	Fri Feb 20 21:31:42 1998 CST	f	0
695		59 WHITMORE SQUARE	82316278	ADELAIDE			2638	Sat Mar 07 21:51:57 1998 CST	f	0
696		6 MORRIS ROAD	82663660				0	epoch	f	0
697		5B STEPHENS AVENUE	83521335				0	epoch	f	0
698		69 HACKNEY ROAD	83634597	HACKNEY		around the back\
\
	1431	Sat Feb 14 19:43:56 1998 CST	f	0
699		2 RUTHVEN AVENUE	82118605				0	epoch	f	0
700		136 WRIGHT STREET	82311392				0	epoch	f	0
701		UNIT11/11-18 PENNINGTON	82390328	NORTH ADELAIDE			1003	Fri Feb 06 18:20:30 1998 CST	f	0
702		10 CREMORNE STREET	82729923	FULLARTON			2624	Sat Mar 07 18:50:44 1998 CST	f	0
703		20 WILLIAMS AVENUE	84315540	DULWICH			2364	Tue Mar 03 18:41:40 1998 CST	f	0
704		UNIT 2-29 CROSS ROAD	82726390				0	epoch	f	0
705		5-116 SECOND AVE	83633046	ROYSTON PARK			1666	Thu Feb 19 00:00:04 1998 CST	f	0
706		8 AROHA TCE	82932928			$1.00 DELIVERY	129	epoch	f	0
707		65 VINE ST	83443767	PROSPECT		CHEQUE CAN BE ACCEPTED (GEORGE)\
	1826	Sat Feb 21 22:27:18 1998 CST	f	0
708		81 ALBERT ST	82712232				132	epoch	f	0
709		196 HALIFAX ST	82240135				134	epoch	f	0
710	R.A.H	SECURITY	82225415	ADELAIDE		LEVEL 3 X-RAY\
FOR MARK-- MEET AT THE CASUALTY ENTRANCE AND\
GO TO SECURITY AND ASK FOR MARK FROM X-RAY	2154	Sat Feb 28 00:07:47 1998 CST	f	0
711	R.A.H - CASUALTY	CASUALTIES	82224000	ADELAIDE		B\
	2536	Fri Mar 06 03:27:49 1998 CST	f	0
712		1 GREER ST	83579752	HYDE PK		RIGHT HOUSE WITH LIGHT ON	2413	Wed Mar 04 02:33:23 1998 CST	f	0
713		18 TOBRUK AVE KENSINGTON PK	83322516	KENSINGTON PK			2224	Sat Feb 28 23:22:20 1998 CST	f	0
714		368 HALIFAX ST	82231515				140	epoch	f	0
715		43 RICHMOND ST	83624346	HACKNEY			2304	Mon Mar 02 00:30:32 1998 CST	f	0
716		U65/40 PARK TCE	83441317	ADELAIDE	118		1046	Sat Feb 07 03:02:50 1998 CST	f	0
717		U3/34 RAILWAY TCE NORTH	82721987				143	epoch	f	0
718		93 EDWARD ST	83510256		141		144	epoch	f	0
719		18 DUDLEY ST	82712015				145	epoch	f	0
720	MCCLELLAND	TRAVELODGE STH TCE CITY RM 26	82232744	ADELAIDE			1630	Wed Feb 18 16:52:45 1998 CST	f	0
721		58 BREAKER ST	83326442				149	epoch	f	0
722		7 PHILLIPS ST	83322742				151	epoch	f	0
723		228 north tce	83035000	ADELAIDE			1757	Fri Feb 20 21:22:29 1998 CST	f	0
724		10/15 WAKEFIELD ST	83627850	KENT TOWN			2530	Fri Mar 06 02:09:50 1998 CST	f	0
725		11 FULLARTON RD	83632090	KENT TOWN			1696	Thu Feb 19 20:30:31 1998 CST	f	10
726		40 smith street	83526195		118		155	epoch	f	0
727	JACKSON MOTOR INN	G373 GLEN OSMOND ROAD	83791601	GLEN OSMOND		JACKSON MOTOR INN  ROOM 49\
\
\
\
\
\
	1274	Wed Feb 11 21:57:03 1998 CST	f	0
728		66 stephen tce	83627391				161	epoch	f	0
729	EARL OF LEICESTER HOTEL	85 LEICESTER ST	82715700	PARK SIDE			2586	Sat Mar 07 01:07:25 1998 CST	f	0
730		97 KING WILLIAM STREET	82104246				165	epoch	f	0
731		21-87 MARY STREET	83577017				166	epoch	f	0
732		2-90 ASHBROOK AVENUE	83324468				168	epoch	f	0
733		2-252 SEAVIEW ROAD	83538969				0	epoch	f	0
734	BAKKAS	94 ARTHUR STREET	015507666				170	epoch	f	0
735	CRASY HORSE	HINDLEY ST	0	ADELAIDE			2431	Wed Mar 04 20:14:25 1998 CST	f	10
736		38 HUNTRISS STREET	82340643				173	epoch	f	0
737		143 WEST TERRACE	84102343	ADELAIDE	118		625	Fri Jan 30 02:40:33 1998 CST	f	0
738	MACDONALDS	61 NORTH EAST RD	82695220				176	epoch	f	0
739		2-19 BOLINGBROKE GROVE	84314309				178	epoch	f	0
740		22 CLYDE ST	83734025	PARKSIDE			1742	Fri Feb 20 18:41:12 1998 CST	f	0
741		8 ELM AV	83540640				181	epoch	f	0
742		1-29 AVENUE RD	83794832	FREWVILLE	118		458	Mon Jan 26 18:18:53 1998 CST	f	0
743	DIRECTORS HOTEL	247 GOUGER ST	82318484	ADELAIDE		RM 417 HELENA\
	2225	Sat Feb 28 23:44:10 1998 CST	f	0
744		1 RAWLINGS AVE	83523119	FLINDERS PK		$ 1.00 DELIVERY FEE\
	2219	Sat Feb 28 22:20:57 1998 CST	f	0
745		16 CONYNGHAM ST	83383099				185	epoch	f	0
746		34 DUKES LANE	82322479				186	epoch	f	0
747		1 GREER ST	23579752				0	epoch	f	0
748		5 PULLIENE AVE	83798462			$1.00 DELIVERY FEE\
	193	epoch	f	0
749		16 PASSMORE ST	84435394			$1.00 DELIVERY FEE	194	epoch	f	0
750		14-3 WITTER ST	82346736			$1.00 DELIVERY FEE	197	epoch	f	0
751		1-74 WARD ST	83618773				200	epoch	f	0
752		22B CLIFTON ST	83624926				201	epoch	f	0
753		45 PERCY ST	83445070			\
	202	epoch	f	0
754		4-362 ANGAS ST	82323839	ADELAIDE			2559	Fri Mar 06 20:05:31 1998 CST	f	0
755	PATRICK	2/6 DEVON STREET NORTH	0411759229	GOODWOOD			2257	Sun Mar 01 17:06:35 1998 CST	f	0
756		47A  ORSMOND STREET	83407110				206	epoch	f	0
757		3 DUKE ST	83313551				209	epoch	f	0
758		FLAT 42/11 CHARLICK  CCR	82326648	ADELAIDE			1009	Fri Feb 06 20:01:19 1998 CST	f	0
759		SEC THE ADVERTISER	82062304	ADELAIDE		SECURITY\
IN SPORT DEPT\
	2122	Fri Feb 27 18:14:45 1998 CST	f	0
760		27 PROVOST STREET	82676314				212	epoch	f	0
761		124 WILLIAM STREET	83332881	NORWOOD	118		1478	Sun Feb 15 18:01:00 1998 CST	f	0
762		88 PIRIE STREET	82322772				217	epoch	f	0
763		3 CHISHOLM AVENUE	83646123	BURNSIDE		DID NOT PAY FOR LAST DELIVERY ON THE 25/01/98\
\
$1.00 DELIVERY FEE\
	397	Sun Jan 25 03:36:52 1998 CST	t	0
764		1 BROWN STREET	83463573	BROMPTON			2604	Sat Mar 07 03:10:28 1998 CST	f	0
765		5 BELFORD AVENUE	83400824	DEVON PK			2497	Thu Mar 05 20:18:57 1998 CST	f	0
766		42 CLIFTON STREET	83441623				225	epoch	f	0
767	PETER	143 FISHER STREET	0412385775				226	epoch	f	0
768		3 GORDON RD	82976573			$ 1 DELIVERY FEE	0	epoch	f	0
769		42 PALMERSTON ROAD	82719331				229	epoch	f	0
770		UNIT 14/174 BARTON TCE WEST	82673958				230	epoch	f	0
771		4 MORRELL ST	0414751256			$ 1.00 DELIVERY FEE	231	epoch	f	0
772		65 CONYNGHAM ST	83015333				232	epoch	f	0
773		38 BLYTH ST	82741825	PARK SIDE	118		2577	Fri Mar 06 23:59:30 1998 CST	f	0
774	TOM	8 NEWCUT AVE	0417684532	HECTORVILLE		\
	289	Thu Jan 22 23:38:50 1998 CST	f	0
775		633 GREENHILL RD	83318649		118		236	epoch	f	0
776		22 HAMLEY ST	82310838	ADELAIDE	118		494	Tue Jan 27 01:05:48 1998 CST	f	0
777		18 SHERRIF ST	83517936			$ 1.00 DELIVERY FEE	240	epoch	f	0
778		4 BALLARA STREET	82345430	MILE END			1150	Mon Feb 09 00:06:03 1998 CST	f	0
779		229 KENSINGTON RD	83317841			\
\
	0	epoch	f	0
780		18 ALBERT ST	83629488				0	epoch	f	0
781		1/45 FASHODA ST	83579585	HYDE PK			2065	Thu Feb 26 03:00:51 1998 CST	f	0
782		11 EUSTON TCE	83404603	CROYDON			2001	Tue Feb 24 23:13:17 1998 CST	f	0
783		4/2 BURTON ST	83522480				0	epoch	f	0
784		16 FLINDERS ST	83627567	KENT TOWN		\
	2369	Tue Mar 03 19:35:31 1998 CST	f	0
785		150 DRAYTON ST	83404035	BOWDEN			849	Tue Feb 03 19:56:26 1998 CST	f	0
786		unit 40 49 leader st	82724825				245	epoch	f	0
787		17/30 phillip	83326204				0	epoch	f	0
788		47 hill st	82720787				247	epoch	f	0
789		5 barr smith st	83613623	TUSMORE			2615	Sat Mar 07 17:43:45 1998 CST	f	0
790		10 meredith street	82931040				248	epoch	f	0
791		2/22 holder ave	83522426	RICHMOND	118		2260	Sun Mar 01 17:46:09 1998 CST	f	0
792		5 torrens st	83622957	COLLEGE PARK	118		2281	Sun Mar 01 20:05:06 1998 CST	f	0
793	AMBASSADORS "POKIES"	king william street	82314331	ADELAIDE		GEORGE\
	2051	Thu Feb 26 00:23:08 1998 CST	f	0
794		11 harris st	84314637	NORWOOD			2500	Thu Mar 05 20:41:48 1998 CST	f	0
795		214 greenhill rd	82726254	EASTWOOD			481	Mon Jan 26 21:55:34 1998 CST	f	0
796		15/7 regent st	83622969				0	epoch	f	0
797		4/42 charlick circuit	82233727	ADELAIDE			2485	Thu Mar 05 18:51:46 1998 CST	f	0
798		14 cotham ave	83324732	KENSINGTON PK			2342	Mon Mar 02 23:26:32 1998 CST	f	0
799	JAMES	38 the park way	017863573	ADELAIDE	118		1149	Sun Feb 08 23:55:22 1998 CST	f	0
800		9 eldon st	83460816			$1.00 delivery fee	0	epoch	f	0
801		233 EAST TCE UNIT 15 TOP FLOOR	82320932				258	epoch	f	0
802		326 YOUNG ST	82729761				0	epoch	f	0
803	CHRIS	432 north east road	0417600116				259	epoch	f	0
804		llkjkjjkk	82117895				0	epoch	f	0
805		10a salisbury gds	82766090				0	epoch	f	0
806		16 ELEVENTH ST	83404002				0	epoch	f	0
807		25 HAIG ST	83693338		118		262	epoch	f	0
808		12 hook street	123123123	FERRY PARK			263	Thu Jan 22 18:50:00 1998 CST	f	0
809	METRO HOLDEN	1 PORT RD	83549555	ADELAIDE			264	Thu Jan 22 19:03:00 1998 CST	f	0
810		10 DAMORA COURT	82240506	ADELAIDE			265	Thu Jan 22 19:13:55 1998 CST	f	0
811		7/5 ROBERT ST	83730468	UNLEY			267	Thu Jan 22 19:27:58 1998 CST	f	0
812		15 VERDUN ST	83332396	BEULAH PK	118		2041	Wed Feb 25 21:07:57 1998 CST	f	0
813		I8 AUGUSTA ST	82580012	ADELAIDE	118		277	Thu Jan 22 21:31:32 1998 CST	f	0
814		78 VICTORIA ST	83420751	PROSPECT			321	Fri Jan 23 21:31:39 1998 CST	f	0
815	ADELAIDE POST OFFICE	GOUGER ST	82162588	ADELAIDE		DELIVER AT 10.25 P.M. EACH PIZZA CUT INTO 12 PIECES\
	1316	Thu Feb 12 21:14:17 1998 CST	f	0
816		46 REGENT ST	84316373	KENSINGTON			280	Thu Jan 22 21:56:41 1998 CST	f	0
817	ELLIS	RICHMOND HOTEL 128 RUNDLE MALL ROOM 53	82234044	ADELAIDE			282	Thu Jan 22 22:17:13 1998 CST	f	0
818		5 GARLAND ST	83511901	GLANDORE		$1.00\
	284	Thu Jan 22 22:51:06 1998 CST	f	0
819		105 MAKINNON PD	82392065	NTH ADEL			285	Thu Jan 22 23:03:35 1998 CST	f	0
820		EXIBITION CAR PK NTH TCE	82106739	ADELAIDE			2100	Fri Feb 27 00:00:53 1998 CST	f	0
821		3/2 DONEGAL ST	83321521	NORWOOD			291	Thu Jan 22 23:51:28 1998 CST	f	0
822		24 MILTON AVE	83381107	FULLARTON			293	Fri Jan 23 00:04:35 1998 CST	f	0
823		18 ALBERT ST	82713657	GOODWOOD			295	Fri Jan 23 00:44:25 1998 CST	f	0
824		323 GLYNBURN RD	83640738	ADELAIDE	118		0	Fri Jan 23 00:48:21 1998 CST	f	0
825		R.A.H SECURITY	82224207	ADELAIDE			2109	Fri Feb 27 01:59:42 1998 CST	f	0
826		2/9 ELDERSLIE AVE	82432629	FITZROY			298	Fri Jan 23 01:30:49 1998 CST	f	0
827		ADVERTISER LANE	82062001	ADELAIDE		THE ADVERTISER\
GO TO SECURITY DESK	301	Fri Jan 23 01:52:04 1998 CST	f	0
828		23-41 GALWAY AVE  (ARNOTTS)	84074100	MARLESTON			303	Fri Jan 23 02:13:24 1998 CST	f	0
829		R.A.H.  EMERGENCY	82220000	ADELAIDE			369	Sat Jan 24 21:24:02 1998 CST	f	0
830		4/19 FINNIS ST	82673032	NTH ADEL			2153	Fri Feb 27 23:38:50 1998 CST	f	0
831		199A STURT ST (ENTER LITTLE STURT ST	82316803	ADELAIDE			306	Fri Jan 23 03:42:46 1998 CST	f	0
832		61 RICHMOND ST	83628197	COLLEGE PK			307	Fri Jan 23 17:36:37 1998 CST	f	0
833		17 DUNSTAN AVE	83666777	KENSINGTON PK			2627	Sat Mar 07 19:04:48 1998 CST	f	0
834		41A CALIFORNIA ST	82697374	NAILSWORTH		\
\
	1969	Tue Feb 24 17:25:37 1998 CST	f	0
835		4/17 MARLBOROUGH ST	83624029	COLLEGE PK			0	Fri Jan 23 19:09:32 1998 CST	f	0
836	MARCO	98 HENLEY BEACH RD PEN HALL MOTEL RM 9	0412030091	MILE END			313	Fri Jan 23 19:40:21 1998 CST	f	0
837		APART. 21/42 EAST END CHARLICK CIRCUIT	83593343	ADELAIDE			315	Fri Jan 23 19:53:45 1998 CST	f	0
838		49 delamere ave	82725849	TORRENS PK			0	Fri Jan 23 20:11:04 1998 CST	f	0
839	DAVID	21 AVENUE RD	0411580021	FREWVILLE			1330	Thu Feb 12 23:40:42 1998 CST	f	0
840		23 MAUD ST	82725846	UNLEY			1871	Sun Feb 22 19:29:09 1998 CST	f	0
841		355 PORTRUSH RD	83332756	TOORAK GDS			319	Fri Jan 23 21:19:16 1998 CST	f	0
842		160 YOUNG ST	82722082	PARK SIDE			320	Fri Jan 23 21:22:09 1998 CST	f	0
843		31 CARLISLE RD	82712882	WESTBOURNE PK		$ 1.00 DELIVERY FEE\
`	323	Fri Jan 23 22:14:18 1998 CST	f	0
844		2-70 MAESBURY ST	83328059	KENSINGTON			372	Sat Jan 24 21:53:26 1998 CST	f	0
845		31 FULLARTON RD	83622888	KENT TOWN			325	Fri Jan 23 22:25:10 1998 CST	f	0
846		361A CARRINGTON ST	82236487	ADELAIDE			329	Fri Jan 23 23:06:10 1998 CST	f	0
847		52 AVENUE RD	83377139	GLYNDE			333	Fri Jan 23 23:58:03 1998 CST	f	0
848		50 BROOKER TCE	84433761	RICHMOND			2012	Wed Feb 25 01:09:45 1998 CST	f	0
849		U6 10 EDSALL ST	83632070	NORWOOD			477	Mon Jan 26 21:07:33 1998 CST	f	0
850		86 WEST ST	83460354	BROMPTON			339	Sat Jan 24 01:07:18 1998 CST	f	0
851		20 DERWENT AVE	83646918	MAGILL		$1.00 DELIVERY FEE\
\
	868	Tue Feb 03 23:31:47 1998 CST	f	0
852		unit 8/6 vailima crt	83627519	HACKNEY			343	Sat Jan 24 01:51:07 1998 CST	f	0
853		unit 5/78 hayward  ave	83517903	TORRENSVILLE		\
\
\
	344	Sat Jan 24 02:06:53 1998 CST	f	0
854		106 REID AVE	83656386	HECTORVILLE		$1.00 DELIVERY FEE	346	Sat Jan 24 02:19:00 1998 CST	f	0
855	ROYAL ADEL HOSPITAL	NORTH TCE	82225057	ADELAIDE		GO TO CASUALTY	347	Sat Jan 24 02:25:53 1998 CST	f	0
856		101 HILL ST	83735624	NETHERBY			1017	Fri Feb 06 21:35:29 1998 CST	f	0
857		48 HOWARD TCE	83642410	HAZELWOOD PK		$1.00 DELIVERY FEE	351	Sat Jan 24 03:15:37 1998 CST	f	0
858		20 HYDE ST	83327463	TUSMORE			1264	Wed Feb 11 19:36:21 1998 CST	f	0
859	GEORGE BASHEER	103 AYERS AVE	83741293	MELROSE PARK			0	Sat Jan 24 16:53:35 1998 CST	f	0
860		dsd	82988888	ADELAIDE			0	Sat Jan 24 17:05:27 1998 CST	f	0
861	TIP TOP MOBIL SERVICE STATION	195 richmond road	84439120	RICHMOND			1789	Sat Feb 21 03:26:34 1998 CST	f	0
862		34325345	394875983475983475	ADELAIDE			355	Sat Jan 24 18:04:01 1998 CST	f	0
863		14 florence st	83797237	FULLARTON			356	Sat Jan 24 19:10:48 1998 CST	f	0
864		41556	11236	ADELAIDE			357	Sat Jan 24 19:13:40 1998 CST	f	0
865		17 milton ave	83790756	FULLARTON			2291	Sun Mar 01 22:32:17 1998 CST	f	0
866	HINDLEY PARKROYAL RM 307	hindley street	82315552	ADELAIDE			1078	Sat Feb 07 23:05:40 1998 CST	f	0
867	BREAKERS POOL HALL	9 LIGHT SQUARE	82317922	ADELAIDE			362	Sat Jan 24 19:50:22 1998 CST	f	0
868		181 PORTRUSH RD	84311087	MAYLANDS			711	Sat Jan 31 21:26:48 1998 CST	f	0
869		17 WELLER ST	82722562	GOODWOOD			366	Sat Jan 24 20:42:15 1998 CST	f	0
870		UNIT 2-31 ROSE ST	83443683	PROSPECT			1440	Sat Feb 14 22:37:27 1998 CST	f	0
871		27 boulton street	82392774	NORTH ADELAIDE			373	Sat Jan 24 22:53:27 1998 CST	f	0
872		unit 3 - 36 rundle street	83622943	KENT TOWN			376	Sun Jan 25 00:05:55 1998 CST	f	0
873		5-10 DACOSTA AVE	83442661	PROSPECT			965	Thu Feb 05 23:11:29 1998 CST	f	0
874		16-45 THORNTON ST	83612631	KENSINGTON			378	Sun Jan 25 00:28:51 1998 CST	f	0
875		unit 1 48 clifford st	83517253	TOTORRENSVILLE			380	Sun Jan 25 00:54:13 1998 CST	f	0
876		unit4 /2-4 kent rd	82978982	KESWICK			381	Sun Jan 25 00:57:43 1998 CST	f	0
877		34 STRATHSPEY AVE	83799744	HAZELWOOD PK		$1.00DELIVERY\
\
	1912	Mon Feb 23 01:59:28 1998 CST	f	0
878		UNIT 4-58 SUTTON TCE	82931259	MARLESTON			2301	Sun Mar 01 23:56:52 1998 CST	f	0
879		367 CARRINGTON ST	82324780	ADELAIDE			1466	Sun Feb 15 04:13:48 1998 CST	f	0
880	RAH	x	82224473	ADELAIDE		mick x-ray dept for 5.30pm	2612	Sat Mar 07 16:29:23 1998 CST	f	0
881		64 HIGHBURY ST	82693998	PROSPECT			1776	Sat Feb 21 01:33:46 1998 CST	f	0
882		20 TYNTE ST	82676501	NORTH ADELAIDE			2170	Sat Feb 28 02:22:14 1998 CST	f	0
883		7 SWIFT AVE	83640361	DULWICH			393	Sun Jan 25 02:37:00 1998 CST	f	0
884	ROYAL COACH MOTOR INN	DEQUEVILLE TCE	83625676	ADELAIDE		ROOM 306\
	394	Sun Jan 25 02:47:05 1998 CST	f	0
885		76 WATSON AVE	84315661	ROSE PARK			395	Sun Jan 25 03:17:58 1998 CST	f	0
886	LASING	261 GOUGER ST	84102266	ADELAIDE			1514	Mon Feb 16 01:04:10 1998 CST	f	0
887		1LINCOLM AVE	82667606	MANNINGHAM			398	Sun Jan 25 03:46:26 1998 CST	f	0
888	THE ADVERTIZER	ADVERTISER LANE	82062420	ADELAIDE			2273	Sun Mar 01 19:10:26 1998 CST	f	0
889		unit 5 8 hill st	12345	BURNSIDE		Deliver at 7pm\
$1 dollar delivery charge	405	Sun Jan 25 17:59:57 1998 CST	f	0
890		unit 2/12 parsons street	82712604	WAYVEILLE			406	Sun Jan 25 18:02:21 1998 CST	f	0
891		1 DIMORA CT	82240304	ADELAIDE			408	Sun Jan 25 19:20:43 1998 CST	f	0
892		UNIT9/20 WAKEFIELD ST	83643453	KENT TOWN			1434	Sat Feb 14 20:26:43 1998 CST	f	0
893		10 BROAD STREET	83632039	MARDEN			410	Sun Jan 25 19:42:08 1998 CST	f	0
894		28 BROUGHAM COURT	83618172	NORTH ADELAIDE			411	Sun Jan 25 20:05:16 1998 CST	f	0
895		76 GOVER STREET	82675237	NORTH ADELAIDE			556	Wed Jan 28 22:26:00 1998 CST	f	0
896		UNIT 3/371 ANGAS ST	82321870	ADELAIDE			1829	Sat Feb 21 22:47:24 1998 CST	f	0
897		43A HENLEY STREET	82346635	MILE END			420	Sun Jan 25 20:37:14 1998 CST	f	0
898	STAMFORD PLAZA	NORTH TERRACE RM1902		ADELAIDE			2371	Tue Mar 03 20:04:56 1998 CST	f	0
899		UNIT 3 15 VINCENT PLACE	83592254	ADELAIDE			422	Sun Jan 25 21:07:38 1998 CST	f	0
900		6 WELLINGTON TERRACE	83381136	FULLARTON			423	Sun Jan 25 21:19:24 1998 CST	f	0
901	THE AMBASSADOR HOTEL	107 KING WILLIAM STREET	82314331	ADELAIDE		room 308\
	2642	Sat Mar 07 22:59:42 1998 CST	f	0
902		UNIT 27/22 BROAD ST	83625947	MARDEN		CENTRE BLOCK OF UNITS GO RIGHT TO THE TOP AND AROUND THE BACK\
	425	Sun Jan 25 21:34:07 1998 CST	f	0
903		34 CUDMORE TERRACE	82973839	MARLESTON			2372	Tue Mar 03 20:06:34 1998 CST	f	0
904	DDD	dddd	0.75	ADELAIDE			0	Sun Jan 25 22:01:16 1998 CST	f	0
905	YANNI	8 NEWCUT AVE	019410481	HECTORVILLE			2282	Sun Mar 01 20:09:59 1998 CST	f	0
906		28 ST JOHN ST	82237932	ADELAIDE			428	Sun Jan 25 22:26:22 1998 CST	f	0
907		8 ALNWICK STREET	0414447013	HEATHPOOL			430	Sun Jan 25 23:11:56 1998 CST	f	0
908		84 EIGHTH AVE	83628183	JOSLIN		GO TO THE BACK 	2312	Mon Mar 02 01:47:10 1998 CST	f	0
909		12 MARIAN ST	83618882	NORTH ADELAIDE		AT REAR OF NO 10 MARIAN STREET\
\
	2297	Sun Mar 01 23:03:57 1998 CST	f	0
910		71 STATENBOROUGH ST	84312006	ERINDALE			434	Sun Jan 25 23:57:06 1998 CST	f	0
911		U4 15 FLINDERS ST	83624439	KENT TOWN			435	Mon Jan 26 00:31:04 1998 CST	f	0
912		10 FIRST AVE	84313438	ST MORRIS			436	Mon Jan 26 00:36:22 1998 CST	f	0
913		197 CROSS RD	83579187	CUMBERLAND PARK			437	Mon Jan 26 00:49:59 1998 CST	f	0
914		41/45 KING W. ROAD	83663614	NORTH ADELADE			438	Mon Jan 26 00:53:01 1998 CST	f	0
915		UNIT 4/39 BURWOOD AVE	83420476	NAILSWORTH			440	Mon Jan 26 01:07:26 1998 CST	f	0
916		106 SIXTH AVENUE UNIT 4	83631372	JOSLIN			442	Mon Jan 26 01:30:35 1998 CST	f	0
917		306 CARRINGTON ST	82322686	ADELAIDE			2492	Thu Mar 05 19:56:32 1998 CST	f	0
918		U3 28 ELSTON ST	82349362	BROOKLYN PK			444	Mon Jan 26 01:56:48 1998 CST	f	0
919		300 HALIFAX STREET	83593480	ADELAIDE			445	Mon Jan 26 02:07:09 1998 CST	f	0
920		48 YOUNG AVE	83468715	WEST HINDMARSH			447	Mon Jan 26 02:52:08 1998 CST	f	0
921		34 MONTTELIAR ST	82720734	PARKSIDE			448	Mon Jan 26 03:09:11 1998 CST	f	0
922		9 GIFFORD ST	83517267	TORRENSVILLE			2383	Tue Mar 03 21:08:33 1998 CST	f	0
923		25 BANK ST	82318881	ADELAIDE		ADJACENT CASINO MOTEL\
	2578	Sat Mar 07 00:02:56 1998 CST	f	0
924		unit 3/26 robsart st	82719044	PARKSIDE			453	Mon Jan 26 17:11:09 1998 CST	f	0
925	PEDROS	41-45 K.W.RD (RM. 14)	0419850969	NTH.ADEL			454	Mon Jan 26 17:34:57 1998 CST	f	0
926		5 CHARLES ST	82741845	UNLEY			455	Mon Jan 26 17:43:16 1998 CST	f	0
927		10  COLLINS ST	82692146	COLLINSWOOD			2630	Sat Mar 07 19:44:07 1998 CST	f	0
928		32 TUTT AVE	83730884	KINGSWOOD			457	Mon Jan 26 17:54:06 1998 CST	f	0
929		1 WARNER CRS	82616626	KLEMZIG			459	Mon Jan 26 18:24:21 1998 CST	f	0
930		22 LYNTON AVE	83735377	ADELAIDE	118		1436	Sat Feb 14 20:31:13 1998 CST	f	0
931		41-45 K.W RD APARTMENT 14	0419050969	NORTH ADELAIDE			463	Mon Jan 26 18:44:12 1998 CST	f	0
932		30 REGENT ST	82716253	PARK SIDE			464	Mon Jan 26 18:51:09 1998 CST	f	0
933	UNION ST CARPARK	across the road		ADELAIDE			466	Mon Jan 26 18:58:07 1998 CST	f	0
934	VICTORIA PARK CHILD CARE CENTRE	163 FULLARTON RD	83319971	ROSE PARK			468	Mon Jan 26 19:12:53 1998 CST	f	0
935		83 NINTH AVENUE	83627280	JOSLIN			470	Mon Jan 26 19:48:55 1998 CST	f	0
936		UNIT 4 61 HARVEY STREET	83444751	COLLINSWOOD			0	Mon Jan 26 20:15:29 1998 CST	f	0
937		5 PALOMINO ROAD	83324890	AULDANA		4 DELIVERY DELIVER 9.50PM\
	0	Mon Jan 26 20:36:00 1998 CST	f	0
938		17 WELLINGTON ST	83512238	GLANDORE			479	Mon Jan 26 21:34:37 1998 CST	f	0
939		21A SIXTH AVENUE	83631473	ST PETERS			2505	Thu Mar 05 21:02:38 1998 CST	f	0
940		R.A.H. (RESIDENTIAL WING) ROBYN	0417301232	ADELAIDE			482	Mon Jan 26 22:11:44 1998 CST	f	0
941		UNIT 1 /4CLEVE ST	83330207	NORWOOD			485	Mon Jan 26 22:30:12 1998 CST	f	0
942		3-17 CASTLE ST	82321805	ADELAIDE			2659	Sun Mar 08 02:19:58 1998 CST	f	0
943		UNIT 6/115 ALEXANDRA AVE	8332764	TOORAK GARDENS			491	Mon Jan 26 23:46:26 1998 CST	f	0
944		UNIT 4/46 GLADSTONE RD	82349337	MILE END			492	Mon Jan 26 23:52:37 1998 CST	f	0
945		UNIT 1/17 THORNTON ST	83642512	KENSINGTON			1880	Sun Feb 22 20:28:55 1998 CST	f	0
946		11 SPENCER ST	83521710	COWANDILLA			495	Tue Jan 27 01:47:21 1998 CST	f	0
947		19 ALDRIDGE TCE	83714494	MARLESTON			496	Tue Jan 27 02:02:52 1998 CST	f	0
948		1 LETTIE ST	83441763	BLAIR ATHOL			497	Tue Jan 27 02:16:26 1998 CST	f	0
949	R.A.H.	EMERGENCY	STEVE	ADELAIDE		GO TO EMERGENCY AND ASK FOR SURESH	1097	Sun Feb 08 03:19:23 1998 CST	f	0
950		23 HENLEY ST	0411665169	PAYNEHAM			500	Tue Jan 27 03:21:55 1998 CST	f	0
952		27 CAPPER ST	83630046	KENT TOWN			2068	Thu Feb 26 17:53:17 1998 CST	f	0
953		hfgjkgk	11111	ADELAIDE			0	Tue Jan 27 20:16:26 1998 CST	f	0
954		MCBEATH ST	83657574	HECTORVILLE			1386	Sat Feb 14 00:57:16 1998 CST	f	0
955		24A STEPHENS ST	82232447	ADELAIDE			2570	Fri Mar 06 21:40:52 1998 CST	f	0
956		73 VINE ST	83445782	PROSPECT			933	Thu Feb 05 17:40:55 1998 CST	f	0
957		10 WESTBURY ST	83631534	HACKNEY			748	Sun Feb 01 13:08:17 1998 CST	f	0
958		14 WILLSMORE	82431688	BEVERLEL			521	Tue Jan 27 22:52:23 1998 CST	f	0
959		39 MAIN ST	82729946	EASTWOOD			2264	Sun Mar 01 18:20:52 1998 CST	f	0
960		sdrdtvyh	2222	ADELAIDE			0	Tue Jan 27 23:42:53 1998 CST	f	0
961		2\\177 angas st	82248819	ADELAIDE			525	Tue Jan 27 23:57:54 1998 CST	f	0
962		63 west st	82340801	TORRENSVILLE			526	Wed Jan 28 00:22:38 1998 CST	f	0
963		2\\10 swan ave	82665583	KLEMZIG			728	Sun Feb 01 01:09:30 1998 CST	f	0
964	THEO	8/6 harley st	018088378	COWANDILLA			530	Wed Jan 28 02:08:11 1998 CST	f	0
965		21 BALHAM AVE	82719940	KINGSWOOD			2191	Sat Feb 28 18:38:00 1998 CST	f	0
966		50 ROSE STREET	82345658	MILE END			536	Wed Jan 28 19:24:25 1998 CST	f	0
967		29/12-26  WILLCOX ST	84102002	ADELAIDE			537	Wed Jan 28 19:30:26 1998 CST	f	0
968		24 TORRENS AVENUE	83400842	WEST HINDMARSH			538	Wed Jan 28 19:34:44 1998 CST	f	0
969	APARTMENTS ON PARK	SOUTH TERRACE	82233457	ADELAIDE		ROOM 16	2488	Thu Mar 05 19:08:00 1998 CST	f	0
970		13 KENT ROAD	83510093	KESWICK			543	Wed Jan 28 19:50:41 1998 CST	f	0
971		5 AVELANDE AVE	83643480	TRINITY GDNS			544	Wed Jan 28 19:59:22 1998 CST	f	0
972		20 GILBERT STREET	83420120	GILBERTON			545	Wed Jan 28 20:06:34 1998 CST	f	0
973	TINA CREA	THE HYATT ROOM NO 2019	0419816796	ADELAIDE			546	Wed Jan 28 20:13:39 1998 CST	f	0
974	TONY	CRAZY HORSE		ADELAIDE			0	Wed Jan 28 20:41:07 1998 CST	f	0
975		69 EIGHTH AVENUE	83628075	ST PETERS			550	Wed Jan 28 20:44:34 1998 CST	f	0
976		17 OSBORNE ST	83621048	HACKNEY			552	Wed Jan 28 20:56:57 1998 CST	f	0
977		15 CROSS STREET	82715688	FULLARTON			1611	Wed Feb 18 00:13:32 1998 CST	f	0
978		UNIT 2 2B LEIGHTON AVENUE	83690248	KLEMZIG		$1.00 DEL	2670	Sun Mar 08 03:31:04 1998 CST	f	0
979		6/ 12 KATHERINE	83383457	FULLARTON			561	Wed Jan 28 23:33:09 1998 CST	f	0
980		UNIT 8/15 HATHERLEY AVENUE	82727036	HYDE PK			742	Sun Feb 01 03:46:22 1998 CST	f	0
981		46 SHELDON STREET	83626367	NORWOOD			563	Wed Jan 28 23:47:38 1998 CST	f	0
982		UNIT 6/24 WAKEFIELD STREET	83645576	KENT TOWN			565	Wed Jan 28 23:58:12 1998 CST	f	0
983		26 MOORLANDS RD	83362496	HECTORVILLE			568	Thu Jan 29 00:29:44 1998 CST	f	0
984		UNIT 8/390 BURBRIDGE ROAD	82343714	BROOKLYN PARK			570	Thu Jan 29 00:50:04 1998 CST	f	0
985		334 HALIFAX ST	82323812	ADELAIDE		VISA VISA VISA VISA 4557 015000045291\
EXPIRY 01/99	1420	Sat Feb 14 18:16:51 1998 CST	f	0
986		19 GRAY STREET	82121902	ADELAIDE			573	Thu Jan 29 01:23:02 1998 CST	f	0
987		4/42 ANZAC.HGH.WAY	83714665	EVERAD PARK			2061	Thu Feb 26 02:21:08 1998 CST	f	0
988		12 BURLEY GRIFFIN BOULEVARD	83469715	BROMPTON			2112	Fri Feb 27 03:25:58 1998 CST	f	0
989		1 LEICESTER STREET	83736723	PARKSIDE		ON CORNER OF KENNELWORTH\
\
	1497	Sun Feb 15 20:43:18 1998 CST	f	0
990		U15 30 CHATHAM RD	82938885	KESWICK			1886	Sun Feb 22 21:03:35 1998 CST	f	0
991		8 ROSSINGTON AVE	83793924	MYRTLE BANK		4546051141752267 05/98	2119	Fri Feb 27 17:44:46 1998 CST	f	0
992		U5\\15 WAKEFIELD ST	019676662	ADELAIDE			585	Thu Jan 29 17:42:00 1998 CST	f	0
993		7/2 GRAND ST	83655462	HECTORVILLE		$1.00 DELIVERY\
\
	586	Thu Jan 29 18:08:22 1998 CST	f	0
994		214 GREENHILL RD	82727677	EASTWOOD			587	Thu Jan 29 18:54:18 1998 CST	f	0
995		28 WHITMORE SQUARE (ST.VINCENT DE PAUL)	82312250	ADELAIDE			2470	Thu Mar 05 02:09:27 1998 CST	f	0
996		27/21 MOORE ST	82315225	ADELAIDE			592	Thu Jan 29 19:34:48 1998 CST	f	0
997	ROBYN	R.A.H. (RESIDENTIAL WING )		ADELAIDE			597	Thu Jan 29 20:02:55 1998 CST	f	0
998		28 LOUISA ST	83592678	ADELAIDE			0	Thu Jan 29 20:04:43 1998 CST	f	0
999		U3\\49 PHILLIS ST	83634108	MAYLANDS			599	Thu Jan 29 20:32:48 1998 CST	f	0
1000		79 HARROW RD	83631172	ST PETERS			1755	Fri Feb 20 20:40:20 1998 CST	f	0
1001		2/ 2 FASHODA ST	82724520	HYDE PK			1988	Tue Feb 24 20:55:51 1998 CST	f	0
1002		35 FINNISS ST	82673482	NTH ADEL			612	Thu Jan 29 23:39:03 1998 CST	f	0
1003		19 GRANT AVE	83613709	ROSE PK			615	Fri Jan 30 00:20:07 1998 CST	f	0
1004		U6 115 ALEXANDRA AVE	83322764	TOORAK GARDENS			617	Fri Jan 30 00:49:27 1998 CST	f	0
1005		88 WRIGHT ST	82118000	ADELAIDE			621	Fri Jan 30 01:45:57 1998 CST	f	0
1006		U1 124 ROSE TCE	82728796	WAYVILLE			2593	Sat Mar 07 01:29:36 1998 CST	f	0
1007		1/15-21 HAMLEY ST	0417331855	ADELAIDE			1582	Tue Feb 17 03:38:02 1998 CST	f	0
1008		U22 11 CHARLOT TCE	82321742	ADELAIDE			630	Fri Jan 30 04:08:47 1998 CST	f	0
1009		22 beasley  street	83624661	MARDEN			2546	Fri Mar 06 18:34:03 1998 CST	f	0
1010		233 east trce	82231637	ADELAIDE			634	Fri Jan 30 18:17:35 1998 CST	f	0
1011	THE MANSIONS APARTMENTS	unit 41 / 21 pulteney street	82322214	ADELAIDE			635	Fri Jan 30 18:19:50 1998 CST	f	0
1012		42 WINCHESTER ST	83625342	ST PETERS			636	Fri Jan 30 18:24:58 1998 CST	f	0
1013		UNIT 8/23 HART TCE	83443602	GILBERTON			637	Fri Jan 30 18:29:51 1998 CST	f	0
1014		2\\43 OSMOND TRCE	83313680	NOORWOOD			639	Fri Jan 30 18:47:49 1998 CST	f	0
1015		77 CASTLE ST	82714303	PARKSIDE			2555	Fri Mar 06 19:53:31 1998 CST	f	0
1016		37 CHARLES STREET	82717619	UNLEY			641	Fri Jan 30 19:14:26 1998 CST	f	0
1017		1-12 A KING ST	82938290	GLANDORE		$ 1.00 DELIVERY FEE	644	Fri Jan 30 19:30:02 1998 CST	f	0
1018		90 GEORGE ST	83579606	PARKSIDE			1310	Thu Feb 12 19:31:38 1998 CST	f	0
1020		UNIT5/24 WAKEFIELD ST	83311040	KENT TOWN		VISA 4564500104904452 EXP0799	1978	Tue Feb 24 19:27:06 1998 CST	f	0
1021		63 MACLAREN ST	82321550	ADELAIDE			2279	Sun Mar 01 19:57:28 1998 CST	f	0
1022		68 TUSMORE AVENUE	83325349	TUSMORE		GRANNY FLAT AT BACK 4564 500101843141 EXP 04/99\
	665	Fri Jan 30 22:13:08 1998 CST	f	0
1023		shop 7 austin pl (back entrance of pultney st)	82325440	ADELAIDE			666	Fri Jan 30 22:34:47 1998 CST	f	0
1024	APARTMENTS ON THE PARK	274 south tce	82230533	ADELAIDE		APARTMENT 54\
RECEPTION WILL PAY FOR THE PIZZA. GO THERE\
	1941	Mon Feb 23 20:24:35 1998 CST	f	0
1025		8 ENTERPRISE STREET	83579121	HYDE PK		HERB BREAD INSTEAD OF COKE\
	2636	Sat Mar 07 20:48:18 1998 CST	f	0
1026		50 BRIDGE ST	84315553	KENSINGTON			864	Tue Feb 03 23:00:22 1998 CST	f	0
1027		16 STEPHEN ST	82236463	ADELAIDE			1777	Sat Feb 21 01:34:41 1998 CST	f	0
1028		40 TORRENS AVE	83463091	WEST HINDMARSH			677	Sat Jan 31 01:21:42 1998 CST	f	0
1029		26 GRACE ST	0412300162	GOODWOOD		EVELINA PLEASE CHECK THIS NUMBER WHILE I AM ON THE PHONE\
\
	678	Sat Jan 31 01:29:01 1998 CST	f	0
1030		31A WILSON ST	83522291	ADELAIDE	118		684	Sat Jan 31 15:41:03 1998 CST	f	0
1031		106 LEICESTER ST	82712072	PARKSIDE			683	Sat Jan 31 02:32:43 1998 CST	f	0
1032	COMPUTER STEVE	17 SONGLARK GRV	83586263	FLAGSTAFF HILL			0	Sat Jan 31 16:00:05 1998 CST	f	0
1033	EMERGENCY	R.A.H	82225640	ADELAIDE			688	Sat Jan 31 17:48:17 1998 CST	f	0
1034		7 /11 WAKEFIELD ST	83634214	KENT TOWN			1408	Sat Feb 14 03:08:04 1998 CST	f	0
1035		124 LEICESTER ST	83732557	PARKSIDE			690	Sat Jan 31 18:06:28 1998 CST	f	0
1036		UNIT 2/4 HARLEY ST	82724538	HYDE PK			1109	Sun Feb 08 17:50:13 1998 CST	f	0
1037		33 SWIFT AVE	84314859	DULWICH			2506	Thu Mar 05 21:18:14 1998 CST	f	0
1038		flat 42/11-15 CHARLICK CIRCUIT	82328376	ADELAIDE			696	Sat Jan 31 19:24:13 1998 CST	f	0
1039		1/60 PARK TCE	83446702	OVINGHAM			698	Sat Jan 31 19:38:41 1998 CST	f	0
1040		255 HINDLEY ST (RM 237) HOLIDAY INN	017918813	ADELAIDE			699	Sat Jan 31 19:42:07 1998 CST	f	0
1041		7 RUSHWORTH ST	83496824	BLAIR ATHOL		$1.00 DELIVERY\
\
	1819	Sat Feb 21 21:25:35 1998 CST	f	0
1042		12 GLADSTONE RD	83518163	MILE END			2071	Thu Feb 26 18:41:57 1998 CST	f	0
1043		1/3 CHURCH ST	82725921	HIGATE			704	Sat Jan 31 20:33:18 1998 CST	f	0
1044		10 EVE ST	83364727	HECTORVILLE		$1.00 DELIVERY\
	705	Sat Jan 31 20:51:59 1998 CST	f	0
1045	TIVOLI HOTEL	261 PIRIE ST		ADELAIDE		ROOM 12	0	Sat Jan 31 21:03:51 1998 CST	f	0
1046		270 HALIFAX ST	82328089	ADELAIDE			1638	Wed Feb 18 18:37:05 1998 CST	f	0
1047		3A RANDOLPH ST	83523874	THEBARTON			710	Sat Jan 31 21:22:40 1998 CST	f	0
1048		110 STEPHEN TCE	83447739	GILBERTON			712	Sat Jan 31 22:22:03 1998 CST	f	0
1049		UNIT 51 APARTMENTS ON THE PARK SOUTH TERRACE	018757173	ADELAIDE			714	Sat Jan 31 22:32:57 1998 CST	f	0
1050		47 LYNTON AVE	82716338	MILLSWOOD			715	Sat Jan 31 22:55:12 1998 CST	f	0
1051		110 MILLS TCE	82392730	NORTH ADELAIDE			2278	Sun Mar 01 19:53:11 1998 CST	f	0
1053	MERIDIEN	21-39 MELBOURNE ST	82673033	NORTH ADELAIDE		GIVE RECEIPT\
\
SUITE 20	718	Sat Jan 31 23:31:18 1998 CST	f	0
1054		28 GWYNNE ST	0418825195	FIRLE			2287	Sun Mar 01 20:47:38 1998 CST	f	0
1055		4 VERRON AVE	84435980	HILTON			723	Sun Feb 01 00:07:56 1998 CST	f	0
1056		12A FLORA ST	83620251	STEPNEY			725	Sun Feb 01 00:28:23 1998 CST	f	0
1057		33 HARDY ST	0419837342	GOODWOOD			726	Sun Feb 01 00:55:30 1998 CST	f	0
1058		UNIT 6/389 GLYNBURN RD	84314235	KENSINGTON PARK			729	Sun Feb 01 01:13:43 1998 CST	f	0
1059		1 REECE AVE	82690372	KLEMZIG			730	Sun Feb 01 01:15:26 1998 CST	f	0
1060		61 HARROW RD	83621433	ST PETERS			731	Sun Feb 01 01:32:33 1998 CST	f	0
1061		22 FULLER ST	82714916	PARK SIDE			732	Sun Feb 01 01:42:44 1998 CST	f	0
1062		1 SWIFT AVE	83317384	DULWICH			733	Sun Feb 01 02:08:06 1998 CST	f	0
1063		4/31 BRIDGE ST	83645413	KENSINGTON			735	Sun Feb 01 02:43:08 1998 CST	f	0
1064		66 JOHNS RD	83441293	PROSPECT			736	Sun Feb 01 02:46:10 1998 CST	f	0
1065	TRAVELODGE	SOUTH TERRACE		ADELAIDE		RM 1004\
	2266	Sun Mar 01 18:31:07 1998 CST	f	0
1066	RECEPTION- O'CONNELL ST INN	O'CONNELL ST	82390766	NORTH ADELAIDE			743	Sun Feb 01 04:09:04 1998 CST	f	0
1067	PENHALL MOTEL	98 HENLEY BEACH ROAD	8436449	MILE END		ROOM 8 FOR VINCE\
\
\
	2272	Sun Mar 01 19:06:16 1998 CST	f	0
1068		3 ACACIA STREET	82694498	MEDINDIE			749	Sun Feb 01 17:24:22 1998 CST	f	0
1069		29 KNIGHT STREET	83469671	ALLENBY GDNS			750	Sun Feb 01 17:42:39 1998 CST	f	0
1070		67 SIXTH AVENUE	83632739	ST PETERS			752	Sun Feb 01 18:20:58 1998 CST	f	0
1071		5 junction st	83519610	MILE END			753	Sun Feb 01 18:30:44 1998 CST	f	0
1072	THE ADVERTISER	BACK LANE		ADELAIDE		SECURITY\
	2265	Sun Mar 01 18:25:49 1998 CST	f	0
1073		6 RALPH STREET	83527692	WEST RICHMOND			756	Sun Feb 01 18:38:37 1998 CST	f	0
1074		APART. ON PARK SOUTH TERRACE	82230519	ADELAIDE		APARTMENT 19\
1ST LEVEL\
\
\
\
\
\
\
	758	Sun Feb 01 18:51:35 1998 CST	f	0
1075		290 MARION RD	82937812	NETLEY			1808	Sat Feb 21 19:14:25 1998 CST	f	0
1076		28 STEPHEN TERRACE	83621456	ST PETERS			762	Sun Feb 01 19:24:43 1998 CST	f	0
1077	CHANNEL 7	PARK TERRACE	83427725	GILBERTON		FRONT DOOR\
ASK FOR ANDREW\
	764	Sun Feb 01 19:47:20 1998 CST	f	0
1078		329 GLEN OSMOND ROAD	83798202	GLENUNGA			2594	Sat Mar 07 01:31:12 1998 CST	f	0
1079	TRAVEL LODGE HOTEL	SOUTH TERRACE	82232744	ADELAIDE		ROOM 312 IN THE HIGH RISE	2204	Sat Feb 28 19:53:31 1998 CST	f	0
1080		66 church terrace	82692321	WALKERVILLE			768	Sun Feb 01 20:19:56 1998 CST	f	0
1081		29 ADA STREET	82233813	ADELAIDE			2539	Fri Mar 06 17:10:18 1998 CST	f	0
1082		18 AUGUSTA STREET	83635175	MAYLANDS	118		1676	Thu Feb 19 01:29:03 1998 CST	f	0
1083		94 CURRIE ST	82117539	ADELAIDE			776	Sun Feb 01 21:40:01 1998 CST	f	0
1084	ADELAIDE MERIDIAN	21 MELBOURNE STREET	83673033	NORTH ADELAIDE		ROOM 20	780	Sun Feb 01 22:19:08 1998 CST	f	0
1085		357 CARRINGTON STREET	82240248	ADELAIDE			1887	Sun Feb 22 21:05:00 1998 CST	f	0
1086		40 CHARLES STREET	83624504	NORWOOD			782	Sun Feb 01 22:42:12 1998 CST	f	0
1087		313 MORPHET ST	82123220	ADELAIDE			783	Sun Feb 01 22:58:37 1998 CST	f	0
1088		U 1/6 FRADERICK  STREET	83516005	CLARENCE PARK			787	Sun Feb 01 23:35:00 1998 CST	f	0
1089		57 BEATRICE STREET	82691856	PROSPECT			788	Sun Feb 01 23:55:54 1998 CST	f	0
1090	GRAY	56 CARDWELL STREET	0417827265	ADELAIDE			789	Sun Feb 01 23:57:42 1998 CST	f	0
1091		15 HENLEY BEACH ROAD	83519457	MILE END			790	Mon Feb 02 00:10:17 1998 CST	f	0
1092		UNIT 9/137 ANZAC HIGHWAY	82933373	KARRALTA PARK			792	Mon Feb 02 00:36:25 1998 CST	f	0
1093	RICHMOND HOTEL	RUNDLE MALL		ADELAIDE		ROOM 44	1752	Fri Feb 20 20:12:58 1998 CST	f	0
1094		28GROSENER ST	0414455697	GLANDORE			795	Mon Feb 02 00:52:10 1998 CST	f	0
1095		1\\1 BARNES AVE	0419825736	MAGILL			796	Mon Feb 02 01:06:04 1998 CST	f	0
1096		1-5 ALBERT PLACE	83630902	PAYNEHAM			797	Mon Feb 02 01:11:06 1998 CST	f	0
1097	CHANNEL 9	MANSFIELD GATE (OFF TINT ST)	82670145	NORTH ADELAIDE			798	Mon Feb 02 01:26:58 1998 CST	f	0
1098		27 WILCOX STREET	82128015	ADELAIDE		\
	2436	Wed Mar 04 21:01:20 1998 CST	f	0
1099	STORMYS	WAYMOUTH ST		ADELAIDE		\
	2475	Thu Mar 05 03:00:56 1998 CST	f	10
1100	RAH EMERGENCY	NORTH TERACE	82225056	ADELAIDE		ask for DR, RYAN\
	2474	Thu Mar 05 02:59:20 1998 CST	f	0
1101		204 GREENHILL ROAD	82914248	EASTWOOD		ROOM 48	804	Mon Feb 02 03:21:18 1998 CST	f	0
1102		35 GEORGE STREET	82724842	PARKSIDE			806	Mon Feb 02 17:57:04 1998 CST	f	0
1103		52 FLINDERS ST	0417822022	ADELAIDE		4564150230797865\
04/99\
RING BEFORE LEAVE	807	Mon Feb 02 18:00:01 1998 CST	f	0
1104		18 MAIN STREET	82715739	EASTWOOD			1255	Wed Feb 11 18:20:10 1998 CST	f	0
1105		26 SWAN AVENUE	82667420	KLEMZIG			811	Mon Feb 02 19:29:02 1998 CST	f	0
1106		unit 7/ 27 flinders st	83630236	KENT TOWN			812	Mon Feb 02 19:36:52 1998 CST	f	0
1107		3/51 ANGAS STREET	83593191	ADELAIDE			815	Mon Feb 02 20:02:11 1998 CST	f	0
1108		19 MYALL AVE	83318232	KENSINGTON GDNS			2271	Sun Mar 01 19:00:00 1998 CST	f	0
1109		15 HINDMARSH AVENUE	83407774	WEST HINDMARSH			818	Mon Feb 02 20:28:38 1998 CST	f	0
1110		32 LANTIA RD	83401661	CROYDON PK			823	Mon Feb 02 21:52:35 1998 CST	f	0
1111	REGENT ST	APT 28C / 18 BEWES ST	82237660	ADELAIDE		OPP EARL OF ABERDEEN\
	825	Mon Feb 02 22:16:35 1998 CST	f	0
1112		12 SHERIFF ST	83519961	UNDERDALE			826	Mon Feb 02 22:49:52 1998 CST	f	0
1113		24 MAUD ST	82711428	UNLEY			2235	Sun Mar 01 01:04:34 1998 CST	f	0
1114		residential suite r.a.h	0414710634	CITY		KUSMAVI\
	1219	Tue Feb 10 19:04:00 1998 CST	f	0
1115	BARRON TOWNHOUSE	HINDLEY STREET	82118255	ADELAIDE		ROOM 317\
PRESS BELL	837	Tue Feb 03 01:47:22 1998 CST	f	0
1116		MACDONALDS (CORNER GOODWOOD RD CROSS RDS)	82729136	KINGS PK			838	Tue Feb 03 02:27:09 1998 CST	f	0
1117		4/46 BLIGHT ST	83464238	RIDLEYTON			1785	Sat Feb 21 02:48:54 1998 CST	f	0
1118	LUKE	R.A.H.(EMERGENCY)		ADELAIDE			841	Tue Feb 03 03:34:38 1998 CST	f	0
1119	CASINO	NTH.TERACE		ADELAIDE			847	Tue Feb 03 19:46:52 1998 CST	f	0
1120		APARTMENTS ON THE PARK SOUTH TERRACE	0412569994	ADELAIDE		ROOM 58	848	Tue Feb 03 19:53:46 1998 CST	f	0
1121		63 HACKNEY RD (VILLIAGE RET.CENTRE.)	83630600	HACKNEY		DRIVE THROUGH END OF DRIVE WAY AT THE BACK\
\
	855	Tue Feb 03 21:13:01 1998 CST	f	0
1122		90 EIGHTH AVE	83631764	JOSLIN			858	Tue Feb 03 22:09:38 1998 CST	f	0
1123	MR.HALL	FLINDERS LODGE 27 DEQUETIVILLE TCE	83328222	KENT TOWN			859	Tue Feb 03 22:18:55 1998 CST	f	0
1124		254 GILLES ST	82231801	ADELAIDE			861	Tue Feb 03 22:31:43 1998 CST	f	0
1125		6/207 O.G.ROAD (CRN.OG+PAYNEHAM RD)	83366971	MARDEN			1733	Fri Feb 20 02:52:21 1998 CST	f	0
1126		90 LEICESTER ST	83735040	PARK SIDE			2606	Sat Mar 07 03:28:53 1998 CST	f	0
1127		UNIT1/1A ETHEL	83714641	FORRESTVILLE			873	Wed Feb 04 00:19:17 1998 CST	f	0
1128		2 SIXTH AVE	83623919	ST PETERS			1713	Thu Feb 19 23:50:37 1998 CST	f	0
1129	JULIA FARR	103 FISHER ST	0411625747	FULLARTON		GATE 1\
	1328	Thu Feb 12 23:02:10 1998 CST	f	0
1130		10 ABLION TCE	83364978	CAMPBELLTOWN		$1.00 DELIVERY FEE	879	Wed Feb 04 01:59:52 1998 CST	f	0
1131		UNIT 6/1A HARTLAND AVE	0417836497	BLACK FOREST			884	Wed Feb 04 02:36:37 1998 CST	f	0
1132		91 HACKNEY RD	0414825790	HACKNEY			885	Wed Feb 04 02:45:15 1998 CST	f	0
1133		UNIT 3/354 GREENHILL RD	83791863	GLENSIDE			912	Wed Feb 04 22:37:59 1998 CST	f	0
1134		2/29 ASHBROOK AVE	83365176	PAYNEHAM			887	Wed Feb 04 03:12:38 1998 CST	f	0
1135		2 INVERGOWIRE AVE	82714369	FULLARTON			2016	Wed Feb 25 01:57:53 1998 CST	f	0
1136		5A BOSKENNA AVE	83622265	NORWOOD			919	Wed Feb 04 23:56:38 1998 CST	f	0
1137	EDEN MASSAGE	11 FULLARTON ROAD	83625660	KENT TOWN			1633	Wed Feb 18 17:38:10 1998 CST	f	10
1138	BEVELANDER	2/63 MARLBOROUGH STREET	014837264	MALVERN			896	Wed Feb 04 18:12:52 1998 CST	f	0
1139	APARTMENT 15	apart on park south terrace	82230515	ADELAIDE		apartment 15\
	1004	Fri Feb 06 18:37:39 1998 CST	f	0
1140		125A LEADER ST	0412602276	FORESTVILLE	118		2641	Sat Mar 07 22:55:03 1998 CST	f	0
1141		145 CROZIER AVENUE	82771031	MELROSE PARK			905	Wed Feb 04 21:10:58 1998 CST	f	0
1142		57 LEICESTER STREET	82727384	PARKSIDE			1867	Sun Feb 22 18:44:45 1998 CST	f	0
1143		18 GLEN AVENUE	82711456	UNLEY PARK			2423	Wed Mar 04 18:35:37 1998 CST	f	0
1144		68 HARROW RD	83630768	COLLEGE PK			911	Wed Feb 04 22:06:20 1998 CST	f	0
1145		2/27 FLINDERS STREET	8362843	KENT TOWN			913	Wed Feb 04 23:23:58 1998 CST	f	0
1146		11 TRENNERY STREET	84434330	WEST RICHMOND			1523	Mon Feb 16 17:33:07 1998 CST	f	0
1147		11 HUME ST	83592531	ADELAIDE			920	Thu Feb 05 00:09:43 1998 CST	f	0
1148		1/1A ELMS AVE	83518396	RICHMOND			1381	Sat Feb 14 00:26:04 1998 CST	f	0
1149		69 HALLETT ROAD	83640165	BURNSIDE			923	Thu Feb 05 00:44:39 1998 CST	f	0
1150		5 GAILBRAITH COURT	83460951	REKNOWN PARK			924	Thu Feb 05 01:18:16 1998 CST	f	0
1151		6/9 CRAIG STREET	82667078	GREENACRES			925	Thu Feb 05 01:21:41 1998 CST	f	0
1152		52 SHELDON STREET	83634578	NORWOOD			2296	Sun Mar 01 22:58:15 1998 CST	f	0
1153		RAH CASUALTY	82225050	ADELAIDE		EMERGENCY DEPARTMENT\
	1295	Thu Feb 12 02:37:13 1998 CST	f	0
1154		46 TORRENS STREET	83623859	COLLEGE PARK			930	Thu Feb 05 02:20:22 1998 CST	f	0
1155		94 AURTHUR ST	83372094	PAYNEHAM SOUTH			931	Thu Feb 05 02:38:12 1998 CST	f	0
1156		32 ADEL. ARCADE(GROOVE HAIR CUTTERS)	82232900	ADELAIDE		TO BE THERE BY 6:00 PM\
	2479	Thu Mar 05 17:40:09 1998 CST	f	0
1157		22 COKE ST	84314922	NORWOOD			936	Thu Feb 05 18:15:53 1998 CST	f	0
1158		9 CAMPBELL RD	82713137	PARK SIDE			941	Thu Feb 05 19:34:16 1998 CST	f	0
1159		6D/58 WILLIAM ST	84310537	NORWOOD			942	Thu Feb 05 19:37:27 1998 CST	f	0
1160		19 AUGUSTA STREET	82954462	GLENELG			0	Thu Feb 05 19:38:53 1998 CST	f	0
1161		18 KENTON ST	82326468	ADELAIDE			1982	Tue Feb 24 19:58:16 1998 CST	f	0
1162		101 PORT ROAD	83008371	THEBORTONADELAIDE			946	Thu Feb 05 20:09:26 1998 CST	f	0
1163		424 CARRINGTON ST	82323115	ADELAIDE			949	Thu Feb 05 20:20:42 1998 CST	f	0
1164		77 ANZAC.HG.WAY	83515810	ASHFORD			1938	Mon Feb 23 20:01:04 1998 CST	f	0
1165		2 HOMER RD	83512334	CLARENCE PK			956	Thu Feb 05 21:23:58 1998 CST	f	0
1166		130 YOUNG ST	82729770	PARKSIDE			957	Thu Feb 05 21:34:01 1998 CST	f	0
1167		419 GILES ST	0412057251	ADELAIDE			959	Thu Feb 05 21:50:11 1998 CST	f	0
1168		455 PULTENEY ST	82232324	ADELAIDE			963	Thu Feb 05 23:01:42 1998 CST	f	0
1169		7-47 BOSS AVE	83511675	MARLESTON		$1.00 DELIVERY FEE	964	Thu Feb 05 23:05:26 1998 CST	f	0
1170		12 FOUNDRY ST	82728465	GOODWOOD			967	Thu Feb 05 23:36:46 1998 CST	f	0
1171		47 DEVON ST SOUTH	82724584	GOODWOOD			969	Thu Feb 05 23:41:09 1998 CST	f	0
1172		21 POWER STREET	82235658	ADELAIDE			970	Thu Feb 05 23:43:46 1998 CST	f	0
1173		1 TORRENS AVE	82722241	FULLARTON			971	Thu Feb 05 23:58:21 1998 CST	f	0
1174		5/414 CARRINGTON ST	82326625	CITY			973	Fri Feb 06 00:10:10 1998 CST	f	0
1175		57 WINCHESTER ST	82714185	MALVERN			974	Fri Feb 06 00:14:12 1998 CST	f	0
1176		187 ANGAS ST (SEVEN STARS HOTEL)	82236879	ADELAIDE		please knock and wait for answer\
	1334	Fri Feb 13 00:23:02 1998 CST	f	0
1177		6 CLARK ST	83736272	WAYVILLE			976	Fri Feb 06 00:20:33 1998 CST	f	0
1178		42 CASTLE ST	82724684	PARK SIDE			979	Fri Feb 06 00:40:07 1998 CST	f	0
1179		91 HACKNEY RD	83626561	HACKNEY			1211	Tue Feb 10 03:52:39 1998 CST	f	0
1180		19 REGENT ST	82715586	PARKSIDE			2563	Fri Mar 06 20:24:11 1998 CST	f	0
1181		2/29 ASHBROOK AVE	83361576	PAYNEHAM			1282	Thu Feb 12 00:28:08 1998 CST	f	0
1182		63 CONYNGHAM ST	83790444	GLENSIDE			994	Fri Feb 06 03:03:11 1998 CST	f	0
1183	COKE-COLA	LIGHT TCE OFF PORT RD	84969408	THEBARTON	118		2447	Wed Mar 04 23:16:44 1998 CST	f	0
1184	QUEENS ARMS HOTEL	88 WRIGHT ST	0414896104	ADELAIDE			996	Fri Feb 06 03:37:39 1998 CST	f	0
1185		41-9 JERNINGHAM ST	83347741	NTH.ADEL		ENTRANCE FROMLE FEVER 	1085	Sun Feb 08 00:50:06 1998 CST	f	0
1186		12 hugh street	83517759	MILE END			999	Fri Feb 06 17:18:07 1998 CST	f	0
1187		18 AUDLEY AVE	83420239	PROSPECT			1005	Fri Feb 06 18:50:57 1998 CST	f	0
1188		15 GREENWOOD GROVE	83798598	URRBRAE		\
$ 1 DELIVERY FEE\
\
\
\
\
	1008	Fri Feb 06 19:54:18 1998 CST	f	0
1189		JULIA FARR CENTRE - CHELTNHAM STREET ENTERENCE.	015682321	ADELAIDE			1010	Fri Feb 06 20:11:36 1998 CST	f	0
1190		UNIT 5/ 8 HILL	84310523	BURNSIDE			1011	Fri Feb 06 20:14:59 1998 CST	f	0
1191		287 MAIN NORTH RD	83446574	ENFIELD		ONE DOLLAR DELIVERY	2625	Sat Mar 07 18:58:10 1998 CST	f	0
1192		1 OSBORNE ST	83634427	HACKNEY			1280	Thu Feb 12 00:23:42 1998 CST	f	0
1193		APARTMENT 26 11-15 CHARLICK CIRCUIT	82327708	ADELAIDE			1025	Fri Feb 06 23:17:21 1998 CST	f	0
1194		72 YOUNG ST	83732824	PARKSIDE		GLEN OSMOND RD END	1027	Sat Feb 07 00:06:18 1998 CST	f	0
1195		U4 603 SOUTH RD	82934174	EVERAD PARK			1029	Sat Feb 07 00:29:24 1998 CST	f	0
1196		UNIT 6/67 ROBSART ST	82723772	PARKSIDE			1030	Sat Feb 07 00:31:17 1998 CST	f	0
1197	CAFE MEDICI	59 THE PARADE	83627822	NORWOOD			1033	Sat Feb 07 00:56:26 1998 CST	f	0
1198	INTERNATIONAL STUDENT HOSTEL	143 WEST TCE	82117219	ADELAIDE			1034	Sat Feb 07 00:59:24 1998 CST	f	0
1199		UNIT4/2A DULWICH RD	83332117	DULWICH			1037	Sat Feb 07 01:31:19 1998 CST	f	0
1200	HARAJ	U1 15 HANLEY ST	0417331855	ADELAIDE			1039	Sat Feb 07 01:43:58 1998 CST	f	0
1201		49 HAWKER ST	83462409	BROMPTON			1040	Sat Feb 07 01:49:36 1998 CST	f	0
1202		73 EIGHT AVE	83624665	ST PETERS			1041	Sat Feb 07 01:57:39 1998 CST	f	0
1203		5 LISTON ST	83579054	PARKSIDE			2647	Sun Mar 08 00:38:53 1998 CST	f	0
1204		U2 9 ELDERSLIE AVE	83422629	FITZROY			2152	Fri Feb 27 23:32:42 1998 CST	f	0
1205		63 WILPENA AVE	82614648	VALE PARK			1044	Sat Feb 07 02:55:43 1998 CST	f	0
1206		35 KENILWORTH RD	82720449	PARKSIDE			2603	Sat Mar 07 03:06:25 1998 CST	f	0
1207		UNIT1/43 OSMOND TCE	84310171	NORWOOD		3RD DRIVEWAY ON THE LEFT, BEHIND THE ART SCHOOL\
	1724	Fri Feb 20 01:23:41 1998 CST	f	0
1208		25 ROSA ST	82726536	GOODWOOD			1050	Sat Feb 07 17:08:04 1998 CST	f	0
1209		24 WESTBURY ST	83633535	HACKNEY			1351	Fri Feb 13 19:16:00 1998 CST	f	0
1210		U4 18 KENT ROAD	83713992	KESWICK			1057	Sat Feb 07 18:47:09 1998 CST	f	0
1211		69 LANSDOWNE TCE	83442209	WALKERVILLE			1061	Sat Feb 07 19:22:31 1998 CST	f	0
1212		22 ROSA ST	82726312	GOODWOOD			1062	Sat Feb 07 19:26:41 1998 CST	f	0
1213		8 TALLALA TCE	83795252	MYRTLE BANK			1066	Sat Feb 07 20:09:18 1998 CST	f	0
1214		164A GOODWOOD RD	82728477	GOODWOOD			1068	Sat Feb 07 20:51:05 1998 CST	f	0
1215		35 LABRINA AVE	83422732	PROSPECT			1069	Sat Feb 07 20:58:01 1998 CST	f	0
1216		30WELLS ST	83633359	STEPNEY			1278	Thu Feb 12 00:05:24 1998 CST	f	0
1217		82 FISCHER ST	82727073	FULLARTON			1073	Sat Feb 07 21:31:56 1998 CST	f	0
1218		58 MCDONNELL AVE	83460904	WEST HINDMARSH			1074	Sat Feb 07 22:12:53 1998 CST	f	0
1219		UNIT4/11 JOHNSTONE PLACE	83618872	NTH ADEL			2284	Sun Mar 01 20:13:14 1998 CST	f	0
1220		22 GRANDVIEW AVE	83797273	URRBRAE		ONE DOLLAR DELIVERY	1081	Sun Feb 08 00:24:36 1998 CST	f	0
1221	KENTISH ARMS HOTEL	STANLEY ST	82671173	ADELAIDE			1084	Sun Feb 08 00:46:32 1998 CST	f	0
1222		37 THE GROVE	82766143	LOWER MITCHAM		ONE DOLLAR DELIVERY	1088	Sun Feb 08 02:01:15 1998 CST	f	0
1223		35 MAESBURY ST	83332125	KENSINGTON			1090	Sun Feb 08 02:09:07 1998 CST	f	0
1224		25 TRALEE AVE	82667386	BROADVIEW			1092	Sun Feb 08 02:30:28 1998 CST	f	0
1225	83372158	16 HENREY ST		PAYNEHAM			1093	Sun Feb 08 02:36:20 1998 CST	f	0
1226		18 WOODFIELD AVE	83579131	FULLARTON			1094	Sun Feb 08 02:38:33 1998 CST	f	0
1227		45 FREDERICK ST	83465883	WELLAND			1096	Sun Feb 08 03:04:35 1998 CST	f	0
1228		73A SUSSEX ST	82674383	NTH ADELAIDE			1099	Sun Feb 08 03:49:34 1998 CST	f	0
1229	NIGHT TRAIN	9 LIGHT SQUARE	82312252	ADELAIDE			1101	Sun Feb 08 15:39:21 1998 CST	f	0
1230	PARK ROYAL	55 HINDLEY STREET	82315552	ADELAIDE		ROOM 1011\
	1102	Sun Feb 08 16:19:12 1998 CST	f	0
1231		APART. 8 42 CHARLICK CIRCUIT	82233769	ADELAIDE			1106	Sun Feb 08 17:20:18 1998 CST	f	0
1232		15 KENTON STREET	82320142	ADELAIDE			1595	Tue Feb 17 20:12:58 1998 CST	f	0
1233		UNIT 1 32 WARE AVENUE	83656730	MARDEN			1114	Sun Feb 08 18:29:55 1998 CST	f	0
1234		14 TENTH AVENUE	83631932	ST PETERS			1116	Sun Feb 08 18:46:02 1998 CST	f	0
1235	OLD LION APARTMENTS	9 JERNINGHAM STREET	83347733	NORTH ADELAIDE		APARTMENT 33\
	1117	Sun Feb 08 18:53:05 1998 CST	f	0
1236		57/91 ROBSART STREET	82717723	PARKSIDE			1119	Sun Feb 08 19:01:42 1998 CST	f	0
1237		UNIT 3 20 KING WILLIAM ROAD	82722135	WAYVILLE		BIG IRON GATES ON RIGHT SIDE \
	1121	Sun Feb 08 19:08:30 1998 CST	f	0
1238		20 LOUISA STREET	82236709	ADELAIDE			2503	Thu Mar 05 20:58:12 1998 CST	f	0
1239		57 SYDENHAM ROAD	83632975	NORWOOD			1129	Sun Feb 08 20:13:31 1998 CST	f	0
1240		5-6 VAILAMA CRT	82327513	HACKNEY			1134	Sun Feb 08 21:15:50 1998 CST	f	0
1241		9 BEVINGTON RD	83799816	GLENUNGA			2195	Sat Feb 28 19:09:08 1998 CST	f	0
1242		17 SCOTT STREET	82721851	PARKSIDE			1140	Sun Feb 08 22:47:36 1998 CST	f	0
1243		143SECOND AVE	83620198	ROYSTON PARK			1143	Sun Feb 08 23:21:44 1998 CST	f	0
1244		15 A MYALL AVE	83642780	KENSINGTON GDNS		$1.00 DELIVERY FEE	1144	Sun Feb 08 23:23:46 1998 CST	f	0
1245		5/15CASSIE STREET	83422885	COLLINSWOOD			1148	Sun Feb 08 23:53:17 1998 CST	f	0
1246		9-6 WELLINGTON ST	83320637	KENSINGTON			1152	Mon Feb 09 00:14:49 1998 CST	f	0
1247		508 FISCHER ST	83795732	FULLERTON			1155	Mon Feb 09 00:57:22 1998 CST	f	0
1248		11 KATE CRT	83592523	ADELAIDE			2610	Sat Mar 07 04:13:16 1998 CST	f	0
1249		14 SALTER ST	83641317	KENSINGTON			2661	Sun Mar 08 02:29:21 1998 CST	f	0
1250		4 EDWIN AVE	83371344	TRANMARE			1160	Mon Feb 09 02:41:00 1998 CST	f	0
1251	PRINCESS ARCADE	262 HINDLEY STREET		ADELAIDE		ROOM 16 ASK FOR LISA	1161	Mon Feb 09 03:32:14 1998 CST	f	0
1252	EDEN RELAXATION CENTRE	11 fullarton rd	8362 5660	KENT TOWN			1474	Sun Feb 15 17:33:23 1998 CST	f	10
1253			82720251	ADELAIDE			0	Mon Feb 09 17:44:39 1998 CST	t	0
1254		11 little greNFELL ST	83633667	KENT TOWN			1169	Mon Feb 09 19:27:26 1998 CST	f	0
1255		197 BARTON TERRACE WEST	82673007	NORTH ADELAIDE			1484	Sun Feb 15 18:51:12 1998 CST	f	0
1256		12 JUNCTION LANE	84439402	MILE END			1176	Mon Feb 09 20:49:46 1998 CST	f	0
1257		UNIT 3/36 RUNDLE STREET	83631908	KENT TOWN			2478	Thu Mar 05 17:06:32 1998 CST	f	0
1258		HOUSE 6/ 25 MAXWELL STREET	82317213	ADELAIDE			1184	Mon Feb 09 21:58:31 1998 CST	f	0
1259		180 GOUGER ST	84101741	ADELAIDE			1186	Mon Feb 09 22:46:05 1998 CST	f	0
1260		13-15 WAKEFEILD ST	83620087	KENT TOWN			0	Mon Feb 09 22:57:49 1998 CST	f	0
1261		356 UNLEY RD	82724135	UNLEY PARK			1189	Mon Feb 09 23:34:44 1998 CST	f	0
1262	KENT TOWN LODGE	WAKEFIELD ST		KENT TOWN		ROOM 111	1190	Mon Feb 09 23:40:00 1998 CST	f	0
1263		5-233 EAST TCE	82324512	ADELAIDE		CORNER HALIFAX+ EAST TCE	1922	Mon Feb 23 18:12:00 1998 CST	f	0
1264		36 BELAUH RD	83628666	NORWOOD		BUSSINESS NETWORK 8 (PRESS BUZZER )\
\
\
	1194	Tue Feb 10 00:11:24 1998 CST	f	0
1265		14 EIGHTH AVE	83623722	ADELAIDE	118		1195	Tue Feb 10 00:24:00 1998 CST	f	0
1266		UNIT 1/4 SECOND AVE	84310107	PAYN SOUTH			1198	Tue Feb 10 00:47:12 1998 CST	f	0
1267		58 ELFORD AVE	83469707	DEVON PARK			1199	Tue Feb 10 00:50:45 1998 CST	f	0
1268		UNIT1/KINTORE LANE	014649640	MILE END		ON THE CORNER OF PARK ER ST	1200	Tue Feb 10 01:00:31 1998 CST	f	0
1269		2 WILLAROO AVE	0414976065	BEAUMONT			1204	Tue Feb 10 02:05:24 1998 CST	f	0
1270	FALAFEL HOUSE	HINDLEY ST		ADELAIDE		OPPOSITE RIO'S	1208	Tue Feb 10 03:00:13 1998 CST	f	0
1271		15 DIMORA COURT	82240438	ADELAIDE			1213	Tue Feb 10 17:47:03 1998 CST	f	0
1272		14 GRAY COURT	82123575	ADELAIDE			1214	Tue Feb 10 18:02:43 1998 CST	f	0
1273		ADVERTISER OFF WAYMOUYH ST	82062622	ADELAIDE		ASK FOR DELIA\
	1216	Tue Feb 10 18:18:17 1998 CST	f	0
1274		33 FIRST AVE	0418832378	PAYNEHAM SOUTH			0	Tue Feb 10 18:20:51 1998 CST	f	0
1275		33 FIRST AVE	0418822378	PAYNEHAM SOUTH			1217	Tue Feb 10 18:27:45 1998 CST	f	0
1276	ADELAIDE CASINO	NORTH TERRACE	82184124	ADELAIDE		STAFF ENTRY BY VALET PARKING	1970	Tue Feb 24 18:35:02 1998 CST	f	0
1277		18 ELY PLACE	82320842	ADELAIDE			2482	Thu Mar 05 18:05:06 1998 CST	f	0
1278	CARE TAPAS	RUNDLE ST	82237564	ADELAIDE			1229	Tue Feb 10 22:18:26 1998 CST	f	0
1279		UNIT2/13 ABBOTT LANE	82675658	NTH ADELAIDE			1558	Mon Feb 16 23:25:15 1998 CST	f	0
1280		10B ANN ST	83372049	CAMPBELLTOWN		ONE DOLLARDELIVERY	1233	Wed Feb 11 01:05:11 1998 CST	f	0
1281		44 DAVID TCER	82444286	KILKENNY		TWO DOLLAR DELIVERY	2331	Mon Mar 02 20:35:46 1998 CST	f	0
1282		81 BICKFORD ST	82345885	RICHMOND			1243	Wed Feb 11 02:21:32 1998 CST	f	0
1283		297 RICHMOND ROAD	82345361	WEST RICHMOND			1254	Wed Feb 11 17:35:15 1998 CST	f	0
1284		43B WAKEFIELD STREET	83630379	KENT TOWN			1267	Wed Feb 11 20:12:37 1998 CST	f	0
1285		262-266 HINDLEY ST(PRINCES MOTEL) RM	82319524	ADELAIDE		ROOM 6 DEAN\
	1272	Wed Feb 11 21:02:07 1998 CST	f	0
1286		14 DAVENPORT TERRACE	82348312	RICHMOND			1276	Wed Feb 11 23:40:34 1998 CST	f	0
1287		5-9 HOCKING CRT	82121395	ADELAIDE			2125	Fri Feb 27 18:50:37 1998 CST	f	0
1288		23 RUSSEL TERRACE	82681927	WOODVILLE			1279	Thu Feb 12 00:19:04 1998 CST	f	0
1289		18 HARLEY ROAD	83404878	CROYDON PARK			2176	Sat Feb 28 02:47:48 1998 CST	f	0
1290		58 SECOND STREET	83461754	BROMPTON			1292	Thu Feb 12 02:10:14 1998 CST	f	0
1291		4-35A SEVENTH AVE	83632229	ST PETERS			1300	Thu Feb 12 04:05:18 1998 CST	f	0
1292	PUBLIC TRUSTEE BUILDING	25 FRANKLIN ST	82269211	ADELAIDE			1301	Thu Feb 12 16:07:02 1998 CST	f	0
1293		1 PORT RD METRO HOLDEN	83540555	ADELAIDE			0	Thu Feb 12 18:08:42 1998 CST	f	0
1294		89 WATSON AVENUE	83644601	TOORAK GARDENS			2486	Thu Mar 05 18:55:25 1998 CST	f	0
1295		60 WYATT ST	82237533	ADELAIDE			2085	Thu Feb 26 20:21:15 1998 CST	f	0
1296		98 HENLEY BEACH RD (PENHALL MOTEL)	84436944	MILE END		ROOM.1 PLUNKETT\
	1308	Thu Feb 12 19:01:22 1998 CST	f	0
1297		45 KING WILLIAM ROAD	83663624	ADELAIDE		NEXT TO THE PARKLANDS, OPPOSITE CHLDRENS HOSPITAL\
	1309	Thu Feb 12 19:15:56 1998 CST	f	0
1298		1/454 PORTRUSH ROAD	83386030	LINDEN PARK			1313	Thu Feb 12 20:26:19 1998 CST	f	0
1299	TRAVEL LODGE MOTEL	SOUTH TERRACE		ADELAIDE		THE TOWER PART ROOM 1009\
	1314	Thu Feb 12 20:36:19 1998 CST	f	0
1300		1/6 PLYMOUTH AVE	83469433	DEVON PK		WHITE ROLLER DOOR FULL DOWN\
	1318	Thu Feb 12 21:47:46 1998 CST	f	0
1301		2/36 BARKER ROAD	82697465	PROSPECT		CORNER OF MURIEL AND BARKER\
	1323	Thu Feb 12 22:17:33 1998 CST	f	0
1302		5/12 FLORENCE ST	83794794	FULLARTON			1324	Thu Feb 12 22:25:18 1998 CST	f	0
1303		35 KENSINGTON ROAD	83322138	NORWOOD		BEHIND BLITZ HAIRDRESSING SALON IN CAR PARK OUT BACK\
\
	1870	Sun Feb 22 19:24:54 1998 CST	f	0
1304		3/1A WILLIAM ST	83321243	BURNSIDE			1331	Thu Feb 12 23:48:43 1998 CST	f	0
1305		35-37 RUNDLE STREET	83631700	KENT TOWN		PLEASE DELIVER AT 2.40PM\
	1338	Fri Feb 13 01:58:16 1998 CST	f	0
1306		61 FORTH AVENUE	83621923	ST PETERS			1340	Fri Feb 13 02:04:59 1998 CST	f	0
1307		38A TARRAGON ST	84435469	MILE END			2023	Wed Feb 25 18:38:42 1998 CST	f	0
1308		11 HARRISS ST	841314637	NORWOOD			1344	Fri Feb 13 18:32:56 1998 CST	f	0
1309		22CHARLBURY ST	83441544	MEDINDIE GARDENS			1347	Fri Feb 13 19:01:23 1998 CST	f	0
1310	INTERACTIVE GALLERY	254 HINDLEY ST	84100987	ADELAIDE			1348	Fri Feb 13 19:04:27 1998 CST	f	0
1311		7 GILBERT  STREET	83422848	GILBERTON			1628	Wed Feb 18 03:46:48 1998 CST	f	0
1312		25 WELLINGTON ST	82664219	KLEMZIG		ONE DOLLAR DELIVERY	1350	Fri Feb 13 19:13:19 1998 CST	f	0
1313		12 RAILWAY TCE	82342599	MILE END		FOR 8:15 PM	1353	Fri Feb 13 19:29:36 1998 CST	f	0
1314		7 OXFORD PLACE	83623720	NORWOOD			1356	Fri Feb 13 19:57:26 1998 CST	f	0
1315		44CLIFTON ST	83732987	MALVERN			1984	Tue Feb 24 20:29:21 1998 CST	f	0
1316		59 GERVOIS  AVE	83463964	WEST HINDMARSH			0	Fri Feb 13 20:11:05 1998 CST	f	0
1317		2\\406 CARRINGTON ST	82233904	ADELAIDE			2430	Wed Mar 04 20:09:34 1998 CST	f	0
1318		UNIT5/67 ROBSART ST	82718483	PARKSIDE			2628	Sat Mar 07 19:22:11 1998 CST	f	0
1319		18HIGH ST	83321873	KENSINGTON			1368	Fri Feb 13 21:20:47 1998 CST	f	0
1320	ITALIAN FUNCTION CENTRE	262 CARRINGTON ST		ADELAIDE			0	Fri Feb 13 21:24:25 1998 CST	f	0
1321		17 CEDAR CRES	83383140	GLENSIDE		PART OF AMBER WOODS ESTATE	1369	Fri Feb 13 21:27:29 1998 CST	f	0
1322	LA LUPA ENTRANCE ST PAUL'S ENT CENTRE	CNR PULTENEY AND FLINDERS	82325711	ADELAIDE		GO TO FLINDERS ST ENTRANCE for paul	2044	Wed Feb 25 22:27:06 1998 CST	f	0
1323		10 TALLALA TCE	83793032	MYRTLE BANK			1377	Fri Feb 13 23:04:11 1998 CST	f	0
1324		U6 74 FIRST AVE	83632826	ST PETERS			1379	Fri Feb 13 23:44:55 1998 CST	f	0
1325		23 BROWN ST	83401617	WEST CROYDON			2459	Thu Mar 05 01:19:10 1998 CST	f	0
1326		UNIT 13/142 CARRINGTON ST	82326960	ADELAIDE			1383	Sat Feb 14 00:35:49 1998 CST	f	0
1327		fgg	83657575	ADELAIDE			1385	Sat Feb 14 00:55:02 1998 CST	f	0
1328		93A COOMBE RD	83402211	ALLBENY GARDENS		$1.00 DELIVERY FEE\
DON'T DELIVER UNLESS YOU HAVE THE RIGHT ADDRESS\
	1770	Sat Feb 21 00:27:00 1998 CST	t	0
1329		UNIT2/2WARWICK AVE	83613501	TOORAK GDNS	118		1547	Mon Feb 16 22:19:08 1998 CST	f	0
1330		2 SURFLEN ST	82117751	ADELAIDE			1391	Sat Feb 14 01:28:12 1998 CST	f	0
1331		U4/86 GEORGE ST	84316865	NORWOOD			1393	Sat Feb 14 01:43:47 1998 CST	f	0
1332		U4 62 WARWICK AVE	82695180	WALKERVILLE			1394	Sat Feb 14 01:46:53 1998 CST	f	0
1333		U6 16 HARROW RD	83633341	COLLEGE PARK			1396	Sat Feb 14 02:03:40 1998 CST	f	0
1334		2\\103 HIGH ST	83317085	KENSINGTON			1401	Sat Feb 14 02:34:27 1998 CST	f	0
1335		6 eversley ave	82695617	ENFIELD			1402	Sat Feb 14 02:36:24 1998 CST	f	0
1336		44 WYATT RD	83318820	BURNSIDE			1405	Sat Feb 14 02:52:03 1998 CST	f	0
1337		10 WHEATON ST	83629182	EVANDALE			1407	Sat Feb 14 03:06:19 1998 CST	f	0
1338		U3 4 BATTAMS RD	83626565	MARDEN			1410	Sat Feb 14 03:29:00 1998 CST	f	0
1339	PRODUCERS HOTEL	235 GRENFELL ST	82235026	ADELAIDE		KNOCK ON THE FRONT DOOR	1411	Sat Feb 14 03:40:06 1998 CST	f	0
1340		24 NAIRNE TCE	83510326	FORRESTVILLE			1412	Sat Feb 14 03:44:25 1998 CST	f	0
1341		U4 11 ST BERNARDS RD	84315888	MAGILL			1413	Sat Feb 14 03:59:15 1998 CST	f	0
1342		26 DOUGLAS ST	83735971	PARKSIDE			1416	Sat Feb 14 16:18:13 1998 CST	f	0
1343	SMOKE MARKET	244 RUNDLE ST	82233971	ADELAIDE			1417	Sat Feb 14 17:26:50 1998 CST	f	0
1344		390 CARRINGTON ST	82240786	ADELAIDE			1418	Sat Feb 14 17:56:17 1998 CST	f	0
1345	APARTMENT ON THE PARK	274 STH TERRACE	82240502	ADELAIDE		FRONT OFFICE\
\
\
	1427	Sat Feb 14 19:17:39 1998 CST	f	0
1346		1-311 YOUNG ST	82741037	WAYVILLE			1428	Sat Feb 14 19:19:27 1998 CST	f	0
1347		419 gilles st	82240553	ADELAIDE		TURN LEFT OFF HUTT ST	2551	Fri Mar 06 19:10:38 1998 CST	f	0
1348	MOTEL	277 GLENOSMOND RD	83799911	GLENUNGA		ROOM 3\
\
	1432	Sat Feb 14 19:51:55 1998 CST	f	0
1349		111 SYDNEY ST	83793381	GLENUNGA			1433	Sat Feb 14 19:57:23 1998 CST	f	0
1350		21 AUBURN AVE	83795380	MYRTLE BANK	118		1460	Sun Feb 15 03:07:03 1998 CST	f	0
1351	MADAM JOSEPHINES	149 waymouth st		ADELAIDE			1439	Sat Feb 14 22:30:26 1998 CST	f	0
1352		351 GREENHILL RD	83322255	TOORAK GDNS			1443	Sun Feb 15 00:00:42 1998 CST	f	0
1353	DUSK TIL DAWN	270a PIRIE ST	82272211	ADELAIDE		side entrance\
	2576	Fri Mar 06 23:47:12 1998 CST	f	10
1354		16-80 WATTLE ST	82727797	FULLARTON			1448	Sun Feb 15 01:13:37 1998 CST	f	0
1355		2-1 DUDLEY RD	83318117	MARRYATVILLE			1449	Sun Feb 15 01:16:32 1998 CST	f	0
1356		5/133A KENSINGTON ST	83318463	NORWOOD			1451	Sun Feb 15 01:44:39 1998 CST	f	0
1357		93 CHELTENHAM ST	82726503	MALVERN		DO NOT DELIVER UNLESS PAY FOR LAST ORDER ON THE 15/02/98	1452	Sun Feb 15 01:47:00 1998 CST	t	0
1358		9 TAYLOR TCE	83324148	ROSLYN PK			1454	Sun Feb 15 02:06:55 1998 CST	f	0
1359		31 TUTOR ST	83330507	DULWICH			1456	Sun Feb 15 02:32:06 1998 CST	f	0
1360		97 ALEXANDRA ST	83443915	PROSPECT			1458	Sun Feb 15 02:47:10 1998 CST	f	0
1361		1 WILLIAM ST	84310560	BURNSIDE		THE HOUSE IN BETWEEN 3& 4\
$ 1.00 DELIVERY FEE	1459	Sun Feb 15 02:51:26 1998 CST	f	0
1362	CARGO NIGHTCLUB	213 HINDLEY ST	82312367	ADELAIDE			1461	Sun Feb 15 03:12:19 1998 CST	f	0
1363		19 AVELAND AVE	83612911	TRINITY GDNS			1895	Sun Feb 22 22:49:31 1998 CST	f	0
1364		49 BEVINGTON RD	83799374	GLENUNGA		GO THRU SYBNEY ST GATE\
	1464	Sun Feb 15 03:49:46 1998 CST	f	0
1365		1/5 KENNEDY ST	82343187	BROOKLYN PK		$1.00 DELIVERY\
\
	1465	Sun Feb 15 03:59:55 1998 CST	f	0
1366	JOH	R.A.H.	82224435	ADELAIDE		NORTH WING Q3\
\
	1913	Mon Feb 23 02:12:57 1998 CST	f	0
1367		2 ANGAS STREET	82240592	ADELAIDE			1469	Sun Feb 15 15:20:49 1998 CST	f	0
1368		2/ 12 GUILFORD AVENUE	83448974	PROSPECT			2508	Thu Mar 05 21:37:16 1998 CST	f	0
1369		5 MITCHEL CLOSE	82697764	FITZROY			1475	Sun Feb 15 17:36:32 1998 CST	f	0
1370		APART.15 9 JERNINGHAM STREET	83347715	NORTH ADELAIDE		OLD LION MAJESTIC APARTMENTS\
	2617	Sat Mar 07 18:13:01 1998 CST	f	0
1371		28 VINCENT STREET	83321122	ADELAIDE		AMEX 376006228063007 EXP 05/99\
	1489	Sun Feb 15 19:44:09 1998 CST	f	0
1372		7-40 BROAD ST	83630734	MARDEN			1490	Sun Feb 15 19:54:04 1998 CST	f	0
1373		UNIT 5/54 EAST AVENUE	83511631	BLACKFOREST			1492	Sun Feb 15 20:01:44 1998 CST	f	0
1374		46 FOSTER ST	82728227	PARKSIDE			1498	Sun Feb 15 20:51:31 1998 CST	f	0
1375		1\\42 LEHUNTE	83733250	WAYVILLE			0	Sun Feb 15 21:19:02 1998 CST	f	0
1376		BENT ST CAR PARK	82236391	ADELAIDE			1525	Mon Feb 16 18:41:09 1998 CST	f	0
1377		103  MACKINNON ST	82672159	NTH ADELAIDE			1505	Sun Feb 15 23:03:10 1998 CST	f	0
1378		39 ELIZABETH ST	83623095	EVANDALE			1506	Sun Feb 15 23:07:50 1998 CST	f	0
1379		1-30 CHATHAM ST	0412458784	ADELAIDE			1507	Sun Feb 15 23:10:44 1998 CST	f	0
1380		1\\37 STUART RD	82691315	PROSPECT			1620	Wed Feb 18 01:22:52 1998 CST	f	0
1381		1 MOULDEN ST	83621104	NORWOOD			2056	Thu Feb 26 01:03:24 1998 CST	f	0
1382		15\\3 ORCHARD ST	82938282	EVERARD PARK			1513	Mon Feb 16 00:57:32 1998 CST	f	0
1383		66 RICHMOND ST	83622145	COLLEGE PK			1518	Mon Feb 16 02:36:17 1998 CST	f	0
1384	SEAWALL APPARTEMENT	22 OLDEN ST		GLENELG			1521	Mon Feb 16 04:07:17 1998 CST	f	0
1385		UNIT3/15 FLINDERS STREET	83626507	KENT TOWN		\
	1527	Mon Feb 16 19:08:07 1998 CST	f	0
1386		18 WESTBURY STREET	83621938	HACKNEY			1940	Mon Feb 23 20:16:25 1998 CST	f	0
1387		3 MCKINNON COURT	82673827	NORTH ADELAIDE			1534	Mon Feb 16 20:22:07 1998 CST	f	0
1388		20 LITTLESTURT ST	82121308	ADELAIDE			1535	Mon Feb 16 20:26:03 1998 CST	f	0
1389		35 SECOND AVE	111111	ST PETERS			0	Mon Feb 16 20:40:15 1998 CST	f	0
1390		7A BERTRAM ST	83632268	HACKNEY			2518	Thu Mar 05 23:49:33 1998 CST	f	0
1391	ROBERT SARAF	UNIT4/10 WASHINGTON ST	789456	HILTON	118		1540	Mon Feb 16 21:20:53 1998 CST	f	0
1392		95 HIGH ST	84310416	KENSINGTON			1544	Mon Feb 16 22:06:35 1998 CST	f	0
1393		34 MITCHELL ST	83578765	MILLSWOOD			2335	Mon Mar 02 21:05:28 1998 CST	f	0
1394		13 HALL ST	83613852	NORWOOD		     	1554	Mon Feb 16 22:59:28 1998 CST	f	0
1395		53 CHURCHILL RD	83421092	PROSPECT			1555	Mon Feb 16 23:01:39 1998 CST	f	0
1396		22/42 CHARLICK CIRCUIT	0414577822	ADELAIDE			1559	Mon Feb 16 23:26:25 1998 CST	f	0
1397		39 DULWICH AVE	83312022	DULWICH		SIDE ENTRANCE\
\
	1560	Mon Feb 16 23:42:24 1998 CST	f	0
1398		11 KING EDWARD AVE	82717478	HAWTHORNE			1566	Tue Feb 17 00:24:51 1998 CST	f	0
1399		53 WARWICK ST	83590837	ENFIELD		ONE DOLLAR DELIVERY	1569	Tue Feb 17 00:35:28 1998 CST	f	0
1400		56B REID AVE	83657804	TRANMERE		$1.00 DELIVERY	1877	Sun Feb 22 19:52:41 1998 CST	f	0
1401		188 KENSINGTON RD	84312351	MARRYATVILLE			1577	Tue Feb 17 02:25:24 1998 CST	f	0
1402		222C YOUNG ST	82729743	UNLEY			1578	Tue Feb 17 02:39:11 1998 CST	f	0
1403		END OF RUNDLE ST	0411502566	ADELAIDE		BIG RED\
	2066	Thu Feb 26 03:10:38 1998 CST	f	0
1404		61 THIRD AVE	83630637	ST PETERS			1584	Tue Feb 17 17:25:47 1998 CST	f	0
1405		14 opie ave	83733471	HYDE PARK			1586	Tue Feb 17 18:31:43 1998 CST	f	0
1406		22 BAGOT AVE	82346705	MILE END			1587	Tue Feb 17 18:51:55 1998 CST	f	0
1407		14 ANNESLEY AVE	84311412	TRINITY GDNS			1590	Tue Feb 17 19:32:55 1998 CST	f	0
1408		UNIT3/5 LESTRANGE ST	83799270	GLENSIDE			1594	Tue Feb 17 20:08:38 1998 CST	f	0
1409		17A DANBY ST	84438024	TORRENSVILLE			1596	Tue Feb 17 20:26:51 1998 CST	f	0
1410		15 AVONMORE AVE	83332389	TRINITY GARDENS			2525	Fri Mar 06 01:16:44 1998 CST	f	0
1411		5/26 MAESBURY ST	83612496	KENSINGTON		UPSTAIRS FLAT\
	1610	Wed Feb 18 00:11:55 1998 CST	f	0
1412		1 REECE AVE	83690372	KLEMZIG		$1.00 DELIVERY\
	1612	Wed Feb 18 00:21:11 1998 CST	f	0
1413		17 MARION ST	0412451524	ADELAIDE			1618	Wed Feb 18 01:09:33 1998 CST	f	0
1414		D23 /17 EDEN ST	82328015	ADELAIDE			2062	Thu Feb 26 02:45:06 1998 CST	f	0
1415	O'CONNELL INN	197-99 O'CONNELL ST		NORTH ADELAIDE		ROOM 205	1622	Wed Feb 18 01:39:59 1998 CST	f	0
1416	TRAVELODGE MOTEL	SOUTH TERRACE		ADELAIDE		ROOM 61 DON\
\
	1653	Wed Feb 18 21:44:59 1998 CST	f	0
1417		64 HEWITT AVENUE	83332321	ROSE PARK			1631	Wed Feb 18 17:18:57 1998 CST	f	0
1418		5 MACLAREN ST	82326015	ADELAIDE			2319	Mon Mar 02 17:33:58 1998 CST	f	0
1419		17 GURNEY ROAD	83640123	ROSE PARK			1636	Wed Feb 18 18:15:25 1998 CST	f	0
1420	STEVE	R.A.H. CASUALTY	82225321	ADELAIDE		FOR 7.00 O,CLOCK	1637	Wed Feb 18 18:22:07 1998 CST	f	0
1421		5 BROUGHTON AVE	82938176	KARRALTA PK			1640	Wed Feb 18 19:50:11 1998 CST	f	0
1422		4\\10 collingrove ave	83447040	BROADVIEW			1645	Wed Feb 18 20:10:09 1998 CST	f	0
1423	STATE FORENSIC SCIENCE CENTRE	21 DIVETT PLACE	82267700	ADELAIDE			1646	Wed Feb 18 20:11:57 1998 CST	f	0
1424	GROVERNOR VISTA HOTEL	125 NORTH TERRACE		ADELAIDE		ROOM 214\
FOR DAVIS\
	1647	Wed Feb 18 20:19:02 1998 CST	f	0
1425		2\\89 LEICESTER ST	82720191	PARKSIDE		ENTER OFF GEORGE ST\
\
	1651	Wed Feb 18 21:17:55 1998 CST	f	0
1426		54 LEICESTER STREET	82728872	PARKSIDE			1656	Wed Feb 18 22:22:30 1998 CST	f	0
1427		UNIT 7/ 7 HIGHGATE STREET	82714435	FULLARTON			1657	Wed Feb 18 22:35:45 1998 CST	f	0
1428		1\\3 LEWIS ST	82723932	GOODWOOD			1660	Wed Feb 18 23:02:05 1998 CST	f	0
1429		17 OAK CRESCENT	83703603	HAWTHORN			1661	Wed Feb 18 23:19:43 1998 CST	f	0
1430		39 DULWICH AVENUE	83312088	DULWICH			1664	Wed Feb 18 23:47:54 1998 CST	f	0
1431	ANTHONY	THE AUSTRAL	0412111725	ADELAIDE			1668	Thu Feb 19 00:14:35 1998 CST	f	0
1432		18 LEAH STREET	82977057	FORRESTVILLE			2111	Fri Feb 27 02:58:48 1998 CST	f	0
1433		33 LANSDOWNE TERRACE	83441601	VALE PK	118		1907	Mon Feb 23 00:38:25 1998 CST	f	0
1434		RAH	82225333	ADELAIDE		TRIAGE DESK - EMERGENCY DEPT\
FOR MAUREEN\
	1681	Thu Feb 19 03:00:17 1998 CST	f	0
1435	JIMMY WATSON	192 PIRIE ST	82322646	ADELAIDE			1683	Thu Feb 19 12:48:21 1998 CST	f	0
1436		90 LEICESTER ST	412212345	PARK SIDE			1686	Thu Feb 19 18:05:58 1998 CST	f	0
1437		5/4 WAKEFIELD ST	83328356	KENT TOWN		OFF DEQUETIVILLE TCE\
	1694	Thu Feb 19 19:56:31 1998 CST	f	0
1438		98 HENLEY BCH RD PENHALL MOTEL	0412310367	MILE END		JAMES RM. 11\
	1695	Thu Feb 19 20:20:47 1998 CST	f	0
1439		11/71 YOUNG ST	82714587	PARK SIDE			1701	Thu Feb 19 21:25:07 1998 CST	f	0
1440	FIVE STARS PRESS	15A RICHARD ST	83460310	HINDMARSH			1712	Thu Feb 19 23:37:10 1998 CST	f	0
1441		3-1A  FLORENCE ST	83795282	FULLARTON			2588	Sat Mar 07 01:11:55 1998 CST	f	0
1442		6 MADGE ST	82623921	BLAIR ATHOL		$2.00 DELIVERY\
	1721	Fri Feb 20 01:02:00 1998 CST	f	0
1443		2 HIGHGATE ST	014842848	FULLARTON			1722	Fri Feb 20 01:09:01 1998 CST	f	0
1444		102 ASHLEY ST	82349184	TORRENSVILLE		\
	1723	Fri Feb 20 01:15:01 1998 CST	f	0
1445		56B REED AVE	82657804	TRANMERE		$1.00 DEL.	1725	Fri Feb 20 01:43:24 1998 CST	f	0
1446		15 MITCHELL ST	82717052	HYDE PK			1728	Fri Feb 20 02:06:14 1998 CST	f	0
1447		9 FORMBY ST	84438548	HILTON	118		2465	Thu Mar 05 01:37:23 1998 CST	f	0
1448		7-423 PAYNEHAM RD	83369448	FELIXTOW		$1.00 DELIVERY FEE	1731	Fri Feb 20 02:45:28 1998 CST	f	0
1449		3 MILNER ST	83446805	PROSPECT			1735	Fri Feb 20 03:45:08 1998 CST	f	0
1450		48 ANGAS STREET	82240400	ADELAIDE			1736	Fri Feb 20 12:21:38 1998 CST	f	0
1451	SIMMS RICHMOND	GROUND FLOOR 99 FROME STREET	82056266	ADELAIDE		FOR 1.15PM\
	2115	Fri Feb 27 12:24:48 1998 CST	f	0
1452	IMBS	FROME ROAD	82223346	ADELAIDE		BETWEEN DENTAL SCHOOL AND IMBS \
RING BEFORE LEAVING	1741	Fri Feb 20 18:39:18 1998 CST	f	0
1453		UNIT 4 / 390 REGENCY ROAD	83446559	PROSPECT			1746	Fri Feb 20 19:32:46 1998 CST	f	0
1454		1 DAPHNE STREET	83442536	MEDINDIE			1747	Fri Feb 20 19:38:54 1998 CST	f	0
1455		6/40 LEHUNT ST	83731321	WAYVILLE			1750	Fri Feb 20 20:01:57 1998 CST	f	0
1456		25 MURRAY STREET	82671987	NORTH ADELAIDE			1753	Fri Feb 20 20:27:59 1998 CST	f	0
1457		1 ROSE STREET	83444423	GILBERTON			2207	Sat Feb 28 20:08:02 1998 CST	f	0
1458		3 FREDERICK STREET	83796044	FREWVILLE			1765	Fri Feb 20 23:18:08 1998 CST	f	0
1459		3 JUNCTION ST	83519970	MILE END			2231	Sun Mar 01 00:35:45 1998 CST	f	0
1460	PINK PALACE	21 AUSTIN ST	82234343	ADELAIDE			2650	Sun Mar 08 01:00:17 1998 CST	f	10
1461		21B PARSONS STREET	82725870	WAYVILLE			1768	Sat Feb 21 00:09:42 1998 CST	f	0
1462	SUMO STATION	172 PULTENEY ST	82320188	ADELAIDE			1769	Sat Feb 21 00:26:53 1998 CST	f	0
1463		28 BAGSHAW WAY	83522036	MILE END			1772	Sat Feb 21 00:53:28 1998 CST	f	0
1464		UNIT 2/1 STONEHOUSE AVENUE	83510765	PLYMPTON		$3.00 DELIVERY	1773	Sat Feb 21 01:06:49 1998 CST	f	0
1465		U3/75 BEULAH ROAD	83623510	NORWOOD			1774	Sat Feb 21 01:12:42 1998 CST	f	0
1466		71 MONMOUTH RD	83579042	WESTBOURNE PK		$1.00 DELIVERY\
	1778	Sat Feb 21 01:40:24 1998 CST	f	0
1467		11 WEIL ST	82215884	ADELAIDE			1979	Tue Feb 24 19:28:43 1998 CST	f	0
1468		8A BLACKBURN AVE	84434675	COWANDILLA		$1.00 DELIVERY\
	1784	Sat Feb 21 02:44:39 1998 CST	f	0
1469		67 ALFRED ST	82721847	PARK SIDE			2237	Sun Mar 01 01:26:00 1998 CST	f	0
1470		43TELFORD ST	83448530	OVINGHAM			1791	Sat Feb 21 03:42:19 1998 CST	f	0
1471		2 /121WALKERVILLE TCE.	83443321	WALKERVILLE			1795	Sat Feb 21 04:09:00 1998 CST	f	0
1472		49 MEYER STREET	83521264	TORRENSVILLE			1796	Sat Feb 21 04:19:00 1998 CST	f	0
1473		10 KENSINGTON RD	83320393	ROSE PK			1797	Sat Feb 21 13:21:36 1998 CST	f	0
1474		UNIT 6/43 OSMOND TCE	84315682	NORWOOD			1807	Sat Feb 21 19:01:11 1998 CST	f	0
1475		15 WELLER ST	82729628	GOODWOOD			1809	Sat Feb 21 19:40:58 1998 CST	f	0
1476		1 CHURCHER ST	83449175	THORNGATE			1810	Sat Feb 21 19:46:45 1998 CST	f	0
1477		TOP BUZZEER ACROSS RD	0417894442	ADELAIDE			2376	Tue Mar 03 20:33:00 1998 CST	f	0
1478	GOOD GIRLS BAD GIRLS	127 RUNDLE MALL	0419859965	ADELAIDE			1812	Sat Feb 21 20:05:34 1998 CST	f	0
1479		5-17 FLORENCE ST	82713975	GOODWOOD			1816	Sat Feb 21 20:54:34 1998 CST	f	0
1480		32 MAIN ST	82714624	EASTWOOD			1823	Sat Feb 21 21:46:07 1998 CST	f	0
1481	DIRECTOR'S HOTEL	259 GOUGER ST		ADELAIDE		ROOM 426	1824	Sat Feb 21 21:50:45 1998 CST	f	0
1482		35/11 CHARLICK CIRCUIT	83592979	ADELAIDE			1825	Sat Feb 21 22:13:36 1998 CST	f	0
1483		2A LANE ST	83518857	RICHMOND			1827	Sat Feb 21 22:38:55 1998 CST	f	0
1484	POLICE	POLICE		ADELAIDE		PICK UP FOR 1:15\
\
\
	1830	Sat Feb 21 23:13:14 1998 CST	f	0
1485		U6 10 DECOSTA AVE	83420191	PROSPECT			1832	Sat Feb 21 23:44:31 1998 CST	f	0
1486		UNIT 2/91 QUEENS ST	83322421	NORWOOD			1835	Sun Feb 22 00:42:31 1998 CST	f	0
1487	DAVE MACK	APRTMENTS ON THE PARK- 274 SOUTH TCE U43	0412319033	ADELAIDE			1836	Sun Feb 22 01:05:01 1998 CST	f	0
1488		2 CASTRES ST	83378145	GLYNDE		ONE DOLLAR DELIVERY	1837	Sun Feb 22 01:41:45 1998 CST	f	0
1489		40 HOWARD ST	84312223	BEULAH PARK			1838	Sun Feb 22 01:50:45 1998 CST	f	0
1490		6 YAMBA ST	83443430	KILBURN			1839	Sun Feb 22 01:56:48 1998 CST	f	0
1491		282 RUNDLE ST	82321699	ADELAIDE		ANDERSONS ICE CREAM	2656	Sun Mar 08 01:46:43 1998 CST	f	0
1492		11 EMILY AVE	82761179	CLAPHAM		THREE DOLLARS DELIVERY	2019	Wed Feb 25 02:22:52 1998 CST	f	0
1493		190 HALIFAX ST	82323965	ADELAIDE			2552	Fri Mar 06 19:24:03 1998 CST	f	0
1494		U4 50 JERNINGHAM ST	83618335	NORTH ADELAIDE			2387	Tue Mar 03 21:23:56 1998 CST	f	0
1495		UNIT 12/12 WILCOX ST	82120272	ADELAIDE			1846	Sun Feb 22 02:50:51 1998 CST	f	0
1496		85 CAMBRIDGE TCE	82710296	MALVERN			1848	Sun Feb 22 03:07:24 1998 CST	f	0
1497	HYATT	ATRIUM COCKTAIL LOUNGE	82311234	ADELAIDE		ARIE	1850	Sun Feb 22 03:30:00 1998 CST	f	0
1498		10B GERTRUDE ST	83323036	MAGILL		ONE DOLLAR DELIVERY	1851	Sun Feb 22 03:32:43 1998 CST	f	0
1499		UNIT5/1A STANNINGTON AVE	83328129	HEATHPOOL			1852	Sun Feb 22 03:35:24 1998 CST	f	0
1500		U18 3 STIRLING ST	82977859	MARLESTON			1855	Sun Feb 22 04:14:21 1998 CST	f	0
1501	MOOSE COLOR	101 KING WILLIAM STREET	83626711	KENT TOWN			1856	Sun Feb 22 12:54:57 1998 CST	f	0
1502	BASKET CASE INDEED	202 FLINDERS ST	82271211	ADELAIDE			1857	Sun Feb 22 17:10:22 1998 CST	f	0
1503		48 APPLEBY CRESCENT	83624336	NORWOOD			1859	Sun Feb 22 17:32:45 1998 CST	f	0
1504		21 FIRST AVENUE	83623430	ST PETERS			1860	Sun Feb 22 17:34:15 1998 CST	f	0
1505		23 SANDERS ST	82340330	RICHMOND			1862	Sun Feb 22 18:13:27 1998 CST	f	0
1506		73 ALFRED STREET	83579056	PARKSIDE			1863	Sun Feb 22 18:18:34 1998 CST	f	0
1507		17 FERGUSSON SQ	83320889	TOORAAK GDNS			1866	Sun Feb 22 18:43:25 1998 CST	f	0
1508		7 GEORGE STREET	82726359	UNLEY PARK			1868	Sun Feb 22 19:02:54 1998 CST	f	0
1509		8 DARLINGTON ST	82621417	ENFIELD		$ 1.00 DELIVERY FEE	2132	Fri Feb 27 20:22:21 1998 CST	f	0
1510	RED SHED THEATRE	255 ANGAS ST	0411799980	ADELAIDE			1875	Sun Feb 22 19:44:34 1998 CST	f	0
1511		58 KENSINGTON RD	83323485	ROSE PARK		PRESS UPSTAIRS BELL	1876	Sun Feb 22 19:49:00 1998 CST	f	0
1512		57 SYMONDS PLACE	82125219	ADELAIDE			2616	Sat Mar 07 18:04:55 1998 CST	f	0
1513		21 CLIFFORD STREET	83447052	PROSPECT			1881	Sun Feb 22 20:31:36 1998 CST	f	0
1514		472A CROSS RD	83511738	GLANDORE			1882	Sun Feb 22 20:42:53 1998 CST	f	0
1515		unit 3/69 COLLINS STREET	82693607	BROADVIEW			1885	Sun Feb 22 21:02:44 1998 CST	f	0
1516		11 northgate trce	82693976	MEDINDIE			1890	Sun Feb 22 21:33:35 1998 CST	f	0
1517		144 gover streeet	82671873	NORTH ADELAIDE		go 	1891	Sun Feb 22 21:37:00 1998 CST	f	0
1518	NEW MARKET HOTEL HEAVEN NIGHTCLUB	WEST TCE	82218533	ADELAIDE		GO INTO JOPLINS VIA WEST TCE AND SEE THE BARMAN TO PAGE THE MANAGER\
	1893	Sun Feb 22 22:23:26 1998 CST	f	0
1519		UNIT 5/2 COLLEGE ROAD	0412415600	KENT TOWN			2330	Mon Mar 02 20:27:25 1998 CST	f	0
1520		211A MELBOURNE ST	82671075	NORTH ADELAIDE		GO DOWN ALLEY WAY , NEXT TO 209	1896	Sun Feb 22 23:17:00 1998 CST	f	0
1521	FIRESTATION- AMBULANCE SERVICE	90 WAKEFIELD ST	82043555	ADELAIDE		FOR RAY	1900	Mon Feb 23 00:16:54 1998 CST	f	0
1522		3 FLORENCE ST	83385836	FULLARTON			1901	Mon Feb 23 00:18:46 1998 CST	f	0
1523		3-81 WINDSOR GRV	82667384	KLEMZIC		$1.00 DELIVERY FEE	1906	Mon Feb 23 00:37:06 1998 CST	f	0
1524		NORTH TERACE	015390502	ADELAIDE		IN FRONT OF STANFORD HOTEL\
           TAXI STAND	1911	Mon Feb 23 01:56:15 1998 CST	f	0
1525		150 CHILDERS ST	83618151	NORTH ADELAIDE			1914	Mon Feb 23 02:14:28 1998 CST	f	0
1526		20 ALEXANDRA ST	83422849	PROSPECT			1916	Mon Feb 23 02:23:46 1998 CST	f	0
1527		64 MILLSWOOD CRES	83579791	MILLSWOOD			1919	Mon Feb 23 02:45:09 1998 CST	f	0
1528		U3 1 VICTORIA TCE	83641910	ROSE PARK			1920	Mon Feb 23 02:55:40 1998 CST	f	0
1529		16 gray ct	82312628	ADELAIDE			1925	Mon Feb 23 18:40:08 1998 CST	f	0
1530		15 / 142 CARRINGTON ST	83592929	ADELAIDE			1929	Mon Feb 23 19:13:37 1998 CST	f	0
1531		8 ENTERPRISE ST	83579128	HYDE PK			1930	Mon Feb 23 19:20:17 1998 CST	f	0
1532		168 GREENHILL RD (OPTIMA BUILD.)	83057766	PARK SIDE		ENTER FROM MONTEPELIER ST	1931	Mon Feb 23 19:29:05 1998 CST	f	0
1533		TRAVELODGE HOTEL	0419910263	ADELAIDE		ROOM 47	1932	Mon Feb 23 19:30:53 1998 CST	f	0
1534		unit 7 / 1 daphne street	82693438	PROSPECT			1936	Mon Feb 23 19:52:53 1998 CST	f	0
1535		26 MARGARET STREET	83323794	NORWOOD			1943	Mon Feb 23 20:33:47 1998 CST	f	0
1536	NETWORK 8	36 BEULAH ROAD	83636333	NORWOOD		PUSH BUZZER AT FRONT DOOR\
	1946	Mon Feb 23 21:29:29 1998 CST	f	0
1537		U4/14 MAESBURY ST	84315958	KENSINGTON			1953	Mon Feb 23 23:16:05 1998 CST	f	0
1538		333 FULLARTON RD UNIT 12	83712635	PARKSIDE			1959	Tue Feb 24 00:30:36 1998 CST	f	0
1539		6 HATSWELL ST	83625998	HACKNEY			2393	Tue Mar 03 22:10:06 1998 CST	f	0
1540		37 FARNHAM RD	83712259	KESWICK			1961	Tue Feb 24 00:46:02 1998 CST	f	0
1541		272 GLENOSMOND RD	0412144229	GLENUNGA		BUDGET MOTEL INN RM 52\
\
	2595	Sat Mar 07 01:48:01 1998 CST	f	0
1542		U2/6 DEVON ST NORTH	041759229	GOODWOOD			1972	Tue Feb 24 18:49:34 1998 CST	f	0
1543		125 NTH TERRACE	84078888	ADELAIDE		GROSVERNER HOTEL RM.264 DAVID\
\
	1973	Tue Feb 24 18:59:14 1998 CST	f	0
1544		46 FIRST AVE	83620861	ST PETERS			1975	Tue Feb 24 19:04:59 1998 CST	f	0
1545		17 ARNOLD ST	83726969	PARK SIDE			1986	Tue Feb 24 20:53:32 1998 CST	f	0
1546		8/11 SHIPSTERS RD	84310336	KENSINGTON			1993	Tue Feb 24 21:30:31 1998 CST	f	0
1547	AMBASSADOR'S	KING WILLIAM ST		ADELAIDE			1994	Tue Feb 24 21:51:38 1998 CST	f	0
1548		140 NTH TERRACE	0417808947	ADELAIDE		FESTIVAL LODGE MOTEL RM.304\
	1999	Tue Feb 24 23:07:07 1998 CST	f	0
1549		128 WRIGHT ST	0416000601	ADELAIDE			2002	Tue Feb 24 23:22:42 1998 CST	f	0
1550		UNIT1/6 DONEGAL ST	83321883	NORWOOD			2006	Wed Feb 25 00:07:13 1998 CST	f	0
1551		44CHILWORTH AVE	83591659	ENFIELD			2008	Wed Feb 25 00:29:47 1998 CST	f	0
1552		10 SALISBURY CRS	82775416	COLONEL LIGHT GDS		$1.00 DELIVERY\
	2009	Wed Feb 25 01:01:06 1998 CST	f	0
1553		474 FLORENCE ST	83379607	GLYNDE		BEHIND THE SHOP\
	2010	Wed Feb 25 01:04:44 1998 CST	f	0
1554		UNIT3/76 HARVEY ST	83421156	COLLINSWOOD			2014	Wed Feb 25 01:13:34 1998 CST	f	0
1555		UNIT2/88 HEWITT AVE	83317545	TOORAK GARDENS			2015	Wed Feb 25 01:45:03 1998 CST	f	0
1556		61 ALFRED ST	84104848	ADELAIDE			2024	Wed Feb 25 18:39:44 1998 CST	f	0
1557		254 FRANKLIN STREET	82317830	ADELAIDE			2025	Wed Feb 25 18:51:53 1998 CST	f	0
1558		23 REGENT STREET	82240164	ADELAIDE			2507	Thu Mar 05 21:35:50 1998 CST	f	0
1559		UNIT 2/12 ROBERT AVENUE	82617253	BROADVIEW			2032	Wed Feb 25 19:51:45 1998 CST	f	0
1560	THE FLINDERS LOGDE	27 DEQUITAVILLE TERRACE		KENT TOWN		ROOM 71\
	2034	Wed Feb 25 20:14:08 1998 CST	f	0
1561	JESSIE	CAR PARK UNION STREET		ADELAIDE			2039	Wed Feb 25 21:01:43 1998 CST	f	0
1562	WALSH	UNIT 10/68 CARDWELL STREET	0414400671	ADELAIDE		USE INTERCOM	2049	Wed Feb 25 23:33:34 1998 CST	f	0
1563		40 CHELTENHAM ST	83577274	HIGATE		RINGWOOD BUILDING\
	2050	Thu Feb 26 00:21:33 1998 CST	f	0
1564		42 BARTON ST	83594510	BLAIR ATHOL		$1.00 DELIVERY	2052	Thu Feb 26 00:26:11 1998 CST	f	0
1565		7 CLIFFORD STREET	83445303	PROSPECT			2055	Thu Feb 26 00:59:46 1998 CST	f	0
1566	GUSMADI	R.A.H. RESIDENTIAL WING	0414710634	ADELAIDE		ROOM 626	2058	Thu Feb 26 01:28:23 1998 CST	f	0
1567		190 WATTLE STREET	82728117	MALVERN			2060	Thu Feb 26 02:14:51 1998 CST	f	0
1568		FLAT 4/317 PORTRUSH ROAD	84310680	NORWOOD			2063	Thu Feb 26 02:52:51 1998 CST	f	0
1569		290 MAIN NTH RD	82693655	ADELAIDE		SOMBRERO MOTEL RM.29 GLEN	0	Thu Feb 26 17:26:55 1998 CST	f	0
1570		245 STANLEY ST	83618144	NTH.ADEL		CNR.STANLEY+NEW ST (ENTER FROM NEW ST)\
	2073	Thu Feb 26 18:48:24 1998 CST	f	0
1571		11 CHARLBURY AVE	82696151	MEDINDIE GDS			2082	Thu Feb 26 20:07:11 1998 CST	f	0
1572		5/6 EDWARD ST	83510553	PLYMPTON			2083	Thu Feb 26 20:13:49 1998 CST	f	0
1573		UNION ST	0417320321	ADELAIDE		FRINGE CLUB	2086	Thu Feb 26 20:44:01 1998 CST	f	0
1574	5 AA RADIO STATION	PULTENEY CRT	82240101	ADELAIDE		RING BEFORE LEAVE	2089	Thu Feb 26 21:42:08 1998 CST	f	0
1575		2/13 SEWELL AVE	83632186	PAYNEHAM			2093	Thu Feb 26 22:54:08 1998 CST	f	0
1576		53 WAYS RD	83692532	HAMSTEAD GDNS		$1.00 DELIVERY FEE	2096	Thu Feb 26 23:30:29 1998 CST	f	0
1577		56 second ave	82693315	SEFTON PARK			2099	Thu Feb 26 23:46:18 1998 CST	f	0
1578		149 FLINDERS ST	0412124645	ADELAIDE			2105	Fri Feb 27 01:20:41 1998 CST	f	0
1579		8/70 BOUCAUT AVE	83690796	KLEMZIG		$1.00 DEL\
	2106	Fri Feb 27 01:22:58 1998 CST	f	0
1580		176 GROTE STREET	82316899	ADELAIDE			2120	Fri Feb 27 17:50:09 1998 CST	f	0
1581		248 GROTE ST	84101770	ADELAIDE			2123	Fri Feb 27 18:24:44 1998 CST	f	0
1582		4-12 CROMWELL ST	82232970	ADELAIDE			2133	Fri Feb 27 20:25:49 1998 CST	f	0
1583		59 DEW ST	83517659	THEBARTON	118	STRAIGHT DOWN SMITH ST	2613	Sat Mar 07 17:22:52 1998 CST	f	0
1584		24-26 WILCOX ST	84104397	ADELAIDE			2140	Fri Feb 27 20:44:58 1998 CST	f	0
1585		UNIT1/113 GEORGE ST	83519496	THEBARTON	118		2268	Sun Mar 01 18:45:05 1998 CST	f	0
1586		16 BEVINGTON RD	83795161	GLENUNGA			2147	Fri Feb 27 22:14:12 1998 CST	f	0
1587		59 CAMBRIDGE TCE	82714229	MALVERN			2157	Sat Feb 28 00:35:56 1998 CST	f	0
1588		5 GREY ST	82345863	MILE END			2657	Sun Mar 08 01:49:18 1998 CST	f	0
1589		6-146 COGLIN ST	83465064	BROMPTON			2160	Sat Feb 28 01:01:27 1998 CST	f	0
1590	KOSTER KIRGIANIS	31 HINTON ST	0411623085	UNDERDALE			2162	Sat Feb 28 01:24:34 1998 CST	f	0
1591		U2 11 WINIFRED ST	82317881	ADELAIDE			2163	Sat Feb 28 01:26:17 1998 CST	f	0
1592		UNIT3/19 EDMUND ST	82717645	MALVERN			2164	Sat Feb 28 01:33:10 1998 CST	f	0
1593	WOMEN AND CHILDREN'S HOSPITAL	KERMODE ST ENTRANCE	82046289	NTH ADELAIDE		STEVE	2165	Sat Feb 28 01:34:46 1998 CST	f	0
1594		3-104 FOURTH AVE	0414870717	JOSLIN		GO DOWN THE DRIVEWAY THRU THE GATE	2166	Sat Feb 28 01:50:38 1998 CST	f	0
1595		U6 46 BLIGHT ST	83404227	RIDLEYTON			2174	Sat Feb 28 02:34:56 1998 CST	f	0
1596	TRAVELODGE HOTEL	208 SOUTH TCE	0419582689	ADELAIDE			2178	Sat Feb 28 03:06:47 1998 CST	f	0
1597		63 WILPENA AVE	0413960153	VALE PARK			2179	Sat Feb 28 03:19:51 1998 CST	f	0
1598		2 CLOSE ST	83313165	ROSE PK			2180	Sat Feb 28 03:21:38 1998 CST	f	0
1599	ELDER PARK	POPEYE LAUNCH K,W.STREET	0411024826	ADELAIDE		TURN INTO DRIVE AFTER FESTIVAL THEATRE\
PAUL	2187	Sat Feb 28 17:32:04 1998 CST	f	0
1600		11 WEIL ST	82315884	ADELAIDE			2189	Sat Feb 28 18:19:08 1998 CST	f	0
1601		40 EVERARD AVE	83512802	KESWICK			2321	Mon Mar 02 18:12:47 1998 CST	f	0
1602		UNIT1/186 JEFCOTT ST	82673636	NTH ADEL			2194	Sat Feb 28 18:58:27 1998 CST	f	0
1603		17 ARTHUR ST	82672482	NTH ADEL			2198	Sat Feb 28 19:28:51 1998 CST	f	0
1604		419 GILLES ST	82230554	ADELAIDE			0	Sat Feb 28 19:30:53 1998 CST	f	0
1605		173 MCKINNON PARADE	82676530	NTH ADEL			2202	Sat Feb 28 19:38:55 1998 CST	f	0
1606		UNIT1/16 COTTON ST	83442951	FITZROY			2206	Sat Feb 28 20:07:37 1998 CST	f	0
1607		U5/9 WAKEFIELD ST	83631745	KENT TOWN			2208	Sat Feb 28 20:22:24 1998 CST	f	0
1608		98 HENLEY BCH RD (PEN HALL MOTEL	84436449	MILE END		RM 5\
	2213	Sat Feb 28 20:54:53 1998 CST	f	0
1609		24 GILBERT6 ST	83447110	OVINGHAM			2633	Sat Mar 07 20:02:34 1998 CST	f	0
1610		2 A ASHLEY AVE	83796473	GLEN OSMOND		$ 1.00 DELIVERY FEE	2216	Sat Feb 28 21:16:26 1998 CST	f	0
1611		U3 30 COLLEGE RD	83629590	KENT TOWN			2217	Sat Feb 28 21:47:10 1998 CST	f	0
1612	XCLUSIVE SECURITY	TORRENS PARADE GROUND	82325945	ADELAIDE		GO DOWN KW RD THEN TURN RIGHT ONTO ROAD BEHIND UNIVERSITY\
WHERE ARMY BARRACKS WERE \
BLAKE	2509	Thu Mar 05 21:40:05 1998 CST	f	0
1613		15 HOOKING ST	83628252	ROYSTON PK			2228	Sun Mar 01 00:07:43 1998 CST	f	0
1614		28 WYNN ST	0418825195	FIRLE			2233	Sun Mar 01 00:57:12 1998 CST	f	0
1615		14 FIRST ST	83466196	BROMPTON			2238	Sun Mar 01 01:41:17 1998 CST	f	0
1616		ROYAL ADELAIDE HOSPITAL	82224666	ADELAIDE		GO TO CASUALTY \
FOR BOARD F8   BERNADINE HAWKES	2242	Sun Mar 01 02:13:06 1998 CST	f	0
1617		114 GEORGE ST	83641331	NORWOOD			2244	Sun Mar 01 02:26:03 1998 CST	f	0
1618	`	R.A.H	82224859	ADELAIDE		EMERGENCY	2519	Fri Mar 06 00:43:20 1998 CST	f	0
1619	BRECKNOCK HOTEL	401 KING WILLIAM ST	82315467	ADELAIDE			2250	Sun Mar 01 03:29:26 1998 CST	f	0
1620		156 ANZAC HIGHWAY	83510239	GLANDORE		$ 1.00 DELIVERY FEE	2252	Sun Mar 01 03:34:25 1998 CST	f	0
1621		3 ELIZABETH ST	83578150	GOODWOOD			2255	Sun Mar 01 04:17:25 1998 CST	f	0
1622	SLOBODAN   / WAITER	unit 12/347 burbridge road	82343509	BROOKLYN PARK			0	Sun Mar 01 16:42:49 1998 CST	f	0
1623		MURAL PERSON	0419894442	ADELAIDE		\
	2267	Sun Mar 01 18:32:59 1998 CST	f	0
1624	CROATIA CLUB	50 WOOD AVE	82464099	RIDLEYTON			2269	Sun Mar 01 18:46:58 1998 CST	f	0
1625	KEANS ARKARVA COURT MOTEL	232 GLEN OSMOND ROAD	83791645	FULLARTON		ROOM 9MASTER 5163253010169362\
09/98	2496	Thu Mar 05 20:12:14 1998 CST	f	0
1626	MAKAYLA	UNIT 3/33 EVERARD AVENUE	0411824694	ASHFORD			2276	Sun Mar 01 19:39:07 1998 CST	f	0
1627		39 COWRA ST	83521840	MILE END		VISA 4509495161014493 EXP07/99	2285	Sun Mar 01 20:25:25 1998 CST	f	0
1628		48 MCLAREN STREET	82240070				2289	Sun Mar 01 21:29:30 1998 CST	f	0
1629		3 BOWYER CRS	82979109	CUMBERLAND PK		$1.00 DELIVERY FEE\
GO DOWN TO THE GATE NEXT GARAGE\
AND FOLLOW THE PATH TO THE GRANNIE FLAT	2295	Sun Mar 01 22:53:54 1998 CST	f	0
1630		32-8 WEMYSS	82722907	HAWTHORNE		$1.00 DELIVERY FEE	2298	Sun Mar 01 23:07:17 1998 CST	f	0
1631		2-23 VICTORIA ST	83515749	GLANDORE		$1.00 DELIVERY FEE	0	Sun Mar 01 23:50:37 1998 CST	f	0
1632		20/151 ANZAC HWY	83714205	KARRALTER PARK			2302	Mon Mar 02 00:27:07 1998 CST	f	0
1633		79 GLADSTONE RD	82340035	MILE END		GO TO THE BACK OF THE HOUSE	2305	Mon Mar 02 00:40:52 1998 CST	f	0
1634		28 Hampden STREEEE	83644303	FIRLE			2307	Mon Mar 02 00:46:00 1998 CST	f	0
1635		17 flora street	83629007	STEPNEY		house on corner,of mary and flora,go to the back	2310	Mon Mar 02 01:06:31 1998 CST	f	0
1636		WIMEN AND CHILDERN HOSPITAL	82046704	ADELAIDE		EMERGENCY DEPARTMEN	2313	Mon Mar 02 02:05:00 1998 CST	f	0
1637		56 KING WILLIAM ST	83624574	KENT TOWN			2314	Mon Mar 02 02:22:44 1998 CST	f	0
1638		40 MACKINNON PARADE	82675218	NORTH ADELAIDE			2317	Mon Mar 02 02:33:23 1998 CST	f	0
1639	VODA FONE	CRNR GRANGERD & FEDERICK RD	015609672	FULLHAM GDNS			0	Mon Mar 02 03:39:20 1998 CST	f	0
1640	R.A. H RESIDENTIAL WING	roOM 302	0412188307	ADELAIDE			2481	Thu Mar 05 17:59:19 1998 CST	f	0
1641		41 CURRIE ST	82117866	ADELAIDE			2322	Mon Mar 02 18:13:59 1998 CST	f	0
1642		U5/422 CARRINGTON ST	83592234	ADELAIDE			2325	Mon Mar 02 19:19:36 1998 CST	f	0
1643		7A HEWITT AVENUE	83310850	ROSE PARK			2326	Mon Mar 02 19:23:54 1998 CST	f	0
1644		108 KING WILLIAM STREET	0412844154	ADELAIDE			2328	Mon Mar 02 19:42:57 1998 CST	f	0
1645		5/10A DELHI ST	82321869	ADELAIDE			2336	Mon Mar 02 21:27:11 1998 CST	f	0
1646		13 VINCENT ST	82325929	ADELAIDE			2337	Mon Mar 02 21:52:34 1998 CST	f	0
1647		U4/57A RICHMOND ST	0419828894	COLLEGE PARK			2338	Mon Mar 02 22:00:30 1998 CST	f	0
1648		57 WHYSALL RD	82661763	GREENACRES		$1.00 DEL.\
	2343	Mon Mar 02 23:35:36 1998 CST	f	0
1649		FLAT 9/389 PAYNEHAM RD	83653536	MARDEN			2344	Mon Mar 02 23:56:45 1998 CST	f	0
1650		14 MUNDULLA ST	82445081	KILKENNY		$2.00 DEL	2637	Sat Mar 07 20:59:20 1998 CST	f	0
1651		1 VINTAGE RD	82340570	UNDERDALE		ONE DOLLAR DELIVERY	2352	Tue Mar 03 00:52:52 1998 CST	f	0
1652	YOUTHWORKS	124 RUNDLE MALL	82237887	ADELAIDE			0	Tue Mar 03 18:44:29 1998 CST	f	0
1653	THE UNIVERSITY OF SOUTH AUSTRALIA	NORTH TERRACE	83022870	ADELAIDE		PLAYFORD BUILDING LEVEL 3 FROMERD ENTRANCE	2366	Tue Mar 03 18:53:02 1998 CST	f	0
1654		34A HARRINGTON ST	83429085	PROSPECT			2368	Tue Mar 03 19:14:40 1998 CST	f	0
1655		15 GLOUCESTER TCE	83613931	NORWOOD			2370	Tue Mar 03 19:51:00 1998 CST	f	0
1656		27A GOODENOUGH ST	84439057	MILE END			2378	Tue Mar 03 20:40:51 1998 CST	f	0
1657	POWELLS COURT MOTEL	GLEN OSMOND RD	82717033	PARKSIDE		RM 12\
\
	2380	Tue Mar 03 20:45:09 1998 CST	f	0
1658		32 WILSDEN ST	0419869705	WALKERVILLE			2385	Tue Mar 03 21:15:18 1998 CST	f	0
1659		UNIT9/16 BISHOP ST	83466842	RENOWN PK		 ONE DOLLAR DELIVERY	2391	Tue Mar 03 21:44:59 1998 CST	f	0
1660		U4/1A STEPHENS AVE	83521048	TORRENSVILLE			2392	Tue Mar 03 22:07:12 1998 CST	f	0
1661	GROSVENOR HOTEL	NORTH TERRACE		ADELAIDE		ROOM 207	2394	Tue Mar 03 22:37:48 1998 CST	f	0
1662		15 WATTS CRS	0417828191	ENFIELD		$1.00 DEL	2398	Tue Mar 03 23:27:16 1998 CST	f	0
1663		UNIT2/43 KINGS ST	83552096	MILE END			2401	Wed Mar 04 00:04:36 1998 CST	f	0
1664		12 ROBERTS ST	83407560	CROYDON		ONE DOLLAR DELIVERY	2591	Sat Mar 07 01:21:58 1998 CST	f	0
1665		40 HAMPTON ST SOUTH	82718505	GOODWOOD			2407	Wed Mar 04 00:54:33 1998 CST	f	0
1666		UNIT3/48 MILLER ST	83736730	UNLEY			2408	Wed Mar 04 01:14:59 1998 CST	f	0
1667		38 ROSTREVOR AVE	83656281	ROSTREVOR		THREE DOLLARS DELIVERY	2410	Wed Mar 04 01:30:08 1998 CST	f	0
1668		10CAREY ST	83362056	MAGILL		ONE DOLLAR DELIVERY	2411	Wed Mar 04 01:34:15 1998 CST	f	0
1669		ROYAL SHOW GROUND GATE 5	82105256	GOODWOOD			2418	Wed Mar 04 17:35:37 1998 CST	f	0
1670		30 PALMERSTON ROAD	82723583	UNLEY			2419	Wed Mar 04 17:51:15 1998 CST	f	0
1671	THE DIRECTORS HOTEL	259 GOUGER STREET	82313572	ADELAIDE		ROOM 417	2420	Wed Mar 04 17:56:05 1998 CST	f	0
1672	BARRON TOWN HOUSE APARTMENTS	HINDLEY STREET	82118255	ADELAIDE		CNR HINDLEY AND MORPHET ROOM 110	2424	Wed Mar 04 19:13:18 1998 CST	f	0
1673		UNIT 2/3 LEWIS STREET	82710702	GOODWOOD			2491	Thu Mar 05 19:54:22 1998 CST	f	0
1674		9/177 JEFFCOTT ST	82672389	NTH.ADEL			2444	Wed Mar 04 22:57:31 1998 CST	f	0
1675	MARIO	15 WOOD AVENUE	83464099	RIDLEYTON			2445	Wed Mar 04 23:06:27 1998 CST	f	0
1676		4 GREVILLEA CRESCENT	83612692	STONYFELL		\
$1.00 DELIVERY	2448	Wed Mar 04 23:23:26 1998 CST	f	0
1677		47 WELLINGTON SQUARE	82672122	NORTH ADELAIDE		KNOCK AT THE OFFICE DOOR	2452	Thu Mar 05 00:27:03 1998 CST	f	0
1678		42 VICTORIA ST	83517418	MILE END			0	Thu Mar 05 01:13:28 1998 CST	f	0
1679		UNIT 2/22 118 LIPSETT TERRACE	82344402	BROOKLYN PARK		$1.00 DELIVERY\
	2460	Thu Mar 05 01:21:00 1998 CST	f	0
1680	MYELLA	FLAT 6/229 SOUTH ROAD	84437640	MILE END			2464	Thu Mar 05 01:33:25 1998 CST	f	0
1681		11 RALSTON ST	82672636	NORTH ADELAIDE			2467	Thu Mar 05 02:03:19 1998 CST	f	0
1682		200 TORRENS RD	83407279	RENOWN PK			2528	Fri Mar 06 01:29:25 1998 CST	f	0
1683		13 ST. HELEN STREET	82725612	PARKSIDE			2471	Thu Mar 05 02:29:40 1998 CST	f	0
1684		138a GILLES STREET	84100799	ADELAIDE		BACK ENTRANCE OFF OF STEVENS STREET	2472	Thu Mar 05 02:48:42 1998 CST	f	0
1685		34 PULSFORD STREET	82696261	PROSPECT			2473	Thu Mar 05 02:50:42 1998 CST	f	0
1686	ROGER CAMPBELL	THE FRINGE OFFICE UNION STREET	0412081739	ADELAIDE			2476	Thu Mar 05 03:40:07 1998 CST	f	0
1687		UNIT 5/49 ELIZABETH STREET	84315194	NORWOOD			2477	Thu Mar 05 04:14:09 1998 CST	f	0
1688		U3/19 OSMOND TCE	83794396	FULLARTON			2480	Thu Mar 05 17:52:40 1998 CST	f	0
1689		4 LISTON ST	83734537	PARKSIDE			2490	Thu Mar 05 19:48:13 1998 CST	f	0
1690	LOTTERIES COMMISSION	23 RUNDLE MALL	82055502	ADELAIDE			2494	Thu Mar 05 20:06:22 1998 CST	f	0
1691		236 PAYNEHAM RD	83625985	PAYNEHAM		NEXT TO PAYNEHAM HOME FURNITURE	2495	Thu Mar 05 20:10:55 1998 CST	f	0
1692		56 HUGHES ST	83517172	MILE END			2499	Thu Mar 05 20:33:22 1998 CST	f	0
1693		22- 85 WINSDOR	82666912	KLEMZIC		$1.00 DELIVERY FEE	2511	Thu Mar 05 22:10:58 1998 CST	f	0
1694		UNIT8/24 WAKEFIELD ST	83613796	KENT TOWN			2515	Thu Mar 05 22:53:15 1998 CST	f	0
1695	ROBERT SARRAF	UNIT 4/10 WASHINGTON ST		HILTON			2516	Thu Mar 05 23:23:35 1998 CST	f	0
1696		71 HARRIET ST	83407502	WEST CROYDON			2521	Fri Mar 06 00:57:40 1998 CST	f	0
1697		2 INVERGOWRIE AVE	82715369	HIGHGATE			2522	Fri Mar 06 01:03:48 1998 CST	f	0
1698		56B RIED AVE	83687804	TRANMERE		$1.00 DELIVERY FEE	2523	Fri Mar 06 01:08:49 1998 CST	f	0
1699		89 PROSPECT RD	83445821	PROSPECT		GO UP DRIVEWAY AND PARK IN CAR PARK AND GO UP STAIRS AT BACK OF RESTAURANT	2527	Fri Mar 06 01:26:51 1998 CST	f	0
1700		6 BLYTH ST	83578657	PARKSIDE			2533	Fri Mar 06 02:26:40 1998 CST	f	0
1701		1-310 A MARION RD	83511216	NETLEY			2534	Fri Mar 06 03:04:35 1998 CST	f	0
1702		11\\181 PAYNEHAM	83633823	ST PETERS			2537	Fri Mar 06 03:37:29 1998 CST	f	0
1703		12 AUDLEY AVE	83448179	PROSPECT			0	Fri Mar 06 15:39:04 1998 CST	f	0
1704		42 charlick circuit unit 31	0417811672	ADELAIDE			2541	Fri Mar 06 17:27:05 1998 CST	f	0
1705		17 NEWBON STREET	83420639	NAILSWORTH			2544	Fri Mar 06 18:18:24 1998 CST	f	0
1706		13 WATSON AVENUE`	83313713	ROSE PARK			2548	Fri Mar 06 18:49:24 1998 CST	f	0
1707		15 ARTHUR STREET	83366125	PAYNEHAM			2549	Fri Mar 06 18:56:04 1998 CST	f	0
1708		246 SOUTH TERRACE	83592334	ADELAIDE			2556	Fri Mar 06 19:56:43 1998 CST	f	0
1709		256 FLINDERS ST (EXPRESS COLOR)	82240722	ADELAIDE			2566	Fri Mar 06 21:03:48 1998 CST	f	0
1710		7 CORINDA AVE	83612329	KENSINGTON PK		\
	2572	Fri Mar 06 22:13:43 1998 CST	f	0
1711		2 SANDERS PLACE	82232962	ADELAIDE			2574	Fri Mar 06 23:21:18 1998 CST	f	0
1712		1/5 HILL ST	83366860	CAMPBELL TOWN		$2.00	2580	Sat Mar 07 00:07:16 1998 CST	f	0
1713		FLAT 6/36 RUNDLE STREET	83629607	KENT TOWN			2584	Sat Mar 07 00:46:30 1998 CST	f	0
1714		369 PORTRUSH RD	83310003	TOORAK GDS	118		2587	Sat Mar 07 01:09:09 1998 CST	f	0
1715		80-40 PARK TCE	83422926	GILBERTON			2589	Sat Mar 07 01:13:35 1998 CST	f	0
1716		4/19 FINNESS STREET	82673032	NORTH ADELAIDE			2590	Sat Mar 07 01:19:00 1998 CST	f	0
1717		16/87 MARY STREET	82711364	UNLEY			2592	Sat Mar 07 01:25:50 1998 CST	f	0
1718		70 BRIDGE ST	84319061	KENSINGTON			2596	Sat Mar 07 01:54:01 1998 CST	f	0
1719		2/25 ROSLIND STREET	83322037	KENSINGTON GRD		1$ FEE	2597	Sat Mar 07 02:06:00 1998 CST	f	0
1720		4/95 KENSINGTON RD	83612721	NORWOOD			2599	Sat Mar 07 02:49:47 1998 CST	f	0
1721	SLOBOPDAN	]		ADELAIDE			0	Sat Mar 07 03:24:24 1998 CST	f	0
1722		2/68 BRIDGE ST	84315930	KENSINGTOM			2607	Sat Mar 07 03:31:34 1998 CST	f	0
1723		NORTH TCE	0.5	ADELAIDE		EMERGENCY DEP.\
\
	2608	Sat Mar 07 04:00:00 1998 CST	f	0
1724		4 KIETH ST	82666107	MANNINGHAM			2621	Sat Mar 07 18:31:20 1998 CST	f	0
1725		UNIT 16/3 CAPPER ST	83620682	KENT TOWN			2623	Sat Mar 07 18:48:14 1998 CST	f	0
1726		3-24 COKE ST	83613919	NORWOOD			2626	Sat Mar 07 19:00:04 1998 CST	f	0
1727		U3 237 FULLARTON RD	82723427	EASTWOOD	118		2649	Sun Mar 08 00:57:38 1998 CST	f	0
1728		63 MYRTLE ST	83420835	PROSPECT			2643	Sat Mar 07 23:04:56 1998 CST	f	0
1729		74 ALBERT ST	82727794	GOODWOOD			2645	Sun Mar 08 00:29:22 1998 CST	f	0
1730		23 TENNYSON AVE	83330064	TRANMERE		$1.OO DEL\
	2652	Sun Mar 08 01:12:51 1998 CST	f	0
1731		22 NORTHCOTE TCE	83421410	GILBERTON			2653	Sun Mar 08 01:14:53 1998 CST	f	0
1732		7 DOVER ST	0419564292	UNLEY			2654	Sun Mar 08 01:15:38 1998 CST	f	0
1733		30 VINCENT ST	82323327	ADELAIDE			2655	Sun Mar 08 01:30:13 1998 CST	f	0
1734		48 FLINDERS ST	83639034	KENT TOWN			2658	Sun Mar 08 02:11:21 1998 CST	f	0
1735		2A BALLARA ST	83522635	MILE END			2667	Sun Mar 08 03:09:18 1998 CST	f	0
1736		13 CHARLES ST	834410483	PROSPECT			2668	Sun Mar 08 03:20:06 1998 CST	f	0
1737		UNIT1/42 GEORGE ST	83612064	NORWOOD			2669	Sun Mar 08 03:28:14 1998 CST	f	0
1738		87A STH TCE	821252111	ADELAIDE		4940526319049465 EXP 1098	2672	Sun Mar 08 03:45:59 1998 CST	f	0
3	NO NAME	hindmarsh square - nw	82232000			this customer has no name !	8	epoch	f	0
4	ANOTHER NON CUSTOMER	hindmarsh square	123		118	this customer has no name !this customer has no name !	3	epoch	f	0
32		6 GILBERT STREET	83646618	ADELAIDE	118	ENTER EAST OFF OF CAMBRIDGE TERRACE ROOM	1790	Sat Feb 21 03:37:01 1998 CST	t	0
491	FLICKS AMUSMENT ARCADE	HINDLEY STREET	82127324	ADELAIDE	118	NEXT TO GREATER UNION	955	Thu Feb 05 21:18:47 1998 CST	f	0
489		33 PRINCES ST	83447864	PROSPECT	 		58	epoch	t	0
1019	CRAZY HORSE	HINDLEY ST		ADELAIDE	 	\
	2651	Sun Mar 08 01:01:23 1998 CST	f	10
277		4 VICTORIA STREET	83629316	PAYNEHAM			2619	Sat May 16 01:49:47 1998 CST	f	0
951		4/31 EVERAD AVE	83512934	ASHFORD			1145	Sun May 17 00:47:12 1998 CST	f	0
1052	STORMYS	155 WAYMOUTH ST		ADELAIDE	 		2660	Sun May 17 01:07:16 1998 CST	f	10
1740		12 HOOK STREET	999	ADELAIDE	 	complains about paying extra for choc sauce	2677	Sun May 17 02:08:58 1998 CST	t	0
1739		198 FRANKLIN ST	82317709	ADELAIDE			2673	Sun May 17 02:10:57 1998 CST	f	0
\.
COPY category FROM stdin;
P	Pizza	t
T	Pasta	t
S	Steak	t
C	Chicken	t
E	Seafood	t
Z	Specials	f
R	Drinks	f
A	Appetisers	t
D	Dessert	t
\.
COPY items FROM stdin;
P	SMA	Small Margherita	8	f	t
P	SAU	Small Australian	8.5	f	t
P	SAM	Small American	9	f	t
P	SHW	Small Hawiian	9	f	t
P	SCP	Small Capriciosa	9	f	t
P	SSP	Small Special	9	f	t
P	SVG	Small Vegetarian	9	f	t
P	SML	Small Meat Lovers	9.5	f	t
P	SMX	Small Mexican	9.5	f	t
P	SSG	Small SanGiorgio	9.5	f	t
P	SCH	Small Chicken Hawiian	9.5	f	t
P	SSE	Small Seafood	9.5	f	t
P	SSU	Small Supreme	9.5	f	t
P	LMA	Large Margherita	11.5	f	t
P	LAU	Large Australian	12	f	t
P	LAM	Large American	12.5	f	t
P	LHW	Large Hawiian	12.5	f	t
P	LCP	Large Capriciosa	12.5	f	t
P	LSP	Large Special	12.5	f	t
P	LVG	Large Vegetarian	12.5	f	t
P	LML	Large Meat Lovers	13	f	t
P	LMX	Large Mexican	13	f	t
P	LSG	Large SanGiorgio	13.5	f	t
P	LCH	Large Chicken Hawiian	13	f	t
P	LSE	Large Seafood	13.5	f	t
P	LSU	Large Supreme	13.5	f	t
P	FMA	Family Margherita	15	f	t
P	FAU	Family Australian	16	f	t
P	FAM	Family American	16.5	f	t
P	FHW	Family Hawiian	16.5	f	t
P	FCP	Family Capriciosa	17	f	t
P	FSP	Family Special	17	f	t
P	FVG	Family Vegetarian	17	f	t
P	FML	Family Meat Lovers	17.5	f	t
P	FMX	Family Mexican	17.5	f	t
P	FSG	Family SanGiorgio	18	f	t
P	FCH	Family Chicken Hawiian	17.5	f	t
P	FSE	Family Seafood	18	f	t
P	FSU	Family Supreme	18	f	t
P	CR	Calzone Rustico	10.5	f	t
P	CV	Calzone Vegetarian	10.5	f	t
P	GB	Garlic Bread	2	f	t
P	HB	Herb Bread	2	f	t
P	CBR	Continental Bread (2 peices)	0.6	f	t
P	BBQ	BBQ Sauce	1	f	t
P	HALF	1/2	0	f	f
P	PSM	SMALL PICK-UP	6.9	f	t
P	PLG	LARGE PICK-UP	9.9	f	t
P	PFM	FAMILY PICK-UP	12.9	f	t
P	SX	EXTRA	0.5	f	t
P	LX	EXTRA	0.7	f	t
P	FX	EXTRA	1	f	t
P	NO	No	0	f	t
P	DIS	discount	-1	t	f
P	+	+	1	t	f
P	50	*****$50.00 NOTE*****	0	f	t
P	100	****$100.00 NOTE*****	0	f	t
P	S	SMALL	9.5	f	t
P	L	LARGE	13.5	f	t
P	F	FAM	18	f	t
T	ESMA	Entree Spaghetti Marinara	9	f	t
T	ESAP	Entree Spaghetti Alla Panna	8	f	t
T	ESCB	Entree Spaghetti Carbonara	8	f	t
T	ESPU	Entree Spaghetti Putanesca	7.5	f	t
T	ESBO	Entree Spaghetti Bolognese	7	f	t
T	ESVG	Entree Spaghetti Vegetarian	7	f	t
T	ESNA	Entree Spaghetti Napoletana	7	f	t
T	ESAL	Entree Spaghetti Alfredo	7	f	t
T	EFMA	Entree Fettucini Marinara	9	f	t
T	EFAP	Entree Fettucini Alla Panna	8	f	t
T	EFCB	Entree Fettucini Carbonara	8	f	t
T	EFPU	Entree Fettucini Putanesca	7.5	f	t
T	EFBO	Entree Fettucini Bolognese	7	f	t
T	EFVG	Entree Fettucini Vegetarian	7	f	t
T	EFNA	Entree Fettucini Napoletana	7	f	t
T	EFAL	Entree Fettucini Alfredo	7	f	t
T	ERMA	Entree Ravioli Marinara	9	f	t
T	ERAP	Entree Ravioli Alla Panna	8	f	t
T	ERCB	Entree Ravioli Carbonara	8	f	t
T	ERPU	Entree Ravioli Putanesca	7.5	f	t
T	ERBO	Entree Ravioli Bolognese	7	f	t
T	ERVG	Entree Ravioli Vegetarian	7	f	t
T	ERNA	Entree Ravioli Napoletana	7	f	t
T	ERAL	Entree Ravioli Alfredo	7	f	t
T	EMMA	Entree Macaroni Marinara	9	f	t
T	EMAP	Entree Macaroni Alla Panna	8	f	t
T	EMCB	Entree Macaroni Carbonara	8	f	t
T	EMPU	Entree Macaroni Putanesca	7.5	f	t
T	EMBO	Entree Macaroni Bolognese	7	f	t
T	EMVG	Entree Macaroni Vegetarian	7	f	t
T	EMNA	Entree Macaroni Napoletana	7	f	t
T	EMAL	Entree Macaroni Alfredo	7	f	t
T	ETMA	Entree Tortelline Marinara	9	f	t
T	ETAP	Entree Tortelline Alla Panna	8	f	t
T	ETCB	Entree Tortelline Carbonara	8	f	t
T	ETPU	Entree Tortelline Putanesca	7.5	f	t
T	ETBO	Entree Tortelline Bolognese	7	f	t
T	ETVG	Entree Tortelline Vegetarian	7	f	t
T	ETNA	Entree Tortelline Napoletana	7	f	t
T	ETAL	Entree Tortelline Alfredo	7	f	t
T	ECMA	Entree Ricotta Ravioli Marinara	9	f	t
T	ECAP	Entree Ricotta Ravioli Alla Panna	8	f	t
T	ECCB	Entree Ricotta Ravioli Carbonara	8	f	t
T	ECPU	Entree Ricotta Ravioli Putanesca	7.5	f	t
T	ECBO	Entree Ricotta Ravioli Bolognese	7	f	t
T	ECVG	Entree Ricotta Ravioli Vegetarian	7	f	t
T	ECNA	Entree Ricotta Ravioli Napoletana	7	f	t
T	ECAL	Entree Ricotta Ravioli Alfredo	7	f	t
T	ELA	Entree Lasagna	7.5	f	t
T	MSMA	Spaghetti Marinara	11.5	f	t
T	MSAP	Spaghetti Alla Panna	10	f	t
T	MSCB	Spaghetti Carbonara	10	f	t
T	MSPU	Spaghetti Putanesca	9.5	f	t
T	MSBO	Spaghetti Bolognese	9.5	f	t
T	MSVG	Spaghetti Vegetarian	9.5	f	t
T	MSNA	Spaghetti Napolitana	9	f	t
T	MSAL	Spaghetti Alfredo	9	f	t
T	MFMA	Fettucini Marinara	11.5	f	t
T	MFAP	Fettucini Alla Panna	10	f	t
T	MFCB	Fettucini Carbonara	10	f	t
T	MFPU	Fettucini Putanesca	9.5	f	t
T	MFBO	Fettucini Bolognese	9.5	f	t
T	MFVG	Fettucini Vegetarian	9.5	f	t
T	MFNA	Fettucini Napolitana	9	f	t
T	MFAL	Fettucini Alfredo	9	f	t
T	MRMA	Ravioli Marinara	11.5	f	t
T	MRAP	Ravioli Alla Panna	10	f	t
T	MRCB	Ravioli Carbonara	10	f	t
T	MRPU	Ravioli Putanesca	9.5	f	t
T	MRBO	Ravioli Bolognese	9.5	f	t
T	MRVG	Ravioli Vegetarian	9.5	f	t
T	MRNA	Ravioli Napolitana	9	f	t
T	MRAL	Ravioli Alfredo	9	f	t
T	MMMA	Macaroni Marinara	11.5	f	t
T	MMAP	Macaroni Alla Panna	10	f	t
T	MMCB	Macaroni Carbonara	10	f	t
T	MMPU	Macaroni Putanesca	9.5	f	t
T	MMBO	Macaroni Bolognese	9.5	f	t
T	MMVG	Macaroni Vegetarian	9.5	f	t
T	MMNA	Macaroni Napolitana	9	f	t
T	MMAL	Macaroni Alfredo	9	f	t
T	MTMA	Tortellini Marinara	11.5	f	t
T	MTAP	Tortellini Alla Panna	10	f	t
T	MTCB	Tortellini Carbonara	10	f	t
T	MTPU	Tortellini Putanesca	9.5	f	t
T	MTBO	Tortellini Bolognese	9.5	f	t
T	MTVG	Tortellini Vegetarian	9.5	f	t
T	MTNA	Tortellini Napolitana	9	f	t
T	MTAL	Tortellini Alfredo	9	f	t
T	MCMA	Ricotta Ravioli Marinara	11.5	f	t
T	MCAP	Ricotta Ravioli Alla Panna	10	f	t
T	MCCB	Ricotta Ravioli Carbonara	10	f	t
T	MCPU	Ricotta Ravioli Putanesca	9.5	f	t
T	MCBO	Ricotta Ravioli Bolognese	9.5	f	t
T	MCVG	Ricotta Ravioli Vegetarian	9.5	f	t
T	MCNA	Ricotta Ravioli Napolitana	9	f	t
T	MCAL	Ricotta Ravioli Alfredo	9	f	t
T	MLA	Main Lasagna	9.5	f	t
S	STPR	Pepper Steak - Rare	15	f	t
S	STRR	Rump Steak - Rare	13	f	t
S	STFR	Fillet Mignon - Rare	17	f	t
S	STDMR	Steak Dianne - Md Rare	15	f	t
S	STPMR	Pepper Steak - Md Rare	15	f	t
S	STRMR	Rump Steak - Md Rare	13	f	t
S	STFMR	Fillet Mignon - Md Rare	17	f	t
S	STD	Steak Dianne	15	f	t
S	STP	Pepper Steak	15	f	t
S	STR	Rump Steak	13	f	t
S	STF	Fillet Mignon	17	f	t
S	STDMW	Steak Dianne - Md Well Done	15	f	t
S	STPMW	Pepper Steak - Md Well Done	15	f	t
S	STRMW	Rump Steak - Md Well Done	13	f	t
S	STFMW	Fillet Mignon - Md Well Done	17	f	t
S	STDWD	Steak Dianne - Well Done	15	f	t
S	STPWD	Pepper Steak - Well Done	15	f	t
S	STRWD	Rump Steak - Well Done	13	f	t
S	STFWD	Fillet Mignon - Well Done	17	f	t
S	STVP	Veal Parmigiana	14	f	t
S	STMS	Scaloppina Mushroom	11.5	f	t
S	STSB	Scaloppina Bianco	10.5	f	t
S	STSM	Scaloppina Marsala	10.5	f	t
S	STSH	Schnitzel	10.5	f	t
C	CHF	Chicken Fillets	14	f	t
C	CHAV	Chicken Avocado	14	f	t
C	CHAS	Chicken Asparagus	14	f	t
C	CHHW	Chicken Hawiian	14	f	t
C	CHGR	Grilled Chicken	13	f	t
C	CHCS	Chef's Salad	13	f	t
C	GRAVY	Gravy for chicken	2	f	t
C	CHMS	Mushroom Sauce	2	f	t
E	EGW	Entree Grilled Whiting	9	f	t
E	EFW	Entree Fried Whiting	9	f	t
E	EFP	Entree Fried Prawns	10	f	t
E	EFC	Entree Fried Calamari	8.5	f	t
E	EGP	Entree Garlic Prawns	10.5	f	t
E	MGW	Main Grilled Whiting	15	f	t
E	MFW	Main Fried Whiting	15	f	t
E	MFP	Main Fried Prawns	16	f	t
E	MFC	Main Fried Calamari	13.5	f	t
E	MGP	Main Garlic Prawns	16.5	f	t
D	DTA	Tartufo	3.5	f	t
D	DCA	Cassata	3.5	f	t
D	DCC	Cheese Cake	3.5	f	t
D	DCM	Chocolate Mousse	3.5	f	t
D	DFS	Fruit Salad & Ice Cream	4.5	f	t
D	DBF	Black Forrest Cake	4	f	t
D	DGE	Gelati Cup	4	f	t
D	DAPC	Apple Pie with Cream	3.5	f	t
A	PC	Prawn Cocktail	8	f	t
A	PA	Prawn Avocado	10	f	t
A	ONH	1/2 Dozen Oysters Natural	8.5	f	t
A	OND	Dozen Oysters Natural	13	f	t
A	OKH	1/2 Dozen Oysters Kilpatrick	10	f	t
A	OKD	Dozen Oysters Kilpatrick	14.5	f	t
A	MINE	Minestrone Soup	4.5	f	t
A	SD	Soup of the Day	4.5	f	t
A	FS	French Salad	4	f	t
Z	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	20	f	t
Z	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	15.9	f	t
Z	CIGS	Cigarettes	8	t	t
P	DIANE	DIANNE SAUCE	2.8	f	t
P	PEPER	PEPPER SAUCE	2.8	f	t
D	DLGE	large gelati cup	6	f	t
Z	CUT	*******CUTLERY**************	0	f	t
P	MAR	1/2 MARGHERITA	0	f	t
P	AUS	1/2 AUSTRALIAN	0	f	t
P	AME	1/2 AMERICAN	0	f	t
P	HAW	1/2 HAWAIIN	0	f	t
P	CAP	1/2 CAPRICIOSA	0	f	t
P	SPE	1/2 SPECIAL	0	f	t
P	VEG	1/2 VEGETARIAN	0	f	t
P	MLO	1/2 MEAT LOVERS	0	f	t
P	MEX	1/2 MEXICAM	0	f	t
P	SAN	1/2 SAN GIORGIO	0	f	t
P	CHA	1/2 CHICKEN HAWAIIN	0	f	t
P	SEA	1/2 SEAFOOD	0	f	t
P	SUP	1/2 SUPREME	0	f	t
C	CSTZ	CHICKEN SCHNITZEL WITH VEGETABLES	14	f	t
A	VEGIE	SERVE OF VEGETABLES	3.5	f	t
P	CPG	chicken parmigana	14	f	t
P	HOT	PLUS CHILLIE	0	f	t
A	GS	Greek Salad	4	f	t
E	CHIPS	Bowl of Chips	3.2	f	f
D	DAPG	Apple Pie with Gelati	3.5	f	t
R	WATR	1.25 Ltr Water	5	f	t
R	DCOKE	1.25 LTR DIET COKE	3	f	t
R	2COKE	2 Ltr Coke	3	f	t
R	2LMND	2 Ltr Lemonade	3	f	t
R	2SQSH	2 Ltr Lemon Squash	3	f	t
R	COKE	1.25 Ltr Coke	3	f	t
R	FANTA	1.25 Ltr Fanta	3	f	t
R	LMND	1.25 Ltr Lemonade	3	f	t
R	SQSH	1.25 Ltr Lemon Squash	3	f	t
R	CCOKE	Can of Coke	1.7	f	t
R	CDIET	CAN OF DIET COKE	1.7	f	t
R	CHIN	BOTTLE OF CHINOTTO	3.5	f	t
R	CFANTA	Can of Fanta	1.7	f	t
R	CLMND	Can of Lemonade	1.7	f	t
R	CSQSH	Can of Lemon Squash	1.7	f	t
R	MIN	BOTTLE OF M/W	3.5	f	t
Z	-	-	0	t	t
Z	2S	2 Small Pizzas	16.9	f	f
Z	2F	2 Family Pizzas	25.9	f	f
Z	2L	2 Large Pizzas	19.9	f	f
S	STDR	Steak Dianne - Rare	15	f	t
S	STSZ	Scaloppina Zingara	11.5	f	t
R	2LOJ	2 LITRE ORANGE JUICE	5	f	t
R	SWATR	SML SPRING WATER	1.7	f	t
\.
COPY suburbs FROM stdin;
NORTH ADELAIDE	5006	15	 	1
HACKNEY	5069	15	 	1
COLLEGE PARK	5069	15	 	1
ST PETERS	5069	15	 	1
GILBERTON	5069	15	 	1
STEPNEY	5069	15	 	1
NORWOOD	5067	15	 	1
ROSE PARK	5067	15	 	1
DULWICH	5065	15	 	1
PAYNEHAM	5070	15	 	1
KENSINGTON	5068	15	 	1
TUSMORE	5065	15	 	1
EASTWOOD	5063	15	 	1
PARKSIDE	5063	15	 	1
UNLEY	5061	15	 	1
WAYVILLE	5034	15	 	1
GOODWOOD	5034	15	 	1
KESWICK	5035	15	 	1
RICHMOND	5033	15	 	1
MARLESTON	5033	15	 	1
PLYMPTON	5038	15	 	1
NETLEY	5037	15	 	1
MILE END	5031	15	 	1
BROOKLYN PARK	5032	15	 	1
UNDERDALE	5032	20	 	1
WELLAND	5007	15	 	1
BROMPTON	5007	15	 	1
CROYDON	5006	20	 	1
WOODVILLE	5011	20	 	1
REGENCY PARK	5010	20	 	1
PROSPECT	5082	15	 	1
NAILSWORTH	5083	15	 	1
ENFIELD	5085	20	 	1
WALKERVILLE	5081	15	 	1
KLEMZIG	5087	15	 	1
MARDEN	5070	15	 	1
HYDE PK	0	15	 	1
GLENSIDE	0	15	 	1
KENT TOWN	0	15	 	1
JOSLIN	0	15	 	1
FULLARTON	0	15	 	1
MILE END SOUTH	0	15	 	1
MYRTLE BANK	0	15	 	1
FULHAM	0	30	 	1
CITY	0	15	 	1
FIRLE	0	15	 	1
KILBURN	0	15	 	1
MELROSE PARK	0	15	 	1
PENNINGTON	0	30	 	1
MALRESTON	0	20	 	1
KENSINGTON GDNS	0	20	 	1
ROYSTON PARK	0	15	 	1
FREWVILLE	0	15	 	1
CLARENCE PK	0	15	 	1
MALVERN	0	15	 	1
COLLINSWOOD	0	15	 	1
TORRENSVILLE	0	15	 	1
GLENUNGA	0	15	 	1
BOWDEN	0	15	 	1
MAGILL	0	15	 	1
CAMBPBELLTOWN	0	25	 	1
TORRENS PK	0	25	 	1
WESTBOURNE PK	0	15	 	1
BLACK FOREST	0	20	 	1
HIGATE	0	15		1
FLINDERS PK	0	20	 	1
NETHERBY	0	20	 	1
WEST RICHMOND	0	15	 	1
BROOKLYN PK	0	15	 	1
HINDMARSH	0	15	 	1
BURNSIDE	0	15	 	1
HECTORVILLE	0	15	 	1
RENOWN PK	0	15	 	1
CROYDON PK	0	20	 	1
FERRY PARK	0	20		1
NTH ADEL	0	15		1
HAZELWOOD PK	0	20		1
HEATHPOOL	0	15		1
NORTH ADELADE	0	20		1
RENOWNE PK	0	20	118	1
NTH.ADEL	0	15		1
KINGSWOOD	0	15		1
ROSE PK	0	15		1
NOORWOOD	0	20		1
GLANDORE	0	20		1
BLAIR ATHOL	0	15		1
MEDINDIE	0	15		1
KENT TEWN	0	20		1
HILTON	0	15	118	1
CLARENCE PARK	0	20		1
CAMPBELLTOWN	0	15		1
HAWTHORNE	0	15		1
COLLEGE PK	0	20		1
REKNOWN PARK	0	20		1
GREENACRES	0	20		1
URRBRAE	0	15		1
EVERAD PARK	0	20		1
FITZROY	0	15		1
LOWER MITCHAM	0	20		1
RIDLEYTON	0	15		1
TRANMARE	0	20		1
PAYNEHAM SOUTH	0	20		1
NTH ADELAIDE	0	15		1
KILKENNY	0	15		1
GLEN OSMOND	0	20		1
CROYDON PARK	0	20		1
DEVON PK	0	15		1
WEST HINDMARSH	0	20		1
KENSINGTON GARDENS	0	20		1
WEST CROYDON	0	15		1
EVANDALE	0	20		1
FORRESTVILLE	0	15		1
MARRYATVILLE	0	15		1
TRINITY GDNS	0	20		1
LOCKLEYS	0	20	118	1
GLENELG	0	20		1
TOORAK GDNS	0	20	118	1
HYDE PARK	0	20	118	1
TRINITY GARDENS	0	20		1
KENSINGTON PK	0	20		1
PANORAMA	0	30	118	1
FELIXTOW	0	20		1
MAYLANDS	0	20		1
COWANDILLA	0	20		1
GLYNDE	0	20		1
BEULAH PARK	0	20		1
CLAPHAM	0	20		1
BROADVIEW	0	15		1
KLEMZIC	0	20		1
VALE PK	0	20	118	1
MILLSWOOD	0	20		1
PARK SIDE	0	15		1
COLONEL LIGHT GDS	0	20		1
TOORAK GARDENS	0	15		1
THEBARTON	0	15	118	1
MEDINDIE GDS	0	20		1
HAMSTEAD GDNS	0	20		1
VALE PARK	0	20		1
OVINGHAM	0	20		1
ROYSTON PK	0	20		1
CUMBERLAND PK	0	20		1
KARRALTER PARK	0	20		1
ROSTREVOR	0	20		1
STONYFELL	0	20		1
HIGHGATE	0	20		1
CAMPBELL TOWN	0	20		1
TOORAK GDS	0	20	118	1
KENSINGTON GRD	0	20		1
KENSINGTOM	0	20		1
MANNINGHAM	0	20		1
ASHFORD	0	20		1
BELAIR	0	25	 	1
ROSEPARK	0	20		1
TRANMERE	0	15		1
ADELAIDE	5000	15	 	1
AULDANA	0	30		1
ALLBENY GARDENS	0	20		1
BEULAH PK	0	20	118	1
WAL;KERVILLE	0	20		1
2	2	2	2	2
3	3	3	3	3
\.
COPY suburb_min FROM stdin;
\.
COPY orders FROM stdin;
1	1	f	1			Mon Jan 14 17:27:28 1980 CST	46	\N
2	1	t	0	** Cancelled ** new pickup order	8PM	Mon Jan 14 17:28:14 1980 CST	0	\N
3	1	f	0			Wed Nov 19 18:03:49 1997 CST	0	\N
4	1	f	0			Wed Nov 19 18:50:05 1997 CST	0	\N
5	1	f	0			Wed Nov 19 17:49:20 1997 CST	17.200001	\N
6	1	t	0	** Cancelled ** barry	11PM	Wed Nov 19 17:54:22 1997 CST	0	\N
7	1	f	0			Wed Nov 19 18:08:25 1997 CST	0	\N
8	1	f	0			Wed Nov 19 18:47:28 1997 CST	58.369999	\N
9	1	t	0	** Cancelled ** jack russel	10.30PM	Wed Nov 19 18:36:43 1997 CST	0	\N
10	1	f	0			Wed Nov 19 21:12:45 1997 CST	33.5	\N
11	1	f	0			Wed Nov 19 21:19:51 1997 CST	16.5	\N
12	1	f	0			Thu Nov 20 02:03:27 1997 CST	0	\N
13	1	f	0			Wed Nov 26 17:48:25 1997 CST	22.5	\N
14	1	f	0			Wed Nov 26 17:50:53 1997 CST	3.5	\N
15	1	t	0	russel		Thu Nov 27 02:01:15 1997 CST	4.5	\N
16	1	f	0			Thu Nov 27 17:59:00 1997 CST	83.5	\N
17	1	f	348			Thu Nov 27 18:07:09 1997 CST	3.5	\N
18	1	f	0			Thu Nov 27 19:13:08 1997 CST	33	\N
19	1	t	0			Thu Nov 27 19:17:13 1997 CST	11.5	\N
20	1	f	0			Thu Nov 27 19:17:33 1997 CST	11.5	\N
21	1	f	350			Sun Nov 30 13:55:02 1997 CST	15	\N
22	1	t	0	a pickup order	11PM	Sun Nov 30 13:56:37 1997 CST	15	\N
23	1	f	351			Sun Nov 30 13:58:00 1997 CST	17.5	\N
24	1	f	352			Sun Nov 30 16:37:19 1997 CST	14	\N
25	1	f	352			Sun Nov 30 16:39:17 1997 CST	14	\N
26	1	f	394			Thu Dec 04 03:37:00 1997 CST	19.9	\N
27	1	f	395			Thu Dec 04 03:38:26 1997 CST	17	\N
28	1	f	395			Thu Dec 04 03:39:01 1997 CST	20	\N
29	1	f	396			Thu Dec 04 03:48:15 1997 CST	13	\N
30	1	f	0			Thu Dec 04 03:58:06 1997 CST	49.5	\N
31	1	f	0			Fri Dec 05 15:59:43 1997 CST	17.5	\N
32	1	t	0			Fri Dec 05 18:47:44 1997 CST	14.9	\N
33	1	t	0			Mon Dec 08 02:02:09 1997 CST	147	\N
34	1	t	0			Mon Dec 08 02:06:21 1997 CST	155.5	\N
35	1	t	0			Mon Dec 08 02:07:58 1997 CST	162	\N
36	1	f	0			Mon Dec 08 02:10:15 1997 CST	69.800003	\N
37	1	f	0			Mon Dec 08 02:18:54 1997 CST	121	\N
38	1	t	0			Mon Dec 08 02:20:17 1997 CST	118	\N
39	1	t	0			Mon Dec 08 02:23:06 1997 CST	114	\N
40	1	f	0			Mon Dec 08 02:24:56 1997 CST	108	\N
41	1	f	0			Mon Dec 08 02:30:05 1997 CST	172	\N
42	1	t	0			Mon Dec 08 02:35:43 1997 CST	96.5	\N
43	1	f	410			Wed Dec 17 17:44:35 1997 CST	20.200001	\N
44	1	t	0			Mon Dec 08 02:43:22 1997 CST	128	\N
45	1	t	0	george	8.00	Mon Dec 08 02:46:13 1997 CST	79.5	\N
46	1	t	0	DAPC		Mon Dec 08 02:48:07 1997 CST	89.5	\N
47	1	f	454			Wed Dec 17 17:44:27 1997 CST	33.400002	\N
48	1	f	456			Mon Dec 08 03:31:01 1997 CST	15	\N
49	1	f	456			Wed Dec 17 17:44:20 1997 CST	29	\N
50	1	f	454			Mon Dec 08 04:12:52 1997 CST	99.5	\N
51	1	t	0			Mon Dec 08 04:15:00 1997 CST	38.200001	\N
52	1	f	0			Tue Dec 09 17:39:57 1997 CST	12.5	\N
53	1	t	0			Tue Dec 09 17:43:18 1997 CST	12.5	\N
54	1	f	164			Tue Dec 09 17:44:13 1997 CST	12.5	\N
55	1	f	164			Tue Dec 09 17:44:52 1997 CST	12.5	\N
56	1	f	164			Wed Dec 17 17:44:04 1997 CST	13	\N
57	1	t	0			Wed Dec 10 07:32:20 1997 CST	8	\N
58	1	f	489			Wed Dec 17 17:43:57 1997 CST	11.5	\N
59	1	t	0	fsu		Wed Dec 17 17:43:49 1997 CST	216	\N
60	1	f	164			Wed Dec 17 17:43:42 1997 CST	249.5	\N
61	1	f	0			Fri Dec 12 18:09:02 1997 CST	2	\N
62	1	f	0			Fri Dec 12 19:11:11 1997 CST	15	\N
63	1	f	0			Wed Dec 17 17:43:35 1997 CST	13.5	\N
64	1	f	536			Wed Dec 17 17:43:28 1997 CST	52.900002	\N
65	1	f	536			Wed Dec 17 17:43:21 1997 CST	19.9	\N
66	1	f	0			Wed Dec 17 17:43:09 1997 CST	20	\N
67	1	f	536			Wed Dec 17 17:43:01 1997 CST	19.9	\N
68	1	f	0			Wed Dec 17 17:42:56 1997 CST	15.6	\N
69	1	f	0			Wed Dec 17 17:42:51 1997 CST	15.6	\N
70	1	t	0	GEORGE	4.30	Wed Dec 17 17:42:46 1997 CST	11.5	\N
71	1	f	0			Wed Dec 17 17:42:42 1997 CST	62.400002	\N
72	1	f	416			Wed Dec 17 17:42:36 1997 CST	13	\N
73	1	f	595			Wed Dec 17 17:42:31 1997 CST	18	\N
74	1	f	596			Wed Dec 17 17:43:14 1997 CST	23.9	\N
75	1	f	597			Wed Dec 17 17:42:15 1997 CST	21	\N
76	1	f	164			Wed Dec 17 17:46:28 1997 CST	260.5	\N
77	1	f	164			Wed Dec 17 17:53:24 1997 CST	13	\N
78	1	t	0			Wed Dec 17 17:53:17 1997 CST	13.5	\N
79	1	f	164			Wed Dec 17 17:54:21 1997 CST	18	\N
80	1	f	0			Wed Dec 17 18:05:26 1997 CST	13.5	\N
81	1	f	0			Wed Dec 17 18:05:48 1997 CST	13.5	\N
82	1	f	5			Wed Dec 17 18:20:32 1997 CST	16.5	\N
83	1	f	306			Thu Dec 18 04:11:10 1997 CST	13.5	\N
84	1	f	5			Thu Dec 18 16:47:10 1997 CST	13.5	\N
85	1	f	5			Thu Dec 18 18:01:15 1997 CST	13.5	\N
86	1	t	0	mr smith		Thu Dec 18 18:02:39 1997 CST	13	\N
87	1	t	0	another pickup order		Thu Dec 18 18:04:00 1997 CST	13	\N
88	1	t	0	third pickup		Thu Dec 18 18:05:13 1997 CST	13	\N
89	1	t	0	new pickup		Thu Dec 18 18:10:28 1997 CST	13	\N
90	1	t	0	another pickup		Thu Dec 18 18:14:36 1997 CST	13	\N
91	1	f	5			Thu Dec 18 18:21:20 1997 CST	9	\N
92	1	f	5			Thu Dec 18 18:22:02 1997 CST	12	\N
93	1	f	625			Thu Dec 18 23:18:21 1997 CST	18.5	\N
94	1	f	626			Thu Dec 18 23:20:53 1997 CST	20	\N
95	1	f	5			Fri Dec 19 03:49:24 1997 CST	6.5	\N
96	1	f	5			Fri Dec 19 16:31:04 1997 CST	52	\N
97	1	t	0			Fri Dec 19 22:30:33 1997 CST	310.799988	\N
98	1	f	657			Fri Jan 02 13:30:08 1998 CST	28	\N
99	1	t	0			Fri Jan 02 04:09:00 1998 CST	18	\N
100	1	f	658			Fri Jan 02 13:29:27 1998 CST	35	\N
101	1	f	5			Sat Jan 03 23:20:15 1998 CST	19.5	\N
102	1	f	5			Sat Jan 03 23:21:58 1998 CST	9	\N
103	1	t	0			Sun Jan 04 18:21:32 1998 CST	39.200001	\N
104	1	f	659			Sun Jan 04 18:39:01 1998 CST	28.5	\N
105	1	f	660			Sun Jan 04 18:42:34 1998 CST	15.9	\N
106	1	f	660			Sun Jan 04 18:49:22 1998 CST	16.6	\N
107	1	f	661			Sun Jan 04 22:52:18 1998 CST	15.9	\N
108	1	t	0	** Cancelled ** 		Thu Jan 08 17:38:08 1998 CST	0	\N
109	1	t	0	** Cancelled ** 		Thu Jan 08 17:41:25 1998 CST	0	\N
110	1	t	0	** Cancelled ** 		Thu Jan 08 17:43:21 1998 CST	0	\N
111	1	t	0	** Cancelled ** 		Thu Jan 08 18:01:52 1998 CST	0	\N
112	1	t	0			Thu Jan 08 18:05:20 1998 CST	26.6	\N
113	1	f	469			Fri Jan 09 01:17:11 1998 CST	19	\N
114	1	f	668			Fri Jan 09 01:18:39 1998 CST	17	\N
115	1	f	669			Fri Jan 09 01:20:12 1998 CST	18	\N
116	1	f	449			Fri Jan 09 02:56:31 1998 CST	21	\N
117	1	f	671			Fri Jan 09 04:06:34 1998 CST	41.5	\N
118	1	f	210			Fri Jan 09 12:47:00 1998 CST	26.9	\N
119	1	f	672			Fri Jan 09 16:34:28 1998 CST	25.4	\N
120	1	f	673			Fri Jan 09 17:31:57 1998 CST	28.9	\N
121	1	f	674			Fri Jan 09 17:35:58 1998 CST	24.5	\N
122	1	f	675			Fri Jan 09 18:42:11 1998 CST	23	\N
123	1	f	660			Fri Jan 09 19:00:55 1998 CST	0	\N
124	1	f	676			Fri Jan 09 19:16:57 1998 CST	15.9	\N
125	1	f	14			Fri Jan 09 22:29:53 1998 CST	42.400002	\N
126	1	f	26			Sun Jan 11 18:35:09 1998 CST	20	\N
127	1	f	705			Sun Jan 11 20:13:11 1998 CST	21.9	\N
128	1	f	498			Sun Jan 11 20:15:53 1998 CST	21.5	\N
129	1	f	706			Sun Jan 11 20:54:23 1998 CST	21.5	\N
130	1	f	29			Sun Jan 11 21:06:57 1998 CST	31	\N
131	1	f	19			Sun Jan 11 21:38:17 1998 CST	29	\N
132	1	f	708			Mon Jan 12 00:19:30 1998 CST	17	\N
133	1	t	0			Mon Jan 12 00:22:58 1998 CST	6.9	\N
134	1	f	709			Mon Jan 12 00:57:42 1998 CST	26.9	\N
135	1	f	710			Mon Jan 12 01:25:12 1998 CST	18	\N
136	1	f	51			Tue Jan 13 20:38:00 1998 CST	12.5	\N
137	1	f	400			Tue Jan 13 20:40:13 1998 CST	10	\N
138	1	f	712			Tue Jan 13 20:43:58 1998 CST	28	\N
139	1	f	713			Tue Jan 13 20:48:20 1998 CST	20	\N
140	1	f	714			Tue Jan 13 20:49:46 1998 CST	9	\N
141	1	f	715			Tue Jan 13 20:51:15 1998 CST	25.9	\N
142	1	f	716			Tue Jan 13 20:52:17 1998 CST	15.5	\N
143	1	f	717			Tue Jan 13 20:53:19 1998 CST	15.9	\N
144	1	f	718			Tue Jan 13 20:54:51 1998 CST	30	\N
145	1	f	719			Tue Jan 13 20:56:13 1998 CST	22.9	\N
146	1	f	707			Tue Jan 13 20:58:12 1998 CST	30	\N
147	1	f	453			Tue Jan 13 21:00:05 1998 CST	20.6	\N
148	1	f	720			Tue Jan 13 21:01:42 1998 CST	15	\N
149	1	f	721			Tue Jan 13 21:02:38 1998 CST	15.5	\N
150	1	f	597			Tue Jan 13 21:08:31 1998 CST	26.5	\N
151	1	f	722			Tue Jan 13 22:49:45 1998 CST	15	\N
152	1	f	723			Wed Jan 14 02:48:05 1998 CST	15.9	\N
153	1	f	725			Wed Jan 14 17:52:30 1998 CST	40	\N
154	1	f	579			Wed Jan 14 18:56:40 1998 CST	16	\N
155	1	f	726			Wed Jan 14 19:58:59 1998 CST	38	\N
156	1	f	707			Wed Jan 14 20:09:36 1998 CST	6	\N
157	1	f	707			Wed Jan 14 20:12:25 1998 CST	18.5	\N
158	1	f	255			Wed Jan 14 20:19:04 1998 CST	20	\N
159	1	f	727			Wed Jan 14 20:25:08 1998 CST	15.9	\N
160	1	f	728			Wed Jan 14 20:52:44 1998 CST	15.9	\N
161	1	f	728			Wed Jan 14 20:49:14 1998 CST	0	\N
162	1	f	729			Wed Jan 14 21:21:42 1998 CST	18	\N
163	1	f	549			Wed Jan 14 22:10:11 1998 CST	15.9	\N
164	1	f	29			Wed Jan 14 22:51:11 1998 CST	25	\N
165	1	f	730			Wed Jan 14 23:33:12 1998 CST	11.5	\N
166	1	f	731			Wed Jan 14 23:37:40 1998 CST	18	\N
167	1	f	715			Wed Jan 14 23:57:25 1998 CST	25.9	\N
168	1	f	732			Thu Jan 15 00:06:01 1998 CST	25.4	\N
169	1	t	0	83612631 JAY		Thu Jan 15 00:17:05 1998 CST	32	\N
170	1	f	734			Thu Jan 15 00:32:19 1998 CST	22	\N
171	1	t	0			Thu Jan 15 00:48:40 1998 CST	10.5	\N
172	1	f	536			Thu Jan 15 01:05:09 1998 CST	16.9	\N
173	1	f	736			Thu Jan 15 02:26:00 1998 CST	17.4	\N
174	1	f	737			Thu Jan 15 02:34:44 1998 CST	10.5	\N
175	1	f	713			Thu Jan 15 03:04:26 1998 CST	26.6	\N
176	1	f	738			Thu Jan 15 03:11:12 1998 CST	25.9	\N
177	1	f	113			Thu Jan 15 03:34:23 1998 CST	20.700001	\N
178	1	f	739			Thu Jan 15 03:39:49 1998 CST	19	\N
179	1	f	740			Thu Jan 15 18:10:16 1998 CST	15.5	\N
180	1	f	368			Thu Jan 15 18:12:06 1998 CST	15.9	\N
181	1	f	741			Thu Jan 15 18:20:58 1998 CST	18	\N
182	1	f	742			Thu Jan 15 18:23:50 1998 CST	30	\N
183	1	f	744			Thu Jan 15 22:09:10 1998 CST	23	\N
184	1	f	498			Thu Jan 15 23:29:51 1998 CST	28.5	\N
185	1	f	745			Thu Jan 15 23:52:44 1998 CST	20	\N
186	1	f	746			Fri Jan 16 00:14:37 1998 CST	17.5	\N
187	1	f	310			Fri Jan 16 00:17:14 1998 CST	23.299999	\N
188	1	f	605			Fri Jan 16 00:20:01 1998 CST	19.9	\N
189	1	t	0			Fri Jan 16 00:22:16 1998 CST	11.9	\N
190	1	f	621			Fri Jan 16 00:30:34 1998 CST	32.5	\N
191	1	f	689			Fri Jan 16 01:59:53 1998 CST	15	\N
192	1	f	536			Fri Jan 16 02:02:25 1998 CST	19.9	\N
193	1	f	748			Fri Jan 16 02:24:30 1998 CST	18	\N
194	1	f	749			Fri Jan 16 03:46:47 1998 CST	37	\N
195	1	f	250			Fri Jan 16 04:01:12 1998 CST	19	\N
196	1	f	210			Fri Jan 16 12:41:41 1998 CST	26.9	\N
197	1	f	750			Sat Jan 17 03:35:38 1998 CST	19.5	\N
198	1	f	735			Sat Jan 17 03:45:22 1998 CST	16.200001	\N
199	1	f	702			Sat Jan 17 18:11:51 1998 CST	21	\N
200	1	f	751			Sat Jan 17 23:03:56 1998 CST	13.5	\N
201	1	f	752			Sat Jan 17 23:06:33 1998 CST	21	\N
202	1	f	753			Sun Jan 18 02:40:31 1998 CST	18	\N
203	1	f	754			Sun Jan 18 02:51:31 1998 CST	25.9	\N
204	1	f	755			Sun Jan 18 17:36:26 1998 CST	17.299999	\N
205	1	f	29			Sun Jan 18 17:38:23 1998 CST	18.5	\N
206	1	f	756			Sun Jan 18 17:47:19 1998 CST	19.9	\N
207	1	f	659			Sun Jan 18 18:05:38 1998 CST	17	\N
208	1	f	659			Sun Jan 18 18:08:10 1998 CST	21	\N
209	1	f	757			Sun Jan 18 18:29:13 1998 CST	17.5	\N
210	1	f	758			Sun Jan 18 18:32:40 1998 CST	12.5	\N
211	1	f	759			Sun Jan 18 18:39:38 1998 CST	27.4	\N
212	1	f	760			Sun Jan 18 18:44:25 1998 CST	15.9	\N
213	1	f	761			Sun Jan 18 18:47:24 1998 CST	19.9	\N
214	1	f	84			Sun Jan 18 18:57:04 1998 CST	19.9	\N
215	1	f	154			Sun Jan 18 19:08:15 1998 CST	25.9	\N
216	1	f	371			Sun Jan 18 19:11:34 1998 CST	11.7	\N
217	1	f	762			Sun Jan 18 19:36:37 1998 CST	22.4	\N
218	1	f	763			Sun Jan 18 19:47:38 1998 CST	23.200001	\N
219	1	f	764			Sun Jan 18 19:51:01 1998 CST	18	\N
220	1	f	764			Sun Jan 18 19:54:35 1998 CST	19	\N
221	1	f	269			Sun Jan 18 20:09:58 1998 CST	20	\N
222	1	f	765			Sun Jan 18 20:24:09 1998 CST	23	\N
223	1	f	21			Sun Jan 18 20:36:27 1998 CST	19.5	\N
224	1	f	227			Sun Jan 18 21:09:51 1998 CST	15.9	\N
225	1	f	766			Sun Jan 18 21:30:42 1998 CST	15.9	\N
226	1	f	767			Sun Jan 18 22:30:07 1998 CST	22.200001	\N
227	1	f	626			Sun Jan 18 22:40:29 1998 CST	17.5	\N
228	1	f	160			Sun Jan 18 23:46:39 1998 CST	10	\N
229	1	f	769			Sun Jan 18 23:58:25 1998 CST	20	\N
230	1	f	770			Mon Jan 19 00:02:01 1998 CST	19	\N
231	1	f	771			Mon Jan 19 00:06:46 1998 CST	23.5	\N
232	1	f	772			Mon Jan 19 00:10:43 1998 CST	32.799999	\N
233	1	f	86			Mon Jan 19 00:12:07 1998 CST	17.5	\N
234	1	f	773			Mon Jan 19 00:14:30 1998 CST	14.5	\N
235	1	f	774			Mon Jan 19 00:23:51 1998 CST	20	\N
236	1	f	775			Mon Jan 19 00:29:34 1998 CST	20.9	\N
237	1	f	680			Mon Jan 19 00:38:41 1998 CST	15.9	\N
238	1	f	776			Mon Jan 19 00:50:53 1998 CST	28.299999	\N
239	1	t	0			Mon Jan 19 00:57:47 1998 CST	9.9	\N
240	1	f	777			Mon Jan 19 01:23:13 1998 CST	25.5	\N
241	1	f	782			Mon Jan 19 02:29:07 1998 CST	20.5	\N
242	1	f	784			Mon Jan 19 03:22:41 1998 CST	16.299999	\N
243	1	f	785			Mon Jan 19 18:19:48 1998 CST	20	\N
244	1	f	512			Mon Jan 19 19:06:04 1998 CST	18	\N
245	1	f	786			Mon Jan 19 19:47:05 1998 CST	28	\N
246	1	f	445			Mon Jan 19 20:57:14 1998 CST	16.6	\N
247	1	f	788			Mon Jan 19 21:06:21 1998 CST	19.5	\N
248	1	f	790			Mon Jan 19 21:16:13 1998 CST	20	\N
249	1	f	789			Mon Jan 19 21:25:52 1998 CST	26.9	\N
250	1	f	792			Mon Jan 19 21:46:32 1998 CST	9.5	\N
251	1	f	652			Tue Jan 20 22:23:33 1998 CST	23.6	\N
252	1	f	798			Tue Jan 20 23:31:03 1998 CST	17	\N
253	1	f	799			Tue Jan 20 23:41:45 1998 CST	26.9	\N
254	1	f	705			Wed Jan 21 00:01:08 1998 CST	27.4	\N
255	1	f	113			Wed Jan 21 00:24:33 1998 CST	13	\N
256	1	f	630			Wed Jan 21 01:13:47 1998 CST	23.5	\N
257	1	f	776			Wed Jan 21 01:58:01 1998 CST	22	\N
258	1	f	801			Wed Jan 21 02:01:19 1998 CST	17.9	\N
259	1	f	803			Wed Jan 21 02:49:23 1998 CST	25.9	\N
260	1	f	670			Wed Jan 21 02:59:37 1998 CST	15	\N
261	1	f	113			Wed Jan 21 03:12:51 1998 CST	13.5	\N
262	1	f	807			Wed Jan 21 03:20:49 1998 CST	19	\N
263	1	f	808			Thu Jan 22 18:50:00 1998 CST	0	\N
264	1	f	809			Thu Jan 29 18:13:53 1998 CST	85	\N
265	1	f	810			Thu Jan 22 19:13:55 1998 CST	15.9	\N
266	1	t	0		19.50	Thu Jan 22 19:19:01 1998 CST	9.5	\N
267	1	f	811			Thu Jan 22 19:27:58 1998 CST	15.5	\N
268	1	f	263			Thu Jan 22 19:35:31 1998 CST	25.9	\N
269	1	f	659			Thu Jan 22 19:44:21 1998 CST	26.299999	\N
270	1	f	812			Thu Jan 22 20:03:46 1998 CST	18	\N
271	1	t	0		20.40	Thu Jan 22 20:20:40 1998 CST	23.700001	\N
272	1	f	642			Thu Jan 22 20:24:36 1998 CST	15.9	\N
273	1	f	93			Thu Jan 22 20:33:55 1998 CST	15.9	\N
274	1	t	0		21.05	Thu Jan 22 20:36:26 1998 CST	12.9	\N
275	1	f	40			Thu Jan 22 20:52:24 1998 CST	15.2	\N
276	1	f	814			Thu Jan 22 21:30:42 1998 CST	20.6	\N
277	1	f	813			Thu Jan 22 21:31:32 1998 CST	0	\N
278	1	f	815			Thu Jan 22 21:39:09 1998 CST	108	\N
279	1	f	566			Thu Jan 22 21:46:12 1998 CST	17.4	\N
280	1	f	816			Thu Jan 22 21:56:41 1998 CST	37.5	\N
281	1	f	670			Thu Jan 22 22:12:04 1998 CST	26.4	\N
282	1	f	817			Thu Jan 22 22:17:13 1998 CST	16.5	\N
283	1	f	127			Thu Jan 22 22:29:58 1998 CST	34.900002	\N
284	1	f	818			Thu Jan 22 22:57:32 1998 CST	22	\N
285	1	f	819			Thu Jan 22 23:03:35 1998 CST	22	\N
286	1	f	820			Thu Jan 22 23:07:16 1998 CST	16.6	\N
287	1	f	6			Thu Jan 22 23:16:45 1998 CST	10.5	\N
288	1	f	29			Thu Jan 22 23:32:32 1998 CST	14.5	\N
289	1	f	774			Thu Jan 22 23:38:50 1998 CST	20	\N
290	1	f	447			Thu Jan 22 23:46:49 1998 CST	20.5	\N
291	1	f	821			Thu Jan 22 23:51:28 1998 CST	18	\N
292	1	f	71			Fri Jan 23 00:00:32 1998 CST	20	\N
293	1	f	822			Fri Jan 23 00:04:35 1998 CST	25	\N
294	1	f	724			Fri Jan 23 00:38:35 1998 CST	15.2	\N
295	1	f	823			Fri Jan 23 00:44:25 1998 CST	21	\N
296	1	f	237			Fri Jan 23 00:53:21 1998 CST	19.9	\N
297	1	f	825			Fri Jan 23 00:59:03 1998 CST	19.5	\N
298	1	f	826			Fri Jan 23 01:30:49 1998 CST	15.9	\N
299	1	f	133			Fri Jan 23 01:40:26 1998 CST	20	\N
300	1	f	782			Fri Jan 23 01:45:34 1998 CST	21.5	\N
301	1	f	827			Fri Jan 23 01:52:04 1998 CST	17.299999	\N
302	1	t	0		2.40	Fri Jan 23 02:09:03 1998 CST	9.9	\N
303	1	f	828			Fri Jan 23 02:13:24 1998 CST	19.9	\N
304	1	f	829			Fri Jan 23 02:23:35 1998 CST	12.5	\N
305	1	f	830			Fri Jan 23 03:37:48 1998 CST	20	\N
306	1	f	831			Fri Jan 23 03:42:46 1998 CST	20.9	\N
307	1	f	832			Fri Jan 23 17:36:37 1998 CST	19.200001	\N
308	1	f	833			Fri Jan 23 17:56:17 1998 CST	20	\N
309	1	t	0		19.00	Fri Jan 23 18:30:02 1998 CST	10.6	\N
310	1	f	397			Fri Jan 23 18:31:46 1998 CST	31	\N
311	1	f	740			Fri Jan 23 18:51:14 1998 CST	20	\N
312	1	f	834			Fri Jan 23 18:57:28 1998 CST	19.9	\N
313	1	f	836			Fri Jan 23 19:40:21 1998 CST	15.5	\N
314	1	t	0		20.15	Fri Jan 23 19:46:56 1998 CST	15.9	\N
315	1	f	837			Fri Jan 23 19:53:45 1998 CST	13.5	\N
316	1	f	341			Fri Jan 23 20:03:45 1998 CST	21.299999	\N
317	1	f	839			Fri Jan 23 20:19:32 1998 CST	64.900002	\N
318	1	f	840			Fri Jan 23 20:35:29 1998 CST	17.5	\N
319	1	f	841			Fri Jan 23 21:19:16 1998 CST	20	\N
320	1	f	842			Fri Jan 23 21:22:09 1998 CST	15	\N
321	1	f	814			Fri Jan 23 21:31:39 1998 CST	27.9	\N
322	1	f	441			Fri Jan 23 22:09:10 1998 CST	15.9	\N
323	1	f	843			Fri Jan 23 22:14:18 1998 CST	42.799999	\N
324	1	f	844			Fri Jan 23 22:20:17 1998 CST	20	\N
325	1	f	845			Fri Jan 23 22:25:10 1998 CST	14	\N
326	1	t	0	BRENTON	23.00	Fri Jan 23 22:43:18 1998 CST	7.5	\N
327	1	f	16			Fri Jan 23 22:45:28 1998 CST	19.5	\N
328	1	f	90			Fri Jan 23 22:58:42 1998 CST	15.9	\N
329	1	f	846			Fri Jan 23 23:07:33 1998 CST	14.2	\N
330	1	t	0		23.40	Fri Jan 23 23:13:18 1998 CST	15	\N
331	1	t	0		23.55	Fri Jan 23 23:24:04 1998 CST	9.5	\N
332	1	f	2347			Fri Jan 23 23:47:38 1998 CST	15.9	\N
333	1	f	847			Fri Jan 23 23:58:03 1998 CST	18	\N
334	1	f	848			Sat Jan 24 00:16:50 1998 CST	39.5	\N
335	1	t	0	NICK  0417849561	1.00	Sat Jan 24 00:32:38 1998 CST	38.400002	\N
336	1	f	449			Sat Jan 24 00:56:06 1998 CST	20	\N
337	1	f	849			Sat Jan 24 01:00:54 1998 CST	15	\N
338	1	f	453			Sat Jan 24 01:05:07 1998 CST	17.9	\N
339	1	f	850			Sat Jan 24 01:13:17 1998 CST	30.700001	\N
340	1	t	0		1.45	Sat Jan 24 01:14:54 1998 CST	21.9	\N
341	1	f	851			Sat Jan 24 01:40:41 1998 CST	36.5	\N
342	1	f	735			Sat Jan 24 01:45:49 1998 CST	35.700001	\N
343	1	f	852			Sat Jan 24 01:51:07 1998 CST	15.9	\N
344	1	f	853			Sat Jan 24 02:06:53 1998 CST	41.400002	\N
345	1	f	277			Sat Jan 24 02:13:29 1998 CST	21	\N
346	1	f	854			Sat Jan 24 02:19:04 1998 CST	20	\N
347	1	f	855			Sat Jan 24 02:25:53 1998 CST	20	\N
348	1	f	856			Sat Jan 24 02:31:23 1998 CST	20.6	\N
349	1	f	735			Sat Jan 24 02:35:08 1998 CST	13	\N
350	1	f	306			Sat Jan 24 02:53:18 1998 CST	34.5	\N
351	1	f	857			Sat Jan 24 03:15:37 1998 CST	18.5	\N
352	1	f	858			Sat Jan 24 17:34:41 1998 CST	19.9	\N
353	1	f	695			Sat Jan 24 17:21:30 1998 CST	20	\N
354	1	f	861			Sat Jan 24 18:00:15 1998 CST	19	\N
355	1	f	862			Sat Jan 24 18:04:01 1998 CST	9	\N
356	1	f	863			Sat Jan 24 19:10:48 1998 CST	53.5	\N
357	1	f	864			Sat Jan 24 19:13:40 1998 CST	1	\N
358	1	f	789			Sat Jan 24 19:17:50 1998 CST	25.9	\N
359	1	f	795			Sat Jan 24 19:23:42 1998 CST	16	\N
360	1	f	865			Sat Jan 24 19:27:04 1998 CST	18	\N
361	1	f	866			Sat Jan 24 19:29:14 1998 CST	43	\N
362	1	f	867			Sat Jan 24 19:50:22 1998 CST	12.5	\N
363	1	f	868			Sat Jan 24 19:53:56 1998 CST	19	\N
364	1	f	514			Sat Jan 24 20:03:59 1998 CST	39.900002	\N
365	1	f	370			Sat Jan 24 21:25:50 1998 CST	16.5	\N
366	1	f	869			Sat Jan 24 20:42:15 1998 CST	44.900002	\N
367	1	f	870			Sat Jan 24 21:01:58 1998 CST	22.9	\N
368	1	f	243			Sat Jan 24 21:08:52 1998 CST	13.5	\N
369	1	f	829			Sat Jan 24 21:24:02 1998 CST	16.6	\N
370	1	f	390			Sat Jan 24 21:38:51 1998 CST	21.5	\N
371	1	f	83			Sat Jan 24 21:47:29 1998 CST	11.2	\N
372	1	f	844			Sat Jan 24 21:53:26 1998 CST	20	\N
373	1	f	871			Sat Jan 24 22:53:27 1998 CST	16.6	\N
374	1	f	6			Sat Jan 24 22:54:56 1998 CST	10	\N
375	1	f	6			Sat Jan 24 23:31:20 1998 CST	10	\N
376	1	f	872			Sun Jan 25 00:05:55 1998 CST	24.9	\N
377	1	f	873			Sun Jan 25 00:12:10 1998 CST	19.9	\N
378	1	f	874			Sun Jan 25 00:28:51 1998 CST	21.299999	\N
379	1	f	687			Sun Jan 25 00:48:04 1998 CST	18	\N
380	1	f	875			Sun Jan 25 00:54:13 1998 CST	19.5	\N
381	1	f	876			Sun Jan 25 00:57:43 1998 CST	17.299999	\N
382	1	f	469			Sun Jan 25 01:02:46 1998 CST	15.5	\N
383	1	f	729			Sun Jan 25 01:12:54 1998 CST	20	\N
384	1	f	877			Sun Jan 25 01:23:09 1998 CST	21	\N
385	1	f	536			Sun Jan 25 01:27:03 1998 CST	28	\N
386	1	f	878			Sun Jan 25 01:31:47 1998 CST	25	\N
387	1	f	879			Sun Jan 25 01:48:29 1998 CST	13.9	\N
388	1	f	880			Sun Jan 25 01:52:48 1998 CST	20	\N
389	1	f	163			Sun Jan 25 02:06:48 1998 CST	19.9	\N
390	1	f	881			Sun Jan 25 02:19:05 1998 CST	15.5	\N
391	1	f	882			Sun Jan 25 02:21:38 1998 CST	17.200001	\N
392	1	f	254			Sun Jan 25 02:34:43 1998 CST	22	\N
393	1	f	883			Sun Jan 25 02:37:58 1998 CST	22.5	\N
394	1	f	884			Sun Jan 25 02:47:05 1998 CST	22.5	\N
395	1	f	885			Sun Jan 25 03:20:52 1998 CST	27.9	\N
396	1	f	886			Sun Jan 25 03:28:32 1998 CST	19	\N
397	1	f	763			Sun Jan 25 03:36:52 1998 CST	24.4	\N
398	1	f	887			Sun Jan 25 03:46:26 1998 CST	24.5	\N
399	1	f	423			Sun Jan 25 04:06:45 1998 CST	13	\N
400	1	f	514			Sun Jan 25 16:03:34 1998 CST	52	\N
401	1	f	442			Sun Jan 25 17:18:29 1998 CST	12.5	\N
402	1	f	888			Sun Jan 25 17:25:18 1998 CST	22.5	\N
403	1	f	185			Sun Jan 25 17:45:35 1998 CST	20	\N
404	1	t	0		18.20	Sun Jan 25 17:53:40 1998 CST	27.799999	\N
405	1	f	889			Sun Jan 25 17:59:57 1998 CST	18	\N
406	1	f	890			Sun Jan 25 18:02:21 1998 CST	18	\N
407	1	f	698			Sun Jan 25 19:07:45 1998 CST	23.299999	\N
408	1	f	891			Sun Jan 25 19:20:43 1998 CST	10	\N
409	1	f	892			Sun Jan 25 19:34:32 1998 CST	27.9	\N
410	1	f	893			Sun Jan 25 19:42:08 1998 CST	15.9	\N
411	1	f	894			Sun Jan 25 20:05:16 1998 CST	14.2	\N
412	1	f	443			Sun Jan 25 20:07:12 1998 CST	26	\N
413	1	f	754			Sun Jan 25 20:10:30 1998 CST	16	\N
414	1	f	710			Sun Jan 25 20:12:55 1998 CST	27.9	\N
415	1	f	895			Sun Jan 25 20:17:38 1998 CST	25.9	\N
416	1	f	63			Sun Jan 25 20:23:25 1998 CST	30	\N
417	1	f	896			Sun Jan 25 20:27:20 1998 CST	15.2	\N
418	1	f	365			Sun Jan 25 20:29:32 1998 CST	23.6	\N
419	1	f	440			Sun Jan 25 20:34:16 1998 CST	20	\N
420	1	f	897			Sun Jan 25 20:37:14 1998 CST	20	\N
421	1	f	898			Sun Jan 25 20:48:51 1998 CST	12.5	\N
422	1	f	899			Sun Jan 25 21:07:38 1998 CST	15.9	\N
423	1	f	900			Sun Jan 25 21:19:24 1998 CST	15.9	\N
424	1	f	901			Sun Jan 25 21:22:28 1998 CST	27.299999	\N
425	1	f	902			Sun Jan 25 21:34:07 1998 CST	31	\N
426	1	f	903			Sun Jan 25 21:51:35 1998 CST	20	\N
427	1	f	905			Sun Jan 25 22:10:49 1998 CST	20	\N
428	1	f	906			Sun Jan 25 22:26:22 1998 CST	19.9	\N
429	1	f	19			Sun Jan 25 22:31:57 1998 CST	34	\N
430	1	f	907			Sun Jan 25 23:11:56 1998 CST	19.9	\N
431	1	f	908			Sun Jan 25 23:36:50 1998 CST	15.5	\N
432	1	f	851			Sun Jan 25 23:51:24 1998 CST	41.5	\N
433	1	f	909			Sun Jan 25 23:53:39 1998 CST	10.5	\N
434	1	f	910			Sun Jan 25 23:57:06 1998 CST	24.5	\N
435	1	f	911			Mon Jan 26 00:31:04 1998 CST	16.700001	\N
436	1	f	912			Mon Jan 26 00:36:22 1998 CST	16.5	\N
437	1	f	913			Mon Jan 26 00:49:59 1998 CST	19.9	\N
438	1	f	914			Mon Jan 26 00:53:01 1998 CST	15.9	\N
439	1	f	735			Mon Jan 26 01:00:57 1998 CST	10.25	\N
440	1	f	915			Mon Jan 26 01:07:26 1998 CST	19.9	\N
441	1	f	440			Mon Jan 26 01:19:41 1998 CST	11	\N
442	1	f	916			Mon Jan 26 01:30:35 1998 CST	15.5	\N
443	1	f	917			Mon Jan 26 01:46:11 1998 CST	58.400002	\N
444	1	f	918			Mon Jan 26 01:56:48 1998 CST	33.099998	\N
445	1	f	919			Mon Jan 26 02:07:09 1998 CST	28.5	\N
446	1	f	735			Mon Jan 26 02:11:44 1998 CST	19.9	\N
447	1	f	920			Mon Jan 26 02:52:08 1998 CST	21.299999	\N
448	1	f	921			Mon Jan 26 03:09:11 1998 CST	20	\N
449	1	f	630			Mon Jan 26 03:13:21 1998 CST	20	\N
450	1	f	922			Mon Jan 26 03:26:18 1998 CST	20	\N
451	1	f	306			Mon Jan 26 03:38:52 1998 CST	20	\N
452	1	f	923			Mon Jan 26 04:20:10 1998 CST	13.5	\N
453	1	f	924			Mon Jan 26 17:11:09 1998 CST	36	\N
454	1	f	925			Mon Jan 26 17:34:57 1998 CST	20.5	\N
455	1	f	926			Mon Jan 26 17:43:16 1998 CST	15.5	\N
456	1	f	927			Mon Jan 26 17:45:59 1998 CST	20	\N
457	1	f	928			Mon Jan 26 17:57:05 1998 CST	19.9	\N
458	1	f	742			Mon Jan 26 18:18:53 1998 CST	20	\N
459	1	f	929			Mon Jan 26 18:24:21 1998 CST	19.9	\N
460	1	f	397			Mon Jan 26 18:31:26 1998 CST	29	\N
461	1	f	812			Mon Jan 26 18:36:40 1998 CST	17.299999	\N
462	1	f	930			Mon Jan 26 18:39:07 1998 CST	46.5	\N
463	1	f	931			Mon Jan 26 18:44:12 1998 CST	34.400002	\N
464	1	f	932			Mon Jan 26 18:51:09 1998 CST	23.6	\N
465	1	f	252			Mon Jan 26 18:53:36 1998 CST	15.5	\N
466	1	f	933			Mon Jan 26 18:58:07 1998 CST	9.5	\N
467	1	f	642			Mon Jan 26 19:01:10 1998 CST	15.9	\N
468	1	f	934			Mon Jan 26 19:12:53 1998 CST	28.9	\N
469	1	f	549			Mon Jan 26 19:32:36 1998 CST	30	\N
470	1	f	935			Mon Jan 26 19:48:55 1998 CST	19.9	\N
471	1	f	724			Mon Jan 26 19:53:11 1998 CST	20.1	\N
472	1	f	641			Mon Jan 26 19:59:47 1998 CST	27.9	\N
473	1	t	0		20.40	Mon Jan 26 20:11:49 1998 CST	33.799999	\N
474	1	f	754			Mon Jan 26 20:33:00 1998 CST	11.5	\N
475	1	f	937			Mon Jan 26 20:39:44 1998 CST	35	\N
476	1	f	60			Mon Jan 26 21:00:00 1998 CST	30.9	\N
477	1	f	849			Mon Jan 26 21:07:33 1998 CST	16.6	\N
478	1	f	669			Mon Jan 26 21:28:22 1998 CST	18.4	\N
479	1	f	938			Mon Jan 26 21:34:37 1998 CST	18.700001	\N
480	1	f	939			Mon Jan 26 21:39:45 1998 CST	26	\N
481	1	f	795			Mon Jan 26 21:55:34 1998 CST	15	\N
482	1	f	940			Mon Jan 26 22:11:44 1998 CST	27	\N
483	1	f	124			Mon Jan 26 22:13:47 1998 CST	13.5	\N
484	1	f	263			Mon Jan 26 22:24:28 1998 CST	15.2	\N
485	1	f	941			Mon Jan 26 22:30:12 1998 CST	21	\N
486	1	f	886			Mon Jan 26 22:43:59 1998 CST	19.9	\N
487	1	f	75			Mon Jan 26 22:55:52 1998 CST	30.9	\N
488	1	f	272			Mon Jan 26 22:57:31 1998 CST	16.5	\N
489	1	f	942			Mon Jan 26 23:01:30 1998 CST	12	\N
490	1	f	257			Mon Jan 26 23:09:53 1998 CST	19	\N
491	1	f	943			Mon Jan 26 23:46:26 1998 CST	21	\N
492	1	f	944			Mon Jan 26 23:52:37 1998 CST	18	\N
493	1	f	945			Mon Jan 26 23:59:35 1998 CST	22	\N
494	1	f	776			Tue Jan 27 01:05:48 1998 CST	19	\N
495	1	f	946			Tue Jan 27 01:47:21 1998 CST	18	\N
496	1	f	947			Tue Jan 27 02:02:52 1998 CST	30.5	\N
497	1	f	948			Tue Jan 27 02:16:26 1998 CST	18	\N
498	1	f	37			Tue Jan 27 02:43:38 1998 CST	15.9	\N
499	1	f	949			Tue Jan 27 02:52:28 1998 CST	25	\N
500	1	f	950			Tue Jan 27 03:21:55 1998 CST	20.5	\N
501	1	f	712			Tue Jan 27 03:29:50 1998 CST	17.299999	\N
502	1	f	951			Tue Jan 27 03:43:55 1998 CST	15.5	\N
503	1	f	952			Tue Jan 27 17:44:45 1998 CST	19.9	\N
504	1	f	277			Tue Jan 27 17:49:57 1998 CST	21	\N
505	1	f	93			Tue Jan 27 18:28:59 1998 CST	25	\N
506	1	t	0		19.10	Tue Jan 27 18:40:53 1998 CST	12.9	\N
507	1	f	432			Tue Jan 27 18:56:50 1998 CST	22	\N
508	1	t	0		19.35	Tue Jan 27 19:02:58 1998 CST	28	\N
509	1	f	21			Tue Jan 27 19:19:06 1998 CST	16.6	\N
510	1	f	659			Tue Jan 27 19:27:03 1998 CST	21.5	\N
511	1	f	272			Tue Jan 27 19:39:55 1998 CST	18.4	\N
512	1	t	0		20.20	Tue Jan 27 19:50:52 1998 CST	14.6	\N
513	1	f	840			Tue Jan 27 19:56:03 1998 CST	28.5	\N
514	1	f	116			Tue Jan 27 20:05:26 1998 CST	19.9	\N
515	1	f	161			Tue Jan 27 20:13:32 1998 CST	31.799999	\N
516	1	f	955			Tue Jan 27 20:57:15 1998 CST	16.6	\N
517	1	f	956			Tue Jan 27 21:03:43 1998 CST	20	\N
518	1	f	957			Tue Jan 27 21:18:46 1998 CST	15.9	\N
519	1	f	74			Tue Jan 27 21:39:33 1998 CST	16.5	\N
520	1	f	243			Tue Jan 27 22:01:16 1998 CST	18	\N
521	1	f	958			Tue Jan 27 22:52:23 1998 CST	22	\N
522	1	f	959			Tue Jan 27 23:05:41 1998 CST	19.200001	\N
523	1	t	0	MEL	15 MINUTES0.00	Tue Jan 27 23:30:05 1998 CST	14	\N
524	1	f	447			Tue Jan 27 23:42:19 1998 CST	20.5	\N
525	1	f	961			Tue Jan 27 23:57:54 1998 CST	23.5	\N
526	1	f	962			Wed Jan 28 00:22:38 1998 CST	16.5	\N
527	1	f	629			Wed Jan 28 00:38:50 1998 CST	23.6	\N
528	1	f	626			Wed Jan 28 00:48:42 1998 CST	20.5	\N
529	1	f	963			Wed Jan 28 01:08:25 1998 CST	17.6	\N
530	1	f	964			Wed Jan 28 02:08:11 1998 CST	27	\N
531	1	f	939			Wed Jan 28 02:22:43 1998 CST	24.5	\N
532	1	t	0		3.05	Wed Jan 28 02:38:50 1998 CST	27.5	\N
533	1	f	179			Wed Jan 28 17:42:13 1998 CST	26.9	\N
534	1	f	47			Wed Jan 28 18:52:30 1998 CST	16.6	\N
535	1	f	965			Wed Jan 28 21:40:31 1998 CST	0	\N
536	1	f	966			Wed Jan 28 19:24:25 1998 CST	18	\N
537	1	f	967			Wed Jan 28 19:30:26 1998 CST	26.9	\N
538	1	f	968			Wed Jan 28 21:40:04 1998 CST	0	\N
539	1	f	758			Wed Jan 28 19:35:19 1998 CST	12.5	\N
540	1	t	0		20.10	Wed Jan 28 19:40:32 1998 CST	10.6	\N
541	1	f	969			Wed Jan 28 19:43:30 1998 CST	11.5	\N
542	1	f	723			Wed Jan 28 19:45:07 1998 CST	18	\N
543	1	f	970			Wed Jan 28 19:50:41 1998 CST	35	\N
544	1	f	971			Wed Jan 28 19:59:22 1998 CST	19.5	\N
545	1	f	972			Wed Jan 28 20:06:34 1998 CST	18	\N
546	1	f	973			Wed Jan 28 20:13:39 1998 CST	18	\N
547	1	f	92			Wed Jan 28 20:21:28 1998 CST	12.5	\N
548	1	t	0		21.00	Wed Jan 28 20:27:17 1998 CST	9.9	\N
549	1	f	794			Wed Jan 28 20:33:18 1998 CST	20.6	\N
550	1	f	975			Wed Jan 28 20:44:34 1998 CST	15.5	\N
551	1	f	74			Wed Jan 28 20:54:46 1998 CST	17.5	\N
552	1	f	976			Wed Jan 28 20:56:57 1998 CST	15.9	\N
553	1	f	90			Wed Jan 28 21:39:49 1998 CST	15.9	\N
554	1	f	655			Wed Jan 28 21:34:41 1998 CST	19.9	\N
555	1	f	977			Wed Jan 28 22:11:16 1998 CST	15.9	\N
556	1	f	895			Wed Jan 28 22:26:00 1998 CST	19.9	\N
557	1	f	978			Wed Jan 28 22:42:21 1998 CST	32.099998	\N
558	1	f	193			Wed Jan 28 22:50:01 1998 CST	20.5	\N
559	1	f	388			Wed Jan 28 22:59:33 1998 CST	16.9	\N
560	1	f	410			Thu Jan 29 00:25:07 1998 CST	10.6	\N
561	1	f	979			Wed Jan 28 23:33:09 1998 CST	37	\N
562	1	f	980			Wed Jan 28 23:36:59 1998 CST	15.5	\N
563	1	f	981			Wed Jan 28 23:47:38 1998 CST	24.5	\N
564	1	f	400			Wed Jan 28 23:54:12 1998 CST	16.6	\N
565	1	f	982			Thu Jan 29 00:14:10 1998 CST	20.5	\N
566	1	f	646			Thu Jan 29 00:10:46 1998 CST	18	\N
567	1	t	0		0.50	Thu Jan 29 00:19:12 1998 CST	11.5	\N
568	1	f	983			Thu Jan 29 00:29:44 1998 CST	18.5	\N
569	1	f	917			Thu Jan 29 00:32:14 1998 CST	18.5	\N
570	1	f	984			Thu Jan 29 00:51:27 1998 CST	20	\N
571	1	f	985			Thu Jan 29 01:08:00 1998 CST	17.5	\N
572	1	f	820			Thu Jan 29 01:17:34 1998 CST	19.9	\N
573	1	f	986			Thu Jan 29 01:23:02 1998 CST	23	\N
574	1	t	0		2.05	Thu Jan 29 01:33:27 1998 CST	10.6	\N
575	1	f	987			Thu Jan 29 01:38:05 1998 CST	26.299999	\N
576	1	t	0		.15	Thu Jan 29 01:45:58 1998 CST	7.4	\N
577	1	f	261			Thu Jan 29 01:53:48 1998 CST	16	\N
578	1	f	988			Thu Jan 29 02:07:42 1998 CST	15	\N
579	1	f	989			Thu Jan 29 02:26:57 1998 CST	18	\N
580	1	f	990			Thu Jan 29 02:29:36 1998 CST	19	\N
581	1	t	0	POLICE	3.35	Thu Jan 29 03:04:10 1998 CST	15.9	\N
582	1	f	449			Thu Jan 29 03:33:10 1998 CST	20	\N
583	1	t	0		17.25	Thu Jan 29 16:56:08 1998 CST	12.9	\N
584	1	f	991			Thu Jan 29 17:18:26 1998 CST	21.299999	\N
585	1	f	992			Thu Jan 29 17:43:02 1998 CST	15.2	\N
586	1	f	993			Thu Jan 29 18:08:22 1998 CST	20.6	\N
587	1	f	994			Thu Jan 29 18:54:18 1998 CST	19.9	\N
588	1	f	148			Thu Jan 29 19:09:17 1998 CST	29.9	\N
589	1	f	995			Thu Jan 29 19:24:09 1998 CST	11.5	\N
590	1	f	368			Thu Jan 29 19:28:31 1998 CST	15.9	\N
591	1	t	0		20.00	Thu Jan 29 19:31:33 1998 CST	12.9	\N
592	1	f	996			Thu Jan 29 19:34:48 1998 CST	16.6	\N
593	1	f	858			Thu Jan 29 19:39:18 1998 CST	15	\N
594	1	f	74			Thu Jan 29 19:47:30 1998 CST	18.5	\N
595	1	f	92			Thu Jan 29 19:49:44 1998 CST	11.5	\N
596	1	t	0		20.30	Thu Jan 29 19:59:15 1998 CST	16.9	\N
597	1	f	997			Thu Jan 29 20:02:55 1998 CST	15	\N
598	1	f	812			Thu Jan 29 20:17:13 1998 CST	22	\N
599	1	f	999			Thu Jan 29 20:32:48 1998 CST	15.9	\N
600	1	f	909			Thu Jan 29 20:35:44 1998 CST	10.5	\N
601	1	f	3			Thu Jan 29 20:39:52 1998 CST	31.9	\N
602	1	f	754			Thu Jan 29 20:54:38 1998 CST	14	\N
603	1	f	4			Thu Jan 29 20:59:35 1998 CST	20	\N
604	1	f	815			Thu Jan 29 22:14:03 1998 CST	108	\N
605	1	f	765			Thu Jan 29 21:39:37 1998 CST	23	\N
606	1	f	687			Thu Jan 29 22:09:28 1998 CST	19.9	\N
607	1	f	554			Thu Jan 29 22:19:53 1998 CST	20	\N
608	1	f	181			Thu Jan 29 23:02:41 1998 CST	21.5	\N
609	1	f	243			Thu Jan 29 23:04:16 1998 CST	18	\N
610	1	t	0		0.00	Thu Jan 29 23:27:35 1998 CST	9.5	\N
611	1	f	400			Thu Jan 29 23:36:20 1998 CST	18	\N
612	1	f	5			Thu Jan 29 23:39:03 1998 CST	25.9	\N
613	1	t	0	ADAM	0.20	Thu Jan 29 23:49:06 1998 CST	20.6	\N
614	1	f	781			Thu Jan 29 23:52:40 1998 CST	21.9	\N
615	1	f	6			Fri Jan 30 00:20:07 1998 CST	17.5	\N
616	1	f	296			Fri Jan 30 00:46:30 1998 CST	18	\N
617	1	f	7			Fri Jan 30 00:49:27 1998 CST	20	\N
618	1	t	0		1.25	Fri Jan 30 00:58:31 1998 CST	11	\N
619	1	f	985			Fri Jan 30 01:09:57 1998 CST	13	\N
620	1	f	8			Fri Jan 30 01:42:32 1998 CST	15	\N
621	1	f	8			Fri Jan 30 01:45:57 1998 CST	14.9	\N
622	1	f	277			Fri Jan 30 01:47:49 1998 CST	17.299999	\N
623	1	f	9			Fri Jan 30 02:05:01 1998 CST	15.9	\N
624	1	f	110			Fri Jan 30 02:12:53 1998 CST	18	\N
625	1	f	737			Fri Jan 30 02:40:33 1998 CST	10	\N
626	1	t	0		3.15	Fri Jan 30 02:42:09 1998 CST	9.9	\N
627	1	t	0		3.20	Fri Jan 30 02:48:24 1998 CST	9.5	\N
628	1	f	10			Fri Jan 30 02:54:12 1998 CST	20	\N
629	1	t	0		3.45	Fri Jan 30 03:15:39 1998 CST	8.9	\N
630	1	f	11			Fri Jan 30 04:08:47 1998 CST	23	\N
631	1	f	323			Fri Jan 30 04:16:10 1998 CST	12.9	\N
632	1	f	74			Fri Jan 30 17:18:00 1998 CST	22.5	\N
633	1	f	12			Fri Jan 30 17:24:01 1998 CST	17	\N
634	1	f	13			Fri Jan 30 18:17:35 1998 CST	15.9	\N
635	1	f	14			Fri Jan 30 18:19:50 1998 CST	18	\N
636	1	f	15			Fri Jan 30 18:24:58 1998 CST	26.9	\N
637	1	f	16			Fri Jan 30 18:29:51 1998 CST	24	\N
638	1	f	917			Fri Jan 30 18:41:59 1998 CST	13.5	\N
639	1	f	17			Fri Jan 30 18:47:49 1998 CST	17.5	\N
640	1	f	18			Fri Jan 30 19:07:52 1998 CST	18	\N
641	1	f	19			Fri Jan 30 19:14:26 1998 CST	36	\N
642	1	t	0	KILLMIER	19.50	Fri Jan 30 19:20:54 1998 CST	25.799999	\N
643	1	t	0	EMMA	19.55	Fri Jan 30 19:23:59 1998 CST	11.6	\N
644	1	f	20			Fri Jan 30 19:30:02 1998 CST	15	\N
645	1	f	234			Fri Jan 30 19:46:42 1998 CST	13.5	\N
646	1	t	0	SHANE	20.30	Fri Jan 30 20:00:09 1998 CST	37	\N
647	1	f	784			Fri Jan 30 20:01:29 1998 CST	16.5	\N
648	1	f	440			Fri Jan 30 20:13:03 1998 CST	15.5	\N
649	1	f	21			Fri Jan 30 20:16:14 1998 CST	18	\N
650	1	f	549			Fri Jan 30 20:20:42 1998 CST	18.5	\N
651	1	f	313			Fri Jan 30 20:26:09 1998 CST	20	\N
652	1	f	22			Fri Jan 30 20:32:33 1998 CST	14	\N
653	1	f	23			Fri Jan 30 20:40:29 1998 CST	15.5	\N
654	1	f	21			Fri Jan 30 20:44:16 1998 CST	21	\N
655	1	f	22			Fri Jan 30 20:49:35 1998 CST	12.6	\N
656	1	f	440			Fri Jan 30 20:54:08 1998 CST	20	\N
657	1	t	0		21.30	Fri Jan 30 20:59:19 1998 CST	9.9	\N
658	1	f	22			Fri Jan 30 21:07:00 1998 CST	12.6	\N
659	1	f	688			Fri Jan 30 21:17:14 1998 CST	25.4	\N
660	1	f	24			Fri Jan 30 21:33:56 1998 CST	18	\N
661	1	f	387			Fri Jan 30 21:36:47 1998 CST	31.9	\N
662	1	f	371			Fri Jan 30 21:54:05 1998 CST	10	\N
663	1	f	198			Fri Jan 30 22:02:35 1998 CST	15	\N
664	1	f	92			Fri Jan 30 22:03:34 1998 CST	13.5	\N
665	1	f	25			Fri Jan 30 22:13:08 1998 CST	22	\N
666	1	f	26			Fri Jan 30 22:34:47 1998 CST	20	\N
667	1	f	27			Fri Jan 30 23:12:25 1998 CST	19.9	\N
668	1	f	237			Fri Jan 30 23:14:32 1998 CST	18	\N
669	1	f	660			Fri Jan 30 23:53:37 1998 CST	15.9	\N
670	1	f	28			Sat Jan 31 00:15:59 1998 CST	0	\N
671	1	f	68			Sat Jan 31 00:18:16 1998 CST	15.9	\N
672	1	f	28			Sat Jan 31 00:24:38 1998 CST	23.200001	\N
673	1	t	0		15 MINUTES	Sat Jan 31 00:29:27 1998 CST	6.9	\N
674	1	f	29			Sat Jan 31 01:18:43 1998 CST	16	\N
675	1	f	30			Sat Jan 31 01:00:27 1998 CST	19.4	\N
676	1	f	945			Sat Jan 31 01:15:04 1998 CST	22.9	\N
677	1	f	31			Sat Jan 31 01:21:42 1998 CST	18	\N
678	1	f	32			Sat Jan 31 01:29:01 1998 CST	15.5	\N
679	1	t	0	BOB PARK	2.10	Sat Jan 31 01:40:38 1998 CST	9.9	\N
680	1	t	0	BOB		Sat Jan 31 01:46:58 1998 CST	11.3	\N
681	1	f	29			Sat Jan 31 01:59:05 1998 CST	13.5	\N
682	1	f	33			Sat Jan 31 02:04:32 1998 CST	19.9	\N
683	1	f	35			Sat Jan 31 02:32:43 1998 CST	18	\N
684	1	f	3530			Sat Jan 31 15:41:03 1998 CST	19.9	\N
685	1	f	514			Sat Jan 31 17:11:12 1998 CST	40.5	\N
686	1	t	0	MARKS	17.50	Sat Jan 31 17:16:58 1998 CST	6.9	\N
687	1	f	430			Sat Jan 31 17:32:45 1998 CST	16.5	\N
688	1	f	37			Sat Jan 31 17:48:17 1998 CST	43.400002	\N
689	1	f	38			Sat Jan 31 17:50:34 1998 CST	22.6	\N
690	1	f	39			Sat Jan 31 18:06:28 1998 CST	16.5	\N
691	1	f	40			Sat Jan 31 18:19:55 1998 CST	22.9	\N
692	1	f	204			Sat Jan 31 18:33:27 1998 CST	31	\N
693	1	f	41			Sat Jan 31 18:53:07 1998 CST	19	\N
694	1	f	674			Sat Jan 31 18:56:38 1998 CST	15	\N
695	1	f	725			Sat Jan 31 19:05:34 1998 CST	20.950001	\N
696	1	f	42			Sat Jan 31 19:24:13 1998 CST	12.5	\N
697	1	t	0	PSM	20.05	Sat Jan 31 19:34:44 1998 CST	14.4	\N
698	1	f	43			Sat Jan 31 19:38:41 1998 CST	17.5	\N
699	1	f	44			Sat Jan 31 19:42:07 1998 CST	13.5	\N
700	1	f	45			Sat Jan 31 19:46:55 1998 CST	19	\N
701	1	f	46			Sat Jan 31 19:56:34 1998 CST	18	\N
702	1	f	707			Sat Jan 31 20:05:04 1998 CST	33	\N
703	1	f	3519			Sat Jan 31 20:11:57 1998 CST	16	\N
704	1	f	47			Sat Jan 31 20:33:18 1998 CST	15.5	\N
705	1	f	48			Sat Jan 31 20:51:59 1998 CST	37	\N
706	1	f	735			Sat Jan 31 21:00:58 1998 CST	12.6	\N
707	1	t	0	ROGER	21.35	Sat Jan 31 21:05:22 1998 CST	12.9	\N
708	1	f	50			Sat Jan 31 21:10:59 1998 CST	13.5	\N
709	1	f	56			Sat Jan 31 21:19:35 1998 CST	39.299999	\N
710	1	f	51			Sat Jan 31 21:22:40 1998 CST	19	\N
711	1	f	868			Sat Jan 31 21:26:48 1998 CST	26.6	\N
712	1	f	52			Sat Jan 31 22:22:03 1998 CST	22.9	\N
713	1	f	870			Sat Jan 31 22:25:04 1998 CST	19.9	\N
714	1	f	53			Sat Jan 31 22:32:57 1998 CST	53.5	\N
715	1	f	54			Sat Jan 31 22:55:12 1998 CST	16.200001	\N
716	1	f	55			Sat Jan 31 22:57:27 1998 CST	13.5	\N
717	1	f	56			Sat Jan 31 23:14:20 1998 CST	17	\N
718	1	f	57			Sat Jan 31 23:31:18 1998 CST	17.700001	\N
719	1	f	107			Sat Jan 31 23:46:07 1998 CST	23	\N
720	1	f	58			Sat Jan 31 23:49:52 1998 CST	34	\N
721	1	f	483			Sun Feb 01 00:00:09 1998 CST	26.700001	\N
722	1	f	57			Sun Feb 01 00:04:29 1998 CST	20.299999	\N
723	1	f	59			Sun Feb 01 00:07:56 1998 CST	15.9	\N
724	1	f	917			Sun Feb 01 00:15:37 1998 CST	17.4	\N
725	1	f	60			Sun Feb 01 00:28:23 1998 CST	18	\N
726	1	f	61			Sun Feb 01 00:55:30 1998 CST	18	\N
727	1	f	945			Sun Feb 01 01:07:49 1998 CST	17.5	\N
728	1	f	963			Sun Feb 01 01:09:30 1998 CST	22	\N
729	1	f	62			Sun Feb 01 01:13:43 1998 CST	20	\N
730	1	f	63			Sun Feb 01 01:15:26 1998 CST	17.299999	\N
731	1	f	64			Sun Feb 01 01:32:33 1998 CST	55.799999	\N
732	1	f	65			Sun Feb 01 01:42:44 1998 CST	15.5	\N
733	1	f	66			Sun Feb 01 02:08:06 1998 CST	18	\N
734	1	f	67			Sun Feb 01 02:41:07 1998 CST	0	\N
735	1	f	67			Sun Feb 01 02:43:08 1998 CST	21	\N
736	1	f	68			Sun Feb 01 02:46:10 1998 CST	20.6	\N
737	1	f	37			Sun Feb 01 02:50:44 1998 CST	15.9	\N
738	1	f	163			Sun Feb 01 02:53:01 1998 CST	20	\N
739	1	t	0		3.35	Sun Feb 01 03:06:25 1998 CST	10.3	\N
740	1	f	69			Sun Feb 01 03:24:07 1998 CST	13.4	\N
741	1	f	679			Sun Feb 01 03:43:43 1998 CST	19.9	\N
742	1	f	980			Sun Feb 01 03:46:22 1998 CST	19	\N
743	1	f	70			Sun Feb 01 04:09:04 1998 CST	12.7	\N
744	1	t	0		4.50	Sun Feb 01 04:24:57 1998 CST	17.9	\N
745	1	t	0		5.10	Sun Feb 01 04:38:22 1998 CST	7.4	\N
746	1	t	0		12.30	Sun Feb 01 12:12:48 1998 CST	9.9	\N
747	1	f	71			Sun Feb 01 12:57:12 1998 CST	16.6	\N
748	1	f	957			Sun Feb 01 13:08:17 1998 CST	19.9	\N
749	1	f	72			Sun Feb 01 17:24:22 1998 CST	25.9	\N
750	1	f	73			Sun Feb 01 17:42:39 1998 CST	25.9	\N
751	1	f	1069			Sun Feb 01 18:19:23 1998 CST	21	\N
752	1	f	6569			Sun Feb 01 18:20:58 1998 CST	21	\N
753	1	f	5570			Sun Feb 01 18:30:44 1998 CST	28.9	\N
754	1	f	5571			Sun Feb 01 18:33:51 1998 CST	10.5	\N
755	1	f	5571			Sun Feb 01 18:35:42 1998 CST	21	\N
756	1	f	5572			Sun Feb 01 18:38:37 1998 CST	19.9	\N
757	1	f	5571			Sun Feb 01 18:42:34 1998 CST	19	\N
758	1	f	5573			Sun Feb 01 18:51:35 1998 CST	13	\N
759	1	t	0	DUFFY	19.25	Sun Feb 01 19:13:46 1998 CST	9.9	\N
760	1	f	681			Sun Feb 01 18:58:09 1998 CST	25.9	\N
761	1	f	5574			Sun Feb 01 19:18:28 1998 CST	36.900002	\N
762	1	f	5575			Sun Feb 01 19:24:43 1998 CST	20	\N
763	1	f	892			Sun Feb 01 19:42:46 1998 CST	20.6	\N
764	1	f	5576			Sun Feb 01 19:47:20 1998 CST	16	\N
765	1	f	797			Sun Feb 01 19:49:07 1998 CST	15.9	\N
766	1	f	5577			Sun Feb 01 20:03:06 1998 CST	24.5	\N
767	1	f	5578			Sun Feb 01 20:08:25 1998 CST	11	\N
768	1	f	5579			Sun Feb 01 20:19:56 1998 CST	20	\N
769	1	f	341			Sun Feb 01 20:33:41 1998 CST	17.299999	\N
770	1	f	754			Sun Feb 01 20:36:44 1998 CST	45.5	\N
771	1	f	5580			Sun Feb 01 20:47:49 1998 CST	10.5	\N
772	1	f	242			Sun Feb 01 20:58:16 1998 CST	15.9	\N
773	1	f	243			Sun Feb 01 21:05:15 1998 CST	19.9	\N
774	1	f	5581			Sun Feb 01 21:10:20 1998 CST	20	\N
775	1	f	514			Sun Feb 01 21:29:29 1998 CST	54.299999	\N
776	1	f	5582			Sun Feb 01 21:40:01 1998 CST	19	\N
777	1	f	314			Sun Feb 01 21:44:40 1998 CST	10	\N
778	1	f	276			Sun Feb 01 22:00:41 1998 CST	15.9	\N
779	1	f	19			Sun Feb 01 22:04:38 1998 CST	21.5	\N
780	1	f	1084			Sun Feb 01 22:19:08 1998 CST	21	\N
781	1	f	1085			Sun Feb 01 22:21:24 1998 CST	20	\N
782	1	f	1086			Sun Feb 01 22:42:12 1998 CST	18.700001	\N
783	1	f	1087			Sun Feb 01 22:58:37 1998 CST	18	\N
784	1	f	316			Sun Feb 01 23:12:00 1998 CST	20	\N
785	1	f	526			Sun Feb 01 23:20:19 1998 CST	24.1	\N
786	1	f	445			Sun Feb 01 23:25:08 1998 CST	15.9	\N
787	1	f	1088			Sun Feb 01 23:42:31 1998 CST	20	\N
788	1	f	1089			Sun Feb 01 23:56:38 1998 CST	19.9	\N
789	1	f	1090			Sun Feb 01 23:57:42 1998 CST	30.5	\N
790	1	f	1091			Mon Feb 02 00:10:17 1998 CST	16.5	\N
791	1	f	6			Mon Feb 02 00:28:39 1998 CST	12.5	\N
792	1	f	1092			Mon Feb 02 00:36:25 1998 CST	19.9	\N
793	1	f	1093			Mon Feb 02 00:42:12 1998 CST	13.5	\N
794	1	f	687			Mon Feb 02 00:46:18 1998 CST	19.9	\N
795	1	f	1094			Mon Feb 02 00:52:10 1998 CST	15.9	\N
796	1	f	1095			Mon Feb 02 01:06:04 1998 CST	20	\N
797	1	f	1096			Mon Feb 02 01:11:06 1998 CST	25.9	\N
798	1	f	1097			Mon Feb 02 01:26:58 1998 CST	13.5	\N
799	1	f	280			Mon Feb 02 01:46:25 1998 CST	25.9	\N
800	1	f	1098			Mon Feb 02 02:09:20 1998 CST	24.5	\N
801	1	f	1099			Mon Feb 02 02:38:22 1998 CST	64.699997	\N
802	1	t	0		3.25	Mon Feb 02 02:58:16 1998 CST	8.9	\N
803	1	f	1100			Mon Feb 02 03:05:13 1998 CST	19.9	\N
804	1	f	1101			Mon Feb 02 03:21:18 1998 CST	45.099998	\N
805	1	f	991			Mon Feb 02 17:30:01 1998 CST	21.299999	\N
806	1	f	1102			Mon Feb 02 17:57:04 1998 CST	53	\N
807	1	f	1103			Mon Feb 02 18:00:01 1998 CST	15.9	\N
808	1	f	277			Mon Feb 02 18:03:03 1998 CST	16.6	\N
809	1	f	1024			Mon Feb 02 18:06:37 1998 CST	16.5	\N
810	1	f	1104			Mon Feb 02 19:19:35 1998 CST	16.6	\N
811	1	f	1105			Mon Feb 02 19:29:02 1998 CST	25.4	\N
812	1	f	1106			Mon Feb 02 19:36:52 1998 CST	27.5	\N
813	1	f	559			Mon Feb 02 19:40:21 1998 CST	22.9	\N
814	1	f	797			Mon Feb 02 20:00:17 1998 CST	21	\N
815	1	f	1107			Mon Feb 02 20:02:11 1998 CST	19.9	\N
816	1	f	348			Mon Feb 02 20:12:20 1998 CST	16.5	\N
817	1	f	1108			Mon Feb 02 20:19:54 1998 CST	19	\N
818	1	f	1109			Mon Feb 02 20:28:38 1998 CST	30.799999	\N
819	1	f	440			Mon Feb 02 20:42:06 1998 CST	35.5	\N
820	1	f	660			Mon Feb 02 21:07:12 1998 CST	14.5	\N
821	1	f	219			Mon Feb 02 21:25:19 1998 CST	18	\N
822	1	f	959			Mon Feb 02 21:30:00 1998 CST	15.5	\N
823	1	f	1110			Mon Feb 02 21:52:35 1998 CST	20	\N
824	1	f	659			Mon Feb 02 22:01:23 1998 CST	28.4	\N
825	1	f	1111			Mon Feb 02 22:16:35 1998 CST	14.2	\N
826	1	f	1112			Mon Feb 02 22:49:52 1998 CST	22.5	\N
827	1	t	0	BILLY	23.20	Mon Feb 02 22:52:09 1998 CST	12.9	\N
828	1	f	687			Mon Feb 02 23:18:56 1998 CST	22.9	\N
829	1	f	1113			Mon Feb 02 23:24:34 1998 CST	19.9	\N
830	1	f	877			Mon Feb 02 23:35:13 1998 CST	21	\N
831	1	f	113			Mon Feb 02 23:42:40 1998 CST	27.1	\N
832	1	f	669			Mon Feb 02 23:58:39 1998 CST	18	\N
833	1	f	1114			Tue Feb 03 00:22:45 1998 CST	19	\N
834	1	f	840			Tue Feb 03 00:43:28 1998 CST	16.5	\N
835	1	f	253			Tue Feb 03 00:50:14 1998 CST	23	\N
836	1	f	735			Tue Feb 03 01:00:25 1998 CST	14.85	\N
837	1	f	1115			Tue Feb 03 01:47:22 1998 CST	18.5	\N
838	1	f	1116			Tue Feb 03 02:27:09 1998 CST	39.400002	\N
839	1	f	1117			Tue Feb 03 02:39:45 1998 CST	19.9	\N
840	1	t	0	LUKE	3.40	Tue Feb 03 03:06:52 1998 CST	8.9	\N
841	1	f	1118			Tue Feb 03 03:34:38 1998 CST	16.5	\N
842	1	f	1020			Tue Feb 03 18:39:49 1998 CST	12	\N
843	1	t	0		19.45	Tue Feb 03 19:13:42 1998 CST	9.9	\N
844	1	t	0		19.45	Tue Feb 03 19:14:49 1998 CST	9.9	\N
845	1	f	410			Tue Feb 03 19:28:14 1998 CST	16.200001	\N
846	1	f	909			Tue Feb 03 19:33:12 1998 CST	12.9	\N
847	1	f	1119			Tue Feb 03 19:46:52 1998 CST	19.9	\N
848	1	f	1120			Tue Feb 03 19:53:46 1998 CST	13.5	\N
849	1	f	785			Tue Feb 03 19:56:26 1998 CST	18	\N
850	1	f	638			Tue Feb 03 20:24:16 1998 CST	27.1	\N
851	1	t	0	TERRRY	20.55	Tue Feb 03 20:24:46 1998 CST	6.9	\N
852	1	f	955			Tue Feb 03 20:44:35 1998 CST	15.9	\N
853	1	t	0	BILLY	21.20	Tue Feb 03 20:50:29 1998 CST	12.9	\N
854	1	f	549			Tue Feb 03 21:01:36 1998 CST	21	\N
855	1	f	1121			Tue Feb 03 21:13:01 1998 CST	15.9	\N
856	1	f	124			Tue Feb 03 21:22:16 1998 CST	15.9	\N
857	1	f	375			Tue Feb 03 21:33:48 1998 CST	13.2	\N
858	1	f	1122			Tue Feb 03 22:09:38 1998 CST	27.1	\N
859	1	f	1123			Tue Feb 03 22:18:55 1998 CST	30.5	\N
860	1	f	812			Tue Feb 03 22:24:54 1998 CST	20	\N
861	1	f	1124			Tue Feb 03 22:31:43 1998 CST	18.5	\N
862	1	f	1019			Tue Feb 03 22:40:53 1998 CST	20	\N
863	1	f	1125			Tue Feb 03 22:56:01 1998 CST	28	\N
864	1	f	1026			Tue Feb 03 23:00:22 1998 CST	24	\N
865	1	f	14			Tue Feb 03 23:04:53 1998 CST	34	\N
866	1	f	659			Tue Feb 03 23:16:35 1998 CST	24.5	\N
867	1	f	660			Tue Feb 03 23:25:23 1998 CST	15	\N
868	1	f	851			Tue Feb 03 23:31:47 1998 CST	28.5	\N
869	1	f	1126			Tue Feb 03 23:37:20 1998 CST	15.2	\N
870	1	t	0		0.25	Tue Feb 03 23:53:08 1998 CST	2	\N
871	1	f	778			Tue Feb 03 23:58:08 1998 CST	15	\N
872	1	f	329			Wed Feb 04 00:11:30 1998 CST	21	\N
873	1	f	1127			Wed Feb 04 00:19:17 1998 CST	23.4	\N
874	1	f	959			Wed Feb 04 00:20:03 1998 CST	15.9	\N
875	1	f	1128			Wed Feb 04 00:25:56 1998 CST	24.9	\N
876	1	f	1067			Wed Feb 04 00:35:19 1998 CST	16.299999	\N
877	1	f	1129			Wed Feb 04 01:04:21 1998 CST	20	\N
878	1	t	0		2.15	Wed Feb 04 01:46:32 1998 CST	44	\N
879	1	f	1130			Wed Feb 04 01:59:52 1998 CST	19.9	\N
880	1	f	17			Wed Feb 04 02:03:25 1998 CST	10	\N
881	1	f	1099			Wed Feb 04 02:22:59 1998 CST	36	\N
882	1	f	310			Wed Feb 04 02:26:31 1998 CST	30.5	\N
883	1	f	309			Wed Feb 04 02:34:55 1998 CST	26	\N
884	1	f	1131			Wed Feb 04 02:36:37 1998 CST	20	\N
885	1	f	1132			Wed Feb 04 02:45:15 1998 CST	20	\N
886	1	f	1133			Wed Feb 04 04:14:55 1998 CST	15.2	\N
887	1	f	1134			Wed Feb 04 03:12:38 1998 CST	21	\N
888	1	f	879			Wed Feb 04 03:35:09 1998 CST	15.9	\N
889	1	f	1135			Wed Feb 04 03:39:08 1998 CST	16.9	\N
890	1	f	711			Wed Feb 04 16:10:33 1998 CST	16.5	\N
891	1	f	1136			Wed Feb 04 17:18:44 1998 CST	20.5	\N
892	1	f	1137			Wed Feb 04 17:45:17 1998 CST	30.6	\N
893	1	f	1009			Wed Feb 04 17:46:29 1998 CST	18	\N
894	1	f	154			Wed Feb 04 17:54:58 1998 CST	20	\N
895	1	f	255			Wed Feb 04 18:03:59 1998 CST	19.9	\N
896	1	f	1138			Wed Feb 04 18:12:52 1998 CST	17	\N
897	1	t	0		18.55	Wed Feb 04 18:27:54 1998 CST	20	\N
898	1	f	1139			Wed Feb 04 18:42:07 1998 CST	20	\N
899	1	f	148			Wed Feb 04 18:50:11 1998 CST	28	\N
900	1	f	1067			Wed Feb 04 18:56:19 1998 CST	21.4	\N
901	1	f	1140			Wed Feb 04 19:08:18 1998 CST	23.6	\N
902	1	f	1054			Wed Feb 04 19:45:41 1998 CST	15	\N
903	1	f	440			Wed Feb 04 19:55:57 1998 CST	18	\N
904	1	f	903			Wed Feb 04 20:01:32 1998 CST	19.9	\N
905	1	f	1141			Wed Feb 04 21:10:58 1998 CST	25.5	\N
906	1	f	1142			Wed Feb 04 21:13:42 1998 CST	17.200001	\N
907	1	f	1082			Wed Feb 04 21:34:05 1998 CST	20	\N
908	1	t	0		22.10	Wed Feb 04 21:41:35 1998 CST	6.9	\N
909	1	f	1143			Wed Feb 04 21:43:50 1998 CST	18	\N
910	1	f	659			Wed Feb 04 21:46:25 1998 CST	15.9	\N
911	1	f	1144			Wed Feb 04 22:06:20 1998 CST	27.299999	\N
912	1	f	1133			Wed Feb 04 22:37:59 1998 CST	25.5	\N
913	1	f	1145			Wed Feb 04 23:23:58 1998 CST	19.5	\N
914	1	f	909			Wed Feb 04 23:27:18 1998 CST	13.5	\N
915	1	f	440			Wed Feb 04 23:32:41 1998 CST	13.5	\N
916	1	f	1146			Wed Feb 04 23:45:53 1998 CST	19.9	\N
917	1	f	450			Wed Feb 04 23:52:52 1998 CST	17	\N
918	1	f	939			Wed Feb 04 23:55:21 1998 CST	20	\N
919	1	f	1136			Wed Feb 04 23:56:38 1998 CST	18.5	\N
920	1	f	1147			Thu Feb 05 00:09:43 1998 CST	13.5	\N
921	1	f	1148			Thu Feb 05 00:27:25 1998 CST	21	\N
922	1	f	1129			Thu Feb 05 00:40:06 1998 CST	18	\N
923	1	f	1149			Thu Feb 05 00:44:39 1998 CST	18	\N
924	1	f	1150			Thu Feb 05 01:18:16 1998 CST	22	\N
925	1	f	1151			Thu Feb 05 01:21:41 1998 CST	20.6	\N
926	1	f	306			Thu Feb 05 01:24:42 1998 CST	16.200001	\N
927	1	f	163			Thu Feb 05 01:26:44 1998 CST	20	\N
928	1	f	1152			Thu Feb 05 01:56:07 1998 CST	15.9	\N
929	1	f	1153			Thu Feb 05 02:18:29 1998 CST	18	\N
930	1	f	1154			Thu Feb 05 02:20:22 1998 CST	22.9	\N
931	1	f	1155			Thu Feb 05 02:38:12 1998 CST	29	\N
932	1	f	1156			Thu Feb 05 17:24:36 1998 CST	26.9	\N
933	1	f	956			Thu Feb 05 17:40:55 1998 CST	22	\N
934	1	f	1146			Thu Feb 05 17:51:57 1998 CST	22.9	\N
935	1	f	56			Thu Feb 05 18:07:02 1998 CST	31.9	\N
936	1	f	1157			Thu Feb 05 18:15:53 1998 CST	18.5	\N
937	1	f	373			Thu Feb 05 18:43:54 1998 CST	16.9	\N
938	1	f	120			Thu Feb 05 18:45:33 1998 CST	13.2	\N
939	1	f	674			Thu Feb 05 18:54:47 1998 CST	30	\N
940	1	f	1078			Thu Feb 05 19:20:49 1998 CST	52.5	\N
941	1	f	1158			Thu Feb 05 19:34:16 1998 CST	19.9	\N
942	1	f	1159			Thu Feb 05 19:37:27 1998 CST	19.9	\N
943	1	f	1161			Thu Feb 05 19:45:48 1998 CST	16.9	\N
944	1	f	220			Thu Feb 05 19:55:55 1998 CST	19.9	\N
945	1	t	0		20.30	Thu Feb 05 19:59:46 1998 CST	11.6	\N
946	1	f	1162			Thu Feb 05 20:09:26 1998 CST	19	\N
947	1	f	60			Thu Feb 05 20:10:48 1998 CST	21	\N
948	1	t	0		20.45	Thu Feb 05 20:18:10 1998 CST	16.9	\N
949	1	f	1163			Thu Feb 05 20:20:42 1998 CST	20	\N
950	1	f	1164			Thu Feb 05 20:22:53 1998 CST	19	\N
951	1	f	698			Thu Feb 05 20:26:11 1998 CST	17.299999	\N
952	1	f	735			Thu Feb 05 20:27:50 1998 CST	27	\N
953	1	f	812			Thu Feb 05 20:45:58 1998 CST	15	\N
954	1	f	815			Thu Feb 05 21:17:54 1998 CST	144	\N
955	1	f	491			Thu Feb 05 21:18:47 1998 CST	15.5	\N
956	1	f	1165			Thu Feb 05 21:23:58 1998 CST	20.5	\N
957	1	f	1166			Thu Feb 05 21:34:01 1998 CST	27.4	\N
958	1	f	93			Thu Feb 05 22:43:35 1998 CST	25	\N
959	1	f	1167			Thu Feb 05 21:50:11 1998 CST	23.5	\N
960	1	f	445			Thu Feb 05 21:50:48 1998 CST	12.5	\N
961	1	f	54			Thu Feb 05 21:52:39 1998 CST	17.299999	\N
962	1	f	710			Thu Feb 05 22:09:42 1998 CST	19.9	\N
963	1	f	1168			Thu Feb 05 23:01:42 1998 CST	53.5	\N
964	1	f	1169			Thu Feb 05 23:05:26 1998 CST	19.9	\N
965	1	f	873			Thu Feb 05 23:12:48 1998 CST	19.9	\N
966	1	f	793			Thu Feb 05 23:30:33 1998 CST	10	\N
967	1	f	1170			Thu Feb 05 23:36:46 1998 CST	26	\N
968	1	t	0		0.10	Thu Feb 05 23:38:49 1998 CST	14	\N
969	1	f	1171			Thu Feb 05 23:41:09 1998 CST	15.2	\N
970	1	f	1172			Thu Feb 05 23:43:46 1998 CST	20.6	\N
971	1	f	1173			Thu Feb 05 23:58:21 1998 CST	19.9	\N
972	1	f	6			Fri Feb 06 00:07:55 1998 CST	10.5	\N
973	1	f	1174			Fri Feb 06 02:19:31 1998 CST	18	\N
974	1	f	1175			Fri Feb 06 00:14:12 1998 CST	20.6	\N
975	1	f	1176			Fri Feb 06 00:18:44 1998 CST	13.5	\N
976	1	f	1177			Fri Feb 06 00:20:33 1998 CST	16.200001	\N
977	1	f	1153			Fri Feb 06 00:34:37 1998 CST	18	\N
978	1	f	825			Fri Feb 06 00:36:36 1998 CST	21	\N
979	1	f	1178			Fri Feb 06 00:40:07 1998 CST	19	\N
980	1	f	724			Fri Feb 06 00:45:24 1998 CST	18	\N
981	1	t	0		1.20	Fri Feb 06 00:49:20 1998 CST	18	\N
982	1	t	0		1.20	Fri Feb 06 00:54:00 1998 CST	19	\N
983	1	t	0		1.25	Fri Feb 06 00:54:24 1998 CST	2	\N
984	1	f	1006			Fri Feb 06 01:11:08 1998 CST	15.9	\N
985	1	f	720			Fri Feb 06 01:19:39 1998 CST	35.799999	\N
986	1	f	1179			Fri Feb 06 01:21:53 1998 CST	21.9	\N
987	1	f	1180			Fri Feb 06 01:34:51 1998 CST	16.6	\N
988	1	t	0		2.05	Fri Feb 06 01:37:26 1998 CST	13.9	\N
989	1	f	1100			Fri Feb 06 01:59:05 1998 CST	10.5	\N
990	1	f	355			Fri Feb 06 02:14:42 1998 CST	18	\N
991	1	f	1181			Fri Feb 06 02:29:59 1998 CST	22.6	\N
992	1	f	1099			Fri Feb 06 02:47:40 1998 CST	37.849998	\N
993	1	f	1052			Fri Feb 06 02:55:36 1998 CST	23.85	\N
994	1	f	1182			Fri Feb 06 03:03:11 1998 CST	30.4	\N
995	1	f	1183			Fri Feb 06 03:28:41 1998 CST	15.5	\N
996	1	f	1184			Fri Feb 06 03:37:39 1998 CST	15	\N
997	1	f	1185			Fri Feb 06 03:58:41 1998 CST	60	\N
998	1	f	492			Fri Feb 06 17:06:16 1998 CST	20	\N
999	1	f	1186			Fri Feb 06 17:18:07 1998 CST	18	\N
1000	1	f	759			Fri Feb 06 17:57:09 1998 CST	17.9	\N
1001	1	f	63			Fri Feb 06 17:59:57 1998 CST	24.9	\N
1002	1	f	1037			Fri Feb 06 18:14:35 1998 CST	24.4	\N
1003	1	f	701			Fri Feb 06 18:20:30 1998 CST	21.5	\N
1004	1	f	1139			Fri Feb 06 18:37:39 1998 CST	41	\N
1005	1	f	1187			Fri Feb 06 18:50:57 1998 CST	27	\N
1006	1	f	789			Fri Feb 06 19:47:06 1998 CST	21.9	\N
1007	1	f	659			Fri Feb 06 19:47:49 1998 CST	15.9	\N
1008	1	f	1188			Fri Feb 06 19:54:18 1998 CST	20	\N
1009	1	f	758			Fri Feb 06 20:01:19 1998 CST	12.5	\N
1010	1	f	1189			Fri Feb 06 20:11:36 1998 CST	51	\N
1011	1	f	1190			Fri Feb 06 20:14:59 1998 CST	0	\N
1012	1	f	440			Fri Feb 06 20:23:23 1998 CST	34	\N
1013	1	f	1019			Fri Feb 06 20:40:20 1998 CST	15.75	\N
1014	1	f	423			Fri Feb 06 21:07:28 1998 CST	30.9	\N
1015	1	f	440			Fri Feb 06 21:11:28 1998 CST	20	\N
1016	1	f	606			Fri Feb 06 21:23:16 1998 CST	19.9	\N
1017	1	f	856			Fri Feb 06 21:35:29 1998 CST	19.9	\N
1018	1	f	116			Fri Feb 06 21:37:04 1998 CST	19.9	\N
1019	1	f	1191			Fri Feb 06 21:39:17 1998 CST	33.5	\N
1020	1	f	371			Fri Feb 06 21:55:45 1998 CST	10.5	\N
1021	1	f	107			Fri Feb 06 22:48:25 1998 CST	23	\N
1022	1	t	0		23.35	Fri Feb 06 23:50:50 1998 CST	30	\N
1023	1	f	1192			Fri Feb 06 23:09:13 1998 CST	17.4	\N
1024	1	f	1019			Fri Feb 06 23:10:38 1998 CST	11.6	\N
1025	1	f	1193			Fri Feb 06 23:17:21 1998 CST	13.5	\N
1026	1	f	1019			Fri Feb 06 23:57:35 1998 CST	8.1	\N
1027	1	f	1194			Sat Feb 07 00:06:18 1998 CST	15	\N
1028	1	f	1025			Sat Feb 07 00:25:59 1998 CST	23.700001	\N
1029	1	f	1195			Sat Feb 07 00:29:24 1998 CST	21.5	\N
1030	1	f	1196			Sat Feb 07 00:31:17 1998 CST	18	\N
1031	1	f	254			Sat Feb 07 00:43:28 1998 CST	27	\N
1032	1	f	1114			Sat Feb 07 00:51:45 1998 CST	21.5	\N
1033	1	f	1197			Sat Feb 07 00:56:26 1998 CST	18	\N
1034	1	f	1198			Sat Feb 07 00:59:24 1998 CST	19	\N
1035	1	f	344			Sat Feb 07 01:24:03 1998 CST	15.5	\N
1036	1	f	1079			Sat Feb 07 01:39:34 1998 CST	19.9	\N
1037	1	f	1199			Sat Feb 07 01:31:19 1998 CST	20	\N
1038	1	f	1081			Sat Feb 07 01:41:42 1998 CST	22.700001	\N
1039	1	f	1200			Sat Feb 07 01:43:58 1998 CST	18	\N
1040	1	f	1201			Sat Feb 07 01:49:36 1998 CST	15.9	\N
1041	1	f	1202			Sat Feb 07 01:57:39 1998 CST	19.9	\N
1042	1	f	1203			Sat Feb 07 02:02:26 1998 CST	22.299999	\N
1043	1	f	1204			Sat Feb 07 02:43:03 1998 CST	15.9	\N
1044	1	f	1205			Sat Feb 07 02:55:43 1998 CST	33.299999	\N
1045	1	f	163			Sat Feb 07 02:58:54 1998 CST	20	\N
1046	1	f	716			Sat Feb 07 03:02:50 1998 CST	14.2	\N
1047	1	f	1206			Sat Feb 07 03:15:19 1998 CST	23.9	\N
1048	1	f	1207			Sat Feb 07 03:39:29 1998 CST	19	\N
1049	1	f	65			Sat Feb 07 04:15:36 1998 CST	23.9	\N
1050	1	f	1208			Sat Feb 07 17:08:04 1998 CST	29.9	\N
1051	1	f	949			Sat Feb 07 17:27:59 1998 CST	0	\N
1052	1	f	954			Sun Feb 08 00:06:10 1998 CST	0	\N
1053	1	f	676			Sat Feb 07 18:21:45 1998 CST	41.799999	\N
1054	1	f	373			Sat Feb 07 18:25:24 1998 CST	32	\N
1055	1	f	892			Sat Feb 07 18:28:46 1998 CST	15	\N
1056	1	f	1209			Sat Feb 07 18:32:16 1998 CST	19	\N
1057	1	f	1210			Sat Feb 07 18:47:09 1998 CST	20	\N
1058	1	f	695			Sat Feb 07 18:50:18 1998 CST	19.9	\N
1059	1	f	1185			Sat Feb 07 18:55:55 1998 CST	44	\N
1060	1	f	235			Sat Feb 07 19:10:54 1998 CST	25.5	\N
1061	1	f	1211			Sat Feb 07 19:22:31 1998 CST	15.9	\N
1062	1	f	1212			Sat Feb 07 19:26:41 1998 CST	24	\N
1063	1	f	60			Sat Feb 07 20:31:34 1998 CST	0	\N
1064	1	f	1128			Sat Feb 07 19:46:24 1998 CST	33.200001	\N
1065	1	f	1019			Sat Feb 07 20:05:56 1998 CST	12.6	\N
1066	1	f	1213			Sat Feb 07 20:09:18 1998 CST	19.9	\N
1067	1	f	930			Sat Feb 07 20:37:30 1998 CST	19.9	\N
1068	1	f	1214			Sat Feb 07 20:51:05 1998 CST	54	\N
1069	1	f	1215			Sat Feb 07 20:58:01 1998 CST	19.9	\N
1070	1	f	870			Sat Feb 07 21:03:20 1998 CST	32	\N
1071	1	f	1216			Sat Feb 07 21:12:21 1998 CST	16.299999	\N
1072	1	f	445			Sat Feb 07 21:18:51 1998 CST	19.9	\N
1073	1	f	1217			Sat Feb 07 21:31:56 1998 CST	15.5	\N
1074	1	f	1218			Sat Feb 07 22:12:53 1998 CST	23.5	\N
1075	1	f	1024			Sat Feb 07 22:20:09 1998 CST	12	\N
1076	1	f	1143			Sat Feb 07 22:45:54 1998 CST	25.700001	\N
1077	1	f	6			Sat Feb 07 22:49:56 1998 CST	10.5	\N
1078	1	f	866			Sat Feb 07 23:05:40 1998 CST	28	\N
1079	1	f	1219			Sat Feb 07 23:57:11 1998 CST	15.6	\N
1080	1	f	858			Sun Feb 08 00:21:07 1998 CST	19	\N
1081	1	f	1220			Sun Feb 08 00:24:36 1998 CST	18	\N
1082	1	f	840			Sun Feb 08 00:32:07 1998 CST	21.5	\N
1083	1	f	1114			Sun Feb 08 00:34:57 1998 CST	18	\N
1084	1	f	1221			Sun Feb 08 00:46:32 1998 CST	18	\N
1085	1	f	1185			Sun Feb 08 00:50:06 1998 CST	67	\N
1086	1	f	942			Sun Feb 08 01:33:46 1998 CST	19	\N
1087	1	f	764			Sun Feb 08 01:54:35 1998 CST	19	\N
1088	1	f	1222			Sun Feb 08 02:01:15 1998 CST	31	\N
1089	1	f	782			Sun Feb 08 02:03:11 1998 CST	20.200001	\N
1090	1	f	1223			Sun Feb 08 02:09:07 1998 CST	18	\N
1091	1	f	711			Sun Feb 08 02:20:43 1998 CST	11.5	\N
1092	1	f	1224			Sun Feb 08 02:30:28 1998 CST	19.9	\N
1093	1	f	1225			Sun Feb 08 02:36:20 1998 CST	18	\N
1094	1	f	1226			Sun Feb 08 02:38:33 1998 CST	15.2	\N
1095	1	f	710			Sun Feb 08 02:55:15 1998 CST	28.5	\N
1096	1	f	1227			Sun Feb 08 03:04:35 1998 CST	16	\N
1097	1	f	949			Sun Feb 08 03:19:23 1998 CST	23.9	\N
1098	1	f	1025			Sun Feb 08 03:38:42 1998 CST	16.9	\N
1099	1	f	1228			Sun Feb 08 03:49:34 1998 CST	20.4	\N
1100	1	f	713			Sun Feb 08 04:18:27 1998 CST	20	\N
1101	1	f	1229			Sun Feb 08 15:39:21 1998 CST	51.799999	\N
1102	1	f	1230			Sun Feb 08 16:19:12 1998 CST	61	\N
1103	1	f	784			Sun Feb 08 16:35:50 1998 CST	15.9	\N
1104	1	f	755			Sun Feb 08 16:41:36 1998 CST	16.6	\N
1105	1	f	1067			Sun Feb 08 16:53:04 1998 CST	43.5	\N
1106	1	f	1231			Sun Feb 08 17:20:18 1998 CST	27.9	\N
1107	1	f	1137			Sun Feb 08 17:32:38 1998 CST	13.5	\N
1108	1	f	1072			Sun Feb 08 18:25:27 1998 CST	36.400002	\N
1109	1	f	1036			Sun Feb 08 17:50:13 1998 CST	15.9	\N
1110	1	f	740			Sun Feb 08 18:05:52 1998 CST	20	\N
1111	1	f	440			Sun Feb 08 18:06:42 1998 CST	13.5	\N
1112	1	f	113			Sun Feb 08 18:24:38 1998 CST	21	\N
1113	1	f	1232			Sun Feb 08 18:26:35 1998 CST	13.5	\N
1114	1	f	1233			Sun Feb 08 18:29:55 1998 CST	21.200001	\N
1115	1	f	1072			Sun Feb 08 18:41:44 1998 CST	10.5	\N
1116	1	f	1234			Sun Feb 08 18:46:02 1998 CST	17	\N
1117	1	f	1235			Sun Feb 08 18:53:05 1998 CST	16.5	\N
1118	1	t	0	ANTHONY	19.30	Sun Feb 08 18:59:37 1998 CST	12.9	\N
1119	1	f	1236			Sun Feb 08 19:01:42 1998 CST	25.9	\N
1120	1	f	1072			Sun Feb 08 19:04:42 1998 CST	10	\N
1121	1	f	1237			Sun Feb 08 19:08:30 1998 CST	26	\N
1122	1	t	0		19.45	Sun Feb 08 19:16:30 1998 CST	5	\N
1123	1	f	1108			Sun Feb 08 19:25:47 1998 CST	21	\N
1124	1	f	1067			Sun Feb 08 19:30:45 1998 CST	16.6	\N
1125	1	f	1238			Sun Feb 08 19:32:40 1998 CST	18	\N
1126	1	f	969			Sun Feb 08 19:36:09 1998 CST	14.4	\N
1127	1	t	0	HEWITT	20.10	Sun Feb 08 19:38:59 1998 CST	13.8	\N
1128	1	t	0		20.25	Sun Feb 08 19:52:40 1998 CST	12.9	\N
1129	1	f	1239			Sun Feb 08 20:13:31 1998 CST	34	\N
1130	1	f	1081			Sun Feb 08 20:42:44 1998 CST	18.799999	\N
1131	1	t	0		21.15	Sun Feb 08 20:43:34 1998 CST	25.799999	\N
1132	1	f	945			Sun Feb 08 20:50:08 1998 CST	23.5	\N
1133	1	f	442			Sun Feb 08 21:04:25 1998 CST	13	\N
1134	1	f	1240			Sun Feb 08 21:15:50 1998 CST	19.9	\N
1135	1	f	1241			Sun Feb 08 21:17:30 1998 CST	15.9	\N
1136	1	f	371			Sun Feb 08 21:25:38 1998 CST	10.5	\N
1137	1	f	164			Sun Feb 08 22:09:13 1998 CST	19.9	\N
1138	1	f	488			Sun Feb 08 22:02:23 1998 CST	33	\N
1139	1	f	679			Sun Feb 08 23:08:44 1998 CST	15	\N
1140	1	f	1242			Sun Feb 08 22:47:36 1998 CST	15.5	\N
1141	1	f	908			Sun Feb 08 23:04:44 1998 CST	16.5	\N
1142	1	f	880			Sun Feb 08 23:16:15 1998 CST	15.9	\N
1143	1	f	1243			Sun Feb 08 23:21:44 1998 CST	17	\N
1144	1	f	1244			Sun Feb 08 23:23:46 1998 CST	18	\N
1146	1	t	0	TAXI	0.15	Sun Feb 08 23:44:21 1998 CST	7.4	\N
1147	1	t	0		0.20	Sun Feb 08 23:51:16 1998 CST	15.9	\N
1148	1	f	1245			Sun Feb 08 23:53:17 1998 CST	28.1	\N
1149	1	f	799			Sun Feb 08 23:55:22 1998 CST	19.9	\N
1150	1	f	778			Mon Feb 09 00:06:03 1998 CST	17	\N
1151	1	f	71			Mon Feb 09 00:12:04 1998 CST	20	\N
1152	1	f	1246			Mon Feb 09 00:17:34 1998 CST	16.700001	\N
1153	1	t	0		0.50	Mon Feb 09 00:21:13 1998 CST	6.9	\N
1154	1	f	348			Mon Feb 09 00:22:01 1998 CST	13.5	\N
1155	1	f	1247			Mon Feb 09 00:57:22 1998 CST	18	\N
1156	1	f	1248			Mon Feb 09 00:59:37 1998 CST	13.9	\N
1157	1	f	1249			Mon Feb 09 01:29:30 1998 CST	15.9	\N
1158	1	t	0	MICHAEL	2.45	Mon Feb 09 02:13:19 1998 CST	6.9	\N
1159	1	f	1100			Mon Feb 09 02:16:53 1998 CST	25	\N
1160	1	f	1250			Mon Feb 09 02:41:06 1998 CST	19	\N
1161	1	f	1251			Mon Feb 09 03:32:14 1998 CST	17.5	\N
1162	1	f	626			Mon Feb 09 03:34:19 1998 CST	21	\N
1163	1	f	1252			Mon Feb 09 17:27:51 1998 CST	27.9	\N
1164	1	f	461			Mon Feb 09 17:58:59 1998 CST	22.9	\N
1165	1	f	398			Mon Feb 09 18:17:44 1998 CST	19.9	\N
1166	1	f	338			Mon Feb 09 18:33:27 1998 CST	19.5	\N
1167	1	f	643			Mon Feb 09 18:49:01 1998 CST	18	\N
1168	1	t	0	billy	19.45	Mon Feb 09 19:12:49 1998 CST	12.9	\N
1169	1	f	1254			Mon Feb 09 19:27:26 1998 CST	19.9	\N
1170	1	t	0	TIM	20.30	Mon Feb 09 19:57:36 1998 CST	7.9	\N
1171	1	f	144			Mon Feb 09 20:03:49 1998 CST	15.9	\N
1172	1	f	754			Mon Feb 09 20:14:06 1998 CST	14	\N
1173	1	f	1255			Mon Feb 09 20:21:58 1998 CST	17	\N
1174	1	f	263			Mon Feb 09 20:29:00 1998 CST	26.4	\N
1175	1	f	1180			Mon Feb 09 20:37:49 1998 CST	15.5	\N
1176	1	f	1256			Mon Feb 09 20:49:46 1998 CST	17.6	\N
1177	1	f	642			Mon Feb 09 20:50:21 1998 CST	15.9	\N
1178	1	f	6			Mon Feb 09 21:08:02 1998 CST	10	\N
1179	1	f	995			Mon Feb 09 21:15:08 1998 CST	13.5	\N
1180	1	f	923			Mon Feb 09 21:15:56 1998 CST	20	\N
1181	1	t	0	eliza	22.15	Mon Feb 09 21:45:26 1998 CST	38.700001	\N
1182	1	f	664			Mon Feb 09 21:47:49 1998 CST	20.5	\N
1183	1	f	1257			Mon Feb 09 21:50:00 1998 CST	15	\N
1184	1	f	1258			Mon Feb 09 21:58:31 1998 CST	14.2	\N
1185	1	f	1143			Mon Feb 09 22:44:52 1998 CST	21.299999	\N
1186	1	f	1259			Mon Feb 09 22:46:05 1998 CST	22.5	\N
1187	1	f	670			Mon Feb 09 22:50:56 1998 CST	15	\N
1188	1	t	0	KRISTY	23.50	Mon Feb 09 23:18:26 1998 CST	9.9	\N
1189	1	f	1261			Mon Feb 09 23:34:44 1998 CST	15	\N
1190	1	f	1262			Mon Feb 09 23:40:00 1998 CST	15.5	\N
1191	1	f	14			Mon Feb 09 23:44:18 1998 CST	22	\N
1192	1	f	1263			Mon Feb 09 23:52:09 1998 CST	18	\N
1193	1	f	669			Mon Feb 09 23:53:58 1998 CST	19	\N
1194	1	f	1264			Tue Feb 10 00:11:24 1998 CST	19.9	\N
1195	1	f	1265			Tue Feb 10 00:24:13 1998 CST	22	\N
1196	1	f	95			Tue Feb 10 00:33:53 1998 CST	26	\N
1197	1	f	536			Tue Feb 10 00:42:39 1998 CST	19.9	\N
1198	1	f	1266			Tue Feb 10 00:51:59 1998 CST	20	\N
1199	1	f	1267			Tue Feb 10 00:50:45 1998 CST	52.599998	\N
1200	1	f	1268			Tue Feb 10 01:00:31 1998 CST	25.9	\N
1201	1	f	1052			Tue Feb 10 01:32:41 1998 CST	46.799999	\N
1202	1	f	659			Tue Feb 10 01:59:11 1998 CST	24.299999	\N
1203	1	f	166			Tue Feb 10 02:00:43 1998 CST	15.3	\N
1204	1	f	1269			Tue Feb 10 02:05:24 1998 CST	17.5	\N
1205	1	t	0	LUKE	2.35	Tue Feb 10 02:05:58 1998 CST	8.9	\N
1206	1	t	0	LINDY	3.15	Tue Feb 10 02:45:30 1998 CST	35	\N
1207	1	f	858			Tue Feb 10 02:59:23 1998 CST	19	\N
1208	1	f	1270			Tue Feb 10 03:00:13 1998 CST	9	\N
1209	1	f	65			Tue Feb 10 03:11:53 1998 CST	20.4	\N
1210	1	t	0	83737343 PAUL	3.50	Tue Feb 10 03:20:04 1998 CST	24.700001	\N
1211	1	f	1179			Tue Feb 10 03:52:39 1998 CST	19.9	\N
1212	1	f	154			Tue Feb 10 17:18:45 1998 CST	12.5	\N
1213	1	f	1271			Tue Feb 10 17:47:03 1998 CST	15.5	\N
1214	1	f	1272			Tue Feb 10 18:02:43 1998 CST	18	\N
1215	1	f	995			Tue Feb 10 18:13:54 1998 CST	9.5	\N
1216	1	f	1273			Tue Feb 10 18:18:17 1998 CST	10.5	\N
1217	1	f	1275			Tue Feb 10 19:00:58 1998 CST	19	\N
1218	1	f	1276			Tue Feb 10 18:58:24 1998 CST	19.9	\N
1219	1	f	1114			Tue Feb 10 19:04:00 1998 CST	21.5	\N
1220	1	f	26			Tue Feb 10 19:05:18 1998 CST	20	\N
1221	1	f	1277			Tue Feb 10 19:42:28 1998 CST	25.9	\N
1222	1	f	797			Tue Feb 10 19:44:17 1998 CST	15.9	\N
1223	1	f	917			Tue Feb 10 20:12:15 1998 CST	19.9	\N
1224	1	f	29			Tue Feb 10 20:26:30 1998 CST	15.5	\N
1225	1	f	1019			Tue Feb 10 21:08:19 1998 CST	12.8	\N
1226	1	f	638			Tue Feb 10 21:14:42 1998 CST	18.5	\N
1227	1	f	124			Tue Feb 10 21:32:40 1998 CST	15.9	\N
1228	1	f	666			Tue Feb 10 22:12:30 1998 CST	12.5	\N
1229	1	f	1278			Tue Feb 10 22:18:26 1998 CST	19	\N
1230	1	f	1019			Tue Feb 10 23:48:48 1998 CST	15	\N
1231	1	f	42			Wed Feb 11 00:12:57 1998 CST	16.6	\N
1232	1	f	1279			Wed Feb 11 01:02:58 1998 CST	26.700001	\N
1233	1	f	1280			Wed Feb 11 01:05:11 1998 CST	18.200001	\N
1234	1	t	0	POLICE	2.05	Wed Feb 11 01:33:34 1998 CST	15	\N
1235	1	t	0		2.05	Wed Feb 11 01:34:36 1998 CST	14.9	\N
1236	1	t	0	POLIC E	2.10	Wed Feb 11 01:40:55 1998 CST	7	\N
1237	1	f	715			Wed Feb 11 01:43:34 1998 CST	16.6	\N
1238	1	f	132			Wed Feb 11 01:49:35 1998 CST	20	\N
1239	1	f	1281			Wed Feb 11 01:54:15 1998 CST	18	\N
1240	1	t	0	** Cancelled ** 	2.30	Wed Feb 11 01:59:24 1998 CST	0	\N
1241	1	t	0		2.30	Wed Feb 11 02:00:06 1998 CST	11.9	\N
1242	1	t	0		2.50	Wed Feb 11 02:19:40 1998 CST	22.799999	\N
1243	1	f	1282			Wed Feb 11 02:21:32 1998 CST	35	\N
1244	1	f	668			Wed Feb 11 02:29:46 1998 CST	19.9	\N
1245	1	f	711			Wed Feb 11 02:31:13 1998 CST	21	\N
1246	1	f	1099			Wed Feb 11 02:48:39 1998 CST	43.950001	\N
1247	1	f	285			Wed Feb 11 02:52:57 1998 CST	15	\N
1248	1	t	0		3.55	Wed Feb 11 03:23:50 1998 CST	12	\N
1249	1	f	447			Wed Feb 11 03:41:40 1998 CST	25.1	\N
1250	1	f	711			Wed Feb 11 03:26:40 1998 CST	20	\N
1251	1	f	1099			Wed Feb 11 03:47:40 1998 CST	10.8	\N
1252	1	f	1137			Wed Feb 11 17:24:13 1998 CST	19.799999	\N
1253	1	t	0	** Cancelled ** 	17.55	Wed Feb 11 17:26:35 1998 CST	0	\N
1254	1	f	1283			Wed Feb 11 18:47:02 1998 CST	15.5	\N
1255	1	f	1104			Wed Feb 11 18:20:10 1998 CST	25	\N
1256	1	f	492			Wed Feb 11 18:26:21 1998 CST	30.9	\N
1257	1	f	92			Wed Feb 11 18:36:35 1998 CST	13.5	\N
1258	1	f	1042			Wed Feb 11 19:11:17 1998 CST	19	\N
1259	1	f	161			Wed Feb 11 19:05:36 1998 CST	20	\N
1260	1	f	1257			Wed Feb 11 19:07:36 1998 CST	14	\N
1261	1	f	1020			Wed Feb 11 19:13:37 1998 CST	12	\N
1262	1	f	645			Wed Feb 11 19:14:16 1998 CST	17	\N
1263	1	f	6			Wed Feb 11 19:22:40 1998 CST	22.799999	\N
1264	1	f	858			Wed Feb 11 19:36:21 1998 CST	15	\N
1265	1	f	430			Wed Feb 11 19:58:31 1998 CST	16.5	\N
1266	1	f	660			Wed Feb 11 20:07:02 1998 CST	15.9	\N
1267	1	f	1284			Wed Feb 11 20:12:37 1998 CST	17.299999	\N
1268	1	f	1000			Wed Feb 11 20:13:42 1998 CST	20	\N
1269	1	f	903			Wed Feb 11 20:14:54 1998 CST	19.9	\N
1270	1	f	277			Wed Feb 11 20:39:51 1998 CST	15.9	\N
1271	1	f	173			Wed Feb 11 20:57:00 1998 CST	28.9	\N
1272	1	f	1285			Wed Feb 11 21:02:07 1998 CST	0	\N
1273	1	f	440			Wed Feb 11 21:03:56 1998 CST	13.5	\N
1274	1	f	727			Wed Feb 11 21:57:03 1998 CST	28	\N
1275	1	f	812			Wed Feb 11 22:28:10 1998 CST	15.2	\N
1276	1	f	1286			Wed Feb 11 23:40:34 1998 CST	18	\N
1277	1	f	1287			Thu Feb 12 00:02:25 1998 CST	23	\N
1278	1	f	1216			Thu Feb 12 00:05:24 1998 CST	21.299999	\N
1279	1	f	1288			Thu Feb 12 00:19:04 1998 CST	15.9	\N
1280	1	f	1192			Thu Feb 12 00:23:42 1998 CST	15.9	\N
1281	1	f	1006			Thu Feb 12 00:26:02 1998 CST	21.4	\N
1282	1	f	1181			Thu Feb 12 00:28:08 1998 CST	22	\N
1283	1	f	29			Thu Feb 12 00:34:22 1998 CST	15.9	\N
1284	1	f	212			Thu Feb 12 01:10:48 1998 CST	20.5	\N
1285	1	f	515			Thu Feb 12 01:36:16 1998 CST	28.4	\N
1286	1	f	449			Thu Feb 12 01:17:01 1998 CST	27.6	\N
1287	1	f	987			Thu Feb 12 01:19:00 1998 CST	16.6	\N
1288	1	f	1289			Thu Feb 12 01:22:45 1998 CST	20	\N
1289	1	f	1117			Thu Feb 12 01:52:31 1998 CST	18.5	\N
1290	1	f	6			Thu Feb 12 01:57:38 1998 CST	10.5	\N
1291	1	f	1099			Thu Feb 12 02:00:18 1998 CST	14.85	\N
1292	1	f	1290			Thu Feb 12 02:10:14 1998 CST	22.5	\N
1293	1	f	1263			Thu Feb 12 02:21:14 1998 CST	13.5	\N
1294	1	f	599			Thu Feb 12 02:35:45 1998 CST	16.5	\N
1295	1	f	1153			Thu Feb 12 02:37:13 1998 CST	39.799999	\N
1296	1	f	306			Thu Feb 12 02:39:40 1998 CST	19	\N
1297	1	f	711			Thu Feb 12 03:34:33 1998 CST	9.5	\N
1298	1	f	447			Thu Feb 12 03:46:03 1998 CST	14.7	\N
1299	1	t	0		4.20	Thu Feb 12 03:50:29 1998 CST	9.9	\N
1300	1	f	1291			Thu Feb 12 04:05:18 1998 CST	15	\N
1301	1	f	1292			Thu Feb 12 16:07:02 1998 CST	129.5	\N
1302	1	f	707			Thu Feb 12 17:44:36 1998 CST	38.400002	\N
1303	1	t	0	MICK	18.15	Thu Feb 12 17:48:43 1998 CST	12	\N
1304	1	t	0		18.35	Thu Feb 12 18:05:41 1998 CST	18.9	\N
1305	1	f	1294			Thu Feb 12 18:14:27 1998 CST	27.5	\N
1306	1	f	1295			Thu Feb 12 18:42:12 1998 CST	33.5	\N
1307	1	f	43			Thu Feb 12 18:48:03 1998 CST	19.9	\N
1308	1	f	1296			Thu Feb 12 19:01:22 1998 CST	19	\N
1309	1	f	1297			Thu Feb 12 19:15:56 1998 CST	28	\N
1310	1	f	1018			Thu Feb 12 19:31:38 1998 CST	18	\N
1311	1	f	6			Thu Feb 12 19:34:51 1998 CST	10.5	\N
1312	1	t	0		20.45	Thu Feb 12 20:13:30 1998 CST	9.9	\N
1313	1	f	1298			Thu Feb 12 20:26:19 1998 CST	18	\N
1314	1	f	1299			Thu Feb 12 20:36:19 1998 CST	15	\N
1315	1	f	641			Thu Feb 12 20:41:20 1998 CST	25.9	\N
1316	1	f	815			Thu Feb 12 21:14:17 1998 CST	120	\N
1317	1	f	242			Thu Feb 12 21:16:34 1998 CST	15.9	\N
1318	1	f	1300			Thu Feb 12 21:47:46 1998 CST	23.5	\N
1319	1	f	424			Thu Feb 12 21:50:13 1998 CST	23	\N
1320	1	f	825			Thu Feb 12 21:50:55 1998 CST	10	\N
1321	1	f	310			Thu Feb 12 21:52:04 1998 CST	16.6	\N
1322	1	f	161			Thu Feb 12 22:06:04 1998 CST	29.5	\N
1323	1	f	1301			Thu Feb 12 22:17:33 1998 CST	18.6	\N
1324	1	f	1302			Thu Feb 12 22:25:18 1998 CST	15.9	\N
1325	1	f	296			Thu Feb 12 22:26:46 1998 CST	19	\N
1326	1	f	447			Thu Feb 12 22:46:11 1998 CST	17	\N
1327	1	f	298			Thu Feb 12 22:55:45 1998 CST	19.9	\N
1328	1	f	1129			Thu Feb 12 23:02:10 1998 CST	23	\N
1329	1	f	1303			Thu Feb 12 23:16:58 1998 CST	15.3	\N
1330	1	f	839			Thu Feb 12 23:40:42 1998 CST	18	\N
1331	1	f	1304			Thu Feb 12 23:48:43 1998 CST	29.299999	\N
1332	1	f	599			Fri Feb 13 00:08:11 1998 CST	16	\N
1333	1	f	630			Fri Feb 13 02:19:12 1998 CST	21	\N
1334	1	f	1176			Fri Feb 13 00:23:02 1998 CST	13.5	\N
1335	1	t	0		1.05	Fri Feb 13 00:35:46 1998 CST	12.9	\N
1336	1	f	355			Fri Feb 13 00:54:16 1998 CST	19.9	\N
1337	1	f	1019			Fri Feb 13 01:37:50 1998 CST	11.7	\N
1338	1	f	1305			Fri Feb 13 01:58:16 1998 CST	25.9	\N
1339	1	f	1183			Fri Feb 13 02:00:08 1998 CST	20	\N
1340	1	f	1306			Fri Feb 13 02:04:59 1998 CST	21	\N
1341	1	f	657			Fri Feb 13 02:21:56 1998 CST	28	\N
1342	1	t	0		3.40	Fri Feb 13 03:11:57 1998 CST	12.9	\N
1343	1	f	1307			Fri Feb 13 18:30:49 1998 CST	15.5	\N
1344	1	f	1308			Fri Feb 13 18:32:56 1998 CST	22.700001	\N
1345	1	t	0		19.10	Fri Feb 13 18:36:32 1998 CST	19.9	\N
1346	1	f	397			Fri Feb 13 18:53:39 1998 CST	31	\N
1347	1	f	1309			Fri Feb 13 19:01:23 1998 CST	55.400002	\N
1348	1	f	1310			Fri Feb 13 19:04:27 1998 CST	17	\N
1349	1	f	1311			Fri Feb 13 19:10:51 1998 CST	21	\N
1350	1	f	1312			Fri Feb 13 19:13:19 1998 CST	23	\N
1351	1	f	1209			Fri Feb 13 19:16:00 1998 CST	14	\N
1352	1	f	6			Fri Feb 13 19:46:45 1998 CST	12.5	\N
1353	1	f	1313			Fri Feb 13 19:29:36 1998 CST	20.6	\N
1354	1	f	148			Fri Feb 13 19:32:31 1998 CST	29	\N
1355	1	f	1180			Fri Feb 13 19:47:21 1998 CST	15	\N
1356	1	f	1314			Fri Feb 13 19:57:26 1998 CST	18	\N
1357	1	f	1315			Fri Feb 13 20:05:25 1998 CST	15	\N
1358	1	f	735			Fri Feb 13 20:14:04 1998 CST	12.6	\N
1359	1	t	0		20.45	Fri Feb 13 20:16:05 1998 CST	13.5	\N
1360	1	f	1317			Fri Feb 13 20:39:42 1998 CST	14.5	\N
1361	1	f	327			Fri Feb 13 20:44:11 1998 CST	18	\N
1362	1	f	198			Fri Feb 13 20:58:38 1998 CST	19	\N
1363	1	f	707			Fri Feb 13 21:03:46 1998 CST	30.6	\N
1364	1	f	549			Fri Feb 13 21:05:14 1998 CST	17	\N
1365	1	f	132			Fri Feb 13 21:06:59 1998 CST	21	\N
1366	1	f	1318			Fri Feb 13 21:16:02 1998 CST	25.9	\N
1367	1	f	440			Fri Feb 13 21:19:02 1998 CST	12	\N
1368	1	f	1319			Fri Feb 13 21:20:47 1998 CST	17.200001	\N
1369	1	f	1321			Fri Feb 13 21:27:29 1998 CST	19	\N
1370	1	f	1322			Fri Feb 13 21:38:43 1998 CST	25.9	\N
1371	1	f	660			Fri Feb 13 21:58:23 1998 CST	15.9	\N
1372	1	f	255			Fri Feb 13 22:06:38 1998 CST	19.9	\N
1373	1	f	21			Fri Feb 13 22:17:09 1998 CST	18	\N
1374	1	f	1019			Fri Feb 13 22:42:25 1998 CST	11.6	\N
1375	1	f	1232			Fri Feb 13 22:54:19 1998 CST	13.5	\N
1376	1	t	0		23.30	Fri Feb 13 22:59:42 1998 CST	9.9	\N
1377	1	f	1323			Fri Feb 13 23:04:11 1998 CST	17.5	\N
1378	1	f	705			Fri Feb 13 23:29:56 1998 CST	25.4	\N
1379	1	f	1324			Sat Feb 14 00:15:39 1998 CST	37	\N
1380	1	t	0		0.30	Sat Feb 14 00:00:57 1998 CST	12.9	\N
1381	1	f	1148			Sat Feb 14 00:26:04 1998 CST	21	\N
1382	1	f	1325			Sat Feb 14 00:32:05 1998 CST	20.5	\N
1383	1	f	1326			Sat Feb 14 00:35:49 1998 CST	21	\N
1384	1	t	0		1.20	Sat Feb 14 00:49:30 1998 CST	9.9	\N
1385	1	f	1327			Sat Feb 14 00:55:02 1998 CST	0	\N
1386	1	f	954			Sat Feb 14 00:57:16 1998 CST	0	\N
1387	1	t	0		1.35	Sat Feb 14 01:05:50 1998 CST	9.9	\N
1388	1	f	411			Sat Feb 14 01:07:20 1998 CST	18	\N
1389	1	f	1328			Sat Feb 14 01:16:18 1998 CST	18	\N
1390	1	f	1329			Sat Feb 14 01:26:21 1998 CST	28	\N
1391	1	f	1330			Sat Feb 14 01:28:12 1998 CST	19.9	\N
1392	1	f	881			Sat Feb 14 01:38:57 1998 CST	16.200001	\N
1393	1	f	1331			Sat Feb 14 01:43:47 1998 CST	20	\N
1394	1	f	1332			Sat Feb 14 01:46:53 1998 CST	17.5	\N
1395	1	f	1082			Sat Feb 14 02:19:43 1998 CST	20	\N
1396	1	f	1333			Sat Feb 14 02:03:40 1998 CST	15.9	\N
1397	1	f	1203			Sat Feb 14 02:04:48 1998 CST	19.9	\N
1398	1	f	508			Sat Feb 14 02:22:59 1998 CST	15	\N
1399	1	f	1067			Sat Feb 14 02:26:47 1998 CST	19.9	\N
1400	1	f	1019			Sat Feb 14 02:28:17 1998 CST	16.700001	\N
1401	1	f	1334			Sat Feb 14 02:34:27 1998 CST	29	\N
1402	1	f	1335			Sat Feb 14 02:36:24 1998 CST	18	\N
1403	1	f	1006			Sat Feb 14 02:42:23 1998 CST	15.9	\N
1404	1	f	285			Sat Feb 14 02:49:38 1998 CST	28.9	\N
1405	1	f	1336			Sat Feb 14 02:53:19 1998 CST	21	\N
1406	1	f	687			Sat Feb 14 03:02:10 1998 CST	18	\N
1407	1	f	1337			Sat Feb 14 03:06:19 1998 CST	16.6	\N
1408	1	f	1034			Sat Feb 14 03:08:04 1998 CST	23.4	\N
1409	1	f	163			Sat Feb 14 03:15:26 1998 CST	20	\N
1410	1	f	1338			Sat Feb 14 03:30:41 1998 CST	20	\N
1411	1	f	1339			Sat Feb 14 03:40:06 1998 CST	13	\N
1412	1	f	1340			Sat Feb 14 03:44:25 1998 CST	19.9	\N
1413	1	f	1341			Sat Feb 14 03:59:15 1998 CST	18.5	\N
1414	1	t	0	JACKIE	12.15	Sat Feb 14 16:18:57 1998 CST	0	\N
1415	1	t	0		16.40	Sat Feb 14 16:19:17 1998 CST	0	\N
1416	1	f	1342			Sat Feb 14 16:18:13 1998 CST	18.5	\N
1417	1	f	1343			Sat Feb 14 17:26:50 1998 CST	18	\N
1418	1	f	1344			Sat Feb 14 17:56:17 1998 CST	15.9	\N
1419	1	f	784			Sat Feb 14 18:15:00 1998 CST	20	\N
1420	1	f	985			Sat Feb 14 18:16:51 1998 CST	21.9	\N
1421	1	f	635			Sat Feb 14 18:30:22 1998 CST	15.9	\N
1422	1	t	0	B AND DEB	19.05	Sat Feb 14 18:35:08 1998 CST	15.5	\N
1423	1	t	0		19.10	Sat Feb 14 18:42:14 1998 CST	12	\N
1424	1	t	0		19.20	Sat Feb 14 18:52:45 1998 CST	7.4	\N
1425	1	t	0		19.25	Sat Feb 14 18:56:15 1998 CST	9.9	\N
1426	1	f	840			Sat Feb 14 19:08:15 1998 CST	47.5	\N
1427	1	f	1345			Sat Feb 14 19:17:39 1998 CST	15.9	\N
1428	1	f	1346			Sat Feb 14 19:19:27 1998 CST	18	\N
1429	1	f	674			Sat Feb 14 19:37:34 1998 CST	15	\N
1430	1	f	1347			Sat Feb 14 19:39:42 1998 CST	16.200001	\N
1431	1	f	698			Sat Feb 14 19:43:56 1998 CST	23	\N
1432	1	f	1348			Sat Feb 14 19:51:55 1998 CST	35.5	\N
1433	1	f	1349			Sat Feb 14 19:57:23 1998 CST	18	\N
1434	1	f	892			Sat Feb 14 20:26:43 1998 CST	26.9	\N
1435	1	f	1350			Sat Feb 14 20:29:16 1998 CST	24.5	\N
1436	1	f	930			Sat Feb 14 20:31:13 1998 CST	25.9	\N
1437	1	t	0	DARREN THOMSON	21.30	Sat Feb 14 21:01:14 1998 CST	52.5	\N
1438	1	f	660			Sat Feb 14 21:09:35 1998 CST	15.9	\N
1439	1	f	1351			Sat Feb 14 22:30:26 1998 CST	14	\N
1440	1	f	870			Sat Feb 14 22:37:27 1998 CST	21	\N
1441	1	f	133			Sat Feb 14 23:15:50 1998 CST	20	\N
1442	1	f	54			Sat Feb 14 23:47:00 1998 CST	16.5	\N
1443	1	f	1352			Sun Feb 15 00:00:42 1998 CST	30	\N
1444	1	f	1353			Sun Feb 15 00:12:14 1998 CST	17.1	\N
1445	1	f	190			Sun Feb 15 01:10:51 1998 CST	9.7	\N
1446	1	f	445			Sun Feb 15 00:49:25 1998 CST	17.299999	\N
1447	1	f	30			Sun Feb 15 01:00:23 1998 CST	16.6	\N
1448	1	f	1354			Sun Feb 15 01:13:37 1998 CST	15	\N
1449	1	f	1355			Sun Feb 15 01:16:32 1998 CST	21	\N
1450	1	f	66			Sun Feb 15 01:24:45 1998 CST	21	\N
1451	1	f	1356			Sun Feb 15 01:44:39 1998 CST	15.5	\N
1452	1	f	1357			Sun Feb 15 01:47:50 1998 CST	36	\N
1453	1	f	173			Sun Feb 15 01:55:26 1998 CST	28.9	\N
1454	1	f	1358			Sun Feb 15 02:06:55 1998 CST	18	\N
1455	1	f	1093			Sun Feb 15 02:14:36 1998 CST	14.2	\N
1456	1	f	1359			Sun Feb 15 02:32:06 1998 CST	19.9	\N
1457	1	f	1093			Sun Feb 15 02:40:09 1998 CST	13.5	\N
1458	1	f	1360			Sun Feb 15 02:47:10 1998 CST	17.5	\N
1459	1	f	1361			Sun Feb 15 02:51:26 1998 CST	21.5	\N
1460	1	f	1350			Sun Feb 15 03:07:03 1998 CST	28.9	\N
1461	1	f	1362			Sun Feb 15 03:12:19 1998 CST	19	\N
1462	1	f	1363			Sun Feb 15 03:16:28 1998 CST	18	\N
1463	1	f	163			Sun Feb 15 03:19:32 1998 CST	20	\N
1464	1	f	1364			Sun Feb 15 03:49:46 1998 CST	19.9	\N
1465	1	f	1365			Sun Feb 15 03:59:55 1998 CST	20	\N
1466	1	f	879			Sun Feb 15 04:13:48 1998 CST	11.5	\N
1467	1	f	283			Sun Feb 15 04:17:05 1998 CST	22	\N
1468	1	f	1366			Sun Feb 15 04:21:18 1998 CST	13.9	\N
1469	1	f	1367			Sun Feb 15 15:20:49 1998 CST	19.9	\N
1470	1	f	1072			Sun Feb 15 16:35:57 1998 CST	19	\N
1471	1	f	434			Sun Feb 15 17:05:38 1998 CST	30.5	\N
1472	1	f	1368			Sun Feb 15 18:09:25 1998 CST	24.9	\N
1473	1	f	1072			Sun Feb 15 17:28:11 1998 CST	29	\N
1474	1	f	1252			Sun Feb 15 17:33:23 1998 CST	18	\N
1475	1	f	1369			Sun Feb 15 17:36:32 1998 CST	57.5	\N
1476	1	f	1257			Sun Feb 15 17:51:19 1998 CST	28	\N
1477	1	f	759			Sun Feb 15 17:59:26 1998 CST	24.5	\N
1478	1	f	761			Sun Feb 15 18:58:45 1998 CST	27.299999	\N
1479	1	f	1370			Sun Feb 15 18:21:10 1998 CST	27.9	\N
1480	1	f	234			Sun Feb 15 19:21:07 1998 CST	15.9	\N
1481	1	f	1072			Sun Feb 15 18:31:12 1998 CST	10.5	\N
1482	1	f	432			Sun Feb 15 18:35:55 1998 CST	15.9	\N
1483	1	f	759			Sun Feb 15 18:47:54 1998 CST	21.1	\N
1484	1	f	1255			Sun Feb 15 18:51:12 1998 CST	22	\N
1485	1	f	1052			Sun Feb 15 19:20:25 1998 CST	19.799999	\N
1486	1	f	896			Sun Feb 15 19:30:14 1998 CST	21	\N
1487	1	f	453			Sun Feb 15 19:32:33 1998 CST	21.299999	\N
1488	1	f	645			Sun Feb 15 19:44:50 1998 CST	26.299999	\N
1489	1	f	1371			Sun Feb 15 19:44:09 1998 CST	22	\N
1490	1	f	1372			Sun Feb 15 19:54:04 1998 CST	36	\N
1490	1	f	1372			Sun Feb 15 19:54:04 1998 CST	36	\N
1492	1	f	1373			Sun Feb 15 20:01:44 1998 CST	20	\N
1493	1	f	68			Sun Feb 15 20:04:34 1998 CST	15.9	\N
1494	1	f	255			Sun Feb 15 20:07:38 1998 CST	19.9	\N
1495	1	f	440			Sun Feb 15 20:22:11 1998 CST	17.5	\N
1496	1	f	488			Sun Feb 15 20:41:03 1998 CST	17	\N
1497	1	f	989			Sun Feb 15 20:43:18 1998 CST	15.9	\N
1498	1	f	1374			Sun Feb 15 20:51:31 1998 CST	21.9	\N
1499	1	f	591			Sun Feb 15 21:44:58 1998 CST	17	\N
1500	1	f	1376			Sun Feb 15 21:51:03 1998 CST	13.5	\N
1501	1	f	830			Sun Feb 15 21:58:28 1998 CST	13.2	\N
1502	1	f	243			Sun Feb 15 22:06:23 1998 CST	16	\N
1503	1	f	533			Sun Feb 15 22:36:37 1998 CST	21	\N
1504	1	f	526			Sun Feb 15 22:54:26 1998 CST	29	\N
1505	1	f	1377			Sun Feb 15 23:03:10 1998 CST	20.6	\N
1506	1	f	1378			Sun Feb 15 23:07:50 1998 CST	21.299999	\N
1507	1	f	1379			Sun Feb 15 23:15:01 1998 CST	35.5	\N
1508	1	t	0	PHILL 82216551	0.10	Sun Feb 15 23:37:29 1998 CST	19	\N
1509	1	f	1380			Mon Feb 16 00:05:31 1998 CST	30.5	\N
1510	1	f	861			Mon Feb 16 00:08:56 1998 CST	20	\N
1511	1	t	0		1.10	Mon Feb 16 00:39:11 1998 CST	10	\N
1512	1	f	1381			Mon Feb 16 00:55:51 1998 CST	20.200001	\N
1513	1	f	1382			Mon Feb 16 00:57:32 1998 CST	15.9	\N
1514	1	f	886			Mon Feb 16 01:04:10 1998 CST	19	\N
1515	1	t	0		1.45	Mon Feb 16 01:15:23 1998 CST	9.9	\N
1516	1	t	0		2.25	Mon Feb 16 01:54:43 1998 CST	13.9	\N
1517	1	f	416			Mon Feb 16 02:20:51 1998 CST	23.5	\N
1518	1	f	1383			Mon Feb 16 02:36:17 1998 CST	33.700001	\N
1519	1	t	0	PFM	3.20	Mon Feb 16 02:47:16 1998 CST	12.9	\N
1520	1	f	65			Mon Feb 16 03:17:00 1998 CST	15.7	\N
1521	1	f	1384			Mon Feb 16 04:07:17 1998 CST	20	\N
1522	1	f	633			Mon Feb 16 17:07:35 1998 CST	14.4	\N
1523	1	f	1146			Mon Feb 16 17:33:07 1998 CST	21.9	\N
1524	1	t	0		19.05	Mon Feb 16 20:09:20 1998 CST	14.9	\N
1525	1	f	1376			Mon Feb 16 18:41:09 1998 CST	18	\N
1526	1	f	1370			Mon Feb 16 18:46:22 1998 CST	25.9	\N
1527	1	f	1385			Mon Feb 16 19:08:27 1998 CST	12	\N
1528	1	f	1277			Mon Feb 16 19:12:14 1998 CST	16.6	\N
1529	1	t	0	GEORGE	20.00	Mon Feb 16 19:27:19 1998 CST	10	\N
1530	1	f	348			Mon Feb 16 19:29:06 1998 CST	15.9	\N
1531	1	f	56			Mon Feb 16 19:32:50 1998 CST	37.099998	\N
1532	1	f	1386			Mon Feb 16 19:33:52 1998 CST	20.5	\N
1533	1	f	237			Mon Feb 16 19:45:39 1998 CST	21	\N
1534	1	f	1387			Mon Feb 16 20:22:07 1998 CST	19	\N
1535	1	f	1388			Mon Feb 16 20:26:03 1998 CST	20.5	\N
1536	1	f	754			Mon Feb 16 20:52:55 1998 CST	10.5	\N
1537	1	f	1390			Mon Feb 16 21:06:35 1998 CST	24	\N
1538	1	t	0		21.40	Mon Feb 16 21:11:25 1998 CST	14.9	\N
1539	1	f	22			Mon Feb 16 21:14:12 1998 CST	16	\N
1540	1	f	1391			Mon Feb 16 21:20:53 1998 CST	18	\N
1541	1	f	440			Mon Feb 16 21:22:13 1998 CST	16.9	\N
1542	1	f	304			Mon Feb 16 21:37:50 1998 CST	20.9	\N
1543	1	f	14			Mon Feb 16 21:43:22 1998 CST	29	\N
1544	1	f	1392			Mon Feb 16 22:06:35 1998 CST	17.200001	\N
1545	1	f	1257			Mon Feb 16 22:10:17 1998 CST	13.7	\N
1546	1	f	161			Mon Feb 16 22:14:35 1998 CST	16.799999	\N
1547	1	f	1329			Mon Feb 16 22:19:08 1998 CST	16.5	\N
1548	1	t	0		22.50	Mon Feb 16 22:20:05 1998 CST	7.4	\N
1549	1	f	1143			Mon Feb 16 22:30:43 1998 CST	21.299999	\N
1550	1	f	1393			Mon Feb 16 22:31:50 1998 CST	14.9	\N
1551	1	f	6			Mon Feb 16 22:34:26 1998 CST	10	\N
1552	1	t	0		23.10	Mon Feb 16 22:38:00 1998 CST	16.5	\N
1553	1	f	277			Mon Feb 16 22:54:50 1998 CST	15.9	\N
1554	1	f	1394			Mon Feb 16 22:59:28 1998 CST	24	\N
1555	1	f	1395			Mon Feb 16 23:01:39 1998 CST	22.9	\N
1556	1	f	19			Mon Feb 16 23:11:24 1998 CST	29.5	\N
1557	1	f	37			Mon Feb 16 23:16:33 1998 CST	15.9	\N
1558	1	f	1279			Mon Feb 16 23:25:15 1998 CST	22	\N
1559	1	f	1396			Mon Feb 16 23:26:25 1998 CST	11.5	\N
1560	1	f	1397			Mon Feb 16 23:42:24 1998 CST	18	\N
1561	1	f	400			Mon Feb 16 23:52:33 1998 CST	17.299999	\N
1562	1	f	254			Mon Feb 16 23:55:24 1998 CST	26	\N
1563	1	t	0		0.35	Tue Feb 17 00:05:48 1998 CST	15.9	\N
1565	1	t	0		0.50	Tue Feb 17 00:21:00 1998 CST	20	\N
1566	1	f	1398			Tue Feb 17 00:24:51 1998 CST	19	\N
1567	1	t	0		1.00	Tue Feb 17 00:28:10 1998 CST	9.9	\N
1568	1	f	95			Tue Feb 17 00:32:59 1998 CST	27.5	\N
1569	1	f	1399			Tue Feb 17 00:35:28 1998 CST	22.9	\N
1570	1	f	253			Tue Feb 17 00:38:26 1998 CST	33.900002	\N
1571	1	f	164			Tue Feb 17 00:45:10 1998 CST	19.9	\N
1572	1	t	0		1.25	Tue Feb 17 00:55:22 1998 CST	20	\N
1573	1	f	793			Tue Feb 17 00:56:08 1998 CST	13.5	\N
1574	1	t	0		1.40	Tue Feb 17 01:07:36 1998 CST	13.9	\N
1575	1	f	711			Tue Feb 17 01:43:30 1998 CST	44	\N
1576	1	f	1400			Tue Feb 17 02:02:52 1998 CST	21.700001	\N
1577	1	f	1401			Tue Feb 17 02:25:24 1998 CST	23.4	\N
1578	1	f	1402			Tue Feb 17 02:39:11 1998 CST	18	\N
1579	1	f	1403			Tue Feb 17 03:12:41 1998 CST	21.6	\N
1580	1	f	707			Tue Feb 17 04:43:49 1998 CST	16.6	\N
1581	1	f	65			Tue Feb 17 03:32:08 1998 CST	17.700001	\N
1582	1	f	1007			Tue Feb 17 03:38:02 1998 CST	21	\N
1583	1	f	1156			Tue Feb 17 16:40:04 1998 CST	43.900002	\N
1584	1	f	1404			Tue Feb 17 17:25:47 1998 CST	19.5	\N
1585	1	t	0		18.55	Tue Feb 17 18:24:48 1998 CST	9.9	\N
1586	1	f	1405			Tue Feb 17 18:31:43 1998 CST	20	\N
1587	1	f	1406			Tue Feb 17 18:51:55 1998 CST	15	\N
1588	1	f	1021			Tue Feb 17 19:00:24 1998 CST	18	\N
1589	1	f	896			Tue Feb 17 19:06:41 1998 CST	13.5	\N
1590	1	f	1407			Tue Feb 17 19:32:55 1998 CST	16.5	\N
1591	1	f	1020			Tue Feb 17 19:51:59 1998 CST	15.9	\N
1592	1	f	659			Tue Feb 17 19:54:56 1998 CST	23.9	\N
1593	1	f	60			Tue Feb 17 20:05:36 1998 CST	33.900002	\N
1594	1	f	1408			Tue Feb 17 20:08:38 1998 CST	17	\N
1595	1	f	1232			Tue Feb 17 20:12:58 1998 CST	12.5	\N
1596	1	f	1409			Tue Feb 17 20:26:51 1998 CST	15.9	\N
1597	1	f	514			Tue Feb 17 20:38:14 1998 CST	40.5	\N
1598	1	f	440			Tue Feb 17 21:07:56 1998 CST	23.9	\N
1599	1	f	955			Tue Feb 17 21:08:33 1998 CST	16.5	\N
1600	1	f	591			Tue Feb 17 21:25:39 1998 CST	53	\N
1601	1	f	16			Tue Feb 17 22:27:52 1998 CST	27.5	\N
1602	1	f	274			Tue Feb 17 22:46:46 1998 CST	19.9	\N
1603	1	t	0	GB	23.35	Tue Feb 17 23:05:36 1998 CST	19	\N
1604	1	t	0		23.40	Tue Feb 17 23:07:10 1998 CST	3.5	\N
1605	1	t	0		23.45	Tue Feb 17 23:11:35 1998 CST	6.9	\N
1606	1	f	848			Tue Feb 17 23:39:06 1998 CST	16	\N
1607	1	f	410			Tue Feb 17 23:42:40 1998 CST	15	\N
1608	1	f	1054			Tue Feb 17 23:47:41 1998 CST	15.5	\N
1609	1	f	1410			Wed Feb 18 00:00:00 1998 CST	15.5	\N
1610	1	f	1411			Wed Feb 18 00:11:55 1998 CST	21	\N
1611	1	f	977			Wed Feb 18 00:13:32 1998 CST	19.9	\N
1612	1	f	1412			Wed Feb 18 00:21:11 1998 CST	21	\N
1613	1	t	0		1.10	Wed Feb 18 00:37:50 1998 CST	16.9	\N
1614	1	f	296			Wed Feb 18 00:50:08 1998 CST	16.5	\N
1615	1	f	1006			Wed Feb 18 00:51:25 1998 CST	15.9	\N
1616	1	f	1128			Wed Feb 18 00:58:33 1998 CST	24.9	\N
1617	1	t	0		1.35	Wed Feb 18 01:06:25 1998 CST	13.9	\N
1618	1	f	1413			Wed Feb 18 02:17:36 1998 CST	10.5	\N
1619	1	t	0		1.45	Wed Feb 18 01:13:42 1998 CST	11.3	\N
1620	1	f	1380			Wed Feb 18 01:22:52 1998 CST	29.9	\N
1621	1	f	1414			Wed Feb 18 01:28:14 1998 CST	11	\N
1622	1	f	1415			Wed Feb 18 01:39:59 1998 CST	17.1	\N
1623	1	f	1416			Wed Feb 18 01:49:00 1998 CST	47.5	\N
1624	1	f	1400			Wed Feb 18 02:44:29 1998 CST	21.700001	\N
1625	1	t	0		3.20	Wed Feb 18 02:50:22 1998 CST	13	\N
1626	1	t	0		3.25	Wed Feb 18 02:56:11 1998 CST	9.9	\N
1627	1	t	0		4.15	Wed Feb 18 03:41:08 1998 CST	10	\N
1628	1	f	1311			Wed Feb 18 03:46:48 1998 CST	15.2	\N
1629	1	t	0		4.30	Wed Feb 18 03:59:51 1998 CST	8	\N
1630	1	f	720			Wed Feb 18 16:52:45 1998 CST	15.7	\N
1631	1	f	1417			Wed Feb 18 17:18:57 1998 CST	23	\N
1632	1	f	1081			Wed Feb 18 17:34:57 1998 CST	22.799999	\N
1633	1	f	1137			Wed Feb 18 17:38:10 1998 CST	13.5	\N
1634	1	f	1418			Wed Feb 18 18:04:40 1998 CST	19	\N
1635	1	f	154			Wed Feb 18 18:13:54 1998 CST	12.5	\N
1636	1	f	1419			Wed Feb 18 18:15:25 1998 CST	25.9	\N
1637	1	f	1420			Wed Feb 18 18:22:07 1998 CST	13.5	\N
1638	1	f	1046			Wed Feb 18 18:37:05 1998 CST	16.5	\N
1639	1	t	0	KENT 82267700	19.20	Wed Feb 18 18:50:23 1998 CST	25.799999	\N
1640	1	f	1421			Wed Feb 18 19:50:11 1998 CST	16.200001	\N
1641	1	f	148			Wed Feb 18 19:57:01 1998 CST	28	\N
1642	1	f	754			Wed Feb 18 20:05:01 1998 CST	48.099998	\N
1643	1	f	1001			Wed Feb 18 20:05:48 1998 CST	20	\N
1644	1	f	903			Wed Feb 18 20:07:48 1998 CST	19.9	\N
1645	1	f	1422			Wed Feb 18 20:10:09 1998 CST	18	\N
1646	1	f	1423			Wed Feb 18 20:11:57 1998 CST	51.799999	\N
1647	1	f	1424			Wed Feb 18 20:19:02 1998 CST	15	\N
1648	1	f	641			Wed Feb 18 21:01:50 1998 CST	15.9	\N
1649	1	f	93			Wed Feb 18 21:06:09 1998 CST	32.599998	\N
1650	1	f	443			Wed Feb 18 21:11:48 1998 CST	22	\N
1651	1	f	1425			Wed Feb 18 21:17:55 1998 CST	15.9	\N
1652	1	f	1019			Wed Feb 18 21:35:10 1998 CST	11.6	\N
1653	1	f	1416			Wed Feb 18 21:44:59 1998 CST	15.2	\N
1654	1	f	591			Wed Feb 18 21:49:25 1998 CST	19.5	\N
1655	1	f	635			Wed Feb 18 22:20:46 1998 CST	16.9	\N
1656	1	f	1426			Wed Feb 18 22:22:30 1998 CST	18	\N
1657	1	f	1427			Wed Feb 18 22:36:05 1998 CST	21	\N
1658	1	f	1067			Wed Feb 18 22:52:34 1998 CST	25.9	\N
1659	1	f	605			Wed Feb 18 22:54:50 1998 CST	17	\N
1660	1	f	1428			Wed Feb 18 23:02:05 1998 CST	20.5	\N
1661	1	f	1429			Wed Feb 18 23:19:43 1998 CST	0	\N
1662	1	f	711			Wed Feb 18 23:29:36 1998 CST	15.9	\N
1663	1	f	1019			Wed Feb 18 23:58:25 1998 CST	10.5	\N
1664	1	f	1430			Wed Feb 18 23:47:54 1998 CST	17.5	\N
1665	1	f	132			Wed Feb 18 23:52:06 1998 CST	31.9	\N
1666	1	f	705			Thu Feb 19 00:00:04 1998 CST	26.6	\N
1667	1	f	534			Thu Feb 19 00:04:03 1998 CST	13.5	\N
1668	1	f	1431			Thu Feb 19 00:14:35 1998 CST	18	\N
1669	1	f	830			Thu Feb 19 00:29:27 1998 CST	16.9	\N
1670	1	f	1432			Thu Feb 19 00:27:29 1998 CST	23	\N
1671	1	f	1433			Thu Feb 19 00:45:15 1998 CST	16.6	\N
1672	1	f	310			Thu Feb 19 00:51:33 1998 CST	21	\N
1673	1	f	132			Thu Feb 19 01:20:37 1998 CST	20	\N
1674	1	f	65			Thu Feb 19 01:21:57 1998 CST	15.9	\N
1675	1	t	0		1.55	Thu Feb 19 01:25:30 1998 CST	14.9	\N
1676	1	f	1082			Thu Feb 19 01:29:03 1998 CST	21	\N
1677	1	f	163			Thu Feb 19 01:37:18 1998 CST	20	\N
1678	1	f	1400			Thu Feb 19 01:42:31 1998 CST	17.700001	\N
1679	1	f	1006			Thu Feb 19 01:57:26 1998 CST	15.9	\N
1680	1	f	400			Thu Feb 19 02:50:35 1998 CST	22.5	\N
1681	1	f	1434			Thu Feb 19 03:00:17 1998 CST	29.9	\N
1682	1	t	0	LUKE	4.10	Thu Feb 19 03:40:30 1998 CST	8.9	\N
1683	1	f	1435			Thu Feb 19 12:48:21 1998 CST	112.5	\N
1684	1	f	494			Thu Feb 19 17:13:49 1998 CST	17.5	\N
1685	1	f	674			Thu Feb 19 17:44:28 1998 CST	29.5	\N
1686	1	f	1436			Thu Feb 19 18:05:58 1998 CST	17	\N
1687	1	f	952			Thu Feb 19 18:09:24 1998 CST	31.299999	\N
1688	1	t	0		18.45	Thu Feb 19 18:13:22 1998 CST	9.9	\N
1689	1	f	502			Thu Feb 19 18:19:50 1998 CST	22	\N
1690	1	f	797			Thu Feb 19 18:51:26 1998 CST	15.9	\N
1691	1	t	0		19.25	Thu Feb 19 18:55:08 1998 CST	9.9	\N
1692	1	f	63			Thu Feb 19 19:17:58 1998 CST	25.6	\N
1693	1	f	382			Thu Feb 19 19:40:19 1998 CST	20	\N
1694	1	f	1437			Thu Feb 19 19:56:31 1998 CST	13.5	\N
1695	1	f	1438			Thu Feb 19 20:20:47 1998 CST	20	\N
1696	1	f	725			Thu Feb 19 20:32:03 1998 CST	21.15	\N
1697	1	f	42			Thu Feb 19 20:34:50 1998 CST	21	\N
1698	1	t	0		1.10	Thu Feb 19 20:37:33 1998 CST	12.9	\N
1699	1	f	713			Thu Feb 19 20:41:22 1998 CST	15.9	\N
1700	1	f	161			Thu Feb 19 20:55:39 1998 CST	19.299999	\N
1701	1	f	1439			Thu Feb 19 21:25:07 1998 CST	18	\N
1702	1	f	1143			Thu Feb 19 21:29:40 1998 CST	28.9	\N
1703	1	f	1353			Thu Feb 19 21:55:28 1998 CST	31.35	\N
1704	1	f	181			Thu Feb 19 22:27:25 1998 CST	17.299999	\N
1705	1	f	298			Thu Feb 19 22:35:44 1998 CST	27.4	\N
1706	1	f	1054			Thu Feb 19 22:48:07 1998 CST	20	\N
1707	1	f	368			Thu Feb 19 23:02:49 1998 CST	15.9	\N
1708	1	f	1052			Thu Feb 19 23:06:27 1998 CST	26.190001	\N
1709	1	f	942			Thu Feb 19 23:10:19 1998 CST	10	\N
1710	1	f	1019			Thu Feb 19 23:18:41 1998 CST	15.3	\N
1711	1	f	1410			Thu Feb 19 23:23:26 1998 CST	17	\N
1712	1	f	1440			Thu Feb 19 23:37:10 1998 CST	18	\N
1713	1	f	1128			Thu Feb 19 23:50:37 1998 CST	27.4	\N
1714	1	f	242			Thu Feb 19 23:55:43 1998 CST	24.9	\N
1715	1	f	528			Fri Feb 20 00:06:11 1998 CST	31.9	\N
1716	1	f	1441			Fri Feb 20 00:13:04 1998 CST	29	\N
1717	1	t	0		1.05	Fri Feb 20 00:33:20 1998 CST	20	\N
1718	1	f	629			Fri Feb 20 00:35:32 1998 CST	19.5	\N
1719	1	f	612			Fri Feb 20 00:42:25 1998 CST	34.5	\N
1720	1	f	1432			Fri Feb 20 00:53:28 1998 CST	19	\N
1721	1	f	1442			Fri Feb 20 01:17:09 1998 CST	34	\N
1722	1	f	1443			Fri Feb 20 01:09:01 1998 CST	22	\N
1723	1	f	1444			Fri Feb 20 01:15:01 1998 CST	18.5	\N
1724	1	f	1207			Fri Feb 20 01:23:41 1998 CST	19.5	\N
1725	1	f	1445			Fri Feb 20 01:58:02 1998 CST	17.700001	\N
1726	1	f	923			Fri Feb 20 01:45:51 1998 CST	20.6	\N
1727	1	f	310			Fri Feb 20 01:50:19 1998 CST	31.9	\N
1728	1	f	1446			Fri Feb 20 02:06:14 1998 CST	24.6	\N
1729	1	f	1447			Fri Feb 20 02:17:45 1998 CST	23.9	\N
1730	1	f	283			Fri Feb 20 02:36:29 1998 CST	19	\N
1731	1	f	1448			Fri Feb 20 02:45:28 1998 CST	21	\N
1732	1	f	370			Fri Feb 20 02:48:21 1998 CST	10.5	\N
1733	1	f	1125			Fri Feb 20 02:52:21 1998 CST	18	\N
1734	1	f	440			Fri Feb 20 03:07:20 1998 CST	23.9	\N
1735	1	f	1449			Fri Feb 20 03:45:08 1998 CST	16.200001	\N
1736	1	f	1450			Fri Feb 20 12:21:38 1998 CST	19.9	\N
1737	1	f	1451			Fri Feb 20 12:45:51 1998 CST	34.900002	\N
1738	1	f	759			Fri Feb 20 17:17:17 1998 CST	13.5	\N
1739	1	f	492			Fri Feb 20 17:33:50 1998 CST	24.9	\N
1740	1	t	0		19.00	Fri Feb 20 18:26:47 1998 CST	19.9	\N
1741	1	f	1452			Fri Feb 20 18:39:18 1998 CST	34.099998	\N
1742	1	f	740			Fri Feb 20 18:41:12 1998 CST	15.5	\N
1743	1	t	0	POLICE DEPT	19.15	Fri Feb 20 18:45:03 1998 CST	20	\N
1744	1	f	896			Fri Feb 20 19:11:35 1998 CST	25.5	\N
1745	1	f	1294			Fri Feb 20 19:30:37 1998 CST	21.9	\N
1746	1	f	1453			Fri Feb 20 19:32:46 1998 CST	28	\N
1747	1	f	1454			Fri Feb 20 19:38:54 1998 CST	18	\N
1748	1	f	434			Fri Feb 20 19:46:19 1998 CST	21.9	\N
1749	1	f	445			Fri Feb 20 19:56:08 1998 CST	22.9	\N
1750	1	f	1455			Fri Feb 20 20:01:57 1998 CST	18.9	\N
1751	1	f	955			Fri Feb 20 20:07:59 1998 CST	16.200001	\N
1752	1	f	1093			Fri Feb 20 20:12:58 1998 CST	15.9	\N
1753	1	f	1456			Fri Feb 20 20:27:59 1998 CST	20	\N
1754	1	f	479			Fri Feb 20 20:29:08 1998 CST	16.5	\N
1755	1	f	1000			Fri Feb 20 20:40:20 1998 CST	19.9	\N
1756	1	f	1457			Fri Feb 20 20:54:39 1998 CST	21	\N
1757	1	f	723			Fri Feb 20 21:22:29 1998 CST	15.9	\N
1758	1	f	30			Fri Feb 20 21:28:54 1998 CST	16.6	\N
1759	1	f	1019			Fri Feb 20 21:30:22 1998 CST	18	\N
1760	1	f	694			Fri Feb 20 21:31:42 1998 CST	13.2	\N
1761	1	f	848			Fri Feb 20 22:32:17 1998 CST	17	\N
1762	1	f	73			Fri Feb 20 22:45:48 1998 CST	11	\N
1763	1	f	1019			Fri Feb 20 23:05:47 1998 CST	8.1	\N
1764	1	f	243			Fri Feb 20 23:07:38 1998 CST	25	\N
1765	1	f	1458			Fri Feb 20 23:23:19 1998 CST	24	\N
1766	1	f	1459			Fri Feb 20 23:48:27 1998 CST	16.6	\N
1767	1	f	1460			Fri Feb 20 23:57:35 1998 CST	10.5	\N
1768	1	f	1461			Sat Feb 21 00:09:42 1998 CST	20	\N
1769	1	f	1462			Sat Feb 21 00:26:53 1998 CST	22	\N
1770	1	f	1328			Sat Feb 21 01:27:31 1998 CST	18	\N
1771	1	f	830			Sat Feb 21 00:43:37 1998 CST	13.5	\N
1772	1	f	1463			Sat Feb 21 01:08:08 1998 CST	28.5	\N
1773	1	f	1464			Sat Feb 21 01:06:49 1998 CST	27.9	\N
1774	1	f	1465			Sat Feb 21 01:12:42 1998 CST	19.9	\N
1775	1	f	1100			Sat Feb 21 01:30:27 1998 CST	16.5	\N
1776	1	f	881			Sat Feb 21 01:33:46 1998 CST	15.2	\N
1777	1	f	1027			Sat Feb 21 01:37:12 1998 CST	19.9	\N
1778	1	f	1466			Sat Feb 21 01:40:24 1998 CST	21.5	\N
1779	1	f	1410			Sat Feb 21 02:20:31 1998 CST	19.9	\N
1780	1	f	277			Sat Feb 21 02:24:37 1998 CST	20	\N
1781	1	f	163			Sat Feb 21 02:34:35 1998 CST	43.900002	\N
1782	1	t	0		3.05	Sat Feb 21 02:37:24 1998 CST	9.9	\N
1783	1	f	1467			Sat Feb 21 02:42:11 1998 CST	36.700001	\N
1784	1	f	1468			Sat Feb 21 02:44:39 1998 CST	25.9	\N
1785	1	f	1117			Sat Feb 21 02:48:54 1998 CST	19.9	\N
1786	1	f	1469			Sat Feb 21 03:01:57 1998 CST	16.9	\N
1787	1	f	1400			Sat Feb 21 03:04:35 1998 CST	19.9	\N
1788	1	f	1248			Sat Feb 21 03:18:22 1998 CST	16.9	\N
1789	1	f	861			Sat Feb 21 03:26:34 1998 CST	15	\N
1790	1	f	32			Sat Feb 21 03:37:01 1998 CST	28	\N
1791	1	f	1470			Sat Feb 21 03:42:19 1998 CST	20	\N
1792	1	f	114			Sat Feb 21 03:48:47 1998 CST	21.9	\N
1793	1	f	833			Sat Feb 21 03:51:48 1998 CST	20	\N
1794	1	f	483			Sat Feb 21 04:04:28 1998 CST	28.299999	\N
1795	1	f	1471			Sat Feb 21 04:26:09 1998 CST	22.5	\N
1796	1	f	1472			Sat Feb 21 04:23:30 1998 CST	15	\N
1797	1	f	1473			Sat Feb 21 13:21:36 1998 CST	27.9	\N
1798	1	t	0		15.10	Sat Feb 21 14:42:03 1998 CST	51.599998	\N
1799	1	f	280			Sat Feb 21 17:20:23 1998 CST	23	\N
1800	1	t	0		18.15	Sat Feb 21 17:41:52 1998 CST	9.9	\N
1801	1	f	1400			Sat Feb 21 17:56:43 1998 CST	31.4	\N
1802	1	f	400			Sat Feb 21 18:08:37 1998 CST	32.400002	\N
1803	1	f	784			Sat Feb 21 18:23:21 1998 CST	16.5	\N
1804	1	f	24			Sat Feb 21 18:27:49 1998 CST	21	\N
1805	1	f	141			Sat Feb 21 18:31:51 1998 CST	25.6	\N
1806	1	f	380			Sat Feb 21 18:59:27 1998 CST	20	\N
1807	1	f	1474			Sat Feb 21 19:01:11 1998 CST	23	\N
1808	1	f	1075			Sat Feb 21 19:14:25 1998 CST	20	\N
1809	1	f	1475			Sat Feb 21 19:40:58 1998 CST	18.5	\N
1810	1	f	1476			Sat Feb 21 19:46:45 1998 CST	20	\N
1811	1	f	1477			Sat Feb 21 20:03:36 1998 CST	16.6	\N
1812	1	f	1478			Sat Feb 21 20:05:34 1998 CST	18	\N
1813	1	f	51			Sat Feb 21 20:06:50 1998 CST	28	\N
1814	1	f	56			Sat Feb 21 20:44:35 1998 CST	60	\N
1815	1	f	1019			Sat Feb 21 20:49:32 1998 CST	36.450001	\N
1816	1	f	1479			Sat Feb 21 20:54:34 1998 CST	59.700001	\N
1817	1	f	812			Sat Feb 21 21:16:44 1998 CST	15.9	\N
1818	1	t	0		21.50	Sat Feb 21 21:17:19 1998 CST	12.9	\N
1819	1	f	1041			Sat Feb 21 21:25:35 1998 CST	19	\N
1820	1	t	0		21.55	Sat Feb 21 21:26:05 1998 CST	12.9	\N
1821	1	f	691			Sat Feb 21 21:38:33 1998 CST	19.9	\N
1822	1	f	939			Sat Feb 21 21:41:40 1998 CST	38	\N
1823	1	f	1480			Sat Feb 21 21:46:07 1998 CST	16	\N
1824	1	f	1481			Sat Feb 21 21:50:45 1998 CST	13.5	\N
1825	1	f	1482			Sat Feb 21 22:13:36 1998 CST	22	\N
1826	1	f	707			Sat Feb 21 22:27:18 1998 CST	30	\N
1827	1	f	1483			Sat Feb 21 22:38:55 1998 CST	29.5	\N
1828	1	f	60			Sat Feb 21 22:40:26 1998 CST	26.6	\N
1829	1	f	896			Sat Feb 21 22:47:24 1998 CST	18.700001	\N
1830	1	f	1484			Sat Feb 21 23:13:14 1998 CST	26	\N
1831	1	f	1006			Sat Feb 21 23:15:10 1998 CST	15.9	\N
1832	1	f	1485			Sat Feb 21 23:44:31 1998 CST	17.5	\N
1833	1	f	277			Sat Feb 21 23:55:01 1998 CST	22	\N
1834	1	f	1219			Sun Feb 22 00:06:25 1998 CST	15.9	\N
1835	1	f	1486			Sun Feb 22 00:42:31 1998 CST	20	\N
1836	1	f	1487			Sun Feb 22 01:05:01 1998 CST	15.2	\N
1837	1	f	1488			Sun Feb 22 01:41:45 1998 CST	25.9	\N
1838	1	f	1489			Sun Feb 22 01:50:45 1998 CST	16.6	\N
1839	1	f	1490			Sun Feb 22 01:56:48 1998 CST	21.9	\N
1840	1	f	1491			Sun Feb 22 02:02:13 1998 CST	13.5	\N
1841	1	f	1492			Sun Feb 22 02:12:26 1998 CST	26.9	\N
1842	1	f	1493			Sun Feb 22 02:19:11 1998 CST	15.9	\N
1843	1	f	460			Sun Feb 22 02:36:00 1998 CST	15.9	\N
1844	1	f	877			Sun Feb 22 02:39:40 1998 CST	27.9	\N
1845	1	f	1494			Sun Feb 22 02:47:37 1998 CST	32.299999	\N
1846	1	f	1495			Sun Feb 22 02:50:51 1998 CST	15.3	\N
1847	1	f	664			Sun Feb 22 02:55:14 1998 CST	19.5	\N
1848	1	f	1496			Sun Feb 22 03:07:24 1998 CST	15.5	\N
1849	1	t	0		3.50	Sun Feb 22 03:18:48 1998 CST	12	\N
1850	1	f	1497			Sun Feb 22 03:30:00 1998 CST	18	\N
1851	1	f	1498			Sun Feb 22 03:32:43 1998 CST	18.200001	\N
1852	1	f	1499			Sun Feb 22 03:35:24 1998 CST	19	\N
1853	1	t	0		4.40	Sun Feb 22 04:07:06 1998 CST	13.4	\N
1854	1	f	169			Sun Feb 22 04:12:49 1998 CST	25.9	\N
1855	1	f	1500			Sun Feb 22 04:14:21 1998 CST	19	\N
1856	1	f	1501			Sun Feb 22 12:54:57 1998 CST	18	\N
1857	1	f	1502			Sun Feb 22 17:10:22 1998 CST	26	\N
1858	1	f	17			Sun Feb 22 17:16:22 1998 CST	16.6	\N
1859	1	f	1503			Sun Feb 22 17:32:45 1998 CST	16.6	\N
1860	1	f	1504			Sun Feb 22 17:34:15 1998 CST	23.9	\N
1861	1	f	888			Sun Feb 22 18:12:09 1998 CST	21	\N
1862	1	f	1505			Sun Feb 22 18:13:27 1998 CST	16	\N
1863	1	f	1506			Sun Feb 22 18:18:34 1998 CST	20.6	\N
1864	1	f	272			Sun Feb 22 18:21:00 1998 CST	13.2	\N
1865	1	f	1368			Sun Feb 22 18:35:31 1998 CST	27.5	\N
1866	1	f	1507			Sun Feb 22 18:43:25 1998 CST	25.9	\N
1867	1	f	1142			Sun Feb 22 18:44:45 1998 CST	17.5	\N
1868	1	f	1508			Sun Feb 22 19:02:54 1998 CST	23.9	\N
1869	1	f	248			Sun Feb 22 19:13:04 1998 CST	18	\N
1870	1	f	1303			Sun Feb 22 19:24:54 1998 CST	15.5	\N
1871	1	f	840			Sun Feb 22 19:29:09 1998 CST	26.5	\N
1872	1	f	400			Sun Feb 22 19:32:23 1998 CST	26	\N
1873	1	f	1100			Sun Feb 22 19:38:28 1998 CST	38	\N
1874	1	f	1509			Sun Feb 22 19:40:30 1998 CST	41.5	\N
1875	1	f	1510			Sun Feb 22 19:44:34 1998 CST	75	\N
1876	1	f	1511			Sun Feb 22 19:50:55 1998 CST	15.5	\N
1877	1	f	1400			Sun Feb 22 19:52:41 1998 CST	21.200001	\N
1878	1	f	93			Sun Feb 22 20:10:45 1998 CST	17	\N
1879	1	f	1512			Sun Feb 22 20:17:54 1998 CST	31.5	\N
1880	1	f	945			Sun Feb 22 20:28:55 1998 CST	26	\N
1881	1	f	1513			Sun Feb 22 20:31:36 1998 CST	19.700001	\N
1882	1	f	1514			Sun Feb 22 20:42:53 1998 CST	30.5	\N
1883	1	f	908			Sun Feb 22 20:49:01 1998 CST	15.9	\N
1884	1	f	1143			Sun Feb 22 20:53:12 1998 CST	29.9	\N
1885	1	f	1515			Sun Feb 22 21:06:29 1998 CST	51.5	\N
1886	1	f	990			Sun Feb 22 21:03:35 1998 CST	20.6	\N
1887	1	f	1085			Sun Feb 22 21:05:00 1998 CST	13.5	\N
1888	1	f	90			Sun Feb 22 21:07:43 1998 CST	15.5	\N
1889	1	f	483			Sun Feb 22 21:09:28 1998 CST	28.5	\N
1890	1	f	1516			Sun Feb 22 21:33:35 1998 CST	15.5	\N
1891	1	f	1517			Sun Feb 22 21:37:16 1998 CST	21	\N
1892	1	f	469			Sun Feb 22 22:01:45 1998 CST	20	\N
1893	1	f	1518			Sun Feb 22 22:23:26 1998 CST	17	\N
1894	1	f	1519			Sun Feb 22 22:41:47 1998 CST	24	\N
1895	1	f	1363			Sun Feb 22 22:49:31 1998 CST	15	\N
1896	1	f	1520			Sun Feb 22 23:17:00 1998 CST	18	\N
1897	1	f	1441			Sun Feb 22 23:22:28 1998 CST	24.5	\N
1898	1	f	687			Sun Feb 22 23:32:13 1998 CST	19.9	\N
1899	1	f	283			Sun Feb 22 23:50:07 1998 CST	17.9	\N
1900	1	f	1521			Mon Feb 23 00:16:54 1998 CST	13.5	\N
1901	1	f	1522			Mon Feb 23 00:19:23 1998 CST	15.9	\N
1902	1	f	643			Mon Feb 23 00:20:21 1998 CST	18.200001	\N
1903	1	f	176			Mon Feb 23 00:21:55 1998 CST	15	\N
1904	1	f	715			Mon Feb 23 00:30:25 1998 CST	22	\N
1905	1	f	370			Mon Feb 23 00:34:28 1998 CST	19	\N
1906	1	f	1523			Mon Feb 23 00:37:06 1998 CST	18	\N
1907	1	f	1433			Mon Feb 23 00:38:25 1998 CST	26.700001	\N
1908	1	t	0		1.30	Mon Feb 23 00:58:57 1998 CST	12.9	\N
1909	1	f	630			Mon Feb 23 01:07:46 1998 CST	19.5	\N
1910	1	t	0	F	1.50	Mon Feb 23 01:22:32 1998 CST	27.799999	\N
1911	1	f	1524			Mon Feb 23 01:56:15 1998 CST	17.4	\N
1912	1	f	877			Mon Feb 23 01:59:28 1998 CST	21	\N
1913	1	f	1366			Mon Feb 23 02:12:57 1998 CST	13.5	\N
1914	1	f	1525			Mon Feb 23 02:14:28 1998 CST	15.5	\N
1915	1	f	820			Mon Feb 23 02:19:07 1998 CST	20	\N
1916	1	f	1526			Mon Feb 23 02:23:46 1998 CST	18.5	\N
1917	1	f	164			Mon Feb 23 02:35:30 1998 CST	19.9	\N
1918	1	t	0		3.10	Mon Feb 23 02:40:12 1998 CST	16.4	\N
1919	1	f	1527			Mon Feb 23 02:45:09 1998 CST	15.9	\N
1920	1	f	1528			Mon Feb 23 02:55:40 1998 CST	15.9	\N
1921	1	f	633			Mon Feb 23 17:12:40 1998 CST	10.5	\N
1922	1	f	1263			Mon Feb 23 18:12:00 1998 CST	14.2	\N
1923	1	f	6			Mon Feb 23 18:24:11 1998 CST	11.5	\N
1924	1	f	496			Mon Feb 23 18:34:53 1998 CST	18	\N
1925	1	f	1529			Mon Feb 23 18:40:08 1998 CST	16.9	\N
1926	1	f	84			Mon Feb 23 18:51:37 1998 CST	19.9	\N
1927	1	f	488			Mon Feb 23 18:54:14 1998 CST	16	\N
1928	1	f	169			Mon Feb 23 18:55:51 1998 CST	12.5	\N
1929	1	f	1530			Mon Feb 23 19:13:37 1998 CST	37	\N
1930	1	f	1531			Mon Feb 23 19:20:17 1998 CST	21	\N
1931	1	f	1532			Mon Feb 23 19:29:05 1998 CST	15.5	\N
1932	1	f	1533			Mon Feb 23 19:30:53 1998 CST	24	\N
1933	1	f	1081			Mon Feb 23 19:31:45 1998 CST	18.5	\N
1934	1	f	116			Mon Feb 23 19:45:37 1998 CST	19.9	\N
1935	1	f	917			Mon Feb 23 19:49:12 1998 CST	15.5	\N
1936	1	f	1534			Mon Feb 23 19:52:53 1998 CST	19.9	\N
1937	1	f	1180			Mon Feb 23 19:54:05 1998 CST	34.5	\N
1938	1	f	1164			Mon Feb 23 20:01:04 1998 CST	16	\N
1939	1	f	903			Mon Feb 23 20:08:34 1998 CST	19.9	\N
1940	1	f	1386			Mon Feb 23 20:16:25 1998 CST	23.5	\N
1941	1	f	1024			Mon Feb 23 20:24:35 1998 CST	14.2	\N
1942	1	f	277			Mon Feb 23 20:31:26 1998 CST	26.6	\N
1943	1	f	1535			Mon Feb 23 20:33:47 1998 CST	16.9	\N
1944	1	f	1019			Mon Feb 23 21:11:51 1998 CST	14.15	\N
1945	1	f	212			Mon Feb 23 21:15:50 1998 CST	17.5	\N
1946	1	f	1536			Mon Feb 23 21:29:29 1998 CST	27	\N
1947	1	f	442			Mon Feb 23 21:47:52 1998 CST	11	\N
1948	1	t	0		22.50	Mon Feb 23 22:19:13 1998 CST	9.9	\N
1949	1	t	0		23.20	Mon Feb 23 22:46:38 1998 CST	29.5	\N
1950	1	t	0		23.35	Mon Feb 23 23:03:00 1998 CST	15	\N
1951	1	f	1353			Mon Feb 23 23:06:09 1998 CST	17.1	\N
1952	1	f	1065			Mon Feb 23 23:07:38 1998 CST	20	\N
1953	1	f	1537			Mon Feb 23 23:16:05 1998 CST	25	\N
1954	1	f	14			Mon Feb 23 23:27:52 1998 CST	27.5	\N
1955	1	f	95			Mon Feb 23 23:29:54 1998 CST	26.5	\N
1956	1	f	1019			Mon Feb 23 23:33:35 1998 CST	10.35	\N
1957	1	t	0		0.25	Mon Feb 23 23:54:29 1998 CST	13.9	\N
1958	1	t	0		0.35	Tue Feb 24 00:03:45 1998 CST	12.9	\N
1959	1	f	1538			Tue Feb 24 00:30:36 1998 CST	23.9	\N
1960	1	f	1539			Tue Feb 24 00:37:15 1998 CST	25.9	\N
1961	1	f	1540			Tue Feb 24 00:46:02 1998 CST	18	\N
1962	1	f	659			Tue Feb 24 00:56:20 1998 CST	21	\N
1963	1	f	1460			Tue Feb 24 01:58:39 1998 CST	43.200001	\N
1964	1	f	710			Tue Feb 24 02:26:32 1998 CST	17.5	\N
1965	1	f	711			Tue Feb 24 02:53:28 1998 CST	12.5	\N
1966	1	f	1541			Tue Feb 24 03:02:34 1998 CST	20	\N
1967	1	f	241			Tue Feb 24 03:46:57 1998 CST	15.5	\N
1968	1	f	880			Tue Feb 24 03:55:18 1998 CST	19.9	\N
1969	1	f	834			Tue Feb 24 17:25:37 1998 CST	18	\N
1970	1	f	1276			Tue Feb 24 18:35:02 1998 CST	20	\N
1971	1	t	0	kate	19.15	Tue Feb 24 18:43:27 1998 CST	9.9	\N
1972	1	f	1542			Tue Feb 24 18:49:34 1998 CST	17.299999	\N
1973	1	f	1543			Tue Feb 24 18:59:14 1998 CST	17.5	\N
1974	1	f	1081			Tue Feb 24 19:03:38 1998 CST	10	\N
1975	1	f	1544			Tue Feb 24 19:04:59 1998 CST	20	\N
1976	1	f	1370			Tue Feb 24 19:10:52 1998 CST	25.9	\N
1977	1	f	161			Tue Feb 24 19:16:00 1998 CST	26.299999	\N
1978	1	f	1020			Tue Feb 24 19:27:06 1998 CST	15.9	\N
1979	1	f	1467			Tue Feb 24 19:28:43 1998 CST	15.9	\N
1980	1	t	0		20.20	Tue Feb 24 19:50:48 1998 CST	9.9	\N
1981	1	f	338			Tue Feb 24 19:55:59 1998 CST	19.9	\N
1982	1	f	1161			Tue Feb 24 19:58:16 1998 CST	53	\N
1983	1	f	1019			Tue Feb 24 20:21:09 1998 CST	17.299999	\N
1984	1	f	1315			Tue Feb 24 20:29:21 1998 CST	15.5	\N
1985	1	f	442			Tue Feb 24 20:48:24 1998 CST	19.9	\N
1986	1	f	1545			Tue Feb 24 20:53:32 1998 CST	15.9	\N
1987	1	f	398			Tue Feb 24 20:54:20 1998 CST	14.2	\N
1988	1	f	1001			Tue Feb 24 20:55:51 1998 CST	20	\N
1989	1	f	123			Tue Feb 24 21:04:19 1998 CST	21.299999	\N
1990	1	f	56			Tue Feb 24 21:06:18 1998 CST	18.9	\N
1991	1	f	124			Tue Feb 24 21:10:55 1998 CST	15.9	\N
1992	1	f	57			Tue Feb 24 21:22:53 1998 CST	20.9	\N
1993	1	f	1546			Tue Feb 24 21:30:31 1998 CST	19	\N
1994	1	f	1547			Tue Feb 24 21:51:38 1998 CST	10	\N
1995	1	f	735			Tue Feb 24 22:04:29 1998 CST	11.6	\N
1996	1	f	1180			Tue Feb 24 22:20:59 1998 CST	16.200001	\N
1997	1	t	0		23.05	Tue Feb 24 22:34:21 1998 CST	12.9	\N
1998	1	t	0		23.10	Tue Feb 24 22:41:31 1998 CST	41.799999	\N
1999	1	f	1548			Tue Feb 24 23:07:07 1998 CST	21	\N
2000	1	f	917			Tue Feb 24 23:08:03 1998 CST	13.5	\N
2001	1	f	782			Tue Feb 24 23:13:17 1998 CST	25.9	\N
2002	1	f	1549			Tue Feb 24 23:22:42 1998 CST	20.6	\N
2003	1	f	942			Tue Feb 24 23:25:47 1998 CST	20.5	\N
2004	1	f	1460			Tue Feb 24 23:29:57 1998 CST	38.099998	\N
2005	1	t	0	POLICE	0.35	Wed Feb 25 00:05:20 1998 CST	31	\N
2006	1	f	1550			Wed Feb 25 00:07:13 1998 CST	25.9	\N
2007	1	f	248			Wed Feb 25 00:10:17 1998 CST	15.9	\N
2008	1	f	1551			Wed Feb 25 00:29:47 1998 CST	15.5	\N
2009	1	f	1552			Wed Feb 25 01:01:06 1998 CST	21	\N
2010	1	f	1553			Wed Feb 25 01:04:44 1998 CST	0	\N
2011	1	f	1491			Wed Feb 25 01:05:15 1998 CST	13.5	\N
2012	1	f	848			Wed Feb 25 01:09:45 1998 CST	17	\N
2013	1	f	729			Wed Feb 25 01:11:25 1998 CST	19	\N
2014	1	f	1554			Wed Feb 25 01:13:34 1998 CST	19	\N
2015	1	f	1555			Wed Feb 25 01:45:03 1998 CST	17.5	\N
2016	1	f	1135			Wed Feb 25 01:57:53 1998 CST	16.9	\N
2017	1	f	711			Wed Feb 25 02:06:54 1998 CST	21.9	\N
2018	1	f	987			Wed Feb 25 02:20:28 1998 CST	17.299999	\N
2019	1	f	1492			Wed Feb 25 02:22:52 1998 CST	20	\N
2020	1	t	0		3.10	Wed Feb 25 02:36:44 1998 CST	9.9	\N
2021	1	t	0		3.40	Wed Feb 25 03:08:28 1998 CST	6.9	\N
2022	1	f	154			Wed Feb 25 17:47:25 1998 CST	20	\N
2023	1	f	1307			Wed Feb 25 18:38:42 1998 CST	15.9	\N
2024	1	f	1556			Wed Feb 25 18:39:44 1998 CST	19.9	\N
2025	1	f	1557			Wed Feb 25 18:51:53 1998 CST	20	\N
2026	1	f	400			Wed Feb 25 18:55:29 1998 CST	16	\N
2027	1	f	641			Wed Feb 25 19:00:58 1998 CST	20.6	\N
2028	1	f	169			Wed Feb 25 19:14:17 1998 CST	12.5	\N
2029	1	f	560			Wed Feb 25 19:17:16 1998 CST	15.9	\N
2030	1	f	1078			Wed Feb 25 19:43:10 1998 CST	69	\N
2031	1	f	1558			Wed Feb 25 19:49:33 1998 CST	22	\N
2032	1	f	1559			Wed Feb 25 19:51:45 1998 CST	15.5	\N
2033	1	f	660			Wed Feb 25 20:08:51 1998 CST	15.9	\N
2034	1	f	1560			Wed Feb 25 20:14:08 1998 CST	20	\N
2035	1	f	995			Wed Feb 25 20:17:03 1998 CST	19.700001	\N
2036	1	f	6			Wed Feb 25 20:28:21 1998 CST	10.5	\N
2037	1	f	237			Wed Feb 25 20:34:08 1998 CST	19.9	\N
2038	1	f	6			Wed Feb 25 20:36:30 1998 CST	10.5	\N
2039	1	f	1561			Wed Feb 25 21:01:43 1998 CST	10	\N
2040	1	f	443			Wed Feb 25 21:04:23 1998 CST	23.299999	\N
2041	1	f	812			Wed Feb 25 21:07:57 1998 CST	15	\N
2042	1	f	549			Wed Feb 25 21:39:24 1998 CST	25.4	\N
2043	1	f	1019			Wed Feb 25 22:18:43 1998 CST	12.25	\N
2044	1	f	1322			Wed Feb 25 22:27:06 1998 CST	18	\N
2045	1	f	1460			Wed Feb 25 22:33:19 1998 CST	30.299999	\N
2046	1	t	0		23.20	Wed Feb 25 23:12:05 1998 CST	7.6	\N
2047	1	f	1410			Wed Feb 25 22:57:09 1998 CST	18	\N
2048	1	f	537			Wed Feb 25 23:30:55 1998 CST	22.5	\N
2049	1	f	1562			Wed Feb 25 23:33:34 1998 CST	13.5	\N
2050	1	f	1563			Thu Feb 26 00:21:33 1998 CST	15.9	\N
2051	1	f	793			Thu Feb 26 00:23:08 1998 CST	19.9	\N
2052	1	f	1564			Thu Feb 26 00:26:11 1998 CST	26	\N
2053	1	f	1006			Thu Feb 26 00:28:15 1998 CST	15.9	\N
2054	1	f	181			Thu Feb 26 00:39:35 1998 CST	25	\N
2055	1	f	1565			Thu Feb 26 00:59:46 1998 CST	28.5	\N
2056	1	f	1381			Thu Feb 26 01:03:24 1998 CST	20	\N
2057	1	f	291			Thu Feb 26 01:09:29 1998 CST	20	\N
2058	1	f	1566			Thu Feb 26 01:37:28 1998 CST	23.5	\N
2059	1	f	1287			Thu Feb 26 01:59:29 1998 CST	13.5	\N
2060	1	f	1567			Thu Feb 26 02:14:51 1998 CST	24.299999	\N
2061	1	f	987			Thu Feb 26 02:21:08 1998 CST	22	\N
2062	1	f	1414			Thu Feb 26 02:45:06 1998 CST	17	\N
2063	1	f	1568			Thu Feb 26 02:52:51 1998 CST	15.9	\N
2064	1	f	65			Thu Feb 26 02:57:53 1998 CST	15.9	\N
2065	1	f	781			Thu Feb 26 03:00:51 1998 CST	21	\N
2066	1	f	1403			Thu Feb 26 03:10:38 1998 CST	16.200001	\N
2067	1	f	830			Thu Feb 26 04:00:41 1998 CST	16.5	\N
2068	1	f	952			Thu Feb 26 17:53:17 1998 CST	28.299999	\N
2069	1	f	1294			Thu Feb 26 18:09:37 1998 CST	21.9	\N
2070	1	f	370			Thu Feb 26 18:24:16 1998 CST	31.5	\N
2071	1	f	1042			Thu Feb 26 18:41:57 1998 CST	22	\N
2072	1	f	423			Thu Feb 26 18:45:29 1998 CST	19.9	\N
2073	1	f	1570			Thu Feb 26 18:48:24 1998 CST	13.5	\N
2074	1	f	148			Thu Feb 26 18:50:52 1998 CST	27.4	\N
2075	1	f	262			Thu Feb 26 18:59:55 1998 CST	34.700001	\N
2076	1	f	92			Thu Feb 26 19:11:33 1998 CST	12.5	\N
2077	1	f	60			Thu Feb 26 19:38:06 1998 CST	23.5	\N
2078	1	f	57			Thu Feb 26 19:43:25 1998 CST	16.299999	\N
2079	1	f	56			Thu Feb 26 19:51:21 1998 CST	27	\N
2080	1	f	47			Thu Feb 26 19:53:32 1998 CST	13.7	\N
2081	1	f	479			Thu Feb 26 20:02:08 1998 CST	15.5	\N
2082	1	f	1571			Thu Feb 26 20:07:11 1998 CST	23.6	\N
2083	1	f	1572			Thu Feb 26 20:13:49 1998 CST	29.9	\N
2084	1	f	549			Thu Feb 26 20:17:48 1998 CST	23	\N
2085	1	f	1295			Thu Feb 26 20:21:15 1998 CST	25.5	\N
2086	1	f	1573			Thu Feb 26 20:44:01 1998 CST	43.900002	\N
2087	1	f	488			Thu Feb 26 21:05:48 1998 CST	41.400002	\N
2088	1	f	566			Thu Feb 26 21:28:16 1998 CST	20.6	\N
2089	1	f	1574			Thu Feb 26 21:42:08 1998 CST	13.5	\N
2090	1	f	1019			Thu Feb 26 22:13:30 1998 CST	14.22	\N
2091	1	f	298			Thu Feb 26 22:18:46 1998 CST	20	\N
2092	1	f	263			Thu Feb 26 22:34:39 1998 CST	21	\N
2093	1	f	1575			Thu Feb 26 22:54:08 1998 CST	18	\N
2094	1	t	0		23.35	Thu Feb 26 23:03:43 1998 CST	6.9	\N
2095	1	f	1393			Thu Feb 26 23:09:45 1998 CST	15.7	\N
2096	1	f	1576			Thu Feb 26 23:30:29 1998 CST	26.5	\N
2097	1	f	1460			Thu Feb 26 23:32:46 1998 CST	25.4	\N
2098	1	f	1353			Thu Feb 26 23:38:54 1998 CST	19.9	\N
2099	1	f	1577			Thu Feb 26 23:46:18 1998 CST	21	\N
2100	1	f	820			Fri Feb 27 00:00:53 1998 CST	19.9	\N
2101	1	t	0		0.35	Fri Feb 27 00:04:17 1998 CST	29	\N
2102	1	f	1006			Fri Feb 27 00:14:53 1998 CST	15.9	\N
2103	1	t	0		0.50	Fri Feb 27 00:19:09 1998 CST	6.9	\N
2104	1	t	0		1.05	Fri Feb 27 00:34:29 1998 CST	5.5	\N
2105	1	f	1578			Fri Feb 27 01:20:41 1998 CST	13.9	\N
2106	1	f	1579			Fri Feb 27 01:22:58 1998 CST	21.299999	\N
2107	1	f	447			Fri Feb 27 01:39:25 1998 CST	26.5	\N
2108	1	f	764			Fri Feb 27 01:41:32 1998 CST	15.6	\N
2109	1	f	825			Fri Feb 27 01:59:42 1998 CST	9.5	\N
2110	1	f	190			Fri Feb 27 02:25:07 1998 CST	12.5	\N
2111	1	f	1432			Fri Feb 27 02:58:48 1998 CST	25.9	\N
2112	1	f	988			Fri Feb 27 03:25:58 1998 CST	24.700001	\N
2113	1	f	711			Fri Feb 27 03:41:42 1998 CST	33.5	\N
2114	1	t	0		4.30	Fri Feb 27 03:57:56 1998 CST	19.9	\N
2115	1	f	1451			Fri Feb 27 12:24:48 1998 CST	25.9	\N
2116	1	f	434			Fri Feb 27 17:16:35 1998 CST	17	\N
2117	1	f	492			Fri Feb 27 17:28:13 1998 CST	22.9	\N
2118	1	f	434			Fri Feb 27 17:35:15 1998 CST	21	\N
2119	1	f	991			Fri Feb 27 17:44:46 1998 CST	21.9	\N
2120	1	f	1580			Fri Feb 27 17:50:09 1998 CST	25.700001	\N
2121	1	t	0		18.25	Fri Feb 27 17:57:06 1998 CST	20	\N
2122	1	f	759			Fri Feb 27 18:14:45 1998 CST	28.5	\N
2123	1	f	1581			Fri Feb 27 18:24:44 1998 CST	16.5	\N
2124	1	t	0		19.15	Fri Feb 27 18:44:31 1998 CST	11.3	\N
2125	1	f	1287			Fri Feb 27 18:50:55 1998 CST	17.5	\N
2126	1	f	397			Fri Feb 27 18:57:07 1998 CST	30	\N
2127	1	f	328			Fri Feb 27 18:58:43 1998 CST	20	\N
2128	1	t	0		20.00	Fri Feb 27 19:26:33 1998 CST	9.9	\N
2129	1	f	294			Fri Feb 27 19:38:33 1998 CST	12.5	\N
2130	1	f	277			Fri Feb 27 20:13:17 1998 CST	20	\N
2131	1	f	1019			Fri Feb 27 20:17:31 1998 CST	15.75	\N
2132	1	f	1509			Fri Feb 27 20:22:21 1998 CST	25.5	\N
2133	1	f	1582			Fri Feb 27 20:25:49 1998 CST	16.5	\N
2134	1	f	18			Fri Feb 27 20:27:15 1998 CST	33.5	\N
2135	1	f	955			Fri Feb 27 20:28:20 1998 CST	16.5	\N
2136	1	f	735			Fri Feb 27 20:29:38 1998 CST	13.25	\N
2137	1	f	1583			Fri Feb 27 20:39:21 1998 CST	19	\N
2138	1	f	1191			Fri Feb 27 20:42:25 1998 CST	19.5	\N
2139	1	f	147			Fri Feb 27 20:43:25 1998 CST	15.5	\N
2140	1	f	1584			Fri Feb 27 20:44:58 1998 CST	27	\N
2141	1	f	110			Fri Feb 27 20:49:14 1998 CST	32.900002	\N
2142	1	f	1585			Fri Feb 27 20:53:51 1998 CST	18	\N
2143	1	f	1079			Fri Feb 27 21:14:26 1998 CST	16.5	\N
2144	1	t	0		21.55	Fri Feb 27 21:22:21 1998 CST	9.9	\N
2145	1	f	735			Fri Feb 27 21:25:12 1998 CST	20.700001	\N
2146	1	t	0		22.10	Fri Feb 27 21:40:26 1998 CST	11.9	\N
2147	1	f	1586			Fri Feb 27 22:14:12 1998 CST	15.5	\N
2148	1	f	189			Fri Feb 27 22:14:50 1998 CST	20	\N
2149	1	f	591			Fri Feb 27 22:29:24 1998 CST	23.5	\N
2150	1	f	668			Fri Feb 27 22:49:57 1998 CST	19.9	\N
2151	1	t	0		23.20	Fri Feb 27 22:50:40 1998 CST	12.9	\N
2152	1	f	1204			Fri Feb 27 23:32:42 1998 CST	18	\N
2153	1	f	830			Fri Feb 27 23:38:50 1998 CST	15.9	\N
2154	1	f	710			Sat Feb 28 00:07:47 1998 CST	12.5	\N
2155	1	t	0	PFM	0.55	Sat Feb 28 00:25:34 1998 CST	12.9	\N
2156	1	f	1390			Sat Feb 28 00:27:26 1998 CST	21	\N
2157	1	f	1587			Sat Feb 28 00:35:56 1998 CST	15	\N
2158	1	f	163			Sat Feb 28 00:55:38 1998 CST	60	\N
2159	1	f	1588			Sat Feb 28 00:59:46 1998 CST	16.200001	\N
2160	1	f	1589			Sat Feb 28 01:01:27 1998 CST	15.6	\N
2161	1	f	627			Sat Feb 28 01:02:19 1998 CST	16.9	\N
2162	1	f	1590			Sat Feb 28 01:24:34 1998 CST	19	\N
2163	1	f	1591			Sat Feb 28 01:26:17 1998 CST	17.5	\N
2164	1	f	1592			Sat Feb 28 01:33:10 1998 CST	15.6	\N
2165	1	f	1593			Sat Feb 28 01:34:46 1998 CST	13.2	\N
2166	1	f	1594			Sat Feb 28 01:50:38 1998 CST	15.5	\N
2167	1	f	1081			Sat Feb 28 02:05:09 1998 CST	14.9	\N
2168	1	t	0		2.40	Sat Feb 28 02:08:21 1998 CST	9.9	\N
2169	1	t	0		2.50	Sat Feb 28 02:17:11 1998 CST	6.9	\N
2170	1	f	882			Sat Feb 28 02:22:14 1998 CST	16.6	\N
2171	1	f	629			Sat Feb 28 02:26:01 1998 CST	15.7	\N
2172	1	t	0		3.00	Sat Feb 28 02:29:34 1998 CST	10	\N
2173	1	t	0		3.00	Sat Feb 28 02:29:53 1998 CST	6.9	\N
2174	1	f	1595			Sat Feb 28 02:34:56 1998 CST	22.9	\N
2175	1	t	0		3.05	Sat Feb 28 02:36:07 1998 CST	13.6	\N
2176	1	f	1289			Sat Feb 28 02:47:48 1998 CST	27.5	\N
2177	1	f	310			Sat Feb 28 02:54:59 1998 CST	16.6	\N
2178	1	f	1596			Sat Feb 28 03:06:47 1998 CST	21.200001	\N
2179	1	f	1597			Sat Feb 28 03:19:51 1998 CST	18.9	\N
2180	1	f	1598			Sat Feb 28 03:21:38 1998 CST	18	\N
2181	1	f	687			Sat Feb 28 03:22:32 1998 CST	22.9	\N
2182	1	f	1019			Sat Feb 28 04:02:45 1998 CST	12.15	\N
2183	1	f	371			Sat Feb 28 04:13:54 1998 CST	10	\N
2184	1	f	1206			Sat Feb 28 04:23:18 1998 CST	21	\N
2185	1	f	420			Sat Feb 28 04:24:51 1998 CST	19	\N
2186	1	t	0		17.30	Sat Feb 28 16:59:24 1998 CST	9.9	\N
2187	1	f	1599			Sat Feb 28 17:32:04 1998 CST	15.5	\N
2188	1	t	0		18.50	Sat Feb 28 18:17:26 1998 CST	15.9	\N
2189	1	f	1600			Sat Feb 28 18:19:08 1998 CST	26	\N
2190	1	f	177			Sat Feb 28 18:22:30 1998 CST	16.200001	\N
2191	1	f	965			Sat Feb 28 18:38:00 1998 CST	18	\N
2192	1	f	1460			Sat Feb 28 18:44:04 1998 CST	13.05	\N
2193	1	f	1601			Sat Feb 28 18:47:12 1998 CST	16	\N
2194	1	f	1602			Sat Feb 28 18:58:27 1998 CST	18	\N
2195	1	f	1241			Sat Feb 28 19:09:08 1998 CST	14.5	\N
2196	1	f	702			Sat Feb 28 19:10:30 1998 CST	26	\N
2197	1	f	754			Sat Feb 28 19:21:51 1998 CST	16	\N
2198	1	f	1603			Sat Feb 28 19:28:51 1998 CST	15	\N
2199	1	t	0		20.00	Sat Feb 28 19:29:24 1998 CST	9.5	\N
2200	1	f	1347			Sat Feb 28 19:32:26 1998 CST	19.1	\N
2201	1	f	784			Sat Feb 28 19:37:33 1998 CST	15.9	\N
2202	1	f	1605			Sat Feb 28 19:38:55 1998 CST	20.6	\N
2203	1	f	645			Sat Feb 28 19:51:39 1998 CST	19	\N
2204	1	f	1079			Sat Feb 28 19:53:31 1998 CST	22.9	\N
2205	1	t	0		20.25	Sat Feb 28 20:12:24 1998 CST	51.599998	\N
2206	1	f	1606			Sat Feb 28 20:07:37 1998 CST	33.900002	\N
2207	1	f	1457			Sat Feb 28 20:08:02 1998 CST	18	\N
2208	1	f	1607			Sat Feb 28 20:25:38 1998 CST	14.2	\N
2209	1	t	0		20.55	Sat Feb 28 20:26:03 1998 CST	9.9	\N
2210	1	f	234			Sat Feb 28 20:28:48 1998 CST	21	\N
2211	1	f	498			Sat Feb 28 20:47:11 1998 CST	21.5	\N
2212	1	f	514			Sat Feb 28 20:50:36 1998 CST	19.9	\N
2213	1	f	1608			Sat Feb 28 20:54:53 1998 CST	22.5	\N
2214	1	f	1609			Sat Feb 28 21:04:00 1998 CST	24.4	\N
2215	1	f	86			Sat Feb 28 21:09:40 1998 CST	22.9	\N
2216	1	f	1610			Sat Feb 28 21:16:26 1998 CST	21	\N
2217	1	f	1611			Sat Feb 28 21:47:10 1998 CST	12.5	\N
2218	1	f	483			Sat Feb 28 22:03:54 1998 CST	32.099998	\N
2219	1	f	744			Sat Feb 28 22:20:57 1998 CST	28.1	\N
2220	1	f	1100			Sat Feb 28 22:24:56 1998 CST	14.9	\N
2221	1	f	279			Sat Feb 28 22:44:11 1998 CST	19.9	\N
2222	1	t	0		23.20	Sat Feb 28 22:48:31 1998 CST	6.9	\N
2223	1	f	1612			Sat Feb 28 23:15:40 1998 CST	17	\N
2224	1	f	713			Sat Feb 28 23:22:20 1998 CST	20	\N
2225	1	f	743			Sat Feb 28 23:44:10 1998 CST	22.5	\N
2226	1	f	640			Sat Feb 28 23:45:33 1998 CST	13.2	\N
2227	1	f	1410			Sun Mar 01 00:00:20 1998 CST	16.5	\N
2228	1	f	1613			Sun Mar 01 00:07:43 1998 CST	15.9	\N
2229	1	f	687			Sun Mar 01 00:20:44 1998 CST	18	\N
2230	1	f	440			Sun Mar 01 00:23:05 1998 CST	10.5	\N
2231	1	f	1459			Sun Mar 01 00:35:45 1998 CST	19	\N
2232	1	f	1203			Sun Mar 01 00:47:59 1998 CST	20.6	\N
2233	1	f	1614			Sun Mar 01 00:57:12 1998 CST	17	\N
2234	1	f	97			Sun Mar 01 01:00:46 1998 CST	17.200001	\N
2235	1	f	1113			Sun Mar 01 01:04:34 1998 CST	20	\N
2236	1	t	0		1.40	Sun Mar 01 01:11:01 1998 CST	9.9	\N
2237	1	f	1469			Sun Mar 01 01:26:00 1998 CST	16.6	\N
2238	1	f	1615			Sun Mar 01 01:41:17 1998 CST	27.200001	\N
2239	1	t	0		2.15	Sun Mar 01 01:43:19 1998 CST	6.9	\N
2240	1	f	692			Sun Mar 01 01:57:29 1998 CST	16.9	\N
2241	1	t	0		2.35	Sun Mar 01 02:05:08 1998 CST	6.9	\N
2242	1	f	1616			Sun Mar 01 02:13:06 1998 CST	18	\N
2243	1	t	0		2.50	Sun Mar 01 02:19:47 1998 CST	9.9	\N
2244	1	f	1617			Sun Mar 01 02:26:03 1998 CST	27.200001	\N
2245	1	f	1618			Sun Mar 01 02:45:26 1998 CST	20	\N
2246	1	f	166			Sun Mar 01 02:49:50 1998 CST	15.3	\N
2247	1	f	1078			Sun Mar 01 02:56:41 1998 CST	36	\N
2248	1	t	0		3.45	Sun Mar 01 03:14:41 1998 CST	14.9	\N
2249	1	f	114			Sun Mar 01 03:15:41 1998 CST	18	\N
2250	1	f	1619			Sun Mar 01 03:29:26 1998 CST	25.9	\N
2251	1	f	494			Sun Mar 01 03:32:23 1998 CST	12.5	\N
2252	1	f	1620			Sun Mar 01 03:34:25 1998 CST	21	\N
2253	1	f	223			Sun Mar 01 03:36:51 1998 CST	16.5	\N
2254	1	f	37			Sun Mar 01 03:39:16 1998 CST	15.9	\N
2255	1	f	1621			Sun Mar 01 04:17:25 1998 CST	15.6	\N
2256	1	f	711			Sun Mar 01 17:00:32 1998 CST	75.5	\N
2257	1	f	755			Sun Mar 01 17:06:35 1998 CST	17.299999	\N
2258	1	t	0		17.45	Sun Mar 01 17:15:56 1998 CST	6.9	\N
2259	1	t	0		17.50	Sun Mar 01 17:17:37 1998 CST	11	\N
2260	1	f	791			Sun Mar 01 17:51:16 1998 CST	16.6	\N
2261	1	f	888			Sun Mar 01 17:52:19 1998 CST	30.5	\N
2262	1	f	599			Sun Mar 01 18:00:01 1998 CST	13	\N
2263	1	t	0		18.45	Sun Mar 01 18:13:28 1998 CST	9.9	\N
2264	1	f	959			Sun Mar 01 18:20:52 1998 CST	15.9	\N
2265	1	f	1072			Sun Mar 01 18:25:49 1998 CST	10	\N
2266	1	f	1065			Sun Mar 01 18:31:07 1998 CST	21.9	\N
2267	1	f	1623			Sun Mar 01 18:32:59 1998 CST	10	\N
2268	1	f	1585			Sun Mar 01 18:45:05 1998 CST	15.5	\N
2269	1	f	1624			Sun Mar 01 18:46:58 1998 CST	17.6	\N
2270	1	f	432			Sun Mar 01 18:58:09 1998 CST	19.9	\N
2271	1	f	1108			Sun Mar 01 19:00:00 1998 CST	20.6	\N
2272	1	f	1067			Sun Mar 01 19:06:16 1998 CST	26.1	\N
2273	1	f	888			Sun Mar 01 19:10:26 1998 CST	11.7	\N
2274	1	f	670			Sun Mar 01 19:17:05 1998 CST	34	\N
2275	1	f	1625			Mon Mar 02 21:31:57 1998 CST	17.5	\N
2276	1	f	1626			Sun Mar 01 19:39:07 1998 CST	20	\N
2277	1	f	113			Sun Mar 01 19:48:13 1998 CST	17.799999	\N
2278	1	f	1051			Sun Mar 01 19:53:11 1998 CST	18.5	\N
2279	1	f	1021			Sun Mar 01 19:57:28 1998 CST	29	\N
2280	1	f	833			Sun Mar 01 19:58:49 1998 CST	20	\N
2281	1	f	792			Sun Mar 01 20:05:06 1998 CST	19.799999	\N
2282	1	f	905			Sun Mar 01 20:09:59 1998 CST	29.9	\N
2283	1	f	1512			Sun Mar 01 20:11:42 1998 CST	33.5	\N
2284	1	f	1219			Sun Mar 01 20:13:14 1998 CST	13.5	\N
2285	1	f	1627			Sun Mar 01 20:25:25 1998 CST	20	\N
2286	1	f	442			Sun Mar 01 20:31:31 1998 CST	19	\N
2287	1	f	1054			Sun Mar 01 20:47:38 1998 CST	16	\N
2288	1	t	0		21.50	Sun Mar 01 21:20:34 1998 CST	9.9	\N
2289	1	f	1628			Sun Mar 01 21:29:30 1998 CST	16.6	\N
2290	1	f	19			Sun Mar 01 21:55:28 1998 CST	24.5	\N
2291	1	f	865			Sun Mar 01 22:32:17 1998 CST	18	\N
2292	1	f	951			Sun Mar 01 22:34:44 1998 CST	15.5	\N
2293	1	f	338			Sun Mar 01 22:35:24 1998 CST	15.9	\N
2294	1	f	1460			Sun Mar 01 22:39:37 1998 CST	25.5	\N
2295	1	f	1629			Sun Mar 01 22:53:54 1998 CST	21	\N
2296	1	f	1152			Sun Mar 01 22:58:15 1998 CST	15.5	\N
2297	1	f	909			Sun Mar 01 23:03:57 1998 CST	12.9	\N
2298	1	f	1630			Sun Mar 01 23:07:17 1998 CST	24.5	\N
2299	1	f	320			Sun Mar 01 23:14:15 1998 CST	19.700001	\N
2300	1	f	917			Sun Mar 01 23:15:10 1998 CST	13.5	\N
2301	1	f	878			Sun Mar 01 23:56:52 1998 CST	15.9	\N
2302	1	f	1632			Mon Mar 02 00:27:07 1998 CST	17.5	\N
2303	1	f	1618			Mon Mar 02 00:28:46 1998 CST	23	\N
2304	1	f	715			Mon Mar 02 00:30:32 1998 CST	16.6	\N
2305	1	f	1633			Mon Mar 02 00:40:52 1998 CST	21	\N
2306	1	f	1390			Mon Mar 02 00:42:30 1998 CST	19	\N
2307	1	f	1634			Mon Mar 02 00:51:46 1998 CST	22.9	\N
2308	1	t	0		1.20	Mon Mar 02 00:48:10 1998 CST	10.6	\N
2309	1	f	1460			Mon Mar 02 01:00:38 1998 CST	19.799999	\N
2310	1	f	1635			Mon Mar 02 01:06:31 1998 CST	20	\N
2311	1	f	1052			Mon Mar 02 01:30:26 1998 CST	75	\N
2312	1	f	908			Mon Mar 02 01:47:10 1998 CST	15.5	\N
2313	1	f	1636			Mon Mar 02 02:05:56 1998 CST	17.5	\N
2314	1	f	1637			Mon Mar 02 02:22:44 1998 CST	17.4	\N
2315	1	f	537			Mon Mar 02 02:25:41 1998 CST	30.200001	\N
2316	1	t	0		2.55	Mon Mar 02 02:27:19 1998 CST	60	\N
2317	1	f	1638			Mon Mar 02 02:33:23 1998 CST	13.5	\N
2318	1	f	310			Mon Mar 02 04:02:37 1998 CST	21.6	\N
2319	1	f	1418			Mon Mar 02 17:33:58 1998 CST	26.4	\N
2320	1	f	1640			Mon Mar 02 17:45:04 1998 CST	13.5	\N
2321	1	f	1601			Mon Mar 02 18:12:47 1998 CST	16.5	\N
2322	1	f	1641			Mon Mar 02 18:13:59 1998 CST	20	\N
2323	1	f	269			Mon Mar 02 18:20:29 1998 CST	16.5	\N
2324	1	t	0		18.55	Mon Mar 02 18:23:41 1998 CST	10.6	\N
2325	1	f	1642			Mon Mar 02 19:19:36 1998 CST	21.5	\N
2326	1	f	1643			Mon Mar 02 19:23:54 1998 CST	19.9	\N
2327	1	f	797			Mon Mar 02 19:28:37 1998 CST	15.9	\N
2328	1	f	1644			Mon Mar 02 19:42:57 1998 CST	20.299999	\N
2329	1	t	0		20.20	Mon Mar 02 19:47:55 1998 CST	6.9	\N
2330	1	f	1519			Mon Mar 02 20:27:25 1998 CST	21	\N
2331	1	f	1281			Mon Mar 02 20:35:46 1998 CST	34	\N
2332	1	f	969			Mon Mar 02 20:45:03 1998 CST	22	\N
2333	1	f	68			Mon Mar 02 20:47:15 1998 CST	15.9	\N
2334	1	f	22			Mon Mar 02 20:49:48 1998 CST	16	\N
2335	1	f	1393			Mon Mar 02 21:05:28 1998 CST	15.6	\N
2336	1	f	1645			Mon Mar 02 21:27:11 1998 CST	12.5	\N
2337	1	f	1646			Mon Mar 02 21:52:34 1998 CST	14.2	\N
2338	1	f	1647			Mon Mar 02 22:00:30 1998 CST	18.5	\N
2339	1	f	338			Mon Mar 02 22:52:52 1998 CST	30.9	\N
2340	1	f	254			Mon Mar 02 23:08:29 1998 CST	19	\N
2341	1	t	0		23.50	Tue Mar 03 20:23:51 1998 CST	9.9	\N
2342	1	f	798			Mon Mar 02 23:26:32 1998 CST	23	\N
2343	1	f	1648			Mon Mar 02 23:35:36 1998 CST	22	\N
2344	1	f	1649			Mon Mar 02 23:56:45 1998 CST	17.1	\N
2345	1	t	0		0.40	Tue Mar 03 00:06:46 1998 CST	4	\N
2346	1	t	0	POLICE	0.55	Tue Mar 03 00:26:24 1998 CST	20	\N
2347	1	f	1650			Tue Mar 03 00:32:08 1998 CST	23	\N
2348	1	f	285			Tue Mar 03 00:34:05 1998 CST	22.5	\N
2349	1	t	0		1.10	Tue Mar 03 00:40:28 1998 CST	9.9	\N
2350	1	f	534			Tue Mar 03 00:45:31 1998 CST	18	\N
2351	1	t	0	POLICE	1.20	Tue Mar 03 00:48:42 1998 CST	7	\N
2352	1	f	1651			Tue Mar 03 00:52:52 1998 CST	17.5	\N
2353	1	f	355			Tue Mar 03 01:03:12 1998 CST	21.9	\N
2354	1	f	132			Tue Mar 03 01:09:48 1998 CST	30.5	\N
2355	1	f	711			Tue Mar 03 01:11:45 1998 CST	18	\N
2356	1	t	0		1.50	Tue Mar 03 01:16:22 1998 CST	9.9	\N
2357	1	f	1052			Tue Mar 03 01:35:09 1998 CST	14.85	\N
2358	1	f	21			Tue Mar 03 01:41:54 1998 CST	20.1	\N
2359	1	t	0		2.15	Tue Mar 03 01:45:06 1998 CST	11.3	\N
2360	1	f	711			Tue Mar 03 02:30:47 1998 CST	30.4	\N
2361	1	t	0	SOCRETES	4.00	Tue Mar 03 03:37:06 1998 CST	9.9	\N
2362	1	f	641			Tue Mar 03 18:05:12 1998 CST	20	\N
2363	1	t	0		19.05	Tue Mar 03 18:33:30 1998 CST	9.9	\N
2364	1	f	703			Tue Mar 03 18:41:40 1998 CST	37.5	\N
2365	1	f	969			Tue Mar 03 18:42:55 1998 CST	0	\N
2366	1	f	1653			Tue Mar 03 18:53:02 1998 CST	13.5	\N
2367	1	t	0		19.40	Tue Mar 03 19:10:44 1998 CST	12	\N
2368	1	f	1654			Tue Mar 03 19:14:40 1998 CST	17	\N
2369	1	f	784			Tue Mar 03 19:35:31 1998 CST	15.9	\N
2370	1	f	1655			Tue Mar 03 19:51:00 1998 CST	16	\N
2371	1	f	898			Tue Mar 03 20:04:56 1998 CST	17.5	\N
2372	1	f	903			Tue Mar 03 20:06:34 1998 CST	19.9	\N
2373	1	t	0		20.40	Tue Mar 03 20:09:48 1998 CST	6.9	\N
2374	1	f	1493			Tue Mar 03 20:27:53 1998 CST	16.9	\N
2375	1	t	0		21.00	Tue Mar 03 20:28:48 1998 CST	9.9	\N
2376	1	f	1477			Tue Mar 03 20:33:00 1998 CST	10	\N
2377	1	f	56			Tue Mar 03 20:37:29 1998 CST	33.400002	\N
2378	1	f	1656			Tue Mar 03 20:40:51 1998 CST	15.5	\N
2379	1	f	242			Tue Mar 03 20:41:43 1998 CST	19.9	\N
2380	1	f	1657			Tue Mar 03 20:45:09 1998 CST	23.9	\N
2381	1	f	6			Tue Mar 03 21:02:23 1998 CST	10	\N
2382	1	f	190			Tue Mar 03 21:06:53 1998 CST	25.65	\N
2383	1	f	922			Tue Mar 03 21:08:33 1998 CST	22.6	\N
2384	1	f	57			Tue Mar 03 21:11:18 1998 CST	22.9	\N
2385	1	f	1658			Tue Mar 03 21:15:18 1998 CST	18	\N
2386	1	f	514			Tue Mar 03 21:16:03 1998 CST	17	\N
2387	1	f	1494			Tue Mar 03 21:23:56 1998 CST	16.5	\N
2388	1	f	1019			Tue Mar 03 21:31:34 1998 CST	13.5	\N
2389	1	f	1512			Tue Mar 03 21:32:35 1998 CST	17.4	\N
2390	1	f	1257			Tue Mar 03 21:39:21 1998 CST	20	\N
2391	1	f	1659			Tue Mar 03 21:44:59 1998 CST	18	\N
2392	1	f	1660			Tue Mar 03 22:07:12 1998 CST	18	\N
2393	1	f	1539			Tue Mar 03 22:10:06 1998 CST	15.9	\N
2394	1	f	1661			Tue Mar 03 22:37:48 1998 CST	38.5	\N
2395	1	f	942			Tue Mar 03 22:44:48 1998 CST	16	\N
2396	1	f	21			Tue Mar 03 23:12:43 1998 CST	18	\N
2397	1	t	0		23.45	Tue Mar 03 23:13:04 1998 CST	6.9	\N
2398	1	f	1662			Tue Mar 03 23:27:16 1998 CST	20	\N
2399	1	f	494			Tue Mar 03 23:39:36 1998 CST	19.5	\N
2400	1	t	0	TOM	0.25	Tue Mar 03 23:53:04 1998 CST	11.5	\N
2401	1	f	1663			Wed Mar 04 00:04:36 1998 CST	26.5	\N
2402	1	t	0		0.40	Wed Mar 04 00:08:06 1998 CST	6.9	\N
2403	1	f	1664			Wed Mar 04 00:26:06 1998 CST	19.9	\N
2404	1	t	0		1.00	Wed Mar 04 00:28:59 1998 CST	10.6	\N
2405	1	t	0		1.05	Wed Mar 04 00:35:14 1998 CST	16.5	\N
2406	1	t	0		1.10	Wed Mar 04 00:37:12 1998 CST	9.9	\N
2407	1	f	1665			Wed Mar 04 00:54:33 1998 CST	15.5	\N
2408	1	f	1666			Wed Mar 04 01:14:59 1998 CST	20	\N
2409	1	f	6			Wed Mar 04 01:15:59 1998 CST	40	\N
2410	1	f	1667			Wed Mar 04 01:30:08 1998 CST	28	\N
2411	1	f	1668			Wed Mar 04 01:34:15 1998 CST	16.9	\N
2412	1	t	0		2.35	Wed Mar 04 02:06:15 1998 CST	9.9	\N
2413	1	f	712			Wed Mar 04 02:33:23 1998 CST	22	\N
2414	1	t	0		3.25	Wed Mar 04 02:53:42 1998 CST	6.9	\N
2415	1	f	711			Wed Mar 04 03:16:25 1998 CST	28.9	\N
2416	1	f	65			Wed Mar 04 03:51:19 1998 CST	16.9	\N
2417	1	f	580			Wed Mar 04 17:24:43 1998 CST	17.5	\N
2418	1	f	1669			Wed Mar 04 17:35:37 1998 CST	28.700001	\N
2419	1	f	1670			Wed Mar 04 17:51:15 1998 CST	25.5	\N
2420	1	f	1671			Wed Mar 04 17:56:05 1998 CST	31.5	\N
2421	1	f	123			Wed Mar 04 18:09:51 1998 CST	21.299999	\N
2422	1	f	29			Wed Mar 04 18:11:07 1998 CST	16.5	\N
2423	1	f	1143			Wed Mar 04 18:40:28 1998 CST	36.099998	\N
2424	1	f	1672			Wed Mar 04 19:13:18 1998 CST	13.5	\N
2425	1	f	434			Wed Mar 04 19:15:17 1998 CST	33	\N
2426	1	t	0		20.20	Wed Mar 04 19:50:38 1998 CST	9.9	\N
2427	1	f	917			Wed Mar 04 19:51:37 1998 CST	13.5	\N
2428	1	f	17			Wed Mar 04 20:00:57 1998 CST	16.6	\N
2429	1	t	0		20.35	Wed Mar 04 20:03:39 1998 CST	12.9	\N
2430	1	f	1317			Wed Mar 04 20:09:34 1998 CST	26	\N
2431	1	f	735			Wed Mar 04 20:14:25 1998 CST	18.5	\N
2432	1	f	224			Wed Mar 04 20:27:31 1998 CST	18	\N
2433	1	f	1625			Wed Mar 04 20:34:59 1998 CST	21	\N
2434	1	f	1019			Wed Mar 04 20:47:25 1998 CST	9.2	\N
2435	1	f	93			Wed Mar 04 20:55:37 1998 CST	21.5	\N
2436	1	f	1098			Wed Mar 04 21:01:20 1998 CST	25.799999	\N
2437	1	f	1673			Wed Mar 04 21:05:28 1998 CST	15.5	\N
2438	1	f	6			Wed Mar 04 21:48:19 1998 CST	22.5	\N
2439	1	f	1180			Wed Mar 04 21:54:27 1998 CST	15.9	\N
2440	1	t	0		22.30	Wed Mar 04 21:58:13 1998 CST	14.3	\N
2441	1	f	113			Wed Mar 04 22:04:58 1998 CST	14.2	\N
2442	1	f	1353			Wed Mar 04 22:14:20 1998 CST	15.4	\N
2443	1	f	6			Wed Mar 04 22:17:40 1998 CST	16	\N
2444	1	f	1674			Wed Mar 04 22:57:31 1998 CST	19.9	\N
2445	1	f	1675			Wed Mar 04 23:06:27 1998 CST	17	\N
2446	1	f	255			Wed Mar 04 23:13:22 1998 CST	19.9	\N
2447	1	f	1183			Wed Mar 04 23:16:44 1998 CST	16.200001	\N
2448	1	f	1676			Wed Mar 04 23:23:26 1998 CST	27.9	\N
2449	1	f	241			Wed Mar 04 23:33:52 1998 CST	15.9	\N
2450	1	t	0		0.05	Wed Mar 04 23:34:22 1998 CST	12.9	\N
2451	1	f	1006			Thu Mar 05 00:13:34 1998 CST	15.9	\N
2452	1	f	1677			Thu Mar 05 00:27:03 1998 CST	13	\N
2453	1	t	0		1.05	Thu Mar 05 00:32:05 1998 CST	6.9	\N
2454	1	t	0		1.15	Thu Mar 05 00:44:30 1998 CST	6.9	\N
2455	1	f	254			Thu Mar 05 00:49:25 1998 CST	26.6	\N
2456	1	f	540			Thu Mar 05 00:51:03 1998 CST	16.6	\N
2457	1	f	212			Thu Mar 05 00:55:13 1998 CST	17.5	\N
2458	1	f	1625			Thu Mar 05 01:04:51 1998 CST	15.9	\N
2459	1	f	1325			Thu Mar 05 01:19:10 1998 CST	20	\N
2460	1	f	1679			Thu Mar 05 01:21:34 1998 CST	39	\N
2461	1	t	0		1.55	Thu Mar 05 01:24:15 1998 CST	18.9	\N
2462	1	f	599			Thu Mar 05 01:28:31 1998 CST	9	\N
2463	1	t	0		2.00	Thu Mar 05 01:30:01 1998 CST	24.9	\N
2464	1	f	1680			Thu Mar 05 01:33:25 1998 CST	16.6	\N
2465	1	f	1447			Thu Mar 05 01:37:23 1998 CST	16.6	\N
2466	1	t	0		2.30	Thu Mar 05 01:59:23 1998 CST	13.9	\N
2467	1	f	1681			Thu Mar 05 02:03:19 1998 CST	24	\N
2468	1	f	1052			Thu Mar 05 02:05:17 1998 CST	17.200001	\N
2469	1	f	1682			Thu Mar 05 02:06:45 1998 CST	16	\N
2470	1	f	995			Thu Mar 05 02:09:27 1998 CST	21	\N
2471	1	f	1683			Thu Mar 05 02:30:19 1998 CST	17.5	\N
2472	1	f	1684			Thu Mar 05 02:56:43 1998 CST	34.700001	\N
2473	1	f	1685			Thu Mar 05 02:50:42 1998 CST	16.5	\N
2474	1	f	1100			Thu Mar 05 02:59:20 1998 CST	25.9	\N
2475	1	f	1099			Thu Mar 05 03:23:08 1998 CST	23.85	\N
2476	1	f	1686			Thu Mar 05 03:40:07 1998 CST	23.200001	\N
2477	1	f	1687			Thu Mar 05 04:14:09 1998 CST	15.5	\N
2478	1	f	1257			Thu Mar 05 17:06:32 1998 CST	16	\N
2479	1	f	1156			Thu Mar 05 17:40:09 1998 CST	26.9	\N
2480	1	f	1688			Thu Mar 05 17:53:32 1998 CST	21	\N
2481	1	f	1640			Thu Mar 05 17:59:19 1998 CST	14	\N
2482	1	f	1277			Thu Mar 05 18:05:06 1998 CST	13.5	\N
2483	1	f	435			Thu Mar 05 18:21:45 1998 CST	20	\N
2484	1	t	0		19.05	Thu Mar 05 18:31:51 1998 CST	12.9	\N
2485	1	f	797			Thu Mar 05 18:51:46 1998 CST	15.9	\N
2486	1	f	1294			Thu Mar 05 18:55:25 1998 CST	20	\N
2487	1	f	234			Thu Mar 05 18:57:35 1998 CST	15.9	\N
2488	1	f	969			Thu Mar 05 19:08:00 1998 CST	11.5	\N
2489	1	f	1019			Thu Mar 05 19:41:21 1998 CST	11.7	\N
2490	1	f	1689			Thu Mar 05 19:48:13 1998 CST	27.9	\N
2491	1	f	1673			Thu Mar 05 19:54:22 1998 CST	27.5	\N
2492	1	f	917			Thu Mar 05 19:56:32 1998 CST	11	\N
2493	1	t	0		20.35	Thu Mar 05 20:01:37 1998 CST	13	\N
2494	1	f	1690			Thu Mar 05 20:06:22 1998 CST	9.5	\N
2495	1	f	1691			Thu Mar 05 20:10:55 1998 CST	28.9	\N
2496	1	f	1625			Thu Mar 05 20:12:14 1998 CST	21	\N
2497	1	f	765			Thu Mar 05 20:18:57 1998 CST	21	\N
2498	1	t	0		21.00	Thu Mar 05 20:27:33 1998 CST	9.5	\N
2499	1	f	1692			Thu Mar 05 20:33:22 1998 CST	16.200001	\N
2500	1	f	794			Thu Mar 05 20:41:48 1998 CST	35.599998	\N
2501	1	f	1460			Thu Mar 05 20:48:53 1998 CST	39	\N
2502	1	f	514			Thu Mar 05 20:52:35 1998 CST	23.4	\N
2503	1	f	1238			Thu Mar 05 20:58:12 1998 CST	51.799999	\N
2504	1	f	1019			Thu Mar 05 20:59:26 1998 CST	30.200001	\N
2505	1	f	939			Thu Mar 05 21:02:38 1998 CST	20	\N
2506	1	f	1037			Thu Mar 05 21:18:14 1998 CST	25.299999	\N
2507	1	f	1558			Thu Mar 05 21:35:50 1998 CST	27.5	\N
2508	1	f	1368			Thu Mar 05 21:37:16 1998 CST	32.099998	\N
2509	1	f	1612			Thu Mar 05 21:40:05 1998 CST	20	\N
2510	1	f	447			Thu Mar 05 21:41:28 1998 CST	17	\N
2511	1	f	1693			Thu Mar 05 22:10:58 1998 CST	21.5	\N
2512	1	t	0		22.45	Thu Mar 05 22:12:01 1998 CST	8.6	\N
2513	1	f	348			Thu Mar 05 22:28:59 1998 CST	14.2	\N
2514	1	f	483			Thu Mar 05 22:52:11 1998 CST	35.5	\N
2515	1	f	1694			Thu Mar 05 22:53:15 1998 CST	23.5	\N
2516	1	f	1695			Thu Mar 05 23:23:35 1998 CST	24.9	\N
2517	1	t	0		0.15	Thu Mar 05 23:41:23 1998 CST	11.3	\N
2518	1	f	1390			Thu Mar 05 23:49:33 1998 CST	22	\N
2519	1	f	1618			Fri Mar 06 00:43:20 1998 CST	17	\N
2520	1	f	449			Fri Mar 06 00:44:11 1998 CST	23	\N
2521	1	f	1696			Fri Mar 06 00:59:27 1998 CST	19	\N
2522	1	f	1697			Fri Mar 06 01:03:48 1998 CST	16.9	\N
2523	1	f	1698			Fri Mar 06 01:08:49 1998 CST	22.200001	\N
2524	1	f	355			Fri Mar 06 01:12:40 1998 CST	31.5	\N
2525	1	f	1410			Fri Mar 06 01:16:44 1998 CST	15.9	\N
2526	1	f	1052			Fri Mar 06 01:20:49 1998 CST	24.299999	\N
2527	1	f	1699			Fri Mar 06 01:26:51 1998 CST	21	\N
2528	1	f	1682			Fri Mar 06 01:38:15 1998 CST	18.5	\N
2529	1	t	0		2.15	Fri Mar 06 01:44:14 1998 CST	9.5	\N
2530	1	f	724			Fri Mar 06 02:09:50 1998 CST	18	\N
2531	1	t	0		2.45	Fri Mar 06 02:13:21 1998 CST	12	\N
2532	1	t	0		2.45	Fri Mar 06 02:14:17 1998 CST	16.4	\N
2533	1	f	1700			Fri Mar 06 02:26:40 1998 CST	14	\N
2534	1	f	1701			Fri Mar 06 03:04:35 1998 CST	21	\N
2535	1	f	923			Fri Mar 06 03:22:03 1998 CST	9.5	\N
2536	1	f	711			Fri Mar 06 03:27:49 1998 CST	19	\N
2537	1	f	1702			Fri Mar 06 03:37:29 1998 CST	14.2	\N
2538	1	t	0		17.30	Fri Mar 06 16:58:50 1998 CST	9.9	\N
2539	1	f	1081			Fri Mar 06 17:10:18 1998 CST	17.299999	\N
2540	1	t	0		17.55	Fri Mar 06 17:25:42 1998 CST	14.9	\N
2541	1	f	1704			Fri Mar 06 17:27:05 1998 CST	38.900002	\N
2542	1	f	544			Fri Mar 06 17:31:08 1998 CST	15.9	\N
2543	1	f	674			Fri Mar 06 17:49:24 1998 CST	15.5	\N
2544	1	f	1705			Fri Mar 06 18:18:24 1998 CST	20	\N
2545	1	t	0		19.00	Fri Mar 06 18:31:04 1998 CST	19.9	\N
2546	1	f	1009			Fri Mar 06 18:34:03 1998 CST	17	\N
2547	1	f	397			Fri Mar 06 18:37:31 1998 CST	28	\N
2548	1	f	1706			Fri Mar 06 18:49:24 1998 CST	21	\N
2549	1	f	1707			Fri Mar 06 18:56:04 1998 CST	26	\N
2550	1	t	0		19.30	Fri Mar 06 18:57:49 1998 CST	12.9	\N
2551	1	f	1347			Fri Mar 06 19:10:38 1998 CST	21.6	\N
2552	1	f	1493			Fri Mar 06 19:24:03 1998 CST	15.9	\N
2553	1	t	0		20.00	Fri Mar 06 19:28:21 1998 CST	12.9	\N
2554	1	t	0		20.05	Fri Mar 06 19:33:23 1998 CST	9.9	\N
2555	1	f	1015			Fri Mar 06 19:53:31 1998 CST	20	\N
2556	1	f	1708			Fri Mar 06 19:57:10 1998 CST	25.9	\N
2557	1	f	429			Fri Mar 06 19:58:23 1998 CST	14	\N
2558	1	t	0		20.35	Fri Mar 06 20:02:27 1998 CST	16.5	\N
2559	1	f	754			Fri Mar 06 20:05:31 1998 CST	15	\N
2560	1	t	0		20.40	Fri Mar 06 20:10:22 1998 CST	9.9	\N
2561	1	f	212			Fri Mar 06 20:11:12 1998 CST	18	\N
2562	1	t	0		20.50	Fri Mar 06 20:20:50 1998 CST	6.9	\N
2563	1	f	1180			Fri Mar 06 20:24:11 1998 CST	18.4	\N
2564	1	t	0		21.05	Fri Mar 06 20:34:20 1998 CST	12.9	\N
2565	1	f	1353			Fri Mar 06 20:44:24 1998 CST	14.4	\N
2566	1	f	1709			Fri Mar 06 21:03:48 1998 CST	17.700001	\N
2567	1	f	942			Fri Mar 06 21:15:09 1998 CST	25.5	\N
2568	1	f	68			Fri Mar 06 21:16:55 1998 CST	15.9	\N
2569	1	f	483			Fri Mar 06 21:37:39 1998 CST	16.200001	\N
2570	1	f	955			Fri Mar 06 21:40:52 1998 CST	16.200001	\N
2571	1	t	0		22.35	Fri Mar 06 22:02:30 1998 CST	2	\N
2572	1	f	1710			Fri Mar 06 22:13:43 1998 CST	25.9	\N
2573	1	t	0		23.20	Fri Mar 06 22:52:04 1998 CST	6.9	\N
2574	1	f	1711			Fri Mar 06 23:21:18 1998 CST	21	\N
2575	1	f	1052			Fri Mar 06 23:24:25 1998 CST	9.5	\N
2576	1	f	1353			Fri Mar 06 23:47:12 1998 CST	23.049999	\N
2577	1	f	773			Fri Mar 06 23:59:30 1998 CST	15.9	\N
2578	1	f	923			Sat Mar 07 00:02:56 1998 CST	10	\N
2579	1	f	215			Sat Mar 07 00:04:55 1998 CST	15.5	\N
2580	1	f	1712			Sat Mar 07 00:07:16 1998 CST	19.9	\N
2581	1	f	19			Sat Mar 07 00:09:15 1998 CST	21	\N
2582	1	f	668			Sat Mar 07 00:38:46 1998 CST	20.6	\N
2583	1	f	1019			Sat Mar 07 00:40:58 1998 CST	10.8	\N
2584	1	f	1713			Sat Mar 07 00:46:30 1998 CST	26.200001	\N
2585	1	f	880			Sat Mar 07 01:05:22 1998 CST	18.5	\N
2586	1	f	729			Sat Mar 07 01:07:25 1998 CST	15	\N
2587	1	f	1714			Sat Mar 07 01:09:09 1998 CST	18	\N
2588	1	f	1441			Sat Mar 07 01:11:55 1998 CST	35.5	\N
2589	1	f	1715			Sat Mar 07 01:13:35 1998 CST	20.5	\N
2590	1	f	1716			Sat Mar 07 01:37:54 1998 CST	16.9	\N
2591	1	f	1664			Sat Mar 07 01:21:58 1998 CST	20.6	\N
2592	1	f	1717			Sat Mar 07 01:25:50 1998 CST	24.9	\N
2593	1	f	1006			Sat Mar 07 01:29:36 1998 CST	15.9	\N
2594	1	f	1078			Sat Mar 07 01:31:12 1998 CST	33	\N
2595	1	f	1541			Sat Mar 07 01:48:01 1998 CST	27.5	\N
2596	1	f	1718			Sat Mar 07 01:54:01 1998 CST	16.200001	\N
2597	1	f	1719			Sat Mar 07 02:11:51 1998 CST	22	\N
2598	1	f	190			Sat Mar 07 02:32:19 1998 CST	12.95	\N
2599	1	f	1720			Sat Mar 07 02:49:47 1998 CST	18	\N
2600	1	t	0		3.25	Sat Mar 07 02:52:38 1998 CST	25.799999	\N
2601	1	f	1460			Sat Mar 07 02:55:46 1998 CST	21	\N
2602	1	f	163			Sat Mar 07 03:02:04 1998 CST	19.9	\N
2603	1	f	1206			Sat Mar 07 03:06:25 1998 CST	34.299999	\N
2604	1	f	764			Sat Mar 07 03:10:28 1998 CST	27.9	\N
2605	1	t	0		3.45	Sat Mar 07 03:15:30 1998 CST	14.3	\N
2606	1	f	1126			Sat Mar 07 03:28:53 1998 CST	12	\N
2607	1	f	1722			Sat Mar 07 03:31:34 1998 CST	18	\N
2608	1	f	1723			Sat Mar 07 04:02:48 1998 CST	12.2	\N
2609	1	f	163			Sat Mar 07 04:06:15 1998 CST	18	\N
2610	1	f	1248			Sat Mar 07 04:13:16 1998 CST	21.299999	\N
2611	1	t	0		16.00	Sat Mar 07 15:28:50 1998 CST	12.9	\N
2612	1	f	880			Sat Mar 07 16:29:23 1998 CST	25.9	\N
2613	1	f	1583			Sat Mar 07 17:22:52 1998 CST	16	\N
2614	1	f	224			Sat Mar 07 17:38:33 1998 CST	20	\N
2615	1	f	789			Sat Mar 07 17:43:45 1998 CST	19.9	\N
2616	1	f	1512			Sat Mar 07 18:04:55 1998 CST	48.700001	\N
2617	1	f	1370			Sat Mar 07 18:13:01 1998 CST	28	\N
2618	1	f	235			Sat Mar 07 18:19:56 1998 CST	40.5	\N
2620	1	f	242			Sat Mar 07 18:22:29 1998 CST	20	\N
2621	1	f	1724			Sat Mar 07 18:31:20 1998 CST	15.5	\N
2622	1	f	84			Sat Mar 07 18:32:14 1998 CST	32.400002	\N
2623	1	f	1725			Sat Mar 07 18:59:01 1998 CST	15.9	\N
2624	1	f	702			Sat Mar 07 18:55:17 1998 CST	23	\N
2625	1	f	1191			Sat Mar 07 18:58:10 1998 CST	30	\N
2626	1	f	1726			Sat Mar 07 19:00:04 1998 CST	19.9	\N
2627	1	f	833			Sat Mar 07 19:04:48 1998 CST	25.9	\N
2628	1	f	1318			Sat Mar 07 19:22:11 1998 CST	20	\N
2629	1	f	380			Sat Mar 07 19:24:27 1998 CST	26	\N
2630	1	f	927			Sat Mar 07 19:44:07 1998 CST	19.9	\N
2631	1	t	0		20.20	Sat Mar 07 19:47:20 1998 CST	11	\N
2632	1	t	0		20.25	Sat Mar 07 19:54:53 1998 CST	15	\N
2633	1	f	1609			Sat Mar 07 20:02:34 1998 CST	23.4	\N
2634	1	f	56			Sat Mar 07 20:09:50 1998 CST	27	\N
2635	1	f	1727			Sat Mar 07 20:37:47 1998 CST	15.9	\N
2636	1	f	1025			Sat Mar 07 20:48:18 1998 CST	16.6	\N
2637	1	f	1650			Sat Mar 07 20:59:20 1998 CST	36	\N
2638	1	f	695			Sat Mar 07 21:51:57 1998 CST	19.9	\N
2639	1	f	586			Sat Mar 07 22:11:28 1998 CST	68	\N
2640	1	f	18			Sat Mar 07 22:14:44 1998 CST	29	\N
2641	1	f	1140			Sat Mar 07 22:55:03 1998 CST	16.9	\N
2642	1	f	901			Sat Mar 07 22:59:42 1998 CST	9.5	\N
2643	1	f	1728			Sat Mar 07 23:04:56 1998 CST	43.599998	\N
2644	1	t	0		23.45	Sat Mar 07 23:14:42 1998 CST	10.5	\N
2645	1	f	1729			Sun Mar 08 00:29:22 1998 CST	18	\N
2646	1	f	14			Sun Mar 08 00:36:47 1998 CST	24	\N
2647	1	f	1203			Sun Mar 08 00:38:53 1998 CST	19.9	\N
2648	1	f	454			Sun Mar 08 00:54:01 1998 CST	19.9	\N
2649	1	f	1727			Sun Mar 08 00:57:38 1998 CST	25.4	\N
2650	1	f	1460			Sun Mar 08 01:00:17 1998 CST	46.200001	\N
2651	1	f	1019			Sun Mar 08 01:01:23 1998 CST	21.6	\N
2652	1	f	1730			Sun Mar 08 01:12:51 1998 CST	25.9	\N
2653	1	f	1731			Sun Mar 08 01:14:53 1998 CST	15	\N
2654	1	f	1732			Sun Mar 08 01:15:38 1998 CST	17.5	\N
2655	1	f	1733			Sun Mar 08 01:30:13 1998 CST	25.9	\N
2656	1	f	1491			Sun Mar 08 01:46:43 1998 CST	18	\N
2657	1	f	1588			Sun Mar 08 01:49:18 1998 CST	24.5	\N
2658	1	f	1734			Sun Mar 08 02:16:40 1998 CST	13.5	\N
2659	1	f	942			Sun Mar 08 02:19:58 1998 CST	18.5	\N
2661	1	f	1249			Sun Mar 08 02:29:21 1998 CST	29.5	\N
2662	1	t	0		3.00	Sun Mar 08 02:30:03 1998 CST	9.9	\N
2663	1	t	0		3.10	Sun Mar 08 02:36:30 1998 CST	9.9	\N
2665	1	t	0		3.15	Sun Mar 08 02:45:18 1998 CST	9.9	\N
2666	1	t	0		3.20	Sun Mar 08 02:47:26 1998 CST	12.9	\N
2667	1	f	1735			Sun Mar 08 03:09:18 1998 CST	16	\N
2668	1	f	1736			Sun Mar 08 03:20:06 1998 CST	19.9	\N
2669	1	f	1737			Sun Mar 08 03:28:14 1998 CST	15.5	\N
2670	1	f	978			Sun Mar 08 03:31:04 1998 CST	22.9	\N
2671	1	t	0		4.10	Sun Mar 08 03:36:21 1998 CST	12.9	\N
2672	1	f	1738			Sun Mar 08 03:45:59 1998 CST	18	\N
2674	1	t	0		5.05	Sun Mar 08 04:32:26 1998 CST	12.9	\N
2675	1	t	0		13.15	Sun Mar 08 12:42:36 1998 CST	8.6	\N
2678	1	f	1740			Fri May 15 02:33:50 1998 CST	50	\N
2619	1	f	277			Sat Mar 07 18:21:04 1998 CST	61	\N
2664	1	f	951			Sun Mar 08 02:39:03 1998 CST	15	\N
1564	1	f	951			Tue Feb 17 00:06:55 1998 CST	15	\N
1145	1	f	951			Sun Feb 08 23:26:32 1998 CST	15	\N
2660	1	f	1052			Sun Mar 08 02:28:40 1998 CST	100	\N
2677	1	f	1740			Fri May 15 02:17:08 1998 CST	43.5	\N
2673	1	f	1739		5.05	Sun Mar 08 04:09:03 1998 CST	38.5	\N
\.
COPY ordet FROM stdin;
337	3	+	+	1	0.5	1
578	7	+	+	0	0.1	1
716	2	HAW	1/2 HAWAIIN	1	0	1
888	3	GB	Garlic Bread	1	2	1
999	1	F	FAM	1	18	1
1146	3	NO	NoTOM	1	0	1
1199	4	FSU	Family Supreme	1	18	1
1365	4	COKE	1.25 Ltr Coke	1	3	1
1473	1	SMX	Small Mexican	1	9.5	1
1571	2	2L	2 Large Pizzas	1	19.9	1
1706	3	GB	Garlic Bread	1	2	1
1747	1	F	FAM	1	18	1
2308	1	PLG	LARGE PICK-UP	1	9.9	1
1	1	FHW	Family Hawiian	2	33	1
1	2	FX	Family Extra - anchovies,olives,chilli,sun dried tomatoes,artichokes,capsicum,salami,paprika,tabasco sauce,egg	10	10	1
1	3	2COKE	2 Ltr Coke	1	3	1
5	1	FHW	Family Hawiian	1	16.5	1
5	2	HALF	1/2 special	0	0	1
5	3	LX	+ sal on 1/4	1	0.7	1
8	1	FHW	Family Hawiian	0.75	12.37	1
8	2	FX	EXTRA olives	1	1	1
8	3	LMX	Large Mexican	1	13	1
8	4	HALF	1/2 special	1	0	1
8	5	COKE	1.25 Ltr Coke	1	3	1
8	6	CIG	Cigarettes - B&H extra mild	1	8	1
8	7	EGP	Entree Garlic Prawns	2	21	1
10	1	SD	Soup of the Day	1	4.5	1
10	2	MGW	Main Grilled Whiting	1	15	1
10	3	AP	Main Alla Panna	1	10	1
10	4	FS	French Salad	1	4	1
11	1	FHW	Family Hawiian	1	16.5	1
13	1	STD	Steak Dianne MED	1	15	1
13	2	ELA	Entree Lasagna	1	7.5	1
14	1	DCC	Cheese Cake	1	3.5	1
15	1	SSP	Small Special-OL + CHILLI	0.5	4.5	1
16	1	FVG	Family Vegetarian	1	17	1
16	2	FX	EXTRA olives	1	1	1
16	3	STD	Steak Dianne	1	15	1
16	4	STDWD	Steak Dianne - Well Done	1	15	1
16	5	STFMR	Fillet Mignon - Md Rare	1	17	1
16	6	STPR	Pepper Steak - Rare	1	15	1
16	7	CHIPS	Chips	1	3.5	1
17	1	CHIPS	Chips	1	3.5	1
18	1	SMA	Small Margherita	1	8	1
18	2	LMA	Macaroni Marinara	1	11.5	1
18	3	LSE	Large Seafood	1	13.5	1
19	1	LMA	Large Margherita	1	11.5	1
20	1	LMA	Large Margherita	1	11.5	1
20	2	CPKE		0	0	1
21	1	STPMW	Pepper Steak - Md Well Done	1	15	1
22	1	STPMW	Pepper Steak - Md Well Done	1	15	1
23	1	FHW	Family Hawiian	1	16.5	1
23	2	FX	EXTRA pineapple	1	1	1
24	1	CHF	Chicken Fillets	1	14	1
25	1	CHF	Chicken Fillets	1	14	1
26	1	2L	2 Large Pizzas	1	19.9	1
26	2	LSP	Large Special	0	0	1
26	3	LSP	Large Special	0	0	1
27	1	FV	Family Vegetarian	1	17	1
28	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
28	2	FVG	Family Vegetarian	0	0	1
29	1	CR	Calzone Rustico	1	10.5	1
29	2	SX	EXTRA PIN	1	0.5	1
29	3	GB	Garlic Bread	1	2	1
30	1	CR	Calzone Rustico	3	31.5	1
30	2	FSU	Family Supreme-ANC	1	18	1
30	3	HALF	1/2 CHICKEN HAWW	1	0	1
31	1	ELA	Entree Lasagna	1	7.5	1
31	2	SAP	Small Margherita	1	10	1
32	1	PFM	FAMILY PICK-UP	1	12.9	1
32	2	FHW	Family Hawiian	0	0	1
32	3	GB	Garlic Bread	1	2	1
32	4	00		0	0	1
33	1	SMA	Small Margherita	1	8	1
33	2	LMA	Large Margherita	1	11.5	1
33	3	FMA	Family Margherita	1	15	1
33	4	SAU	Small Australian	1	8.5	1
33	5	LAU	Large Australian	1	12	1
33	6	FAU	Family Australian	1	16	1
33	7	SAM	Small American	1	9	1
33	8	LAM	Large American	1	12.5	1
33	9	FAM	Family American	1	16.5	1
33	10	SHW	Small Hawiian	1	9	1
33	11	LHW	Large Hawiian	1	12.5	1
33	12	FHW	Family Hawiian	1	16.5	1
34	1	SCP	Small Capriciosa	1	9	1
34	2	LCP	Large Capriciosa	1	12.5	1
34	3	FCP	Family Capriciosa	1	17	1
34	4	SSP	Small Special	1	9	1
34	5	LSP	Large Special	1	12.5	1
34	6	FSP	Family Special	1	17	1
34	7	SVG	Small Vegetarian	1	9	1
34	8	LVG	Large Vegetarian	1	12.5	1
34	9	FVG	Family Vegetarian	1	17	1
34	10	SML	Small Meat Lovers	1	9.5	1
34	11	LML	Large Meat Lovers	1	13	1
34	12	FML	Family Meat Lovers	1	17.5	1
35	1	SMX	Small Mexican	1	9.5	1
35	2	LMX	Large Mexican	1	13	1
35	3	FMX	Family Mexican	1	17.5	1
35	4	SSG	Small SanGiorgio	1	9.5	1
35	5	LSG	Large SanGiorgio	1	13.5	1
35	6	FSG	Family SanGiorgio	1	18	1
35	7	SCH	Small Chicken Hawiian	1	9.5	1
35	8	LCH	Large Chicken Hawiian	1	13	1
35	9	FCH	Family Chicken Hawiian	1	17.5	1
35	10	SSE	Small Seafood	1	9.5	1
35	11	LSE	Large Seafood	1	13.5	1
35	12	FSE	Family Seafood	1	18	1
36	1	SSU	Small Supreme	1	9.5	1
36	2	LSU	Large Supreme	1	13.5	1
36	3	FSU	Family Supreme	1	18	1
36	4	GB	Garlic Bread	1	2	1
36	5	HB	Herb Bread	1	2	1
36	6	CBR	Continental Bread (3 peices)	1	0.6	1
36	7	BBQ	BBQ Sauce	1	1	1
36	8	SX	EXTRA	1	0.5	1
36	9	LX	EXTRA	1	0.7	1
36	10	FX	EXTRA	1	1	1
36	11	CR	Calzone Rustico	1	10.5	1
36	12	CV	Calzone Vegetarian	1	10.5	1
37	1	SMA	Small Margherita	1	8	1
37	2	ESMA	Entree Spaghetti Marinara	1	9	1
37	3	RMA	Ravioli Marinara	1	11.5	1
37	4	ERMA	Entree Ravioli Marinara	1	9	1
37	5	MMA	Macaroni Marinara	1	11.5	1
37	6	EMMA	Entree Macaroni Marinara	1	9	1
37	7	TMA	Tortellini Marinara	1	11.5	1
37	8	CMA	Ricotta Ravioli Marinara	1	11.5	1
37	9	SAP	Spaghetti Alla Panna	1	10	1
37	10	FAP	Fettucini Alla Panna	1	10	1
37	11	RAP	Ravioli Alla Panna	1	10	1
37	12	MAP	Macaroni Alla Panna	1	10	1
38	1	TAP	Tortellini Alla Panna	1	10	1
38	2	CAP	Ricotta Ravioli Alla Panna	1	10	1
38	3	SCB	Spaghetti Carbonara	1	10	1
38	4	FCB	Fettucini Carbonara	1	10	1
38	5	RCB	Ravioli Carbonara	1	10	1
38	6	TCB	Tortellini Carbonara	1	10	1
38	7	CCB	Ricotta Ravioli Carbonara	1	10	1
38	8	MCB	Macaroni Carbonara	1	10	1
38	9	SPU	Spaghetti Putanesca	1	9.5	1
38	10	FPU	Fettucini Putanesca	1	9.5	1
38	11	TPU	Tortellini Putanesca	1	9.5	1
38	12	RPU	Ravioli Putanesca	1	9.5	1
39	1	MPU	Macaroni Putanesca	1	9.5	1
39	2	CPU	Ricotta Ravioli Putanesca	1	9.5	1
39	3	SBO	Spaghetti Bolognese	1	9.5	1
39	4	FBO	Fettucini Bolognese	1	9.5	1
39	5	MBO	Macaroni Bolognese	1	9.5	1
39	6	RBO	Ravioli Bolognese	1	9.5	1
39	7	CBO	Ricotta Ravioli Bolognese	1	9.5	1
39	8	TBO	Tortellini Bolognese	1	9.5	1
39	9	RVG	Ravioli Vegetarian	1	9.5	1
39	10	TVG	Tortellini Vegetarian	1	9.5	1
39	11	MVG	Macaroni Vegetarian	1	9.5	1
39	12	CVG	Ricotta Ravioli Vegetarian	1	9.5	1
40	1	SNA	Spaghetti Napolitana	1	9	1
40	2	FNA	Fettucini Napolitana	1	9	1
40	3	RNA	Ravioli Napolitana	1	9	1
40	4	TNA	Tortellini Napolitana	1	9	1
40	5	CNA	Ricotta Ravioli Napolitana	1	9	1
40	6	MNA	Macaroni Napolitana	1	9	1
40	7	SAL	Spaghetti Alfredo	1	9	1
40	8	FAL	Fettucini Alfredo	1	9	1
40	9	MAL	Macaroni Alfredo	1	9	1
40	10	RAL	Ravioli Alfredo	1	9	1
40	11	CAL	Ricotta Ravioli Alfredo	1	9	1
40	12	TAL	Tortellini Alfredo	1	9	1
41	1	STDMR	Steak Dianne - Md Rare	1	15	1
41	2	STDMW	Steak Dianne - Md Well Done	1	15	1
41	3	STDWD	Steak Dianne - Well Done	1	15	1
41	4	STDR	Steak Dianne - Rare	1	15	1
41	5	STPR	Pepper Steak - Rare	1	15	1
41	6	STPMR	Pepper Steak - Md Rare	1	15	1
41	7	STPMW	Pepper Steak - Md Well Done	1	15	1
41	8	STPWD	Pepper Steak - Well Done	1	15	1
41	9	STRR	Rump Steak - Rare	1	13	1
41	10	STRMR	Rump Steak - Md Rare	1	13	1
41	11	STRMW	Rump Steak - Md Well Done	1	13	1
41	12	STRWD	Rump Steak - Well Done	1	13	1
42	1	STVP	Veal Parmigiana	1	14	1
42	2	STMS	Scaloppina Mushroom	1	11.5	1
42	3	STSZ	Scaloppina Zingara	1	11.5	1
42	4	STSB	Scaloppina Bianco	1	10.5	1
42	5	STSM	Scaloppina Marsala	1	10.5	1
42	6	STSH	Schnitzel	1	10.5	1
42	7	CHF	Chicken Fillets	1	14	1
42	8	CHAV	Chicken Avocado	1	14	1
43	1	FSU	Family Supreme	1	18	1
43	2	FX	EXTRA cheese pin on	1	1	1
43	3	HALF	1/2 + pepp	1	0	1
43	4	CCOKE	Can of Coke	1	1.2	1
44	1	CHAS	Chicken Asparagus	1	14	1
44	2	CHHW	Chicken Hawiian	1	14	1
44	3	CHGR	Grilled Chicken	1	13	1
44	4	CHCS	Chef's Salad	1	13	1
44	5	GRAVY	Gravy for chicken	1	2	1
44	6	CHMS	Mushroom Sauce	1	2	1
44	7	EGW	Entree Grilled Whiting	1	9	1
44	8	MGW	Main Grilled Whiting	1	15	1
44	9	EFW	Entree Fried Whiting	1	9	1
44	10	MFW	Main Fried Whiting	1	15	1
44	11	EFC	Entree Fried Calamari	1	8.5	1
44	12	MFC	Main Fried Calamari	1	13.5	1
45	1	EFP	Entree Fried Prawns	1	10	1
45	2	MFP	Main Fried Prawns	1	16	1
45	3	EGP	Entree Garlic Prawns	1	10.5	1
45	4	MGP	Main Garlic Prawns	1	16.5	1
45	5	DTA	Tartufo	1	3.5	1
45	6	DCA	Cassata	1	3.5	1
45	7	DCC	Cheese Cake	1	3.5	1
45	8	DCM	Chocolate Mousse	1	3.5	1
45	9	DBF	Black Forrest Cake	1	4	1
45	10	DFS	Fruit Salad & Ice Cream	1	4.5	1
45	11	DGE	Gelati Cup	1	4	1
46	1	DAPC	Apple Pie with Cream	1	3.5	1
46	2	DAPG	Apple Pie with Gelati	1	3.5	1
46	3	PC	Prawn Cocktail	1	8	1
46	4	PA	Prawn Avocado	1	10	1
46	5	ONH	1/2 Dozen Oysters Natural	1	8.5	1
46	6	OND	Dozen Oysters Natural	1	13	1
46	7	OKH	1/2 Dozen Oysters Kilpatrick	1	10	1
46	8	OKD	Dozen Oysters Kilpatrick	1	14.5	1
46	9	MIN	Minestrone Soup	1	4.5	1
46	10	SD	Soup of the Day	1	4.5	1
46	11	FS	French Salad	1	4	1
46	12	GS	Greek Salad	1	5.5	1
47	1	2L	2 Large Pizzas	1	19.9	1
47	2	LSG	Large SanGiorgio0	1	13.5	1
48	1	STD	Steak Dianne	1	15	1
49	1	CHAS	Chicken Asparagus	1	14	1
49	2	STDWD	Steak Dianne - Well Done	1	15	1
50	1	STP	Pepper Steak	1	15	1
50	2	SPU	Spaghetti Putanesca	1	9.5	1
50	3	ECAL	Entree Ricotta Ravioli Alfredo	1	7	1
50	4	CHGR	Grilled Chicken	3	39	1
50	5	OKD	Dozen Oysters Kilpatrick	2	29	1
51	1	LSP	Large Special	1	12.5	1
51	2	LSP	Large Special	1	12.5	1
51	3	LSP	Large Special	1	12.5	1
51	4	LX	EXTRAPINE	1	0.7	1
52	1	LHW	Large Hawiian	1	12.5	1
53	1	LHW	Large Hawiian	1	12.5	1
54	1	LHW	Large Hawiian	1	12.5	1
55	1	LHW	Large Hawiian	1	12.5	1
56	1	LMX	Large Mexican	1	13	1
57	1	SMA	Small Margherita	1	8	1
58	1	LMA	Large Margherita	1	11.5	1
59	1	FSU	Family Supreme	12	216	1
60	1	MSMA	Spaghetti Marinara	1	11.5	1
60	2	ESMA	Entree Spaghetti Marinara	1	9	1
60	3	ERBO	Entree Ravioli Bolognese	1	7	1
60	4	MCAP	Ricotta Ravioli Alla Panna	1	10	1
60	5	CHAS	Chicken Asparagus	1	14	1
60	6	GRAVY	Gravy for chicken	1	2	1
60	7	FMA	Family Margherita	1	15	1
60	8	FX	EXTRA onion	1	1	1
60	9	FSG	Family SanGiorgio	10	180	1
61	1	HALF	1/2 CHIC ON OL MUS ANC	1	0	1
61	2	HALF	1/2PEPP CAP GAR	1	0	1
61	3	FX	EXTRA FRESH TOMATO	2	2	1
62	1	MRBO	Ravioli Bolognese	1	9.5	1
62	2	GS	Greek Salad	1	5.5	1
63	1	LSU	Large Supreme XOLIVE XCHEESE XPEPP	1	13.5	1
64	1	LSG	Large SanGiorgio	1	13.5	1
64	2	LSU	Large Supreme	1	13.5	1
64	3	2F	2 Family Pizzas	1	25.9	1
64	4	FSU	Family Supreme	0	0	1
65	1	LSG	Large SanGiorgio	0	0	1
65	2	LSU	Large Supreme	0	0	1
65	3	2L	2 Large Pizzas	1	19.9	1
66	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
66	2	HALF	1/2 LOT - ANC	1	0	1
66	3	HALF	1/2 HAM ON SAL CAP	1	0	1
67	1	2L	2 Large Pizzas	1	19.9	1
67	2	LSG	Large SanGiorgio	0	0	1
67	3	LSU	Large Supreme	0	0	1
68	1	LSU	Large Supreme	1	13.5	1
68	2	LX	EXTRA  OLIVES, CHEESE, PEPP	3	2.1	1
69	1	LSU	Large Supreme - ANCH	1	13.5	1
69	2	LX	EXTRA OLIVES, CHEESE, PEPP	3	2.1	1
70	1	SMA	Small Margherita	1	8	1
70	2	HALF	1/2 + ANC	1	0	1
70	3	SX	EXTRA SAL	1	0.5	1
70	4	COKE	1.25 Ltr Coke	1	3	1
71	1	LMA	Large Margherita	1	11.5	1
71	2	LX	EXTRA	2	1.4	1
71	3	MSMA	Spaghetti Marinara	1	11.5	1
71	4	EMMA	Entree Macaroni Marinara	1	9	1
71	5	STDR	Steak Dianne - Rare	1	15	1
71	6	CHF	Chicken Fillets	1	14	1
72	1	STR	Rump Steak	1	13	1
73	1	FSU	Family Supreme	1	18	1
73	2	HALF	1/2 SEAFOOD	1	0	1
74	1	LHW	Large Hawiian	0	0	1
74	2	HALF	1/2HAM+MUSH	0	0	1
74	3	LSU	Large Supreme	0	0	1
74	4	GB	Garlic Bread	2	4	1
74	5	2L	2 Large Pizzas	1	19.9	1
75	1	LSU	Large Supreme	1	13.5	1
75	2	ETBO	Entree Tortelline Bolognese	1	7	1
75	3	SX	EXTRA	1	0.5	1
76	1	MSMA	Spaghetti Marinara	1	11.5	1
76	2	ESMA	Entree Spaghetti Marinara	1	9	1
76	3	ERBO	Entree Ravioli Bolognese	1	7	1
76	4	MCAP	Ricotta Ravioli Alla Panna	1	10	1
76	5	CHAS	Chicken Asparagus	1	14	1
76	6	GRAVY	Gravy for chicken	1	2	1
76	7	FMA	Family Margherita	1	15	1
76	8	FX	EXTRA onion	1	1	1
76	9	FSG	Family SanGiorgio	10	180	1
76	10	DTA	Tartufo	1	3.5	1
76	11	DCC	Cheese Cake	1	3.5	1
76	12	DBF	Black Forrest Cake	1	4	1
77	1	LMX	Large Mexican	1	13	1
78	1	LSG	Large SanGiorgio	1	13.5	1
79	1	FSG	Family SanGiorgio	1	18	1
80	1	LSU	Large Supreme	1	13.5	1
81	1	LSU	Large Supreme	1	13.5	1
82	1	LMX	Large Mexican	1	13	1
82	2	DTA	Tartufo	1	3.5	1
83	1	LSU	Large Supreme	1	13.5	1
84	1	LSU	Large Supreme	1	13.5	1
84	2	HALF	1/2 + anc	1	0	1
85	1	LSU	Large Supreme	1	13.5	1
85	2	NO	No salad	1	0	1
86	1	LMX	Large Mexican	1	13	1
86	2	NO		1	0	1
87	1	LMX	Large Mexican	1	13	1
87	2	-	-	1	0	1
88	1	LMX	Large Mexican	1	13	1
88	2	NO	No chilli	1	0	1
89	1	LMX	Large Mexican	1	13	1
89	2	-	- no chilli	1	0	1
90	1	LMX	Large Mexican	1	13	1
90	2	NO	No tomato sauce	1	0	1
90	3	-	- will be wearing a white rose	1	0	1
90	4	.	chrge double	1	0	1
91	1	ESMA	Entree Spaghetti Marinara	1	9	1
91	2	.	+ fresh chilli	1	0	1
92	1	ESMA	Entree Spaghetti Marinara	1	9	1
92	2	.	+ fresh chilli	1	0	1
92	3	COKE	1.25 Ltr Coke	1	3	1
93	1	FHW	Family Hawiian	1	16.5	1
93	2	FX	EXTRA PEPP BAC PR	2	2	1
93	3	DEL	DELIVERY	0	0	1
94	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
95	1	DTA	Tartufo	1	3.5	1
95	2	COKE	1.25 Ltr Coke	0	3	1
96	1	SMA	Small Margherita	1	8	1
96	2	LSP	Large Special	1	12.5	1
96	3	CHF	Chicken Fillets	1	14	1
96	4	FHW	Family Hawiian	1	16.5	1
96	5	HALF	1/2 +ANC	1	0	1
96	6	FX	EXTRA PIN CHI	2	1	1
97	1	2F	2 Family Pizzas	12	310.8	1
97	2	.	TRY TO ADJUST A PRICE	1	0	1
98	1	STRWD	Rump Steak - Well Done	1	13	1
98	2	STPWD	Pepper Steak - Well Done	1	15	1
98	3	.	delivery	1	0	1
99	1	FSU	Family Supreme - seafood	1	18	1
99	2	HALF	1/2 + pin	1	0	1
100	1	MLA	Main Lasagna	2	19	1
100	2	GB	Garlic Bread	1	2	1
100	3	GS	Greek Salad	2	11	1
100	4	COKE	1.25 Ltr Coke	1	3	1
100	5	.	B & H XTRA MILD	1	0	1
101	1	SMA	Small Margherita	1	8	1
101	2	LMA	Large Margherita	2	11.5	1
102	1	SMA	Small Margherita	1	8	1
102	2	SX	EXTRA PIN OL	2	1	1
102	3	HALF	1/2 + OL	1	0	1
102	4	HALF	1/2 LOT - OL	1	0	1
102	5	HALF	1/2 MAR + OL	1	0	1
103	1	PFM	FAMILY PICK-UP	1	12.9	1
103	2	PLG	LARGE PICK-UP	1	9.9	1
103	3	PSM	SMALL PICK-UP	1	6.9	1
103	4	SSU	Small Supreme	0	9.5	1
104	1	STPWD	Pepper Steak - Well Done	1	15	1
104	2	CHIPS	Chips ONLEY	0	0	1
104	3	CR	Calzone Rustico	1	10.5	1
104	4	COKE	1.25 Ltr Coke	1	3	1
105	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
105	2	LSU	Large Supreme	0	0	1
106	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
106	2	LSU	Large Supreme	0	0	1
106	3	LX	EXTRA OLIVES	1	0.7	1
107	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
107	2	LSU	Large Supreme	0	0	1
112	1	LMX	Large Mexican	1	13	1
112	2	+	+ beer	2	7	1
112	3	CIGS	Cigarettes - marlb red	1	6.8	1
112	4	DIS	discount	1	-0.2	1
113	1	FSU	Family Supreme	1	18	1
113	2	+	+ olive	1	1	1
113	3	HALF	1/2 american  XTRA OLIVE	1	0	1
114	1	FSP	Family Special	1	17	1
114	2	HALF	1/2 MARG + OLIVE	1	0	1
115	1	FSU	Family Supreme	1	18	1
115	2	HALF	1/2 - CHEESE + ON CAP MUS OL PIN	1	0	1
116	1	FSU	Family Supreme - ANC	1	18	1
116	2	HALF	1/2 CHIC MUS ON	1	0	1
116	3	COKE	1.25 Ltr Coke	1	3	1
117	1	ELA	Entree Lasagna	1	7.5	1
117	2	MFAP	Fettucini Alla Panna	1	10	1
117	3	PC	Prawn Cocktail	3	24	1
118	1	2F	2 Family Pizzas	1	25.9	1
118	2	FCH	Family Chicken Hawiian	0	0	1
118	3	FSG	Family SanGiorgio	0	0	1
118	4	FX	EXTRA HAM	1	1	1
119	1	2S	2 Small Pizzas	1	16.9	1
119	2	SVG	Small Vegetarian	0	0	1
119	3	SMX	Small Mexican	0	0	1
119	4	SAU	Small Australian + PEP PIN	1	8.5	1
120	1	2F	2 Family Pizzas	1	25.9	1
120	2	FVG	Family Vegetarian	0	0	1
120	3	GB	Garlic Bread	1	2	1
120	4	+	+ DELIVERY	1	1	1
121	1	OKH	1/2 Dozen Oysters Kilpatrick	1	10	1
121	2	FS	French Salad	1	4	1
121	3	DAPC	Apple Pie with Cream	1	3.5	1
121	4	+	+ VEG + ALFREDO	7	7	1
122	1	MSBO	Spaghetti Bolognese	1	9.5	1
122	2	MCVG	Ricotta Ravioli Vegetarian	1	9.5	1
122	3	HB	Herb Bread	2	4	1
124	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
124	2	HALF	1/2 AUS	1	0	1
124	3	HALF	1/2 MEAT LOVERS	1	0	1
125	1	OND	Dozen Oysters Natural	1	13	1
125	2	CHAV	Chicken Avocado	1	14	1
125	3	COKE	1.25 Ltr Coke	2	6	1
125	4	CIGS	Cigarettes B&H XTRA MILD	1	7.4	1
125	5	+	+ DELIVERY FEE	1	2	1
126	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
126	2	FSP	Family Special	0	0	1
126	3	HALF	1/2-OLI	1	0	1
127	1	2L	2 Large Pizzas	1	19.9	1
127	2	LSU	Large Supreme	0	0	1
127	3	LSG	Large SanGiorgio	0	0	1
127	4	GB	Garlic Bread	1	2	1
128	1	MTCB	Tortellini Carbonara	1	10	1
128	2	MTBO	Tortellini Bolognese	1	9.5	1
128	3	GB	Garlic Bread	1	2	1
129	1	MSBO	Spaghetti Bolognese	1	9.5	1
129	2	ESBO	Entree Spaghetti Bolognese	1	7	1
129	3	GB	Garlic Bread	1	2	1
129	4	COKE	1.25 Ltr Coke	1	3	1
130	1	ECAP	Entree Ricotta Ravioli Alla Panna	1	8	1
130	2	SCH	Small Chicken Hawiian	1	9.5	1
130	3	SAU	Small Australian	1	8.5	1
130	4	COKE	1.25 Ltr Coke	1	3	1
130	5	GB	Garlic Bread	1	2	1
131	1	OND	Dozen Oysters Natural	1	13	1
131	2	MSMA	Spaghetti Marinara	1	11.5	1
131	3	MIN	Minestrone Soup	1	4.5	1
132	1	STF	Fillet Mignon	1	17	1
133	1	PSM	SMALL PICK-UP	1	6.9	1
134	1	2L	2 Large Pizzas	1	19.9	1
134	2	LAU	Large Australian SAL MUS	0	0	1
134	3	LSU	Large Supreme- ON OL ANC	0	0	1
134	4	COKE	1.25 Ltr Coke	1	3	1
134	5	GB	Garlic Bread	2	4	1
135	1	FSU	Family Supreme - ANC	1	18	1
136	1	LVG	Large Vegetarian	1	12.5	1
137	1	SPC	Small Pizza, 1 Can Coke	1	10	1
138	1	MSPU	Spaghetti Putanesca	1	9.5	1
138	2	SVG	Small Vegetarian	1	9	1
138	3	SX	EXTRA ANCH	1	0.5	1
138	4	GS	Greek Salad	1	5.5	1
138	5	CHIPS	Chips	1	3.5	1
139	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
139	2	HALF	1/2VEG NO OLIVES	1	0	1
139	3	HALF	1/2HAW	1	0	1
140	1	SVG	Small Vegetarian	1	9	1
140	2	NO	NoCHEESE	1	0	1
140	3	50		0	0	1
140	4	FIFTY		0	0	1
141	1	2F	2 Family Pizzas	1	25.9	1
142	1	LSU	Large Supreme	1	13.5	1
142	2	GB	Garlic Bread	1	2	1
143	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
144	1	STDWD	Steak Dianne - Well Done	1	15	1
144	2	STDWD	Steak Dianne - Well Done	1	15	1
145	1	2L	2 Large Pizzas	1	19.9	1
145	2	2COKE	2 Ltr Coke	1	3	1
146	1	CHF	Chicken Fillets	1	14	1
146	2	NO	NoVEG ONLY POT AND RICE	1	0	1
146	3	GB	Garlic Bread	1	2	1
146	4	EMBO	Entree Macaroni Bolognese	1	7	1
146	5	DTA	Tartufo	2	7	1
147	1	2L	2 Large Pizzas	1	19.9	1
147	2	L	SANGIORGIO	0	0	1
147	3	LX	EXTRAANCH	1	0.7	1
148	1	STDWD	Steak Dianne - Well Done	1	15	1
148	2	CHANGE	FIFTY DOLLARS	0	0	1
149	1	LSU	Large Supreme	1	13.5	1
149	2	GB	Garlic Bread	1	2	1
150	1	ETBO	Entree Tortelline Bolognese	1	7	1
150	2	SX	EXTRAMUSH OLIVE CHILLI PARMESAN	4	2	1
150	3	MLA	Main Lasagna	1	9.5	1
150	4	SX	EXTRA2 BOTTLE MIN WATER	16	8	1
151	1	LCH	Large Chicken Hawiian	1	13	1
151	2	HB	Herb Bread	1	2	1
152	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
152	2	LSU	Large Supreme	0	0	1
153	1	MMCB	Macaroni Carbonara	1	10	1
153	2	EMCB	Entree Macaroni Carbonara	1	8	1
153	3	SX	EXTRA MUSH	1	0.5	1
153	4	FS	French Salad	1	4	1
153	5	CHGR	Grilled Chicken	1	13	1
153	6	DIS	discount	1	-3.5	1
153	7	COKE	1.25 Ltr Coke	1	3	1
153	8	+	CANS FANTA	3	5.1	1
153	9	DIS	discount	1	-0.1	1
154	1	SMA	Small Margherita	2	16	1
155	1	FVG	Family Vegetarian	1	17	1
155	2	FX	EXTRA pin	1	1	1
155	3	FVG	Family Vegetarian	1	17	1
155	4	FX	EXTRA SUN D TOM GAR CHEESE	3	3	1
156	1	GB	Garlic Bread	3	6	1
156	2	MHW		0	0	1
157	1	GB	Garlic Bread	3	6	1
157	2	LHW	Large Hawiian	1	12.5	1
158	1	FSG	Family SanGiorgio	1	18	1
158	2	GB	Garlic Bread	2	2	1
159	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
159	2	HALF	1/2 MEAT LOVER	1	0	1
159	3	HALF	1/2 LOT	1	0	1
160	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
160	2	HALF	1/2 MEAT LOVERS	1	0	1
160	3	HALF	1/2 LOT	1	0	1
162	1	FSU	Family Supreme	1	18	1
163	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
163	2	LSU	Large Supreme	0	0	1
164	1	MSMA	Spaghetti Marinara	1	11.5	1
164	2	MRBO	Ravioli Bolognese	1	9.5	1
164	3	GB	Garlic Bread	2	4	1
165	1	MSBO	Spaghetti Bolognese	1	9.5	1
165	2	GB	Garlic Bread	1	2	1
166	1	FSU	Family Supreme NO OLIVE, ANCH 1/4 +CHILI	1	18	1
167	1	2F	2 Family Pizzas	1	25.9	1
167	2	FSU	Family Supreme	0	0	1
167	3	FHW	Family Hawiian	0	0	1
167	4	--	DELIVER IN HALF AN HOUR	0	0	1
168	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
168	2	LSU	Large Supreme	0	0	1
168	3	MLA	Main Lasagna	1	9.5	1
169	1	MFC	Main Fried Calamari	1	13.5	1
169	2	MSMA	Spaghetti Marinara	1	11.5	1
169	3	GB	Garlic Bread	2	4	1
169	4	COKE	1.25 Ltr Coke	1	3	1
170	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
170	2	FMX	Family Mexican	0	0	1
170	3	FX	EXTRA X X ANCH	2	2	1
171	1	CR	Calzone Rustico	1	10.5	1
171	2	--	HAM + CHILI	0	0	1
172	1	2S	2 Small Pizzas	1	16.9	1
172	2	SHW	Small Hawiian 1/2 NO CHEESE	0	0	1
172	3	--	SMALL PWNS MUSH HAM	0	0	1
173	1	2S	2 Small Pizzas	1	16.9	1
173	2	S	SMALL HAM OLIVES PEPP ANCH	0	0	1
173	3	SX	EXTRA CHEESE	1	0.5	1
173	4	S	SMALL HAM F/TOM PEPP	0	0	1
174	1	CR	Calzone Rustico	1	10.5	1
174	2	+	+PRESS INTERCOM	0	0	1
175	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
175	2	F	FAM VEG 1/2 PEPP	0	0	1
175	3	CIGS	Cigarettes PETER STYVESON	1	6.6	1
176	1	2F	2 Family Pizzas	1	25.9	1
176	2	FHW	Family Hawiian	0	0	1
176	3	FSU	Family Supreme - ANC	0	0	1
177	1	LVG	Large Vegetarian- PIN	1	12.5	1
177	2	LX	EXTRA CHICKEN	1	0.7	1
177	3	LX	EXTRA FR TOMATO CHEESE	2	1.4	1
177	4	CIGS	Cigarettes PETER STY	1	6.6	1
177	5	DIS	discount	1	-0.5	1
178	1	GB	Garlic Bread	1	2	1
178	2	DCC	Cheese Cake	1	3.5	1
178	3	STSH	Schnitzel + VEG	1	10.5	1
178	4	+	1.25 DIET COKE	1	3	1
179	1	LSU	Large Supreme 1/2 - OLIVE	1	13.5	1
179	2	GB	Garlic Bread	1	2	1
180	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
180	2	LSU	Large Supreme	0	0	1
180	3	NO	No SEA PIN OL	1	0	1
181	1	F	FAM	1	18	1
181	2	HALF	1/2 BAC SAL CA OL	1	0	1
181	3	HALF	1/2 HAM 1/4 + PIN	1	0	1
182	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
182	2	FSU	Family Supreme- OL ANC	0	0	1
182	3	MMAP	Macaroni Alla Panna	1	10	1
183	1	MSBO	Spaghetti Bolognese	1	9.5	1
183	2	MSMA	Spaghetti Marinara	1	11.5	1
183	3	GB	Garlic Bread	1	2	1
184	1	MTAP	Tortellini Alla Panna	1	10	1
184	2	MCVG	Ricotta Ravioli Vegetarian	1	9.5	1
184	3	GB	Garlic Bread	1	2	1
184	4	DCM	Chocolate Mousse	2	7	1
184	5	50	*************$50.00 NOTE**************	1	0	1
184	6	50	*****$50.00 NOTE*****	1	0	1
184	7	100	****$100.00 NOTE*****	1	0	1
185	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
185	2	HALF	1/2 VEG	1	0	1
185	3	HALF	1/2SUP - OL AN	1	0	1
186	1	FCH	Family Chicken Hawiian	1	17.5	1
186	2	HALF	1/2 MEAT LOVERS	1	0	1
187	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
187	2	LSU	Large Supreme	0	0	1
187	3	CIGS	Cigarettes B& H XTRA MILD	1	7.4	1
188	1	2L	2 Large Pizzas	1	19.9	1
188	2	LSP	Large Special - OLIVE	0	0	1
188	3	LMX	Large Mexican - OLIVE	0	0	1
189	1	PLG	LARGE PICK-UP	1	9.9	1
189	2	LSG	Large SanGiorgio	0	0	1
189	3	GB	Garlic Bread	1	2	1
190	1	SVG	Small Vegetarian	1	9	1
190	2	SX	EXTRA ANC	1	0.5	1
190	3	ERAP	Entree Ravioli Alla Panna	1	8	1
190	4	STSZ	Scaloppina Zingara	1	11.5	1
190	5	CHIPS	Chips	1	3.5	1
190	6	50	*****$50.00 NOTE*****	1	0	1
191	1	LVG	Large Vegetarian+ ANC - PIN	1	12.5	1
191	2	HALF	1/2MARG	1	0	1
191	3	+	+ GB	1	2.5	1
192	1	2L	2 Large Pizzas	1	19.9	1
192	2	LSU	Large Supreme	0	0	1
192	3	LSG	Large SanGiorgio - OLIVE	0	0	1
193	1	FSU	Family Supreme - ANC	1	18	1
194	1	STRWD	Rump Steak - Well Done	2	26	1
194	2	CHIPS	Chips ONLY	0	0	1
194	3	COKE	1.25 Ltr Coke	1	3	1
194	4	ERAP	Entree Ravioli Alla Panna	1	8	1
195	1	F	FAM	1	18	1
195	2	HALF	1/2 MEAT LOVERS	1	0	1
195	3	FX	EXTRA CHEESE ONION	1	1	1
195	4	HALF	1/2 CHICK PR ON MUS	1	0	1
196	1	2F	2 Family Pizzas	1	25.9	1
196	2	FCH	Family Chicken Hawiian	0	0	1
196	3	FSG	Family SanGiorgio	0	0	1
196	4	FX	EXTRA HAM	1	1	1
197	1	LCH	Large Chicken Hawiian	1	13	1
197	2	BBQ	BBQ Sauce	1	1	1
197	3	DCM	Chocolate Mousse	1	3.5	1
197	4	GB	Garlic Bread	1	2	1
198	1	FSU	Family Supreme	1	18	1
198	2	DIS	discount	1	-1.8	1
199	1	MFMA	Fettucini Marinara	1	11.5	1
199	2	MMPU	Macaroni Putanesca	1	9.5	1
200	1	L	LARGE PEPP MUS OLI	1	13.5	1
201	1	MFVG	Fettucini Vegetarian	1	9.5	1
201	2	STSZ	Scaloppina Zingara	1	11.5	1
202	1	FSG	Family SanGiorgio	1	18	1
202	2	HALF	1/2 VEG	1	0	1
203	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
203	2	LSU	Large Supreme	0	0	1
203	3	SPC	Small Pizza, 1 Can Coke	1	10	1
203	4	SSG	Small SanGiorgio	0	0	1
204	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
204	2	LGE	SAN G	0	0	1
204	3	LX	EXTRA MUSH CHICK	2	1.4	1
205	1	FML	Family Meat Lovers	1	17.5	1
205	2	FX	EXTRA MUSH	1	1	1
206	1	2L	2 Large Pizzas	1	19.9	1
206	2	LVG	Large Vegetarian	0	0	1
206	3	LVG	Large Vegetarian	0	0	1
206	4	LX	EXTRA CHILLI	0	0	1
207	1	FSP	Family Special	1	17	1
208	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
208	2	FMX	Family Mexican	0	0	1
208	3	FX	EXTRA SALAM	1	1	1
209	1	LSU	Large Supreme	1	13.5	1
209	2	++	1/2 HAW	0	0	1
209	3	DGE	Gelati Cup MIX	1	4	1
210	1	SSU	Small Supreme	1	9.5	1
210	2	COKE	1.25 Ltr Coke	1	3	1
211	1	2S	2 Small Pizzas	1	16.9	1
211	2	SSP	Small Special	0	0	1
211	3	SX	EXTRA ANCH	1	0.5	1
211	4	SMA	Small Margherita	0	0	1
211	5	SX	EXTRA PINE	1	0.5	1
211	6	SSG	Small SanGiorgio	1	9.5	1
212	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
212	2	LSP	Large Special	0	0	1
213	1	2L	2 Large Pizzas	1	19.9	1
213	2	LSG	Large SanGiorgio  + HAM	0	0	1
213	3	LSU	Large Supreme	0	0	1
214	1	2L	2 Large Pizzas	1	19.9	1
214	2	LMX	Large Mexican	0	0	1
214	3	LAM	Large American	0	0	1
215	1	2F	2 Family Pizzas	1	25.9	1
215	2	FVG	Family Vegetarian	0	0	1
215	3	FSU	Family Supreme  NO S/FOOD	0	0	1
215	4	HALF	1/2 PEPPERONI ONLY	0	0	1
216	1	SSU	Small Supreme NO ANCH	1	9.5	1
216	2	SX	EXTRA SALAMI	1	0.5	1
216	3	CSQSH	Can of Lemon Squash	1	1.7	1
217	1	2L	2 Large Pizzas	1	19.9	1
217	2	LVG	Large Vegetarian	0	0	1
217	3	LSU	Large Supreme NO CHEESE	0	0	1
217	4	WATR	750 ML MINERAL WATER	1	2.5	1
218	1	LSP	Large Special	1	12.5	1
218	2	LX	EXTRA CHEESE	1	0.7	1
218	3	MSCB	Spaghetti Carbonara	1	10	1
219	1	F	F/TOM, ARTCH, CHILLI, GARLIC	1	18	1
219	2	HALF	1/2 ANCH	1	0	1
220	1	FSU	Family  F/TOM, ARTICHOKE	1	18	1
220	2	FX	HALF ANCH	1	1	1
221	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
221	2	HALF	1/2 SAN G	1	0	1
221	3	HALF	1/2 CHICK HAW	1	0	1
222	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
222	2	FSU	Family Supreme NO SEAFOOD	0	0	1
222	3	FX	EXTRA PEPP, CAP, ONION	3	3	1
223	1	FHW	Family Hawiian  + PEPP	1	16.5	1
223	2	HALF	1/2 HAM MUSH CAP F/TOM	2	0	1
223	3	COKE	1.25 Ltr Coke	1	3	1
224	1	LHW	Large Hawiian	1	12.5	1
224	2	LX	EXTRA pepp	1	0.7	1
224	3	LX	bacon	1	0.7	1
224	4	GB	Garlic Bread	1	2	1
225	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
225	2	LMA	Large Margherita	0	0	1
226	1	FAM	Family American	1	16.5	1
226	2	LX	EXTRA F/TOM	1	0.7	1
226	3	HALF	1/2VEG + CHICK CHILLIE	1	0	1
226	4	+	2 LITRE O J	1	5	1
227	1	EFCB	Entree Fettucini Carbonara	1	8	1
227	2	ELA	Entree Lasagna	1	7.5	1
227	3	GB	Garlic Bread	1	2	1
228	1	SPC	Small Pizza, 1 Can Coke	1	10	1
228	2	SSE	Small Seafood	0	0	1
229	1	F	FAM 1/2 CONTI.	1	18	1
229	2	FX	EXTRA SUND TO. FETT. CCAP	2	2	1
229	3	HALF	1/2 VEG GOURMET	1	0	1
230	1	CHF	Chicken Fillets	1	14	1
230	2	COKE	1.25 Ltr Coke	1	3	1
230	3	GB	Garlic Bread	1	2	1
231	1	LSU	Large Supreme - ANC	1	13.5	1
231	2	DGE	Gelati Cup CHOCOLATE	2	8	1
231	3	GB	Garlic Bread	1	2	1
232	1	2L	2 Large Pizzas	1	19.9	1
232	2	L	LARGE HAM SAL MUS	0	0	1
232	3	LX	EXTRA CHEESE	1	0.7	1
232	4	LVG	Large Vegetarian	0	0	1
232	5	LX	EXTRA HAM - OLIVE	1	0.7	1
232	6	SVG	Small Vegetarian - CAP	1	9	1
232	7	SX	EXTRA SAL	1	0.5	1
232	8	GB	Garlic Bread	1	2	1
233	1	LHW	Large Hawiian	1	12.5	1
233	2	GB	Garlic Bread	1	2	1
233	3	COKE	1.25 Ltr Coke	1	3	1
234	1	LSP	Large Special	1	12.5	1
234	2	HALF	1/2HAW	1	0	1
234	3	GB	Garlic Bread	1	2	1
234	4	--	GO OFF KENILWORTH ST	0	0	1
235	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
235	2	HALF	1/2 SUP	1	0	1
235	3	HALF	1/2 HAW	1	0	1
236	1	2L	2 Large Pizzas	1	19.9	1
236	2	LHW	Large Hawiian	0	0	1
236	3	LCH	Large Chicken Hawiian	0	0	1
236	4	BBQ	BBQ Sauce	1	1	1
237	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
237	2	LSG	Large SanGiorgio	0	0	1
237	3	--	SAL ON TOP	0	0	1
238	1	LSU	Large Supreme - SEAFOOD	1	13.5	1
238	2	CIGS	Cigarettes B& H SP FILTER	1	14.8	1
239	1	PLG	LARGE PICK-UP	1	9.9	1
239	2	LSU	Large Supreme	0	0	1
240	1	SMX	Small Mexican	1	9.5	1
240	2	MFP	Main Fried Prawns	1	16	1
241	1	STFR	Fillet Mignon - Rare	1	17	1
241	2	CHIPS	Chips	1	3.5	1
242	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
242	2	LVG	Large Vegetarian	0	0	1
242	3	LX	EXTRA 1/2 + PEPPORINI	0.5	0.35	1
242	4	+	+	1	0.05	1
243	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
243	2	FSU	Family Supreme	0	0	1
244	1	STSH	Schnitzel + CHIPS ONLY	1	10.5	1
244	2	FX	EXTRA gravy	2	2	1
244	3	CHIPS	Chips + gravy	1	3.5	1
244	4	FX	EXTRA gravy	2	2	1
245	1	FMX	Family Mexican	1	17.5	1
245	2	FX	EXTRA mussels	1	1	1
245	3	SSG	Small SanGiorgio	1	9.5	1
246	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
246	2	LX	EXTRA olive mush	1	0.7	1
247	1	SPC	Small Pizza, 1 Can Coke	1	10	1
247	2	SSG	Small SanGiorgio	1	9.5	1
248	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
248	2	FSU	Family Supreme no olives no anch	0	0	1
249	1	2F	2 Family Pizzas	1	25.9	1
249	2	HALF	1/2 vg +garlic	1	0	1
249	3	HALF	1/2 seafood - anch	0	0	1
249	4	FX	EXTRA bacon	1	1	1
249	5	HALF	1/2 chick  haw	1	0	1
249	6	HALF	1/2 san g	1	0	1
250	1	MFBO	Fettucini Bolognese	1	9.5	1
250	2	1.25 FX	water	1	0	1
251	1	2L	2 Large Pizzas	1	19.9	1
251	2	LML	Large Meat Lovers	0	0	1
251	3	LX	EXTRA chik	1	0.7	1
251	4	LSU	Large Supreme -olives -anch	0	0	1
251	5	COKE	1.25 Ltr Coke	1	3	1
252	1	S	SMALL pepp onion	1	9.5	1
252	2	CHIPS	Chips	1	3.5	1
252	3	DBF	Black Forrest Cake	1	4	1
253	1	2F	2 Family Pizzas	1	25.9	1
253	2	FCH	Family Chicken Hawiian	0	0	1
253	3	FSG	Family SanGiorgio	0	0	1
253	4	FX	EXTRA +bacon	1	1	1
254	1	STMS	Scaloppina Mushroom	1	11.5	1
254	2	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
254	3	LSG	Large SanGiorgio	0	0	1
255	1	LCH	Large Chicken Hawiian	1	13	1
256	1	FML	Family Meat Lovers	1	17.5	1
256	2	BBQ	BBQ Sauce	1	1	1
256	3	FX	EXTRA chicken bacon ham sal	3	3	1
256	4	FX	EXTRA	2	2	1
257	1	F	FAM	1	18	1
257	2	HALF	1/2CHICK HAW	1	0	1
257	3	HALF	1/2CHICK MUSH ONION	1	0	1
257	4	FX	EXTRACHEESE	1	1	1
257	5	BBQ	BBQ Sauce ALL OVER BASE ONLY	1	1	1
257	6	GB	Garlic Bread	1	2	1
258	1	S	SMALL	1	9.5	1
258	2	HB	Herb Bread	1	2	1
258	3	CLMND	Can of Lemonade	2	3.4	1
258	4	COKE	1.25 Ltr Coke	1	3	1
259	1	2F	2 Family Pizzas	1	25.9	1
259	2	HALF	1/2capr 1/2c/fd	1	0	1
259	3	HALF	1/2s/g 1/2lot	1	0	1
260	1	STD	Steak Dianne ( med)	1	15	1
261	1	L	LARGE	1	13.5	1
261	2	HALF	1/2chick 1/2amer +herbs	1	0	1
262	1	CHF	Chicken Fillets	1	14	1
262	2	GB	Garlic Bread	1	2	1
262	3	COKE	1.25 Ltr Coke	1	3	1
264	1	F	FAM BARBECUE CHICK	2	36	1
264	2	FMX	Family Mexican	1	17.5	1
264	3	FAM	Family American	2	33	1
264	4	FSP	Family Special	1	17	1
264	5	SVG	Small Vegetarian	1	9	1
264	6	+	discount	1	-27.5	1
265	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
265	2	LMX	Large Mexican	0	0	1
266	1	MSBO	Spaghetti Bolognese	1	9.5	1
267	1	L	LARGE	1	13.5	1
267	2	HALF	1/2LOT -ANCH	1	0	1
267	3	HALF	1/2HAW	1	0	1
267	4	GB	Garlic Bread	1	2	1
268	1	2F	2 Family Pizzas	1	25.9	1
268	2	FSG	Family SanGiorgio 1/2-OLIVES	0	0	1
268	3	FSU	Family Supreme	0	0	1
269	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
269	2	LSG	Large SanGiorgio	0	0	1
269	3	COKE	1.25 Ltr Coke	1	3	1
269	4	CIGS	Cigarettes B+H EX M	1	7.4	1
270	1	FVG	Family Vegetarian +FR.BASIL	1	17	1
270	2	HALF	1/2 LITTLE CHILLI	1	0	1
270	3	FX	EXTRA ANCH	1	1	1
271	1	PFM	FAMILY PICK-UP	1	12.9	1
271	2	HALF	1/2HAW	0	0	1
271	3	HALF	1/2SP	1	0	1
271	4	GB	Garlic Bread	2	4	1
271	5	CCOKE	Can of Coke	2	3.4	1
271	6	+	+CAN OF DIET COKE	2	3.4	1
272	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
272	2	LSU	Large Supreme -ANCH -OLIVES	0	0	1
273	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
273	2	LML	Large Meat Lovers	0	0	1
274	1	PFM	FAMILY PICK-UP	1	12.9	1
274	2	FSP	Family Special	0	0	1
275	1	LVG	Large Vegetarian XGARLICXBASIL	1	12.5	1
275	2	LX	EXTRA+PEPP	1	0.7	1
275	3	GB	Garlic Bread	1	2	1
276	1	2L	2 Large Pizzas	1	19.9	1
276	2	LSG	Large SanGiorgio	0	0	1
276	3	LX	EXTRA CHEESE	1	0.7	1
276	4	LMX	Large Mexican	0	0	1
278	1	FSU	Family Supreme	1	18	1
278	2	HALF	1/2 VEG + FR TOM	1	0	1
278	3	FSU	Family Supreme XTRA ANC	1	18	1
278	4	HALF	1/2 HAM	1	0	1
278	5	FSU	Family Supreme - PIN	1	18	1
278	6	FVG	Family Vegetarian- MUS	1	17	1
278	7	HALF	1/2 + OLIVE	1	0	1
278	8	FSU	Family Supreme + MCHILLI	1	18	1
278	9	FSU	Family Supreme 1/2 MEAT LOV	1	18	1
278	10	FSU	Family Supreme- ANC	1	18	1
278	11	FHW	Family Hawiian 1/2 + MUS SAL	1	16.5	1
278	12	FSE	Family Seafood - ANC	1	18	1
278	13	HALF	1/2 SUP - ANC	1	0	1
278	14	DIS	discount	1	-51.5	1
279	1	2S	2 Small Pizzas	1	16.9	1
279	2	SVG	Small Vegetarian	0	0	1
279	3	SX	EXTRA EGG	1	0.5	1
279	4	SSU	Small Supreme - PINE	0	0	1
280	1	EGW	Entree Grilled Whiting	1	9	1
280	2	EFW	Entree Fried Whiting	1	9	1
280	3	CHIPS	Chips	1	3.5	1
280	4	CHAV	Chicken Avocado	1	14	1
280	5	GB	Garlic Bread	1	2	1
281	1	STD	Steak Dianne	1	15	1
281	2	COKE	1.25 Ltr Coke	1	3	1
281	3	CIGS	Cigarettes ESCORT BLUE	1	8.4	1
282	1	LSU	Large Supreme	1	13.5	1
282	2	COKE	1.25 Ltr Coke	1	3	1
283	1	2F	2 Family Pizzas	1	25.9	1
283	2	FCH	Family Chicken Hawiian	0	0	1
283	3	FX	EXTRA BARB.SAUCE CAPS PEPP	3	3	1
283	4	FSU	Family Supreme	0	0	1
283	5	COKE	1.25 Ltr Coke	2	6	1
284	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
284	2	GB	Garlic Bread	1	2	1
284	3	F	FAM HAM SALAMI ANCH OLIVES	0	0	1
285	1	2L	2 Large Pizzas	1	19.9	1
285	2	LVG	Large Vegetarian	0	0	1
285	3	LX	EXTRA FR.TOM  X OLIVES	2	1.4	1
285	4	LSG	Large SanGiorgio	0	0	1
285	5	LX	EXTRA X OLIVES	1	0.7	1
286	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
286	2	LSP	Large Special	0	0	1
286	3	LX	EXTRA ANCH	1	0.7	1
287	1	SPC	Small Pizza, 1 Can Coke	1	10	1
287	2	SVG	Small Vegetarian -OLIVES	0	0	1
287	3	SX	EXTRA X PINE	1	0.5	1
288	1	MSMA	Spaghetti Marinara	1	11.5	1
288	2	COKE	1.25 Ltr Coke	1	3	1
289	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
289	2	HALF	1/2HW	1	0	1
289	3	HALF	1/2 SU -ANCH	1	0	1
290	1	SSP	Small Special	1	9	1
290	2	SX	EXTRA TOM	1	0.5	1
290	3	SX	EXTRA BASIL	1	0.5	1
290	4	DTA	Tartufo	1	3.5	1
290	5	DCM	Chocolate Mousse	1	3.5	1
290	6	DAPG	Apple Pie with Gelati	1	3.5	1
291	1	F	FAM	1	18	1
291	2	HALF	1/2C/FOOD	1	0	1
291	3	HALF	1/2LOT	1	0	1
292	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
292	2	HALF	1/2MEAT.L x SAUCE	1	0	1
292	3	HALF	1/2FR.TOM SALAMI DASH OF CHILI	1	0	1
293	1	CHGR	Grilled Chicken	1	13	1
293	2	GB	Garlic Bread	1	2	1
293	3	CHIPS	Chips	1	3.5	1
293	4	DCM	Chocolate Mousse	1	3.5	1
293	5	COKE	1.25 Ltr Coke	1	3	1
294	1	LMA	Large Margherita	1	11.5	1
294	2	GB	Garlic Bread	1	2	1
294	3	CCOKE	Can of Coke	1	1.7	1
295	1	FSG	Family SanGiorgio +FR.BASIL	1	18	1
295	2	COKE	1.25 Ltr Coke	1	3	1
296	1	2L	2 Large Pizzas	1	19.9	1
296	2	LVG	Large Vegetarian	0	0	1
296	3	LSU	Large Supreme  1/2-ANCH	0	0	1
297	1	FHW	Family Hawiian	1	16.5	1
297	2	FX	EXTRA MUSHROOM	1	1	1
297	3	GB	Garlic Bread	1	2	1
298	1	LSP	Large Special	1	12.5	1
298	2	LX	EXTRA PEPP ANCH	2	1.4	1
298	3	GB	Garlic Bread	1	2	1
299	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
299	2	F	FAM 1/2 CHICKHAW 1/2 MEAT.L.	0	0	1
300	1	STP	Pepper Steak   (R)	1	15	1
300	2	CHIPS	Chips	1	3.5	1
300	3	COKE	1.25 Ltr Coke	1	3	1
301	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
301	2	LAM	Large American	0	0	1
301	3	LX	EXTRA SALAMI	1	0.7	1
301	4	LX	EXTRA CHEESE	1	0.7	1
302	1	PLG	LARGE PICK-UP	1	9.9	1
302	2	L	LARGE 1/2SAN.G   1/2  MEX	0	0	1
303	1	2L	2 Large Pizzas	1	19.9	1
303	2	LSU	Large Supreme  BOTH-ANCH	0	0	1
304	1	LHW	Large Hawiian	1	12.5	1
305	1	F	FAM	1	18	1
305	2	HALF	1/2 SAN.G	1	0	1
305	3	HALF	1/2OLIVES ON BACON CHICK PINE CHILLI	1	0	1
305	4	FX	EXTRA CHEESE XXGARLIC	2	2	1
306	1	SVG	Small Vegetarian	1	9	1
306	2	SX	EXTRA ham	1	0.5	1
306	3	COKE	1.25 Ltr Coke	1	3	1
306	4	CIGS	Cigarettes escort blue	1	8.4	1
307	1	F	FAM	1	18	1
307	2	HALF	1/2HAW	1	0	1
307	3	HALF	1/2 SAN.G - CAPS	1	0	1
307	4	CBR	Continental Bread (3 peices)	2	1.2	1
308	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
308	2	HALF	1/2LOT - ANCH	1	0	1
308	3	HALF	1/2CHICK HAW	1	0	1
309	1	PLG	LARGE PICK-UP	1	9.9	1
309	2	LAM	Large American	0	0	1
309	3	LX	EXTRA pineapple	1	0.7	1
310	1	STF	Fillet Mignon	1	17	1
310	2	CHAV	Chicken Avocado	1	14	1
311	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
311	2	HALF	1/2CH HAW	1	0	1
311	3	HALF	1/2SAN.G  -OLIVES	1	0	1
312	1	2L	2 Large Pizzas	1	19.9	1
312	2	LSG	Large SanGiorgio	0	0	1
312	3	LSU	Large Supreme  - ANCH	0	0	1
313	1	L	LARGE	1	13.5	1
313	2	HALF	1/2 MARG	1	0	1
313	3	HALF	1/2 SPEC	1	0	1
313	4	GB	Garlic Bread	1	2	1
314	1	PFM	FAMILY PICK-UP	1	12.9	1
314	2	HALF	1/2 HAW	1	0	1
314	3	HALF	1/2 AUST	1	0	1
314	4	COKE	1.25 Ltr Coke	1	3	1
315	1	MRBO	Ravioli Bolognese	1	9.5	1
315	2	DGE	Gelati Cup CHOC,VAN	1	4	1
316	1	2L	2 Large Pizzas	1	19.9	1
316	2	LSG	Large SanGiorgio	0	0	1
316	3	LX	EXTRA PINE HAM LITTLE CHILI+GARLIC	2	1.4	1
316	4	L	LARGE	0	0	1
316	5	HALF	1/2 HAW	1	0	1
316	6	HALF	1/2 AUST	1	0	1
317	1	PC	Prawn Cocktail	2	16	1
317	2	GS	Greek Salad	1	5.5	1
317	3	STD	Steak Dianne	1	15	1
317	4	CHAS	Chicken Asparagus	1	14	1
317	5	GB	Garlic Bread	1	2	1
317	6	CIGS	Cigarettes DUNHILL BLUE	1	7.4	1
317	7	+	2 LITRE ORANGE JUICE	1	5	1
318	1	PC	Prawn Cocktail	1	8	1
318	2	MLA	Main Lasagna	1	9.5	1
319	1	FSU	Family Supreme	1	18	1
319	2	HALF	1/2 -ANCH -OLIVES	1	0	1
319	3	GB	Garlic Bread	1	2	1
320	1	STP	Pepper Steak   (EX R )	1	15	1
321	1	2F	2 Family Pizzas	1	25.9	1
321	2	FSP	Family Special	0	0	1
321	3	FX	EXTRA ANCH CHEESE	2	2	1
321	4	FMX	Family Mexican X CHILLI	0	0	1
322	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
322	2	LSU	Large Supreme	0	0	1
323	1	OKD	Dozen Oysters Kilpatrick	1	14.5	1
323	2	STDMW	Steak Dianne - Md Well Done	1	15	1
323	3	STSH	Schnitzel	1	10.5	1
323	4	+	+ DIANNE SAUCE	1	2.8	1
324	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
324	2	HALF	1/2 VEG 1/2 SUP - OL	1	0	1
325	1	CHF	Chicken Fillets	1	14	1
326	1	MTCB	Tortellini Carbonara	1	10	1
326	2	DIS	Discount	1	-2.5	1
327	1	STVP	Veal Parmigiana	1	14	1
327	2	GB	Garlic Bread	1	2	1
327	3	DCM	Chocolate Mousse	1	3.5	1
328	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
328	2	HALF	1/2 LOT +CHILLI	1	0	1
328	3	HALF	1/2 H P	1	0	1
329	1	LSE	Large Seafood	1	13.5	1
329	2	HALF	1/2 VEGETARIAN -PIN	1	0	1
329	3	LX	EXTRA FRE TOM	1	0.7	1
329	4	+	EXTRA CHILLI	0	0	1
329	5	0		0	0	1
330	1	STDWD	Steak Dianne - Well Done	1	15	1
330	2	--	POTATO & SALAD ONLY	0	0	1
331	1	MLA	Main Lasagna	1	9.5	1
331	2	--	WITH MOZARELLA CHEESE	0	0	1
332	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
332	2	LML	Large Meat Lovers	0	0	1
333	1	FML	Family Meat Lovers	1	17.5	1
333	2	HALF	1/2 CHIK HAW	1	0	1
333	3	--		0	0.5	1
334	1	MCNA	Ricotta Ravioli Napolitana	1	9	1
334	2	MFMA	Fettucini Marinara	1	11.5	1
334	3	CHAV	Chicken Avocado	1	14	1
334	4	COKE	1.25 Ltr Coke	1	3	1
334	5	GB	Garlic Bread	1	2	1
335	1	2F	2 Family Pizzas	1	25.9	1
335	2	FML	Family Meat Lovers	0	0	1
335	3	LVG	Large Vegetarian	1	12.5	1
336	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
336	2	HALF	1/2 LOT -ANCH	1	0	1
336	3	HALF	1/2 SAN GIORGIO	1	0	1
337	1	CR	Calzone Rustico	1	10.5	1
337	2	GB	Garlic Bread	2	4	1
338	1	2S	2 Small Pizzas	1	16.9	1
338	2	SSG	Small SanGiorgio	0	0	1
338	3	SX	EXTRA ANCH	2	1	1
339	1	2L	2 Large Pizzas	1	19.9	1
339	2	LVG	Large Vegetarian	0	0	1
339	3	LX	EXTRA CHEESE	2	1.4	1
339	4	--	ONE - PIN + GARLIC	0	0	1
339	5	CIGS	Cigarettes B & H XTRA MILD	1	7.4	1
339	6	GB	Garlic Bread	1	2	1
339	7	50	*****$50.00 NOTE*****	1	0	1
340	1	PFM	FAMILY PICK-UP	1	12.9	1
340	2	FML	Family Meat Lovers	0	0	1
340	3	+	+	1	9	1
341	1	STVP	Veal Parmigiana	1	14	1
341	2	--	-VEG+SALAD	0	0	1
341	3	OKD	Dozen Oysters Kilpatrick	1	14.5	1
341	4	+	+LAG GELATI CUP BACI VANI	1	6	1
341	5	GB	Garlic Bread	1	2	1
342	1	CHGR	Grilled Chicken	3	35.1	1
342	2	--	one with vegetable	0	0	1
342	3	CBR	Continental Bread (3 peices)	1	0.54	1
342	4	DIS	Discount	1	0.0600000000000023	1
343	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
343	2	LSU	Large Supreme	0	0	1
343	3	HALF	1/2minus anch	0	0	1
344	1	OKD	Dozen Oysters Kilpatrick	1	14.5	1
344	2	MLA	Main Lasagna	1	9.5	1
344	3	CHAV	Chicken Avocado	1	14	1
344	4	CSQSH	Can of Lemon Squash	2	3.4	1
345	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
345	2	FAM	Family American	0	0	1
345	3	--	1/2 +PIN	0	0	1
345	4	FX	EXTRA MUSH	1	1	1
346	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
346	2	HALF	1/2 VEGETARIAN	1	0	1
346	3	HALF	1/2 H P	1	0	1
347	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
347	2	HALF	1/2 LOT	1	0	1
347	3	HALF	1/2 VEGETARIAN	1	0	1
348	1	2L	2 Large Pizzas	1	19.9	1
348	2	LSG	Large SanGiorgio	0	0	1
348	3	LSP	Large Special	0	0	1
348	4	LX	EXTRA ANCH	1	0.7	1
348	5	LX	EXTRA CHILLI	0	0	1
349	1	ESBO	Entree Spaghetti Bolognese	1	6.3	1
349	2	DCC	Cheese Cake	1	3.15	1
349	3	FS	French Salad	1	3.6	1
349	4	DIS	Discount	1	-0.0499999999999989	1
350	1	GB	Garlic Bread	1	2	1
350	2	OKD	Dozen Oysters Kilpatrick	1	14.5	1
350	3	CHAV	Chicken Avocado	1	14	1
350	4	DGE	Gelati Cup LEMON	1	4	1
351	1	FAM	Family American	1	16.5	1
351	2	GB	Garlic Bread	1	2	1
352	1	LSU	Large Supreme	1	13.5	1
352	2	HALF	1/2 SPECIAL	1	0	1
352	3	LX	EXTRA PR PEPP	2	1.4	1
352	4	GB	Garlic Bread	1	2	1
352	5	COKE	1.25 Ltr Coke	1	3	1
353	1	FSU	Family Supreme minus anch	1	18	1
353	2	HALF	1/2hawaii	0	0	1
353	3	GB	Garlic Bread	1	2	1
354	1	FSU	Family Supreme	1	18	1
354	2	+	+anchovie olives pinea; salami coke cheese olicers fuck	1	1	1
355	1	ESMA	Entree Spaghetti Marinara with lots of prawns and a huge heap of chilli and some more things and some anchovies and that sort of stuff, all put together in a little brown box, with red ribbons and one of those little silver star things	1	9	1
356	1	FHW	Family Hawiian	1	16.5	1
356	2	FX	EXTRAsalami	1	1	1
356	3	FSG	Family SanGiorgio	1	18	1
356	4	FSU	Family Supreme	1	18	1
357	1	FX	EXTRA Dear Lisa , how are you today good that's good . What are you doing, are you working or talking you fuckwit.	1	1	1
358	1	2F	2 Family Pizzas	1	25.9	1
358	2	HALF	1/2chick haw	1	0	1
358	3	HALF	1/2veg	1	0	1
358	4	HALF	1/2s.giorgio	1	0	1
358	5	HALF	1/2mexican	1	0	1
358	6	+	+garlic on all ov them	0	0	1
359	1	MCNA	Ricotta Ravioli Napolitana	1	9	1
359	2	GB	Garlic Bread	1	2	1
359	3	COKE	1.25 Ltr Coke	1	3	1
359	4	HB	Herb Bread	1	2	1
360	1	F	FAM	1	18	1
360	2	HALF	1/2cfood	1	0	1
360	3	HALF	1/2s.giorgio plus little chilli	1	0	1
361	1	FCP	Family Capriciosa	1	17	1
361	2	FCP	Family Capriciosa	1	17	1
361	3	COKE	1.25 Ltr Coke	3	9	1
362	1	CR	Calzone Rustico	1	10.5	1
362	2	GB	Garlic Bread	1	2	1
363	1	F	FAM PEP MUSH ONION FRESH TOM FRESH BASIL	1	18	1
363	2	FX	EXTRACHEESE	1	1	1
364	1	2F	2 Family Pizzas	1	25.9	1
364	2	FSG	Family SanGiorgio	0	0	1
364	3	F	FAM HALF CFOOD	0	0	1
364	4	FX	EXTRAMUSSELS	1	1	1
364	5	HALF	1/2MEXICAN	0	0	1
364	6	GB	Garlic Bread	3	6	1
364	7	CHIN	BOTTLE OF CHINOTTO	2	7	1
365	1	L	LARGE	1	13.5	1
365	2	HALF	1/2MEXICAN	1	0	1
365	3	HALF	1/2S GIORGIO	1	0	1
365	4	COKE	1.25 Ltr Coke	1	3	1
366	1	2S	2 Small Pizzas	1	16.9	1
366	2	SSG	Small SanGiorgio	0	0	1
366	3	--	ONE NO OLIVE	0	0	1
366	4	GB	Garlic Bread	3	6	1
366	5	COKE	1.25 Ltr Coke	1	3	1
366	6	MSBO	Spaghetti Bolognese	1	9.5	1
366	7	MFBO	Fettucini Bolognese	1	9.5	1
367	1	2L	2 Large Pizzas	1	19.9	1
367	2	LSU	Large Supreme	0	0	1
367	3	LSU	Large Supreme	0	0	1
367	4	NO	NoANCH ON ONE	1	0	1
367	5	COKE	1.25 Ltr Coke	1	3	1
368	1	LSG	Large SanGiorgio	1	13.5	1
369	1	GB	Garlic Bread	1	2	1
369	2	LMA	Large Margherita	1	11.5	1
369	3	LX	EXTRACHEESE MUSH	2	1.4	1
369	4	CDIET	CAN OF DIET COKE	1	1.7	1
370	1	MRAP	Ravioli Alla Panna	1	10	1
370	2	MLA	Main Lasagna	1	9.5	1
370	3	GB	Garlic Bread	1	2	1
371	1	MFAP	Fettucini Alla Panna	1	10	1
371	2	CBR	Continental Bread (3 peices)	2	1.2	1
372	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
372	2	HALF	1/2VEG	1	0	1
372	3	HALF	1/2SUP	1	0	1
372	4	VISA	4564150230743612	0	0	1
372	5	EXP	09/98	0	0	1
373	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
373	2	LVG	Large Vegetarian	0	0	1
373	3	LX	EXTRA sun dry tom	1	0.7	1
374	1	SPC	Small Pizza, 1 Can Coke	1	10	1
374	2	SSE	Small Seafood	0	0	1
375	1	SPC	Small Pizza, 1 Can Coke	1	10	1
375	2	S	SMALL veg , no olives but with extra pineapple	0	0	1
376	1	CR	Calzone Rustico	1	10.5	1
376	2	DBF	Black Forrest Cake	1	4	1
376	3	COKE	1.25 Ltr Coke	1	3	1
376	4	CIGS	Cigaretteswinfield blue	1	7.4	1
376	5	50	*****$50.00 NOTE*****	1	0	1
377	1	2L	2 Large Pizzas	1	19.9	1
377	2	LSU	Large Supreme	0	0	1
377	3	LML	Large Meat Lovers	0	0	1
378	1	2L	2 Large Pizzas	1	19.9	1
378	2	L	LARGE PEPP CHICK MUS	0	0	1
378	3	LSU	Large Supreme	0	0	1
378	4	LX	EXTRA TWO EGGS	2	1.4	1
379	1	FSG	Family SanGiorgio	1	18	1
380	1	MFCB	Fettucini Carbonara	1	10	1
380	2	MMBO	Macaroni Bolognese	1	9.5	1
380	3	50	*****$50.00 NOTE*****	1	0	1
381	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
381	2	L	LARGEsupreme	0	0	1
381	3	LX	EXTRAherbs cheese sauce	2	1.4	1
382	1	MTAP	Tortellini Alla Panna	1	10	1
382	2	GB	Garlic Bread	1	2	1
382	3	DCA	Cassata	1	3.5	1
383	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
383	2	FSU	Family Supreme - ANC	0	0	1
384	1	MMNA	Macaroni Napolitana	1	9	1
384	2	MMCB	Macaroni Carbonara	1	10	1
384	3	GB	Garlic Bread	1	2	1
384	4	50	*****$50.00 NOTE*****	1	0	1
385	1	CR	Calzone Rustico	1	10.5	1
385	2	MLA	Main Lasagna	1	9.5	1
385	3	COKE	1.25 Ltr Coke	2	6	1
385	4	GB	Garlic Bread	1	2	1
386	1	GB	Garlic Bread	1	2	1
386	2	F	FAMGOURMET VEG	1	18	1
386	3	FX	EXTRA	2	2	1
386	4	COKE	1.25 Ltr Coke	1	3	1
387	1	LVG	Large Vegetarian	1	12.5	1
387	2	NO	NoMUSH	1	0	1
387	3	LX	EXTRAF.TOM AND ARTICHOKE	2	1.4	1
388	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
388	2	F	FAM SAN GIORGIO	0	0	1
388	3	HALF	1/2NO OLIVES	1	0	1
389	1	2L	2 Large Pizzas	1	19.9	1
389	2	LVG	Large Vegetarian	0	0	1
389	3	LSU	Large Supreme- ANC	0	0	1
389	4	HALF	1/2 PIN 1/2 OLI	1	0	1
390	1	L	LARGE	1	13.5	1
390	2	HALF	1/2LOT NO SEAFOOD	1	0	1
390	3	HALF	1/2HAM MUSH SAL BASIL FRESH TOMATO CHILLI	1	0	1
390	4	GB	Garlic Bread	1	2	1
390	5	50	*****$50.00 NOTE*****	1	0	1
391	1	L	LARGE	1	13.5	1
391	2	+	+ FR TOM SAL CHILLI	0	0	1
391	3	GB	Garlic Bread	1	2	1
391	4	CCOKE	Can of Coke	1	1.7	1
392	1	MLA	Main Lasagna	1	9.5	1
392	2	SSU	Small Supreme - OL ANC PIN	1	9.5	1
392	3	COKE	1.25 Ltr Coke	1	3	1
393	1	MLA	Main Lasagna	1	9.5	1
393	2	OND	Dozen Oysters Natural	1	13	1
394	1	LSU	Large Supreme	1	13.5	1
394	2	NO	No ANC PIN	1	0	1
394	3	ESBO	Entree Spaghetti Bolognese	1	7	1
394	4	GB	Garlic Bread	1	2	1
395	1	2F	2 Family Pizzas	1	25.9	1
395	2	FSG	Family SanGiorgio	0	0	1
395	3	FSE	Family Seafood	0	0	1
395	4	FX	EXTRA CHEESE OLI	2	2	1
396	1	FSU	Family Supreme	1	18	1
396	2	FX	EXTRA ANC	1	1	1
397	1	LML	Large Meat Lovers	1	13	1
397	2	LX	EXTRA CHEESE ,MUSH	2	1.4	1
397	3	MSCB	Spaghetti Carbonara	1	10	1
398	1	FMA	Family Margherita	1	15	1
398	2	CHIPS	Chips	1	3.5	1
398	3	+	+SAUCE	1	1	1
398	4	COKE	1.25 Ltr Coke	1	3	1
398	5	GB	Garlic Bread	1	2	1
399	1	LMX	Large Mexican	1	13	1
400	1	MSBO	Spaghetti Bolognese	2	19	1
400	2	MTAP	Tortellini Alla Panna	2	20	1
400	3	+	+NAP SAUCE	0	0	1
400	4	GB	Garlic Bread	1	2	1
400	5	GS	Greek Salad	2	11	1
401	1	MTNA	Tortellini Napolitana	1	9	1
401	2	DAPG	Apple Pie with Gelati	1	3.5	1
402	1	+	+SMALL HAM MUSH	1	9	1
402	2	SMX	Small Mexican	1	9.5	1
402	3	GB	Garlic Bread	2	4	1
403	1	F	FAM	1	18	1
403	2	HALF	1/2SUP NO ANCH OR OLIVES	1	0	1
403	3	HALF	1/2chick haw	1	0	1
403	4	GB	Garlic Bread	1	2	1
404	1	PFM	FAMILY PICK-UP	2	25.8	1
404	2	FHW	Family Hawiian	0	0	1
404	3	FX	EXTRA cheese	1	1	1
404	4	FSU	Family Supreme no anch no onion	0	0	1
404	5	FX	EXTRA cheese	1	1	1
405	1	FMA	Family Margherita	1	15	1
405	2	FX	EXTRAham	1	1	1
405	3	GB	Garlic Breadc	1	2	1
406	1	MFPU	Fettucini Putanesca	1	9.5	1
406	2	GS	Greek Salad	1	5.5	1
406	3	COKE	1.25 Ltr Coke	1	3	1
407	1	2L	2 Large Pizzas	1	19.9	1
407	2	L	LARGEhaw	0	0	1
407	3	LX	EXTRApep	1	0.7	1
407	4	BBQ	BBQ Sauce	1	1	1
407	5	L	LARGE meatlovers	0	0	1
407	6	LX	EXTRAcap	1	0.7	1
407	7	BBQ	BBQ Sauce	1	1	1
408	1	SPC	Small Pizza, 1 Can Coke	1	10	1
408	2	SMX	Small Mexican	0	0	1
409	1	2F	2 Family Pizzas	1	25.9	1
409	2	FVG	Family Vegetarian	0	0	1
409	3	FX	EXTRAHAM	1	1	1
409	4	HALF	1/2HAW	1	0	1
409	5	HALF	1/2MEATLOVERS	1	0	1
409	6	FX	EXTRAANCHOVIES	1	1	1
410	1	LVG	Large Vegetarian HALF	1	12.5	1
410	2	LX	EXTRA POTATOE + CHILI	1	0.7	1
410	3	HALF	1/2 SAN G NO OLIVES	1	0	1
410	4	LX	EXTRA MUSH	1	0.7	1
410	5	GB	Garlic Bread	1	2	1
411	1	L	LARGESALAMI FRESH TOMATO SUNDRIED TOMATO CAP MUSH	1	13.5	1
411	2	LX	EXTRA	1	0.7	1
412	1	2L	2 Large Pizzas	1	19.9	1
412	2	LSP	Large Special	0	0	1
412	3	NO	NoOLIVES	1	0	1
412	4	LX	EXTRAPRAWNS AND PINE	2	1.4	1
412	5	LAM	Large American	0	0	1
412	6	LX	EXTRAMUSHROOMS	1	0.7	1
412	7	GB	Garlic Bread	1	2	1
412	8	HB	Herb Bread	1	2	1
413	1	STMS	Scaloppina Mushroom	1	11.5	1
413	2	MIN	Minestrone Soup	1	4.5	1
414	1	2F	2 Family Pizzas	1	25.9	1
414	2	FSU	Family Supreme	0	0	1
414	3	FCH	Family Chicken Hawiian	0	0	1
414	4	FX	EXTRA MUSH	1	1	1
414	5	FX	EXTRA ONION	1	1	1
415	1	2F	2 Family Pizzas	1	25.9	1
415	2	FSU	Family Supreme	0	0	1
415	3	FSU	Family Supreme	0	0	1
416	1	LSU	Large Supreme	1	13.5	1
416	2	MFAP	Fettucini Alla Panna	1	10	1
416	3	DAPC	Apple Pie with Cream	1	3.5	1
416	4	COKE	1.25 Ltr Coke	1	3	1
417	1	LVG	Large Vegetarian	1	12.5	1
417	2	LX	EXTRACHICKEN	1	0.7	1
417	3	GB	Garlic Bread	1	2	1
418	1	2L	2 Large Pizzas	1	19.9	1
418	2	LSU	Large SupremeNO PINE	0	0	1
418	3	LMX	Large Mexican	0	0	1
418	4	LX	EXTRAPINEAPPLE	1	0.7	1
418	5	COKE	1.25 Ltr Coke	1	3	1
419	1	F	FAM	1	18	1
419	2	HALF	1/2VEG NO MUSH	1	0	1
419	3	HALF	1/2SAN GIORGIO	1	0	1
419	4	GB	Garlic Bread	1	2	1
420	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
420	2	FVG	Family Vegetarian	0	0	1
421	1	LHW	Large Hawiian	1	12.5	1
422	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
422	2	LSU	Large Supreme NO ANCH	0	0	1
423	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
423	2	LSU	Large Supreme NO ANCH	0	0	1
424	1	MGP	Main Garlic Prawns	1	16.5	1
424	2	+	+ chips	1	1.8	1
424	3	SCP	Small Capriciosa	1	9	1
425	1	STDMW	Steak Dianne - Md Well Done	1	15	1
425	2	GB	Garlic Bread	1	2	1
425	3	CHAV	Chicken Avocado	1	14	1
426	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
426	2	FSU	Family Supreme	0	0	1
426	3	DEL	$1.00	0	0	1
427	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
427	2	FSU	Family Supreme	0	0	1
427	3	--	- PIN 1/2 -ANCH	0	0	1
428	1	2L	2 Large Pizzas	1	19.9	1
428	2	LVG	Large Vegetarian	0	0	1
428	3	--	- PIN	0	0	1
428	4	LSP	Large Special	0	0	1
429	1	OND	Dozen Oysters Natural	1	13	1
429	2	SD	Soup of the Day	1	4.5	1
429	3	MGP	Main Garlic Prawns	1	16.5	1
430	1	2L	2 Large Pizzas	1	19.9	1
430	2	LSU	Large Supreme -ANCH	0	0	1
430	3	LAM	Large American	0	0	1
430	4	NO	No SAL +PEPP	0	0	1
431	1	L	LARGE	1	13.5	1
431	2	HALF	1/2CFOOD	1	0	1
431	3	HALF	1/2LOT	1	0	1
431	4	GB	Garlic Bread	1	2	1
432	1	STVP	Veal Parmigiana	1	14	1
432	2	FS	French Salad	1	4	1
432	3	OKD	Dozen Oysters Kilpatrick	1	14.5	1
432	4	COKE	1.25 Ltr Coke	1	3	1
432	5	DLGE	large gelati cup	1	6	1
432	6	--	VAN,BACI, PIST,	0	0	1
433	1	CR	Calzone Rustico	1	10.5	1
434	1	SAM	Small American	1	9	1
434	2	MMAP	Macaroni Alla Panna	1	10	1
434	3	NO	NoHAM	1	0	1
434	4	+	+CREAM CHICKEN SDRY TOM MUSH	1	3.5	1
434	5	HB	Herb Bread	1	2	1
435	1	LML	Large Meat Lovers	1	13	1
435	2	LX	EXTRA CHICKEN	1	0.7	1
435	3	COKE	1.25 Ltr Coke	1	3	1
436	1	LSU	Large Supreme	1	13.5	1
436	2	GB	Garlic Bread	1	2	1
436	3	50	*****$50.00 NOTE*****	1	0	1
436	4	+	+CHILLI	0	0	1
436	5	+	+COOKED WELL DONE	0	1	1
437	1	2L	2 Large Pizzas	1	19.9	1
437	2	LSU	Large Supreme	0	0	1
437	3	LSU	Large Supreme	0	0	1
437	4	NO	NoPRAWNS ANCH AND PINE	1	0	1
438	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
438	2	LCH	Large Chicken Hawiian	0	0	1
439	1	ELA	Entree Lasagna	1	6.75	1
439	2	+	+ENT. SEVE OF POTATOES	1	3.5	1
440	1	2L	2 Large Pizzas	1	19.9	1
440	2	LSU	Large Supreme -ANCH	0	0	1
440	3	LHW	Large Hawiian	0	0	1
441	1	SSP	Small Special	1	9	1
441	2	GB	Garlic Bread	1	2	1
442	1	LSU	Large Supreme	1	13.5	1
442	2	GB	Garlic Bread	1	2	1
443	1	2L	2 Large Pizzas	1	19.9	1
443	2	HALF	1/2SUP NO ANCH	1	0	1
443	3	HALF	1/2HAW	1	0	1
443	4	HALF	1/2SUP NO ANCH	1	0	1
443	5	HALF	1/2AUST	1	0	1
443	6	FVG	Family Vegetarian	1	17	1
443	7	FX	EXTRAANCH	1	1	1
443	8	ETMA	Entree Tortelline Marinara	1	9	1
443	9	MCMA	Ricotta Ravioli Marinara	1	11.5	1
444	1	2L	2 Large Pizzas	1	19.9	1
444	2	LHW	Large Hawiian	0	0	1
444	3	LSU	Large Supreme	0	0	1
444	4	LAM	Large American -SAL +PEPP	1	12.5	1
444	5	LX	EXTRA CHEESE	1	0.7	1
445	1	FSU	Family Supreme	1	18	1
445	2	CR	Calzone Rustico	1	10.5	1
446	1	2L	2 Large Pizzas	1	19.9	1
446	2	LSG	Large SanGiorgio	0	0	1
446	3	LSU	Large Supreme	0	0	1
447	1	2L	2 Large Pizzas	1	19.9	1
447	2	LSU	Large Supreme	0	0	1
447	3	NO	NoCAP	1	0	1
447	4	LSU	Large Supreme	0	0	1
447	5	LX	EXTRAF TOM ON BOTH	2	1.4	1
448	1	F	FAM	1	18	1
448	2	HALF	1/2HAW	1	0	1
448	3	HALF	1/2GOURMET VEG	1	0	1
448	4	FX	EXTRA	2	2	1
449	1	FSU	Family Supreme	1	18	1
449	2	FX	EXTRACHICK,BBQ	2	2	1
449	3	HALF	1/2OLIVES	0	0	1
449	4	-	-ANCHI	0	0	1
450	1	FSU	Family Supreme	1	18	1
450	2	NO	NoANCH OR OLIVES	1	0	1
450	3	GB	Garlic Bread	1	2	1
451	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
451	2	FSU	Family Supreme NO ANCH	0	0	1
452	1	LSG	Large SanGiorgio	1	13.5	1
452	2	LX	EXTRA CHILLI	0	0	1
453	1	+	CHICKEN SCHNITZEL	1	14	1
453	2	GRAVY	GRAVY FOR CHICKEN	1	2	1
453	3	+	+VEGETABLES	0	0	1
453	4	STDWD	Steak Dianne - Well Done	1	15	1
453	5	NO	No SAUCE ADD MUSH SAUCE	0	0	1
453	6	HB	Herb Bread	1	2	1
453	7	DCOKE	1.25 LTR DIET COKE	1	3	1
454	1	ESBO	Entree Spaghetti Bolognese	1	7	1
454	2	CR	Calzone Rustico	1	10.5	1
454	3	COKE	1.25 Ltr Coke	1	3	1
455	1	LSU	Large Supreme - SEA	1	13.5	1
455	2	GB	Garlic Bread	1	2	1
455	3	50	*****$50.00 NOTE*****	1	0	1
456	1	FSG	Family SanGiorgio	1	18	1
456	2	GB	Garlic Bread	1	2	1
457	1	2L	2 Large Pizzas	1	19.9	1
457	2	L	LARGE HAM+CHEESE	0	0	1
457	3	L	LARGE SPECIAL	0	0	1
458	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
458	2	HALF	1/2ham pin sal	1	0	1
458	3	HALF	1/2 supreme	1	0	1
459	1	2L	2 Large Pizzas	1	19.9	1
459	2	LSG	Large SanGiorgio	0	0	1
459	3	LSU	Large Supreme	0	0	1
460	1	STD	Steak Dianne (M)	1	15	1
460	2	STVP	Veal Parmigiana	1	14	1
461	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
461	2	LVG	Large Vegetarian	0	0	1
461	3	LX	EXTRA ANCH+ FR.TOM	2	1.4	1
462	1	2F	2 Family Pizzas	1	25.9	1
462	2	FCP	Family Capriciosa	0	0	1
462	3	FSU	Family Supreme	0	0	1
462	4	2L	2 Large Pizzas	1	19.9	1
462	5	L	LARGEHAM PEP OLIVES	0	0	1
462	6	LHW	Large Hawiian	0	0	1
462	7	LX	EXTRAPRAWNS	1	0.7	1
463	1	SPC	Small Pizza, 1 Can Coke	1	10	1
463	2	SCH	Small Chicken Hawiian	0	0	1
463	3	CR	Calzone Rustico	2	21	1
463	4	CCOKE	Can of Coke	2	3.4	1
464	1	2L	2 Large Pizzas	1	19.9	1
464	2	L	LARGE FR.TOM,CAPS,EX PRAWNS,PINE,ONIONS,OLIVES,HERBS	0	0	1
464	3	L	LARGE HAM,COOKED ONIONS	0	0	1
464	4	LX	EXTRA cheese	1	0.7	1
464	5	COKE	1.25 Ltr Coke	1	3	1
465	1	L	LARGE	1	13.5	1
465	2	HALF	1/2chick hawaiian	1	0	1
465	3	HALF	1/2supreme	1	0	1
465	4	GB	Garlic Bread	1	2	1
466	1	MMBO	Macaroni Bolognese	1	9.5	1
467	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
467	2	L	LARGESUP NO OLIVES OR ANCH	0	0	1
468	1	2F	2 Family Pizzas	1	25.9	1
468	2	FVG	Family Vegetarian	0	0	1
468	3	FSG	Family SanGiorgio	0	0	1
468	4	NO	Nosalami with anchovies instead	1	0	1
468	5	COKE	1.25 Ltr Coke	1	3	1
469	1	CHGR	Grilled Chicken	1	13	1
469	2	NO	Nosalad  ADD VEGETABLES	1	0	1
469	3	GRAVY	Gravy for chicken	1	2	1
469	4	CHGR	Grilled Chicken	1	13	1
469	5	NO	No DRESSING	1	0	1
469	6	HB	Herb Bread	1	2	1
470	1	2L	2 Large Pizzas	1	19.9	1
470	2	LSE	Large Seafood	0	0	1
470	3	L	LARGE HALF HAW	0	0	1
470	4	HALF	1/2 MEATLOVERS	1	0	1
470	5	MENU		0	0	1
471	1	FMA	Family Margherita	1	15	1
471	2	CLMND	Can of Lemonade	3	5.1	1
472	1	2F	2 Family Pizzas	1	25.9	1
472	2	FSU	Family Supreme	0	0	1
472	3	HALF	1/2NO ANCHOVIES	1	0	1
472	4	HALF	1/2MEATLOVERS	1	0	1
472	5	HALF	1/2MEXICAN	1	0	1
472	6	GB	Garlic Bread	1	2	1
473	1	PFM	FAMILY PICK-UP	1	12.9	1
473	2	PFM	FAMILY PICK-UP HALF SAN G	1	12.9	1
473	3	HALF	1/2 CAPRICIOSA	1	0	1
473	4	FHW	Family Hawiian	0	0	1
473	5	FX	EXTRA F/TOMS MUSH ANCH HALF	3	3	1
473	6	GB	Garlic Bread	1	2	1
473	7	COKE	1.25 Ltr Coke	1	3	1
474	1	MLA	Main Lasagna	1	9.5	1
474	2	GB	Garlic Bread	1	2	1
475	1	FSU	Family Supreme	1	18	1
475	2	FCP	Family Capriciosa	1	17	1
476	1	2F	2 Family Pizzas	1	25.9	1
476	2	F	FAM SAN GIORGIO	0	0	1
476	3	F	FAM MEAT LOVERS	0	0	1
476	4	GB	Garlic Bread	1	2	1
476	5	COKE	1.25 Ltr Coke	1	3	1
477	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
477	2	L	LARGE SAN GIORGIO	0	0	1
477	3	LX	EXTRA PIN	1	0.7	1
478	1	LVG	Large Vegetarian	1	12.5	1
478	2	GB	Garlic Bread	1	2	1
478	3	+	+MINIMUM ORDER	1	0.5	1
478	4	CCOKE	Can of Coke	2	3.4	1
479	1	LVG	Large Vegetarian	1	12.5	1
479	2	LX	EXTRASALAMI CHILLI	1	0.7	1
479	3	NO	NoPINEAPPLE	1	0	1
479	4	GS	Greek Salad	1	5.5	1
480	1	SVG	Small Vegetarian	1	9	1
480	2	GB	Garlic Bread	1	2	1
480	3	ETNA	Entree Tortelline Napoletana	1	7	1
480	4	ETAP	Entree Tortelline Alla Panna	1	8	1
481	1	MCPU	Ricotta Ravioli Putanesca	1	9.5	1
481	2	GS	Greek Salad	1	5.5	1
482	1	FAU	Family Australian	1	16	1
482	2	EFAP	Entree Fettucini Alla Panna	1	8	1
482	3	COKE	1.25 Ltr Coke	1	3	1
483	1	LSG	Large SanGiorgio	1	13.5	1
484	1	SSE	Small Seafood	1	9.5	1
484	2	+	+HERBS GARLIC MUSSELS CALAMARI	1	1.5	1
484	3	SX	EXTRACHEESE	1	0.5	1
484	4	GB	Garlic Bread	1	2	1
484	5	CCOKE	Can of Coke	1	1.7	1
485	1	F	FAM	1	18	1
485	2	HALF	1/2GOURMET VEG	1	0	1
485	3	FX	EXTRAFRESH TOMATO	1	1	1
485	4	HALF	1/2LOT	1	0	1
485	5	+	+EXTRA AMOUNT FOR GOURMET	2	2	1
486	1	2L	2 Large Pizzas	1	19.9	1
486	2	LSU	Large Supreme	0	0	1
487	1	2F	2 Family Pizzas	1	25.9	1
487	2	FSU	Family Supreme	0	0	1
487	3	FX	EXTRAANCHOVESCHILLI	1	1	1
487	4	FSU	Family Supreme	0	0	1
487	5	GB	Garlic Bread	2	4	1
488	1	LSG	Large SanGiorgio	1	13.5	1
488	2	COKE	1.25 Ltr Coke	1	3	1
489	1	MCAP	Ricotta Ravioli Alla Panna	1	10	1
489	2	NO	No MUSH	1	0	1
489	3	GB	Garlic Bread	1	2	1
490	1	F	FAM	1	18	1
490	2	HALF	1/2LOT -ANCH	1	0	1
490	3	HALF	1/2BARBECUE CHICK HAW	1	0	1
490	4	BBQ	BBQ Sauce	1	1	1
491	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
491	2	HALF	1/2CFOOD	1	0	1
491	3	HALF	1/2 LOT	1	0	1
491	4	+	+GARLIC OREGANO	1	1	1
492	1	FSU	Family Supreme	1	18	1
492	2	NO	No OLIVES AND ANCHOVIES	1	0	1
493	1	MRBO	Ravioli Bolognese	1	9.5	1
493	2	SMX	Small Mexican	1	9.5	1
493	3	NO	No OLIVES	1	0	1
493	4	COKE	1.25 Ltr Coke	1	3	1
494	1	FVG	Family Vegetarian - PINE	1	17	1
494	2	FX	EXTRA CHEESE,OLIVES	2	2	1
495	1	FSU	Family Supreme	1	18	1
495	2	NO	No OLIVES	1	0	1
495	3	C		0	0	1
496	1	F	FAM PEPP,EX CHEESE THIN CRISPY	1	18	1
496	2	SSU	Small Supreme	1	9.5	1
496	3	DCOKE	1.25 LTR DIET COKE	1	3	1
497	1	F	FAM	1	18	1
497	2	HALF	1/2 VEG	1	0	1
497	3	HALF	1/2 LOT -PINE	1	0	1
498	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
498	2	LSU	Large Supreme - ANCH	0	0	1
499	1	FVG	Family Vegetarian	1	17	1
499	2	DGE	Gelati CupBACI CHOC PIST	1	4	1
499	3	DGE	Gelati CupBACI PIST	1	4	1
500	1	MRAP	Ravioli Alla Panna	1	10	1
500	2	NO	No MUSHROOMS	1	0	1
500	3	+	+CAPSICUM , CHICKEN, LITTLE CHILLI	1	2	1
500	4	SMA	Small Margherita	1	8	1
500	5	SX	EXTRA SALAMI, HERBS	1	0.5	1
501	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
501	2	LVG	Large Vegetarian	0	0	1
501	3	LX	EXTRA ANCH FR.TOM	2	1.4	1
502	1	LSU	Large Supreme	1	13.5	1
502	2	GB	Garlic Bread	1	2	1
503	1	2L	2 Large Pizzas	1	19.9	1
503	2	2+	SAN GIORGIO	0	0	1
504	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
504	2	FAM	Family American	0	0	1
504	3	FX	EXTRAMUSHROOMS	1	1	1
504	4	HALF	1/2 PINEAPPLE	1	0	1
505	1	LML	Large Meat Lovers	1	13	1
505	2	MRNA	Ravioli Napolitana	1	9	1
505	3	COKE	1.25 Ltr Coke	1	3	1
506	1	PFM	FAMILY PICK-UP	1	12.9	1
506	2	FSU	Family Supreme	0	0	1
507	1	LSP	Large Special	1	12.5	1
507	2	GS	Greek Salad	1	5.5	1
507	3	DGE	Gelati Cup PIST,COFF,BACI	1	4	1
508	1	MLA	Main Lasagna	1	9.5	1
508	2	MSPU	Spaghetti Putanesca	1	9.5	1
508	3	ECVG	Entree Ricotta Ravioli Vegetarian	1	7	1
508	4	GB	Garlic Bread	1	2	1
509	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
509	2	HALF	1/2 HAW PLUS PEPPERONI	1	0	1
509	3	HALF	1/2 HAM MUSH CAP ONION FRESH TOMATO	0	0	1
509	4	LX	EXTRA FOR TOPPINGS	1	0.7	1
510	1	LSU	Large Supreme	1	13.5	1
510	2	EFCB	Entree Fettucini Carbonara	1	8	1
511	1	STSZ	Scaloppina Zingara	1	11.5	1
511	2	DCC	Cheese Cake	1	3.5	1
511	3	CCOKE	Can of Coke	2	3.4	1
512	1	PFM	FAMILY PICK-UP	1	12.9	1
512	2	FMA	Family Margherita  + CHILLI	0	0	1
512	3	+	+BOTTLE H2O	1.7	1.7	1
513	1	STVP	Veal Parmigiana	1	14	1
513	2	STMS	Scaloppina Mushroom	1	11.5	1
513	3	COKE	1.25 Ltr Coke	1	3	1
514	1	2L	2 Large Pizzas	1	19.9	1
514	2	LMX	Large Mexican	0	0	1
514	3	LSG	Large SanGiorgio	0	0	1
515	1	CHGR	Grilled Chicken	1	13	1
515	2	STSH	Schnitzel	1	10.5	1
515	3	DIANE	DIANNE SAUCE	1	2.8	1
515	4	GB	Garlic Bread	1	2	1
515	5	CHIPS	Chips	1	3.5	1
515	6	+	+ CUTTLERY	0	0	1
516	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
516	2	LHW	Large Hawiian	0	0	1
516	3	LX	EXTRA PEPPERONI	1	0.7	1
517	1	CR	Calzone Rustico	2	21	1
517	2	+	+SAUCE IN SEPERATE CONTAINERS	1	1	1
517	3	DIS	Discount	1	-2	1
518	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
518	2	HALF	1/2HAW	1	0	1
518	3	HALF	1/2 VEG	1	0	1
519	1	MGP	Main Garlic Prawns	1	16.5	1
520	1	FSG	Family SanGiorgio	1	18	1
520	2	HALF	1/2 VEG	1	0	1
521	1	FSU	Family Supreme	1	18	1
521	2	FX	EXTRA MUSHROOM	1	1	1
521	3	COKE	1.25 Ltr Coke	1	3	1
522	1	L	LARGE	1	13.5	1
522	2	VEG	1/2 VEGETARIAN + PRAWNS	1	0	1
522	3	SUP	1/2 SUPREME - OLI ANC	1	0	1
522	4	LX	EXTRA	1	0.7	1
522	5	COKE	1.25 Ltr Coke	1	3	1
522	6	GB	Garlic Bread	1	2	1
523	1	MMAP	Macaroni Alla Panna	1	10	1
523	2	+	+CHICKEN BEANS AND ONION AND CAPSICUM	1	4	1
524	1	SSP	Small Special	1	9	1
524	2	EFAP	Entree Fettucini Alla Panna	1	8	1
524	3	DCM	Chocolate Mousse	1	3.5	1
525	1	LSU	Large Supreme	1	13.5	1
525	2	LX	EXTRA chilli	0	0	1
525	3	GB	Garlic Bread	1	2	1
525	4	ERAP	Entree Ravioli Alla Panna	1	8	1
526	1	FHW	Family Hawiian	1	16.5	1
527	1	2L	2 Large Pizzas	1	19.9	1
527	2	LAU	Large Australian	0	0	1
527	3	LX	EXTRAegg	1	0.7	1
527	4	LSU	Large Supreme	0	0	1
527	5	COKE	1.25 Ltr Coke	1	3	1
528	1	MRCB	Ravioli Carbonara	1	10	1
528	2	CR	Calzone Rustico	1	10.5	1
529	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
529	2	LSP	Large Special	0	0	1
529	3	LX	EXTRA chick	1	0.7	1
529	4	BBQ	BBQ Sauce	1	1	1
529	5	HALF	1/2 olives	1	0	1
530	1	MSBO	Spaghetti Bolognese	1	9.5	1
530	2	OKD	Dozen Oysters Kilpatrick	1	14.5	1
530	3	COKE	1.25 Ltr Coke	1	3	1
531	1	L	LARGE	1	13.5	1
531	2	HALF	1/2supreme	1	0	1
531	3	HALF	1/2 veg	1	0	1
531	4	ETCB	Entree Tortelline Carbonara	1	8	1
531	5	COKE	1.25 Ltr Coke	1	3	1
532	1	2L	2 Large Pizzas	1	19.9	1
532	2	LSU	Large Supreme	0	0	1
532	3	LX	EXTRA anch	1	0.7	1
532	4	LSG	Large SanGiorgio	0	0	1
532	5	PSM	SMALL PICK-UP	1	6.9	1
532	6	SCH	Small Chicken Hawiian	0	0	1
533	1	2L	2 Large Pizzas	1	19.9	1
533	2	LHW	Large Hawiian	0	0	1
533	3	LSU	Large Supreme	0	0	1
533	4	DCC	Cheese Cake	2	7	1
534	1	GB	Garlic Bread	1	2	1
534	2	LAM	Large American	1	12.5	1
534	3	LX	EXTRA F/TOM	1	0.7	1
534	4	LX	EXTRA ONION	1	0.7	1
534	5	LX	EXTRA HAM	1	0.7	1
534	6	PLUS	GARLIC	0	0	1
536	1	FSU	Family Supreme EX SAUCE	1	18	1
537	1	CHAV	Chicken Avocado	1	14	1
537	2	CCOKE	Can of Coke	1	1.7	1
537	3	CLMND	Can of Lemonade	1	1.7	1
537	4	SML	Small Meat Lovers	1	9.5	1
539	1	SSU	Small Supreme	1	9.5	1
539	2	COKE	1.25 Ltr Coke	1	3	1
540	1	PLG	LARGE PICK-UP	1	9.9	1
540	2	LAU	Large Australian	0	0	1
540	3	LX	EXTRA + MUSHROOM	1	0.7	1
541	1	ELA	Entree Lasagna	1	7.5	1
541	2	DGE	Gelati Cup 1/2LEM 1/2CHOC	1	4	1
542	1	FSG	Family SanGiorgio	1	18	1
543	1	SCH	Small Chicken Hawiian	1	9.5	1
543	2	SX	EXTRA BBQ	1	0.5	1
543	3	SX	EXTRA MUSH	1	0.5	1
543	4	SX	EXTRA EGG	1	0.5	1
543	5	GB	Garlic Bread	1	2	1
543	6	STR	Rump Steak MR	1	13	1
543	7	CHMS	Mushroom Sauce	1	2	1
543	8	CBR	Continental Bread (3 peices)	1	0.6	1
543	9	CFANTA	Can of Fanta	1	1.7	1
543	10	COKE	1.25 Ltr Coke	1	3	1
543	11	CCOKE	Can of Coke	1	1.7	1
544	1	ETPU	Entree Tortelline Putanesca	1	7.5	1
544	2	EFAL	Entree Fettucini Alfredo	1	7	1
544	3	GB	Garlic Bread	1	2	1
544	4	COKE	1.25 Ltr Coke	1	3	1
544	5	50	*****$50.00 NOTE*****	1	0	1
544	6	50	*****$50.00 NOTE*****	1	0	1
545	1	F	FAM	1	18	1
545	2	SUP	1/2 SUPREME	1	0	1
545	3	HALF	1/2 PEPPERONI	1	0	1
546	1	FSU	Family Supreme	1	18	1
546	2	NO	No ANCH	1	0	1
546	3	HALF	1/2 SAL HAM OLI	1	0	1
546	4	FX	EXTRA CHILLI	0	0	1
547	1	CR	Calzone Rustico	1	10.5	1
547	2	GB	Garlic Bread	1	2	1
548	1	PLG	LARGE PICK-UP	1	9.9	1
548	2	LML	Large Meat Lovers	0	0	1
549	1	2L	2 Large Pizzas	1	19.9	1
549	2	L	LARGE CHIC HAW	0	0	1
549	3	HALF	1/2 + ANCH	1	0	1
549	4	L	LARGE HAWAIN	0	0	1
549	5	LX	EXTRA 1/2 + ANCH`	1	0.7	1
550	1	L	LARGE	1	13.5	1
550	2	HALF	1/2 SUPREME	1	0	1
550	3	HALF	1/2 PIN	1	0	1
550	4	GB	Garlic Bread	1	2	1
551	1	MLA	Main Lasagna	1	9.5	1
551	2	PC	Prawn Cocktail	1	8	1
552	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
552	2	LSU	Large Supreme	0	0	1
553	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
553	2	SUP	1/2 SUPREME +CHILLI	1	0	1
553	3	HAW	1/2 HAWAIIN	1	0	1
554	1	2L	2 Large Pizzas	1	19.9	1
554	2	HALF	1/2 H MUSH	1	0	1
554	3	HAW	1/2 HAWAIIN	0	0	1
554	4	LSU	Large Supreme	0	0	1
555	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
555	2	HALF	1/2 HAW	1	0	1
555	3	HALF	1/2 VEG	1	0	1
556	1	2L	2 Large Pizzas	1	19.9	1
556	2	LSU	Large Supreme	0	0	1
556	3	HAW	1/2 HAWAIIN	1	0	1
556	4	VEG	1/2 VEGETARIAN	1	0	1
557	1	2L	2 Large Pizzas	1	19.9	1
557	2	LML	Large Meat Lovers	0	0	1
557	3	LX	EXTRA SALAMI CHEESE	2	1.4	1
557	4	LCH	Large Chicken Hawiian	0	0	1
557	5	LX	EXTRA CHICK CHEESE	2	1.4	1
557	6	HALF	1/2 - PIN	1	0	1
557	7	CIGS	Cigarettes LONGBEACH MILD	1	9.4	1
558	1	MFAP	Fettucini Alla Panna	1	10	1
558	2	CR	Calzone Rustico	1	10.5	1
559	1	2S	2 Small Pizzas	1	16.9	1
559	2	SSU	Small Supreme +CHILLI	0	0	1
560	1	S	SMALL	1	9.5	1
560	2	--	PIN ONI PEPP BAC	0	0	1
560	3	SX	EXTRA CHEESE	1	0.5	1
560	4	CBR	Continental Bread (3 peices)	1	0.6	1
561	1	EMBO	Entree Macaroni Bolognese	1	7	1
561	2	GB	Garlic Bread	2	4	1
561	3	+	+CHICKEN SNITZEL	14	14	1
561	4	FS	French Salad	1	4	1
561	5	PC	Prawn Cocktail	1	8	1
562	1	LSU	Large Supreme	1	13.5	1
562	2	HALF	1/2 + CHILLI	1	0	1
562	3	HB	Herb Bread	1	2	1
563	1	MFPU	Fettucini Putanesca	1	9.5	1
563	2	MTAP	Tortellini Alla Panna	1	10	1
563	3	GB	Garlic Bread	1	2	1
563	4	COKE	1.25 Ltr Coke	1	3	1
564	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
564	2	LSU	Large Supreme no anch	0	0	1
564	3	LX	EXTRA CHEESE	1	0.7	1
565	1	MCPU	Ricotta Ravioli Putanesca	1	9.5	1
565	2	PLUS	PARM ON TOP	0	0	1
565	3	EFMA	Entree Fettucini Marinara	1	9	1
565	4	GB	Garlic Bread	1	2	1
566	1	F	FAM	1	18	1
566	2	HALF	1/2 LOT + CHILI	1	0	1
566	3	HALF	1/2 MARG	1	0	1
567	1	MFPU	Fettucini Putanesca	1	9.5	1
567	2	+	+CAPUCINO	2	2	1
568	1	STSB	Scaloppina Bianco	1	10.5	1
568	2	ERAP	Entree Ravioli Alla Panna	1	8	1
569	1	MTMA	Tortellini Marinara	1	11.5	1
569	2	ERBO	Entree Ravioli Bolognese	1	7	1
570	1	FSU	Family Supreme thin base	1	18	1
570	2	HALF	1/2 no olives no anch	1	0	1
570	3	GB	Garlic Bread	1	2	1
571	1	FVG	Family Vegetarian	1	17	1
571	2	SX	EXTRA MUSH ON 1/2	1	0.5	1
572	1	2L	2 Large Pizzas	1	19.9	1
572	2	HALF	1/2 CHIK HAW	1	0	1
572	3	HALF	1/2 MEAT.L	1	0	1
572	4	LSU	Large Supreme	0	0	1
573	1	L	LARGE GOUR VEG	1	13.5	1
573	2	MSBO	Spaghetti Bolognese	1	9.5	1
574	1	PLG	LARGE PICK-UP	1	9.9	1
574	2	LCH	Large Chicken Hawiian	0	0	1
574	3	LX	EXTRA MUSHROOM	1	0.7	1
575	1	2L	2 Large Pizzas	1	19.9	1
575	2	LSU	Large Supreme	0	0	1
575	3	LCP	Large Capriciosa	0	0	1
575	4	LX	EXTRA PRANS	1	0.7	1
575	5	+	+ CHEESE ON BOTH	0.7	0.7	1
575	6	GB	Garlic Bread	1	2	1
575	7	COKE	1.25 Ltr Coke	1	3	1
576	1	PSM	SMALL PICK-UP	1	6.9	1
576	2	SSU	Small Supreme	0	0	1
576	3	SX	EXTRA +ANCH	1	0.5	1
577	1	ECAP	Entree Ricotta Ravioli Alla Panna	1	8	1
577	2	ERAP	Entree Ravioli Alla Panna	1	8	1
578	1	L	LARGE	1	13.5	1
578	2	PLUS	PEPP CAP OLIVES	0	0	1
578	3	LX	EXTRA F/TOM	1	0.7	1
578	4	LX	EXTRA SAL	1	0.7	1
578	5	LX	EXTRA CHILI	0	0	1
578	6	PLUS	WELL DONE	0	0	1
579	1	F	FAM	1	18	1
579	2	HALF	1/2 SUPREME + CHILI	1	0	1
579	3	HALF	1/2 HAW	1	0	1
580	1	FSG	Family SanGiorgio	1	18	1
580	2	FX	EXTRA PIN	1	1	1
580	3	NO	No ANCH	1	0	1
581	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
581	2	LSU	Large Supreme	0	0	1
582	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
582	2	HALF	1/2 LOT -ANCH	1	0	1
582	3	HALF	1/2 SAN GIORGIO	1	0	1
583	1	PFM	FAMILY PICK-UP	1	12.9	1
583	2	FSU	Family Supreme - PIN	0	0	1
584	1	2L	2 Large Pizzas	1	19.9	1
584	2	LSG	Large SanGiorgio	0	0	1
584	3	LVG	Large Vegetarian	0	0	1
584	4	LX	EXTRA FR.TOM,PEPP,	2	1.4	1
585	1	EFAP	Entree Fettucini Alla Panna	1	8	1
585	2	GB	Garlic Bread	1	2	1
585	3	CCOKE	Can of Coke	1	1.7	1
585	4	DCC	Cheese Cake	1	3.5	1
586	1	2L	2 Large Pizzas	1	19.9	1
586	2	LSP	Large Special	0	0	1
586	3	LX	EXTRA POTATO,CHILLI	1	0.7	1
586	4	HALF	1/2CHICK.HAW	1	0	1
586	5	HALF	1/2 SAN.G	1	0	1
587	1	2L	2 Large Pizzas	1	19.9	1
587	2	LSU	Large Supreme  -ANCH	0	0	1
587	3	LSU	Large Supreme -ANCH, - OLIVES	0	0	1
588	1	2L	2 Large Pizzas	1	19.9	1
588	2	LCH	Large Chicken Hawiian	0	0	1
588	3	LMX	Large Mexican	0	0	1
588	4	ETCB	Entree Tortelline Carbonara	1	8	1
588	5	GB	Garlic Bread	1	2	1
589	1	MLA	Main Lasagna - SAUCE	1	9.5	1
589	2	GB	Garlic Bread	1	2	1
590	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
590	2	LSU	Large Supreme	0	0	1
590	3	--	PRAWNS PINE	0	0	1
590	4	HALF	1/2 - ANCH	1	0	1
591	1	PFM	FAMILY PICK-UP	1	12.9	1
591	2	SUP	1/2 SUPREME	1	0	1
591	3	HAW	1/2 HAWAIIN	1	0	1
592	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
592	2	VEG	1/2 VEGETARIAN	1	0	1
592	3	HALF	1/2 MEAT.L.	1	0	1
592	4	LX	EXTRA FR.TOM ,LITTLE CHILLI	1	0.7	1
593	1	STP	Pepper Steak ( M)	1	15	1
594	1	STVP	Veal Parmigiana	1	14	1
594	2	MIN	Minestrone Soup	1	4.5	1
595	1	MFPU	Fettucini Putanesca	1	9.5	1
595	2	GB	Garlic Bread	1	2	1
596	1	PFM	FAMILY PICK-UP	1	12.9	1
596	2	SPE	1/2 SPECIAL	1	0	1
596	3	HAW	1/2 HAWAIIN	1	0	1
596	4	GB	Garlic Bread	2	4	1
597	1	LAU	Large Australian	1	12	1
597	2	COKE	1.25 Ltr Coke	1	3	1
598	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
598	2	FVG	Family Vegetarian	0	0	1
598	3	FX	EXTRA ANCH	1	1	1
598	4	FX	EXTRA FR TOM	1	1	1
598	5	HALF	1/2 -- OLIVES	1	0	1
599	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
599	2	HAW	1/2 HAWAIIN	1	0	1
599	3	SUP	1/2 SUPREME	1	0	1
600	1	CR	Calzone Rustico	1	10.5	1
601	1	2F	2 Family Pizzas	1	25.9	1
601	2	FSU	Family Supreme	0	0	1
601	3	FSG	Family SanGiorgio	0	0	1
601	4	FX	EXTRA CHICK	1	1	1
601	5	BBQ	BBQ Sauce	1	1	1
601	6	GB	Garlic Bread	1	2	1
601	7	HB	Herb Bread	1	2	1
602	1	CHF	Chicken Fillets	1	14	1
603	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
603	2	SAN	1/2 SAN GIORGIO	1	0	1
603	3	MEX	1/2 MEXICAM	1	0	1
604	1	F	FAM	0	0	1
604	2	SUP	1/2 SUPREME	1	0	1
604	3	VEG	1/2 VEGETARIAN +FR.TOM	1	0	1
604	4	FSU	Family Supreme - PINE	1	18	1
604	5	FSG	Family SanGiorgio + GARLIC	1	18	1
604	6	F	FAM	1	18	1
604	7	HALF	1/2 HAM + CHEESE	1	0	1
604	8	SUP	1/2 SUPREME + PEPP	1	0	1
604	9	FSU	Family Supreme	1	18	1
604	10	FSU	Family Supreme	1	18	1
604	11	F	FAM	1	18	1
604	12	HALF	1/2 HAW SALMI+MUSH	1	0	1
604	13	HALF	1/2LOT	1	0	1
604	14	F	FAM	1	18	1
604	15	SEA	1/2 SEAFOOD -ANCH	1	0	1
604	16	SUP	1/2 SUPREME	1	0	1
604	17	FSU	Family Supreme	1	18	1
604	18	DIS	Discount	1	-36	1
604	19	DIS	Discount	1	-108	1
604	20	DIS	Discount	1	108	1
605	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
605	2	FSU	Family Supreme - C/FOOD	0	0	1
605	3	FX	EXTRA PEPP,CAPS,ONION	3	3	1
606	1	2L	2 Large Pizzas	1	19.9	1
606	2	LSG	Large SanGiorgio	0	0	1
606	3	LX	EXTRA CHILLI	0	0	1
606	4	VEG	1/2 VEGETARIAN	0	0	1
606	5	MLO	1/2 MEAT LOVERS	0	0	1
607	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
607	2	FSU	Family Supreme	0	0	1
607	3	HALF	1/2 NO OLI ANCH	1	0	1
608	1	GB	Garlic Bread	1	2	1
608	2	MFAP	Fettucini Alla Panna	1	10	1
608	3	MLA	Main Lasagna	1	9.5	1
609	1	FSG	Family SanGiorgio	1	18	1
610	1	ERPU	Entree Ravioli Putanesca	1	7.5	1
610	2	GB	Garlic Bread	1	2	1
611	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
611	2	AME	1/2 AMERICAN +CHILLI	1	0	1
611	3	LX	EXTRA PEPP+PINE	2	1.4	1
611	4	CAP	1/2 CAPRICIOSA	1	0	1
611	5	LX	EXTRA MUSHROOM	1	0.7	1
612	1	2F	2 Family Pizzas	1	25.9	1
612	2	FAM	Family American	0	0	1
612	3	FSG	Family SanGiorgio	0	0	1
613	1	2L	2 Large Pizzas	1	19.9	1
613	2	L	LARGE FR.TOM,SALAMI,DASH of CHILLI	0	0	1
613	3	LML	Large Meat Lovers	0	0	1
613	4	LX	EXTRA  PINE	1	0.7	1
614	1	2L	2 Large Pizzas	1	19.9	1
614	2	LSU	Large Supreme  + CHILLI	0	0	1
614	3	HAW	1/2 HAWAIIN	1	0	1
614	4	SAN	1/2 SAN GIORGIO	1	0	1
614	5	GB	Garlic Bread	1	2	1
615	1	CR	Calzone Rustico - HAM+MCHILI	1	10.5	1
615	2	ESBO	Entree Spaghetti Bolognese	1	7	1
616	1	FSG	Family SanGiorgio	1	18	1
616	2	NO	No ANCH	1	0	1
616	3	HALF	1/2 NO OLI	1	0	1
617	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
617	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
617	3	SPE	1/2 SPECIAL	1	0	1
617	4	FX	EXTRA GARL OREGANO	0	0	1
618	1	MFAL	Fettucini Alfredo	1	9	1
618	2	GB	Garlic Bread	1	2	1
619	1	MCAL	Ricotta Ravioli Alfredo	1	9	1
619	2	DBF	Black Forrest Cake	1	4	1
620	1	L	LARGE	1	13.5	1
620	2	PLUS	XTRA  CHEESE  +PRAWNS +HAM	0	0	1
620	3	DIS	Discount	1	1.5	1
621	1	L	LARGE	1	13.5	1
621	2	+	+PRAWNS,HAM,MUSH,LITTLE ONION,MCHILLI,	0	0	1
621	3	LX	EXTRA BACON,XCHEESE	2	1.4	1
622	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
622	2	LAM	Large American	0	0	1
622	3	LX	EXTRA MUSHROOMS	1	0.7	1
622	4	LX	EXTRA 1/2+ PINE	1	0.7	1
623	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
623	2	LVG	Large Vegetarian	0	0	1
624	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
624	2	LAU	Large Australian	0	0	1
624	3	LX	EXTRA X CHEESE,MUSHROOMS,CHICKEN	3	2.1	1
625	1	SPC	Small Pizza, 1 Can Coke	1	10	1
625	2	SSU	Small Supreme  -ANCH	0	0	1
626	1	PLG	LARGE PICK-UP	1	9.9	1
626	2	SAN	1/2 SAN GIORGIO	1	0	1
626	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
627	1	MLA	Main Lasagna	1	9.5	1
628	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
628	2	SUP	1/2 SUPREME	1	0	1
628	3	MEX	1/2 MEXICAM X CHILLIS	1	0	1
629	1	PSM	SMALL PICK-UP	1	6.9	1
629	2	SSU	Small Supreme	0	0	1
629	3	GB	Garlic Bread	1	2	1
630	1	F	FAM	1	18	1
630	2	HALF	1/2 MUS ON CAP PIN	1	0	1
630	3	FX	EXTRA ARTICHOKE	1	1	1
630	4	HALF	1/2 PIN HAM SAL BAC	1	0	1
630	5	FX	EXTRA ANC MUS ON	3	3	1
630	6	BBQ	BBQ Sauce	1	1	1
631	1	LMA	Large Margherita	1	11.5	1
631	2	LX	EXTRA PEPP	1	0.7	1
631	3	LX	EXTRA FRE TOM , BASIL	1	0.7	1
631	4	HALF	1/2 +ANCH	1	0	1
632	1	STF	Fillet Mignon	1	17	1
632	2	MIN	Minestrone Soup	1	4.5	1
632	3	+	+pasta	1	1	1
633	1	FSP	Family Special no cap	1	17	1
633	2	HALF	1/2margarita	0	0	1
634	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
634	2	LSU	Large Supreme	0	0	1
634	3	MINUS	olives anch	0	0	1
635	1	F	FAM	1	18	1
635	2	HALF	1/2SPECIAL	1	0	1
635	3	HALF	1/2cfood	1	0	1
635	4	NO	Noanchovies	1	0	1
636	1	MFAP	Fettucini Alla Panna	1	10	1
636	2	2S	2 Small Pizzas	1	16.9	1
636	3	S	SMALLCHICKEN HAW	0	0	1
636	4	S	SMALL SUPREME	0	0	1
636	5	NO	No ANCHOVIES	1	0	1
637	1	CV	Calzone Vegetarian	1	10.5	1
637	2	LSU	Large Supreme	1	13.5	1
638	1	MSMA	Spaghetti Marinara	1	11.5	1
638	2	GB	Garlic Bread	1	2	1
639	1	MCNA	Ricotta Ravioli Napolitana	1	9	1
639	2	GB	Garlic Bread	1	2	1
639	3	DCC	Cheese Cake	1	3.5	1
639	4	COKE	1.25 Ltr Coke	1	3	1
640	1	FSU	Family Supreme	1	18	1
641	1	PC	Prawn Cocktail	1	8	1
641	2	CHAS	Chicken Asparagus	2	28	1
642	1	FHW	Family Hawiian	1	16.5	1
642	2	FSU	Family Supreme	1	18	1
642	3	NO	No ANCH OR OLIVES	1	0	1
642	4	DIS	Discount	1	-8.7	1
643	1	PLG	LARGE PICK-UP	1	9.9	1
643	2	HALF	1/2 LOT	1	0	1
643	3	HALF	1/2 BBQ CHICK HAW	1	0	1
643	4	LX	EXTRA CHEESE	1	0.7	1
643	5	BBQ	BBQ Sauce	1	1	1
644	1	LVG	Large Vegetarian	1	12.5	1
644	2	GB	Garlic Bread	1	2	1
644	3	DIS	Discount	1	0.5	1
645	1	SSG	Small SanGiorgio	1	9.5	1
645	2	DGE	Gelati Cup CHOC AND LEMON	1	4	1
646	1	F	FAM POLLO	1	18	1
646	2	FX	EXTRA FETTA CHEESE	1	1	1
646	3	F	FAM GOURMET VEGETARIAN	1	18	1
647	1	L	LARGE	1	13.5	1
647	2	HALF	1/2 VEG	1	0	1
647	3	HALF	1/2 SUPREME	1	0	1
647	4	COKE	1.25 Ltr Coke	1	3	1
648	1	L	LARGE	1	13.5	1
648	2	HALF	1/2 HAW	1	0	1
648	3	HALF	1/2 SUP	1	0	1
648	4	GB	Garlic Bread	1	2	1
649	1	FVG	Family Vegetarian	1	17	1
649	2	FX	EXTRA CHICKEN	1	1	1
649	3	NO	No OLIVES ON HALF	1	0	1
650	1	PC	Prawn Cocktail	1	8	1
650	2	EMBO	Entree Macaroni Bolognese	1	7	1
650	3	DCM	Chocolate Mousse	1	3.5	1
651	1	FVG	Family Vegetarian	1	17	1
651	2	FX	EXTRA	1	1	1
651	3	NO	No ONION CAP PINE	1	0	1
651	4	FX	EXTRA	1	1	1
651	5	FX	EXTRA	1	1	1
652	1	+	+ CHICKEN SCHNITZEL WITH VEG	1	14	1
652	2	CBR	Continental Bread (3 peices)	1	0.54	1
652	3	DIS	Discount	1	-0.539999999999999	1
653	1	LVG	Large Vegetarian	1	12.5	1
653	2	+	+ BASIL	0	0	1
653	3	COKE	1.25 Ltr Coke	1	3	1
654	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
654	2	HALF	1/2SPECIAL	1	0	1
654	3	FX	EXTRA ONION	1	1	1
654	4	HALF	1/2 VEG	1	0	1
655	1	+	+ CHICKEN SCHNITZEL WITH VEGETABLES   DON'T FORGET THE LEMON PLEASE	1	14	1
655	2	DIS	Discount	1	-1.4	1
656	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
656	2	HALF	1/2SPECIAL	1	0	1
656	3	HALF	1/2 SAN GIORGIO	1	0	1
657	1	PLG	LARGE PICK-UP	1	9.9	1
657	2	HALF	1/2 SUPREME	1	0	1
657	3	HALF	1/2 HAW	1	0	1
658	1	+	+ CHICKEN SCHNITZEL WITH VEG	1	14	1
658	2	DIS	Discount	1	-1.4	1
659	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
659	2	HALF	1/2 LOT NO ANCH	1	0	1
659	3	HALF	1/2 HAM PEP MUSH	1	0	1
659	4	MTVG	Tortellini Vegetarian	1	9.5	1
660	1	FSU	Family Supreme - ANC	1	18	1
661	1	2F	2 Family Pizzas	1	25.9	1
661	2	MLO	1/2 MEAT LOVERS	1	0	1
661	3	HALF	1/2 HAM MUSH	1	0	1
661	4	FSG	Family SanGiorgio	0	0	1
661	5	COKE	1.25 Ltr Coke	2	6	1
662	1	SPC	Small Pizza, 1 Can LIFT	1	10	1
662	2	SSU	Small Supreme	0	0	1
662	3	NO	No ANCHOVIES	1	0	1
662	4	+	+ SALAMI	0	0	1
663	1	L	LARGE	1	13.5	1
663	2	HALF	1/2 LOT NO ANCH	1	0	1
663	3	HALF	1/2 HAM PINE	1	0	1
663	4	LX	EXTRA CHEESE	1	0.7	1
663	5	DIS	discount	1	-1	1
663	6	DIS	Discount	1	1.8	1
664	1	LSU	Large Supreme	1	13.5	1
665	1	F	FAM	1	18	1
665	2	HALF	1/2 HAW	1	0	1
665	3	HALF	1/2 MEXICAN	1	0	1
665	4	FX	EXTRA pickled chilli	1	1	1
665	5	FX	EXTRA mush	1	1	1
665	6	GB	Garlic Bread	1	2	1
666	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
666	2	FSP	Family Special	0	0	1
667	1	2L	2 Large Pizzas	1	19.9	1
667	2	LSE	Large Seafood	0	0	1
667	3	LHW	Large Hawiian	0	0	1
667	4	50	*****$50.00 NOTE*****	1	0	1
667	5	50	*****$50.00 NOTE*****	1	0	1
668	1	FVG	Family Vegetarian - ONION	1	17	1
668	2	FX	EXTRA MUSH CHEESE	1	1	1
669	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
669	2	LSU	Large Supreme	0	0	1
671	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
671	2	LHW	Large Hawiian	0	0	1
672	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
672	2	NO	No coke HERB BREAD INSTEAD	1	0	1
672	3	LSG	Large SanGiorgio	0	0	1
672	4	NO	NoSAL, CAP, ONION,	1	0	1
672	5	LX	EXTRA MUSH	0	0	1
672	6	LX	EXTRA CHICKEN	1	0.7	1
672	7	CIGS	Cigarettes PETER STUYVY'S	1	6.6	1
673	1	PSM	SMALL PICK-UP	1	6.9	1
673	2	SMA	Small Margherita	0	0	1
674	1	LSU	Large Supreme	1	13.5	1
674	2	NO	No CAP	1	0	1
674	3	HALF	OTHER 1/2 -ANCH PIN	1	0	1
674	4	SX	EXTRA MU ON 1/2	1	0.5	1
674	5	GB	Garlic Bread	1	2	1
675	1	FSE	Family Seafood	1	18	1
675	2	LX	EXTRA CHEESE	1	0.7	1
675	3	LX	EXTRA OLI ANCH	1	0.7	1
676	1	2L	2 Large Pizzas	1	19.9	1
676	2	CHA	1/2 CHICKEN HAWAIIN	0	0	1
676	3	SPE	1/2 SPECIAL	0	0	1
676	4	LMX	Large Mexican	0	0	1
676	5	NO	No OLIVES	1	0	1
676	6	COKE	1.25 Ltr Coke	1	3	1
677	1	FSG	Family SanGiorgio	1	18	1
678	1	LSU	Large Supreme	1	13.5	1
678	2	NO	No OLIVES AND ANCH	1	0	1
678	3	GB	Garlic Bread	1	2	1
679	1	PLG	LARGE PICK-UP	1	9.9	1
679	2	LSG	Large SanGiorgio	0	0	1
680	1	PLG	LARGE PICK-UP	1	9.9	1
680	2	L	LARGE HAM SAL MUSH	0	0	1
680	3	LX	EXTRA CHEESE	1	0.7	1
680	4	LX	EXTRA TOMATO PASTE	1	0.7	1
681	1	LSU	Large Supreme	1	13.5	1
681	2	HALF	1/2 NO ANCH AND PINE	1	0	1
681	3	NO	No CAPSICUM ALL OVER	1	0	1
681	4	GB	Garlic Bread	0	0	1
682	1	2L	2 Large Pizzas	1	19.9	1
682	2	LSU	Large Supreme	0	0	1
682	3	NO	No ANCH PIN	1	0	1
683	1	LVG	Large Vegetarian	1	12.5	1
683	2	GB	Garlic Bread	1	2	1
683	3	DAPG	Apple Pie with Gelati	1	3.5	1
684	1	2L	2 Large Pizzas	1	19.9	1
684	2	LSU	Large Supreme	0	0	1
684	3	LSU	No ANCH or PINEAPPLE	0	0	1
685	1	MCVG	Ricotta Ravioli Vegetarian	1	9.5	1
685	2	MMAP	Macaroni Alla Panna	1	10	1
685	3	+	+ NAPOLITANA SAUCE+	2	2	1
685	4	LSG	Large SanGiorgio	1	13.5	1
685	5	GS	Greek Salad	1	5.5	1
686	1	PSM	SMALL PICK-UP	1	6.9	1
686	2	SSG	Small SanGiorgio	0	0	1
686	3	NO	No OLIVES	1	0	1
687	1	L	LARGE	1	13.5	1
687	2	AME	1/2 AMERICAN	1	0	1
687	3	CAP	1/2 CAPRICIOSA	1	0	1
687	4	COKE	1.25 Ltr Coke	1	3	1
688	1	S	SMALL PINE PEP CHILLI	1	9.5	1
688	2	2F	2 Family Pizzas	1	25.9	1
688	3	FML	Family Meat Lovers	0	0	1
688	4	FCH	Family Chicken Hawiian	0	0	1
688	5	GB	Garlic Bread	4	8	1
689	1	L	LARGE FRESH TOM, FETTA, ART, OLIVES, ONION, PINE, HAM, PEP, CHICK	1	13.5	1
689	2	LX	EXTRA	3	2.1	1
689	3	DGE	Gelati Cup LEMON	1	4	1
689	4	COKE	1.25 Ltr Coke	1	3	1
689	5	50	*****$50.00 NOTE*****	1	0	1
690	1	FHW	Family Hawiian	1	16.5	1
691	1	2L	2 Large Pizzas	1	19.9	1
691	2	L	LARGE	0	0	1
691	3	HALF	1/2 CFOOD	1	0	1
691	4	HALF	1/2 MLOVER	1	0	1
691	5	L	LARGE	0	0	1
691	6	HALF	1/2 VEG	1	0	1
691	7	HALF	1/2 MEXICAN	1	0	1
691	8	COKE	1.25 Ltr Coke	1	3	1
692	1	OKD	Dozen Oysters Kilpatrick	1	14.5	1
692	2	CR	Calzone Rustico	1	10.5	1
692	3	NO	No OLIVES	1	0	1
692	4	DLGE	large gelati cup	1	6	1
693	1	SHW	Small Hawiian	1	9	1
693	2	SSU	Small Supreme	1	9.5	1
693	3	SX	EXTRA PINE	1	0.5	1
694	1	STPWD	Pepper Steak - Well Done	1	15	1
695	1	GS	Greek Salad	1	4.95	1
695	2	NO	NO TOMATO	1	0	1
695	3	FS	French Salad	1	3.6	1
695	4	NO	No TOMATO	1	0	1
695	5	CFANTA	Can of Fanta	1	1.7	1
695	6	GB	Garlic Bread	1	1.8	1
695	7	HB	Herb Bread	1	1.8	1
695	8	FS	French Salad	1	3.6	1
695	9	NO	No OLIVES NO DRESSING	1	0	1
695	10	+	+ BOTTLE MIN H20	1	3.5	1
696	1	SSU	Small Supreme	1	9.5	1
696	2	COKE	1.25 Ltr Coke	1	3	1
697	1	PSM	SMALL PICK-UP	1	6.9	1
697	2	SHW	Small Hawiian	0	0	1
697	3	SX	EXTRA  PEPP	1	0.5	1
697	4	ETBO	Entree Tortelline Bolognese	1	7	1
698	1	GB	Garlic Bread	1	2	1
698	2	LHW	Large Hawiian	1	12.5	1
698	3	COKE	1.25 Ltr Coke	1	3	1
699	1	L	LARGE	1	13.5	1
699	2	+	+ HAM,MUSH,OLIVES,ONION	0	0	1
700	1	FSP	Family Special	1	17	1
700	2	FX	EXTRA X ANCH, X CHEESE (W.D)	2	2	1
701	1	F	FAM	1	18	1
701	2	HAW	1/2 HAWAIIN	1	0	1
701	3	HALF	1/2 MUSH,OLIVES,SALAMI,PEPP,CAPS,ONION,LITTLE PINE	1	0	1
702	1	SD	Soup of the Day	2	9	1
702	2	GB	Garlic Bread	1	2	1
702	3	F	FAM	1	18	1
702	4	HALF	1/2 MARG	1	0	1
702	5	FX	EXTRA SALAMI	1	1	1
702	6	HALF	1/2 LOT WITH A LITTLE CHILLI	1	0	1
702	7	COKE	1.25 Ltr Coke	1	3	1
703	1	+	+ CHICKEN SCHNITZELPLUS VEGETABLES	1	14	1
703	2	+	+VEGETABLES	1	3.5	1
703	3	DIS	Discount	1	-1.5	1
704	1	CV	Calzone Vegetarian	1	10.5	1
704	2	GB	Garlic Bread	1	2	1
704	3	COKE	1.25 Ltr Coke	1	3	1
705	1	CHGR	Grilled Chicken	1	13	1
705	2	STVP	Veal Parmigiana	1	14	1
705	3	DCC	Cheese Cake	2	7	1
705	4	COKE	1.25 Ltr Coke	1	3	1
706	1	CSTZ	CHICKEN SCHNITZEL WITH VEGETABLES	1	12.6	1
707	1	PFM	FAMILY PICK-UP	1	12.9	1
707	2	FSP	Family Special	0	0	1
708	1	LSU	Large Supreme	1	13.5	1
709	1	MSNA	Spaghetti Napolitana	1	9	1
709	2	SSG	Small SanGiorgio	1	9.5	1
709	3	COKE	1.25 Ltr Coke	2	6	1
709	4	GB	Garlic Bread	1	2	1
709	5	CIGS	Cigarettes MARLB. LIGHTS	2	12.8	1
710	1	FSG	Family SanGiorgio	1	18	1
710	2	FX	EXTRA HALF EXTRA PINEAPPLE	1	1	1
711	1	2L	2 Large Pizzas	1	19.9	1
711	2	L	LARGE PEPP,MUSH,FR.TOM,FR.BASIL,ONION,	0	0	1
711	3	LX	EXTRA X CHEESE	1	0.7	1
711	4	COKE	1.25 Ltr Coke	2	6	1
712	1	2L	2 Large Pizzas	1	19.9	1
712	2	LML	Large Meat Lovers	0	0	1
712	3	LSG	Large SanGiorgio	0	0	1
712	4	COKE	1.25 Ltr Coke	1	3	1
713	1	2L	2 Large Pizzas	1	19.9	1
713	2	LHW	Large Hawiian	0	0	1
713	3	LSU	Large Supreme - OLIVES	0	0	1
714	1	CHGR	Grilled Chicken	1	13	1
714	2	MFC	Main Fried Calamari	2	27	1
714	3	LSE	Large Seafood	1	13.5	1
715	1	LVG	Large Vegetarian 1/2 + CHILLI	1	12.5	1
715	2	GB	Garlic Bread	1	2	1
715	3	CSQSH	Can of Lemon Squash	1	1.7	1
716	1	L	LARGE	1	13.5	1
716	3	SUP	1/2 SUPREME -OLIVES	1	0	1
717	1	STSH	Schnitzel NO SALAD VEGETABLES INSTEAD	1	10.5	1
717	2	EFC	Entree Fried Calamari	1	8.5	1
717	3	CCOKE	Can of Coke	1	1.7	1
717	4	DIS	Discount	1	-3.7	1
718	1	LAU	Large Australian	1	12	1
718	2	LX	EXTRA EGG	1	0.7	1
718	3	GB	Garlic Bread	1	2	1
718	4	DCOKE	1.25 LTR DIET COKE	1	3	1
719	1	LSU	Large Supreme	1	13.5	1
719	2	MLA	Main Lasagna	1	9.5	1
720	1	STDWD	Steak Dianne - Well Done	1	15	1
720	2	STVP	Veal Parmigiana	1	14	1
720	3	NO	No VEAL + CHICKEN	1	0	1
720	4	GB	Garlic Bread	1	2	1
720	5	COKE	1.25 Ltr Coke	1	3	1
721	1	L	LARGE	1	13.5	1
721	2	MAR	1/2 MARGHERITA	1	0	1
721	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
721	4	LHW	Large Hawiian	1	12.5	1
721	5	LX	EXTRA PEPP	1	0.7	1
722	1	L	LARGE	1	13.5	1
722	2	HALF	1/2 VEG NO PINE	1	0	1
722	3	LX	EXTRA OLIVES MUSH FRESH TOM	3	2.1	1
722	4	HALF	1/2 MUSH ONION CAP HAM PRAWNS CHILLI SALAMI PEPERONI	1	0	1
722	5	LX	EXTRA	1	0.7	1
722	6	FS	French Salad	1	4	1
722	7	NO	No DRESSING	1	0	1
723	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
723	2	HALF	1/2 MARG	1	0	1
723	3	HALF	1/2 SPECIAL	1	0	1
723	4	50	*****$50.00 NOTE*****	1	0	1
724	1	2S	2 Small Pizzas	1	16.9	1
724	2	SSG	Small SanGiorgio	0	0	1
724	3	SX	EXTRA ANCHOVIES	1	0.5	1
724	4	SSE	Small Seafood	0	0	1
725	1	FSU	Family Supreme	1	18	1
725	2	NO	No ANCH	1	0	1
726	1	F	FAM	1	18	1
726	2	MAR	1/2 MARGHERITA	1	0	1
726	3	SUP	1/2 SUPREME	1	0	1
727	1	PC	Prawn Cocktail	1	8	1
727	2	MRBO	Ravioli Bolognese	1	9.5	1
728	1	F	FAM	1	18	1
728	2	HALF	1/2 HAW	1	0	1
728	3	HALF	1/2 PEP BACON HAM MUSH	1	0	1
728	4	FX	EXTRA MUSH	1	1	1
728	5	FX	EXTRA CHEESE ALL OVER	1	1	1
728	6	GB	Garlic Bread	1	2	1
729	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
729	2	F	FAM	0	0	1
729	3	HALF	1/2 SPECCIAL	1	0	1
729	4	HALF	1/2 CHICK HAW	1	0	1
729	5	FX	EXTRA GARLIC AND OREGANO ALL OVER	0	0	1
730	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
730	2	L	LARGE CHICK HAW	0	0	1
730	3	LX	EXTRA PEP AND MUSH	2	1.4	1
731	1	2F	2 Family Pizzas	1	25.9	1
731	2	HALF	1/2 HAW	1	0	1
731	3	HALF	1/2 CFOOD	1	0	1
731	4	FX	EXTRA CHEESE TOMATO ONION GARLIC CHIILI	3	3	1
731	5	HALF	1/2 CHICKEN	1	0	1
731	6	HALF	1/2 MEATLOVERS	1	0	1
731	7	2F	2 Family Pizzas	1	25.9	1
731	8	FSU	Family Supreme	0	0	1
731	9	NO	No PINEAPPLE	1	0	1
731	10	FSG	Family SanGiorgio	0	0	1
731	11	+	+ GARLIC HERBS	0	1	1
732	1	LSU	Large Supreme  1/2-ANCH,+BASIL	1	13.5	1
732	2	GB	Garlic Bread	1	2	1
733	1	FSU	Family Supreme	1	18	1
733	2	NO	No ANCH PINE OR OLIVES	1	0	1
735	1	F	FAM HAM,ONION,MUSHROOM,FR.TOM	1	18	1
735	2	COKE	1.25 Ltr Coke	1	3	1
736	1	2L	2 Large Pizzas	1	19.9	1
736	2	L	LARGE HAM PINE BACON	0	0	1
736	3	LX	EXTRA	1	0.7	1
736	4	LVG	Large Vegetarian	0	0	1
737	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
737	2	LSU	Large Supreme  - ANCH	0	0	1
738	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
738	2	FVG	Family Vegetarian	0	0	1
739	1	PSM	SMALL PICK-UP	1	6.9	1
739	2	SCH	Small Chicken Hawiian	0	0	1
739	3	CCOKE	Can of Coke	2	3.4	1
740	1	LAU	Large Australian	1	12	1
740	2	LX	EXTRA PINE	1	0.7	1
740	3	LX	EXTRA EGG	1	0.7	1
740	4	LX	EXTRA THICK PASTRY	0	0	1
740	5	LX	EXTRA VERY WELL DONE	0	0	1
741	1	2L	2 Large Pizzas	1	19.9	1
741	2	LML	Large Meat Lovers(2)	0	0	1
742	1	SSG	Small SanGiorgio	1	9.5	1
742	2	MCVG	Ricotta Ravioli Vegetarian	1	9.5	1
743	1	LAU	Large Australian	1	12	1
743	2	LX	EXTRA EGG	1	0.7	1
743	3	100	****$100.00 NOTE*****	1	0	1
744	1	PFM	FAMILY PICK-UP	1	12.9	1
744	2	FSG	Family SanGiorgio	0	0	1
744	3	FX	EXTRA  1/2 X OLIVES	1	1	1
744	4	FX	EXTRA 1/2 - OLIVES +PINE+CHICKEN	2	2	1
744	5	GB	Garlic Bread	1	2	1
745	1	PSM	SMALL PICK-UP	1	6.9	1
745	2	SSU	Small Supreme -PINE-OLIVES	0	0	1
745	3	SX	EXTRA X ANCH	1	0.5	1
746	1	PLG	LARGE PICK-UP	1	9.9	1
746	2	LSU	Large Supreme	0	0	1
747	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
747	2	LMA	Large Margherita	0	0	1
747	3	LX	EXTRA HALF PIN	1	0.7	1
748	1	2L	2 Large Pizzas	1	19.9	1
748	2	LSU	Large Supreme	0	0	1
748	3	L	LARGE PEPP	0	0	1
749	1	2F	2 Family Pizzas	1	25.9	1
749	2	FSU	Family Suprem x 2	0	0	1
749	3	-	- PIN	1	0	1
750	1	2F	2 Family Pizzas	1	25.9	1
750	2	FHW	Family Hawiian	0	0	1
750	3	FSG	Family SanGiorgio NO ONION	0	0	1
750	4	DEL	$1.00 DEL	0	0	1
751	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
751	2	FX	EXTRA sal	1	1	1
751	3	FSG	Family SanGiorgio	0	0	1
752	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
752	2	FX	EXTRA sal	1	1	1
753	1	2F	2 Family Pizzas	1	25.9	1
753	2	FVG	Family Vegetarian	0	0	1
753	3	FHW	Family Hawiian	0	0	1
753	4	COKE	1.25 Ltr Coke	1	3	1
754	1	SPC	Small Pizza, 1 Can Coke	1	10	1
754	2	S	SMALL AMERICAN	0	0	1
754	3	SX	EXTRA	1	0.5	1
755	1	SCH	Small Chicken Hawiian	1	9.5	1
755	2	SMX	Small Mexican	1	9.5	1
755	3	GB	Garlic Bread	1	2	1
756	1	2L	2 Large Pizzas	1	19.9	1
756	2	LML	Large Meat Lovers	0	0	1
756	3	LHW	Large Hawiian	0	0	1
757	1	SPC	Small Pizza, 1 Can Coke	1	10	1
757	2	SMX	Small Mexican	0	0	1
757	3	SSP	Small Special	1	9	1
758	1	LMX	Large Mexican	1	13	1
759	1	PLG	LARGE PICK-UP	1	9.9	1
759	2	LSU	Large Supreme	0	0	1
760	1	2F	2 Family Pizzas	1	25.9	1
760	2	FML	Family Meat Lovers	0	0	1
760	3	FSU	Family Supreme	0	0	1
761	1	F	FAM SAL,HAM,MUSH,ONIO,CAP	1	18	1
761	2	FX	EXTRASAUCE	0	0	1
761	3	FX	EXTRA CHEESE	1	1	1
761	4	LSE	Large Seafood	1	13.5	1
761	5	LX	EXTRA ONION	1	0.7	1
761	6	LX	EXTRA SAUCE	0	0	1
761	7	LX	EXTRA CHEESE	1	0.7	1
761	8	LX	EXTRA CHILLI	0	0	1
761	9	COKE	1.25 Ltr Coke	1	3	1
762	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
762	2	FHW	Family Hawiian	0	0	1
763	1	2L	2 Large Pizzas	1	19.9	1
763	2	LHW	Large Hawiian	0	0	1
763	3	LVG	Large Vegetarian	0	0	1
763	4	LX	EXTRA HAM	1	0.7	1
764	1	CHF	Chicken Fillets	1	14	1
764	2	GB	Garlic Bread	1	2	1
765	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
765	2	LSU	Large Supreme NO PIN NO ANCH	0	0	1
766	1	MFCB	Fettucini Carbonara	1	10	1
766	2	OKD	Dozen Oysters Kilpatrick	1	14.5	1
767	1	+	+ small pepperoni	1	9	1
767	2	GB	Garlic Bread	1	2	1
768	1	F	FAM	1	18	1
768	2	HALF	1/2 veg	1	0	1
768	3	HALF	1/2 pepp	1	0	1
768	4	FX	EXTRA meat	1	1	1
768	5	FX	EXTRA cheese	1	1	1
769	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
769	2	L	LARGE SAN GIORG	0	0	1
769	3	LX	EXTRA HAM PIN	2	1.4	1
769	4	+	+ chili and garlic	0	0	1
770	1	STSB	Scaloppina Bianco	1	10.5	1
770	2	STMS	Scaloppina Mushroom	1	11.5	1
770	3	MFMA	Fettucini Marinara	1	11.5	1
770	4	SD	Soup of the Day	2	9	1
770	5	COKE	1.25 Ltr Coke	1	3	1
771	1	SPC	Small Pizza, 1 Can Coke	1	10	1
771	2	SX	EXTRA CHICKEN	1	0.5	1
771	3	_	NO ANCH	0	0	1
772	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
772	2	HALF	1/2 HAW	1	0	1
772	3	HALF	1/2 S/FOOD	1	0	1
773	1	2L	2 Large Pizzas	1	19.9	1
773	2	L	LARGE VEG	0	0	1
773	3	LSG	Large SanGiorgio	0	0	1
774	1	CV	Calzone Vegetarian	1	10.5	1
774	2	+	+BOL SAUCE  X CHILI	0	0	1
774	3	MCBO	Ricotta Ravioli Bolognese X CHILI	1	9.5	1
775	1	2L	2 Large Pizzas	1	19.9	1
775	2	HALF	1/2MARGA	1	0	1
775	3	LX	EXTRAOLI,CAP,ANCH	3	2.1	1
775	4	HALF	1/2SEAFOOD	1	0	1
775	5	LX	EXTRA MUSS	1	0.7	1
775	6	LSG	Large SanGiorgio	0	0	1
775	7	MCVG	Ricotta Ravioli Vegetarian	1	9.5	1
775	8	MTAP	Tortellini Alla Panna+NAPOLI	1	10	1
775	9	GS	Greek Salad	1	5.5	1
775	10	CIGS	Cigarettes	1	6.6	1
776	1	FSU	Family Supreme NO PIN NO CAP	1	18	1
776	2	FX	EXTRA ANCH X SAUCE	1	1	1
777	1	MTAP	Tortellini Alla Panna	1	10	1
778	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
778	2	LSU	Large Supreme	0	0	1
778	3	_	NO PWNS ANCH	0	0	1
779	1	OKH	1/2 Dozen Oysters Kilpatrick	1	10	1
779	2	MSMA	Spaghetti Marinara	1	11.5	1
780	1	STD	Steak Dianne MED	1	15	1
780	2	DLGE	large gelati cup CHOC/LEM	1	6	1
781	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
781	2	HALF	1/2 SUPREME NO OLIVES	1	0	1
781	3	HALF	1/2 HAW	1	0	1
782	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
782	2	LSP	Large Special	0	0	1
782	3	LX	EXTRA PIN, CHICK,ANCH,PROW	4	2.8	1
783	1	F	FAM	1	18	1
783	2	AME	1/2 AMERICAN +HAM	1	0	1
783	3	SUP	1/2 SUPREME	1	0	1
784	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
784	2	FSU	Family Supreme NO ANCH	0	0	1
785	1	ONH	1/2 Dozen Oysters Natural	1	8.5	1
785	2	MLA	Main Lasagna	1	9.5	1
785	3	GB	Garlic Bread	1	2	1
785	4	DCA	Cassata	1	3.5	1
785	5	CBR	Continental Bread (3 peices)	1	0.6	1
786	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
786	2	LVG	Large Vegetarian NO PIN	0	0	1
786	3	+	+ CHILI	0	0	1
787	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
787	2	HALF	1/2SEA FOOD	1	0	1
787	3	HALF	1/2SUPR	1	0	1
788	1	2L	2 Large Pizzas	1	19.9	1
788	2	LSU	Large Supreme NO S/FOOD /OLIVES	0	0	1
788	3	LSU	Large Supreme " "        ""	0	0	1
789	1	MLA	Main Lasagna	2	19	1
789	2	MCMA	Ricotta Ravioli Marinara	1	11.5	1
790	1	FHW	Family Hawiian	1	16.5	1
791	1	SPC	Small Pizza, 1 Can Coke	1	10	1
791	2	SVG	Small Vegetarian NO OLIVES	0	0	1
791	3	SX	EXTRA PIN	1	0.5	1
791	4	GB	Garlic Bread	1	2	1
792	1	2L	2 Large Pizzas	1	19.9	1
792	2	LSU	Large Supreme NO OLIVES NO ANCH	0	0	1
792	3	LML	Large Meat Lovers	0	0	1
793	1	L	LARGE 1/2 SUPREME	1	13.5	1
793	2	HALF	1/2 HAW	1	0	1
794	1	2L	2 Large Pizzas	1	19.9	1
794	2	LSG	Large SanGiorgio	0	0	1
794	3	VEG	1/2 VEGETARIAN	1	0	1
794	4	MLO	1/2 MEAT LOVERS	1	0	1
795	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
795	2	LSU	Large Supreme	0	0	1
795	3	NO	No CFOOD	1	0	1
796	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
796	2	AUS	1/2 AUSTRALIAN + MUSH	1	0	1
796	3	SUP	1/2 SUPREME NO ANCH OLIVES	1	0	1
797	1	2F	2 Family Pizzas	1	25.9	1
797	2	MAR	1/2 MARGHERITA	1	0	1
797	3	HAW	1/2 HAWAIIN	1	0	1
797	4	AME	1/2 AMERICAN	1	0	1
797	5	HAW	1/2 HAWAIIN + MUSH	1	0	1
798	1	L	LARGE	1	13.5	1
798	2	SUP	1/2 SUPREME NO ANCH	1	0	1
798	3	AUS	1/2 AUSTRALIAN	1	0	1
799	1	2F	2 Family Pizzas	1	25.9	1
799	2	LHW	Large Hawiian	0	0	1
799	3	LSP	Large Special	0	0	1
800	1	EGP	Entree Garlic Prawns	1	10.5	1
800	2	STVP	Veal Parmigiana	1	14	1
801	1	SD	Soup of the Day	2	8.1	1
801	2	GB	Garlic Bread	2	3.6	1
801	3	CBR	Continental Bread (3 peices)	1	0.54	1
801	4	ETAP	Entree Tortelline Alla Panna	1	7.2	1
801	5	STSH	Schnitzel	1	9.45	1
801	6	SSP	Small Special	1	8.1	1
801	7	DAPG	Apple Pie with Gelati + van	1	3.15	1
801	8	DBF	Black Forrest Cake	2	7.2	1
801	9	CFANTA	Can of Fanta	2	3.4	1
801	10	CIGS	Cigarettes B & H SP FILTER	1	7.4	1
801	11	CIGS	Cigarettes DUNHILL RED	1	6.6	1
801	12	DIS	Discount	1	-0.039999999999992	1
802	1	PSM	SMALL PICK-UP	1	6.9	1
802	2	SSU	Small Supreme	0	0	1
802	3	GB	Garlic Bread	1	2	1
803	1	2L	2 Large Pizzas	1	19.9	1
803	2	LSU	Large Supreme LITT.CHILLI	0	0	1
803	3	LCH	Large Chicken Hawiian	0	0	1
804	1	ELA	Entree Lasagna	2	15	1
804	2	LSG	Large SanGiorgio	1	13.5	1
804	3	MINU	-OLIV,CAP	0	0	1
804	4	LX	EXTRASAL,BAC,MUSH,PROW,GARL	4	2.8	1
804	5	CFANTA	Can of Fanta	4	6.8	1
804	6	DCC	Cheese Cake	1	3.5	1
804	7	DAPG	Apple Pie with Gelati	1	3.5	1
805	1	2L	2 Large Pizzas	1	19.9	1
805	2	LVG	Large Vegetarian	0	0	1
805	3	LX	EXTRA PEPPERONIAND FRESH TOM	2	1.4	1
805	4	LSG	Large SanGiorgio	0	0	1
806	1	SPC	Small Pizza, 1 Can Coke	1	10	1
806	2	SML	Small Meat Lovers	0	0	1
806	3	STFMW	Fillet Mignon - Md Well Done	1	17	1
806	4	STVP	Veal Parmigiana	1	14	1
806	5	DLGE	large gelati cup LEMON STRAWBERRY	1	6	1
806	6	DLGE	large gelati cup BACI	1	6	1
807	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
807	2	LSG	Large SanGiorgio	0	0	1
808	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
808	2	LAM	Large AmericanPLUS MUSHROOMS	0	0	1
808	3	LX	EXTRA HALF PINE	1	0.7	1
809	1	MGP	Main Garlic Prawns	1	16.5	1
809	2	NO	No VEGETABLES , SALAD INSTEAD	1	0	1
810	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
810	2	SEA	1/2 SEAFOOD  X ANCH	1	0	1
810	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
810	4	LX	EXTRA	1	0.7	1
811	1	FSU	Family Supreme	1	18	1
811	2	_	NO ANCH NO PIN	0	0	1
811	3	CIGS	Cigarette BH X MILDs	1	7.4	1
812	1	STSH	Schnitzel NO SALAD WITH VEG INSTEAD	1	10.5	1
812	2	CHMS	Mushroom Sauce	1	2	1
812	3	CHAS	Chicken Asparagus	1	14	1
812	4	+	+  MOZZARELLA CHEESE	1	1	1
813	1	2L	2 Large Pizzas	1	19.9	1
813	2	LSG	Large SanGiorgio	0	0	1
813	3	LSU	Large Supreme	0	0	1
813	4	COKE	1.25 Ltr Coke	1	3	1
814	1	MLA	Main Lasagna	1	9.5	1
814	2	MRBO	Ravioli Bolognese	1	9.5	1
814	3	GB	Garlic Bread	1	2	1
815	1	LHW	Large Hawiian	1	12.5	1
815	2	CIGS	Cigarettes B H X MILD	1	7.4	1
816	1	L	LARGE	1	13.5	1
816	2	HALF	1/2 CHICK HAW	1	0	1
816	3	HALF	1/2 MARG	1	0	1
816	4	COKE	1.25 Ltr Coke	1	3	1
817	1	F	FAM PEP HAM CAP OLIVES ANCH MUSHIES	1	18	1
817	2	FX	EXTRA	1	1	1
817	3	MENU	MENU	0	0	1
817	4	DELIVERY	ONE DOLLAR DELIVERY	0	0	1
818	1	2L	2 Large Pizzas	1	19.9	1
818	2	LSU	Large Supreme NO CAP ONION PIN	0	0	1
818	3	LX	EXTRA CHEESE + ANCH	2	1.4	1
818	4	LMA	Large Margherita + OLIVES	0	0	1
818	5	LX	EXTRA	1	0.7	1
818	6	GB	Garlic Bread	1	2	1
818	7	CLMND	Can of Lemonade	4	6.8	1
819	1	LAM	Large American	1	12.5	1
819	2	FSP	Family Special	1	17	1
819	3	GB	Garlic Bread	3	6	1
820	1	MLA	Main Lasagna	1	9.5	1
820	2	COKE	1.25 Ltr Coke	1	3	1
820	3	GB	Garlic Bread	1	2	1
821	1	FSP	Family Special	1	17	1
821	2	-	-NO OLIVES	1	0	1
821	3	FX	EXTRA PIN	1	1	1
822	1	LSU	Large Supreme	1	13.5	1
822	2	NO	No ANCH OR OLIVES	1	0	1
822	3	GB	Garlic Bread	1	2	1
823	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
823	2	FML	Family Meat Lovers	0	0	1
823	3	DELIVERY	ONE DOLLAR DELIVERY	0	0	1
824	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
824	2	FSU	Family Supreme	0	0	1
824	3	_	NO OLIVES NO ANCH	0	0	1
824	4	CIGS	Cigarettes ESCORT BLUE	1	8.4	1
825	1	CCOKE	Can of Coke	1	1.7	1
825	2	LCP	Large Capriciosa	1	12.5	1
826	1	FML	Family Meat Lovers	1	17.5	1
826	2	FX	EXTRA CHICK AND PINE BACON AND ANCHOVIES	4	4	1
826	3	BBQ	BBQ Sauce	1	1	1
826	4	DELIVERY	ONE DOLLAR DELIVERY	0	0	1
827	1	PFM	FAMILY PICK-UP	1	12.9	1
827	2	HALF	1/2 MEXIVCAN	1	0	1
827	3	HALF	1/2 SUPREME	1	0	1
828	1	2L	2 Large Pizzas	1	19.9	1
828	2	L	LARGE	0	0	1
828	3	HALF	1/2 VEG PLUS CHILLI	1	0	1
828	4	HALF	1/2 MEATLOVERS PLUS CHILLI	1	0	1
828	5	LSG	Large SanGiorgio PLUS CHILLI	0	0	1
828	6	COKE	1.25 Ltr Coke	1	3	1
829	1	2L	2 Large Pizzas	1	19.9	1
829	2	LVG	Large Vegetarian	0	0	1
830	1	MMNA	Macaroni Napolitana	1	9	1
830	2	MMCB	Macaroni Carbonara	1	10	1
830	3	GB	Garlic Bread	1	2	1
831	1	L	LARGE	1	13.5	1
831	2	HALF	1/2 CHICK,FR,TOM,HERBS	1	0	1
831	3	VEG	1/2 VEGETARIAN - PINE	1	0	1
831	4	DCM	Chocolate Mousse	2	7	1
831	5	CIGS	Cigarettes PETER STYVES	1	6.6	1
832	1	F	FAM	1	18	1
832	2	VEG	1/2 VEGETARIAN - OLIVES	1	0	1
832	3	SUP	1/2 SUPREME - OLIVES	1	0	1
833	1	MLA	Main Lasagna	1	9.5	1
833	2	MSPU	Spaghetti Putanesca	1	9.5	1
834	1	LSU	Large Supreme	1	13.5	1
834	2	NO	No ANCH	1	0	1
834	3	COKE	1.25 Ltr Coke	1	3	1
835	1	FVG	Family Vegetarian	1	17	1
835	2	FX	EXTRA POTATOES,CHILLI+GARLIC	1	1	1
835	3	GB	Garlic Bread	1	2	1
835	4	DCOKE	1.25 LTR DIET COKE	1	3	1
836	1	CHGR	Grilled Chicken -SALAD+POTATEOS	1	11.7	1
836	2	DCM	Chocolate Mousse	1	3.15	1
837	1	LSU	Large Supreme	1	13.5	1
837	2	COKE	1.25 Ltr Coke	1	3	1
837	3	HB	Herb Bread	1	2	1
838	1	FMX	Family Mexican X HOT	1	17.5	1
838	2	2L	2 Large Pizzas	1	19.9	1
838	3	+	+  BARBECUE CHICKEN 1/2 HAM,PINE	0	0	1
838	4	LML	Large Meat Lovers	0	0	1
838	5	GB	Garlic Bread	1	2	1
839	1	2L	2 Large Pizzas	1	19.9	1
839	2	HALF	1/2 CFOOD NO ANCH	1	0	1
839	3	HALF	1/2 BACON MUSH ONION  CAP PRAWNS	1	0	1
839	4	HALF	1/2 HAW	1	0	1
839	5	HALF	1/2 SUP	1	0	1
840	1	PSM	SMALL PICK-UP SSUPREME	1	6.9	1
840	2	GB	Garlic Bread	1	2	1
841	1	LVG	Large Vegetarian	1	12.5	1
841	2	DGE	Gelati Cup BACI LITTLE LEMON	1	4	1
842	1	SPC	Small Pizza, 1 Can Coke	1	10	1
842	2	SVG	Small Vegetarian FR.BASIL	0	0	1
842	3	GB	Garlic Bread	1	2	1
843	1	PLG	LARGE PICK-UP	1	9.9	1
844	1	PLG	LARGE PICK-UP	1	9.9	1
844	2	LSU	Large Supreme	0	0	1
845	1	GB	Garlic Bread	1	2	1
845	2	L	LARGE CHICKEN,SALAMI,PINE,	1	13.5	1
845	3	LX	EXTRA  MUSH	1	0.7	1
846	1	LMA	Large Margherita	1	11.5	1
846	2	LX	EXTRA CHEESE ANCHOIVIIES AND CHILLI	2	1.4	1
847	1	2L	2 Large Pizzas	1	19.9	1
847	2	LHW	Large Hawiian	0	0	1
848	1	LSU	Large Supreme	1	13.5	1
849	1	FSU	Family Supreme	1	18	1
849	2	HALF	1/2 NO ANCHOVIES	1	0	1
849	3	GB	Garlic Bread	0	0	1
849	4	COKE	1.25 Ltr Coke	0	0	1
850	1	SD	Soup of the Day	1	4.5	1
850	2	GB	Garlic Bread	1	2	1
850	3	MGP	Main Garlic Prawns	1	16.5	1
850	4	CBR	Continental Bread (3 peices)	1	0.6	1
850	5	DAPC	Apple Pie with Cream	1	3.5	1
851	1	PSM	SMALL PICK-UP	1	6.9	1
851	2	SSU	Small Supreme	0	0	1
852	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
852	2	LHW	Large Hawiian PLUS PEPPERONI	0	0	1
853	1	PFM	FAMILY PICK-UP	1	12.9	1
853	2	HALF	1/2 SUPREME	1	0	1
853	3	HALF	1/2 MEXICAN	1	0	1
854	1	SSE	Small Seafood	1	9.5	1
854	2	PC	Prawn Cocktail	1	8	1
854	3	DCM	Chocolate Mousse	1	3.5	1
855	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
855	2	LCH	Large Chicken Hawiian	0	0	1
856	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
856	2	SAN	1/2 SAN GIORGIO	1	0	1
856	3	VEG	1/2 VEGETARIAN	1	0	1
857	1	LCP	Large Capriciosa	1	12.5	1
857	2	LX	EXTRA ANCH LITTLE CHILLI	1	0.7	1
858	1	OKH	1/2 Dozen Oysters Kilpatrick	1	10	1
858	2	MGP	Main Garlic Prawns	1	16.5	1
858	3	CBR	Continental Bread (3 peices)	1	0.6	1
859	1	OKH	1/2 Dozen Oysters Kilpatrick	1	10	1
859	2	MFC	Main Fried Calamari	1	13.5	1
859	3	DCM	Chocolate Mousse	2	7	1
860	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
860	2	FVG	Family Vegetarian	0	0	1
861	1	L	LARGE	1	13.5	1
861	2	HALF	1/2 CHICK HAW	1	0	1
861	3	HALF	1/2 SUP	1	0	1
861	4	GB	Garlic Bread	1	2	1
861	5	DCOKE	1.25 LTR DIET COKE	1	3	1
862	1	SPC	Small Pizza, 1 Can Coke	1	10	1
862	2	SVG	Small Vegetarian NO OLIVES EXTRA PINE	0	0	1
862	3	SPC	Small Pizza, 1 Can Coke	1	10	1
862	4	SSU	Small Supreme	0	0	1
862	5	CBR	Continental Bread (3 peices)	1	0.54	1
862	6	DIS	Discount	1	0.460000000000001	1
862	7	DIS	Discount	1	-1	1
863	1	STD	Steak Dianne (M-R) -VEG +SALAD	1	15	1
863	2	CHIPS	Chips	1	3.5	1
863	3	COKE	1.25 Ltr Coke	2	6	1
863	4	DAPC	Apple Pie with Cream	1	3.5	1
864	1	CHAV	Chicken Avocado	1	14	1
864	2	MMNA	Macaroni Napolitana +CHILLI+MUSHROOMS	1	9	1
864	3	SX	EXTRA	2	1	1
865	1	OND	Dozen Oysters Natural	1	13	1
865	2	CHAV	Chicken Avocado	1	14	1
865	3	DTA	Tartufo	2	7	1
866	1	LSU	Large Supreme -ANCH-OLIVES	1	13.5	1
866	2	EFCB	Entree Fettucini Carbonara	1	8	1
866	3	COKE	1.25 Ltr Coke	1	3	1
867	1	MFCB	Fettucini Carbonara	1	10	1
867	2	COKE	1.25 Ltr Coke	1	3	1
867	3	GB	Garlic Bread	1	2	1
868	1	STVP	Veal Parmigiana -VEG+SALAD	1	14	1
868	2	OKD	Dozen Oysters Kilpatrick	1	14.5	1
869	1	LHW	Large Hawiian	1	12.5	1
869	2	LX	EXTRA CHEESE+SAUCE	1	0.7	1
869	3	GB	Garlic Bread	1	2	1
870	1	HB	Herb Bread	1	2	1
871	1	LSP	Large Special	1	12.5	1
871	2	GB	Garlic Bread	1	2	1
871	3	DIS	Discount	1	0.5	1
872	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
872	2	HALF	1/2 VEGETARIAN	1	0	1
872	3	HALF	1/2 BBQ CHICKEN	1	0	1
872	4	BBQ	BBQ Sauce ALL OVER	1	1	1
872	5	GB	Garlic Bread INSTEAD OF COKE AN EXTRA 2 GARLIC BREAD	0	0	1
873	1	MTAP	Tortellini Alla Panna	2	20	1
873	2	CSQSH	Can of Lemon Squash	2	3.4	1
874	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
874	2	LSU	Large Supreme NO ANCH	0	0	1
875	1	2L	2 Large Pizzas	1	19.9	1
875	2	LSU	Large Supreme NO ANCH	0	0	1
875	3	L	LARGE HAM PINE MUSH	0	0	1
875	4	GB	Garlic Bread	1	2	1
875	5	COKE	1.25 Ltr Coke	1	3	1
876	1	LSG	Large SanGiorgio	1	13.5	1
876	2	LX	EXTRA PINE HERBS MUSH SAUCE CHEESE	4	2.8	1
877	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
877	2	HAW	1/2 HAWAIIN + MUS PEPP	1	0	1
877	3	HAW	1/2 HAWAIIN	1	0	1
878	1	FSU	Family Supreme	4	72	1
878	2	FX	EXTRA ANCHOVIES	4	4	1
878	3	DIS	Discount	1	-36	1
878	4	DIS	Discount	1	4	1
879	1	2L	2 Large Pizzas	1	19.9	1
879	2	LAU	Large Australian	0	0	1
879	3	LMX	Large Mexican	0	0	1
880	1	SPC	Small Pizza, 1 Can Coke	1	10	1
880	2	S	SMALL BBQ CHICK HAW	0	0	1
881	1	LSU	Large Supreme -ANCH1/2-OLIVES	1	12.15	1
881	2	STR	Rump Steak(M-R)	1	11.7	1
881	3	CHMS	Mushroom Sauce	1	1.8	1
881	4	DGE	Gelati Cup LEMON	1	3.6	1
881	5	DGE	Gelati Cup BACI+CREAM	1	3.6	1
881	6	DAPC	Apple Pie with Cream	1	3.15	1
882	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
882	2	FSU	Family Supreme	0	0	1
882	3	FX	EXTRA CHEESE+CHILLI	1	1	1
882	4	MFPU	Fettucini Putanesca	1	9.5	1
883	1	LSU	Large Supreme	1	13.5	1
883	2	NO	No ANCH OR OLIVES	1	0	1
883	3	LHW	Large Hawiian	1	12.5	1
883	4	ENTER	ENTER OFF OF GAWLER PLACE AND RING LEFT HAND INTERCOM	0	0	1
884	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
884	2	FSU	Family Supreme	0	0	1
885	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
885	2	FSU	Family Supreme -C/FOOD	0	0	1
886	1	SCH	Small Chicken Hawiian	1	9.5	1
886	2	SX	EXTRA	1	0.5	1
886	3	DCC	Cheese Cake	1	3.5	1
886	4	CDIET	CAN OF DIET COKE	1	1.7	1
887	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
887	2	F	FAM CHICKEN,PEPP,CAPS,ONION,HAM	0	0	1
887	3	HALF	1/2 +FR.TOM,MUSH,PINE	1	0	1
887	4	FX	EXTRA CHICKEN	1	1	1
888	1	LVG	Large Vegetarian -MUSH	1	12.5	1
888	2	LX	EXTRA FR.TOM, LITTLE ARTICHOKE,XOLIVES	2	1.4	1
889	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
889	2	LCH	Large Chicken Hawiian	0	0	1
889	3	BBQ	BBQ Sauce	1	1	1
890	1	LVG	Large Vegetarian	1	12.5	1
890	2	DGE	Gelati Cup BACI PIST CHOC	1	4	1
891	1	FCH	Family Chicken Hawiian	1	17.5	1
891	2	COKE	1.25 Ltr Coke	1	3	1
892	1	STMS	Scaloppina Mushroom	2	23	1
892	2	GB	Garlic Bread	1	2	1
892	3	HB	Herb Bread	1	2	1
892	4	DGE	Gelati Cup VANILLA	1	4	1
892	5	CFANTA	Can of Fanta	1	1.7	1
892	6	DIS	Discount	1	-2.1	1
893	1	SSP	Small Special NO SALAMI	1	9	1
893	2	MFNA	Fettucini Napolitana	1	9	1
894	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
894	2	HALF	1/2 PEPP	1	0	1
894	3	SPE	1/2 SPECIAL	1	0	1
895	1	2L	2 Large Pizzas	1	19.9	1
895	2	L	LARGE CHICKEN	0	0	1
895	3	LSG	Large SanGiorgio	0	0	1
896	1	FMA	Family Margherita	1	15	1
896	2	FX	EXTRA olives	1	1	1
896	3	FX	EXTRA anch	1	1	1
897	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
897	2	FSE	Family Seafood	0	0	1
898	1	CHGR	Grilled Chicken - salad + chips	1	13	1
898	2	CHIPS	Chips	2	7	1
899	1	SMX	Small Mexican	1	9.5	1
899	2	SCH	Small Chicken Hawiian	1	9.5	1
899	3	ERBO	Entree Ravioli Bolognese	1	7	1
899	4	GB	Garlic Bread	1	2	1
900	1	MSBO	Spaghetti Bolognese	1	9.5	1
900	2	SAU	Small Australian	1	8.5	1
900	3	CCOKE	Can of Coke	2	3.4	1
901	1	2L	2 Large Pizzas	1	19.9	1
901	2	LSG	Large SanGiorgio	0	0	1
901	3	L	LARGE HAM SALAMI MUSH	0	0	1
901	4	LX	EXTRA EGG	1	0.7	1
901	5	COKE	1.25 Ltr Coke	1	3	1
902	1	STD	Steak Dianne WD	1	15	1
903	1	SUP	1/2 SUPREME	1	0	1
903	2	VEG	1/2 VEGETARIAN	1	0	1
903	3	DIS	Discount	1	18	1
904	1	2L	2 Large Pizzas	1	19.9	1
904	2	LSU	Large Supreme	0	0	1
904	3	LSU	Large Supreme	0	0	1
904	4	DEL	1.00 DEL	0	0	1
905	1	MSPU	Spaghetti Putanesca	1	9.5	1
905	2	LCP	Large Capriciosa	1	12.5	1
905	3	DCM	Chocolate Mousse	1	3.5	1
905	4	DEL	$3.00 DEL	0	0	1
906	1	MFBO	Fettucini Bolognese	1	9.5	1
906	2	GB	Garlic Bread	1	2	1
906	3	FS	French Salad	1	4	1
906	4	CCOKE	Can of Coke	1	1.7	1
906	5	CUT	*******CUTLERY**************	1	0	1
907	1	CV	Calzone Vegetarian - NAP	1	10.5	1
907	2	+	+ BOLOG SAUCE + CHILI	0	0	1
907	3	MRBO	Ravioli Bolognese+ CHILI	1	9.5	1
907	4	50	*****$50.00 NOTE*****	1	0	1
908	1	PSM	SMALL PICK-UP	1	6.9	1
909	1	FSE	Family Seafood	1	18	1
909	2	-_	NO ANCH	0	0	1
910	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
910	2	LSU	Large Supreme	0	0	1
911	1	2L	2 Large Pizzas	1	19.9	1
911	2	HALF	1/2 meat.l.	1	0	1
911	3	HALF	1/2 barbecue chick	1	0	1
911	4	VEG	1/2 VEGETARIAN	1	0	1
911	5	SUP	1/2 SUPREME -ANCH	1	0	1
911	6	CIGS	Cigarettes B+H EX MILD	1	7.4	1
912	1	FCH	Family Chicken Hawiian	1	17.5	1
912	2	FX	EXTRA PIN PIN MUSH PWN	4	4	1
912	3	HALF	1/2 CHICK BACON OLIV MUSH PWN	0	0	1
912	4	FX	EXTRA	4	4	1
913	1	L	LARGE	1	13.5	1
913	2	SEA	1/2 SEAFOOD	1	0	1
913	3	SUP	1/2 SUPREME	1	0	1
913	4	DLGE	large gelati cup CHOC	1	6	1
914	1	MLA	Main Lasagna	1	9.5	1
914	2	GB	Garlic Bread	2	4	1
915	1	LSG	Large SanGiorgio	1	13.5	1
916	1	2L	2 Large Pizzas	1	19.9	1
916	2	LSE	Large Seafood	0	0	1
916	3	LSG	Large SanGiorgio	0	0	1
917	1	FVG	Family Vegetarian	1	17	1
917	2	HALF	1/2 MARGARITA	1	0	1
918	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
918	2	FSU	Family Supreme NO ANCH	0	0	1
919	1	MTCB	Tortellini Carbonara	1	10	1
919	2	SAU	Small Australian	1	8.5	1
920	1	LSU	Large Supreme - ANC	1	13.5	1
921	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
921	2	HALF	1/2 MEAT.L. XPEPP X SAUCE	1	0	1
921	3	HALF	1/2 LOT	1	0	1
921	4	FX	EXTRA	1	1	1
922	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
922	2	LHW	Large Hawiian	0	0	1
922	3	LX	EXTRA MUSH	1	0.7	1
922	4	HALF	1/2 PEPP SALAMI	2	0	1
922	5	HALF	1/2 ONION CAP	1	0	1
922	6	LX	EXTRA	2	1.4	1
923	1	F	FAM	1	18	1
923	2	HALF	1/2 SUPREME	1	0	1
923	3	HALF	1/2 HAW	1	0	1
923	4	DEL	$1.00 DEL	0	0	1
924	1	LVG	Large Vegetarian + CHILI GARLIC	1	12.5	1
924	2	GB	Garlic Bread	1	2	1
924	3	ELA	Entree Lasagna	1	7.5	1
924	4	DEL	$1.00 DEL	0	0	1
925	1	2L	2 Large Pizzas	1	19.9	1
925	2	LHW	Large Hawiian	0	0	1
925	3	LVG	Large Vegetarian	0	0	1
925	4	LX	EXTRA MUSH	1	0.7	1
925	5	DEL	$1.00 DEL	0	0	1
925	6	MENU	MENU	0	0	1
926	1	L	LARGE	1	13.5	1
926	2	HALF	1/2 MARG + HAM	1	0	1
926	3	HALF	1/2MEX + F/TOM + BASIL	1	0	1
926	4	LX	EXTRA	1	0.7	1
926	5	GB	Garlic Bread	1	2	1
927	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
927	2	FVG	Family Vegetarian	0	0	1
927	3	+	+ D.COKE	0	0	1
928	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
928	2	LVG	Large Vegetarian	0	0	1
929	1	DGE	Gelati Cup	4	16	1
929	2	+	+ LEMON PISTACHIO BACI	0	0	1
929	3	+	+ BACI PISTACHIO	0	0	1
929	4	+	+ CHOC LEMON	0	0	1
929	5	+	+VANILLA COFFE BACI	0	0	1
929	6	GB	Garlic Bread	1	2	1
930	1	2L	2 Large Pizzas	1	19.9	1
930	2	L	LARGE BACON + ONION	0	0	1
930	3	LSU	Large Supreme	0	0	1
930	4	COKE	1.25 Ltr Coke	1	3	1
930	5	50	*****$50.00 NOTE*****	1	0	1
931	1	SVG	Small Vegetarian	1	9	1
931	2	FSU	Family Supreme  +CHILLI	1	18	1
931	3	FX	EXTRA XXX ANCH	2	2	1
932	1	2F	2 Family Pizzas	1	25.9	1
932	2	FVG	Family Vegetarian -PINE	0	0	1
932	3	F	FAM ONION,OLIVE,MUSH,PEPP	0	0	1
932	4	FX	EXTRA XX PEPPERONI	1	1	1
933	1	LSG	Large SanGiorgio - SAL + PEPP	1	13.5	1
933	2	CR	Calzone Rustico	1	10.5	1
933	3	DIS	discount	2	-2	1
934	1	2L	2 Large Pizzas	1	19.9	1
934	2	LCH	Large Chicken Hawiian	0	0	1
934	3	LSU	Large Supreme	0	0	1
934	4	COKE	1.25 Ltr Coke	1	3	1
935	1	2F	2 Family Pizzas	1	25.9	1
935	2	FHW	Family Hawiian	0	0	1
935	3	FX	EXTRA  HALF PEPP	1	1	1
935	4	VEG	1/2 VEGETARIAN	1	0	1
935	5	FX	EXTRA  PEPP +GARLIC	1	1	1
935	6	MEX	1/2 MEXICAM	1	0	1
935	7	GB	Garlic Bread	2	4	1
936	1	FMX	Family Mexican	1	17.5	1
936	2	FX	EXTRA TOBASCO SAUCE	1	1	1
937	1	2S	2 Small Pizzas	1	16.9	1
937	2	SMX	Small Mexican	0	0	1
937	3	SSU	Small Supreme	0	0	1
938	1	LVG	Large Vegetarian -PINE	1	12.5	1
938	2	LX	EXTRA MUSH OLIVES	1	0.7	1
939	1	STP	Pepper Steak  (R)	1	15	1
939	2	STP	Pepper Steak (W.D.)	1	15	1
939	3	CUT	*******CUTLERY**************	1	0	1
940	1	OKD	Dozen Oysters Kilpatrick (W.D)	1	14.5	1
940	2	PC	Prawn Cocktail	1	8	1
940	3	STP	Pepper Steak (M-W)	2	30	1
941	1	2L	2 Large Pizzas	1	19.9	1
941	2	LSU	Large Supreme	0	0	1
941	3	LML	Large Meat Lovers	0	0	1
941	4	+	+  BOTH GARLIC+HERBS	0	0	1
942	1	2L	2 Large Pizzas	1	19.9	1
942	2	LSU	Large Supreme	0	0	1
942	3	LMX	Large Mexican	0	0	1
943	1	2S	2 Small Pizzas	1	16.9	1
943	2	SMA	Small Margherita (THIN CRUST)	0	0	1
943	3	SVG	Small Vegetarian	0	0	1
944	1	2L	2 Large Pizzas	1	19.9	1
944	2	LAM	Large American	0	0	1
944	3	LSE	Large Seafood	0	0	1
945	1	PLG	LARGE PICK-UP	1	9.9	1
945	2	LVG	Large Vegetarian	0	0	1
945	3	CCOKE	Can of Coke	1	1.7	1
946	1	SPC	Small Pizza, 1 Can Coke	1	10	1
946	2	SMA	Small Margherita	0	0	1
946	3	SSP	Small Special	1	9	1
947	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
947	2	FSG	Family SanGiorgio -OLIVES	0	0	1
947	3	FX	EXTRA PEPP	1	1	1
948	1	GB	Garlic Bread	2	4	1
948	2	PFM	FAMILY PICK-UP	1	12.9	1
948	3	HAW	1/2 HAWAIIN	1	0	1
948	4	SPE	1/2 SPECIAL	1	0	1
949	1	STSB	Scaloppina Bianco	1	10.5	1
949	2	MSBO	Spaghetti Bolognese	1	9.5	1
950	1	STF	Fillet Mignon ( MED )	1	17	1
950	2	GB	Garlic Bread	1	2	1
951	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
951	2	LHW	Large Hawiian	0	0	1
951	3	LX	EXTRA BBQ SAUCE+SALAMI	2	1.4	1
952	1	CSTZ	CHICKEN SCHNITZEL WITH VEGETABLES	2	25.2	1
952	2	GB	Garlic Bread	1	1.8	1
953	1	MLA	Main Lasagna	1	9.5	1
953	2	GS	Greek Salad	1	5.5	1
954	1	F	FAM	1	18	1
954	2	HAW	1/2 HAWAIIN OLIVE+PEPP	1	0	1
954	3	SUP	1/2 SUPREME -C/FOOD	1	0	1
954	4	FVG	Family Vegetarian +FR.TOM	1	17	1
954	5	FSU	Family Supreme -PINE	1	18	1
954	6	F	FAM	1	18	1
954	7	SUP	1/2 SUPREME XANCH	1	0	1
954	8	HALF	1/2 HAM+CHEESE	1	0	1
954	9	FSU	Family Supreme CHILLI X ANCH	1	18	1
954	10	F	FAM CHICK,CAPS,ONION,MUSH,GARLIC+HERBS	1	18	1
954	11	FSU	Family Supreme -ANCH	1	18	1
954	12	F	FAM	1	18	1
954	13	HALF	1/2 MEAT.L.	1	0	1
954	14	SUP	1/2 SUPREME	1	0	1
954	15	FHW	Family Hawiian MUSH+SALAMI	1	16.5	1
954	16	FSE	Family Seafood	1	18	1
954	17	FVG	Family Vegetarian -MUSH 1/2-OLIVES+FR.TOM	1	17	1
954	18	FSU	Family Supreme MILDCHILLI	1	18	1
954	19	DIS	discount	1	-1	1
954	20	DIS	Discount	1	-67.5	1
955	1	LVG	Large Vegetarian	1	12.5	1
955	2	COKE	1.25 Ltr Coke	1	3	1
956	1	CR	Calzone Rustico	1	10.5	1
956	2	SPC	Small Pizza, 1 Can Coke	1	10	1
956	3	SSE	Small Seafood	0	0	1
957	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
957	2	FSU	Family Supreme	0	0	1
957	3	CIGS	Cigarettes WHINGFIELD BLUE	1	7.4	1
957	4	50	*****$50.00 NOTE*****	1	0	1
958	1	LML	Large Meat Lovers	1	13	1
958	2	MTNA	Tortellini Napolitana	1	9	1
958	3	COKE	1.25 Ltr Coke	1	3	1
959	1	LSU	Large Supreme - SEA ,MUS ON	1	13.5	1
959	2	GB	Garlic Bread	1	2	1
959	3	2LOJ	2 LITRE ORANGE JUICE	1	5	1
959	4	COKE	1.25 Ltr Coke	1	3	1
960	1	CV	Calzone Vegetarian	1	10.5	1
960	2	GB	Garlic Bread	1	2	1
961	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
961	2	LSG	Large SanGiorgio	0	0	1
961	3	LX	EXTRA SAL TOM	2	1.4	1
962	1	2L	2 Large Pizzas	1	19.9	1
962	2	LSU	Large Supreme	0	0	1
962	3	LMX	Large Mexican	0	0	1
963	1	OND	Dozen Oysters Natural	3	39	1
963	2	OKD	Dozen Oysters Kilpatrick	1	14.5	1
964	1	2L	2 Large Pizzas	1	19.9	1
964	2	LSU	Large Supreme	0	0	1
964	3	LHW	Large Hawiian	0	0	1
965	1	2L	2 Large Pizzas	1	19.9	1
965	2	LMX	Large Mexican	0	0	1
965	3	LAU	Large Australian	0	0	1
966	1	SPC	Small Pizza, 1 Can Coke	1	10	1
966	2	SSG	Small SanGiorgio	0	0	1
966	3	NO	No OLIVES	1	0	1
967	1	S	SMALL FR.TOM+CHICKEN	1	9.5	1
967	2	L	LARGE	1	13.5	1
967	3	VEG	1/2 VEGETARIAN -OLIVRS	1	0	1
967	4	HALF	1/2 CHICK,CAPS,ONION,XCHEESE,SALAMI	1	0	1
967	5	COKE	1.25 Ltr Coke	1	3	1
968	1	STVP	Veal Parmigiana	1	14	1
969	1	LCP	Large Capriciosa	1	12.5	1
969	2	LX	EXTRA ANCH+CHILLI	1	0.7	1
969	3	GB	Garlic Bread	1	2	1
970	1	2L	2 Large Pizzas	1	19.9	1
970	2	LHW	Large HawiianI	0	0	1
970	3	LX	EXTRA + PEPPERONI	1	0.7	1
970	4	LSU	Large Supreme	0	0	1
971	1	2L	2 Large Pizzas	1	19.9	1
971	2	LSG	Large SanGiorgio	0	0	1
971	3	LSU	Large Supreme	0	0	1
971	4	50	*****$50.00 NOTE*****	1	0	1
972	1	SPC	Small Pizza, 1 Can Coke	1	10	1
972	2	SVG	Small Vegetarian -OLIVES	0	0	1
972	3	SX	EXTRA PINE	1	0.5	1
973	1	FSP	Family Special	1	17	1
973	2	FX	EXTRA ANCH	1	1	1
974	1	2L	2 Large Pizzas	1	19.9	1
974	2	LML	Large Meat Lovers	0	0	1
974	3	LX	EXTRA ONION	1	0.7	1
974	4	L	LARGE SALAMI,OLIVES,MUSH,FR.TOM	0	0	1
974	5	+	+ LITTLE GARLIC+HERBS	0	0	1
975	1	LSU	Large Supreme -CAPS,PINE,C/FOOD	1	13.5	1
976	1	LSU	Large Supreme -SALAMI	1	13.5	1
976	2	LX	EXTRA CHEESE	1	0.7	1
976	3	GB	Garlic Bread	1	2	1
977	1	DGE	Gelati Cup LEM,BACI,PIST	1	4	1
977	2	DGE	Gelati Cup VAN,BACI,PIST	1	4	1
977	3	DGE	Gelati Cup BACI,PIST	1	4	1
977	4	DGE	Gelati Cup CHOC,BACI,COFF	1	4	1
977	5	GB	Garlic Bread	1	2	1
978	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
978	2	FHW	Family Hawiian	0	0	1
978	3	FX	EXTRA MUSHROOM	1	1	1
979	1	CR	Calzone Rustico	1	10.5	1
979	2	GB	Garlic Bread	1	2	1
979	3	DAPC	Apple Pie with Cream	1	3.5	1
979	4	DCOKE	1.25 LTR DIET COKE	1	3	1
980	1	F	FAM	1	18	1
980	2	AME	1/2 AMERICAN	1	0	1
980	3	MAR	1/2 MARGHERITA	1	0	1
981	1	F	FAM	1	18	1
981	2	SUP	1/2 SUPREME - olives	1	0	1
982	1	F	FAM	1	18	1
982	2	FSU	Family Supreme	0	0	1
982	3	HALF	1/2  no olives	1	0	1
982	4	FX	EXTRA - 1/2 anchovies	1	1	1
983	1	GB	Garlic Bread	1	2	1
984	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
984	2	LVG	Large Vegetarian	0	0	1
985	1	2L	2 Large Pizzas	1	19.9	1
985	2	LML	Large Meat Lovers	0	0	1
985	3	L	LARGE CHICK+CHEESE	0	0	1
985	4	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
985	5	LSG	Large SanGiorgio	0	0	1
986	1	2L	2 Large Pizzas	1	19.9	1
986	2	LVG	Large Vegetarian	0	0	1
986	3	LSU	Large Supreme -C/FOOD	0	0	1
986	4	GB	Garlic Bread	1	2	1
987	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
987	2	LSG	Large SanGiorgio	0	0	1
987	3	LX	EXTRA 1/2+ ANCH	1	0.7	1
988	1	PLG	LARGE PICK-UP	1	9.9	1
988	2	LVG	Large Vegetarian CHILLI+HERBS	0	0	1
988	3	+	+ CAPUCCINO	0	4	1
989	1	CR	Calzone Rustico	1	10.5	1
990	1	FSU	Family Supreme	1	18	1
991	1	2L	2 Large Pizzas	1	19.9	1
991	2	LMX	Large Mexican	0	0	1
991	3	L	LARGE CHICK,SALAMI,CAPS,ONION,HAM	0	0	1
991	4	LX	EXTRA CHICKEN	1	0.7	1
991	5	GB	Garlic Bread	1	2	1
992	1	SD	Soup of the Day	3	12.15	1
992	2	MLA	Main Lasagna	1	8.55	1
992	3	GB	Garlic Bread	2	3.6	1
992	4	DTA	Tartufo	1	3.15	1
992	5	COKE	1.25 Ltr Coke	1	3	1
992	6	CIGS	Cigarettes WINGFIELD RED	1	7.4	1
992	7	CUT	*******CUTLERY**************	1	0	1
993	1	SD	Soup of the Day	2	8.1	1
993	2	GB	Garlic Bread	2	3.6	1
993	3	L	LARGE FR.TOM,XANCH,HERBS	1	12.15	1
994	1	LCH	Large Chicken Hawiian	1	13	1
994	2	CHF	Chicken Fillets	1	14	1
994	3	CFANTA	Can of Fanta	2	3.4	1
994	4	50	*****$50.00 NOTE*****	1	0	1
995	1	LSU	Large Supreme -CAPS,OLIVES,PINE	1	13.5	1
995	2	GB	Garlic Bread	1	2	1
996	1	GB	Garlic Bread	2	4	1
996	2	L	LARGE PRAWNS,HAM,BACON,MUSH,LITTLEONION,LITTLE CHILLI,XXCHEESE	1	13.5	1
996	3	DIS	Discount	1	-2.5	1
997	1	CHGR	Grilled Chicken	2	26	1
997	2	--	ONE WITH VEG	0	0	1
997	3	CHIPS	Chips	1	3.5	1
997	4	LSU	Large Supreme	1	13.5	1
997	5	HALF	1/2 CHIC MUS	1	0	1
997	6	GB	Garlic Bread	1	2	1
997	7	DCM	Chocolate Mousse	2	7	1
997	8	CFANTA	Can of Fanta	3	5.1	1
997	9	COKE	1.25 Ltr Coke	1	3	1
997	10	DIS	Discount	1	-0.100000000000001	1
998	1	FSP	Family Special	1	17	1
998	2	COKE	1.25 Ltr Coke	1	3	1
999	2	HALF	1/2 HAW	1	0	1
999	3	HALF	1/2 THE LOT	1	0	1
1000	1	2S	2 Small Pizzas	1	16.9	1
1000	2	SMA	Small Margherita	0	0	1
1000	3	SX	EXTRA PIN	1	0.5	1
1000	4	SSP	Small Special	0	0	1
1000	5	SX	EXTRA ANCH	1	0.5	1
1001	1	2L	2 Large Pizzas	1	19.9	1
1001	2	LSG	Large SanGiorgio	0	0	1
1001	3	LSU	Large Supreme	0	0	1
1001	4	GB	Garlic Bread	1	2	1
1001	5	COKE	1.25 Ltr Coke	1	3	1
1002	1	CIGS	Cigarettes BENSON HEDGES EXTRA MILD	1	7.4	1
1002	2	+	+ MILK	1	1.5	1
1002	3	GS	Greek Salad	1	5.5	1
1002	4	MFAP	Fettucini Alla Panna	1	10	1
1003	1	FVG	Family Vegetarian	1	17	1
1003	2	FX	EXTRA PEPPERONI	1	1	1
1003	3	MIN	BOTTLE OF M/W	1	3.5	1
1004	1	MSBO	Spaghetti Bolognese	1	9.5	1
1004	2	CHGR	Grilled Chicken - HERBS, LEMON	1	13	1
1004	3	CHIPS	Chips	1	3.5	1
1004	4	STP	Pepper Steak	1	15	1
1005	1	ESMA	Entree Spaghetti Marinara	3	27	1
1006	1	2L	2 Large Pizzas	1	19.9	1
1006	2	L	LARGE	0	0	1
1006	3	HALF	1/2 mexican plus garlic	0	0	1
1006	4	HALF	1/2 seafood	1	0	1
1006	5	HALF	1/2 VEG PLUS GARLIC	1	0	1
1006	6	HALF	1/2 CHICK HAW PLUS GARLIC	1	0	1
1006	7	GB	Garlic Bread	1	2	1
1007	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1007	2	LSU	Large Supreme	0	0	1
1008	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1008	2	HALF	1/2 AUSTRALIAN	1	0	1
1008	3	HALF	1/2 PEPPERONI AND CHEESE	1	0	1
1009	1	SSU	Small Supreme	1	9.5	1
1009	2	COKE	1.25 Ltr Coke	1	3	1
1010	1	FAU	Family Australian	1	16	1
1010	2	GB	Garlic Bread	2	4	1
1010	3	SD	Soup of the Day	1	4.5	1
1010	4	MFAP	Fettucini Alla Panna	1	10	1
1010	5	DCC	Cheese Cake	3	10.5	1
1010	6	COKE	1.25 Ltr Coke	1	3	1
1010	7	DCOKE	1.25 LTR DIET COKE	1	3	1
1012	1	FVG	Family Vegetarian	1	17	1
1012	2	FVG	Family Vegetarian NO PINE	1	17	1
1013	1	VEGIE	SERVE OF VEGETABLES - NO CARROTS	1	3.15	1
1013	2	CSTZ	CHICKEN SCHNITZEL WITH VEGETABLES - CARROTS	1	12.6	1
1014	1	2F	2 Family Pizzas	1	25.9	1
1014	2	FSP	Family Special	0	0	1
1014	3	FX	EXTRA PINE	1	1	1
1014	4	FSG	Family SanGiorgio	0	0	1
1014	5	GB	Garlic Bread	1	2	1
1014	6	HB	Herb Bread	1	2	1
1015	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1015	2	HALF	1/2 SAN GIORGIO	1	0	1
1015	3	HALF	1/2 SPECIAL	1	0	1
1016	1	2S	2 Small Pizzas	1	16.9	1
1016	2	SCH	Small Chicken Hawiian	0	0	1
1016	3	SSU	Small Supreme	0	0	1
1016	4	COKE	1.25 Ltr Coke	1	3	1
1017	1	2L	2 Large Pizzas	1	19.9	1
1017	2	LSP	Large Special + CHILLI	0	0	1
1017	3	LMX	Large Mexican	0	0	1
1018	1	2L	2 Large Pizzas	1	19.9	1
1018	2	LMX	Large Mexican	0	0	1
1018	3	LSU	Large Supreme	0	0	1
1019	1	MGW	Main Grilled Whiting	1	15	1
1019	2	NO	No DRESSING ON THE SALAD	1	0	1
1019	3	NO	No FAT WITH THE FISH COOK IT WITHOUT OIL OR FAT	1	0	1
1019	4	STDMR	Steak Dianne - Md Rare	1	15	1
1019	5	CHIPS	Chips	1	3.5	1
1020	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1020	2	SSU	Small Supreme NO ANCH	0	0	1
1020	3	SX	EXTRA SALAMI	1	0.5	1
1021	1	LSU	Large Supreme	1	13.5	1
1021	2	MLA	Main Lasagna	1	9.5	1
1022	1	CHF	Chicken Fillets	1	14	1
1022	2	STDWD	Steak Dianne - Well Done	1	15	1
1022	3	MSBO	Spaghetti Bolognese	1	9.5	1
1022	4	DIS	Discount	1	-8.5	1
1022	5	DIS	Discount	1	-30	1
1022	6	DIS	Discount	1	30	1
1023	1	STSH	Schnitzel WITH VEG NO SALAD	1	10.5	1
1023	2	CBR	Continental Bread (3 peices)	1	0.6	1
1023	3	CHIN	BOTTLE OF CHINOTTO	1	3.5	1
1023	4	DIANE	DIANNE SAUCE ON THE SCHNITZEL	1	2.8	1
1024	1	MFAL	Fettucini Alfredo	1	8.1	1
1024	2	GB	Garlic Bread	1	1.8	1
1024	3	CCOKE	Can of Coke	1	1.7	1
1025	1	LSE	Large Seafood	1	13.5	1
1025	2	HAW	1/2 HAWAIIN	1	0	1
1026	1	SHW	Small Hawiian	1	8.1	1
1027	1	LAU	Large Australian	1	12	1
1027	2	BBQ	BBQ Sauce	1	1	1
1027	3	GB	Garlic Bread	1	2	1
1028	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1028	2	LSG	Large SanGiorgio	0	0	1
1028	3	NO	No SAL HAM CAP ONI	1	0	1
1028	4	LX	EXTRA MARIN CHICKEN,OLI	1	0.7	1
1028	5	SX	EXTRA FRE TOM	1	0.5	1
1028	6	CIGS	Cigarettes PETER STYV	1	6.6	1
1029	1	MSBO	Spaghetti Bolognese	1	9.5	1
1029	2	FX	EXTRA MU CAP OLI	1	1	1
1029	3	FS	French Salad	1	4	1
1029	4	NO	No DRESSING	1	0	1
1029	5	GB	Garlic Bread	2	4	1
1029	6	COKE	1.25 Ltr Coke	1	3	1
1030	1	F	FAM	1	18	1
1030	2	HALF	1/2 LOT	1	0	1
1030	3	HALF	1/2 SANGIORGIO	1	0	1
1030	4	MENU	MENU MENU	0	0	1
1031	1	ELA	Entree Lasagna	1	7.5	1
1031	2	SML	Small Meat Lovers	1	9.5	1
1031	3	DAPC	Apple Pie with Cream	2	7	1
1031	4	COKE	1.25 Ltr Coke	1	3	1
1032	1	MSMA	Spaghetti Marinara	1	11.5	1
1032	2	MSAP	Spaghetti Alla Panna	1	10	1
1032	3	CUT	*******CUTLERY**************	1	0	1
1033	1	FSG	Family SanGiorgio	1	18	1
1033	2	+	+ ONE QUARTER NO SALAMI	0	0	1
1034	1	MSCB	Spaghetti Carbonara	1	10	1
1034	2	SHW	Small Hawiian	1	9	1
1035	1	L	LARGE	1	13.5	1
1035	2	HALF	1/2 VEG PLUS CHIILLI	1	0	1
1035	3	HALF	1/2 LOT NO ANCH NO HAM	1	0	1
1035	4	GB	Garlic Bread	1	2	1
1036	1	2L	2 Large Pizzas	1	19.9	1
1036	2	LSU	Large Supreme -ANCH OLI	0	0	1
1036	3	HAW	1/2 HAWAIIN	1	0	1
1036	4	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1037	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1037	2	SUP	1/2 SUPREME NOANCH	1	0	1
1037	3	AUS	1/2 AUSTRALIAN	1	0	1
1038	1	LSU	Large Supreme	1	13.5	1
1038	2	LX	EXTRA CHICKEN	1	0.7	1
1038	3	LX	EXTRA SALAMI	1	0.7	1
1038	4	NO	No ANCH	1	0	1
1038	5	CIGS	Cigarettes PETER JACK-EX MILD	1	7.8	1
1039	1	FSU	Family Supreme	1	18	1
1040	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1040	2	LAM	Large American	0	0	1
1041	1	2L	2 Large Pizzas	1	19.9	1
1041	2	LSU	Large Supreme -ANCH	0	0	1
1041	3	--	PEPP, MU, BAC  +1/2 PIN	1	0	1
1042	1	2L	2 Large Pizzas	1	19.9	1
1042	2	LML	Large Meat Lovers	0	0	1
1042	3	BBQ	BBQ Sauce	1	1	1
1042	4	LX	EXTRA CHIK	1	0.7	1
1042	5	LCP	Large Capriciosa	0	0	1
1042	6	LX	EXTRA ANCH	1	0.7	1
1043	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1043	2	LAM	Large American	0	0	1
1044	1	DTA	Tartufo	3	10.5	1
1044	2	COKE	1.25 Ltr Coke	2	6	1
1044	3	SVG	Small Vegetarian	1	9	1
1044	4	CIGS	Cigarettes PETER JACKSON SUPER MILD	1	7.8	1
1045	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1045	2	FVG	Family Vegetarian	0	0	1
1045	3	--	DIET COKE INSTEAD OF COKE	0	0	1
1046	1	LSU	Large Supreme	1	13.5	1
1046	2	HALF	1/2 -ANCH	1	0	1
1046	3	LX	1/2 EXTRA HAM CHEESE	1	0.7	1
1047	1	2L	2 Large Pizzas	1	19.9	1
1047	2	HAW	1/2 HAWAIIN	1	0	1
1047	3	MEX	1/2 MEXICAM	1	0	1
1047	4	MLO	1/2 MEAT LOVERS	1	0	1
1047	5	SUP	1/2 SUPREME	1	0	1
1047	6	GB	Garlic Bread	2	4	1
1048	1	F	FAM	1	18	1
1048	2	SUP	1/2 SUPREME NOOLIVES OR SEAFOOD	1	0	1
1048	3	HAW	1/2 HAWAIIN	1	0	1
1048	4	FX	EXTRA CHEESEALL OVER	1	1	1
1049	1	EMAL	Entree Macaroni Alfredo	1	7	1
1049	2	+	+ CHILLI	0	0	1
1049	3	LSU	Large Supreme NO HAM	1	13.5	1
1049	4	CDIET	CAN OF DIET COKE	2	3.4	1
1050	1	2F	2 Family Pizzas	1	25.9	1
1050	2	FHW	Family Hawiian	0	0	1
1050	3	FSP	Family Special	0	0	1
1050	4	NO	No CAPSICUM	1	0	1
1050	5	HB	Herb Bread	1	2	1
1050	6	GB	Garlic Bread	1	2	1
1050	7	50	*****$50.00 NOTE*****	1	0	1
1053	1	2F	2 Family Pizzas	1	25.9	1
1053	2	HALF	1/2MEAT LOVERS	1	0	1
1053	3	HALF	1/2HAWA	1	0	1
1053	4	HALF	1/2LOT	1	0	1
1053	5	HALF	1/2AUS	1	0	1
1053	6	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1053	7	HALF	1/2LOT	1	0	1
1053	8	HALF	1/2VEG	1	0	1
1053	9	NO	NoPINE PLUS LITTLE CHILLI	1	0	1
1054	1	SSU	Small Supreme	1	9.5	1
1054	2	GB	Garlic Bread	1	2	1
1054	3	MCAP	Ricotta Ravioli Alla Panna	1	10	1
1054	4	+	+ EXTRA HAM AND MUSH	2	2	1
1054	5	ESBO	Entree Spaghetti Bolognese	1	7	1
1054	6	+	+ EXTRA BOL SAUCE	1	1.5	1
1055	1	LCH	Large Chicken Hawiian	1	13	1
1055	2	GB	Garlic Bread	1	2	1
1056	1	PC	Prawn Cocktail	1	8	1
1056	2	EFAP	Entree Fettucini Alla Panna	1	8	1
1056	3	COKE	1.25 Ltr Coke	1	3	1
1057	1	STR	Rump Steak	1	13	1
1057	2	CHIPS	Chips	1	3.5	1
1057	3	DAPC	Apple Pie with Cream	1	3.5	1
1058	1	2L	2 Large Pizzas	1	19.9	1
1058	2	HALF	1/2MARG	1	0	1
1058	3	HALF	1/2CHICKEN HAWAIIN	1	0	1
1058	4	LSG	Large SanGiorgio	0	0	1
1058	5	HALF	1/2 NO OLIVES	1	0	1
1059	1	CHGR	Grilled Chicken	2	26	1
1059	2	CHIPS	Chips	2	7	1
1059	3	SHW	Small Hawiian	1	9	1
1059	4	GB	Garlic Bread	1	2	1
1060	1	CHAS	Chicken Asparagus	1	14	1
1060	2	PC	Prawn Cocktail	1	8	1
1060	3	DCM	Chocolate Mousse	1	3.5	1
1061	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1061	2	HALF	1/2CAPRI	1	0	1
1061	3	HALF	1/2 LOT PLUS CHILLIE	1	0	1
1062	1	LSG	Large SanGiorgio 1/2 NO SALAMI	1	13.5	1
1062	2	ELA	Entree Lasagna	1	7.5	1
1062	3	COKE	1.25 Ltr Coke	1	3	1
1063	1	L	LARGE	0	0	1
1063	2	HALF	1/2 AMERICAN	1	0	1
1063	3	HALF	1/2 SAN GIORGIO	1	0	1
1063	4	NO	No OLIVES	1	0	1
1063	5	NO	No CHARGE	1	0	1
1064	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1064	2	SUP	1/2 SUPREME	1	0	1
1064	3	NO	No ANCH OR OLIVES OR PINE	1	0	1
1064	4	HAW	1/2 HAWAIIN	1	0	1
1064	5	CIGS	Cigarettes PETER STUYN	2	13.2	1
1065	1	CSTZ	CHICKEN SCHNITZEL WITH VEGETABLES	1	12.6	1
1065	2	NO	No carrots put extra other vegies	1	0	1
1066	1	2L	2 Large Pizzas	1	19.9	1
1066	2	HAW	1/2 HAWAIIN	1	0	1
1066	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1066	4	LSU	Large Supreme	0	0	1
1066	5	HALF	1/2 CHILLI	1	0	1
1067	1	2L	2 Large Pizzas	1	19.9	1
1067	2	LCP	Large Capriciosa	0	0	1
1067	3	LSU	Large Supreme	0	0	1
1068	1	STF	Fillet Mignon	3	51	1
1068	2	COKE	1.25 Ltr Coke	1	3	1
1069	1	2L	2 Large Pizzas	1	19.9	1
1069	2	LSG	Large SanGiorgio	0	0	1
1069	3	+	+CHILLI	0	0	1
1069	4	LVG	Large Vegetarian	0	0	1
1070	1	LSP	Large Special	1	12.5	1
1070	2	LSU	Large Supreme	1	13.5	1
1070	3	GB	Garlic Bread	1	2	1
1070	4	DBF	Black Forrest Cake	1	4	1
1071	1	LAM	Large American	1	12.5	1
1071	2	HALF	1/2 WITH MUSH AND PINE	1	0	1
1071	3	HALF	1/2 WITH CHICKEN	1	0	1
1071	4	LX	EXTRA	3	2.1	1
1071	5	CCOKE	Can of Coke	1	1.7	1
1071	6	50	*****$50.00 NOTE*****	1	0	1
1072	1	2L	2 Large Pizzas	1	19.9	1
1072	2	LSE	Large Seafood NO AN	0	0	1
1072	3	LVG	Large Vegetarian NO PIINE + CHILLI	0	0	1
1073	1	LSG	Large SanGiorgio	1	13.5	1
1073	2	NO	No SALAMI , ADD PEPPERONI	1	0	1
1073	3	GB	Garlic Bread	1	2	1
1074	1	MLA	Main Lasagna	1	9.5	1
1074	2	STVP	Veal Parmigiana	1	14	1
1075	1	LAU	Large Australian	1	12	1
1076	1	DCOKE	1.25 LTR DIET COKE	1	3	1
1076	2	2L	2 Large Pizzas	1	19.9	1
1076	3	LSE	Large Seafood	0	0	1
1076	4	LX	EXTRAPRAWNS,DRIEDTOMATOES	2	1.4	1
1076	5	LSE	Large Seafood	0	0	1
1076	6	LX	EXTRAAS ABOVE	2	1.4	1
1076	7	100	****$100.00 NOTE*****	1	0	1
1077	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1077	2	SVG	Small Vegetarian NO OLIVES +EXTRA PINE	0	0	1
1077	3	SX	EXTRA	1	0.5	1
1078	1	SAM	Small American	1	9	1
1078	2	SX	EXTRA TOMATO PASTE ON TOP	1	0.5	1
1078	3	SHW	Small Hawiian	1	9	1
1078	4	SSU	Small Supreme	1	9.5	1
1078	5	NO	No SEAFOOD	1	0	1
1079	1	L	LARGE	1	13.5	1
1079	2	HAW	1/2 HAWAIIN	1	0	1
1079	3	LX	EXTRA FRESH TOM MUSH ANCH	3	2.1	1
1079	4	MEX	1/2 MEXICAM	1	0	1
1080	1	F	FAM	1	18	1
1080	2	HALF	1/2 haw plus salami	1	0	1
1080	3	HALF	1/2lot no an ch	1	0	1
1080	4	BBQ	BBQ Sauce	1	1	1
1081	1	F	FAM MEATLOVER	1	18	1
1082	1	STVP	Veal Parmigiana	1	14	1
1082	2	ELA	Entree Lasagna	1	7.5	1
1083	1	FSE	Family Seafood	1	18	1
1084	1	FSU	Family Supreme	1	18	1
1085	1	STPMR	Pepper Steak - Md Rare	1	15	1
1085	2	STPMW	Pepper Steak - Md Well Done	1	15	1
1085	3	STP	Pepper Steak	1	15	1
1085	4	GS	Greek Salad	1	5.5	1
1085	5	OND	Dozen Oysters Natural	1	13	1
1085	6	DAPG	Apple Pie with Gelati NO GELATI	1	3.5	1
1086	1	SMA	Small Margherita	1	8	1
1086	2	SX	EXTRAHAM ONION CAP PRAWNS	4	2	1
1086	3	GB	Garlic Bread	1	2	1
1086	4	ECNA	Entree Ricotta Ravioli Napoletana	1	7	1
1087	1	FSU	Family Supreme	1	18	1
1087	2	FX	EXTRATOMATO+CHILLI	1	1	1
1088	1	LSU	Large Supreme	1	13.5	1
1088	2	NO	No ANCH	1	0	1
1088	3	HALF	1/2 NO OLIVES	1	0	1
1088	4	LHW	Large Hawiian	1	12.5	1
1088	5	GB	Garlic Bread	1	2	1
1088	6	COKE	1.25 Ltr Coke	1	3	1
1089	1	STPR	Pepper Steak - Rare	1	15	1
1089	2	CHIPS	Chips	1	3.5	1
1089	3	CCOKE	Can of Coke	1	1.7	1
1090	1	FSU	Family Supreme	1	18	1
1090	2	NO	No SEAFOOD ADD EXTRA PINE	1	0	1
1091	1	MTPU	Tortellini Putanesca	1	9.5	1
1091	2	GB	Garlic Bread	1	2	1
1092	1	2L	2 Large Pizzas	1	19.9	1
1092	2	LSU	Large Supreme	0	0	1
1092	3	LSE	Large Seafood	0	0	1
1093	1	F	FAM	1	18	1
1093	2	HAW	1/2 HAWAIIN	1	0	1
1093	3	HALF	1/2 CHEESE AND BACON	1	0	1
1094	1	LVG	Large Vegetarian	1	12.5	1
1094	2	NO	No PINE	1	0	1
1094	3	LX	EXTRA PICKLED CHILLI	1	0.7	1
1094	4	GB	Garlic Bread	1	2	1
1095	1	ETPU	Entree Tortelline Putanesca	1	7.5	1
1095	2	COKE	1.25 Ltr Coke	1	3	1
1095	3	FAU	Family Australian	1	16	1
1095	4	FX	EXTRA MUSH ALLOVER	1	1	1
1095	5	FX	EXTRA HALF WITH PEP AND CHILLI	1	1	1
1095	6	50	*****$50.00 NOTE*****	1	0	1
1096	1	STVP	Veal Parmigiana	1	14	1
1096	2	NO	No VEGETABLES, CHIPS INSTEAD	1	0	1
1096	3	GB	Garlic Bread	1	2	1
1097	1	2L	2 Large Pizzas	1	19.9	1
1097	2	LSU	Large Supreme	0	0	1
1097	3	LSG	Large SanGiorgio +CHILLI	0	0	1
1097	4	GB	Garlic Bread	2	4	1
1098	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1098	2	LSG	Large SanGiorgio	0	0	1
1098	3	SX	EXTRACHICKEN MUSH BASAIL	2	1	1
1099	1	2L	2 Large Pizzas	1	19.9	1
1099	2	LVG	Large Vegetarian	0	0	1
1099	3	SX	EXTRATOMATO SAUCE	1	0.5	1
1099	4	LSU	Large Supreme	0	0	1
1100	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1100	2	SUP	1/2 SUPREME NO HAM NO SEAFOOD	1	0	1
1100	3	HAW	1/2 HAWAIIN	1	0	1
1101	1	2F	2 Family Pizzas	1	25.9	1
1101	2	2F	2 Family Pizzas	1	25.9	1
1101	3	F	FAM SUPREME	0	0	1
1101	4	F	FAM CHICK HAW	0	0	1
1101	5	F	FAM MEAT LOVER	0	0	1
1101	6	F	FAM SPECIAL	0	0	1
1102	1	ELA	Entree Lasagna	3	22.5	1
1102	2	GB	Garlic Bread	3	6	1
1102	3	ETAP	Entree Tortelline Alla Panna	2	16	1
1102	4	LSU	Large Supreme NO ANCH + CHILI	1	13.5	1
1102	5	COKE	1.25 Ltr Coke	1	3	1
1103	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1103	2	VEG	1/2 VEGETARIAN	1	0	1
1103	3	SUP	1/2 SUPREME	1	0	1
1104	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1104	2	LSG	Large SanGiorgio	0	0	1
1104	3	LX	EXTRA CHICKEN BASIL CHILI	1	0.7	1
1105	1	COKE	1.25 Ltr Coke	2	6	1
1105	2	MSBO	Spaghetti Bolognese	1	9.5	1
1105	3	LML	Large Meat Lovers	1	13	1
1105	4	STD	Steak Dianne MW	1	15	1
1105	5	CUT	*******CUTLERY**************	1	0	1
1106	1	2F	2 Family Pizzas	1	25.9	1
1106	2	FVG	Family Vegetarian x sauce	0	0	1
1106	3	FSU	Family Supreme x sauce	0	0	1
1106	4	FX	EXTRA anch	1	1	1
1106	5	FX	EXTRA olives	1	1	1
1107	1	SD	Soup of the Day	1	4.05	1
1107	2	STSB	Scaloppina Bianco	1	9.45	1
1108	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1108	2	LSP	Large Special	0	0	1
1108	3	GB	Garlic Bread	1	2	1
1108	4	SSP	Small Special	1	9	1
1108	5	S	SMALL ham mush  1/2 pin	1	9.5	1
1109	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1109	2	LSG	Large SanGiorgio	0	0	1
1110	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1110	2	SUP	1/2 SUPREME	1	0	1
1110	3	VEG	1/2 VEGETARIAN no olives	1	0	1
1110	4	+	+ d/ coke	0	0	1
1111	1	LSG	Large SanGiorgio	1	13.5	1
1112	1	L	LARGE 1/2 garlic chicken	1	13.5	1
1112	2	VEG	1/2 VEGETARIAN no olives no pin	1	0	1
1112	3	FS	French Salad	1	4	1
1112	4	VEGIE	SERVE OF VEGETABLES	1	3.5	1
1113	1	LSU	Large Supreme	1	13.5	1
1113	2	+	+ CHILI	0	0	1
1114	1	STMS	Scaloppina Mushroom	1	11.5	1
1114	2	PC	Prawn Cocktail	1	8	1
1114	3	CFANTA	Can of Fanta	1	1.7	1
1114	4	50	*****$50.00 NOTE*****	1	0	1
1115	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1115	2	SSP	Small Special	0	0	1
1115	3	SX	EXTR  ANCHA	1	0.5	1
1116	1	FMA	Family Margherita	1	15	1
1116	2	+	+ 1/2 olives and musch	2	2	1
1117	1	MTNA	Tortellini Napolitana	1	9	1
1117	2	FS	French Salad	1	4	1
1117	3	MIN	BOTTLE OF M/W	1	3.5	1
1118	1	PFM	FAMILY PICK-UP	1	12.9	1
1118	2	FSU	Family Supreme	0	0	1
1118	3	NO	No ANCH,OLIVES	1	0	1
1119	1	MFNA	Fettucini Napolitana	1	9	1
1119	2	+	+ PARM CHEESE SEPARATE	1	1	1
1119	3	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1119	4	LSU	Large Supreme	0	0	1
1120	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1120	2	SCH	Small Chicken Hawiian	0	0	1
1121	1	MSVG	Spaghetti Vegetarian NO GARLIC	1	9.5	1
1121	2	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1121	3	LSE	Large Seafood	0	0	1
1121	4	CBR	Continental Bread (3 peices)	1	0.6	1
1122	1	PSM	SMALL PICK-UP	1	6.9	1
1122	2	SMX	Small Mexican	0	0	1
1122	3	DIS	Discount	1	-1.9	1
1123	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1123	2	FSP	Family Special	0	0	1
1123	3	FX	EXTRA anch	1	1	1
1123	4	DEL	DEL $1.00	0	0	1
1124	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1124	2	MAR	1/2 MARGHERITA X BASIL	1	0	1
1124	3	LX	EXTRA	1	0.7	1
1124	4	SUP	1/2 SUPREME	1	0	1
1125	1	FSU	Family Supreme	1	18	1
1126	1	SHW	Small Hawiian	1	9	1
1126	2	GB	Garlic Bread	1	2	1
1126	3	CLMND	Can of Lemonade	2	3.4	1
1127	1	PSM	SMALL PICK-UP	1	6.9	1
1127	2	SVG	Small Vegetarian	0	0	1
1127	3	PSM	SMALL PICK-UP	1	6.9	1
1127	4	SSU	Small Supreme NO PIN	0	0	1
1128	1	PFM	FAMILY PICK-UP	1	12.9	1
1128	2	F	FAM PEPP F/TOM	0	0	1
1129	1	SD	Soup of the Day	1	4.5	1
1129	2	ELA	Entree Lasagna	1	7.5	1
1129	3	LHW	Large Hawiian	1	12.5	1
1129	4	LX	EXTRA f/tom mush onion chicken	4	2.8	1
1129	5	LX	EXTRA cheese	1	0.7	1
1129	6	COKE	1.25 Ltr Coke	1	3	1
1129	7	DCOKE	1.25 LTR DIET COKE	1	3	1
1130	1	SSU	Small Supreme	1	9.5	1
1130	2	NO	No anch	1	0	1
1130	3	SX	EXTRA chick	2	1	1
1130	4	SX	EXTRA pepp	1	0.5	1
1130	5	CIGS	Cigarettes peter jacks s mild	1	7.8	1
1131	1	PFM	FAMILY PICK-UP	2	25.8	1
1131	2	FMX	Family Mexican	0	0	1
1131	3	FSU	Family Supreme	0	0	1
1132	1	CR	Calzone Rustico	1	10.5	1
1132	2	NO	NooliOLIV	1	0	1
1132	3	COKE	1.25 Ltr Coke	1	3	1
1132	4	MRAP	Ravioli Alla Panna	1	10	1
1133	1	SSG	Small SanGiorgio	1	9.5	1
1133	2	DAPG	Apple Pie with Gelati	1	3.5	1
1134	1	2L	2 Large Pizzas	1	19.9	1
1134	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1134	3	MLO	1/2 MEAT LOVERS	1	0	1
1134	4	HAW	1/2 HAWAIIN	1	0	1
1134	5	MEX	1/2 MEXICAM	1	0	1
1135	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1135	2	LSU	Large Supreme - ANC	0	0	1
1136	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1136	2	SSU	Small Supreme	0	0	1
1136	3	NO	No ANCH	1	0	1
1136	4	SX	EXTRA SALA	1	0.5	1
1136	5	CSQSH	Can of Lemon Squash	0	0	1
1137	1	2L	2 Large Pizzas	1	19.9	1
1137	2	LAU	Large Australian + ON	0	0	1
1137	3	L	LARGE ON TOM CAP PR PIN OLI	0	0	1
1138	1	CHAS	Chicken Asparagus	1	14	1
1138	2	NO	No VEG PLUS SALAD	1	0	1
1138	3	ELA	Entree Lasagna	1	7.5	1
1138	4	DFS	Fruit Salad & Ice Cream PLAIN	1	4.5	1
1138	5	DCC	Cheese Cake STRO	1	3.5	1
1138	6	DCC	Cheese Cake CHOCO	1	3.5	1
1138	7	*	MENU	0	0	1
1139	1	LCH	Large Chicken Hawiian	1	13	1
1139	2	GB	Garlic Bread	1	2	1
1140	1	LSU	Large Supreme	1	13.5	1
1140	2	HALF	1/2MAET LOVER	1	0	1
1140	3	HB	Herb Bread	1	2	1
1141	1	LSU	Large Supreme	1	13.5	1
1141	2	HALF	1/2 SEAFOOD	1	0	1
1141	3	COKE	1.25 Ltr Coke	1	3	1
1142	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1142	2	LSU	Large Supreme	0	0	1
1142	3	50	*****$50.00 NOTE*****	1	0	1
1143	1	FVG	Family Vegetarian	1	17	1
1143	2	HALF	1/2 SUP -NO ANCH	1	0	1
1144	1	F	FAM MUS CAP OL PEPP	1	18	1
1146	1	PSM	SMALL PICK-UP	1	6.9	1
1146	2	SSG	Small SanGiorgio	0	0	1
1146	4	SX	EXTRA HAM,CHILLI	1	0.5	1
1147	1	PFM	FAMILY PICK-UP	1	12.9	1
1147	2	FX	EXTRA CHICKEN SAL ON CAP HAM	3	3	1
1148	1	LVG	Large Vegetarian	1	12.5	1
1148	2	LX	EXTRA OLI,FRASH TOM	2	1.4	1
1148	3	LSG	Large SanGiorgio	1	13.5	1
1148	4	LX	EXTRA OLIV	1	0.7	1
1149	1	2L	2 Large Pizzas	1	19.9	1
1149	2	LML	Large Meat Lovers	0	0	1
1149	3	LSU	Large Supreme - ANC	0	0	1
1150	1	FSP	Family Special	1	17	1
1151	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1151	2	HALF	1/2MEAT.L x SAUCE	1	0	1
1151	3	HALF	1/2FR.TOM SALAMI DASH OF CHILI	1	0	1
1152	1	SSU	Small Supreme- ANC	1	9.5	1
1152	2	GB	Garlic Bread	1	2	1
1152	3	DCC	Cheese Cake	1	3.5	1
1152	4	CLMND	Can of Lemonade	1	1.7	1
1153	1	PSM	SMALL PICK-UP	1	6.9	1
1153	2	SVG	Small Vegetarian	0	0	1
1154	1	LSU	Large Supreme	1	13.5	1
1154	2	HAW	1/2 HAWAIIN	1	0	1
1155	1	FSU	Family Supreme	1	18	1
1155	2	NO	No ANCH	1	0	1
1156	1	LVG	Large Vegetarian	1	12.5	1
1156	2	NO	No OLIVES	1	0	1
1156	3	LX	EXTRA HAM	1	0.7	1
1156	4	LX	EXTRA PEPP	1	0.7	1
1157	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1157	2	HALF	1/2 PEPP MU OLI	1	0	1
1157	3	HALF	1/2 SEAFOOD -ANCH	1	0	1
1158	1	PSM	SMALL PICK-UP	1	6.9	1
1158	2	SSG	Small SanGiorgio	0	0	1
1159	1	FVG	Family Vegetarian	1	17	1
1159	2	DGE	Gelati Cup PIST/BACI	1	4	1
1159	3	DGE	Gelati Cup BACI/CHOCO	1	4	1
1160	1	COKE	1.25 Ltr Coke	1	3	1
1160	2	GB	Garlic Bread	1	2	1
1160	3	STVP	Veal Parmigiana	1	14	1
1161	1	LHW	Large Hawiian	1	12.5	1
1161	2	HALF	1/2 MARG	1	0	1
1161	3	GB	Garlic Bread	1	2	1
1161	4	COKE	1.25 Ltr Coke	1	3	1
1162	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1162	2	HALF	1/2 CHIK HAWAII	1	0	1
1162	3	HALF	1/2 VEG	1	0	1
1162	4	FX	EXTRA SALAM	1	1	1
1163	1	SD	Soup of the Day	1	4.05	1
1163	2	HB	Herb Bread	1	1.8	1
1163	3	CHAV	Chicken Avocado	1	12.6	1
1163	4	STSB	Scaloppina Bianco	1	9.45	1
1164	1	2L	2 Large Pizzas	1	19.9	1
1164	2	LSU	Large Supreme no cheese	0	0	1
1164	3	LMA	Large Margherita	0	0	1
1164	4	DCOKE	1.25 LTR DIET COKE	1	3	1
1165	1	2L	2 Large Pizzas	1	19.9	1
1165	2	HAW	1/2 HAWAIIN	1	0	1
1165	3	AME	1/2 AMERICAN	1	0	1
1165	4	LSU	Large Supreme	0	0	1
1165	5	NO	No anchovies	1	0	1
1166	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1166	2	SSU	Small Supreme	0	0	1
1166	3	MLA	Main Lasagna	1	9.5	1
1167	1	LCH	Large Chicken Hawiian	1	13	1
1167	2	+	+ chilli and garlic	0	0	1
1167	3	GB	Garlic Bread	1	2	1
1167	4	COKE	1.25 Ltr Coke	1	3	1
1168	1	PFM	FAMILY PICK-UP	1	12.9	1
1168	2	MEX	1/2 MEXICAM plus tabasco	1	0	1
1168	3	SAN	1/2 SAN GIORGIO	1	0	1
1169	1	2L	2 Large Pizzas	1	19.9	1
1169	2	LMA	Large Margherita	0	0	1
1169	3	LCH	Large Chicken Hawiian	0	0	1
1170	1	PSM	SMALL PICK-UP	1	6.9	1
1170	2	S	SMALL HAM BACON AND ONION	0	0	1
1170	3	SX	EXTRA CHEESE AND SAUCE	2	1	1
1171	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1171	2	L	LARGE PEPPERONI	0	0	1
1172	1	CHF	Chicken Fillets	1	14	1
1172	2	50	*****$50.00 NOTE*****	1	0	1
1173	1	FVG	Family Vegetarian	1	17	1
1174	1	MLA	Main Lasagna	1	9.5	1
1174	2	+	+ EXTRA MOZZARELLA CHEESE	1	1	1
1174	3	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1174	4	LSP	Large Special	0	0	1
1175	1	L	LARGE	1	13.5	1
1175	2	MEX	1/2 MEXICAM	1	0	1
1175	3	SAN	1/2 SAN GIORGIO	1	0	1
1175	4	NO	No OLIVES	1	0	1
1175	5	GB	Garlic Bread	1	2	1
1176	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1176	2	LCH	Large Chicken Hawiian	0	0	1
1176	3	+	+ BBQ SAUCE	1	1	1
1176	4	LX	EXTRA HALF OLIVES	1	0.7	1
1177	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1177	2	LSU	Large Supreme	0	0	1
1177	3	NO	No ANCH OR OLIVES	1	0	1
1178	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1178	2	SVG	Small Vegetarian	0	0	1
1178	3	NO	No OLIVES AND EXTRA PINE	1	0	1
1179	1	MTAP	Tortellini Alla Panna	1	10	1
1179	2	+	+ garlic	0	0	1
1179	3	DCC	Cheese Cake	1	3.5	1
1179	4	P		0	0	1
1180	1	FSP	Family Special	1	17	1
1180	2	FX	EXTRA chick	1	1	1
1180	3	GB	Garlic Bread	1	2	1
1181	1	PFM	FAMILY PICK-UP	3	38.7	1
1181	2	FSU	Family Supreme	0	0	1
1181	3	FSU	Family Supreme	0	0	1
1181	4	NO	No anch	1	0	1
1181	5	FHW	Family Hawiian with salami and olives	0	0	1
1182	1	STFMW	Fillet Mignon - Md Well Done	1	17	1
1182	2	VEGIE	SERVE OF VEGETABLES	1	3.5	1
1183	1	MINE	Minestrone Soup	1	4.5	1
1183	2	+	+ MACC	1	1	1
1183	3	MSBO	Spaghetti Bolognese	1	9.5	1
1184	1	L	LARGE	1	13.5	1
1184	2	HAW	1/2 HAWAIIN	1	0	1
1184	3	HALFQ	HAM BACON SALAMI ONION CAP	0	0	1
1184	4	LX	EXTRA	1	0.7	1
1185	1	2L	2 Large Pizzas	1	19.9	1
1185	2	LSE	Large Seafood (BOTH -ANCH)	0	0	1
1185	3	LX	EXTRA ONE + SUNDRY TOM+ARTICHOKES	2	1.4	1
1186	1	SAU	Small Australian	1	8.5	1
1186	2	STVP	Veal Parmigiana	1	14	1
1187	1	STD	Steak Dianne ( MED )	1	15	1
1188	1	PLG	LARGE PICK-UP	1	9.9	1
1188	2	LSU	Large Supreme NO ANCH	0	0	1
1189	1	S	SMALL MARINARA GOURMET	1	9.5	1
1189	2	SX	EXTRA OLIVES FETTA SUN DRY TOM BASIL PEP	5	2.5	1
1189	3	COKE	1.25 Ltr Coke	1	3	1
1190	1	LHW	Large Hawiian	1	12.5	1
1190	2	COKE	1.25 Ltr Coke	1	3	1
1191	1	PC	Prawn Cocktail	1	8	1
1191	2	CHAV	Chicken Avocado	1	14	1
1191	3	100	****$100.00 NOTE*****	1	0	1
1192	1	F	FAM	1	18	1
1192	2	SUP	1/2 SUPREME -PINE	1	0	1
1192	3	HALF	1/2 C/FOOD + GARLIC	1	0	1
1193	1	F	FAM SALAMI DOUBLE MUSH ONION CAP PIJNE DOUBE CHEESE	1	18	1
1193	2	FX	EXTRA	1	1	1
1194	1	2L	2 Large Pizzas	1	19.9	1
1194	2	LVG	Large Vegetarian	0	0	1
1194	3	L	LARGE PRAWNS,HAM+GARLIC	0	0	1
1195	1	FSU	Family Supreme - ANCH 1/2+CHILLI	1	18	1
1195	2	FX	EXTRA  CHEESE	1	1	1
1195	3	COKE	1.25 Ltr Coke	1	3	1
1196	1	EFW	Entree Fried Whiting	1	9	1
1196	2	STFWD	Fillet Mignon - Well Done	1	17	1
1197	1	2L	2 Large Pizzas	1	19.9	1
1197	2	LSU	Large Supreme	0	0	1
1197	3	LSG	Large SanGiorgio	0	0	1
1198	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1198	2	HAW	1/2 HAWAIIN	1	0	1
1198	3	SUP	1/2 SUPREME  ONE QUARTER NO OLIVES NO ANCH AT ALL ADD FRESH TOM ALL OVER	1	0	1
1199	1	ONH	1/2 Dozen Oysters Natural	1	8.5	1
1199	2	OKD	Dozen Oysters Kilpatrick	1	14.5	1
1199	3	EMBO	Entree Macaroni Bolognese	1	7	1
1199	5	NO	No ANCH	1	0	1
1199	6	FS	French Salad	1	4	1
1199	7	CBR	Continental Bread (3 peices)	1	0.6	1
1200	1	2F	2 Family Pizzas	1	25.9	1
1200	2	FSG	Family SanGiorgio PLUS CHILLI	0	0	1
1200	3	FCP	Family Capriciosa EXTRA GARLIC AND EXTRA HERBS	0	0	1
1200	4	WELL DONEQ	WELL DONE	0	0	1
1201	1	LSG	Large SanGiorgio	1	12.15	1
1201	2	ESCB	Entree Spaghetti Carbonara	1	7.2	1
1201	3	+	+ MUSHROOMS	1	0.9	1
1201	4	STSH	Schnitzel	1	9.45	1
1201	5	SHW	Small Hawiian	1	8.1	1
1201	6	ETCB	Entree Tortelline Carbonara	1	7.2	1
1201	7	GB	Garlic Bread	1	1.8	1
1202	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1202	2	LSU	Large Supreme	0	0	1
1202	3	NO	No ANCH OR OLIVES	1	0	1
1202	4	CIGS	Cigarettes ESCORT BLUE	1	8.4	1
1203	1	LVG	Large Vegetarian	1	12.5	1
1203	2	LX	EXTRA FRESH TOM	1	0.7	1
1203	3	LX	EXTRA FRESH TOM	1	0.7	1
1203	4	+	+ HERBS AND GARLIC AND CHILLI	0	0	1
1203	5	LX	EXTRA ANCHOVIES	1	0.7	1
1203	6	NO	No PINE	1	0	1
1203	7	LX	EXTRA ARTICHOKE	1	0.7	1
1204	1	LVG	Large Vegetarian	1	12.5	1
1204	2	GB	Garlic Bread	1	2	1
1204	3	COKE	1.25 Ltr Coke	1	3	1
1205	1	PSM	SMALL PICK-UP	1	6.9	1
1205	2	SSU	Small Supreme	0	0	1
1205	3	GB	Garlic Bread	1	2	1
1206	1	PLG	LARGE PICK-UP	5	49.5	1
1206	2	LSU	Large Supreme	0	0	1
1206	3	LX	EXTRA CHEESE	1	0.7	1
1206	4	LSU	Large Supreme	2	27	1
1206	5	NO	No ANCH	1	0	1
1206	6	LSU	Large Supreme	0	0	1
1206	7	NO	No CHEESE AND NO ANCH	1	0	1
1206	8	LVG	Large Vegetarian	0	0	1
1206	9	DIS	Discount	1	-42.2	1
1206	10	POLICE	POLICE ORDER	0	0	1
1207	1	F	FAM	1	18	1
1207	2	HAW	1/2 HAWAIIN	1	0	1
1207	3	MEX	1/2 MEXICAM	1	0	1
1207	4	FX	EXTRA SALAMI ALL OVER THE PIZZA	1	1	1
1208	1	SSP	Small Special	1	9	1
1208	2	NO	No OLIVES	1	0	1
1209	1	L	LARGE	1	13.5	1
1209	2	MAR	1/2 MARGHERITAPLUS CHILLI	1	0	1
1209	3	HAW	1/2 HAWAIIN	1	0	1
1209	4	DAPC	Apple Pie with Cream	1	3.5	1
1209	5	CDIET	CAN OF DIET COKE	2	3.4	1
1210	1	2L	2 Large Pizzas	1	19.9	1
1210	2	LSU	Large Supreme	0	0	1
1210	3	LAU	Large Australian	0	0	1
1210	4	LX	EXTRA EGG PINE PEP CAP	4	2.8	1
1210	5	GB	Garlic Bread	1	2	1
1211	1	2L	2 Large Pizzas	1	19.9	1
1211	2	LVG	Large Vegetarian	0	0	1
1211	3	LSU	Large Supreme	0	0	1
1211	4	NO	No SEAFOOD	1	0	1
1212	1	LSP	Large Special -CAPS	1	12.5	1
1213	1	L	LARGE	1	13.5	1
1213	2	+	+ ONION PEP MUSH	0	0	1
1213	3	HALF	1/2 PLUS PINE	1	0	1
1213	4	+	+ EXTRA TOMATO PASTE ALL OVER	0	0	1
1213	5	GB	Garlic Bread	1	2	1
1214	1	STR	Rump Steak MED	1	13	1
1214	2	GB	Garlic Bread	1	2	1
1214	3	COKE	1.25 Ltr Coke	1	3	1
1215	1	MLA	Main Lasagna	1	9.5	1
1216	1	STSB	Scaloppina Bianco	1	10.5	1
1217	1	MFAP	Fettucini Alla Panna	1	10	1
1217	2	SHW	Small Hawiian	1	9	1
1218	1	2L	2 Large Pizzas	1	19.9	1
1218	2	LHW	Large Hawiian	0	0	1
1218	3	LSG	Large SanGiorgio	0	0	1
1219	1	MSAP	Spaghetti Alla Panna	1	10	1
1219	2	MSMA	Spaghetti Marinara	1	11.5	1
1220	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1220	2	FSP	Family Special	0	0	1
1221	1	2F	2 Family Pizzas	1	25.9	1
1221	2	FSU	Family Supreme	0	0	1
1221	3	HALF	1/2 no olives	1	0	1
1221	4	NO	No anchovies	1	0	1
1221	5	FVG	Family Vegetarian	0	0	1
1222	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1222	2	LSU	Large Supreme -ANCH-PINE	0	0	1
1223	1	2L	2 Large Pizzas	1	19.9	1
1223	2	LSU	Large Supreme -CAPS-ANCH	0	0	1
1223	3	LSU	Large Supreme -PINE-ANCH-OLIVES	0	0	1
1224	1	MTCB	Tortellini Carbonara	1	10	1
1224	2	GS	Greek Salad	1	5.5	1
1225	1	CHGR	Grilled Chicken NO SALAD WITH VEG	1	11.7	1
1225	2	CBR	Continental Bread (3 peices)	2	1.08	1
1225	3	DIS	Discount	1	0.0200000000000014	1
1226	1	GB	Garlic Bread	1	2	1
1226	2	MGP	Main Garlic Prawns	1	16.5	1
1227	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1227	2	VEG	1/2 VEGETARIAN	1	0	1
1227	3	SAN	1/2 SAN GIORGIO	1	0	1
1228	1	LSP	Large Special	1	12.5	1
1229	1	F	FAM	1	18	1
1229	2	SUP	1/2 SUPREME NO ANCH	1	0	1
1229	3	VEG	1/2 VEGETARIAN	1	0	1
1229	4	FX	EXTRA FETTA ALL OVER	1	1	1
1230	1	MFAL	Fettucini Alfredo	1	8.1	1
1230	2	NO	No TARRAGON	1	0	1
1230	3	VEGIE	SERVE OF VEGETABLES	1	3.15	1
1230	4	NO	No POTATOE	1	0	1
1230	5	GB	Garlic Bread	1	1.8	1
1230	6	CCOKE	Can of Coke	1	1.7	1
1230	7	DIS	Discount	1	0.25	1
1231	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1231	2	LAM	Large American	0	0	1
1231	3	LX	EXTRA CHEESE	1	0.7	1
1232	1	LVG	Large Vegetarian	1	12.5	1
1232	2	LX	EXTRA PEP,	1	0.7	1
1232	3	MLA	Main Lasagna	1	9.5	1
1232	4	GB	Garlic Bread	2	4	1
1233	1	LHW	Large Hawiian	1	12.5	1
1233	2	LX	EXTRA SAL	1	0.7	1
1233	3	BBQ	BBQ Sauce	1	1	1
1233	4	GB	Garlic Bread	1	2	1
1233	5	HB	Herb Bread	1	2	1
1234	1	PSM	SMALL PICK-UP HAWAIIAM	1	6.9	1
1234	2	PFM	FAMILY PICK-UP	1	12.9	1
1234	3	HALF	1/2 BBQ CHICK	1	0	1
1234	4	HALF	1/2 SUP	1	0	1
1234	5	DIS	Discount	1	-4.8	1
1235	1	ETAP	Entree Tortelline Alla Panna	1	8	1
1235	2	PSM	SMALL PICK-UP	1	6.9	1
1235	3	SSP	Small Special NO OLIVES	0	0	1
1236	1	LSE	Large Seafood	1	13.5	1
1236	2	DIS	Discount	1	-6.5	1
1237	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1237	2	LSU	Large Supreme	0	0	1
1237	3	LX	EXTRA PINE	1	0.7	1
1238	1	F	FAM	1	18	1
1238	2	CAP	1/2 CAPRICIOSA	1	0	1
1238	3	SAN	1/2 SAN GIORGIO	1	0	1
1238	4	GB	Garlic Bread	1	2	1
1239	1	FSU	Family Supreme	1	18	1
1239	2	NO	No ANCHOVIES	1	0	1
1241	1	PLG	LARGE PICK-UP	1	9.9	1
1241	2	LMA	Large Margherita PLUS PEP	0	0	1
1241	3	GB	Garlic Bread	1	2	1
1242	1	PFM	FAMILY PICK-UP SUPREME	1	12.9	1
1242	2	PLG	LARGE PICK-UP VEG	1	9.9	1
1243	1	STRMR	Rump Steak - Md Rare	1	13	1
1243	2	ERAP	Entree Ravioli Alla Panna	1	8	1
1243	3	STVP	Veal Parmigiana	1	14	1
1243	4	CUT	*******CUTLERY**************	1	0	1
1244	1	2L	2 Large Pizzas	1	19.9	1
1244	2	LMA	Large Margherita PLUS ANCH	0	0	1
1244	3	LAU	Large Australian	0	0	1
1245	1	FVG	Family Vegetarian	1	17	1
1245	2	DGE	Gelati Cup BACI PIST CHOC	1	4	1
1246	1	MLA	Main Lasagna	1	8.55	1
1246	2	DBF	Black Forrest Cake	1	3.6	1
1246	3	SHW	Small Hawiian	2	16.2	1
1246	4	ETAP	Entree Tortelline Alla Panna	1	7.2	1
1246	5	CIGS	Cigarettes  ESCORT BLUE	1	8.4	1
1246	6	CUT	*******CUTLERY**************	1	0	1
1247	1	MMNA	Macaroni Napolitana +ALFREDO	1	9	1
1247	2	SX	EXTRA CHICKEN,MUSH,BACON	4	2	1
1247	3	GB	Garlic Bread	2	4	1
1248	1	LSG	Large SanGiorgio	1	13.5	1
1248	2	DIS	Discount	1	-13.5	1
1248	3	SHW	Small Hawiian	1	9	1
1248	4	DIS	Discount	1	3	1
1249	1	SVG	Small Vegetarian	1	9	1
1249	2	DCM	Chocolate Mousse	1	3.5	1
1249	3	DAPG	Apple Pie with Gelati	1	3.5	1
1249	4	CCOKE	Can of Coke	1	1.7	1
1249	5	CIGS	Cigarettes DUNHILL WHITE	1	7.4	1
1250	1	F	FAM	1	18	1
1250	2	SUP	1/2 SUPREME	1	0	1
1250	3	HAW	1/2 HAWAIIN	1	0	1
1250	4	FX	EXTRA MUXH AND PRAWNS	2	2	1
1251	1	SSE	Small Seafood	1	8.55	1
1251	2	SX	EXTRA ANCH	1	0.45	1
1251	3	GB	Garlic Bread	1	1.8	1
1252	1	SD	Soup of the Day	1	4.05	1
1252	2	GB	Garlic Bread	2	3.6	1
1252	3	DGE	Gelati Cup CHOC	2	7.2	1
1252	4	GS	Greek Salad	1	4.95	1
1254	1	MFBO	Fettucini Bolognese X SAUCE	1	9.5	1
1254	2	GB	Garlic Bread	1	2	1
1254	3	DGE	Gelati Cup CHOC LEMON	1	4	1
1255	1	FSU	Family Supreme X ANCH+HERBS	1	18	1
1255	2	HALF	1/2 CHICKEN HW +MUSHROOMS	2	0	1
1255	3	GB	Garlic Bread	1	2	1
1255	4	COKE	1.25 Ltr Coke	1	3	1
1255	5	DIS	Discount	1	2	1
1256	1	2F	2 Family Pizzas	1	25.9	1
1256	2	FSP	Family Special	0	0	1
1256	3	FSG	Family SanGiorgio	0	0	1
1256	4	GB	Garlic Bread	1	2	1
1256	5	COKE	1.25 Ltr Coke	1	3	1
1257	1	LSU	Large Supreme	1	13.5	1
1258	1	F	FAM OLIVES MUSH SALAMI PEPP	1	18	1
1258	2	+	+ HERBS GARLIC PIN ONION CAP	1	1	1
1259	1	CHGR	Grilled Chicken	1	13	1
1259	2	DTA	Tartufo NO CREAM	1	3.5	1
1259	3	DCC	Cheese Cake	1	3.5	1
1259	4	CUT	*******CUTLERY**************	1	0	1
1260	1	STVP	Veal Parmigiana	1	14	1
1261	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1261	2	SVG	Small Vegetarian	0	0	1
1261	3	+	+BASIL	0	0	1
1261	4	HB	Herb Bread	1	2	1
1262	1	FSP	Family Special NO OLIVES	1	17	1
1263	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1263	2	SVG	Small Vegetarian NO OLIVES	0	0	1
1263	3	SX	EXTRA PIN	1	0.5	1
1263	4	STSH	Schnitzel	1	10.5	1
1263	5	+	+ CHIPS	1.8	1.8	1
1264	1	STP	Pepper Steak R	1	15	1
1264	2	+	+ SAUCE  SEPARATE	0	0	1
1265	1	L	LARGE	1	13.5	1
1265	2	HALF	1/2 AMERICAN	1	0	1
1265	3	HALF	1/2 CAPRICIOSA	1	0	1
1265	4	COKE	1.25 Ltr Coke	1	3	1
1266	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1266	2	LSU	Large Supreme	0	0	1
1267	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1267	2	LCP	Large Capriciosa NO OLIVES	0	0	1
1267	3	LX	EXTRA CAP	1	0.7	1
1267	4	LX	EXTRA HALF PIN	1	0.7	1
1268	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1268	2	HALF	1/2 VEG	1	0	1
1268	3	HALF	1/2 SEAFOOD	1	0	1
1269	1	2L	2 Large Pizzas	1	19.9	1
1269	2	LSU	Large Supreme	0	0	1
1269	3	LSU	Large Supreme	0	0	1
1270	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1270	2	LARGE	SALAMI ONION CARLIC	0	0	1
1271	1	2F	2 Family Pizzas	1	25.9	1
1271	2	FSU	Family Supreme-ANCH-OLIVES	0	0	1
1271	3	FSU	Family Supreme XANCHXOLIVES	0	0	1
1271	4	COKE	1.25 Ltr Coke	1	3	1
1273	1	LSG	Large SanGiorgio	1	13.5	1
1274	1	STVP	Veal Parmigiana	1	14	1
1274	2	CHF	Chicken Fillets	1	14	1
1274	3	CUT	*******CUTLERY**************	1	0	1
1274	4	SALT	SALT	0	0	1
1274	5	DEL	$1.00	0	0	1
1275	1	LVG	Large Vegetarian +FR.BASIL1/2 MCHILLI	1	12.5	1
1275	2	GB	Garlic Bread	1	2	1
1275	3	LX	EXTRA OLIVES	1	0.7	1
1276	1	MSMA	Spaghetti Marinara	1	11.5	1
1276	2	+	+ X SAUCE	0	0	1
1276	3	DCM	Chocolate Mousse	1	3.5	1
1276	4	COKE	1.25 Ltr Coke	1	3	1
1277	1	MMBO	Macaroni Bolognese	1	9.5	1
1277	2	MMPU	Macaroni Putanesca	1	9.5	1
1277	3	GB	Garlic Bread	2	4	1
1278	1	2L	2 Large Pizzas	1	19.9	1
1278	2	LAM	Large American	0	0	1
1278	3	LX	EXTRA PIN MUSH	2	1.4	1
1278	4	L	LARGE HALF MEXICAN NO OLIVES	0	0	1
1278	5	CAP	1/2 CAPRICIOSA NO OLIVES	1	0	1
1279	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1279	2	LSU	Large Supreme	0	0	1
1280	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1280	2	LMA	Large Margherita	0	0	1
1281	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1281	2	LVG	Large Vegetarian	0	0	1
1281	3	GS	Greek Salad	1	5.5	1
1282	1	2L	2 Large Pizzas	1	19.9	1
1282	2	LMX	Large Mexican	0	0	1
1282	3	L	LARGE CHICK,SALAMI,CAPS,ONION,HAM	0	0	1
1282	4	LX	EXTRA CHICKEN	3	2.1	1
1283	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1283	2	LSU	Large Supreme NO PIN	0	0	1
1283	3	HALF	1/2 NO OLIVES	1	0	1
1284	1	FHW	Family Hawiian	1	16.5	1
1284	2	FX	EXTRA CHICK HERBS	1	1	1
1284	3	COKE	1.25 Ltr Coke	1	3	1
1284	4	50	*****$50.00 NOTE*****	1	0	1
1285	1	STD	Steak Dianne MED  X SAUCE	1	15	1
1285	2	MGP	Main Garlic Prawns X SAUCE	1	16.5	1
1285	3	DIS	Discount	1	-3.1	1
1286	1	F	FAM	1	18	1
1286	2	SUP	1/2 SUPREME	1	0	1
1286	3	SAN	1/2 SAN GIORGIO	1	0	1
1286	4	COKE	1.25 Ltr Coke	1	3	1
1286	5	CIGS	Cigarettes PETER SYVESANT	1	6.6	1
1287	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1287	2	LSG	Large SanGiorgio	0	0	1
1287	3	LX	EXTRA BACON	1	0.7	1
1288	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1288	2	F	FAM SUPREME	0	0	1
1288	3	+	+ DEL $1.00	0	0	1
1289	1	MTNA	Tortellini Napolitana	1	9	1
1289	2	S	SMALL HAM MUSH PIN ONION	1	9.5	1
1290	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1290	2	SVG	Small Vegetarian NO OLIVES	0	0	1
1290	3	SX	EXTRA PIN	1	0.5	1
1291	1	MGP	Main Garlic Prawns X SAUCE	1	14.85	1
1291	2	CUT	*******CUTLERY**************	1	0	1
1292	1	MCNA	Ricotta Ravioli Napolitana	1	9	1
1292	2	MRBO	Ravioli Bolognese	1	9.5	1
1292	3	GB	Garlic Bread	2	4	1
1293	1	LSG	Large SanGiorgio	1	13.5	1
1294	1	FHW	Family Hawiian	1	16.5	1
1295	1	2L	2 Large Pizzas	1	19.9	1
1295	2	2L	2 Large Pizzas	1	19.9	1
1295	3	LVG	Large Vegetarian	0	0	1
1295	4	LSG	Large SanGiorgio	0	0	1
1295	5	LCH	Large Chicken Hawiian	0	0	1
1295	6	LSU	Large Supreme	0	0	1
1296	1	F	FAM	1	18	1
1296	2	HAW	1/2 HAWAIIN + PEPP	1	0	1
1296	3	SUP	1/2 SUPREME NO ANCH	1	0	1
1296	4	FX	EXTRA CHEESE ALL OVER	1	1	1
1297	1	DCA	Cassata	1	3.5	1
1297	2	DLGE	large gelati cup	1	6	1
1297	3	--	CHO BAC PIS	0	0	1
1298	1	MCPU	Ricotta Ravioli Putanesca	1	9.5	1
1298	2	CCOKE	Can of Coke	1	1.7	1
1298	3	DCM	Chocolate Mousse	1	3.5	1
1299	1	LCH	Large Chicken Hawiian	0	0	1
1299	2	PLG	LARGE PICK-UP	1	9.9	1
1300	1	LML	Large Meat Lovers	1	13	1
1300	2	GB	Garlic Bread	1	2	1
1301	1	2F	2 Family Pizzas	5	129.5	1
1301	2	.	FAM AUS	2	0	1
1301	3	.	FAM HAWAIIN	2	0	1
1301	4	.	FAM MEXICAN	2	0	1
1301	5	.	FAM SUP - SEA	3	0	1
1302	1	L	LARGE	1	13.5	1
1302	2	MAR	1/2 MARGHERITA + SALAMI	1	0	1
1302	3	SUP	1/2 SUPREME	1	0	1
1302	4	SHW	Small Hawiian	1	9	1
1302	5	COKE	1.25 Ltr Coke	1	3	1
1302	6	CIGS	Cigarettes B& H SP FILTER	1	7.4	1
1302	7	GB	Garlic Bread	1	2	1
1302	8	DTA	Tartufo	1	3.5	1
1303	1	PLG	LARGE PICK-UP SUPREME	1	9.9	1
1303	2	LX	EXTRA PIN ANCH LITTLE CHILI	2	1.4	1
1303	3	LX	EXTRA CHEESE	1	0.7	1
1304	1	PFM	FAMILY PICK-UP	1	12.9	1
1304	2	FCH	Family Chicken Hawiian	0	0	1
1304	3	FX	EXTRA CHEESE	1	1	1
1304	4	BBQ	BBQ Sauce	1	1	1
1304	5	GB	Garlic Bread	2	4	1
1305	1	ELA	Entree Lasagna	1	7.5	1
1305	2	ESBO	Entree Spaghetti Bolognese	1	7	1
1305	3	GB	Garlic Bread	1	2	1
1305	4	EMPU	Entree Macaroni Putanesca	1	7.5	1
1305	5	VEGIE	SERVE OF VEGETABLES POTATOES	1	3.5	1
1306	1	CR	Calzone Rustico	2	21	1
1306	2	GB	Garlic Bread	1	2	1
1306	3	ELA	Entree Lasagna	1	7.5	1
1306	4	COKE	1.25 Ltr Coke	1	3	1
1307	1	2L	2 Large Pizzas	1	19.9	1
1307	2	LAM	Large American	0	0	1
1307	3	LCH	Large Chicken Hawiian	0	0	1
1308	1	STD	Steak Dianne ( MED )	1	15	1
1308	2	DBF	Black Forrest Cake	1	4	1
1308	3	50	*****$50.00 NOTE*****	1	0	1
1309	1	LHW	Large Hawiian	1	12.5	1
1309	2	L	LARGE PEPPERONI AND ONION	1	13.5	1
1309	3	GB	Garlic Bread	1	2	1
1310	1	FVG	Family Vegetarian	1	17	1
1310	2	FX	EXTRA CHICK	1	1	1
1310	3	HALF	1/2 NO OLIVES	1	0	1
1311	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1311	2	SVG	Small Vegetarian NO OLIVES	0	0	1
1311	3	SX	EXTRA PIN	1	0.5	1
1312	1	PLG	LARGE PICK-UP	1	9.9	1
1312	2	LVG	Large Vegetarian	0	0	1
1313	1	CHGR	Grilled Chicken	1	13	1
1313	2	GB	Garlic Bread	1	2	1
1313	3	COKE	1.25 Ltr Coke	1	3	1
1314	1	LMX	Large Mexican	1	13	1
1314	2	GB	Garlic Bread	1	2	1
1315	1	2F	2 Family Pizzas	1	25.9	1
1315	2	FSU	Family Supreme 1/2-ANCH-OLIVES	0	0	1
1315	3	FML	Family Meat Lovers	0	0	1
1316	1	F	FAM	1	18	1
1316	2	HAW	1/2 HAWAIIN + CHICK	1	0	1
1316	3	HAW	1/2 HAWAIIN + MUSH + SALAMI	1	0	1
1316	4	FVG	Family Vegetarian	1	17	1
1316	5	FX	EXTRA FRESH TOM	1	1	1
1316	6	FSU	Family SupremE - PIN	1	18	1
1316	7	FSU	Family Supreme NO ANCH	1	18	1
1316	8	F	FAM	1	18	1
1316	9	SUP	1/2 SUPREME  NO SEAFOOD	1	0	1
1316	10	HAW	1/2 HAWAIIN + OLIVES + PEPP	1	0	1
1316	11	F	FAM	1	18	1
1316	12	+	+ CHICK CAP MUSH ONION	1	1	1
1316	13	+	+GARLIC + HERBS	1	1	1
1316	14	FVG	Family Vegetarian NO MUSH	1	17	1
1316	15	HALF	1/2 NO OLIVES + CHILI ALL OVER	1	0	1
1316	16	FSU	Family Supreme LITTLE CHILI	1	18	1
1316	17	FSU	Family Supreme + CHILI	1	18	1
1316	18	F	FAM HALF SEAFOOD NO ANCH	1	18	1
1316	19	HALF	1/2 SUPREME NO ANCH	1	0	1
1316	20	DIS	Discount	1	-61	1
1317	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1317	2	HAW	1/2 HAWAIIN	1	0	1
1317	3	SEA	1/2 SEAFOOD	1	0	1
1318	1	GS	Greek Salad -OLIVES X ONION	1	5.5	1
1318	2	STR	Rump Steak MED RARE	1	13	1
1318	3	GB	Garlic Bread	1	2	1
1318	4	COKE	1.25 Ltr Coke	1	3	1
1319	1	ETAP	Entree Tortelline Alla Panna	1	8	1
1319	2	STP	Pepper Steak WD	1	15	1
1320	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1320	2	SHW	Small Hawiian	0	0	1
1321	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1321	2	LSU	Large Supreme	0	0	1
1321	3	LX	EXTRA CHEESE MILD CHILI	1	0.7	1
1322	1	CHGR	Grilled Chicken	1	13	1
1322	2	CHCS	Chef's Salad	1	13	1
1322	3	DTA	Tartufo	1	3.5	1
1322	4	CUT	*******CUTLERY**************	1	0	1
1323	1	LSG	Large SanGiorgio	1	13.5	1
1323	2	LX	EXTRA CHEESE	1	0.7	1
1323	3	LX	EXTRA HAM	1	0.7	1
1323	4	LX	EXTRA MUSH	1	0.7	1
1323	5	COKE	1.25 Ltr Coke	1	3	1
1324	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1324	2	LSU	Large Supreme 1/2-ANCH +CHILLI-PINE	0	0	1
1325	1	SSG	Small SanGiorgio	1	9.5	1
1325	2	MRBO	Ravioli Bolognese	1	9.5	1
1326	1	STSZ	Scaloppina Zingara	1	11.5	1
1326	2	GB	Garlic Bread	1	2	1
1326	3	DCM	Chocolate Mousse	1	3.5	1
1327	1	2L	2 Large Pizzas	1	19.9	1
1327	2	LSG	Large SanGiorgio	0	0	1
1327	3	LCP	Large Capriciosa	0	0	1
1328	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1328	2	HAW	1/2 HAWAIIN	1	0	1
1328	3	FX	EXTRA MUSH+PEPP	2	2	1
1328	4	HAW	1/2 HAWAIIN	1	0	1
1328	5	FX	EXTRA ONION+CAPS+MUSH	1	1	1
1329	1	LVG	Large Vegetarian NO CHEESE	1	12.5	1
1329	2	LX	EXTRA pwns	2	1.4	1
1329	3	LX	EXTRA anch	1	0.7	1
1329	4	LX	EXTRA mussels	1	0.7	1
1330	1	FSU	Family Supreme -anch	1	18	1
1330	2	FX	EXTRA CHEESE	1	1	1
1330	3	DIS	discount	1	-1	1
1331	1	2L	2 Large Pizzas	1	19.9	1
1331	2	LSP	Large Special	0	0	1
1331	3	LMA	Large Margherita	0	0	1
1331	4	LX	EXTRA SALAMI+CHICKEN	2	1.4	1
1331	5	PC	Prawn Cocktail	1	8	1
1332	1	CHF	Chicken Fillets	1	14	1
1332	2	GB	Garlic Bread	1	2	1
1332	3	CUT	*******CUTLERY**************	1	0	1
1333	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1333	2	FML	Family Meat Lovers	0	0	1
1333	3	FX	EXTRA bbq sauce	1	1	1
1334	1	LSU	Large Supreme no seafood	1	13.5	1
1334	2	_	no pin no capsicum	0	0	1
1335	1	PFM	FAMILY PICK-UP	1	12.9	1
1335	2	HAW	1/2 HAWAIIN	1	0	1
1335	3	SPE	1/2 SPECIAL	1	0	1
1336	1	2L	2 Large Pizzas	1	19.9	1
1336	2	LCH	Large Chicken Hawiian	0	0	1
1336	3	LSE	Large Seafood	0	0	1
1337	1	CHGR	Grilled Chicken	1	11.7	1
1338	1	2F	2 Family Pizzas	1	25.9	1
1338	2	FVG	Family Vegetarian	0	0	1
1338	3	FSP	Family Special	0	0	1
1339	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1339	2	FSU	Family Supreme NO OLIVES	0	0	1
1339	3	HALF	1/2 NO ANCH	1	0	1
1339	4	+	+ GIVE 3 G/B  NO COKE	0	0	1
1340	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1340	2	FVG	Family Vegetarian	0	0	1
1340	3	+	+ EXTRA SAUCE	0	0	1
1340	4	HALF	1/2 NO PIN  + ANCH	1	0	1
1340	5	FX	EXTRA	1	1	1
1341	1	CHF	Chicken Fillets	2	28	1
1341	2	DEL	$1.00 DELIVERY	0	0	1
1342	1	PFM	FAMILY PICK-UP	1	12.9	1
1342	2	MAR	1/2 MARGHERITA	1	0	1
1342	3	SUP	1/2 SUPREME - ANCH	1	0	1
1343	1	L	LARGE	1	13.5	1
1343	2	MAR	1/2 MARGHERITA	1	0	1
1343	3	SAN	1/2 SAN GIORGIO	1	0	1
1343	4	GB	Garlic Bread	1	2	1
1344	1	2L	2 Large Pizzas	1	19.9	1
1344	2	L	LARGE HAM CHICK MUSH GARLIC	0	0	1
1344	3	L	LARGE BACON HAM PINE MUSH ONION GARLIC	0	0	1
1344	4	LX	EXTRA	2	1.4	1
1344	5	LX	EXTRA HALF ANCHOVIES ON BOTH	2	1.4	1
1345	1	2L	2 Large Pizzas	1	19.9	1
1345	2	LSE	Large Seafood	0	0	1
1345	3	LSU	Large Supreme	0	0	1
1346	1	CHAV	Chicken Avocado	1	14	1
1346	2	STF	Fillet Mignon	1	17	1
1347	1	2L	2 Large Pizzas	1	19.9	1
1347	2	LSU	Large Supreme	0	0	1
1347	3	LSE	Large Seafood	1	13.5	1
1347	4	COKE	1.25 Ltr Coke	1	3	1
1347	5	DCOKE	1.25 LTR DIET COKE	1	3	1
1347	6	DBF	Black Forrest Cake	3	12	1
1347	7	GB	Garlic Bread	2	4	1
1347	8	L	LARGE FRESH TOM AND ONION	0	0	1
1348	1	FVG	Family Vegetarian	1	17	1
1349	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1349	2	HAW	1/2 HAWAIIN	1	0	1
1349	3	VEG	1/2 VEGETARIAN	1	0	1
1349	4	FX	EXTRA ANCH ON VEG	1	1	1
1350	1	FSU	Family Supreme	1	18	1
1350	2	NO	No ANCH	1	0	1
1350	3	COKE	1.25 Ltr Coke	1	3	1
1350	4	GB	Garlic Bread	1	2	1
1351	1	MFAP	Fettucini Alla Panna	1	10	1
1351	2	+	+ BOLOGNESE SAUCE AND CHIILLI MIXED IN ONLY A LITTLE BIT	1	1	1
1351	3	+	+ EXTRA MUSHROOMS	1	1	1
1351	4	GB	Garlic Bread	1	2	1
1352	1	LVG	Large Vegetarian	1	12.5	1
1352	2	NO	No OLIVESPLUS PINEAPPLE	1	0	1
1353	1	2L	2 Large Pizzas	1	19.9	1
1353	2	LCH	Large Chicken Hawiian	0	0	1
1353	3	LX	EXTRA ONION	1	0.7	1
1353	4	LSU	Large Supreme	0	0	1
1353	5	NO	No OLIVES	1	0	1
1353	6	HALF	1/2 ANCH ON SUP	1	0	1
1354	1	ETAP	Entree Tortelline Alla Panna	1	8	1
1354	2	SCH	Small Chicken Hawiian	1	9.5	1
1354	3	SMX	Small Mexican	1	9.5	1
1354	4	GB	Garlic Bread	1	2	1
1355	1	MLA	Main Lasagna	1	9.5	1
1355	2	GS	Greek Salad	1	5.5	1
1356	1	LCH	Large Chicken Hawiian	1	13	1
1356	2	GB	Garlic Bread	1	2	1
1356	3	DCOKE	1.25 LTR DIET COKE	1	3	1
1357	1	SSG	Small SanGiorgio	1	9.5	1
1357	2	SX	EXTRA ANCH	1	0.5	1
1357	3	GB	Garlic Bread	1	2	1
1357	4	COKE	1.25 Ltr Coke	1	3	1
1358	1	CSTZ	CHICKEN SCHNITZEL WITH VEGETABLES	1	12.6	1
1358	2	NO	NoCAROT	1	0	1
1359	1	L	LARGECONTINENTAL	1	13.5	1
1360	1	LVG	Large Vegetarian	1	12.5	1
1360	2	GB	Garlic Bread	1	2	1
1361	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1361	2	LSP	Large Special	0	0	1
1361	3	NO	No CAPS  SALAMI	1	0	1
1361	4	LX	EXTRA FR TOM	1	0.7	1
1361	5	LX	EXTRA PEPP	1	0.7	1
1361	6	LX	EXTRA CHEESE	1	0.7	1
1362	1	F	FAM	1	18	1
1362	2	SUP	1/2 SUPREME NO ANCH	1	0	1
1362	3	HAW	1/2 HAWAIIN	1	0	1
1362	4	FX	EXTRA CHEESE ON THE HAW	1	1	1
1363	1	F	FAM	1	18	1
1363	2	MAR	1/2 MARGHERITA	1	0	1
1363	3	FX	EXTRA SALAMI	1	1	1
1363	4	SUP	1/2 SUPREME	1	0	1
1363	5	SD	Soup of the Day	2	9	1
1363	6	GB	Garlic Bread	1	2	1
1363	7	CBR	Continental Bread (3 peices)	1	0.6	1
1364	1	PC	Prawn Cocktail	1	8	1
1364	2	SSP	Small Special	1	9	1
1365	1	F	FAM	1	18	1
1365	2	CAP	1/2 CAPRICIOSA	1	0	1
1365	3	SEA	1/2 SEAFOOD NO ANCH	1	0	1
1366	1	2F	2 Family Pizzas	1	25.9	1
1366	2	FCP	Family Capriciosa	0	0	1
1366	3	FSG	Family SanGiorgio	0	0	1
1367	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1367	2	SSP	Small Special	0	0	1
1367	3	GB	Garlic Bread	1	2	1
1368	1	L	LARGE	1	13.5	1
1368	2	SEA	1/2 SEAFOOD	1	0	1
1368	3	SUP	1/2 SUPREME	1	0	1
1368	4	CCOKE	Can of Coke	1	1.7	1
1368	5	GB	Garlic Bread	1	2	1
1369	1	FSG	Family SanGiorgio	1	18	1
1369	2	FX	EXTRA ANCH	1	1	1
1370	1	2F	2 Family Pizzas	1	25.9	1
1370	2	HAW	1/2 HAWAIIN	1	0	1
1370	3	SEA	1/2 SEAFOOD	1	0	1
1370	4	SPE	1/2 SPECIAL	1	0	1
1370	5	MAR	1/2 MARGHERITA	1	0	1
1371	1	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1371	2	LSU	Large Supreme	0	0	1
1372	1	2L	2 Large Pizzas	1	19.9	1
1372	2	LMA	Large Margherita	0	0	1
1372	3	LSG	Large SanGiorgio	0	0	1
1373	1	F	FAM HAM ONION CAP MUSH SALAMI FRESH TOM	1	18	1
1374	1	MFAL	Fettucini Alfredo	1	8.1	1
1374	2	CCOKE	Can of Coke	1	1.7	1
1374	3	GB	Garlic Bread	1	1.8	1
1375	1	LSU	Large Supreme	1	13.5	1
1375	2	NO	No PINE HALF WITH CHILLI	1	0	1
1376	1	PLG	LARGE PICK-UP	1	9.9	1
1376	2	SUP	1/2 SUPREME	1	0	1
1376	3	SAN	1/2 SAN GIORGIO	1	0	1
1377	1	FAM	Family American	1	16.5	1
1377	2	FX	EXTRA PEPP	1	1	1
1378	1	MCBO	Ricotta Ravioli Bolognese	1	9.5	1
1378	2	LPGC	Large Pizza, Garlic Br, Coke	1	15.9	1
1378	3	LSG	Large SanGiorgio	0	0	1
1379	1	PC	Prawn Cocktail	1	8	1
1379	2	CHF	Chicken Fillets	1	14	1
1379	3	STPWD	Pepper Steak - Well Done	1	15	1
1380	1	PFM	FAMILY PICK-UP	1	12.9	1
1380	2	HAW	1/2 HAWAIIN PLUS MUSH AND ANCH	1	0	1
1380	3	MEX	1/2 MEXICAM	1	0	1
1381	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1381	2	MLO	1/2 MEAT LOVERS	1	0	1
1381	3	MEX	1/2 MEXICAM	1	0	1
1381	4	FX	EXTRA SAUCE ALL OVER	1	1	1
1382	1	FSU	Family Supreme -ANCH OLI	1	18	1
1382	2	SX	EXTRA PEPPON THIS HALF	1	0.5	1
1382	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1382	4	GB	Garlic Bread	1	2	1
1383	1	FPGC	Family Pizza, Garlic Br, Coke	1	20	1
1383	2	VEG	1/2 VEGETARIAN	1	0	1
1383	3	MLO	1/2 MEAT LOVERS	1	0	1
1383	4	FX	EXTRA  FRESHH TOM ON THIS HALF	1	1	1
1384	1	PLG	LARGE PICK-UP	1	9.9	1
1384	2	MAR	1/2 MARGHERITA	1	0	1
1384	3	SUP	1/2 SUPREME NO ANCH	1	0	1
1387	1	PLG	LARGE PICK-UP	1	9.9	1
1387	2	LSU	Large Supreme no seafood	0	0	1
1388	1	FSU	Family Supreme -anch	1	18	1
1388	2	MLO	1/2 MEAT LOVERS	1	0	1
1389	1	FSU	Family Supreme	1	18	1
1390	1	SSP	Small Special	1	9	1
1390	2	NO	No OLIVES	1	0	1
1390	3	MFCB	Fettucini Carbonara	1	10	1
1390	4	DAPG	Apple Pie with Gelati	2	7	1
1390	5	GB	Garlic Bread	1	2	1
1391	1	2L	2 Large Pizzas	1	19.9	1
1391	2	LSU	Large Supreme	2	27	1
1391	3	DIS	Discount	1	-27	1
1392	1	L	LARGE  H MU SAL BASIL	1	13.5	1
1392	2	LX	EXTRA CHEESE	1	0.7	1
1392	3	GB	Garlic Bread	1	2	1
1393	1	F	FAM	1	18	1
1393	2	HAW	1/2 HAWAIIN	1	0	1
1393	3	SUP	1/2 SUPREME	1	0	1
1393	4	GB	Garlic Bread	1	2	1
1394	1	FMX	Family Mexican	1	17.5	1
1395	1	CV	Calzone Vegetarian	1	10.5	1
1395	2	--	BOLOGNESE SAUCE INSTEAD OF NAPOLITANA	0	0	1
1395	3	MCBO	Ricotta Ravioli Bolognese +CHILLI	1	9.5	1
1396	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1396	2	LMA	Large Margherita PLUS OLIVES	0	0	1
1397	1	2L	2 Large Pizzas	1	19.9	1
1397	2	LML	Large Meat Lovers	0	0	1
1397	3	L	LARGE MUSH OLIVES ANCH PEP	0	0	1
1398	1	MLA	Main Lasagna	1	9.5	1
1398	2	GB	Garlic Bread	1	2	1
1398	3	CHIPS	Chips	1	3.5	1
1399	1	2L	2 Large Pizzas	1	19.9	1
1399	2	LVG	Large Vegetarian	0	0	1
1399	3	LML	Large Meat Lovers	0	0	1
1400	1	EMAP	Entree Macaroni Alla Panna	1	7.2	1
1400	2	SD	Soup of the Day	1	4.05	1
1400	3	GS	Greek Salad	1	4.95	1
1400	4	CBR	Continental Bread (3 peices)	1	0.54	1
1400	5	DIS	Discount	1	-0.0399999999999991	1
1401	1	STVP	Veal Parmigiana	1	14	1
1401	2	NO	No veal	1	0	1
1401	3	+	+ chicken	1	1	1
1401	4	GS	Greek Salad	1	5.5	1
1401	5	DCM	Chocolate Mousse	1	3.5	1
1401	6	GB	Garlic Bread	1	2	1
1401	7	COKE	1.25 Ltr Coke	1	3	1
1402	1	FSU	Family Supreme	1	18	1
1403	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1403	2	LVG	Large Vegetarian	0	0	1
1404	1	EMCB	Entree Macaroni Carbonara	1	8	1
1404	2	+	+ MUSH CHICK NAPOLITANA SAUCE	3	3	1
1404	3	L	LARGE	1	13.5	1
1404	4	MLO	1/2 MEAT LOVERS	1	0	1
1404	5	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1404	6	BBQ	BBQ Sauce on chicken haw	1	1	1
1404	7	CFANTA	Can of Fanta	2	3.4	1
1405	1	FSU	Family Supreme -ANCH	1	18	1
1405	2	COKE	1.25 Ltr Coke	1	3	1
1406	1	FSG	Family SanGiorgio	1	18	1
1407	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1407	2	L	LARGE H PIN PEPP CHIK PR GARL	0	0	1
1407	3	--	MU	0	0	1
1407	4	LX	EXTRA FRE TOM	1	0.7	1
1408	1	CR	Calzone Rustico	1	10.5	1
1408	2	SX	EXTRA PINE	1	0.5	1
1408	3	DGE	Gelati Cup LEMON	1	4	1
1408	4	CIGS	Cigarettes ESCORT BLUE	1	8.4	1
1408	5	100	****$100.00 NOTE*****	1	0	1
1408	6	100	****$100.00 NOTE*****	1	0	1
1409	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1409	2	FSU	Family Supreme NO ANCH	0	0	1
1410	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1410	2	FSU	Family Supreme	0	0	1
1411	1	LVG	Large Vegetarian	1	12.5	1
1411	2	SX	EXTRA OLI ,CHILLI	1	0.5	1
1412	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1412	2	HAW	1/2 HAWAIIN	1	0	1
1412	3	HALF	1/2 H PIN MU CHIK ONI	1	0	1
1412	4	GB	Garlic Bread	2	4	1
1413	1	S	SMALL PINE ONLY	1	9.5	1
1413	2	ESBO	Entree Spaghetti Bolognese	1	7	1
1413	3	GB	Garlic Bread	1	2	1
1413	4	50	*****$50.00 NOTE*****	1	0	1
1413	5	50	*****$50.00 NOTE*****	1	0	1
1416	1	SSU	Small Supreme	1	9.5	1
1416	2	SX	EXTRA ANC CHEESE	2	1	1
1416	3	NO	No PIN	1	0	1
1416	4	DBF	Black Forrest Cake	2	8	1
1417	1	FSU	Family Supreme	1	18	1
1418	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1418	2	LSG	Large SanGiorgio	0	0	1
1419	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1419	2	VEG	1/2 VEGETARIAN	1	0	1
1419	3	SUP	1/2 SUPREME	1	0	1
1419	4	NO	No ANCH	1	0	1
1420	1	MCAL	Ricotta Ravioli Alfredo	1	9	1
1420	2	S	SMALL CHICK MUSH HAM OLIVE PEP	1	9.5	1
1420	3	CCOKE	Can of Coke	1	1.7	1
1420	4	CFANTA	Can of Fanta	1	1.7	1
1421	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1421	2	F	FAMLOT	0	0	1
1422	1	L	LARGE GOURMET VEG	1	13.5	1
1422	2	+	+ LITTLE CHILLI	0	0	1
1422	3	GB	Garlic Bread	1	2	1
1423	1	SAM	Small American +MUSHROOM	1	9	1
1423	2	COKE	1.25 Ltr Coke	1	3	1
1424	1	PSM	SMALL PICK-UP	1	6.9	1
1424	2	SAM	Small American	0	0	1
1424	3	SX	EXTRA MUSH	0	0.5	1
1425	1	PSM	SMALL PICK-UP	1	6.9	1
1425	2	SAM	Small American	0	0	1
1425	3	COKE	1.25 Ltr Coke	1	3	1
1426	1	STVP	Veal Parmigiana	2	28	1
1426	2	ECVG	Entree Ricotta Ravioli Vegetarian	1	7	1
1426	3	ELA	Entree Lasagna	1	7.5	1
1426	4	COKE	1.25 Ltr Coke	1	3	1
1426	5	GB	Garlic Bread	1	2	1
1427	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1427	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1427	3	SEA	1/2 SEAFOOD	1	0	1
1428	1	FSU	Family Supreme	1	18	1
1428	2	NO	1/2 No ANC OL PR	1	0	1
1429	1	STP	Pepper Steak	1	15	1
1429	2	WD	well done	0	0	1
1429	3	CUT	*******CUTLERY**************	1	0	1
1430	1	L	LARGE CAP SAL ANCH PINE FRESH TOMATO	1	13.5	1
1430	2	LX	EXTRA CHEESE	1	0.7	1
1430	3	GB	Garlic Bread	1	2	1
1431	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1431	2	FML	Family Meat Lovers	0	0	1
1431	3	FX	EXTRACAPSICUM	1	1	1
1431	4	FX	EXTRAPINE	1	1	1
1431	5	FX	EXTRABBQ	1	1	1
1432	1	MLA	Main Lasagna	1	9.5	1
1432	2	MFBO	Fettucini Bolognese	1	9.5	1
1432	3	MSBO	Spaghetti Bolognese	1	9.5	1
1432	4	GB	Garlic Bread	2	4	1
1432	5	COKE	1.25 Ltr Coke	1	3	1
1433	1	SUP	1/2 SUPREME	1	0	1
1433	2	VEG	1/2 VEGETARIAN	1	0	1
1433	3	FSU	Family Supreme	1	18	1
1434	1	2F	2 Family Pizzas	1	25.9	1
1434	2	FVG	Family Vegetarian	0	0	1
1434	3	FX	EXTRAHAM	1	1	1
1434	4	HAW	1/2 HAWAIIN	1	0	1
1434	5	MEX	1/2 MEXICAM	1	0	1
1435	1	EFC	Entree Fried Calamari	1	8.5	1
1435	2	STVP	Veal Parmigiana	1	14	1
1435	3	GB	Garlic Bread	1	2	1
1436	1	2F	2 Family Pizzas	1	25.9	1
1436	2	FCP	Family Capriciosa	0	0	1
1436	3	FML	Family Meat Lovers	0	0	1
1437	1	PA	Prawn Avocado	2	20	1
1437	2	EGP	Entree Garlic Prawns	1	10.5	1
1437	3	MSBO	Spaghetti Bolognese	1	9.5	1
1437	4	EGW	Entree Grilled Whiting	1	9	1
1437	5	CHIPS	Chips	1	3.5	1
1438	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1438	2	LSU	Large Supreme	0	0	1
1439	1	CHF	Chicken FilletsNOT TOO MUCH GARLIC AND POTATOES ONLU MIUSROOM SAUCE INSTEAD	1	14	1
1440	1	LSU	Large Supreme	1	13.5	1
1440	2	ELA	Entree Lasagna	1	7.5	1
1441	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1441	2	HAW	1/2 HAWAIIN	1	0	1
1441	3	SAN	1/2 SAN GIORGIO	1	0	1
1442	1	LSG	Large SanGiorgio	1	13.5	1
1442	2	COKE	1.25 Ltr Coke	1	3	1
1443	1	STP	Pepper Steak M-R	1	15	1
1443	2	+	+ FILLET STK M-R (MUSH SAUCE)	0	15	1
1443	3	+	+ BOTH SAUCES SEPARATE	0	0	1
1444	1	F	FAM	1	16.2	1
1444	2	SUP	1/2 SUPREME NO OLIVES OR ANCH	1	0	1
1444	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1444	4	FX	EXTRA CHEESE	1	0.9	1
1444	5	MENU	MENU MENU	0	0	1
1445	1	ETAP	Entree Tortelline Alla Panna	1	8	1
1445	2	CDIET	CAN OF DIET COKE	1	1.7	1
1446	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1446	2	LVG	Large Vegetarian	0	0	1
1446	3	LX	EXTRA MUSH AND OLIVES	2	1.4	1
1447	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1447	2	AME	1/2 AMERICAN	1	0	1
1447	3	SPE	1/2 SPECIAL	1	0	1
1447	4	LX	EXTRA PEPPERONI	1	0.7	1
1448	1	MLA	Main Lasagna	1	9.5	1
1448	2	GB	Garlic Bread	1	2	1
1448	3	DAPG	Apple Pie with Gelati	1	3.5	1
1449	1	FSU	Family Supreme	1	18	1
1449	2	HALF	1/2 - SEA	1	0	1
1449	3	COKE	1.25 Ltr Coke	1	3	1
1450	1	FSU	Family Supreme THIN	1	18	1
1450	2	FX	EXTRA SAUCE,1/2 -ANCH,PINE,CHILLI	1	1	1
1450	3	GB	Garlic Bread	1	2	1
1451	1	L	LARGE	1	13.5	1
1451	2	VEG	1/2 VEGETARIAN	1	0	1
1451	3	HALF	1/2 MEAT.L.	1	0	1
1451	4	GB	Garlic Bread	1	2	1
1452	1	FSU	Family Supreme	1	18	1
1452	2	FSU	Family Supreme 1/2-PINE -ANCH	1	18	1
1453	1	2F	2 Family Pizzas	1	25.9	1
1453	2	FSU	Family Supreme - anc	0	0	1
1453	3	COKE	1.25 Ltr Coke	1	3	1
1454	1	F	FAM	1	18	1
1454	2	HAW	1/2 HAWAIIN	1	0	1
1454	3	SPE	1/2 SPECIAL - CAPS	1	0	1
1455	1	L	LARGE HAM ON BAC	1	13.5	1
1455	2	LX	EXTRA SAL	1	0.7	1
1456	1	2L	2 Large Pizzas	1	19.9	1
1456	2	HAW	1/2 HAWAIIN	1	0	1
1456	3	SUP	1/2 SUPREME	1	0	1
1456	4	LSU	Large Supreme	0	0	1
1457	1	LSU	Large Supreme	1	13.5	1
1458	1	FML	Family Meat Lovers	1	17.5	1
1459	1	FHW	Family Hawiian	1	16.5	1
1459	2	FX	EXTRA SAL CHEESE	2	2	1
1459	3	COKE	1.25 Ltr Coke	1	3	1
1460	1	2F	2 Family Pizzas	1	25.9	1
1460	2	FSE	Family Seafood	0	0	1
1460	3	FSU	Family Supreme	0	0	1
1460	4	COKE	1.25 Ltr Coke	1	3	1
1461	1	FSG	Family SanGiorgio	1	18	1
1461	2	VEG	1/2 VEGETARIAN	1	0	1
1461	3	FX	EXTRA ANC	1	1	1
1462	1	FSU	Family Supreme - PIN	1	18	1
1462	2	VEG	1/2 VEGETARIAN - PIN	1	0	1
1463	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1463	2	FVG	Family Vegetarian	0	0	1
1464	1	2L	2 Large Pizzas	1	19.9	1
1464	2	LMA	Large Margherita + ANC	0	0	1
1464	3	LSG	Large SanGiorgio	0	0	1
1465	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1465	2	FSU	Family Supreme -ANCH-OLIVES	0	0	1
1466	1	SVG	Small Vegetarian	1	9	1
1466	2	SX	EXTRA FR.TOM ,OLIVES+1/2CHILLI	1	0.5	1
1466	3	GB	Garlic Bread	1	2	1
1467	1	FSU	Family Supreme -C/FOOD	1	18	1
1467	2	FX	EXTRA PEPP+MUSHROOM	1	1	1
1467	3	COKE	1.25 Ltr Coke	1	3	1
1468	1	LHW	Large Hawiian	1	12.5	1
1468	2	LX	EXTRA 1/2 PEPP+MUSHROOM	2	1.4	1
1469	1	2L	2 Large Pizzas	1	19.9	1
1469	2	LSU	Large Supreme	0	0	1
1469	3	LSU	Large Supreme	0	0	1
1470	1	FSP	Family Special	1	17	1
1470	2	FX	EXTRA ONION	1	1	1
1470	3	FX	EXTRA ANCH	1	1	1
1471	1	MRBO	Ravioli Bolognese	1	9.5	1
1471	2	+	+ EXTRA CHEESE ON TOP	1	1	1
1471	3	CCOKE	Can of Coke	1	1.7	1
1471	4	CBR	Continental Bread (3 peices)	1	0.6	1
1471	5	STVP	Veal Parmigiana	1	14	1
1471	6	GB	Garlic Bread	1	2	1
1471	7	CLMND	Can of Lemonade	1	1.7	1
1471	8	DEL	$1.00 DEL	0	0	1
1471	9	50	*****$50.00 NOTE*****	1	0	1
1472	1	CHGR	Grilled Chicken	1	13	1
1472	2	NO	No VEG PLUS SALAD	1	0	1
1472	3	NO	No DRESS	1	0	1
1472	4	DCC	Cheese Cake	1	3.5	1
1472	5	CIGS	Cigarettes escort red	1	8.4	1
1472	6	50	*****$50.00 NOTE*****	1	0	1
1473	2	GB	Garlic Bread	1	2	1
1473	3	SCH	Small Chicken Hawiian	1	9.5	1
1473	4	SMA	Small Margherita	1	8	1
1474	1	MINE	Minestrone Soup	1	4.05	1
1474	2	SD	Soup of the Day	1	4.05	1
1474	3	HB	Herb Bread	1	1.8	1
1474	4	SHW	Small Hawiian	1	8.1	1
1475	1	CHGR	Grilled Chicken	4	52	1
1475	2	VEGIE	SERVE OF VEGETABLES	1	3.5	1
1475	3	GB	Garlic Bread	1	2	1
1476	1	MFP	Main Fried Prawns	1	16	1
1476	2	+	+ CHIPS ONLY	1	0	1
1476	3	MINE	Minestrone Soup	1	4.5	1
1476	4	+	+ MACARONI	1	1	1
1476	5	COKE	1.25 Ltr Coke	1	3	1
1476	6	DCC	Cheese Cake	1	3.5	1
1477	1	EGP	Entree Garlic Prawns	1	10.5	1
1477	2	CHF	Chicken Fillets	1	14	1
1478	1	2L	2 Large Pizzas	1	19.9	1
1478	2	LML	Large Meat Lovers	0	0	1
1478	3	LSU	Large Supreme NO PIN	0	0	1
1478	4	CIGS	Cigarettes BH SP FILITER	1	7.4	1
1479	1	2F	2 Family Pizzas	1	25.9	1
1479	2	FVG	Family Vegetarian	0	0	1
1479	3	FVG	Family Vegetarian	0	0	1
1479	4	HB	Herb Bread	1	2	1
1480	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1480	2	LSP	Large Special	0	0	1
1481	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1481	2	SSG	Small SanGiorgio	0	0	1
1481	3	SX	EXTRA ANCH	1	0.5	1
1481	4	CDIET	CAN OF DIET COKE	0	0	1
1482	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1482	2	LCP	Large Capriciosa	0	0	1
1483	1	EGP	Entree Garlic Prawns	1	10.5	1
1483	2	CBR	Continental Bread (3 peices)	1	0.6	1
1483	3	SSG	Small SanGiorgio	1	9.5	1
1483	4	SX	EXTRA ANCH	1	0.5	1
1484	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1484	2	FVG	Family Vegetarian	0	0	1
1484	3	FX	EXTRA PWNS	1	1	1
1484	4	FX	EXTRA ANCH	1	1	1
1485	1	CR	Calzone Rustico	2	18.9	1
1485	2	SX	EXTRA ONION	2	0.9	1
1486	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1486	2	FVG	Family Vegetarian	0	0	1
1486	3	FX	EXTRA CHICKEN	1	1	1
1487	1	2L	2 Large Pizzas	1	19.9	1
1487	2	LSG	Large SanGiorgio	0	0	1
1487	3	LSG	Large SanGiorgio	0	0	1
1487	4	LX	EXTRA ANCH	2	1.4	1
1488	1	2L	2 Large Pizzas	1	19.9	1
1488	2	LMA	Large Margherita	0	0	1
1488	3	LSP	Large Special - OLI	0	0	1
1488	4	COKE	1.25 Ltr Coke	1	3	1
1488	5	CCOKE	Can of Coke	2	3.4	1
1489	1	2L	2 Large Pizzas	1	19.9	1
1489	2	LCH	Large Chicken Hawiian	0	0	1
1489	3	LX	EXTRA BBQ PEPPERONI CAP	3	2.1	1
1489	4	LML	Large Meat Lovers	0	0	1
1490	1	FSU	Family Supreme	1	18	1
1490	2	HALF	1/2 + ANC	1	0	1
1490	1	FSU	Family Supreme	1	18	1
1490	2	HALF	1/2 + ANC	1	0	1
1492	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1492	2	FSU	Family Supreme	0	0	1
1492	3	DEL	$1.00 delivery	0	0	1
1493	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1493	2	L	LARGE CHICK BAC PIN CAPS	0	0	1
1494	1	2L	2 Large Pizzas	1	19.9	1
1494	2	LCH	Large Chicken Hawiian NO PIN	0	0	1
1494	3	LCP	Large Capriciosa	0	0	1
1494	4	DEL	$1.00 DEL	0	0	1
1495	1	LSG	Large SanGiorgio	1	13.5	1
1495	2	GB	Garlic Bread	2	4	1
1496	1	DCC	Cheese Cake	1	3.5	1
1496	2	GS	Greek Salad	1	5.5	1
1496	3	EMCB	Entree Macaroni Carbonara	1	8	1
1496	4	+	+M E N U	0	0	1
1497	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1497	2	LML	Large Meat Lovers	0	0	1
1498	1	2L	2 Large Pizzas	1	19.9	1
1498	2	LHW	Large Hawiian	0	0	1
1498	3	LSU	Large Supreme	0	0	1
1498	4	GB	Garlic Bread	1	2	1
1499	1	PA	Prawn Avocado	1	10	1
1499	2	EFBO	Entree Fettucini Bolognese	1	7	1
1499	3	+	+KNOCK ON DOOR	0	0	1
1500	1	LSU	Large Supreme	1	13.5	1
1500	2	NO	No  SEAFOOD	1	0	1
1501	1	SCH	Small Chicken Hawiian	1	9.5	1
1501	2	CCOKE	Can of Coke	1	1.7	1
1501	3	GB	Garlic Bread	1	2	1
1502	1	STVP	Veal Parmigiana	1	14	1
1502	2	GB	Garlic Bread	1	2	1
1503	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1503	2	FHW	Family Hawiian	0	0	1
1503	3	FX	EXTRA PINE	1	1	1
1504	1	SSU	Small Supreme	1	9.5	1
1504	2	PC	Prawn Cocktail	1	8	1
1504	3	EFC	Entree Fried Calamari	1	8.5	1
1504	4	COKE	1.25 Ltr Coke	1	3	1
1505	1	2L	2 Large Pizzas	1	19.9	1
1505	2	LVG	Large Vegetarian	0	0	1
1505	3	LCP	Large Capriciosa	0	0	1
1505	4	LX	EXTRA ANCH	1	0.7	1
1506	1	L	LARGE	1	13.5	1
1506	2	MLO	1/2 MEAT LOVERS	1	0	1
1506	3	AUS	1/2 AUSTRALIAN	1	0	1
1506	4	LX	EXTRA MUSH	1	0.7	1
1506	5	LX	EXTRA OLIVES	1	0.7	1
1506	6	LX	EXTRA SALAMI	1	0.7	1
1506	7	GB	Garlic Bread	2	4	1
1506	8	CCOKE	Can of Coke	1	1.7	1
1507	1	2F	2 Family Pizzas	1	25.9	1
1507	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1507	3	FX	EXTRA ON MUS	3	3	1
1507	4	HALF	1/2 SAL CAP MUS ANC FR TOM	1	0	1
1507	5	FSG	Family SanGiorgio	0	0	1
1507	6	CIGS	Cigarettes PETER STYV	1	6.6	1
1507	7	50	*****$50.00 NOTE*****	1	0	1
1508	1	MRVG	Ravioli Vegetarian	2	19	1
1509	1	MSBO	Spaghetti Bolognese	2	19	1
1509	2	GB	Garlic Bread	1	2	1
1509	3	MTBO	Tortellini Bolognese	1	9.5	1
1510	1	LHW	Large Hawiian	1	12.5	1
1510	2	SAN	1/2 SAN GIORGIO	1	0	1
1510	3	CHCS	Chef's Salad	1	13	1
1510	4	DIS	Discount	1	-5.5	1
1511	1	MRAP	Ravioli Alla Panna	1	10	1
1512	1	LSE	Large Seafood	1	13.5	1
1512	2	VEG	1/2 VEGETARIAN	1	0	1
1512	3	LX	EXTRA PIN	1	0.7	1
1512	4	FS	French Salad	1	4	1
1512	5	GB	Garlic Bread	1	2	1
1513	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1513	2	LSU	Large Supreme	0	0	1
1514	1	FSU	Family Supreme	1	18	1
1514	2	FX	EXTRA ANCH	1	1	1
1515	1	PLG	LARGE PICK-UP	1	9.9	1
1515	2	LSE	Large Seafood	0	0	1
1515	3	--	CHILLI	0	0	1
1516	1	PFM	FAMILY PICK-UP	1	12.9	1
1516	2	FSU	Family Supreme -OLI	0	0	1
1516	3	FX	EXTRA CHIK	1	1	1
1517	1	LSU	Large Supreme -ANCH OLI	1	13.5	1
1517	2	ESBO	Entree Spaghetti Bolognese	1	7	1
1517	3	COKE	1.25 Ltr Coke	1	3	1
1518	1	MGP	Main Garlic Prawns	1	16.5	1
1518	2	LSG	Large SanGiorgio	1	13.5	1
1518	3	LX	EXTRA PRAWNS 1/2 + PIN	1	0.7	1
1518	4	COKE	1.25 Ltr Coke	1	3	1
1519	1	PFM	FAMILY PICK-UP	1	12.9	1
1519	2	FSU	Family Supreme	0	0	1
1519	3	HALF	1/2 -ANCH	1	0	1
1520	1	EMAL	Entree Macaroni Alfredo	1	7	1
1520	2	EMBO	Entree Macaroni Bolognese	1	7	1
1520	3	CDIET	CAN OF DIET COKE	1	1.7	1
1521	1	FSU	Family Supreme - ANC	1	18	1
1521	2	GB	Garlic Bread	1	2	1
1522	1	CHF	Chicken Fillets	1	14	1
1522	2	GB	Garlic Bread	1	2	1
1522	3	DIS	Discount	1	-1.6	1
1523	1	2L	2 Large Pizzas	1	19.9	1
1523	2	LSE	Large Seafood	0	0	1
1523	3	HALF	1/2 NO ANCH	1	0	1
1523	4	LCH	Large Chicken Hawiian	0	0	1
1523	5	GB	Garlic Bread	1	2	1
1524	1	PFM	FAMILY PICK-UP	1	12.9	1
1524	2	FMA	Family Margherita	0	0	1
1524	3	FX	EXTRA chicken and egg	2	2	1
1525	1	FSU	Family Supreme	1	18	1
1525	2	NO	No seafood	0	0	1
1526	1	2F	2 Family Pizzas	1	25.9	1
1526	2	FVG	Family Vegetarian	0	0	1
1526	3	FVG	Family Vegetarian	0	0	1
1527	1	SSG	Small SanGiorgio NO OLIVES	1	9.5	1
1527	2	SX	EXTRA MUSH	1	0.5	1
1527	3	GB	Garlic Bread	1	2	1
1528	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1528	2	LMX	Large Mexican	0	0	1
1528	3	LX	EXTRA MUSH	1	0.7	1
1529	1	MFAP	Fettucini Alla Panna	1	10	1
1530	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1530	2	LSU	Large Supreme	0	0	1
1530	3	NO	No ANCH OR OLIVES	1	0	1
1531	1	2L	2 Large Pizzas	1	19.9	1
1531	2	LHW	Large Hawiian	0	0	1
1531	3	LSG	Large SanGiorgio	0	0	1
1531	4	LX	EXTRA ANCH	1	0.7	1
1531	5	GB	Garlic Bread	2	4	1
1531	6	COKE	1.25 Ltr Coke	1	3	1
1531	7	MTPU	Tortellini Putanesca	1	9.5	1
1531	8	+	+PARMESAN CHEESE	0	0	1
1531	9	50	*****$50.00 NOTE*****	1	0	1
1532	1	MFBO	Fettucini Bolognese	1	9.5	1
1532	2	MSNA	Spaghetti Napolitana	1	9	1
1532	3	GB	Garlic Bread	1	2	1
1533	1	CR	Calzone RusticoPLUS CHILLI	1	10.5	1
1533	2	CV	Calzone Vegetarian	1	10.5	1
1534	1	STVP	Veal Parmigiana	1	14	1
1534	2	GB	Garlic Bread	1	2	1
1534	3	COKE	1.25 Ltr Coke	1	3	1
1535	1	CR	Calzone Rustico	1	10.5	1
1535	2	NO	No OLIVES	1	0	1
1535	3	MTAP	Tortellini Alla Panna	1	10	1
1536	1	STSH	Schnitzel	1	10.5	1
1537	1	MRBO	Ravioli Bolognese	1	9.5	1
1537	2	SSU	Small Supreme	1	9.5	1
1537	3	COKE	1.25 Ltr Coke	1	3	1
1537	4	GB	Garlic Bread	1	2	1
1537	5	MENU	MENU MENU	0	0	1
1538	1	PFM	FAMILY PICK-UP	1	12.9	1
1538	2	FSP	Family Special	0	0	1
1538	3	FX	EXTRA CHEESE	1	1	1
1538	4	WD	WELL DONE WELL DONE	0	0	1
1538	5	FX	EXTRA ANCHOVIES	1	1	1
1539	1	CHF	Chicken Fillets	1	14	1
1539	2	CHMS	Mushroom Sauce	1	2	1
1540	1	F	FAM	1	18	1
1540	2	HALF	1/2 PINE MUSH CAP OLIVES ONION OREGANO	1	0	1
1540	3	HALF	1/2 THE SAME PLUS HAM SALAMI	1	0	1
1541	1	2S	2 Small Pizzas	1	16.9	1
1541	2	SCH	Small Chicken Hawiian	0	0	1
1541	3	SMA	Small Margherita	0	0	1
1542	1	CR	Calzone Rustico	1	10.5	1
1542	2	NO	No OLIVES	1	0	1
1542	3	COKE	1.25 Ltr Coke	1	3	1
1542	4	CIGS	Cigarettes BH EXTRA MILD	1	7.4	1
1543	1	CHAV	Chicken Avocado	1	14	1
1543	2	PC	Prawn Cocktail	1	8	1
1543	3	DTA	Tartufo	2	7	1
1544	1	ERNA	Entree Ravioli Napoletana	1	7	1
1544	2	GS	Greek Salad EXTRA FETTA	1	5.5	1
1544	3	GB	Garlic Bread	1	2	1
1544	4	+	+ FETTA	1	1	1
1544	5	CDIET	CAN OF DIET COKE	1	1.7	1
1545	1	LML	Large Meat Lovers	1	13	1
1545	2	LX	EXTRA PINE	1	0.7	1
1546	1	STSH	Schnitzel	1	10.5	1
1546	2	DIANE	DIANNE SAUCE	1	2.8	1
1546	3	CHIPS	Chips	1	3.5	1
1546	4	CUT	*******CUTLERY**************	1	0	1
1547	1	MMPU	Macaroni Putanesca -ANCH-CAPPERS-OLIVES	1	9.5	1
1547	2	DGE	Gelati Cup VANILLA	1	4	1
1547	3	COKE	1.25 Ltr Coke	1	3	1
1548	1	PSM	SMALL PICK-UP	1	6.9	1
1548	2	SCH	Small Chicken Hawiian	0	0	1
1548	3	SX	EXTRA CHICKEN	1	0.5	1
1549	1	2L	2 Large Pizzas	1	19.9	1
1549	2	LVG	Large Vegetarian	0	0	1
1549	3	LX	EXTRA SUNDRIED TOM AND ART	2	1.4	1
1549	4	LSE	Large Seafood NO ANCH  EXTRA PRAWNS	0	0	1
1550	1	LMA	Large Margherita	1	11.5	1
1550	2	LX	EXTRA OLIVES AND PEP	2	1.4	1
1550	3	HB	Herb Bread	1	2	1
1551	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1551	2	SVG	Small Vegetarian NO OLIVES BUT EXTRA PINE	0	0	1
1551	3	50	*****$50.00 NOTE*****	1	0	1
1552	1	MCNA	Ricotta Ravioli Napolitana	1	9	1
1552	2	ECNA	Entree Ricotta Ravioli Napoletana	1	7	1
1552	3	+	+CAPSICUM IN ENTREE ONLY	1	0.5	1
1553	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1553	2	LSG	Large SanGiorgio	0	0	1
1554	1	F	FAM	1	18	1
1554	2	HALF	1/2 PEPP + HAM	1	0	1
1554	3	SUP	1/2 SUPREME - C/FOOD	1	0	1
1554	4	COKE	1.25 Ltr Coke	2	6	1
1555	1	2L	2 Large Pizzas	1	19.9	1
1555	2	LSU	Large Supreme -ANCH +CHILLI	0	0	1
1555	3	LSU	Large Supreme	0	0	1
1555	4	COKE	1.25 Ltr Coke	1	3	1
1556	1	ONH	1/2 Dozen Oysters Natural	1	8.5	1
1556	2	SD	Soup of the Day	1	4.5	1
1556	3	MGP	Main Garlic Prawns	1	16.5	1
1557	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1557	2	LSU	Large Supreme	0	0	1
1557	3	NO	No ANCH	1	0	1
1558	1	MLA	Main Lasagna	1	9.5	1
1558	2	FS	French Salad	1	4	1
1558	3	GB	Garlic Bread	2	4	1
1558	4	+	+ STRAWBERRY CHEESE CAKE	0.4	4.5	1
1559	1	SSU	Small Supreme	1	9.5	1
1559	2	GB	Garlic Bread	1	2	1
1560	1	L	LARGE HAM,MUSH,PEPP,SALAMI,1/2ANCH,PRAWNS	1	13.5	1
1560	2	LX	EXTRA CHICKEN,PEPP CHILLI+GARLIC	2	1.4	1
1560	3	COKE	1.25 Ltr Coke	1	3	1
1560	4	DIS	Discount	1	0.100000000000001	1
1561	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1561	2	HALF	1/2 MEAT.L. + PEPPERONI	0.7	0	1
1561	3	SPE	1/2 SPECIAL  + PINE	1	0	1
1561	4	LX	EXTRA	2	1.4	1
1562	1	MLA	Main Lasagna	1	9.5	1
1562	2	SML	Small Meat Lovers	1	9.5	1
1562	3	DAPC	Apple Pie with Cream	2	7	1
1563	1	PFM	FAMILY PICK-UP	1	12.9	1
1563	2	HALF	1/2 FR.TOM,SALAMI,TOUCH CHILLI	1	0	1
1563	3	HALF	1/2 MEAT.L.	1	0	1
1563	4	BBQ	BBQ Sauce	1	1	1
1563	5	GB	Garlic Bread	1	2	1
1565	1	FSU	Family Supreme	0	0	1
1565	2	F	FAM HAM,PEPP,PINE,MUSH	0	0	1
1565	3	DIS	Discount	1	20	1
1566	1	FSU	Family Supreme	1	18	1
1566	2	FX	EXTRA FR.TOM + HERBS	1	1	1
1567	1	PLG	LARGE PICK-UP	1	9.9	1
1567	2	LHW	Large Hawiian WITH EXTRA CAP, MUSH	0	0	1
1568	1	MFP	Main Fried Prawns	1	16	1
1568	2	MSMA	Spaghetti Marinara	1	11.5	1
1569	1	2L	2 Large Pizzas	1	19.9	1
1569	2	L	LARGE PEP CHEESE	0	0	1
1569	3	LSU	Large Supreme	0	0	1
1569	4	NO	No ANCH	1	0	1
1569	5	COKE	1.25 Ltr Coke	1	3	1
1570	1	2F	2 Family Pizzas	1	25.9	1
1570	2	FVG	Family Vegetarian PLUS GARLIC CHILLI AND FRESH BASIL	0	0	1
1570	3	FX	EXTRA ROAST POTATO	1	1	1
1570	4	GB	Garlic Bread	2	4	1
1570	5	DCOKE	1.25 LTR DIET COKE	1	3	1
1571	1	L	LARGE SAL HAM OLIVES MUSH CAP FRESH TOMATO	0	0	1
1571	3	HALF	1/2 CHEESE HAM ONION	1	0	1
1571	4	HALF	1/2 FRESH TOM MUSH CAP PRAWNS HERBS OLIVES ONION	1	0	1
1571	5	NO	No OIL OR SALT ON PIZZA	1	0	1
1572	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1572	2	FML	Family Meat Lovers	0	0	1
1573	1	LSU	Large Supreme	1	13.5	1
1573	2	NO	No ONION CAP OR ANCH	1	0	1
1573	3	HALF	1/2 PLUS CHILLI	1	0	1
1574	1	PFM	FAMILY PICK-UP	1	12.9	1
1574	2	FSU	Family Supreme	0	0	1
1574	3	NO	No ONION SEAFOOD	1	0	1
1574	4	HALF	1/2 NO CAPSICUM	1	0	1
1574	5	+	+ MUSH SAL CHEESE	1	1	1
1575	1	SCP	Small Capriciosa	1	9	1
1575	2	CR	Calzone Rustico	1	10.5	1
1575	3	NO	No OLIVES EXTRA PARMESAN	1	0	1
1575	4	CR	Calzone Rustico	1	10.5	1
1575	5	CR	Calzone Rustico	1	10.5	1
1575	6	DCA	Cassata	1	3.5	1
1576	1	CHF	Chicken Fillets	1	14	1
1576	2	GB	Garlic Bread	1	2	1
1576	3	DGE	Gelati Cup CHOC	1	4	1
1576	4	CCOKE	Can of Coke	1	1.7	1
1577	1	F	FAM	1	18	1
1577	2	HAW	1/2 HAWAIIN	1	0	1
1577	3	VEG	1/2 VEGETARIAN	1	0	1
1577	4	GB	Garlic Bread	1	2	1
1577	5	CDIET	CAN OF DIET COKE	1	1.7	1
1577	6	CSQSH	Can of Lemon Squash	1	1.7	1
1578	1	F	FAM	1	18	1
1578	2	VEG	1/2 VEGETARIAN CHILLI	1	0	1
1578	3	HAW	1/2 HAWAIIN	1	0	1
1579	1	LVG	Large Vegetarian	1	12.5	1
1579	2	HALF	1/2 NO PINE NO PEP	1	0	1
1579	3	LX	EXTRA ANCH	1	0.7	1
1579	4	HALF	1/2 PINE AND PEP	1	0	1
1579	5	GB	Garlic Bread	1	2	1
1579	6	CSQSH	Can of Lemon Squash	2	3.4	1
1579	7	COKE	1.25 Ltr Coke	1	3	1
1580	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1580	2	MAR	1/2 MARGHERITA+SALAMI TOUCH CHILLI	1	0	1
1580	3	SUP	1/2 SUPREME	1	0	1
1580	4	LX	EXTRA	1	0.7	1
1581	1	EMAL	Entree Macaroni Alfredo	1	7	1
1581	2	EMBO	Entree Macaroni Bolognese	1	7	1
1581	3	GB	Garlic Bread	1	2	1
1581	4	CDIET	CAN OF DIET COKE	1	1.7	1
1582	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1582	2	SUP	1/2 SUPREME	1	0	1
1582	3	FX	EXTRA CHICKEN	1	1	1
1582	4	MEX	1/2 MEXICAM	1	0	1
1583	1	2F	2 Family Pizzas	1	25.9	1
1583	2	FSU	Family Supreme	0	0	1
1583	3	NO	No ANCH	0	0	1
1583	4	FMA	Family Margherita	0	0	1
1583	5	FSU	Family Supreme	1	18	1
1584	1	MCAL	Ricotta Ravioli Alfredo	1	9	1
1584	2	DCC	Cheese Cake	3	10.5	1
1585	1	PLG	LARGE PICK-UP	1	9.9	1
1585	2	HAW	1/2 HAWAIIN	1	0	1
1585	3	SUP	1/2 SUPREME	1	0	1
1586	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1586	2	FSU	Family Supreme	0	0	1
1586	3	NO	No olives and anchovies	1	0	1
1587	1	GB	Garlic Bread	1	2	1
1587	2	MRBO	Ravioli Bolognese	1	9.5	1
1587	3	DCM	Chocolate Mousse	1	3.5	1
1588	1	F	FAM	1	18	1
1588	2	SPE	1/2 SPECIAL	1	0	1
1588	3	SEA	1/2 SEAFOOD	1	0	1
1588	4	NO	No ANCH WITH PINE INSTEAD	1	0	1
1589	1	MRVG	Ravioli Vegetarian	1	9.5	1
1589	2	FS	French Salad	1	4	1
1590	1	MSMA	Spaghetti Marinara	1	11.5	1
1590	2	GB	Garlic Bread	1	2	1
1590	3	DCOKE	1.25 LTR DIET COKE	1	3	1
1591	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1591	2	LVG	Large VegetarianWITH FRESH BASIL	0	0	1
1592	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1592	2	LSU	Large Supreme	0	0	1
1592	3	EFCB	Entree Fettucini Carbonara	1	8	1
1592	4	100	****$100.00 NOTE*****	1	0	1
1593	1	2F	2 Family Pizzas	1	25.9	1
1593	2	FSG	Family SanGiorgio	0	0	1
1593	3	FAM	Family American	0	0	1
1593	4	COKE	1.25 Ltr Coke	2	6	1
1593	5	GB	Garlic Bread	1	2	1
1594	1	FVG	Family Vegetarian	1	17	1
1594	2	NO	No PINE	1	0	1
1594	3	HALF	1/2PLUS CHILLI	1	0	1
1595	1	LVG	Large Vegetarian -PINE+MILD CHILLI	1	12.5	1
1596	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1596	2	LVG	Large Vegetarian	0	0	1
1597	1	MTAP	Tortellini Alla Panna	2	20	1
1597	2	+	+ NAP SAUCE IN ALL OF THEM AS WELL	3	3	1
1597	3	GS	Greek Salad	1	5.5	1
1597	4	GB	Garlic Bread	1	2	1
1597	5	MMAP	Macaroni Alla Panna PLUS NAP SAUCE AS WELL	1	10	1
1598	1	2L	2 Large Pizzas	1	19.9	1
1598	2	LSG	Large SanGiorgio	0	0	1
1598	3	MAR	1/2 MARGHERITA WITH SALAMI	1	0	1
1598	4	SPE	1/2 SPECIAL	1	0	1
1598	5	GB	Garlic Bread	2	4	1
1599	1	LSU	Large Supreme	1	13.5	1
1599	2	NO	No PRAWNS	1	0	1
1599	3	COKE	1.25 Ltr Coke	1	3	1
1600	1	FAM	Family American	1	16.5	1
1600	2	FX	EXTRA MUSHROOMS	1	1	1
1600	3	ESPU	Entree Spaghetti Putanesca	1	7.5	1
1600	4	NO	No ANCH	1	0	1
1600	5	ESCB	Entree Spaghetti Carbonara	1	8	1
1600	6	EFAP	Entree Fettucini Alla Panna	1	8	1
1600	7	GB	Garlic Bread	1	2	1
1600	8	PA	Prawn Avocado	1	10	1
1601	1	CR	Calzone Rustico	1	10.5	1
1601	2	STVP	Veal Parmigiana	1	14	1
1601	3	COKE	1.25 Ltr Coke	1	3	1
1602	1	2L	2 Large Pizzas	1	19.9	1
1602	2	LSE	Large Seafood	0	0	1
1602	3	LSU	Large Supreme	0	0	1
1603	1	GB	Garlic Bread	1	2	1
1603	2	VEGIE	SERVE OF VEGETABLES	1	3.5	1
1603	3	STMS	Scaloppina Mushroom	1	11.5	1
1603	4	CHMS	Mushroom SauceIN SEPERATE CONTAINER	1	2	1
1604	1	CHIPS	Chips	1	3.5	1
1605	1	SCP	Small Capriciosa	0	0	1
1605	2	PSM	SMALL PICK-UP	1	6.9	1
1606	1	CHAV	Chicken Avocado	1	14	1
1606	2	GB	Garlic Bread	1	2	1
1607	1	LMX	Large Mexican - 0LIVES	1	13	1
1607	2	LX	EXTRA CHEESE,BARBECUE SAUCE	2	1.4	1
1607	3	DIS	Discount	1	0.6	1
1608	1	GB	Garlic Bread	1	2	1
1608	2	L	LARGE HAM,SALAMI,OLIVES,ANCH+CAPS	1	13.5	1
1609	1	L	LARGE	1	13.5	1
1609	2	MAR	1/2 MARGHERITA	1	0	1
1609	3	VEG	1/2 VEGETARIAN NO OLIVES	1	0	1
1609	4	GB	Garlic Bread	1	2	1
1610	1	FSU	Family Supreme -ANCH	1	18	1
1610	2	FX	EXTRA CHICKEN	1	1	1
1610	3	GB	Garlic Bread	1	2	1
1611	1	2L	2 Large Pizzas	1	19.9	1
1611	2	LCH	Large Chicken Hawiian -PINE	0	0	1
1611	3	LSP	Large Special 1/2 + CHILLI	0	0	1
1612	1	CR	Calzone Rustico -OLIVES	1	10.5	1
1612	2	SX	EXTRA ONIONS,PRAWNS,PEPP	2	1	1
1612	3	ELA	Entree Lasagna	1	7.5	1
1612	4	GB	Garlic Bread	1	2	1
1613	1	PLG	LARGE PICK-UP	1	9.9	1
1613	2	LSP	Large Special	0	0	1
1613	3	CHIPS	Chips	2	7	1
1614	1	SVG	Small Vegetarian	1	9	1
1614	2	ECPU	Entree Ricotta Ravioli Putanesca	1	7.5	1
1615	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1615	2	LVG	Large Vegetarian	0	0	1
1615	3	50	*****$50.00 NOTE*****	1	0	1
1616	1	2L	2 Large Pizzas	1	19.9	1
1616	2	L	LARGE PINE MUSH	0	0	1
1616	3	LSU	Large Supreme	0	0	1
1616	4	NO	No ANCH	1	0	1
1616	5	GB	Garlic Bread	1	2	1
1616	6	COKE	1.25 Ltr Coke	1	3	1
1617	1	PFM	FAMILY PICK-UP	1	12.9	1
1617	2	FSG	Family SanGiorgio -OLIVES	0	0	1
1617	3	FX	EXTRA MUSHROOM	1	1	1
1618	1	CR	Calzone Rustico	1	10.5	1
1618	2	NO	No OLIVES	1	0	1
1619	1	PLG	LARGE PICK-UP	1	9.9	1
1619	2	LSP	Large Special	0	0	1
1619	3	LX	EXTRA ANCH ANDONION	2	1.4	1
1620	1	2F	2 Family Pizzas	1	25.9	1
1620	2	FSU	Family Supreme	0	0	1
1620	3	NO	No ANCH OR OLIVES	1	0	1
1620	4	FHW	Family Hawiian	0	0	1
1620	5	GB	Garlic Bread	2	4	1
1621	1	SHW	Small Hawiian	1	9	1
1621	2	GB	Garlic Bread	1	2	1
1622	1	LAU	Large Australian	1	12	1
1622	2	LX	EXTRA BACON EGG AND EXTRA CHEESE	3	2.1	1
1622	3	COKE	1.25 Ltr Coke	1	3	1
1623	1	PC	Prawn Cocktail	1	8	1
1623	2	PA	Prawn Avocado	1	10	1
1623	3	CHCS	Chef's Salad	2	26	1
1623	4	CHIPS	Chips	1	3.5	1
1624	1	CHF	Chicken Fillets	1	14	1
1624	2	GB	Garlic Bread	1	2	1
1624	3	DGE	Gelati Cup choc	1	4	1
1624	4	CCOKE	Can of Coke	1	1.7	1
1624	5	DEL	ONE DOLLAR DELIVERY	0	0	1
1625	1	PLG	LARGE PICK-UP	1	9.9	1
1625	2	AME	1/2 AMERICAN	1	0	1
1625	3	HAW	1/2 HAWAIIN plus cap	1	0	1
1625	4	MFPU	Fettucini Putanesca	1	9.5	1
1625	5	DIS	Discount	1	-6.4	1
1626	1	PLG	LARGE PICK-UP	1	9.9	1
1626	2	LSU	Large Supreme no anch or olives	0	0	1
1627	1	MTAP	Tortellini Alla Panna	1	10	1
1628	1	LVG	Large Vegetarian -PINE	1	12.5	1
1628	2	LX	EXTRA ANCH,GARLIC+HERBS	1	0.7	1
1628	3	GB	Garlic Bread	1	2	1
1629	1	ELA	Entree Lasagna	1	7.5	1
1629	2	EMBO	Entree Macaroni Bolognese	1	7	1
1629	3	DIS	Discount	1	-6.5	1
1630	1	LML	Large Meat Lovers	1	13	1
1630	2	LX	EXTRA MUSHROOMS	1	0.7	1
1630	3	GB	Garlic Bread	1	2	1
1631	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1631	2	AME	1/2 AMERICAN	1	0	1
1631	3	VEG	1/2 VEGETARIAN	1	0	1
1631	4	DCOKE	1.25 LTR DIET COKE	1	3	1
1632	1	STPWD	Pepper Steak - Well Done	1	15	1
1632	2	CHIPS	Chips	0	0	1
1632	3	CIGS	Cigarettes PETER J. X MILD	1	7.8	1
1633	1	STSB	Scaloppina Bianco	1	9.45	1
1633	2	MINE	Minestrone Soup	1	4.05	1
1634	1	F	FAM	1	18	1
1634	2	SAN	1/2 SAN GIORGIO	1	0	1
1634	3	HAW	1/2 HAWAIIN	1	0	1
1634	4	FX	EXTRA FRESH.TOM	1	1	1
1635	1	LMA	Large Margherita HALF	1	11.5	1
1635	2	HALF	1/2 SPECIAL NO CAP	1	0	1
1635	3	DIS	Discount	1	1	1
1636	1	2F	2 Family Pizzas	1	25.9	1
1636	2	FSG	Family SanGiorgio	0	0	1
1636	3	HALF	1/2 CHICK HAW	1	0	1
1636	4	HALF	1/2 HAW	1	0	1
1637	1	STMS	Scaloppina Mushroom	1	11.5	1
1637	2	GB	Garlic Bread	1	2	1
1637	3	50	*****$50.00 NOTE*****	1	0	1
1638	1	L	LARGE	1	13.5	1
1638	2	HALF	1/2 SAN G	1	0	1
1638	3	HALF	1/2 MARG + SALAMI	1	0	1
1638	4	COKE	1.25 Ltr Coke	1	3	1
1639	1	PFM	FAMILY PICK-UP	2	25.8	1
1639	2	VEG	1/2 VEGETARIAN	1	0	1
1639	3	HAW	1/2 HAWAIIN	1	0	1
1639	4	MLO	1/2 MEAT LOVERS	1	0	1
1639	5	SEA	1/2 SEAFOOD	1	0	1
1640	1	L	LARGE	1	13.5	1
1640	2	SPE	1/2 SPECIAL	1	0	1
1640	3	LX	EXTRA FETTA CHEESE	1	0.7	1
1640	4	VEG	1/2 VEGETARIAN - CHEESE	1	0	1
1640	5	GB	Garlic Bread	1	2	1
1641	1	ETAP	Entree Tortelline Alla Panna	1	8	1
1641	2	GB	Garlic Bread	1	2	1
1641	3	F	FAM	1	18	1
1641	4	HALF	1/2 MEXICAN	1	0	1
1641	5	HALF	1/2 CHICK HAW	1	0	1
1642	1	STR	Rump Steak MED	1	13	1
1642	2	CHMS	Mushroom Sauce	1	2	1
1642	3	MINE	Minestrone Soup	1	4.5	1
1642	4	MSBO	Spaghetti Bolognese	1	9.5	1
1642	5	SSG	Small SanGiorgio	1	9.5	1
1642	6	COKE	1.25 Ltr Coke	1	3	1
1642	7	CIGS	Cigarettes DUNHILL RED	1	6.6	1
1643	1	F	FAM	1	18	1
1643	2	HALF	1/2 SAN G	1	0	1
1643	3	HALF	1/2 SPECIAL	1	0	1
1643	4	GB	Garlic Bread	1	2	1
1644	1	2L	2 Large Pizzas	1	19.9	1
1644	2	LSU	Large Supreme	0	0	1
1644	3	LSU	Large Supreme	0	0	1
1645	1	FVG	Family Vegetarian	1	17	1
1645	2	FX	EXTRA pepp	1	1	1
1646	1	2F	2 Family Pizzas	1	25.9	1
1646	2	2F	2 Family Pizzas	1	25.9	1
1646	3	FSU	Family Supreme	0	0	1
1646	4	FSU	Family Supreme	0	0	1
1646	5	FSU	Family Supreme	0	0	1
1646	6	FVG	Family Vegetarian	0	0	1
1647	1	GB	Garlic Bread	1	2	1
1647	2	LCH	Large Chicken Hawiian	1	13	1
1648	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1648	2	SUP	1/2 SUPREME	1	0	1
1648	3	NO	NO ANCH OLIVES	1	0	1
1648	4	MLO	1/2 MEAT LOVERS	1	0	1
1649	1	2L	2 Large Pizzas	1	19.9	1
1649	2	LML	Large Meat Lovers	0	0	1
1649	3	LX	EXTRA PINE	1	0.7	1
1649	4	LSP	Large Special	0	0	1
1649	5	MRNA	Ravioli Napolitana	1	9	1
1649	6	COKE	1.25 Ltr Coke	1	3	1
1650	1	2L	2 Large Pizzas	1	19.9	1
1650	2	LAM	Large American	0	0	1
1650	3	LX	EXTRA MUSH	1	0.7	1
1650	4	LSP	Large Special	0	0	1
1650	5	NO	No OLIVES	1	0	1
1650	6	LX	EXTRA PRAWNS	1	0.7	1
1650	7	LX	EXTRA PINE	1	0.7	1
1651	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1651	2	LSU	Large Supreme	0	0	1
1652	1	MFAL	Fettucini Alfredo	1	8.1	1
1652	2	GB	Garlic Bread	1	1.8	1
1652	3	CCOKE	Can of Coke	1	1.7	1
1653	1	L	LARGE PEPP,CAPS,OLIVES,ANCH	1	13.5	1
1653	2	LX	EXTRA TOUCH CHILLI,GARLIC,HERBS,LITTLE CHEESE	0	0	1
1653	3	CCOKE	Can of Coke	1	1.7	1
1654	1	GB	Garlic Bread	1	2	1
1654	2	FAM	Family American	1	16.5	1
1654	3	FX	EXTRA MUSHROOMS	1	1	1
1655	1	2S	2 Small Pizzas	1	16.9	1
1655	2	SCH	Small Chicken Hawiian	0	0	1
1655	3	SSE	Small Seafood	0	0	1
1656	1	FSU	Family Supreme	1	18	1
1656	2	NO	No PIN	1	0	1
1657	1	MRBO	Ravioli Bolognese	1	9.5	1
1657	2	FX	EXTRA PEPPERONI AND GARLIC	1	1	1
1657	3	GS	Greek Salad	1	5.5	1
1657	4	GB	Garlic Bread	1	2	1
1657	5	COKE	1.25 Ltr Coke	1	3	1
1658	1	2F	2 Family Pizzas	1	25.9	1
1658	2	FSU	Family Supreme	0	0	1
1658	3	FSP	Family Special	0	0	1
1659	1	STPMW	Pepper Steak - Md Well Done	1	15	1
1659	2	GB	Garlic Bread	1	2	1
1660	1	FHW	Family Hawiian	1	16.5	1
1660	2	HALF	1/2 NO PINE	1	0	1
1660	3	FX	EXTRA SALAMI	1	1	1
1660	4	FX	EXTRA CHICK	1	1	1
1660	5	GB	Garlic Bread	1	2	1
1662	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1662	2	LSU	Large Supreme NO ANCH	0	0	1
1663	1	MMNA	Macaroni Napolitana	1	8.1	1
1663	2	CBR	Continental Bread (3 peices)	1	0.54	1
1663	3	GB	Garlic Bread	1	1.8	1
1663	4	DIS	Discount	1	0.0599999999999987	1
1664	1	LSU	Large Supreme	1	13.5	1
1664	2	NO	NoONION CAP ANCH PIN	1	0	1
1664	3	+	+ CHILI	1	1	1
1664	4	COKE	1.25 Ltr Coke	1	3	1
1665	1	2F	2 Family Pizzas	1	25.9	1
1665	2	FHW	Family Hawiian	0	0	1
1665	3	FSU	Family Supreme	0	0	1
1665	4	NO	No ANCH	1	0	1
1665	5	COKE	1.25 Ltr Coke	2	6	1
1666	1	2L	2 Large Pizzas	1	19.9	1
1666	2	LSG	Large SanGiorgio	0	0	1
1666	3	LSG	Large SanGiorgio	0	0	1
1666	4	LX	EXTRA ANCH	1	0.7	1
1666	5	COKE	1.25 Ltr Coke	2	6	1
1667	1	L	LARGE	1	13.5	1
1667	2	+	+ pepp olives mush anch pine	0	0	1
1668	1	F	FAM	1	18	1
1668	2	HALF	1/2 AMERICAN + MUSH	1	0	1
1668	3	HALF	1/2 MARGERITA + SAL CHILI	1	0	1
1669	1	L	LARGE	1	13.5	1
1669	2	HALF	1/2 CHICK HAW X GARLIC	1	0	1
1669	3	HALF	1/2 SUPREME	1	0	1
1669	4	CCOKE	Can of Coke	2	3.4	1
1670	1	FMA	Family Margherita	1	15	1
1670	2	FX	EXTRA F/TOM PEPPERONI	2	2	1
1670	3	+	+ BASIL	0	0	1
1670	4	COKE	1.25 Ltr Coke	2	6	1
1671	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1671	2	HALF	1/2 MEAT LOVERS	1	0	1
1671	3	HALF	1/2 LOT NO ANCH MUSH ONION	1	0	1
1671	4	LX	EXTRA CHEESE	1	0.7	1
1672	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1672	2	FSU	Family Supreme	0	0	1
1672	3	FX	EXTRA CHEESE + CHILI	1	1	1
1672	4	50	*****$50.00 NOTE*****	1	0	1
1673	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1673	2	SUP	1/2 SUPREME	1	0	1
1673	3	HAW	1/2 HAWAIIN	1	0	1
1673	4	+	+ CHILI ALL OVER	0	0	1
1674	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1674	2	HAW	1/2 HAWAIIN	1	0	1
1674	3	MAR	1/2 MARGHERITA + GARLIC	1	0	1
1674	4	DCOKE	1.25 LTR DIET COKE	0	0	1
1675	1	PFM	FAMILY PICK-UP	1	12.9	1
1675	2	VEG	1/2 VEGETARIAN NO PIN	1	0	1
1675	3	FX	EXTRA CHICKEN	1	1	1
1675	4	SEA	1/2 SEAFOOD	1	0	1
1675	5	+	+ GARLIC ALL OVER +	0	0	1
1675	6	FX	EXTRA OLIVES ALL OVER	1	1	1
1675	7	+	+ HOT CHILLI ALL OVER	0	0	1
1676	1	CV	Calzone Vegetarian	1	10.5	1
1676	2	+	+ BOLOGNAISE SAUSE + CHILI	1	1	1
1676	3	MCBO	Ricotta Ravioli Bolognese + CHILI	1	9.5	1
1677	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1677	2	DCOKE	1.25 LTR DIET COKE	0	0	1
1677	3	VEG	1/2 VEGETARIAN	1	0	1
1677	4	SUP	1/2 SUPREME NO ANCH	1	0	1
1678	1	CHF	Chicken Fillets	1	14	1
1678	2	GB	Garlic Bread	1	2	1
1678	3	CCOKE	Can of Coke	1	1.7	1
1679	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1679	2	LVG	Large Vegetarian	0	0	1
1680	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1680	2	SUP	1/2 SUPREME	1	0	1
1680	3	HALF	1/2 meat lovers	1	0	1
1680	4	CIGS	Cigarettes peter styvesant	1	6.6	1
1681	1	2F	2 Family Pizzas	1	25.9	1
1681	2	FSU	Family Supreme	0	0	1
1681	3	F	FAM	0	0	1
1681	4	HALF	1/2 CHICK HAW	1	0	1
1681	5	VEG	1/2 VEGETARIAN	1	0	1
1681	6	GB	Garlic Bread	2	4	1
1682	1	PSM	SMALL PICK-UP SUPREME	1	6.9	1
1682	2	GB	Garlic Bread	1	2	1
1683	1	F	FAM	9	162	1
1683	2	DIS	Discount	1	-49.5	1
1684	1	MFC	Main Fried Calamari EX SALAD	1	13.5	1
1684	2	DGE	Gelati Cup CHOC,LEMON	1	4	1
1685	1	VEGIE	SERVE OF VEGETABLES	1	3.5	1
1685	2	+	+ ALFREDO SAUCE	1	2.8	1
1685	3	COKE	1.25 Ltr Coke	1	3	1
1685	4	CHAV	Chicken Avocado	1	14	1
1685	5	CCOKE	Can of Coke	1	1.7	1
1685	6	SD	Soup of the Day	1	4.5	1
1685	7	CUT	*******CUTLERY**************	1	0	1
1686	1	GB	Garlic Bread	1	2	1
1686	2	LAU	Large Australian	1	12	1
1686	3	COKE	1.25 Ltr Coke	1	3	1
1687	1	2L	2 Large Pizzas	1	19.9	1
1687	2	SPE	1/2 SPECIAL	1	0	1
1687	3	HAW	1/2 HAWAIIN	1	0	1
1687	4	LSG	Large SanGiorgio	0	0	1
1687	5	CIGS	Cigarettes ESCORT ULTRA	1	8.4	1
1687	6	COKE	1.25 Ltr Coke	1	3	1
1688	1	PLG	LARGE PICK-UP	1	9.9	1
1688	2	L	LARGE CHICKEN+CHEESE	0	0	1
1689	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1689	2	FSG	Family SanGiorgio	0	0	1
1689	3	NO	No ONION	1	0	1
1689	4	FX	EXTRA CHICK	1	1	1
1689	5	FX	EXTRA SALAMI	1	1	1
1690	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1690	2	LSU	Large Supreme	0	0	1
1690	3	NO	No PINE ANCH	1	0	1
1691	1	PLG	LARGE PICK-UP	1	9.9	1
1691	2	HAW	1/2 HAWAIIN	1	0	1
1691	3	SUP	1/2 SUPREME -PINE-OLIVES	1	0	1
1692	1	2L	2 Large Pizzas	1	19.9	1
1692	2	LSU	Large Supreme	0	0	1
1692	3	LML	Large Meat Lovers	0	0	1
1692	4	LX	EXTRA OLIVES	1	0.7	1
1692	5	GB	Garlic Bread	1	2	1
1692	6	COKE	1.25 Ltr Coke	1	3	1
1693	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1693	2	FSU	Family Supreme	0	0	1
1694	1	LSU	Large Supreme + LITTLE CHILLI	1	13.5	1
1695	1	FSU	Family Supreme -C/FOOD-OLIVES 1/2+MUSH	1	18	1
1695	2	GB	Garlic Bread	1	2	1
1696	1	MINE	Minestrone Soup	1	4.05	1
1696	2	STVP	Veal Parmigiana	1	12.6	1
1696	3	NO	No VEAL	1	0	1
1696	4	+	+ CHICKEN	1	0.9	1
1696	5	GB	Garlic Bread	1	1.8	1
1696	6	HB	Herb Bread	1	1.8	1
1697	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1697	2	AME	1/2 AMERICAN	1	0	1
1697	3	SPE	1/2 SPECIAL	1	0	1
1697	4	FX	EXTRA CHEESE	1	1	1
1698	1	PFM	FAMILY PICK-UP	1	12.9	1
1698	2	FSG	Family SanGiorgio	0	0	1
1699	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1699	2	VEG	1/2 VEGETARIAN	1	0	1
1699	3	SUP	1/2 SUPREME -C/FOOD-HAM	1	0	1
1700	1	CHGR	Grilled Chicken	1	13	1
1700	2	CHIPS	Chips	1	3.5	1
1700	3	DIANE	DIANNE SAUCE	1	2.8	1
1700	4	CUT	*******CUTLERY**************	1	0	1
1701	1	STVP	Veal Parmigiana	1	14	1
1701	2	DGE	Gelati Cup VANILLA	1	4	1
1702	1	2F	2 Family Pizzas	1	25.9	1
1702	2	FVG	Family Vegetarian	0	0	1
1702	3	FX	EXTRA SUNDRY TOM,ARTICHOKES,+PRAWNS	3	3	1
1702	4	FSE	Family Seafood - ANCH	0	0	1
1703	1	STVP	Veal Parmigiana	1	12.6	1
1703	2	NO	No VEAL CHICKEN INSTEAD	1	0	1
1703	3	ELA	Entree Lasagna XXX CHEESE	1	6.75	1
1703	4	+	+ CHEESE	2	1.8	1
1703	5	PC	Prawn Cocktail	1	7.2	1
1703	6	COKE	1.25 Ltr Coke	1	3	1
1704	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1704	2	HAW	1/2 HAWAIIN	1	0	1
1704	3	LX	EXTRA ANCH+FR.TOM	2	1.4	1
1704	4	MEX	1/2 MEXICAM	1	0	1
1705	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1705	2	CAP	1/2 CAPRICIOSA	1	0	1
1705	3	VEG	1/2 VEGETARIAN	1	0	1
1705	4	FX	EXTRA FR.TOM ALL OVER	1	1	1
1705	5	CIGS	Cigarettes MARL LIGHT	1	6.4	1
1706	1	STDWD	Steak Dianne - Well Done	1	15	1
1706	2	COKE	1.25 Ltr Coke	1	3	1
1707	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1707	2	LSU	Large Supreme -PINE-ANCH-PRAWNS	0	0	1
1708	1	SSG	Small SanGiorgio	1	8.55	1
1708	2	EFC	Entree Fried Calamari	1	7.65	1
1708	3	SD	Soup of the Day	1	4.05	1
1708	4	CBR	Continental Bread (3 peices)	1	0.54	1
1708	5	GB	Garlic Bread	1	1.8	1
1708	6	DGE	Gelati Cup BACI+CREAM	1	3.6	1
1709	1	MCNA	Ricotta Ravioli Napolitana	1	9	1
1709	2	CBR	Continental Bread (3 peices)	1	0.6	1
1709	3	DIS	Discount	1	0.4	1
1710	1	STF	Fillet Mignon	1	15.3	1
1711	1	FVG	Family Vegetarian	1	17	1
1711	2	MAR	1/2 MARGHERITA	1	0	1
1711	3	50	*****$50.00 NOTE*****	1	0	1
1712	1	F	FAM	1	18	1
1712	2	--	HAM SAL MUS OLIVE	0	0	1
1713	1	2L	2 Large Pizzas	1	19.9	1
1713	2	LSU	Large Supreme - ANC	0	0	1
1713	3	LHW	Large Hawiian + MUS	0	0	1
1713	4	ELA	Entree Lasagna	1	7.5	1
1714	1	2L	2 Large Pizzas	1	19.9	1
1714	2	LML	Large Meat Lovers	0	0	1
1714	3	LHW	Large Hawiian	0	0	1
1714	4	COKE	1.25 Ltr Coke	1	3	1
1714	5	GB	Garlic Bread	1	2	1
1715	1	SSU	Small Supreme	1	9.5	1
1715	2	SX	EXTRA 1/2 ANCH	1	0.5	1
1715	3	ESAP	Entree Spaghetti Alla Panna	1	8	1
1715	4	CCOKE	Can of Coke	2	3.4	1
1715	5	EGP	Entree Garlic Prawns	1	10.5	1
1716	1	MSMA	Spaghetti Marinara	2	23	1
1716	2	GB	Garlic Bread	1	2	1
1716	3	FS	French Salad	1	4	1
1717	1	FSU	Family Supreme - ANC	1	18	1
1717	2	F	FAM	1	18	1
1717	3	MLO	1/2 MEAT LOVERS	1	0	1
1717	4	SAN	1/2 SAN GIORGIO	1	0	1
1717	5	DIS	Discount	1	-16	1
1718	1	LSU	Large Supreme	1	13.5	1
1718	2	HALF	1/2 - OLIVE	1	0	1
1718	3	+	+ 1 EGG	1	1	1
1718	4	COKE	1.25 Ltr Coke	1	3	1
1718	5	GB	Garlic Bread	1	2	1
1719	1	MSMA	Spaghetti Marinara	2	23	1
1719	2	DCC	Cheese Cake	1	3.5	1
1719	3	PC	Prawn Cocktail	1	8	1
1720	1	FMA	Family Margherita	1	15	1
1720	2	FX	EXTRA PEPP OL FR TOM ANC	4	4	1
1720	3	--	+ BASIL	0	0	1
1721	1	STF	Fillet Mignon ( MED )	1	17	1
1721	2	CHF	Chicken Fillets	1	14	1
1721	3	DCOKE	1.25 LTR DIET COKE	1	3	1
1722	1	FSU	Family Supreme - ANC	1	18	1
1722	2	FX	EXTRA CHEESE	1	1	1
1722	3	COKE	1.25 Ltr Coke	1	3	1
1723	1	LSE	Large Seafood	1	13.5	1
1723	2	HALF	1/2 PIN	1	0	1
1723	3	GB	Garlic Bread	1	2	1
1723	4	COKE	1.25 Ltr Coke	1	3	1
1724	1	STSB	Scaloppina Bianco	1	10.5	1
1724	2	SHW	Small Hawiian	1	9	1
1725	1	CHF	Chicken Fillets	1	14	1
1725	2	GB	Garlic Bread	1	2	1
1725	3	CFANTA	Can of Fanta	1	1.7	1
1726	1	2L	2 Large Pizzas	1	19.9	1
1726	2	LSP	Large Special	0	0	1
1726	3	L	LARGE CHICK,BACON,CAPS+PINE	0	0	1
1726	4	LX	EXTRA BACON	1	0.7	1
1727	1	2F	2 Family Pizzas	1	25.9	1
1727	2	FSU	Family Supreme	0	0	1
1727	3	FX	EXTRA CHEESE+MILD CHILLI	1	1	1
1727	4	FSG	Family SanGiorgio	0	0	1
1727	5	FX	EXTRA barbecue sauce	1	1	1
1727	6	GB	Garlic Bread	2	4	1
1728	1	L	LARGE HAM,PINE,PEPP,ONION,CAPS	1	13.5	1
1728	2	GB	Garlic Bread	1	2	1
1728	3	CIGS	Cigarettes DUNHILL BLUE	1	7.4	1
1728	4	CCOKE	Can of Coke	1	1.7	1
1729	1	LSU	Large Supreme	1	13.5	1
1729	2	GB	Garlic Bread	1	2	1
1729	3	CIGS	Cigarettes ESCORT BLUE	1	8.4	1
1730	1	FSU	Family Supreme -C/FOOD	1	18	1
1730	2	FX	EXTRA OLIVES	1	1	1
1731	1	FSU	Family Supreme	1	18	1
1731	2	NO	No CAP	1	0	1
1731	3	HAW	1/2 HAWAIIN	1	0	1
1731	4	COKE	1.25 Ltr Coke	1	3	1
1732	1	S	SMALL HAM PEPP	1	9.5	1
1732	2	SX	EXTRA CHICKEN ON	2	1	1
1733	1	STP	Pepper Steak MED-RARE	1	15	1
1733	2	COKE	1.25 Ltr Coke	1	3	1
1734	1	2L	2 Large Pizzas	1	19.9	1
1734	2	LSU	Large Supreme -ANCH-OLIVES	0	0	1
1734	3	LSG	Large SanGiorgio	0	0	1
1734	4	GB	Garlic Bread	2	4	1
1735	1	L	LARGE	1	13.5	1
1735	2	VEG	1/2 VEGETARIAN -OLIVES	1	0	1
1735	3	HALF	1/2 CHICH,PEPP,ONION,PINE,HAM,SALAMI	1	0	1
1735	4	LX	EXTRA CHICK	1	0.7	1
1735	5	GB	Garlic Bread	1	2	1
1736	1	2L	2 Large Pizzas`	1	19.9	1
1736	2	LSU	Large Supreme	0	0	1
1736	3	LVG	Large Vegetarian	0	0	1
1737	1	2F	2 Family Pizzas	1	25.9	1
1737	2	FMX	Family Mexican	0	0	1
1737	3	FSG	Family SanGiorgio	0	0	1
1737	4	COKE	1.25 Ltr Coke	3	9	1
1738	1	SSG	Small SanGiorgio	1	9.5	1
1738	2	SX	EXTRA ANCH	1	0.5	1
1738	3	DCC	Cheese Cake STRAW	1	3.5	1
1739	1	2L	2 Large Pizzas	1	19.9	1
1739	2	LSP	Large Special	0	0	1
1739	3	LSG	Large SanGiorgio	0	0	1
1739	4	COKE	1.25 Ltr Coke	1	3	1
1739	5	GB	Garlic Bread	1	2	1
1740	1	2L	2 Large Pizzas	1	19.9	1
1740	2	LML	Large Meat Lovers	0	0	1
1740	3	LSG	Large SanGiorgio	0	0	1
1741	1	2L	2 Large Pizzas	1	19.9	1
1741	2	L	LARGE SAN G	0	0	1
1741	3	SAN	1/2 SAN GIORGIO + CHILI	1	0	1
1741	4	HALF	1/2 CHEESE AND PIN	1	0	1
1741	5	L	LARGE	1	13.5	1
1741	6	HALF	1/2 SAN GIOR	1	0	1
1741	7	LX	EXTRA OLIVES	1	0.7	1
1741	8	SPE	1/2 SPECIAL	1	0	1
1742	1	L	LARGE	1	13.5	1
1742	2	HALF	1/2 LOT	1	0	1
1742	3	HALF	1/2 MEAT	1	0	1
1742	4	GB	Garlic Bread	1	2	1
1743	1	PFM	FAMILY PICK-UP	0	0	1
1743	2	FSU	Family Supreme	2	36	1
1743	3	DIS	Discount	1	-16	1
1744	1	CHAV	Chicken Avocado	1	14	1
1744	2	ETPU	Entree Tortelline Putanesca NO ANCH	1	7.5	1
1744	3	FS	French Salad	1	4	1
1745	1	2L	2 Large Pizzas	1	19.9	1
1745	2	LMX	Large Mexican	0	0	1
1745	3	LHW	Large Hawiian	0	0	1
1745	4	GB	Garlic Bread	1	2	1
1746	1	STVP	Veal Parmigiana	1	14	1
1746	2	MFAP	Fettucini Alla Panna	1	10	1
1746	3	GB	Garlic Bread	1	2	1
1746	4	HB	Herb Bread	1	2	1
1747	2	SUP	1/2 SUPREME NO ANCH	1	0	1
1747	3	VEG	1/2 VEGETARIAN	1	0	1
1748	1	CHIPS	Chips	1	3.5	1
1748	2	EMAP	Entree Macaroni Alla Panna	1	8	1
1748	3	DCC	Cheese Cake	2	7	1
1748	4	CCOKE	Can of Coke	2	3.4	1
1749	1	2L	2 Large Pizzas	1	19.9	1
1749	2	LVG	Large Vegetarian NO PIN	0	0	1
1749	3	HALF	1/2 SEAFOOD NO ANCH	0	0	1
1749	4	HALF	1/2 VEG	0	0	1
1749	5	+	+ CHILI ON BOTH PIZZAS	0	0	1
1749	6	COKE	1.25 Ltr Coke	1	3	1
1750	1	2S	2 Small Pizzas	1	16.9	1
1750	2	SCP	Small Capriciosa	0	0	1
1750	3	SCH	Small Chicken Hawiian	0	0	1
1750	4	GB	Garlic Bread	1	2	1
1751	1	LHW	Large Hawiian	1	12.5	1
1751	2	LX	EXTRA PEPPERONI	1	0.7	1
1751	3	COKE	1.25 Ltr Coke	1	3	1
1752	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1752	2	HALF	1/2 HAW	1	0	1
1752	3	HALF	1/2 LOT NO ANCH	1	0	1
1753	1	FSU	Family Supreme	1	18	1
1753	2	GB	Garlic Bread	1	2	1
1754	1	LSU	Large Supreme NO ANCH	1	13.5	1
1754	2	+	+ CHILI	1	1	1
1754	3	GB	Garlic Bread	1	2	1
1755	1	2L	2 Large Pizzas	1	19.9	1
1755	2	LSU	Large Supreme	0	0	1
1755	3	HALF	1/2 seafood	1	0	1
1755	4	HALF	1/2 veg	1	0	1
1756	1	FSU	Family Supreme NO ANCH	1	18	1
1756	2	COKE	1.25 Ltr Coke	1	3	1
1757	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1757	2	LSU	Large Supreme -ANCH	0	0	1
1758	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1758	2	AME	1/2 AMERICAN	1	0	1
1758	3	SPE	1/2 SPECIAL	1	0	1
1758	4	LX	EXTRA PEPPERONI ALL OVER	1	0.7	1
1759	1	CHGR	Grilled Chicken	1	11.7	1
1759	2	ESNA	Entree Spaghetti Napoletana	1	6.3	1
1760	1	LHW	Large Hawiian	1	12.5	1
1760	2	LX	EXTRA CAP AND CHILI	1	0.7	1
1761	1	STD	Steak Dianne MR	1	15	1
1761	2	GB	Garlic Bread	1	2	1
1762	1	SVG	Small Vegetarian	1	9	1
1762	2	NO	No CAPSICUM	1	0	1
1762	3	GB	Garlic Bread	1	2	1
1763	1	SHW	Small Hawiian	1	8.1	1
1764	1	STSZ	Scaloppina Zingara	1	11.5	1
1764	2	LSG	Large SanGiorgio	1	13.5	1
1765	1	STVP	Veal Parmigiana	1	14	1
1765	2	GB	Garlic Bread	1	2	1
1765	3	EFAP	Entree Fettucini Alla Panna	1	8	1
1766	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1766	2	SEA	1/2 SEAFOOD	1	0	1
1766	3	VEG	1/2 VEGETARIAN	1	0	1
1766	4	LX	EXTRA ARTICHOKES, CHILLI	1	0.7	1
1767	1	CR	Calzone Rustico	1	10.5	1
1767	2	--	HAM HERB FRE TOM	0	0	1
1768	1	F	FAM	1	18	1
1768	2	SAN	1/2 SAN GIORGIO	1	0	1
1768	3	HAW	1/2 HAWAIIN	1	0	1
1768	4	GB	Garlic Bread	1	2	1
1769	1	2L	2 Large Pizzas	1	19.9	1
1769	2	LVG	Large Vegetarian	0	0	1
1769	3	HALF	1/2 NO PINE	1	0	1
1769	4	LX	EXTRA CHEESE	1	0.7	1
1769	5	LSG	Large SanGiorgio	0	0	1
1769	6	LX	EXTRA PEP	1	0.7	1
1769	7	LX	EXTRA CHEESE	1	0.7	1
1770	1	FSU	Family Supreme	1	18	1
1771	1	L	LARGE	1	13.5	1
1771	2	HALF	1/2 SAN G	1	0	1
1771	3	HALF	1/2 CHICK HAW	1	0	1
1772	1	MSNA	Spaghetti Napolitana	1	9	1
1772	2	L	LARGE	1	13.5	1
1772	3	+	+ PEPPERONI MUSH PIN LITTLE CHILI	1	1	1
1772	4	HB	Herb Bread	1	2	1
1772	5	COKE	1.25 Ltr Coke	1	3	1
1773	1	2F	2 Family Pizzas	1	25.9	1
1773	2	FSE	Family Seafood NO ANCH	0	0	1
1773	3	FVG	Family Vegetarian	0	0	1
1773	4	GB	Garlic Bread	1	2	1
1774	1	2L	2 Large Pizzas	1	19.9	1
1774	2	LVG	Large Vegetarian + CHILI	0	0	1
1774	3	LSP	Large Special	0	0	1
1775	1	LSU	Large Supreme -OLI	1	13.5	1
1775	2	DCOKE	1.25 LTR DIET COKE	1	3	1
1776	1	LVG	Large Vegetarian -CHEESE	1	12.5	1
1776	2	HALF	1/2 HAM MU SAL BASIL FRE TOM	1	0	1
1776	3	LX	EXTRA CHEESE	1	0.7	1
1776	4	GB	Garlic Bread	1	2	1
1777	1	2L	2 Large Pizzas	1	19.9	1
1777	2	LMX	Large Mexican	0	0	1
1777	3	LSE	Large Seafood	0	0	1
1778	1	LVG	Large Vegetarian	1	12.5	1
1778	2	EMVG	Entree Macaroni Vegetarian	1	7	1
1778	3	GB	Garlic Bread	1	2	1
1779	1	2L	2 Large Pizzas	1	19.9	1
1779	2	LMA	Large Margherita	0	0	1
1779	3	LVG	Large Vegetarian	0	0	1
1780	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1780	2	FAM	Family American	0	0	1
1780	3	HALF	1/2 PLUS PINE	1	0	1
1781	1	2F	2 Family Pizzas	1	25.9	1
1781	2	FSU	Family Supreme -C/FOOD	0	0	1
1781	3	FSU	Family Supreme -C/FOOD	0	0	1
1781	4	FSU	Family Supreme -C/FOOD	1	18	1
1782	1	PLG	LARGE PICK-UP	1	9.9	1
1782	2	LSU	Large Supreme  -OLIVES-ANCH	0	0	1
1783	1	2S	2 Small Pizzas	1	16.9	1
1783	2	SSU	Small Supreme -ANCH-OLIVES	0	0	1
1783	3	BBQ	BBQ Sauce	1	1	1
1783	4	SMX	Small Mexican	0	0	1
1783	5	SX	EXTRA SALAMI	1	0.5	1
1783	6	DCC	Cheese Cake	1	3.5	1
1783	7	DBF	Black Forrest Cake	1	4	1
1783	8	CLMND	Can of Lemonade	2	3.4	1
1783	9	CIGS	Cigarettes B+H SPE FILT	1	7.4	1
1783	10	100	****$100.00 NOTE*****	1	0	1
1784	1	2F	2 Family Pizzas	1	25.9	1
1784	2	FSU	Family Supreme	0	0	1
1784	3	FMX	Family Mexican	0	0	1
1785	1	2L	2 Large Pizzas	1	19.9	1
1785	2	HALF	1/2 CHICKEN HAW	1	0	1
1785	3	SUP	1/2 SUPREME	1	0	1
1785	4	L	LARGE	0	0	1
1785	5	SUP	1/2 SUPREME	1	0	1
1785	6	HALF	1/2 MEAT.L.	1	0	1
1786	1	2S	2 Small Pizzas	1	16.9	1
1786	2	SMA	Small Margherita	0	0	1
1786	3	SHW	Small Hawiian	0	0	1
1787	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1787	2	HALF	1/2 CHICKEN	1	0	1
1787	3	MEX	1/2 MEXICAM	1	0	1
1787	4	DGE	Gelati Cup CHOC,COFFEE	1	4	1
1788	1	LVG	Large Vegetarian 1/2-OLIVES	1	12.5	1
1788	2	LX	EXTRA SALAMI	1	0.7	1
1788	3	GB	Garlic Bread	1	2	1
1788	4	CFANTA	Can of Fanta	1	1.7	1
1789	1	L	LARGE	1	13.5	1
1789	2	HAW	1/2 HAWAIIN	1	0	1
1789	3	SUP	1/2 SUPREME - CAPS	1	0	1
1789	4	DIS	Discount	1	1.5	1
1790	1	CHF	Chicken Fillets	2	28	1
1790	2	+	+ ONE WITH SALAD	1	0	1
1791	1	F	FAM	1	18	1
1791	2	HALF	1/2VEG	1	0	1
1791	3	HALF	1/2 MEX	1	0	1
1791	4	GB	Garlic Bread	1	2	1
1792	1	2L	2 Large Pizzas	1	19.9	1
1792	2	L	LARGEHAM CHEESE,CAP,ONIO,SALAMI,OREGANO	0	0	1
1792	3	LSU	Large Supreme-ANCH,OLIVE	0	0	1
1792	4	GRAVY	Gravy for chicken+CHIPS	1	2	1
1793	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1793	2	FSP	Family Special	0	0	1
1794	1	2L	2 Large Pizzas	1	19.9	1
1794	2	LCH	Large Chicken Hawiian+CHILLI	0	0	1
1794	3	BBQ	BBQ Sauce	1	1	1
1794	4	LSU	Large Supreme	0	0	1
1794	5	CIGS	Cigarettes WIN BLUE	1	7.4	1
1795	1	L	LARGEHAM,CHEESE,PEPP,	1	13.5	1
1795	2	HALF	1/2MUSH,ANCH	1	0	1
1795	3	ESMA	Entree Spaghetti Marinara	1	9	1
1796	1	FMA	Family Margherita	1	15	1
1796	2	HALF	1/2PEPP,CHEESE	1	0	1
1797	1	2F	2 Family Pizzas	1	25.9	1
1797	2	FSU	Family Supreme - ANC	0	0	1
1797	3	FVG	Family Vegetarian	0	0	1
1797	4	GB	Garlic Bread	1	2	1
1798	1	PFM	FAMILY PICK-UP	4	51.6	1
1798	2	FHW	2 Family Hawiian	0	0	1
1798	3	FCP	Family Capriciosa + ANC	0	0	1
1798	4	FSP	Family Special	0	0	1
1799	1	FSU	Family Supreme	1	18	1
1799	2	FX	EXTRA SALAMI	1	1	1
1799	3	GB	Garlic Bread	2	4	1
1800	1	PLG	LARGE PICK-UP	1	9.9	1
1800	2	LVG	Large Vegetarian	0	0	1
1801	1	CHF	Chicken Fillets	2	28	1
1801	2	CCOKE	Can of Coke	2	3.4	1
1802	1	CPG	chicken parmigana	1	14	1
1802	2	CIGS	Cigarettes ESCORT RED	1	8.4	1
1802	3	ESAL	Entree Spaghetti Alfredo	1	7	1
1802	4	COKE	1.25 Ltr Coke	1	3	1
1803	1	L	LARGE	1	13.5	1
1803	2	HALF	1/2 CHILLI PEP CAP PINE	1	0	1
1803	3	HALF	1/2 LOT	1	0	1
1803	4	COKE	1.25 Ltr Coke	1	3	1
1804	1	CR	Calzone Rustico	2	21	1
1805	1	2L	2 Large Pizzas	1	19.9	1
1805	2	LHW	Large Hawiian	0	0	1
1805	3	LCH	Large Chicken Hawiian	0	0	1
1805	4	LX	EXTRA AVOCADO	1	0.7	1
1805	5	GB	Garlic Bread	1	2	1
1805	6	COKE	1.25 Ltr Coke	1	3	1
1806	1	FMA	Family Margherita	1	15	1
1806	2	FX	EXTRA FRESH TOMATO	1	1	1
1806	3	+	+ LOTS OF GARLIC	0	0	1
1806	4	DGE	Gelati Cup LEMON CHOC	1	4	1
1807	1	F	FAM	1	18	1
1807	2	MLO	1/2 MEAT LOVERS	1	0	1
1807	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1807	4	GB	Garlic Bread	1	2	1
1807	5	COKE	1.25 Ltr Coke	1	3	1
1808	1	SAU	Small Australian	1	8.5	1
1808	2	+	+ SAL;AMI ONION MUSH CAPS	1	1	1
1808	3	SSE	Small Seafood	1	9.5	1
1808	4	SX	EXTRA  CHILLI OMION	1	0.5	1
1808	5	SX	EXTRA CHEESE SAUCE ON BOTH	1	0.5	1
1809	1	L	LARGE CAPS OLIVE ANCH GARLIC HERBS LITTLE CHEESE	1	13.5	1
1809	2	HALF	1/2 MUSH AND ONION FRESH TOM	1	0	1
1809	3	HALF	1/2 PEP CHILLI	1	0	1
1809	4	COKE	1.25 Ltr Coke	1	3	1
1809	5	GB	Garlic Bread	1	2	1
1810	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1810	2	VEG	1/2 VEGETARIAN	1	0	1
1810	3	SEA	1/2 SEAFOOD	1	0	1
1810	4	NO	No ANCH	1	0	1
1811	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1811	2	LVG	Large Vegetarian	0	0	1
1811	3	HALF	1/2 NO OLIVES	1	0	1
1811	4	LX	EXTRA CHEESE ALL OVER	1	0.7	1
1812	1	FSU	Family Supreme	1	18	1
1812	2	NO	No ANCH NO SEAFOOD	1	0	1
1813	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1813	2	SHW	Small Hawiian	0	0	1
1813	3	CV	Calzone Vegetarian	1	10.5	1
1813	4	ECPU	Entree Ricotta Ravioli Putanesca	1	7.5	1
1813	5	NO	No ANCH IN PASTA	1	0	1
1814	1	LHW	Large Hawiian	1	12.5	1
1814	2	LSG	Large SanGiorgio	1	13.5	1
1814	3	MMPU	Macaroni Putanesca	1	9.5	1
1814	4	NO	No ANCH	1	0	1
1814	5	+	+ CAPS AND ONION	1	1	1
1814	6	GB	Garlic Bread	2	4	1
1814	7	MRPU	Ravioli Putanesca	1	9.5	1
1814	8	COKE	1.25 Ltr Coke	3	9	1
1814	9	+	+ PARMESAN CHEESE WITH PASTA	1	1	1
1815	1	STSH	Schnitzel	1	9.45	1
1815	2	NO	No SALAD WITH VEG INSTEAD	1	0	1
1815	3	STVP	Veal Parmigiana	1	12.6	1
1815	4	NO	No VEG WITH CHIPS INSTEAD	1	0	1
1815	5	MFP	Main Fried Prawns	1	14.4	1
1815	6	CUT	*******CUTLERY**************	1	0	1
1816	1	2L	2 Large Pizzas	3	59.7	1
1816	2	--	2 BBQ CHICKEN	0	0	1
1816	3	--	2 MEX	0	0	1
1816	4	--	1 VEG	0	0	1
1817	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1817	2	LVG	Large Vegetarian	0	0	1
1818	1	PFM	FAMILY PICK-UP	1	12.9	1
1818	2	FVG	Family Vegetarian	0	0	1
1819	1	FSP	Family Special	1	17	1
1819	2	FX	EXTRA CHEESE+ANCH ( W.D.)	2	2	1
1820	1	PFM	FAMILY PICK-UP	1	12.9	1
1820	2	FCH	Family Chicken Hawiian	0	0	1
1821	1	2L	2 Large Pizzas	1	19.9	1
1821	2	L	LARGE FRESH TOM, ONION, OLIVES, PINE, HERBS AND GARLIC	0	0	1
1822	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1822	2	FSU	Family Supreme	1	18	1
1822	3	NO	No ANCH	1	0	1
1823	1	+	LG GORMET VEG	1	14	1
1823	2	GB	Garlic Bread	1	2	1
1824	1	LSU	Large Supreme	1	13.5	1
1825	1	L	LARGE HAM,SALAMI,MUSH,ONION,GARLIC+HERBS	1	13.5	1
1825	2	COKE	1.25 Ltr Coke	1	3	1
1825	3	GB	Garlic Bread	1	2	1
1825	4	DCM	Chocolate Mousse	1	3.5	1
1825	5	50	*****$50.00 NOTE*****	1	0	1
1826	1	F	FAM	1	18	1
1826	2	SPE	1/2 SPECIAL	1	0	1
1826	3	MAR	1/2 MARGHERITA + SAL	1	0	1
1826	4	COKE	1.25 Ltr Coke	1	3	1
1826	5	GB	Garlic Bread	1	2	1
1826	6	CIGS	Cigarettes B&H SP FILTER	1	7.4	1
1826	7	DIS	Discount	1	-0.399999999999999	1
1827	1	LHW	Large Hawiian	1	12.5	1
1827	2	STFWD	Fillet Mignon - Well Done -MUSHROOM SAUCE+DIANNE SAUCE	1	17	1
1828	1	2L	2 Large Pizzas	1	19.9	1
1828	2	LAM	Large American	0	0	1
1828	3	LX	EXTRA MUSHROOMS	1	0.7	1
1828	4	LML	Large Meat Lovers	0	0	1
1828	5	COKE	1.25 Ltr Coke	2	6	1
1829	1	CHGR	Grilled Chicken	1	13	1
1829	2	GRAVY	Gravy for chicken ( SEPARATE )	1	2	1
1829	3	GB	Garlic Bread	1	2	1
1829	4	CCOKE	Can of Coke	1	1.7	1
1830	1	L	LARGE	0	0	1
1830	2	HAW	1/2 HAWAIIN	1	0	1
1830	3	SUP	1/2 SUPREME -ANCH	1	0	1
1830	4	L	LARGE	0	0	1
1830	5	HAW	1/2 HAWAIIN	1	0	1
1830	6	SUP	1/2 SUPREME -ANCH	1	0	1
1830	7	LSU	Large Supreme -ANCH 1/2-OLIVES	0	0	1
1830	8	SHW	Small Hawiian + SALAMI	0	0	1
1830	9	DIS	Discount	1	26	1
1831	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1831	2	LVG	Large Vegetarian	0	0	1
1832	1	MLA	Main Lasagna	1	9.5	1
1832	2	PC	Prawn Cocktail	1	8	1
1833	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1833	2	--	FM HAM MUS CAP OL PIN SAL	0	0	1
1833	3	FX	EXTRA MUS SAL	2	2	1
1834	1	LHW	Large Hawiian	1	12.5	1
1834	2	LX	EXTRA MUSH AND ANCHOVIES	2	1.4	1
1834	3	GB	Garlic Bread	1	2	1
1835	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1835	2	MLO	1/2 MEAT LOVERS	1	0	1
1835	3	SUP	1/2 SUPREME	1	0	1
1835	4	NO	No ANCH	1	0	1
1836	1	L	LARGE	1	13.5	1
1836	2	--	H P OLI CHIK ONI CAP	0	0	1
1836	3	--	MILD CHILLI	0	0	1
1836	4	CCOKE	Can of Coke	1	1.7	1
1837	1	2F	2 Family Pizzas	1	25.9	1
1837	2	FSP	Family Special	0	0	1
1837	3	MAR	1/2 MARGHERITA	1	0	1
1837	4	SUP	1/2 SUPREME	1	0	1
1838	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1838	2	LML	Large Meat Lovers	0	0	1
1838	3	LX	EXTRA MU CAP	1	0.7	1
1839	1	2L	2 Large Pizzas	1	19.9	1
1839	2	L	LARGE H P ONI SAL	0	0	1
1839	3	L	LARGE H P PEPP	0	0	1
1839	4	GB	Garlic Bread	1	2	1
1840	1	LSU	Large Supreme -ANCH OLI	1	13.5	1
1840	2	HAW	1/2 HAWAIIN	1	0	1
1841	1	2F	2 Family Pizzas	1	25.9	1
1841	2	FML	Family Meat Lovers PLUS CHICKEN	0	0	1
1841	3	FSU	Family Supreme	0	0	1
1841	4	NO	No ANCH	1	0	1
1841	5	FX	EXTRA	1	1	1
1842	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1842	2	LSG	Large SanGiorgio	0	0	1
1842	3	MENU	MENU MENU MENU	0	0	1
1843	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1843	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1843	3	VEG	1/2 VEGETARIAN -ONI	1	0	1
1844	1	SVG	Small Vegetarian	1	9	1
1844	2	SX	EXTRA FRE TOM	1	0.5	1
1844	3	MMNA	Macaroni Napolitana	1	9	1
1844	4	GB	Garlic Bread	1	2	1
1844	5	CIGS	Cigarettes DUNHILL BLUE	1	7.4	1
1845	1	L	LARGE CHIK OLI ONI MU TOM	1	13.5	1
1845	2	SUP	1/2 SUPREME	1	0	1
1845	3	CIGS	Cigarettes ESCORT RED	1	8.4	1
1845	4	CIGS	Cigarettes B&H -EXTRA MILD	1	7.4	1
1845	5	COKE	1.25 Ltr Coke	1	3	1
1846	1	LHW	Large Hawiian	1	12.5	1
1846	2	LX	EXTRA PEP, BACON ONION GARLIC	3	2.1	1
1846	3	LX	EXTRA CHEESE	1	0.7	1
1847	1	STVP	Veal Parmigiana	1	14	1
1847	2	GB	Garlic Bread	1	2	1
1847	3	DCM	Chocolate Mousse	1	3.5	1
1848	1	LSU	Large Supreme	1	13.5	1
1848	2	NO	No ANCH	1	0	1
1848	3	GB	Garlic Bread	1	2	1
1849	1	PLG	LARGE PICK-UP	1	9.9	1
1849	2	L	LARGE SALAMI OLIVE MUSH CAP	0	0	1
1849	3	LX	EXTRA PASTE AND CAP AND ANCH	3	2.1	1
1850	1	FSU	Family Supreme	1	18	1
1850	2	NO	No ANCH	1	0	1
1851	1	L	LARGE MUSH PEP	1	13.5	1
1851	2	--	ONE QUARTER NO PEP	0	0	1
1851	3	LX	EXTRA CHEESE	1	0.7	1
1851	4	GB	Garlic Bread	2	4	1
1852	1	FSU	Family Supreme	1	18	1
1852	2	FX	EXTRA TOMATO PASTE	1	1	1
1853	1	MMCB	Macaroni Carbonara	1	10	1
1853	2	CCOKE	Can of Coke	2	3.4	1
1854	1	2F	2 Family Pizzas	1	25.9	1
1854	2	FSP	Family Special	0	0	1
1854	3	FVG	Family Vegetarian	0	0	1
1855	1	F	FAM H MU CAP	1	18	1
1855	2	FX	EXTRA FRE TOM	1	1	1
1856	1	FVG	Family Vegetarian	1	17	1
1856	2	FX	EXTRA CHICKEN	1	1	1
1856	3	HALF	1/2 CHILI	1	0	1
1857	1	MLA	Main Lasagna	1	9.5	1
1857	2	STMS	Scaloppina Mushroom	1	11.5	1
1857	3	GB	Garlic Bread	1	2	1
1857	4	COKE	1.25 Ltr Coke	1	3	1
1858	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1858	2	HALF	1/2 LOT	1	0	1
1858	3	HALF	1/2 BBQ CHICK HAW	1	0	1
1858	4	LX	EXTRA	1	0.7	1
1859	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1859	2	HAW	1/2 HAWAIIN	1	0	1
1859	3	MAR	1/2 MARGHERITA + HAM	1	0	1
1859	4	LX	EXTRA HAM	1	0.7	1
1860	1	L	LARGE	1	13.5	1
1860	2	HALF	1/2 HAW	1	0	1
1860	3	LX	EXTRA EGG MUSHROOM	2	1.4	1
1860	4	HALF	1/2 VEG	1	0	1
1860	5	EFNA	Entree Fettucini Napoletana	1	7	1
1860	6	GB	Garlic Bread	1	2	1
1861	1	SSG	Small SanGiorgio + ANC	1	9.5	1
1861	2	SMX	Small Mexican	1	9.5	1
1861	3	GB	Garlic Bread	1	2	1
1862	1	CHAV	Chicken Avocado	1	14	1
1862	2	GB	Garlic Bread	1	2	1
1863	1	2L	2 Large Pizzas	1	19.9	1
1863	2	LHW	Large Hawiian	0	0	1
1863	3	LSP	Large Special	0	0	1
1863	4	LX	EXTRA ANCH	1	0.7	1
1864	1	LHW	Large Hawiian	1	12.5	1
1864	2	HALF	1/2 + MUSHROOM	1	0	1
1864	3	LX	EXTRA	1	0.7	1
1865	1	CPG	chicken parmigana	1	14	1
1865	2	DAPC	Apple Pie with Cream	1	3.5	1
1865	3	COKE	1.25 Ltr Coke	1	3	1
1865	4	ESBO	Entree Spaghetti Bolognese	1	7	1
1865	5	50	*****$50.00 NOTE*****	1	0	1
1866	1	2F	2 Family Pizzas	1	25.9	1
1866	2	FVG	Family Vegetarian	0	0	1
1866	3	FCH	Family Chicken Hawiian	0	0	1
1867	1	MFMA	Fettucini Marinara	1	11.5	1
1867	2	FS	French Salad	1	4	1
1867	3	GB	Garlic Bread	1	2	1
1868	1	2L	2 Large Pizzas	1	19.9	1
1868	2	LHW	Large Hawiian	0	0	1
1868	3	LMX	Large Mexican	0	0	1
1868	4	HALF	1/2 + ANCH	1	0	1
1868	5	GB	Garlic Bread	2	4	1
1869	1	FSU	Family Supreme	1	18	1
1869	2	NO	No ANCH NO OLIVES	1	0	1
1870	1	LSE	Large Seafood	1	13.5	1
1870	2	NO	No CHEESE	1	0	1
1870	3	GB	Garlic Bread	1	2	1
1871	1	STVP	Veal Parmigiana	1	14	1
1871	2	MLA	Main Lasagna	1	9.5	1
1871	3	COKE	1.25 Ltr Coke	1	3	1
1872	1	MFMA	Fettucini Marinara	1	11.5	1
1872	2	SCH	Small Chicken Hawiian	1	9.5	1
1872	3	GB	Garlic Bread	1	2	1
1872	4	COKE	1.25 Ltr Coke	1	3	1
1873	1	MCNA	Ricotta Ravioli Napolitana	1	9	1
1873	2	MMPU	Macaroni Putanesca	1	9.5	1
1873	3	MMPU	Macaroni Putanesca	1	9.5	1
1873	4	NO	No ANCH	1	0	1
1873	5	MTAP	Tortellini Alla Panna	1	10	1
1874	1	STD	Steak Dianne	1	15	1
1874	2	SCH	Small Chicken Hawiian	1	9.5	1
1874	3	SX	EXTRA PRA	1	0.5	1
1874	4	MGP	Main Garlic Prawns	1	16.5	1
1875	1	FVG	Family Vegetarian	2	34	1
1875	2	FMA	Family Margherita + OL	1	15	1
1875	3	FMX	Family Mexican	1	17.5	1
1875	4	FSU	Family Supreme - PIN	1	18	1
1875	5	FSG	Family SanGiorgio	1	18	1
1875	6	DIS	Discount	1	-27.5	1
1876	1	LSU	Large Supreme	1	13.5	1
1876	2	NO	No SEAFOOD,OLIVES	1	0	1
1876	3	GB	Garlic Bread	1	2	1
1877	1	CHF	Chicken Fillets	1	14	1
1877	2	GB	Garlic Bread	1	2	1
1877	3	DAPC	Apple Pie with Cream	1	3.5	1
1877	4	CCOKE	Can of Coke	1	1.7	1
1878	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1878	2	SML	Small Meat Lovers	0	0	1
1878	3	ERNA	Entree Ravioli Napoletana	1	7	1
1879	1	FS	French Salad	1	4	1
1879	2	SMA	Small Margherita	1	8	1
1879	3	GB	Garlic Bread	1	2	1
1879	4	EFPU	Entree Fettucini Putanesca	1	7.5	1
1879	5	+	2 BTTLE WATER	1	10	1
1880	1	PC	Prawn Cocktail	1	8	1
1880	2	STR	Rump Steak mr	1	13	1
1880	3	CHMS	Mushroom Sauce	1	2	1
1880	4	COKE	1.25 Ltr Coke	1	3	1
1881	1	L	LARGE	1	13.5	1
1881	2	HALF	1/2 CHICK BBQ	1	0	1
1881	3	HALF	1/2 HAW	1	0	1
1881	4	LX	EXTRA	1	0.7	1
1881	5	GS	Greek Salad	1	5.5	1
1882	1	STR	Rump Steak	1	13	1
1882	2	CHAS	Chicken Asparagus	1	14	1
1882	3	CHIPS	Chips	1	3.5	1
1883	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1883	2	SUP	1/2 SUPREME	1	0	1
1883	3	HALF	1/2 MEAT LOVERS	1	0	1
1884	1	2F	2 Family Pizzas	1	25.9	1
1884	2	FML	Family Meat Lovers	0	0	1
1884	3	FX	EXTRA PRAWNS	1	1	1
1884	4	FVG	Family Vegetarian	0	0	1
1884	5	FX	EXTRA SD TOM	1	1	1
1884	6	FX	EXTRA ARTICHOKE	1	1	1
1884	7	FX	EXTRA  HALF PRAWNS	1	1	1
1885	1	MGP	Main Garlic Prawns	1	16.5	1
1885	2	GS	Greek Salad	1	5.5	1
1885	3	F	FAM	1	18	1
1885	4	HALF	1/2 CHICKEN	1	0	1
1885	5	HOT	PLUS CHILLIE	1	0	1
1885	6	HALF	1/2 LOT NO ANCH	1	0	1
1885	7	GB	Garlic Bread	1	2	1
1885	8	MSBO	Spaghetti Bolognese	1	9.5	1
1885	9	HOT	PLUS CHILLIE	1	0	1
1886	1	2L	2 Large Pizzas	1	19.9	1
1886	2	LSG	Large SanGiorgio	0	0	1
1886	3	LX	EXTRA ANCH	1	0.7	1
1886	4	LVG	Large Vegetarian	0	0	1
1887	1	LSU	Large Supreme	1	13.5	1
1887	2	NO	No ANC	1	0	1
1888	1	STSZ	Scaloppina Zingara	1	11.5	1
1888	2	GB	Garlic Bread`	2	4	1
1889	1	OKD	Dozen Oysters Kilpatrick	1	14.5	1
1889	2	LCH	Large Chicken Hawiian	1	13	1
1889	3	BBQ	BBQ Sauce AND CHILLI	1	1	1
1889	4	SUP	1/2 SUPREME	1	0	1
1890	1	LSU	Large Supreme	1	13.5	1
1890	2	NO	No olives pine	1	0	1
1890	3	GB	Garlic Bread	1	2	1
1891	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1891	2	VEG	1/2 VEGETARIANq	1	0	1
1891	3	HALF	1/2 CHICK HAW + MUSH	1	0	1
1891	4	FX	EXTRA	1	1	1
1891	5	PLUS	HERBS ALL OVER	0	0	1
1892	1	MTAP	Tortellini Alla Panna	1	10	1
1892	2	GB	Garlic Bread	1	2	1
1892	3	MIN	BOTTLE OF M/W	1	3.5	1
1892	4	DFS	Fruit Salad & Ice Cream	1	4.5	1
1893	1	STFMR	Fillet Mignon - Md Rare	1	17	1
1894	1	MLA	Main Lasagna	2	19	1
1894	2	DCOKE	1.25 LTR DIET COKE	1	3	1
1894	3	HB	Herb Bread	1	2	1
1895	1	LSU	Large Supreme -ANCH	1	13.5	1
1895	2	LX	EXTRA CHEESE	1	0.7	1
1895	3	LX	EXTRA MUSH	1	0.7	1
1895	4	DIS	Discount	1	0.100000000000001	1
1896	1	FSU	Family Supreme -ANCH	1	18	1
1896	2	VEG	1/2 VEGETARIAN	1	0	1
1897	1	LCH	Large Chicken Hawiian	1	13	1
1897	2	HALF	1/2 HAM MUSH	1	0	1
1897	3	MTMA	Tortellini Marinara	1	11.5	1
1898	1	2L	2 Large Pizzas	1	19.9	1
1898	2	LSG	Large SanGiorgio	0	0	1
1898	3	--	+ CHILLI	0	0	1
1898	4	MLO	1/2 MEAT LOVERS	1	0	1
1898	5	VEG	1/2 VEGETARIAN	1	0	1
1899	1	LSU	Large Supreme -SEAFOOD	1	13.5	1
1899	2	LX	EXTRA KAL OLI	1	0.7	1
1899	3	LX	EXTRA PEPP	1	0.7	1
1899	4	COKE	1.25 Ltr Coke	1	3	1
1900	1	LSU	Large Supreme	1	13.5	1
1900	2	NO	No PIN	1	0	1
1901	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1901	2	LSU	Large Supreme	0	0	1
1902	1	LHW	Large Hawiian	1	12.5	1
1902	2	LX	EXTRA PRAWNS	1	0.7	1
1902	3	GB	Garlic Bread	1	2	1
1902	4	COKE	1.25 Ltr Coke	1	3	1
1903	1	LVG	Large Vegetarian - PIN	1	12.5	1
1903	2	SX	EXTRA MUS	1	0.5	1
1903	3	GB	Garlic Bread	1	2	1
1904	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1904	2	FCH	Family Chicken Hawiian	0	0	1
1904	3	FX	EXTRA OL MUS	2	2	1
1905	1	SHW	Small Hawiian	2	18	1
1905	2	SX	EXTRA PR SAL CAP	2	1	1
1906	1	F	FAM	1	18	1
1906	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1906	3	SUP	1/2 SUPREME	1	0	1
1907	1	EGW	Entree Grilled Whiting	1	9	1
1907	2	L	LARGE	1	13.5	1
1907	3	MLO	1/2 MEAT LOVERS	1	0	1
1907	4	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1907	5	LX	EXTRA CHEESE	1	0.7	1
1907	6	DCM	Chocolate Mousse	1	3.5	1
1908	1	PFM	FAMILY PICK-UP	1	12.9	1
1908	2	SUP	1/2 SUPREME	1	0	1
1908	3	SEA	1/2 SEAFOOD	1	0	1
1909	1	FML	Family Meat Lovers	1	17.5	1
1909	2	BBQ	BBQ Sauce	1	1	1
1909	3	FX	EXTRA CHEESE	1	1	1
1910	1	PFM	FAMILY PICK-UP	2	25.8	1
1910	2	--	H MU OLI ONI BAC	0	0	1
1910	3	FX	EXTRA MUSH	1	1	1
1910	4	FX	EXTRA CHEESE	1	1	1
1911	1	SSG	Small SanGiorgio	1	9.5	1
1911	2	NO	NoFRASH TOMA	1	0	1
1911	3	SX	EXTRA  HAM,CHILLI	1	0.5	1
1911	4	CIGS	Cigarettes BH SPEC	1	7.4	1
1912	1	MMNA	Macaroni Napolitana	1	9	1
1912	2	MTAP	Tortellini Alla Panna	1	10	1
1912	3	GB	Garlic Bread	1	2	1
1913	1	LSU	Large Supreme	1	13.5	1
1913	2	HAW	1/2 HAWAIIN	1	0	1
1914	1	LHW	Large Hawiian	1	12.5	1
1914	2	COKE	1.25 Ltr Coke	1	3	1
1915	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1915	2	MLO	1/2 MEAT LOVERS	1	0	1
1915	3	SUP	1/2 SUPREME	1	0	1
1916	1	L	LARGE	1	13.5	1
1916	2	MLO	1/2 MEAT LOVERS	1	0	1
1916	3	HOT	PLUS CHILLIE	1	0	1
1916	4	SUP	1/2 SUPREME - MUS	1	0	1
1916	5	GB	Garlic Bread	1	2	1
1916	6	COKE	1.25 Ltr Coke	1	3	1
1917	1	2L	2 Large Pizzas	1	19.9	1
1917	2	LAU	Large Australian + ON	0	0	1
1917	3	L	LARGE ON TOM CAP PR PIN OLI	0	0	1
1917	4	--	MUS HERBS	0	0	1
1918	1	ELA	Entree Lasagna	1	7.5	1
1918	2	PSM	SMALL PICK-UP	1	6.9	1
1918	3	SMX	Small Mexican	0	0	1
1918	4	GB	Garlic Bread	1	2	1
1919	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1919	2	HAW	1/2 HAWAIIN	1	0	1
1919	3	SUP	1/2 SUPREME	1	0	1
1920	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1920	2	HAW	1/2 HAWAIIN	1	0	1
1920	3	HALF	1/2 BBQ CHICKEN	1	0	1
1921	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1921	2	SSP	Small Special	0	0	1
1921	3	SX	EXTRA PINEAPPLE	1	0.5	1
1922	1	CR	Calzone Rustico	1	10.5	1
1922	2	+	+ parmesan cheese	0	0	1
1922	3	GB	Garlic Bread	1	2	1
1922	4	CCOKE	Can of Coke	1	1.7	1
1923	1	STSZ	Scaloppina Zingara	1	11.5	1
1924	1	FSG	Family SanGiorgio	1	18	1
1925	1	L	LARGE CHICK CAP MUSH	1	13.5	1
1925	2	NO	No CHEESE	1	0	1
1925	3	CDIET	CAN OF DIET COKE	2	3.4	1
1926	1	2L	2 Large Pizzas	1	19.9	1
1926	2	LMX	Large Mexican	0	0	1
1926	3	LSE	Large Seafood	0	0	1
1927	1	EMCB	Entree Macaroni Carbonara	2	16	1
1928	1	LSP	Large Special	1	12.5	1
1929	1	LSU	Large Supreme	1	13.5	1
1929	2	STVP	Veal Parmigiana -VEG +SALAD+	1	14	1
1929	3	SX	EXTRA FETTA CHEESE+OLIVES	2	1	1
1929	4	EFC	Entree Fried Calamari FETTA=OLIVES	1	8.5	1
1929	5	100	****$100.00 NOTE*****	1	0	1
1930	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1930	2	FSG	Family SanGiorgio -SALAMI-ONION-CAPS	0	0	1
1930	3	FX	EXTRA CHICKEN+MUSHROOMS+FR.BASIL	1	1	1
1930	4	HB	Herb Bread	0	0	1
1931	1	LSU	Large Supreme	1	13.5	1
1931	2	GB	Garlic Bread	1	2	1
1932	1	FSU	Family Supreme	1	18	1
1932	2	NO	No PINE OR ANCH	1	0	1
1932	3	DCOKE	1.25 LTR DIET COKE	1	3	1
1932	4	COKE	1.25 Ltr Coke	1	3	1
1933	1	STPWD	Pepper Steak - Well Done	1	15	1
1933	2	CHIPS	Chips	1	3.5	1
1933	3	50	*****$50.00 NOTE*****	1	0	1
1934	1	2L	2 Large Pizzas	1	19.9	1
1934	2	LMX	Large Mexican	0	0	1
1934	3	LHW	Large Hawiian	0	0	1
1935	1	LSU	Large Supreme	1	13.5	1
1935	2	NO	NoPIN NO OLIVES NO ANCH	1	0	1
1935	3	HB	Herb Bread	1	2	1
1936	1	2L	2 Large Pizzas	1	19.9	1
1936	2	LSU	Large Supreme	0	0	1
1936	3	LSG	Large SanGiorgio	0	0	1
1937	1	LSU	Large Supreme	1	13.5	1
1937	2	FSU	Family Supreme	1	18	1
1937	3	NO	No anch or olives on family	1	0	1
1937	4	COKE	1.25 Ltr Coke	1	3	1
1938	1	CHF	Chicken Fillets	1	14	1
1938	2	GB	Garlic Bread	1	2	1
1939	1	2L	2 Large Pizzas	1	19.9	1
1939	2	LSU	Large Supreme	0	0	1
1940	1	EFVG	Entree Fettucini Vegetarian	1	7	1
1940	2	L	LARGE pep ham pine	1	13.5	1
1940	3	COKE	1.25 Ltr Coke	1	3	1
1940	4	R	receipt	0	0	1
1941	1	LSU	Large Supreme	1	13.5	1
1941	2	LX	EXTRA pep	1	0.7	1
1942	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1942	2	AME	1/2 AMERICAN	1	0	1
1942	3	SAN	1/2 SAN GIORGIO	1	0	1
1942	4	CIGS	Cigarettes PETER STYVES	1	6.6	1
1943	1	2S	2 Small Pizzas	1	16.9	1
1943	2	SML	Small Meat Lovers	0	0	1
1943	3	SSG	Small SanGiorgio	0	0	1
1944	1	SD	Soup of the Day	2	8.1	1
1944	2	CBR	Continental Bread (3 peices)	2	1.08	1
1944	3	GS	Greek Salad	1	4.95	1
1944	4	CUT	*******CUTLERY**************	1	0	1
1944	5	DIS	Discount	1	0.0200000000000014	1
1945	1	FHW	Family Hawiian	1	16.5	1
1945	2	FX	EXTRA CHICKEN HERBS	1	1	1
1946	1	L	LARGE GARLIC PWN F/TOM HAM	1	13.5	1
1946	2	LSU	Large Supreme	1	13.5	1
1947	1	DCC	Cheese Cake	1	3.5	1
1947	2	DCM	Chocolate Mousse	1	3.5	1
1947	3	DBF	Black Forrest Cake	1	4	1
1948	1	PLG	LARGE PICK-UP	1	9.9	1
1948	2	LSU	Large Supreme	0	0	1
1948	3	NO	No ANCHOVIES	1	0	1
1949	1	CHGR	Grilled Chicken	1	13	1
1949	2	GS	Greek Salad	1	5.5	1
1949	3	SHW	Small Hawiian	1	9	1
1949	4	GB	Garlic Bread	1	2	1
1950	1	STP	Pepper Steak	1	15	1
1951	1	F	FAM	1	16.2	1
1951	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
1951	3	SUP	1/2 SUPREME	1	0	1
1951	4	FX	EXTRA CHEESE ALL OVER	1	0.9	1
1951	5	NO	No HERBS	1	0	1
1952	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1952	2	SEA	1/2 SEAFOOD	1	0	1
1952	3	SUP	1/2 SUPREME	1	0	1
1953	1	LSU	Large Supreme	1	13.5	1
1953	2	NO	No ANCH	1	0	1
1953	3	LX	EXTRA SALAMI	1	0.7	1
1953	4	COKE	1.25 Ltr Coke	1	3	1
1953	5	CIGS	CigarettesPJ SUPER	1	7.8	1
1954	1	EGP	Entree Garlic Prawns	1	10.5	1
1954	2	CHAV	Chicken Avocado	1	14	1
1954	3	COKE	1.25 Ltr Coke	1	3	1
1955	1	MFW	Main Fried Whiting	1	15	1
1955	2	MSMA	Spaghetti Marinara	1	11.5	1
1956	1	MSBO	Spaghetti Bolognese	1	8.55	1
1956	2	GB	Garlic Bread	1	1.8	1
1957	1	PFM	FAMILY PICK-UP	1	12.9	1
1957	2	FSU	Family Supreme	0	0	1
1957	3	FX	EXTRA ANCHOVIES	1	1	1
1958	1	PFM	FAMILY PICK-UP	1	12.9	1
1958	2	FSU	Family Supreme	0	0	1
1959	1	2L	2 Large Pizzas	1	19.9	1
1959	2	LCH	Large Chicken Hawiian	0	0	1
1959	3	BBQ	BBQ Sauce	1	1	1
1959	4	L	LARGE MUSH BACON ONION	0	0	1
1959	5	COKE	1.25 Ltr Coke	1	3	1
1960	1	L	LARGE	1	13.5	1
1960	2	MEX	1/2 MEXICAM	1	0	1
1960	3	HALF	1/2 CHICK HAW	1	0	1
1960	4	GB	Garlic Bread	1	2	1
1960	5	COKE	1.25 Ltr Coke	1	3	1
1960	6	CIGS	Cigarettes B+H EX MILD	1	7.4	1
1961	1	F	FAM	1	18	1
1961	2	HAW	1/2 HAWAIIN	1	0	1
1961	3	HALF	1/2 BACON+ONION	1	0	1
1962	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1962	2	SAN	1/2 SAN GIORGIO	1	0	1
1962	3	FX	EXTRA SALAMI	1	1	1
1962	4	MEX	1/2 MEXICAM	1	0	1
1962	5	FX	EXTRA SALAMI AND CHILLI	0	0	1
1963	1	FSU	Family Supreme	1	18	1
1963	2	+	+THREE QUARTERS NO ANCH OR OLIVES	0	0	1
1963	3	COKE	1.25 Ltr Coke	2	6	1
1963	4	CIGS	Cigarettes PETER J EXTRA MILD	1	7.8	1
1963	5	CIGS	Cigarettes ESCORT RED	1	8.4	1
1963	6	CIGS	Cigarettes BH SPECIAL FILTER	1	7.4	1
1963	7	DIS	Discount	1	-4.4	1
1964	1	LSG	Large SanGiorgio	1	13.5	1
1964	2	DGE	Gelati Cup PIST+BACI	1	4	1
1965	1	LVG	Large Vegetarian	1	12.5	1
1965	2	+	+ CHILLI	0	0	1
1966	1	CHGR	Grilled Chicken	1	13	1
1966	2	CHIPS	Chips	1	3.5	1
1966	3	DCM	Chocolate Mousse	1	3.5	1
1967	1	LSU	Large Supreme	1	13.5	1
1967	2	NO	No ANCH	1	0	1
1967	3	GB	Garlic Bread	1	2	1
1968	1	2L	2 Large Pizzas	1	19.9	1
1968	2	LCH	Large Chicken Hawiian	0	0	1
1968	3	LSU	Large Supreme	0	0	1
1969	1	FSG	Family SanGiorgio	1	18	1
1970	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
1970	2	FHW	Family Hawiian	0	0	1
1971	1	PLG	LARGE PICK-UP	1	9.9	1
1971	2	LVG	Large Vegetarian - olives	0	0	1
1972	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1972	2	LSG	Large SanGiorgio	0	0	1
1972	3	LX	EXTRA MUSH CHICKJ	2	1.4	1
1973	1	FCH	Family Chicken Hawiian	1	17.5	1
1974	1	MMAP	Macaroni Alla Panna	1	10	1
1975	1	FAU	Family Australian	1	16	1
1975	2	FX	EXTRA ONIONS AND MUSH	2	2	1
1975	3	GB	Garlic Bread	1	2	1
1976	1	2F	2 Family Pizzas	1	25.9	1
1976	2	FVG	Family Vegetarian	0	0	1
1977	1	CHGR	Grilled Chicken	1	13	1
1977	2	VEGIE	SERVE OF VEGETABLES	1	3.5	1
1977	3	CHIPS	Chips	1	3.5	1
1977	4	DIANE	DIANNE SAUCE	1	2.8	1
1977	5	DTA	Tartufo - CREAM	1	3.5	1
1978	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1978	2	LVG	Large Vegetarian	0	0	1
1978	3	+	+ FRESH BASIL	0	0	1
1979	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1979	2	LAM	Large American	0	0	1
1980	1	PLG	LARGE PICK-UP SANGIORGIO	1	9.9	1
1981	1	2S	2 Small Pizzas	1	16.9	1
1981	2	SCH	Small Chicken Hawiian	0	0	1
1981	3	SSG	Small SanGiorgio	0	0	1
1981	4	COKE	1.25 Ltr Coke	1	3	1
1982	1	SAM	Small American	1	9	1
1982	2	GB	Garlic Bread	1	2	1
1982	3	L	LARGE HAM SAL CAP PINE	1	13.5	1
1982	4	MFBO	Fettucini Bolognese	3	28.5	1
1983	1	SD	Soup of the Day	4	16.2	1
1983	2	CBR	Continental Bread (3 peices)	2	1.08	1
1983	3	CUT	*******CUTLERY**************	1	0	1
1983	4	DIS	Discount	1	0.0199999999999996	1
1984	1	SSG	Small SanGiorgio	1	9.5	1
1984	2	SX	EXTRA ANCH	1	0.5	1
1984	3	GB	Garlic Bread	1	2	1
1984	4	DCC	Cheese Cake	1	3.5	1
1984	5	50	*****$50.00 NOTE*****	1	0	1
1985	1	MTNA	Tortellini Napolitana	1	9	1
1985	2	CIGS	Cigarettes BH EXTRA MILD	1	7.4	1
1985	3	MIN	BOTTLE OF M/W APPLE JUICE	1	3.5	1
1986	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1986	2	LSU	Large Supreme	0	0	1
1987	1	LAM	Large American	1	12.5	1
1987	2	CCOKE	Can of Coke	1	1.7	1
1988	1	F	FAM	1	18	1
1988	2	SAN	1/2 SAN GIORGIO	1	0	1
1988	3	MLO	1/2 MEAT LOVERS	1	0	1
1988	4	GB	Garlic Bread	1	2	1
1989	1	2L	2 Large Pizzas	1	19.9	1
1989	2	LSU	Large Supreme -ANCH (BOTH)	0	0	1
1989	3	LX	EXTRA CHICKEN(BOTH)	2	1.4	1
1989	4	LX	EXTRA +CHILLI ON ONE	0	0	1
1989	5	50	*****$50.00 NOTE*****	1	0	1
1990	1	2S	2 Small Pizzas	1	16.9	1
1990	2	SHW	Small Hawiian	0	0	1
1990	3	S	SMALL HAM,PINE,PEPP,MUSH,CAPS,OLIVES+GARLIC	0	0	1
1990	4	GB	Garlic Bread	1	2	1
1991	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
1991	2	VEG	1/2 VEGETARIAN	1	0	1
1991	3	SAN	1/2 SAN GIORGIO	1	0	1
1992	1	L	LARGE	1	13.5	1
1992	2	VEG	1/2 VEGETARIAN	1	0	1
1992	3	NO	No PINE PLUS FRESH TOM	1	0	1
1992	4	LX	EXTRA MUSH AND OLIVES	2	1.4	1
1992	5	HALF	1/2 PRAWNS MUSH SAL PEP CHILLI ONION CAP F.TOM	1	0	1
1992	6	HB	Herb Bread	1	2	1
1992	7	FS	French Salad	1	4	1
1993	1	GB	Garlic Bread	1	2	1
1993	2	FVG	Family Vegetarian NO ONION NO PINE	1	17	1
1993	3	FX	EXTRA OLIVES GARLIC + HERBS	0	0	1
1994	1	SPC	Small Pizza, 1 Can Coke	1	10	1
1994	2	SML	Small Meat Lovers	0	0	1
1995	1	MFAL	Fettucini Alfredo	1	8.1	1
1995	2	GB	Garlic Bread	1	1.8	1
1995	3	CCOKE	Can of Coke	1	1.7	1
1996	1	LSU	Large Supreme X CHILLI	1	13.5	1
1996	2	LX	EXTRA OLIVES	1	0.7	1
1996	3	GB	Garlic Bread	1	2	1
1997	1	PFM	FAMILY PICK-UP SANGIORGIO	1	12.9	1
1998	1	MMPU	Macaroni Putanesca	1	9.5	1
1998	2	MMBO	Macaroni Bolognese	1	9.5	1
1998	3	PFM	FAMILY PICK-UP  SUPREME	1	12.9	1
1998	4	PLG	LARGE PICK-UP VEGETARIAN	1	9.9	1
1999	1	F	FAM	1	18	1
1999	2	HALF	1/2 CHICKEN	1	0	1
1999	3	HALF	1/2 HAM,MUSHROOM	1	0	1
1999	4	COKE	1.25 Ltr Coke	1	3	1
2000	1	LSU	Large Supreme NO OLIVES NO ANCH NO PINE	1	13.5	1
2001	1	2F	2 Family Pizzas	1	25.9	1
2001	2	VEG	1/2 VEGETARIAN	1	0	1
2001	3	MAR	1/2 MARGHERITA	1	0	1
2001	4	FSU	Family Supreme	0	0	1
2001	5	NO	No ANC	1	0	1
2002	1	2L	2 Large Pizzas	1	19.9	1
2002	2	LAM	Large AmericanPLUS ONION	0	0	1
2002	3	LMA	Large Margherita	0	0	1
2002	4	LX	EXTRA MUSH NONION	1	0.7	1
2003	1	ECNA	Entree Ricotta Ravioli Napoletana	1	7	1
2003	2	MCBO	Ricotta Ravioli Bolognese	1	9.5	1
2003	3	FS	French Salad	1	4	1
2003	4	NO	No ONION	1	0	1
2004	1	CPG	chicken parmigana	2	25.2	1
2004	2	MFAP	Fettucini Alla Panna	1	9	1
2004	3	+	+ EXTRA PANNA SAUCE	1	0.9	1
2004	4	COKE	1.25 Ltr Coke	1	3	1
2004	5	MENU	MENU MENU	0	0	1
2005	1	FSU	Family Supreme NO OLIVES	0	0	1
2005	2	FX	EXTRA ANCH	1	1	1
2005	3	F	FAM	0	0	1
2005	4	SUP	1/2 SUPREME no anch no olives	1	0	1
2005	5	SPE	1/2 SPECIAL	1	0	1
2005	6	F	FAM	0	0	1
2005	7	HAW	1/2 HAWAIIN	1	0	1
2005	8	HALF	1/2 HAM+MUSHROOM	1	0	1
2005	9	DIS	Discount	1	30	1
2006	1	2F	2 Family Pizzas	1	25.9	1
2006	2	FSU	Family Supreme	0	0	1
2006	3	F	FAM PEP CAP	0	0	1
2007	1	LCH	Large Chicken Hawiian	0	0	1
2007	2	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2008	1	L	LARGE HAM SALAMI PEP FRESH TOMATO BASIL ONION CAP LITTLE MUSH HERBS	1	13.5	1
2008	2	GB	Garlic Bread	1	2	1
2009	1	F	FAM	1	18	1
2009	2	MAR	1/2 MARGHERITA	1	0	1
2009	3	HALF	1/2 PEPPERONI	1	0	1
2009	4	COKE	1.25 Ltr Coke	1	3	1
2011	1	L	LARGE	1	13.5	1
2011	2	HAW	1/2 HAWAIIN	1	0	1
2011	3	SUP	1/2 SUPREME	1	0	1
2011	4	NO	No OLIVES OR ANCH	1	0	1
2012	1	STDMR	Steak Dianne - Md Rare	1	15	1
2012	2	GB	Garlic Bread	1	2	1
2013	1	F	FAM	1	18	1
2013	2	SUP	1/2 SUPREME	1	0	1
2013	3	NO	No OLIVES OR ANCH	1	0	1
2013	4	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2013	5	BBQ	BBQ Sauce ON CHICKEN	1	1	1
2014	1	FVG	Family Vegetarian	1	17	1
2014	2	+	+ SUN DRIED TOM AND ARTICHOKE	2	2	1
2015	1	LVG	Large VegetarianPLUS GARLIC	1	12.5	1
2015	2	NO	No OLIVES OR MUSH	1	0	1
2015	3	GB	Garlic Bread	1	2	1
2015	4	COKE	1.25 Ltr Coke	1	3	1
2016	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2016	2	HAW	1/2 HAWAIIN	1	0	1
2016	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2016	4	BBQ	BBQ Sauce ON THE CHICKEN	1	1	1
2017	1	2L	2 Large Pizzas	1	19.9	1
2017	2	LSU	Large Supreme	0	0	1
2017	3	LSG	Large SanGiorgio	0	0	1
2017	4	GB	Garlic Bread	1	2	1
2018	1	LSG	Large SanGiorgio	0	0	1
2018	2	LX	EXTRA BACON MUSH P	2	1.4	1
2018	3	HALF	1/2 WITH PINE	1	0	1
2018	4	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2018	5	GGG	5353	0	0	1
2019	1	F	FAM	1	18	1
2019	2	SUP	1/2 SUPREME	1	0	1
2019	3	NO	No SEAFOOD PLUS HERBS AND CHILLI	1	0	1
2019	4	MLO	1/2 MEAT LOVERS	1	0	1
2019	5	FX	EXTRA WITH CHICK AND PRAWNS	2	2	1
2020	1	PLG	LARGE PICK-UP SEAFOOD	1	9.9	1
2021	1	PSM	SMALL PICK-UP	1	6.9	1
2021	2	SVG	Small Vegetarian	0	0	1
2022	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2022	2	HALF	1/2 PEPP	1	0	1
2022	3	MAR	1/2 MARGHERITA	1	0	1
2023	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2023	2	HALF	1/2 MARGARITA	1	0	1
2023	3	HALF	1/2 SAN GIORGIO	1	0	1
2024	1	2L	2 Large Pizzas	1	19.9	1
2024	2	LCH	Large Chicken Hawiian	0	0	1
2024	3	LSU	Large Supreme	0	0	1
2024	4	50	*****$50.00 NOTE*****	1	0	1
2025	1	CHGR	Grilled Chicken	1	13	1
2025	2	VEGIE	SERVE OF VEGETABLES	1	3.5	1
2025	3	DTA	Tartufo	1	3.5	1
2026	1	MINE	Minestrone Soup	1	4.5	1
2026	2	MSBO	Spaghetti Bolognese	1	9.5	1
2026	3	GB	Garlic Bread	1	2	1
2027	1	2L	2 Large Pizzas	1	19.9	1
2027	2	LML	Large Meat Lovers	0	0	1
2027	3	LX	EXTRA MUSHROOMS	1	0.7	1
2027	4	LSU	Large Supreme NO OLIVES 1/2-ANCH	0	0	1
2028	1	LSP	Large Special	1	12.5	1
2029	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2029	2	LSU	Large Supreme	0	0	1
2030	1	OKD	Dozen Oysters Kilpatrick WELL DONE	1	14.5	1
2030	2	PA	Prawn Avocado	1	10	1
2030	3	ESBO	Entree Spaghetti Bolognese	1	7	1
2030	4	MSBO	Spaghetti Bolognese	1	9.5	1
2030	5	CHAV	Chicken Avocado	1	14	1
2030	6	CHAS	Chicken Asparagus	1	14	1
2031	1	ELA	Entree Lasagna	2	15	1
2031	2	FS	French Salad	1	4	1
2031	3	COKE	1.25 Ltr Coke	1	3	1
2032	1	MRPU	Ravioli Putanesca	1	9.5	1
2032	2	GB	Garlic Bread	1	2	1
2032	3	FS	French Salad	1	4	1
2033	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2033	2	LSU	Large Supreme	0	0	1
2034	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2034	2	HALF	1/2 CHICK HAW	1	0	1
2034	3	HALF	1/2 MEAT LOVERS	1	0	1
2035	1	FMA	Family Margherita	1	15	1
2035	2	FX	EXTRA CHEESE	1	1	1
2035	3	EXTRA	SAUCE  HERBS	0	0	1
2035	4	FX	EXTRA CAP MUSH	2	2	1
2035	5	CLMND	Can of Lemonade	1	1.7	1
2036	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2036	2	SCH	Small Chicken Hawiian	0	0	1
2036	3	SX	EXTRA PIN	1	0.5	1
2036	4	CFANTA	Can of Fanta	0	0	1
2037	1	2L	2 Large Pizzas	1	19.9	1
2037	2	LVG	Large Vegetarian	0	0	1
2037	3	LVG	Large Vegetarian	0	0	1
2038	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2038	2	SVG	Small Vegetarian	0	0	1
2038	3	NO	No OLIVES	1	0	1
2038	4	SX	EXTRA PIN	1	0.5	1
2039	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2039	2	SSU	Small Supreme	0	0	1
2040	1	2L	2 Large Pizzas	1	19.9	1
2040	2	LSG	Large SanGiorgio	0	0	1
2040	3	LSP	Large Special	0	0	1
2040	4	NO	No OLIVES	1	0	1
2040	5	LX	EXTRA PINE	1	0.7	1
2040	6	LX	EXTRA PRAWNS	1	0.7	1
2040	7	HB	Herb Bread	1	2	1
2041	1	SVG	Small Vegetarian	1	9	1
2041	2	GS	Greek Salad	1	5.5	1
2041	3	SX	EXTRA FR.TOM	1	0.5	1
2042	1	ELA	Entree Lasagna	2	15	1
2042	2	DAPC	Apple Pie with Cream	2	7	1
2042	3	CCOKE	Can of Coke	2	3.4	1
2043	1	CHGR	Grilled Chicken POTATOES ONLY	1	11.7	1
2043	2	CBR	Continental Bread (3 peices)	1	0.54	1
2043	3	DIS	Discount	1	0.0100000000000016	1
2044	1	F	FAM	1	18	1
2044	2	MAR	1/2 MARGHERITA	1	0	1
2044	3	SUP	1/2 SUPREME	1	0	1
2045	1	MLA	Main Lasagna	1	8.55	1
2045	2	DGE	Gelati Cup choc	2	7.2	1
2045	3	COKE	1.25 Ltr Coke	2	6	1
2045	4	2LOJ	2 LITRE ORANGE JUICE	1	4.5	1
2045	5	DFS	Fruit Salad & Ice Cream	1	4.05	1
2045	6	NO	No ice cream	1	0	1
2046	1	PSM	SMALL PICK-UP	1	6.9	1
2046	2	SMA	Small Margherita + pepp	0	0	1
2046	3	LX	EXTRA	1	0.7	1
2047	1	F	FAM	1	18	1
2047	2	MAR	1/2 MARGHERITA	1	0	1
2047	3	VEG	1/2 VEGETARIAN	1	0	1
2048	1	LMA	Large Margherita	1	11.5	1
2048	2	NO	No fresh tomato	1	0	1
2048	3	EFCB	Entree Fettucini Carbonara	1	8	1
2048	4	COKE	1.25 Ltr Coke	1	3	1
2049	1	LSU	Large Supreme	1	13.5	1
2049	2	NO	No SEAFOOD NO OLIVES	1	0	1
2050	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2050	2	SUP	1/2 SUPREME NO HAM	1	0	1
2050	3	HALF	1/2 CHICKEN MILD CHILLI	1	0	1
2051	1	2L	2 Large Pizzas	1	19.9	1
2051	2	LSG	Large SanGiorgio	0	0	1
2051	3	LHW	Large Hawiian	0	0	1
2052	1	FSU	Family Supreme	1	18	1
2052	2	FX	EXTRA HAM,SALAMI,CHEESE+SAUCE	3	3	1
2052	3	GB	Garlic Bread	1	2	1
2052	4	COKE	1.25 Ltr Coke	1	3	1
2053	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2053	2	LVG	Large Vegetarian	0	0	1
2054	1	ELA	Entree Lasagna	1	7.5	1
2054	2	CR	Calzone Rustico	1	10.5	1
2054	3	GB	Garlic Bread	1	2	1
2054	4	2LOJ	2 LITRE ORANGE JUICE	1	5	1
2055	1	LSU	Large Supreme	1	13.5	1
2055	2	NO	No ANCH OLIVES	1	0	1
2055	3	STR	Rump Steak MED	1	13	1
2055	4	CHMS	Mushroom Sauce	1	2	1
2056	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2056	2	VEG	1/2 VEGETARIAN CHILI ON HALF	1	0	1
2056	3	SEA	1/2 SEAFOOD CHILI ON HALF	1	0	1
2057	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2057	2	SAN	1/2 SAN GIORGIO	1	0	1
2057	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2058	1	MSAP	Spaghetti Alla Panna	1	10	1
2058	2	LSE	Large Seafood	1	13.5	1
2058	3	CUT	*******CUTLERY**************	1	0	1
2059	1	MMBO	Macaroni Bolognese	1	9.5	1
2059	2	GB	Garlic Bread	2	4	1
2060	1	2L	2 Large Pizzas	1	19.9	1
2060	2	LHW	Large Hawiian	0	0	1
2060	3	LX	EXTRA  HALF EXTRA CHEESE	1	0.7	1
2060	4	SEA	1/2 SEAFOOD	1	0	1
2060	5	HAW	1/2 HAWAIIN	1	0	1
2060	6	LX	EXTRA PEPPERONI + CHILI	1	0.7	1
2060	7	COKE	1.25 Ltr Coke	1	3	1
2061	1	2L	2 Large Pizzas	1	19.9	1
2061	2	LCH	Large Chicken Hawiian	0	0	1
2061	3	LX	EXTRA CHEESE BACON BBQ	3	2.1	1
2061	4	LSU	Large Supree	0	0	1
2061	5	HALF	1/2 NO ANCH OLIVES	1	0	1
2062	1	FSP	Family Special NO OLIVES	1	17	1
2063	1	LVG	Large Vegetarian	1	12.5	1
2063	2	LX	EXTRA PIN MUSH	2	1.4	1
2063	3	GB	Garlic Bread	1	2	1
2064	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2064	2	MAR	1/2 MARGHERITA CHILI	1	0	1
2064	3	HAW	1/2 HAWAIIN	1	0	1
2064	4	DCOKE	1.25 LTR DIET COKE	0	0	1
2065	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2065	2	MEX	1/2 MEXICAM	1	0	1
2065	3	SPE	1/2 SPECIAL	1	0	1
2065	4	FX	EXTRA PIN ONION	1	1	1
2066	1	LSU	Large Supreme NO C/FOOD	1	13.5	1
2066	2	LX	EXTRA PEPP	1	0.7	1
2066	3	GB	Garlic Bread	1	2	1
2067	1	LSG	Large SanGiorgio	1	13.5	1
2067	2	COKE	1.25 Ltr Coke	1	3	1
2068	1	2L	2 Large Pizzas	1	19.9	1
2068	2	LSG	Large SanGiorgio	0	0	1
2068	3	LSP	Large Special	0	0	1
2068	4	CIGS	Cigarettes ESCORT ULTRA	1	8.4	1
2069	1	2L	2 Large Pizzas	1	19.9	1
2069	2	LMX	Large Mexican	0	0	1
2069	3	LHW	Large Hawiian	0	0	1
2069	4	GB	Garlic Bread	1	2	1
2070	1	LAU	Large Australian	1	12	1
2070	2	EFW	Entree Fried Whiting	1	9	1
2070	3	CHIPS	Chips + TARTEA SAUCE	1	3.5	1
2070	4	DAPG	Apple Pie with Gelati	2	7	1
2071	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2071	2	VEG	1/2 VEGETARIAN	1	0	1
2071	3	FX	EXTRA SALAMI	1	1	1
2071	4	SUP	1/2 SUPREME NO ANCH	1	0	1
2071	5	FX	EXTRA BOTH FR.TOM+GARLIC	1	1	1
2072	1	2L	2 Large Pizzas	1	19.9	1
2072	2	LSP	Large Special	0	0	1
2072	3	LSE	Large Seafood	0	0	1
2073	1	L	LARGE	1	13.5	1
2073	2	VEG	1/2 VEGETARIAN	1	0	1
2073	3	SUP	1/2 SUPREME	1	0	1
2074	1	2S	2 Small Pizzas	1	16.9	1
2074	2	SMX	Small Mexican	0	0	1
2074	3	SCH	Small Chicken Hawiian	0	0	1
2074	4	SX	EXTRA CHICKEN	1	0.5	1
2074	5	GB	Garlic Bread	1	2	1
2074	6	ETAP	Entree Tortelline Alla Panna	1	8	1
2075	1	OKD	Dozen Oysters Kilpatrick	1	14.5	1
2075	2	OKH	1/2 Dozen Oysters Kilpatrick	1	10	1
2075	3	+	+ EX SAUCE	0	0	1
2075	4	MINE	Minestrone Soup	1	4.5	1
2075	5	GS	Greek Salad	1	5.5	1
2075	6	GB	Garlic Bread	1	2	1
2075	7	HB	Herb Bread	1	2	1
2075	8	DIS	Discount	1	-3.8	1
2076	1	CR	Calzone Rustico	1	10.5	1
2076	2	GB	Garlic Bread	1	2	1
2077	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2077	2	LML	Large Meat Lovers	0	0	1
2077	3	CIGS	Cigarettes B+H SPE.FILT.	1	7.6	1
2078	1	L	LARGE	1	13.5	1
2078	2	SPE	1/2 SPECIAL	1	0	1
2078	3	LX	EXTRA FR.TOM MUSHROOM	2	1.4	1
2078	4	VEG	1/2 VEGETARIAN NO PINE	1	0	1
2078	5	LX	EXTRA FR.TOM OLIVES	1	0.7	1
2078	6	LX	EXTRA CHEESE	1	0.7	1
2079	1	MTPU	Tortellini Putanesca	1	9.5	1
2079	2	+	+ PARMISAN CHEESE	0	0	1
2079	3	LHW	Large Hawiian	1	12.5	1
2079	4	GB	Garlic Bread	1	2	1
2079	5	COKE	1.25 Ltr Coke	1	3	1
2080	1	LML	Large Meat Lovers	1	13	1
2080	2	LX	EXTRA ONIONS	1	0.7	1
2081	1	GB	Garlic Bread	1	2	1
2081	2	LSU	Large Supreme NO ANCH MILD CHILLI	1	13.5	1
2082	1	2L	2 Large Pizzas	1	19.9	1
2082	2	LHW	Large Hawiian	0	0	1
2082	3	LX	EXTRA PINE	1	0.7	1
2082	4	L	LARGE PEPP POTATOE OLIVES MUSH FR.TOM	0	0	1
2082	5	COKE	1.25 Ltr Coke	1	3	1
2083	1	2L	2 Large Pizzas	1	19.9	1
2083	2	LSE	Large Seafood	0	0	1
2083	3	LCH	Large Chicken Hawiian	0	0	1
2083	4	MSAP	Spaghetti Alla Panna	1	10	1
2084	1	PC	Prawn Cocktail	1	8	1
2084	2	CHGR	Grilled Chicken	1	13	1
2084	3	GRAVY	Gravy for chicken	1	2	1
2085	1	FMA	Family Margherita	1	15	1
2085	2	CR	Calzone Rustico	1	10.5	1
2086	1	2F	2 Family Pizzas	1	25.9	1
2086	2	FSU	Family Supreme	1	18	1
2086	3	FVG	Family Vegetarian	0	0	1
2086	4	FVG	Family Vegetarian	0	0	1
2087	1	EMAL	Entree Macaroni Alfredo	1	7	1
2087	2	DCC	Cheese Cake STRAWBERRY	1	3.5	1
2087	3	L	LARGE HAM,SALAMI,PINE,MUSH,ONION,BACON	1	13.5	1
2087	4	LX	EXTRA BACON PINE+HERBS	2	1.4	1
2087	5	DAPG	Apple Pie with Gelati	1	3.5	1
2087	6	EGW	Entree Grilled Whiting	1	9	1
2087	7	CHIPS	Chips	1	3.5	1
2088	1	2L	2 Large Pizzas	1	19.9	1
2088	2	LSU	Large Supreme NO PINE	0	0	1
2088	3	LVG	Large Vegetarian	0	0	1
2088	4	LX	EXTRA EGG SAUCE	1	0.7	1
2089	1	L	LARGE	1	13.5	1
2089	2	--	PIN OL CAP MUS SAL	0	0	1
2090	1	MSBO	Spaghetti Bolognese	1	8.55	1
2090	2	DFS	Fruit Salad & Ice Cream	1	4.05	1
2090	3	CBR	Continental Bread (2 peices)	3	1.62	1
2090	4	CUT	*******CUTLERY**************	1	0	1
2091	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2091	2	SPE	1/2 SPECIAL	1	0	1
2091	3	SAN	1/2 SAN GIORGIO	1	0	1
2092	1	F	FAM	1	18	1
2092	2	VEG	1/2 VEGETARIAN	1	0	1
2092	3	NO	No PINE	1	0	1
2092	4	SUP	1/2 SUPREME	1	0	1
2092	5	COKE	1.25 Ltr Coke	1	3	1
2093	1	FSU	Family Supreme	1	18	1
2094	1	PSM	SMALL PICK-UP	1	6.9	1
2094	2	SVG	Small Vegetarian NO PINE	0	0	1
2095	1	LMX	Large Mexican NO ONION	1	13	1
2095	2	LX	EXTRA FR.TOM (AFTER)	1	0.7	1
2095	3	HB	Herb Bread	1	2	1
2096	1	MLA	Main Lasagna	1	9.5	1
2096	2	GB	Garlic Bread	2	4	1
2096	3	SMX	Small Mexican	1	9.5	1
2096	4	SX	EXTRA ANC	1	0.5	1
2096	5	DCOKE	1.25 LTR DIET COKE	1	3	1
2097	1	STMS	Scaloppina Mushroom	1	10.35	1
2097	2	LX	EXTRA SAUCE	1	0.63	1
2097	3	CPG	chicken parmigana	1	12.6	1
2097	4	GB	Garlic Bread	1	1.8	1
2097	5	DIS	Discount	1	0.0199999999999996	1
2098	1	2L	2 Large Pizzas	1	19.9	1
2098	2	LCH	Large Chicken Hawiian	0	0	1
2098	3	HAW	1/2 HAWAIIN	1	0	1
2098	4	MEX	1/2 MEXICAM	1	0	1
2099	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2099	2	FSU	Family Supreme	0	0	1
2099	3	FX	EXTRA anch	1	1	1
2100	1	2L	2 Large Pizzas	1	19.9	1
2100	2	LSU	Large Supreme	0	0	1
2100	3	LSU	Large Supreme ( well done)	0	0	1
2101	1	MFPU	Fettucini Putanesca NO ANCH	1	9.5	1
2101	2	STRMR	Rump Steak - Md Rare	1	13	1
2101	3	CHMS	Mushroom Sauce	1	2	1
2101	4	DFS	Fruit Salad & Ice Cream	1	4.5	1
2102	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2102	2	LVG	Large Vegetarian	0	0	1
2103	1	PSM	SMALL PICK-UP	1	6.9	1
2103	2	SSU	Small Supreme NO ANCH	0	0	1
2104	1	GS	Greek Salad	1	5.5	1
2105	1	LVG	Large Vegetarian	1	12.5	1
2105	2	LX	EXTRA ARTICHOKES FR.TOM,BASIL	2	1.4	1
2106	1	2L	2 Large Pizzas	1	19.9	1
2106	2	LHW	Large Hawiian	0	0	1
2106	3	LHW	Large Hawiian	0	0	1
2106	4	LX	EXTRA MUSHROOMS+OLIVES	2	1.4	1
2107	1	CHAV	Chicken Avocado	1	14	1
2107	2	SVG	Small Vegetarian	1	9	1
2107	3	DCM	Chocolate Mousse	1	3.5	1
2107	4	50	*****$50.00 NOTE*****	1	0	1
2108	1	LSU	Large Supreme	1	13.5	1
2108	2	LX	EXTRA PRAWNS FR.TMO+GARLIC	2	1.4	1
2108	3	LX	EXTRA OLIVES	1	0.7	1
2109	1	S	SMALL	1	9.5	1
2109	2	SHW	Small Hawiian	0	0	1
2110	1	LSP	Large Special	1	12.5	1
2111	1	FMA	Family Margherita	1	15	1
2111	2	FX	EXTRA PEPP	1	1	1
2111	3	CIGS	Cigarettes	1	6.9	1
2111	4	COKE	1.25 Ltr Coke	1	3	1
2112	1	STSH	Schnitzel	1	10.5	1
2112	2	PEPER	PEPPER SAUCE	1	2.8	1
2112	3	GB	Garlic Bread	1	2	1
2112	4	CIGS	Cigarettes MRLB SOFT PACK	1	6.4	1
2112	5	COKE	1.25 Ltr Coke	1	3	1
2113	1	CR	Calzone Rustico	3	31.5	1
2113	2	GB	Garlic Bread	1	2	1
2114	1	2L	2 Large Pizzas	1	19.9	1
2114	2	LML	Large Meat Lovers	0	0	1
2115	1	2F	2 Family Pizzas	1	25.9	1
2115	2	FSU	Family Supreme	0	0	1
2115	3	FSG	Family SanGiorgio	0	0	1
2116	1	DTA	Tartufo	1	3.5	1
2116	2	MRBO	Ravioli Bolognese	1	9.5	1
2116	3	CCOKE	Can of Coke	2	3.4	1
2116	4	CBR	Continental Bread (2 peices)	1	0.6	1
2117	1	2L	2 Large Pizzas	1	19.9	1
2117	2	LSG	Large SanGiorgio	0	0	1
2117	3	LSU	Large Supreme	0	0	1
2117	4	COKE	1.25 Ltr Coke	1	3	1
2118	1	DCC	Cheese Cake	1	3.5	1
2118	2	STVP	Veal Parmigiana	1	14	1
2118	3	NO	No vegetables SALAD INSTEAD	1	0	1
2118	4	CHIPS	Chips	1	3.5	1
2119	1	2L	2 Large Pizzas	1	19.9	1
2119	2	LSG	Large SanGiorgio	0	0	1
2119	3	LVG	Large Vegetarian	0	0	1
2119	4	GB	Garlic Bread	1	2	1
2120	1	MSBO	Spaghetti Bolognese	1	9.5	1
2120	2	MRBO	Ravioli Bolognese	1	9.5	1
2120	3	GB	Garlic Bread	1	2	1
2120	4	COKE	1.25 Ltr Coke	1	3	1
2120	5	CSQSH	Can of Lemon Squash	1	1.7	1
2121	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2121	2	SUP	1/2 SUPREME	1	0	1
2121	3	NO	No ANCH	1	0	1
2121	4	MLO	1/2 MEAT LOVERS	1	0	1
2122	1	SSG	Small SanGiorgio	1	9.5	1
2122	2	SX	EXTRA ANCHOVIE	1	0.5	1
2122	3	EGP	Entree Garlic Prawns	1	10.5	1
2122	4	EFCB	Entree Fettucini Carbonara	1	8	1
2123	1	LSU	Large Supreme	1	13.5	1
2123	2	COKE	1.25 Ltr Coke	1	3	1
2124	1	PLG	LARGE PICK-UP	1	9.9	1
2124	2	LSG	Large SanGiorgio	0	0	1
2124	3	LX	EXTRA ANCH AND MUSH AND CHILLI	2	1.4	1
2125	1	L	LARGE	1	13.5	1
2125	2	HAW	1/2 HAWAIIN	1	0	1
2125	3	SUP	1/2 SUPREME - PIN	1	0	1
2125	4	GB	Garlic Bread	2	4	1
2126	1	CHAV	Chicken Avocado	1	14	1
2126	2	STVP	Veal Parmigiana	1	14	1
2126	3	GB	Garlic Bread	1	2	1
2127	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2127	2	FSP	Family Special	0	0	1
2128	1	PLG	LARGE PICK-UP	1	9.9	1
2128	2	SAN	1/2 SAN GIORGIO	1	0	1
2128	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2129	1	LHW	Large Hawiian	1	12.5	1
2130	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2130	2	FAM	Family American	0	0	1
2130	3	HALF	1/2 + PIN	1	0	1
2131	1	CSTZ	CHICKEN SCHNITZEL WITH VEGETABLES	1	12.6	1
2131	2	NO	No CARROTS	1	0	1
2131	3	DCM	Chocolate Mousse	1	3.15	1
2132	1	EGP	Entree Garlic Prawns	1	10.5	1
2132	2	STD	Steak Dianne	1	15	1
2133	1	LSU	Large Supreme - SEA , PIN	1	13.5	1
2133	2	COKE	1.25 Ltr Coke	1	3	1
2134	1	SVG	Small Vegetarian- OLI	1	9	1
2134	2	GS	Greek Salad - OLI  XTRA ON	1	5.5	1
2134	3	CHAV	Chicken Avocado	1	14	1
2134	4	GB	Garlic Bread	1	2	1
2134	5	COKE	1.25 Ltr Coke	1	3	1
2135	1	L	LARGE	1	13.5	1
2135	2	HAW	1/2 HAWAIIN + PEPP	1	0	1
2135	3	SUP	1/2 SUPREME - PRAWNS	1	0	1
2135	4	COKE	1.25 Ltr Coke	1	3	1
2136	1	SD	Soup of the Day	3	12.15	1
2136	2	CBR	Continental Bread (2 peices)	2	1.08	1
2136	3	CUT	*******CUTLERY**************	1	0	1
2136	4	DIS	Discount	1	0.0199999999999996	1
2137	1	STVP	Veal Parmigiana	1	14	1
2137	2	GB	Garlic Bread	1	2	1
2137	3	COKE	1.25 Ltr Coke	1	3	1
2138	1	MINE	Minestrone Soup	1	4.5	1
2138	2	MGW	Main Grilled Whiting	1	15	1
2138	3	NO	No DRESSING ON SALAD	1	0	1
2139	1	LVG	Large Vegetarian	1	12.5	1
2139	2	COKE	1.25 Ltr Coke	1	3	1
2140	1	LSU	Large Supreme	1	13.5	1
2140	2	L	LARGE PEPP XTRA CHEESE	1	13.5	1
2141	1	2F	2 Family Pizzas	1	25.9	1
2141	2	FAM	Family American	0	0	1
2141	3	FX	EXTRA CHEESE MUS	2	2	1
2141	4	FAU	Family Australian	0	0	1
2141	5	FX	EXTRA CHEESE CHIC PIN MUS	2	2	1
2141	6	DCOKE	1.25 LTR DIET COKE	1	3	1
2142	1	F	FAM	1	18	1
2142	2	HAW	1/2 HAWAIIN	1	0	1
2142	3	SPE	1/2 SPECIAL	1	0	1
2143	1	L	LARGE	1	13.5	1
2143	2	--	PEPP CAP OLI ANC HERBS	0	0	1
2143	3	COKE	1.25 Ltr Coke	1	3	1
2144	1	PLG	LARGE PICK-UP	1	9.9	1
2144	2	LSU	Large Supreme	0	0	1
2145	1	SSP	Small Special	1	8.1	1
2145	2	S	SMALL	1	8.55	1
2145	3	--	PIN ON	0	0	1
2145	4	DFS	Fruit Salad & Ice Cream	1	4.05	1
2145	5	NO	No ICE CREAM	1	0	1
2146	1	PLG	LARGE PICK-UP	1	9.9	1
2146	2	LSG	Large SanGiorgio	0	0	1
2146	3	+	+ CHILLI	0	0	1
2146	4	GB	Garlic Bread	1	2	1
2147	1	L	LARGE PEP OLIVE PINE	1	13.5	1
2147	2	GB	Garlic Bread	1	2	1
2148	1	FSP	Family Special	1	17	1
2148	2	COKE	1.25 Ltr Coke	1	3	1
2149	1	PA	Prawn Avocado	1	10	1
2149	2	STSZ	Scaloppina Zingara	1	11.5	1
2149	3	GB	Garlic Bread	1	2	1
2150	1	2L	2 Large Pizzas	1	19.9	1
2150	2	MAR	1/2 MARGHERITA WITH ANCH	1	0	1
2150	3	HAW	1/2 HAWAIIN	1	0	1
2150	4	LSG	Large SanGiorgio	0	0	1
2151	1	PFM	FAMILY PICK-UP	1	12.9	1
2151	2	FSU	Family Supreme	0	0	1
2151	3	NO	No PINE	1	0	1
2152	1	LCH	Large Chicken Hawiian	1	13	1
2152	2	GB	Garlic Bread	1	2	1
2152	3	COKE	1.25 Ltr Coke	1	3	1
2153	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2153	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2153	3	SEA	1/2 SEAFOOD -ANCH	1	0	1
2154	1	CR	Calzone Rustico	1	10.5	1
2154	2	GB	Garlic Bread	1	2	1
2155	1	PFM	FAMILY PICK-UP	1	12.9	1
2155	2	FSU	Family Supreme -OLI PIN	0	0	1
2156	1	MRNA	Ravioli Napolitana	1	9	1
2156	2	SHW	Small Hawiian	1	9	1
2156	3	COKE	1.25 Ltr Coke	1	3	1
2157	1	LMX	Large Mexican	1	13	1
2157	2	GB	Garlic Bread	1	2	1
2158	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	3	60	1
2158	2	FSU	Family Supreme	0	0	1
2158	3	NO	No ANCH  ON ONE	1	0	1
2159	1	L	LARGE	1	13.5	1
2159	2	LVG	Large Vegetarian	0	0	1
2159	3	LX	EXTRA FETTA 1/2 + SAL	1	0.7	1
2159	4	GB	Garlic Bread	1	2	1
2160	1	L	LARGE	1	13.5	1
2160	2	LX	EXTRA MUS ARTICH SUN	3	2.1	1
2160	3	LX	EXTRA ONI	0	0	1
2160	4	AUS	1/2 AUSTRALIAN + MUS ON	1	0	1
2161	1	2S	2 Small Pizzas	1	16.9	1
2161	2	SSU	Small Supreme	0	0	1
2161	3	SSE	Small Seafood	0	0	1
2162	1	EFAP	Entree Fettucini Alla Panna	1	8	1
2162	2	MSNA	Spaghetti Napolitana	1	9	1
2162	3	GB	Garlic Bread	1	2	1
2163	1	MLA	Main Lasagna	1	9.5	1
2163	2	EFAP	Entree Fettucini Alla Panna	1	8	1
2164	1	LSE	Large Seafood	1	13.5	1
2164	2	LX	EXTRA PINE SAL MUSH	3	2.1	1
2165	1	LHW	Large Hawiian	1	12.5	1
2165	2	LX	EXTRA PEP	1	0.7	1
2166	1	LSU	Large Supreme	1	13.5	1
2166	2	NO	No ANC OLI	1	0	1
2166	3	GB	Garlic Bread	1	2	1
2167	1	LSU	Large Supreme	1	13.5	1
2167	2	NO	No ANCH	1	0	1
2167	3	LX	EXTRAPEP AND CHICK	2	1.4	1
2168	1	PLG	LARGE PICK-UP	1	9.9	1
2168	2	VEG	1/2 VEGETARIAN	1	0	1
2168	3	NO	No CHEESE	1	0	1
2168	4	SPE	1/2 SPECIAL	1	0	1
2168	5	NO	No OLIVES	1	0	1
2168	6	+	+ CHILLI	0	0	1
2169	1	PSM	SMALL PICK-UP	1	6.9	1
2169	2	SSU	Small Supreme	0	0	1
2170	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2170	2	HALF	1/2 CHIK AVOCADO	1	0	1
2170	3	LX	EXTRA FRE TOM	1	0.7	1
2170	4	HAW	1/2 HAWAIIN	1	0	1
2171	1	LAU	Large Australian	1	12	1
2171	2	LX	EXTRA EGG	1	0.7	1
2171	3	COKE	1.25 Ltr Coke	1	3	1
2172	1	+	SM GOURMET MARINARA	1	10	1
2173	1	PSM	SMALL PICK-UP AUSTRALIAN	1	6.9	1
2174	1	2L	2 Large Pizzas	1	19.9	1
2174	2	--	H PIN SAL	1	0	1
2174	3	LSU	Large Supreme -SEAFOOD	0	0	1
2174	4	COKE	1.25 Ltr Coke	1	3	1
2175	1	PFM	FAMILY PICK-UP	1	12.9	1
2175	2	MLO	1/2 MEAT LOVERS	1	0	1
2175	3	HAW	1/2 HAWAIIN	1	0	1
2175	4	LX	EXTRA FRE TOM ON HAWAIIN	1	0.7	1
2176	1	2L	2 Large Pizzas	1	19.9	1
2176	2	LSU	Large Supreme	0	0	1
2176	3	LML	Large Meat Lovers	0	0	1
2176	4	CIGS	Cigarettes WINFIELD BLUE	1	7.6	1
2177	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2177	2	LSU	Large Supreme	0	0	1
2177	3	LX	EXTRA CHEESE AND MILD CHILLI	1	0.7	1
2178	1	LMX	Large Mexican	1	13	1
2178	2	LX	EXTRA MUSH	1	0.7	1
2178	3	ELA	Entree Lasagna	1	7.5	1
2179	1	LSU	Large Supreme -ANCH	1	13.5	1
2179	2	HAW	1/2 HAWAIIN	1	0	1
2179	3	GB	Garlic Bread	1	2	1
2179	4	CSQSH	Can of Lemon Squash	1	1.7	1
2179	5	CLMND	Can of Lemonade	1	1.7	1
2180	1	FSU	Family Supreme	1	18	1
2181	1	2L	2 Large Pizzas	1	19.9	1
2181	2	LSG	Large SanGiorgio	0	0	1
2181	3	MLO	1/2 MEAT LOVERS	1	0	1
2181	4	SUP	1/2 SUPREME	1	0	1
2181	5	COKE	1.25 Ltr Coke	1	3	1
2182	1	L	LARGE HAM CHEESE MUSH	1	12.15	1
2183	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2183	2	S	SMALLHAM MUSHCHICK ONION POTATO FRESH TOMATO	0	0	1
2184	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2184	2	SUP	1/2 SUPREME	1	0	1
2184	3	NO	No ANCH	1	0	1
2184	4	HAW	1/2 HAWAIIN	1	0	1
2184	5	FX	EXTRA ANCH	1	1	1
2185	1	F	FAM	1	18	1
2185	2	HAW	1/2 HAWAIIN	1	0	1
2185	3	FX	EXTRA PINE	1	1	1
2185	4	SPE	1/2 SPECIAL	1	0	1
2185	5	NO	No OLIVES	1	0	1
2186	1	PLG	LARGE PICK-UP	1	9.9	1
2186	2	LSU	Large Supreme	0	0	1
2187	1	LSU	Large Supreme	1	13.5	1
2187	2	GB	Garlic Bread	1	2	1
2188	1	PFM	FAMILY PICK-UP	1	12.9	1
2188	2	FSU	Family Supreme	0	0	1
2188	3	NO	No ANCH OR OLIVE	1	0	1
2188	4	COKE	1.25 Ltr Coke	1	3	1
2189	1	CHF	Chicken Fillets	1	14	1
2189	2	EMVG	Entree Macaroni Vegetarian	1	7	1
2189	3	GB	Garlic Bread	1	2	1
2189	4	COKE	1.25 Ltr Coke	1	3	1
2190	1	LSU	Large Supreme	1	13.5	1
2190	2	LX	EXTRA MUSH	1	0.7	1
2190	3	GB	Garlic Bread	1	2	1
2190	4	50	*****$50.00 NOTE*****	1	0	1
2191	1	F	FAM	1	18	1
2191	2	HAW	1/2 HAWAIIN	1	0	1
2191	3	SUP	1/2 SUPREME	1	0	1
2192	1	DFS	Fruit Salad & Ice Cream	1	4.05	1
2192	2	SHW	Small Hawiian	1	8.1	1
2192	3	SX	EXTRA MUSH AND ANCH	2	0.9	1
2193	1	STVP	Veal Parmigiana	1	14	1
2193	2	GB	Garlic Bread	1	2	1
2193	3	MENU	MENU MENU	0	0	1
2194	1	F	FAM	1	18	1
2194	2	SEA	1/2 SEAFOOD	1	0	1
2194	3	SUP	1/2 SUPREME	1	0	1
2194	4	NO	No ONION	1	0	1
2195	1	MMNA	Macaroni Napolitana	1	9	1
2195	2	GB	Garlic Bread	1	2	1
2195	3	DCC	Cheese Cake	1	3.5	1
2196	1	SSP	Small Special	1	9	1
2196	2	SX	EXTRA ANCH	1	0.5	1
2196	3	EMPU	Entree Macaroni Putanesca	1	7.5	1
2196	4	EFMA	Entree Fettucini Marinara	1	9	1
2197	1	SD	Soup of the Day	1	4.5	1
2197	2	STMS	Scaloppina Mushroom	1	11.5	1
2198	1	FMA	Family Margherita	1	15	1
2199	1	MLA	Main Lasagna	1	9.5	1
2200	1	S	SMALL FRESH TOM OLIVES CAP HAM ANCH	1	9.5	1
2200	2	GB	Garlic Bread	1	2	1
2200	3	CIGS	Cigarettes BH EXTRA MILD	1	7.6	1
2201	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2201	2	VEG	1/2 VEGETARIAN	1	0	1
2201	3	SUP	1/2 SUPREME	1	0	1
2202	1	2L	2 Large Pizzas	1	19.9	1
2202	2	LSG	Large SanGiorgio	0	0	1
2202	3	LX	EXTRA ANCH	1	0.7	1
2202	4	LHW	Large Hawiian	0	0	1
2202	5	MENUY	MENU	0	0	1
2203	1	MSBO	Spaghetti Bolognese	1	9.5	1
2203	2	SCH	Small Chicken Hawiian	1	9.5	1
2204	1	2L	2 Large Pizzas	1	19.9	1
2204	2	LHW	Large Hawiian	0	0	1
2204	3	LSU	Large Supreme	0	0	1
2204	4	COKE	1.25 Ltr Coke	1	3	1
2205	1	PFM	FAMILY PICK-UP	4	51.6	1
2205	2	FHW	Family Hawiian	0	0	1
2205	3	FSU	Family Supreme	0	0	1
2205	4	FVG	Family Vegetarian	0	0	1
2205	5	FHW	Family Hawiian HALF CHILLI	0	0	1
2206	1	OND	Dozen Oysters Natural	1	13	1
2206	2	CFANTA	Can of Fanta	2	3.4	1
2206	3	L	LARGE	1	13.5	1
2206	4	HALF	1/2CHICK MUSH	1	0	1
2206	5	HALF	1/2 SAN GIORGIO	1	0	1
2206	6	DGE	Gelati Cup PIST AND LEMON	1	4	1
2207	1	FSU	Family Supreme	1	18	1
2207	2	NO	No ANCH	1	0	1
2208	1	LSU	Large Supreme	1	13.5	1
2208	2	LX	EXTRA SALAMI	1	0.7	1
2209	1	PLG	LARGE PICK-UP	1	9.9	1
2209	2	LHW	Large Hawiian	0	0	1
2210	1	SSP	Small Special	1	9	1
2210	2	COKE	1.25 Ltr Coke	1	3	1
2210	3	+	+ BOTTLE OF WATER 1.5	1	5	1
2210	4	DGE	Gelati Cup CHOC COF LEMON	1	4	1
2210	5	50	*****$50.00 NOTE*****	1	0	1
2211	1	MMAP	Macaroni Alla Panna	1	10	1
2211	2	MRBO	Ravioli Bolognese	1	9.5	1
2211	3	GB	Garlic Bread	1	2	1
2212	1	2L	2 Large Pizzas	1	19.9	1
2212	2	LSG	Large SanGiorgio	0	0	1
2212	3	LMX	Large Mexican	0	0	1
2213	1	L	LARGE SALAMI,OLIVES +ANCH	1	13.5	1
2213	2	SAM	Small American	1	9	1
2214	1	2L	2 Large Pizzas	1	19.9	1
2214	2	LSU	Large Supreme HALF NO ANCH	0	0	1
2214	3	LSG	Large SanGiorgio	0	0	1
2214	4	COKE	1.25 Ltr Coke	1	3	1
2214	5	+	+ MILK	1	1.5	1
2215	1	2L	2 Large Pizzas	1	19.9	1
2215	2	LSU	Large Supreme	0	0	1
2215	3	NO	No ANCH ON BOTH	0	0	1
2215	4	NO	No OLIVES ON ONE ONLY	1	0	1
2215	5	COKE	1.25 Ltr Coke	1	3	1
2216	1	FSU	Family Supreme - ANC	1	18	1
2216	2	DCOKE	1.25 LTR DIET COKE	1	3	1
2216	3	50	*****$50.00 NOTE*****	1	0	1
2217	1	LHW	Large Hawiian	1	12.5	1
2218	1	CHAV	Chicken Avocado	1	14	1
2218	2	SCH	Small Chicken Hawiian	1	9.5	1
2218	3	BBQ	BBQ Sauce	1	1	1
2218	4	--	+ CHILLI	0	0	1
2218	5	CIGS	Cigarettes WING BLUE	1	7.6	1
2219	1	MFAL	Fettucini Alfredo	1	9	1
2219	2	MLA	Main Lasagna +parmesan	1	9.5	1
2219	3	GB	Garlic Bread	1	2	1
2219	4	CBR	Continental Bread (2 peices)	1	0.6	1
2219	5	DCC	Cheese Cake	2	7	1
2220	1	LMA	Large Margherita	1	11.5	1
2220	2	CCOKE	Can of Coke	1	1.7	1
2220	3	CFANTA	Can of Fanta	1	1.7	1
2220	4	50	*****$50.00 NOTE*****	1	0	1
2221	1	2L	2 Large Pizzas	1	19.9	1
2221	2	LSU	Large Supreme	0	0	1
2221	3	NO	No ANCH ON ONE OF THEM	1	0	1
2222	1	PSM	SMALL PICK-UP	1	6.9	1
2222	2	SHW	Small Hawiian	0	0	1
2223	1	FVG	Family Vegetarian	1	17	1
2223	2	+	+ CHILLI	0	0	1
2224	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2224	2	VEG	1/2 VEGETARIAN	1	0	1
2224	3	SUP	1/2 SUPREME	1	0	1
2224	4	NO	No SEAFOOD OR HAM	1	0	1
2225	1	MFAP	Fettucini Alla Panna	1	10	1
2225	2	SCH	Small Chicken Hawiian	1	9.5	1
2225	3	DCOKE	1.25 LTR DIET COKE	1	3	1
2225	4	CUT	*******CUTLERY**************	1	0	1
2226	1	LVG	Large Vegetarian NO OLIVES	1	12.5	1
2226	2	LX	EXTRA 1/2+CHICKEN	1	0.7	1
2227	1	ECNA	Entree Ricotta Ravioli Napoletana	1	7	1
2227	2	MLA	Main Lasagna	1	9.5	1
2228	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2228	2	LMA	Large Margherita	0	0	1
2228	3	HB	2 Herb Bread	0	0	1
2228	4	NO	No COKE	1	0	1
2229	1	FSG	Family SanGiorgio	1	18	1
2229	2	+	+ CHILLI	0	0	1
2230	1	SMA	Small Margherita	1	8	1
2230	2	SX	EXTRA SAL	1	0.5	1
2230	3	GB	Garlic Bread	1	2	1
2231	1	+	+ GOURMET VEG FAMILY	1	18	1
2231	2	FX	EXTRA HAM	1	1	1
2232	1	2L	2 Large Pizzas	1	19.9	1
2232	2	VEG	1/2 VEGETARIAN	1	0	1
2232	3	HAW	1/2 HAWAIIN	1	0	1
2232	4	SUP	1/2 SUPREME	1	0	1
2232	5	LX	EXTRA ANCH	1	0.7	1
2232	6	MLO	1/2 MEAT LOVERS	1	0	1
2233	1	STDWD	Steak Dianne - Well Done	1	15	1
2233	2	+	+ POTATOES AND SALAD	2	2	1
2234	1	L	LARGE MUSH PEP WELL DONE	1	13.5	1
2234	2	CCOKE	Can of Coke	1	1.7	1
2234	3	GB	Garlic Bread	1	2	1
2235	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2235	2	FVG	Family Vegetarian	0	0	1
2236	1	PLG	LARGE PICK-UP	1	9.9	1
2236	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2236	3	SPE	1/2 SPECIAL	1	0	1
2236	4	NO	No HAM	1	0	1
2237	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2237	2	VEG	1/2 VEGETARIAN	1	0	1
2237	3	NO	NoPINEAPPLE	1	0	1
2237	4	SPE	1/2 SPECIAL	1	0	1
2237	5	LX	EXTRA ANCH ON SPECIAL	1	0.7	1
2238	1	LSU	Large Supreme -SEAFOOD	1	13.5	1
2238	2	ESBO	Entree Spaghetti Bolognese	1	7	1
2238	3	CCOKE	Can of Coke	1	1.7	1
2238	4	+	LARGE BOTTLE SPRING H2O	1	5	1
2239	1	PSM	SMALL PICK-UP	1	6.9	1
2239	2	SHW	Small Hawiian	0	0	1
2240	1	LHW	Large Hawiian	1	12.5	1
2240	2	LX	EXTRA PEPP	1	0.7	1
2240	3	LX	EXTRA CHEESE	1	0.7	1
2240	4	COKE	1.25 Ltr Coke	1	3	1
2241	1	PSM	SMALL PICK-UP	1	6.9	1
2241	2	SSU	Small Supreme	0	0	1
2241	3	NO	No SEAFOOOD	1	0	1
2242	1	FSG	Family SanGiorgio	1	18	1
2243	1	PLG	LARGE PICK-UP	1	9.9	1
2243	2	LVG	Large Vegetarian	0	0	1
2243	3	HALF	1/2 NO PINE OR OLIVES	1	0	1
2244	1	LVG	Large Vegetarian	1	12.5	1
2244	2	NO	No CAP	1	0	1
2244	3	LX	1/2 EXTRA SAL	1	0.7	1
2244	4	CHF	Chicken Fillets	1	14	1
2245	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2245	2	HAW	1/2 HAWAIIN	1	0	1
2245	3	SAN	1/2 SAN GIORGIO	1	0	1
2246	1	LVG	Large Vegetarian - PIN	1	12.5	1
2246	2	LX	EXTRA TOMATO FR TOM	1	0.7	1
2246	3	LX	EXTRA HERBS GARLIC	1	0.7	1
2246	4	LX	EXTRA ANC ART	2	1.4	1
2247	1	OKD	Dozen Oysters Kilpatrick	1	14.5	1
2247	2	--	WELL DONE	0	0	1
2247	3	FCH	Family Chicken Hawiian	1	17.5	1
2247	4	FX	EXTRA CHICKEN	1	1	1
2247	5	FX	EXTRA CHEESE	1	1	1
2247	6	FX	EXTRA BAC SAL	1	1	1
2247	7	FX	EXTRA MU	1	1	1
2248	1	PFM	FAMILY PICK-UP	1	12.9	1
2248	2	SUP	1/2 SUPREME	1	0	1
2248	3	SEA	1/2 SEAFOOD	1	0	1
2248	4	GB	Garlic Bread	1	2	1
2249	1	FSU	Family Supreme - ANC	1	18	1
2249	2	HAW	1/2 HAWAIIN	1	0	1
2250	1	2F	2 Family Pizzas	1	25.9	1
2250	2	FHW	Family Hawiian	0	0	1
2250	3	MEX	1/2 MEXICAM	1	0	1
2250	4	SUP	1/2 SUPREME	1	0	1
2251	1	EFC	Entree Fried Calamari	1	8.5	1
2251	2	DGE	Gelati Cup CHO VAN	1	4	1
2252	1	FSU	Family Supreme	1	18	1
2252	2	HALF	1/2 CHI MUS PIN MUSSELS	1	0	1
2252	3	COKE	1.25 Ltr Coke	1	3	1
2253	1	LMA	Large Margherita	1	11.5	1
2253	2	DCOKE	1.25 LTR DIET COKE	1	3	1
2253	3	GB	Garlic Bread	1	2	1
2254	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2254	2	LSU	Large Supreme - ANC	0	0	1
2255	1	L	LARGE	1	13.5	1
2255	2	LX	EXTRA CHI BAC PIN ON	1	0.7	1
2255	3	LX	EXTRA CHEESE	2	1.4	1
2256	1	CR	Calzone Rustico	1	10.5	1
2256	2	SX	EXTRA ANC	1	0.5	1
2256	3	SSU	Small Supreme - ANC	2	19	1
2256	4	SHW	Small Hawiian	1	9	1
2256	5	SX	EXTRA ON MUS CAP	2	1	1
2256	6	SSP	Small Special - OL	1	9	1
2256	7	SCH	Small Chicken Hawiian	1	9.5	1
2256	8	SVG	Small Vegetarian	1	9	1
2256	9	GB	Garlic Bread	4	8	1
2257	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2257	2	LSG	Large SanGiorgio	0	0	1
2257	3	LX	EXTRA MUSH AND CHICKEN	2	1.4	1
2258	1	PSM	SMALL PICK-UP	1	6.9	1
2258	2	SHW	Small Hawiian	0	0	1
2259	1	LSG	Large SanGiorgio	1	13.5	1
2259	2	EMAP	Entree Macaroni Alla Panna	1	8	1
2259	3	DIS	Discount	1	-23.5	1
2259	4	DIS	Discount	1	13	1
2260	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2260	2	LSG	Large SanGiorgio	0	0	1
2260	3	LX	EXTRA PIN	1	0.7	1
2260	4	DCOKE	1.25 LTR DIET COKE	0	0	1
2261	1	SCH	Small Chicken Hawiian	1	9.5	1
2261	2	SMX	Small Mexican	1	9.5	1
2261	3	GB	Garlic Bread	1	2	1
2261	4	SSU	Small Supreme	1	9.5	1
2262	1	SHW	Small Hawiian	1	9	1
2262	2	SX	EXTRA CAP ONION	1	0.5	1
2262	3	VEGIE	SERVE OF VEGETABLES	1	3.5	1
2263	1	PLG	LARGE PICK-UP	1	9.9	1
2263	2	LSU	Large Supreme	0	0	1
2264	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2264	2	SUP	1/2 SUPREME	1	0	1
2264	3	HAW	1/2 HAWAIIN	1	0	1
2265	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2265	2	SSU	Small Supreme	0	0	1
2266	1	2L	2 Large Pizzas	1	19.9	1
2266	2	LHW	Large Hawiian	0	0	1
2266	3	LSU	Large Supreme	0	0	1
2266	4	NO	No PINE	1	0	1
2266	5	GB	Garlic Bread	1	2	1
2267	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2267	2	SVG	Small Vegetarian	0	0	1
2267	3	NO	No OLIVES EXTRA CHEESE	1	0	1
2268	1	LSU	Large Supreme	1	13.5	1
2268	2	GB	Garlic Bread	1	2	1
2269	1	CBR	Continental Bread (2 peices)	1	0.6	1
2269	2	STF	Fillet Mignon	1	17	1
2269	3	NO	No VEG  WITH SALAD INSTEAD	1	0	1
2270	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2270	2	LSG	Large SanGiorgio	0	0	1
2270	3	DGE	Gelati Cup PIST COF BACI	1	4	1
2271	1	2L	2 Large Pizzas	1	19.9	1
2271	2	LSU	Large Supreme	0	0	1
2271	3	LSP	Large Special	0	0	1
2271	4	LX	EXTRA ANCH	1	0.7	1
2271	5	DEL	$1.00 DEL	0	0	1
2272	1	LMA	Large Margherita	1	11.5	1
2272	2	LX	EXTRA CHEESE	1	0.7	1
2272	3	ETAL	Entree Tortelline Alfredo	1	7	1
2272	4	DCC	Cheese Cake	1	3.5	1
2272	5	CCOKE	Can of Coke	1	1.7	1
2272	6	CLMND	Can of Lemonade	1	1.7	1
2273	1	SSG	Small SanGiorgio	1	9.5	1
2273	2	SX	EXTRA ANCH	1	0.5	1
2273	3	CDIET	CAN OF DIET COKE	1	1.7	1
2274	1	SD	Soup of the Day	1	4.5	1
2274	2	STD	Steak Dianne	1	15	1
2274	3	COKE	1.25 Ltr Coke	2	6	1
2274	4	CIGS	Cigarettes ESC BLUE	1	8.5	1
2275	1	STVP	Veal Parmigiana	1	14	1
2275	2	DAPC	Apple Pie with Cream	1	3.5	1
2276	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2276	2	CHA	1/2 CHICKEN HAWAIIN NO PIN	1	0	1
2276	3	SPE	1/2 SPECIAL	1	0	1
2277	1	CPG	chicken parmigana	1	14	1
2277	2	+	+ CHIPS + SALAD	1.8	1.8	1
2277	3	GB	Garlic Bread	1	2	1
2278	1	LSU	Large Supreme	1	13.5	1
2278	2	HALF	1/2 NO OLIVES	1	0	1
2278	3	HALF	1/2 NO ANCH	1	0	1
2278	4	GB	Garlic Bread	1	2	1
2278	5	COKE	1.25 Ltr Coke	1	3	1
2279	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2279	2	SPE	1/2 SPECIAL	1	0	1
2279	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2279	4	BBQ	BBQ Sauce	1	1	1
2279	5	ETAP	Entree Tortelline Alla Panna	1	8	1
2280	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2280	2	FSP	Family Special	0	0	1
2281	1	STP	Pepper Steak	1	15	1
2281	2	+	+ CHIPS	1.8	1.8	1
2281	3	COKE	1.25 Ltr Coke	1	3	1
2281	4	50	*****$50.00 NOTE*****	1	0	1
2282	1	2L	2 Large Pizzas	1	19.9	1
2282	2	LSU	Large Supreme	0	0	1
2282	3	LSE	Large Seafood	0	0	1
2282	4	GB	Garlic Bread	2	4	1
2282	5	COKE	1.25 Ltr Coke	2	6	1
2282	6	DEL	$1.00	0	0	1
2282	7	50	*****$50.00 NOTE*****	1	0	1
2283	1	SMA	Small Margherita	1	8	1
2283	2	GS	Greek Salad	1	5.5	1
2283	3	EFAP	Entree Fettucini Alla Panna	1	8	1
2283	4	NO	No HAM	1	0	1
2283	5	DCM	Chocolate Mousse	1	3.5	1
2283	6	DAPG	Apple Pie with Gelati	1	3.5	1
2283	7	COKE	1.25 Ltr Coke	1	3	1
2283	8	GB	Garlic Bread	1	2	1
2284	1	LSU	Large Supreme	1	13.5	1
2285	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2285	2	FSU	Family Supreme	0	0	1
2285	3	NO	No ANCH BUT EXTRA OLIVES ON ONE HALF INSTEAD	1	0	1
2286	1	CHCS	Chef's Salad	1	13	1
2286	2	GB	Garlic Bread	1	2	1
2286	3	DBF	Black Forrest Cake	1	4	1
2287	1	CHF	Chicken Fillets	1	14	1
2287	2	GB	Garlic Bread	1	2	1
2288	1	PLG	LARGE PICK-UP	1	9.9	1
2288	2	LMX	Large Mexican NO OLIVES NO ONION	0	0	1
2289	1	LVG	Large Vegetarian	1	12.5	1
2289	2	LX	EXTRA SUN DRIED TOM	1	0.7	1
2289	3	LX	EXTRA ARTICHOKES	1	0.7	1
2289	4	LX	EXTRA FETT CHEESE	1	0.7	1
2289	5	GB	Garlic Bread	1	2	1
2290	1	ONH	1/2 Dozen Oysters Natural	1	8.5	1
2290	2	MINE	Minestrone Soup	1	4.5	1
2290	3	MSMA	Spaghetti Marinara	1	11.5	1
2291	1	LMX	Large Mexican	1	13	1
2291	2	HAW	1/2 HAWAIIN	1	0	1
2291	3	GB	Garlic Bread	1	2	1
2291	4	COKE	1.25 Ltr Coke	1	3	1
2292	1	LSU	Large Supreme	1	13.5	1
2292	2	MLO	1/2 MEAT LOVERS	1	0	1
2292	3	GB	Garlic Bread	1	2	1
2293	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2293	2	LCH	Large Chicken Hawiian	0	0	1
2294	1	STMS	Scaloppina Mushroom	2	20.7	1
2294	2	GB	Garlic Bread	1	1.8	1
2294	3	COKE	1.25 Ltr Coke	1	3	1
2295	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2295	2	F	FAM HAM PIN MUS SAL	0	0	1
2295	3	FX	EXTRA OLIVE 1/2 ON CAP	1	1	1
2296	1	LSU	Large Supreme - ANC	1	13.5	1
2296	2	GB	Garlic Bread	1	2	1
2297	1	LMA	Large Margherita	1	11.5	1
2297	2	LX	EXTRA TOPPINGS ANC	2	1.4	1
2298	1	MLA	Main Lasagna	1	9.5	1
2298	2	MRAP	Ravioli Alla Panna	1	10	1
2298	3	GB	Garlic Bread	1	2	1
2298	4	COKE	1.25 Ltr Coke	1	3	1
2299	1	LVG	Large Vegetarian	1	12.5	1
2299	2	LX	EXTRA OLIVES	1	0.7	1
2299	3	COKE	1.25 Ltr Coke	1	3	1
2299	4	DCM	Chocolate Mousse	2	3.5	1
2300	1	LSU	Large Supreme	1	13.5	1
2300	2	NO	No ANCH	1	0	1
2301	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2301	2	LVG	Large Vegetarian	0	0	1
2301	3	50	*****$50.00 NOTE*****	1	0	1
2302	1	FML	Family Meat Lovers	1	17.5	1
2302	2	HALF	1/2 ONI,BAC,HAM ,PIN	1	0	1
2303	1	FVG	Family Vegetarian	1	17	1
2303	2	DLGE	large gelati cup BACI/PIS	1	6	1
2304	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2304	2	LSU	Large Supreme	0	0	1
2304	3	LX	EXTRA CHICKEN	1	0.7	1
2305	1	FSU	Family Supreme - ANC	1	18	1
2305	2	HAW	1/2 HAWAIIN	1	0	1
2305	3	COKE	1.25 Ltr Coke	1	3	1
2306	1	SHW	Small Hawiian	1	9	1
2306	2	ERNA	Entree Ravioli Napoletana	1	7	1
2306	3	COKE	1.25 Ltr Coke	1	3	1
2307	1	MGP	Main Garlic Prawns	1	16.5	1
2307	2	NO	No VEG PLUS SOUCE	1	0	1
2307	3	CIGS	Cigarettes MARL.LIGHT	1	8	1
2307	4	DIS	Discount	1	-1.6	1
2308	2	--	HAM PEPP	0	0	1
2308	3	LX	EXTRA pepp	1	0.7	1
2309	1	DGE	Gelati Cup mix - lem	1	3.6	1
2309	2	DGE	Gelati Cup choc	1	3.6	1
2309	3	CPG	chicken parmigana	1	12.6	1
2309	4	+	+ potato only	0	0	1
2310	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2310	2	HALF	1/2 san	1	0	1
2310	3	HALF	1/2lot	1	0	1
2311	1	STDMW	Steak Dianne - Md Well Done	1	13.5	1
2311	2	CHAS	Chicken Asparagus	2	25.2	1
2311	3	CR	Calzone Rustico	1	9.45	1
2311	4	EFC	Entree Fried Calamari	1	7.65	1
2311	5	DGE	Gelati Cup choc	1	3.6	1
2311	6	MFAP	Fettucini Alla Panna	1	9	1
2311	7	FS	French Salad	1	3.6	1
2311	8	VEGIE	SERVE OF VEGETABLES	1	3.15	1
2311	9	CUT	*******CUTLERY**************	1	0	1
2311	10	DIS	Discount	1	-0.150000000000006	1
2312	1	L	LARGE	1	13.5	1
2312	2	SUP	1/2 SUPREME	1	0	1
2312	3	SEA	1/2 SEAFOOD	1	0	1
2312	4	GB	Garlic Bread	1	2	1
2313	1	LSG	Large SanGiorgio	1	13.5	1
2313	2	HB	Herb Bread	2	4	1
2314	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2314	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2314	3	VEG	1/2 VEGETARIAN	1	0	1
2314	4	+	LIGHTER	1	1.5	1
2315	1	LMA	Large Margherita	1	11.5	1
2315	2	NO	No FR TOM	1	0	1
2315	3	CHIPS	Chips	1	3.5	1
2315	4	CIGS	Cigarettes B& H SP FILTER	2	15.2	1
2316	1	FVG	Family Vegetarian	4	68	1
2316	2	COKE	1.25 Ltr Coke	3	9	1
2316	3	DIS	Discount FRINGE WORKERS	1	-17	1
2317	1	LSU	Large Supreme	1	13.5	1
2318	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2318	2	LSU	Large Supreme	0	0	1
2318	3	LX	EXTRA CHEESE	1	0.7	1
2318	4	+	+ LITTLE CHILLI	1	1	1
2318	5	DGE	Gelati Cup LEMON, COFFEE	1	4	1
2319	1	2S	2 Small Pizzas	1	16.9	1
2319	2	SSG	Small SanGiorgio	0	0	1
2319	3	SHW	Small Hawiian	0	0	1
2319	4	MSBO	Spaghetti Bolognese	1	9.5	1
2320	1	STSH	Schnitzel	1	10.5	1
2320	2	COKE	1.25 Ltr Coke	1	3	1
2321	1	SCP	Small Capriciosa	1	9	1
2321	2	GB	Garlic Bread	1	2	1
2321	3	GS	Greek Salad	1	5.5	1
2322	1	FSP	Family Special	1	17	1
2322	2	COKE	1.25 Ltr Coke	1	3	1
2323	1	L	LARGE THIN	1	13.5	1
2323	2	SAN	1/2 SAN GIORGIO	1	0	1
2323	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2323	4	COKE	1.25 Ltr Coke	1	3	1
2324	1	PLG	LARGE PICK-UP	1	9.9	1
2324	2	LSE	Large Seafood	0	0	1
2324	3	NO	No CHEESE BUT WITH MUSH	1	0	1
2324	4	LX	EXTRA CAPSI UM	1	0.7	1
2325	1	MINE	Minestrone Soup	1	4.5	1
2325	2	MLA	Main Lasagna	1	9.5	1
2325	3	GS	Greek Salad	1	5.5	1
2325	4	GB	Garlic Bread	1	2	1
2326	1	2L	2 Large Pizzas	1	19.9	1
2326	2	LMX	Large Mexican	0	0	1
2326	3	LSU	Large Supreme	0	0	1
2327	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2327	2	LSU	Large Supreme	0	0	1
2327	3	NO	No PINE	0	0	1
2328	1	2S	2 Small Pizzas	1	16.9	1
2328	2	S	SMALL HAM SALAMI OLIVES	0	0	1
2328	3	SSU	Small Supreme	0	0	1
2328	4	+	+ CHILI HERBS GARLIC	0	0	1
2328	5	CCOKE	Can of Coke	2	3.4	1
2329	1	PSM	SMALL PICK-UP	1	6.9	1
2329	2	SML	Small Meat Lovers	0	0	1
2330	1	MLA	Main Lasagna	2	19	1
2330	2	GB	Garlic Bread	1	2	1
2331	1	STFWD	Fillet Mignon - Well Done	2	34	1
2332	1	ELA	Entree Lasagna	1	7.5	1
2332	2	MSBO	Spaghetti Bolognese	1	9.5	1
2332	3	GB	Garlic Bread	1	2	1
2332	4	COKE	1.25 Ltr Coke	1	3	1
2333	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2333	2	LHW	Large Hawiian	0	0	1
2334	1	CHF	Chicken Fillets	1	14	1
2334	2	CHMS	Mushroom Sauce IN SEPERATE CONTAINER	1	2	1
2335	1	LMA	Large Margherita	1	11.5	1
2335	2	LX	EXTRA OLIVES PEP ANCH	3	2.1	1
2335	3	HB	Herb Bread	1	2	1
2336	1	SSU	Small Supreme	1	9.5	1
2336	2	NO	No PINE	1	0	1
2336	3	+	+ MILD CHILLI	0	0	1
2336	4	COKE	1.25 Ltr Coke	1	3	1
2337	1	L	LARGE	1	13.5	1
2337	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2337	3	SEA	1/2 SEAFOOD	1	0	1
2337	4	LX	EXTRA MUSGH ON SEAFOOD	1	0.7	1
2338	1	L	LARGE PEP	1	13.5	1
2338	2	GB	Garlic Bread	1	2	1
2338	3	COKE	1.25 Ltr Coke	1	3	1
2338	4	SERVIETTES	SERVIETTES NAPKINS SERVIETTES	0	0	1
2339	1	2S	2 Small Pizzas	1	16.9	1
2339	2	SCH	Small Chicken Hawiian	0	0	1
2339	3	SSU	Small Supreme	0	0	1
2339	4	DTA	Tartufo	2	7	1
2339	5	DCA	Cassata	2	7	1
2340	1	SML	Small Meat Lovers	1	9.5	1
2340	2	MRBO	Ravioli Bolognese	1	9.5	1
2340	3	+	+ CHILLI	0	0	1
2341	1	PLG	LARGE PICK-UP	1	9.9	1
2341	2	LSG	Large SanGiorgio	0	0	1
2342	1	L	LARGE	1	13.5	1
2342	2	HALF	1/2 PEP ONION	1	0	1
2342	3	SUP	1/2 SUPREME	1	0	1
2342	4	NO	No ANCH OR PINE ON SUP	1	0	1
2342	5	ELA	Entree Lasagna	1	7.5	1
2342	6	GB	Garlic Bread	1	2	1
2343	1	F	FAM HAM,PINE MUSH+PRAWNS	1	18	1
2343	2	GB	Garlic Bread	2	4	1
2344	1	L	LARGE	1	13.5	1
2344	2	VEG	1/2 VEGETARIAN	1	0	1
2344	3	NO	No PINE	1	0	1
2344	4	+	+ ART AND SUN DRY TOM	1	1.5	1
2344	5	VEG	1/2 VEGETARIAN	1	0	1
2344	6	LX	EXTRA SAL AND PEP	2	1.4	1
2344	7	LX	EXTRA MUSH	1	0.7	1
2345	1	GB	Garlic Bread	2	4	1
2346	1	FHW	Family Hawiian	1	16.5	1
2346	2	FSP	Family Special	1	17	1
2346	3	DIS	Discount	1	-13.5	1
2347	1	FSU	Family Supreme	1	18	1
2347	2	GB	Garlic Bread	1	2	1
2347	3	COKE	1.25 Ltr Coke	1	3	1
2348	1	SSU	Small Supreme	1	9.5	1
2348	2	+	+ MAC TOMATO BACON ONION MUSH	1	10	1
2348	3	COKE	1.25 Ltr Coke	1	3	1
2349	1	PLG	LARGE PICK-UP	1	9.9	1
2349	2	LSU	Large Supreme	0	0	1
2350	1	F	FAM OLIVES,SALAMI,MUSH,ONION,PINE+1/2 ANCH	1	18	1
2351	1	PLG	LARGE PICK-UP SPECIAL	1	9.9	1
2351	2	DIS	Discount	1	-2.9	1
2352	1	L	LARGE	1	13.5	1
2352	2	HALF	1/2 CHICK WITH BBQ SAUCE	1	0	1
2352	3	SUP	1/2 SUPREME	1	0	1
2352	4	GB	Garlic Bread	1	2	1
2352	5	HB	Herb Bread	1	2	1
2353	1	2L	2 Large Pizzas	1	19.9	1
2353	2	LSE	Large Seafood	0	0	1
2353	3	LCH	Large Chicken Hawiian	0	0	1
2353	4	GB	Garlic Bread	1	2	1
2354	1	CR	Calzone Rustico	0.75	10.5	1
2354	2	DGE	Gelati Cup CHOC	1	4	1
2354	3	GB	Garlic Bread	1	2	1
2354	4	MTAP	Tortellini Alla Panna	1	10	1
2354	5	DGE	Gelati Cup BACI	1	4	1
2355	1	FSU	Family Supreme NO OLIVES NO ANCH	1	18	1
2356	1	PLG	LARGE PICK-UP	1	9.9	1
2356	2	LSU	Large Supreme	0	0	1
2357	1	STSH	Schnitzel	1	9.45	1
2357	2	CHMS	Mushroom Sauce	1	1.8	1
2357	3	DGE	Gelati CupCHOC	1	3.6	1
2358	1	LHW	Large Hawiian	1	12.5	1
2358	2	LX	EXTRA PEP	1	0.7	1
2358	3	CIGS	Cigarettes PETER STUYV'S	1	6.9	1
2359	1	PLG	LARGE PICK-UP	1	9.9	1
2359	2	LHW	Large Hawiian	0	0	1
2359	3	LX	EXTRA CAPS+ONION	2	1.4	1
2360	1	2F	2 Family Pizzas	1	25.9	1
2360	2	FSU	Family Supreme	0	0	1
2360	3	FVG	Family Vegetarian	0	0	1
2360	4	FX	EXTRA PRAWNS	1	1	1
2360	5	CHIN	BOTTLE OF CHINOTTO	1	3.5	1
2361	1	PLG	LARGE PICK-UP	1	9.9	1
2361	2	HALF	1/2 CHICK CAP OLIVES	1	0	1
2361	3	HALF	1/2 MARGARETA WITH SALAMI	1	0	1
2362	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2362	2	SUP	1/2 SUPREME	1	0	1
2362	3	NO	No anch or olives	1	0	1
2362	4	MLO	1/2 MEAT LOVERS with mushrooms	1	0	1
2363	1	PLG	LARGE PICK-UP	1	9.9	1
2363	2	SPE	1/2 SPECIAL no olives	1	0	1
2363	3	HAW	1/2 HAWAIIN	1	0	1
2364	1	MFC	Main Fried Calamari	2	27	1
2364	2	GB	Garlic Bread	1	2	1
2364	3	GS	Greek Salad	1	5.5	1
2364	4	COKE	1.25 Ltr Coke	1	3	1
2364	5	50	*****$50.00 NOTE*****	1	0	1
2366	1	L	LARGE	1	13.5	1
2366	2	SUP	1/2 SUPREME	1	0	1
2366	3	NO	No ANCH	1	0	1
2366	4	MAR	1/2 MARGHERITA WITH PEP	1	0	1
2367	1	MFAP	Fettucini Alla Panna	1	10	1
2367	2	GB	Garlic Bread	1	2	1
2368	1	STD	Steak Dianne MED	1	15	1
2368	2	GB	Garlic Bread	1	2	1
2369	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2369	2	MEX	1/2 MEXICAM	1	0	1
2369	3	VEG	1/2 VEGETARIAN	1	0	1
2370	1	CHAV	Chicken Avocado	1	14	1
2370	2	GB	Garlic Bread	1	2	1
2371	1	L	LARGE GOURMET POLLO	1	13.5	1
2371	2	SX	EXTRA FOR GOURMET	1	0.5	1
2371	3	MIN	BOTTLE OF M/W	1	3.5	1
2372	1	2L	2 Large Pizzas	1	19.9	1
2372	2	LSU	Large Supreme	0	0	1
2373	1	PSM	SMALL PICK-UP	1	6.9	1
2373	2	SHW	Small Hawiian	0	0	1
2374	1	2S	2 Small Pizzas	1	16.9	1
2374	2	SMX	Small Mexican	0	0	1
2374	3	SSU	Small Supreme	0	0	1
2375	1	PLG	LARGE PICK-UP	1	9.9	1
2375	2	L	LARGE HAM PEPPERONI  EXTRA PEPPERONI	0	0	1
2376	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2376	2	SVG	Small Vegetarian	0	0	1
2376	3	NO	NoOLIVES EXTRA CHEESE	1	0	1
2377	1	2S	2 Small Pizzas	1	16.9	1
2377	2	SHW	Small Hawiian	0	0	1
2377	3	SMX	Small Mexican	0	0	1
2377	4	SSG	Small SanGiorgio	1	9.5	1
2377	5	GB	Garlic Bread	2	4	1
2377	6	COKE	1.25 Ltr Coke	1	3	1
2378	1	LSU	Large Supreme	1	13.5	1
2378	2	GB	Garlic Bread	1	2	1
2379	1	2L	2 Large Pizzas	1	19.9	1
2379	2	LCH	Large Chicken Hawiian	0	0	1
2379	3	LMX	Large Mexican	0	0	1
2380	1	2L	2 Large Pizzas	1	19.9	1
2380	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2380	3	VEG	1/2 VEGETARIAN	1	0	1
2380	4	HAW	1/2 HAWAIIN	1	0	1
2380	5	SUP	1/2 SUPREME	1	0	1
2380	6	NO	No ANCH	1	0	1
2380	7	GB	Garlic Bread	2	4	1
2381	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2381	2	SVG	Small Vegetarian	0	0	1
2381	3	NO	No OLIVE BUT WITH EX PINE	1	0	1
2382	1	FS	French Salad	1	3.6	1
2382	2	NO	No ONION	1	0	1
2382	3	HB	Herb Bread	1	1.8	1
2382	4	+	+ 1.5 BOTTLE WATER	2	10	1
2382	5	CCOKE	Can of Coke	1	1.7	1
2382	6	MSBO	Spaghetti Bolognese	1	8.55	1
2383	1	2L	2 Large Pizzas	1	19.9	1
2383	2	LSU	Large Supreme - ANC OLI	0	0	1
2383	3	LSP	Large Special - OLI	0	0	1
2383	4	LX	EXTRA ONION	1	0.7	1
2383	5	GB	Garlic Bread	1	2	1
2384	1	EMAL	Entree Macaroni Alfredo	1	7	1
2384	2	FX	EXTRA MUS	1	1	1
2384	3	L	LARGE	1	13.5	1
2384	4	VEG	1/2 VEGETARIAN - PIN	1	0	1
2384	5	LX	EXTRA FR TOMATO	1	0.7	1
2384	6	HALF	1/2 PR MUS SAL ONI CAP	1	0	1
2384	7	LX	EXTRA FR TOMAT	1	0.7	1
2385	1	F	FAM	1	18	1
2385	2	VEG	1/2 VEGETARIAN	1	0	1
2385	3	SUP	1/2 SUPREME	1	0	1
2385	4	NO	No ANCH	1	0	1
2386	1	MLA	Main Lasagna	1	9.5	1
2386	2	+	+ MARINARA SAUCE ON TOP	2	2	1
2386	3	GS	Greek Salad	1	5.5	1
2387	1	L	LARGE	1	13.5	1
2387	2	SEA	1/2 SEAFOOD	1	0	1
2387	3	HALF	1/2 CHICK ONION F TOM OLIVES OREGANO	1	0	1
2387	4	COKE	1.25 Ltr Coke	1	3	1
2388	1	STSH	Schnitzel - VEAL + CHICKEN	1	9.45	1
2388	2	+	+   - SALAD + VEG - CARROTS	0	0	1
2388	3	DFS	Fruit Salad & Ice Cream	1	4.05	1
2389	1	2S	2 Small Pizzas	1	16.9	1
2389	2	SMA	Small Margherita	0	0	1
2389	3	SMA	Small Margherita	0	0	1
2389	4	SX	EXTRA OLIVES	1	0.5	1
2390	1	MGP	Main Garlic Prawns	1	16.5	1
2390	2	DCC	Cheese Cake STR	1	3.5	1
2391	1	F	FAM MUSH ONION CAP OLIVES	1	18	1
2391	2	HALF	1/2 ADD HAM SALAMI	1	0	1
2392	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2392	2	LMX	Large Mexican	0	0	1
2392	3	LX	EXTRA BACON AND CHICKEN AND EXTRA CHEESE	3	2.1	1
2393	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2393	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2393	3	MEX	1/2 MEXICAM	1	0	1
2394	1	EFAL	Entree Fettucini Alfredo	3	21	1
2394	2	EFCB	Entree Fettucini CarbonaraQ	1	8	1
2394	3	MLA	Main Lasagna	1	9.5	1
2395	1	CHF	Chicken Fillets	1	14	1
2395	2	GB	Garlic Bread	1	2	1
2396	1	F	FAM HAM CAP MUSH ONION FRESH TOM LITTLE SAL	1	18	1
2397	1	PSM	SMALL PICK-UP	1	6.9	1
2397	2	SMX	Small Mexican NO OLIVES	0	0	1
2398	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2398	2	HALF	1/2 SAN.G	1	0	1
2398	3	SUP	1/2 SUPREME NO ANCH	1	0	1
2399	1	MFC	Main Fried Calamari	1	13.5	1
2399	2	+	+ SALAD IN SEPERATE CONTAINER	1	1	1
2399	3	+	+ EXTRA SALAD	1	1	1
2399	4	DGE	Gelati Cup VANILLA CHOC	1	4	1
2399	5	50	*****$50.00 NOTE*****	1	0	1
2400	1	S	SMALL CONTINENTAL	1	9.5	1
2400	2	GB	Garlic Bread	1	2	1
2401	1	MSCB	Spaghetti Carbonara	1	10	1
2401	2	MFPU	Fettucini Putanesca	1	9.5	1
2401	3	NO	No CAPERS	1	0	1
2401	4	+	+ MUSH  OLIVES ANCH MILD CHILLI GARLIC	3	3	1
2401	5	GB	Garlic Bread	2	4	1
2402	1	PSM	SMALL PICK-UP	1	6.9	1
2402	2	MAR	1/2 MARGHERITA	1	0	1
2402	3	SPE	1/2 SPECIAL	1	0	1
2403	1	2L	2 Large Pizzas	1	19.9	1
2403	2	LMA	Large MargheritaPLUS GARLIC	0	0	1
2403	3	LSU	Large Supreme PLUS GARLIC	0	0	1
2404	1	PLG	LARGE PICK-UP	1	9.9	1
2404	2	LML	Large Meat Lovers	0	0	1
2404	3	LX	EXTRA CAPS	1	0.7	1
2405	1	MGP	Main Garlic Prawns	1	16.5	1
2406	1	PLG	LARGE PICK-UP PEPPERONI AND MUSH	1	9.9	1
2407	1	LHW	Large Hawiian	1	12.5	1
2407	2	COKE	1.25 Ltr Coke	1	3	1
2408	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2408	2	FAM	Family American	0	0	1
2409	1	PC	Prawn Cocktail	5	40	1
2410	1	S	SMALL GOURMET POLLO	1	9.5	1
2410	2	S	SMALL GOURMET MARINARA	1	9.5	1
2410	3	PC	Prawn Cocktail	1	8	1
2410	4	SX	EXTRA FOR GOURMET	2	1	1
2411	1	LSU	Large Supreme	1	13.5	1
2411	2	GB	Garlic Bread	1	2	1
2411	3	LX	EXTRA ANCH PINE CHILLI	2	1.4	1
2412	1	PLG	LARGE PICK-UP	1	9.9	1
2412	2	LML	Large Meat Lovers	0	0	1
2413	1	FVG	Family Vegetarian	1	17	1
2413	2	FX	EXTRA ANCH AND POTATO	2	2	1
2413	3	+	+ DRY CHILLI IN SEPERATE CONTAINER	0	0	1
2413	4	COKE	1.25 Ltr Coke	1	3	1
2414	1	PSM	SMALL PICK-UP	1	6.9	1
2414	2	SCH	Small Chicken Hawiian	0	0	1
2415	1	2F	2 Family Pizzas	1	25.9	1
2415	2	FSU	Family Supreme	0	0	1
2415	3	NO	No ANCH	1	0	1
2415	4	FVG	Family Vegetarian	0	0	1
2415	5	FX	EXTRA PRAWNS ANCHMUSSELS ON VEG	3	3	1
2416	1	L	LARGE	1	13.5	1
2416	2	HAW	1/2 HAWAIIN	1	0	1
2416	3	MAR	1/2 MARGHERITA	1	0	1
2416	4	+	+ CHILLI	0	0	1
2416	5	CDIET	CAN OF DIET COKE	2	3.4	1
2417	1	LSU	Large Supreme NO PINE	1	13.5	1
2417	2	DGE	Gelati Cup BACI	1	4	1
2418	1	L	LARGE	1	13.5	1
2418	2	--	OLIVE PEPP	0	0	1
2418	3	CDIET	CAN OF DIET COKE	1	1.7	1
2418	4	L	LARGE	1	13.5	1
2418	5	--	HAM MUS ON	0	0	1
2419	1	LCP	Large Capriciosa	1	12.5	1
2419	2	LMX	Large Mexican	1	13	1
2420	1	LSU	Large Supreme	1	13.5	1
2420	2	LCH	Large Chicken Hawiian	1	13	1
2420	3	GB	Garlic Bread	1	2	1
2420	4	COKE	1.25 Ltr Coke	1	3	1
2421	1	2L	2 Large Pizzas	1	19.9	1
2421	2	LSU	Large Supreme NO ANCH	0	0	1
2421	3	LX	EXTRA CHICKEN	1	0.7	1
2421	4	LSU	Large Supreme NO ANCH	0	0	1
2421	5	LX	EXTRA CHICKEN	1	0.7	1
2422	1	MSMA	Spaghetti Marinara	1	11.5	1
2422	2	GB	Garlic Bread	1	2	1
2422	3	COKE	1.25 Ltr Coke	1	3	1
2423	1	2F	2 Family Pizzas	1	25.9	1
2423	2	FVG	Family Vegetarian	0	0	1
2423	3	FX	EXTRA SUN DRIED TOM	1	1	1
2423	4	FX	EXTRA ARTICHOKES	1	1	1
2423	5	FX	EXTRA FRESH TOM	1	1	1
2423	6	FSE	Family Seafood	0	0	1
2423	7	CIGS	Cigarettes	1	8	1
2423	8	50	*****$50.00 NOTE*****	1	0	1
2423	9	DIS	Discount	0	0	1
2423	10	DIS	Discount	0	0	1
2423	11	DIS	Discount	1	-0.799999999999997	1
2424	1	L	LARGE	1	13.5	1
2424	2	+L	PEPPERONI CAP ONION	0	0	1
2425	1	MRAP	Ravioli Alla Panna	1	10	1
2425	2	MMAP	Macaroni Alla Panna	1	10	1
2425	3	MRNA	Ravioli Napolitana	1	9	1
2425	4	GB	Garlic Bread	2	4	1
2426	1	PLG	LARGE PICK-UP	1	9.9	1
2426	2	LSU	Large Supreme NO ANCH	0	0	1
2427	1	MSMA	Spaghetti Marinara	1	11.5	1
2427	2	GB	Garlic Bread	1	2	1
2428	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2428	2	SUP	1/2 SUPREME	1	0	1
2428	3	CHA	1/2 CHICKEN HAWAIIN + BBQ	1	0	1
2428	4	LX	EXTRA	1	0.7	1
2429	1	PFM	FAMILY PICK-UP	1	12.9	1
2429	2	FSP	Family Special	0	0	1
2430	1	L	LARGE	1	13.5	1
2430	2	+	+ CHICK OLIVES F/TOM	1	1	1
2430	3	+	+ ONION	0	0	1
2430	4	MSMA	Spaghetti Marinara	1	11.5	1
2431	1	STP	Pepper Steak	1	13.5	1
2431	2	WATR	1.25 Ltr Water	1	5	1
2432	1	FSU	Family Supreme	1	18	1
2433	1	STSH	Schnitzel	2	21	1
2434	1	SD	Soup of the Day	2	8.1	1
2434	2	CBR	Continental Bread (2 peices)	2	1.08	1
2434	3	CUT	*******CUTLERY**************	1	0	1
2434	4	DIS	Discount	1	0.0199999999999996	1
2435	1	MLA	Main Lasagna	1	9.5	1
2435	2	MRNA	Ravioli Napolitana	1	9	1
2435	3	DCOKE	1.25 LTR DIET COKE	1	3	1
2436	1	MGP	Main Garlic Prawns	1	16.5	1
2436	2	CLMND	Can of Lemonade	1	1.7	1
2436	3	CIGS	Cigarettes DUNHILL BLUE	0	7.6	1
2437	1	LSU	Large Supreme	1	13.5	1
2437	2	GB	Garlic Bread	1	2	1
2438	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2438	2	SSU	Small Supreme NO ANCH	0	0	1
2438	3	STSH	Schnitzel	1	10.5	1
2438	4	CHMS	Mushroom Sauce	1	2	1
2439	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2439	2	LSG	Large SanGiorgio NO OLIVES	0	0	1
2440	1	PSM	SMALL PICK-UP	1	6.9	1
2440	2	SVG	Small Vegetarian -CAPS -OLIVES	0	0	1
2440	3	SX	EXTRA OLIVES	1	0.5	1
2440	4	PSM	SMALL PICK-UP	1	6.9	1
2440	5	SML	Small Meat Lovers	0	0	1
2441	1	L	LARGE	1	13.5	1
2441	2	VEG	1/2 VEGETARIAN	1	0	1
2441	3	HALF	1/2 F/TOM CHICKEN	1	0	1
2441	4	LX	EXTRA SUN DRIED TOM	1	0.7	1
2441	5	+	+ GARLIC BASIL	0	0	1
2442	1	LCH	Large Chicken Hawiian	1	11.7	1
2442	2	LX	EXTRA BBQ	1	0.63	1
2442	3	COKE	1.25 Ltr Coke	1	3	1
2442	4	DIS	Discount	1	0.0700000000000003	1
2443	1	PC	Prawn Cocktail	2	16	1
2444	1	2L	2 Large Pizzas	1	19.9	1
2444	2	L	LARGE CHICK+MUSH	0	0	1
2444	3	LSE	Large Seafood	0	0	1
2445	1	STF	Fillet Mignon	1	17	1
2445	2	NO	No VEGETABLES + SALAD	1	0	1
2446	1	2L	2 Large Pizzas	1	19.9	1
2446	2	LSG	Large SanGiorgio	0	0	1
2446	3	LMX	Large Mexican	0	0	1
2447	1	LSU	Large Supreme	1	13.5	1
2447	2	NO	No ANC	1	0	1
2447	3	LX	EXTRA CHICKEN	1	0.7	1
2447	4	GB	Garlic Bread	1	2	1
2448	1	2F	2 Family Pizzas	1	25.9	1
2448	2	FSU	Family Supreme	0	0	1
2448	3	HAW	1/2 HAWAIIN	1	0	1
2448	4	HALF	1/2 MEATLOVERS	1	0	1
2448	5	GB	Garlic Bread	1	2	1
2449	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2449	2	LSU	Large Supreme NO ANCH	0	0	1
2450	1	PFM	FAMILY PICK-UP	1	12.9	1
2450	2	FSU	Family Supreme - PIN	0	0	1
2451	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2451	2	LVG	Large Vegetarian	0	0	1
2452	1	SML	Small Meat Lovers	1	9.5	1
2452	2	DCC	Cheese Cake	1	3.5	1
2453	1	PSM	SMALL PICK-UP	1	6.9	1
2453	2	SVG	Small Vegetarian	0	0	1
2454	1	PSM	SMALL PICK-UP	1	6.9	1
2454	2	SHW	Small Hawiian	0	0	1
2455	1	FSU	Family Supreme	1	18	1
2455	2	--	1/2 NO ANC OLI	0	0	1
2455	3	--	1/2 NO OLI PIN	0	0	1
2455	4	CIGS	Cigarettes ESC RED	1	8.6	1
2456	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2456	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2456	3	NO	No PIN + ONION	1	0	1
2456	4	CAP	1/2 CAPRICIOSA	1	0	1
2456	5	LX	EXTRA	1	0.7	1
2457	1	FHW	Family Hawiian	1	16.5	1
2457	2	FX	EXTRA CHIC	1	1	1
2457	3	50	*****$50.00 NOTE*****	1	0	1
2458	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2458	2	LML	Large Meat Lovers	0	0	1
2459	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2459	2	SUP	1/2 SUPREME NO OLIVE NO ANCH	1	0	1
2459	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2459	4	GB	Garlic Bread	0	0	1
2459	5	COKE	1.25 Ltr Coke	0	0	1
2459	6	DEL	$1.00 DELIVERY	0	0	1
2459	7	50	*****$50.00 NOTE*****	1	0	1
2460	1	STR	Rump Steak	1	13	1
2460	2	CHMS	Mushroom Sauce	1	2	1
2460	3	MGP	Main Garlic Prawns	1	16.5	1
2460	4	GB	Garlic Bread	1	2	1
2460	5	GS	Greek Salad	1	5.5	1
2460	6	DELI	$1.00 DELIVERY	0	0	1
2461	1	PFM	FAMILY PICK-UP	1	12.9	1
2461	2	FSU	Family Supreme NO ANCH NO ONION	0	0	1
2461	3	DCOKE	1.25 LTR DIET COKE	2	6	1
2462	1	SHW	Small Hawiian	1	9	1
2463	1	PLG	LARGE PICK-UP	1	9.9	1
2463	2	LSU	Large Supreme	0	0	1
2463	3	+	FILLET STEAK + MUS SAUCE	1	15	1
2464	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2464	2	L	LARGE F/MUSH F/TOM ONION	0	0	1
2464	3	LX	EXTRA OLIVES SALAMI ON TOP	1	0.7	1
2465	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2465	2	LSU	Large Supreme NO PIN	0	0	1
2465	3	LX	EXTRA CHICKEN	1	0.7	1
2466	1	PFM	FAMILY PICK-UP	1	12.9	1
2466	2	FSU	Family Supreme	0	0	1
2466	3	FX	EXTRA CHICK	1	1	1
2467	1	+	SALTIMBOCA ALA ROMANA	1	14	1
2467	2	S	SMALL SAL OLI ANC	1	9.5	1
2467	3	SX	EXTRA CHEESE CHILLIE	1	0.5	1
2468	1	SSG	Small SanGiorgio	1	8.55	1
2468	2	CIGS	Cigarettes ESC BLUE	1	8.6	1
2468	3	DIS	Discount	1	0.0500000000000007	1
2469	1	STVP	Veal Parmigiana	1	14	1
2469	2	GB	Garlic Bread	1	2	1
2470	1	F	FAM	1	18	1
2470	2	SUP	1/2 SUPREME - ANC	1	0	1
2470	3	HAW	1/2 HAWAIIN	1	0	1
2470	4	COKE	1.25 Ltr Coke	1	3	1
2471	1	FCH	Family Chicken Hawiian	1	17.5	1
2472	1	STSH	Schnitzel + CHIPS	1	10.5	1
2472	2	GRAVY	Gravy for chicken	1	2	1
2472	3	STSH	Schnitzel + CHIPS	1	10.5	1
2472	4	GRAVY	Gravy for chicken SEPARATE	1	2	1
2472	5	FS	French Salad	1	4	1
2472	6	DIS	Discount	1	-11.5	1
2472	7	CIGS	Cigarette EsCORT BLUE	0	8.6	1
2472	8	DIS	Discount	1	8.6	1
2473	1	FHW	Family Hawiian	1	16.5	1
2474	1	2F	2 Family Pizzas	1	25.9	1
2474	2	F	FAM PEPPERONI + CHILI	0	0	1
2474	3	FVG	Family Vegetarian	0	0	1
2475	1	SSG	Small SanGiorgio	1	8.55	1
2475	2	STR	Rump Steak + CHIPS ONLY	1	11.7	1
2475	3	CHMS	Mushroom Sauce	1	1.8	1
2475	4	GB	Garlic Bread	1	1.8	1
2476	1	LCH	Large Chicken Hawiian	1	13	1
2476	2	LX	EXTRA BBQ	1	0.7	1
2476	3	MLA	Main Lasagna	1	9.5	1
2476	4	+	+ PARM CHEESE ON TOP	0	0	1
2476	5	CUT	*******CUTLERY**************	1	0	1
2477	1	L	LARGE	1	13.5	1
2477	2	VEG	1/2 VEGETARIAN	1	0	1
2477	3	HALF	1/2 HAM CHEESE TOM MUSH	1	0	1
2477	4	GB	Garlic Bread	1	2	1
2478	1	MFP	Main Fried Prawns  WITH CHIPS INSTEAD SALAD	1	16	1
2479	1	2F	2 Family Pizzas	1	25.9	1
2479	2	F	FAM PEPP EXTRA PEP	0	0	1
2479	3	MAR	1/2 MARGHERITA	1	0	1
2479	4	VEG	1/2 VEGETARIAN	1	0	1
2479	5	FX	EXTRA PEPPERONI ON THE FIRST PIZZA	1	1	1
2480	1	FSG	Family SanGiorgio PLUS CHILLI	1	18	1
2480	2	NO	No OLIVES ON THREE QUARTERS OF IT	1	0	1
2480	3	COKE	1.25 Ltr Coke	1	3	1
2481	1	ELA	Entree Lasagna	1	7.5	1
2481	2	VEGIE	SERVE OF VEGETABLES	1	3.5	1
2481	3	COKE	1.25 Ltr Coke	1	3	1
2481	4	50	*****$50.00 NOTE*****	1	0	1
2482	1	LSU	Large Supreme	1	13.5	1
2482	2	NO	No SEAFOOD	1	0	1
2482	3	NO	No PINE	1	0	1
2483	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2483	2	CAP	1/2 CAPRICIOSA	1	0	1
2483	3	VEG	1/2 VEGETARIAN	1	0	1
2484	1	PFM	FAMILY PICK-UP CAP MUSH	1	12.9	1
2484	2	HALF	1/2 WITH PEP	1	0	1
2485	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2485	2	LSU	Large Supreme	0	0	1
2485	3	NO	No PINE	1	0	1
2486	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2486	2	FMA	Family Margherita	0	0	1
2487	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2487	2	LSU	Large Supreme	0	0	1
2487	3	NO	No SEAFOOD	1	0	1
2488	1	MTVG	Tortellini Vegetarian	1	9.5	1
2488	2	GB	Garlic Bread	1	2	1
2489	1	CHGR	Grilled Chicken	1	11.7	1
2490	1	2F	2 Family Pizzas	1	25.9	1
2490	2	FMA	Family Margherita EXTRA GARLI	0	0	1
2490	3	FVG	Family Vegetarian	0	0	1
2490	4	FX	EXTRA SUN DRY TOM AND FETTA ON VEG	2	2	1
2491	1	LSG	Large SanGiorgio	1	13.5	1
2491	2	STVP	Veal Parmigiana	1	14	1
2492	1	MSNA	Spaghetti Napolitana	1	9	1
2492	2	+	+ BASIL	0	0	1
2492	3	GB	Garlic Bread	1	2	1
2493	1	STR	Rump Steak	1	13	1
2494	1	MLA	Main Lasagna	1	9.5	1
2495	1	2F	2 Family Pizzas	1	25.9	1
2495	2	FVG	Family Vegetarian	0	0	1
2495	3	FX	EXTRA SDRY TOM AND FETTA AND ANCH	3	3	1
2495	4	FSG	Family SanGiorgio	0	0	1
2496	1	STSH	Schnitzel	2	21	1
2496	2	CUT	*******CUTLERY**************	1	0	1
2497	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2497	2	FSU	Family Supreme	0	0	1
2497	3	NO	No SEAFOOD EXTRA CAP ONION	1	0	1
2497	4	FX	EXTRA PEP	1	1	1
2498	1	MLA	Main Lasagna	1	9.5	1
2499	1	LSU	Large Supreme	1	13.5	1
2499	2	NO	No SEAFOOD	1	0	1
2499	3	LX	EXTRA OLIVES AND MUSH	1	0.7	1
2499	4	GB	Garlic Bread	1	2	1
2500	1	2L	2 Large Pizzas	1	19.9	1
2500	2	LCH	Large Chicken Hawiian	0	0	1
2500	3	L	LARGE MUSH PRAWNS HAM	0	0	1
2500	4	LCH	Large Chicken Hawiian	1	13	1
2500	5	LX	EXTRA ANCH	1	0.7	1
2500	6	GB	Garlic Bread	1	2	1
2501	1	STVP	Veal Parmigiana	1	12.6	1
2501	2	PC	Prawn Cocktail	1	7.2	1
2501	3	STVP	Veal Parmigiana	1	12.6	1
2501	4	NO	No VEAL WITH CHICKEN INSTEAD	1	0	1
2501	5	NO	No VEG WITH POTATO ONLY	1	0	1
2501	6	COKE	1.25 Ltr Coke	1	3	1
2501	7	GB	Garlic Bread	2	3.6	1
2502	1	2L	2 Large Pizzas	1	19.9	1
2502	2	LSG	Large SanGiorgio	0	0	1
2502	3	LMX	Large Mexican	0	0	1
2502	4	CHIN	BOTTLE OF CHINOTTO	1	3.5	1
2503	1	2F	2 Family Pizzas	1	25.9	1
2503	2	2F	2 Family Pizzas	1	25.9	1
2503	3	FSU	Family Supreme	0	0	1
2503	4	FVG	Family Vegetarian	0	0	1
2503	5	FSE	Family Seafood	0	0	1
2504	1	CSTZ	CHICKEN SCHNITZEL WITH VEGETABLES	1	12.6	1
2504	2	S	SMALL CHEESE PINE ONION	1	8.55	1
2504	3	MSBO	Spaghetti Bolognese	1	8.55	1
2504	4	CBR	Continental Bread (2 peices)	1	0.54	1
2504	5	DIS	Discount	1	-0.0399999999999991	1
2504	6	CUT	*******CUTLERY**************	1	0	1
2505	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2505	2	FSU	Family Supreme	0	0	1
2505	3	NO	No ANCH	1	0	1
2506	1	2L	2 Large Pizzas	1	19.9	1
2506	2	LHW	Large Hawiian	0	0	1
2506	3	LSU	Large Supreme	0	0	1
2506	4	FS	French Salad	1	4	1
2506	5	+	+ DRESSING ON THE SIDE	0	0	1
2506	6	LX	EXTRA PINE ON BOTH	2	1.4	1
2507	1	MFCB	Fettucini Carbonara	1	10	1
2507	2	MFPU	Fettucini Putanesca	1	9.5	1
2507	3	FS	French Salad	2	8	1
2508	1	CHGR	Grilled Chicken	1	13	1
2508	2	NO	No DRESSING	1	0	1
2508	3	COKE	1.25 Ltr Coke	1	3	1
2508	4	DCC	Cheese Cake	1	3.5	1
2508	5	CIGS	Cigarettes ESC RED	1	8.6	1
2508	6	DBF	Black Forrest Cake	1	4	1
2509	1	F	FAM	1	18	1
2509	2	--	HAM MUS PEPP XTRA CHEESE	0	0	1
2509	3	GB	Garlic Bread	1	2	1
2509	4	COKE	1.25 Ltr Coke	1	3	1
2509	5	DIS	Discount	1	-3	1
2510	1	LSG	Large SanGiorgio	1	13.5	1
2510	2	DAPG	Apple Pie with Gelati	1	3.5	1
2511	1	FCH	Family Chicken Hawiian	1	17.5	1
2511	2	GB	Garlic Bread	2	4	1
2512	1	PSM	SMALL PICK-UP MUSH AND ANCH	1	6.9	1
2512	2	CDIET	CAN OF DIET COKE	1	1.7	1
2513	1	L	LARGE	1	13.5	1
2513	2	MAR	1/2 MARGHERITA	0	0	1
2513	3	VEG	1/2 VEGETARIAN	1	0	1
2513	4	LX	EXTRA CHICK ON VEG	1	0.7	1
2514	1	OKH	1/2 Dozen Oysters Kilpatrick	1	10	1
2514	2	SCH	Small Chicken Hawiian	1	9.5	1
2514	3	+	+ CHILLI	1	1	1
2514	4	BBQ	BBQ Sauce	1	1	1
2514	5	CHAV	Chicken Avocado	1	14	1
2515	1	MFAP	Fettucini Alla Panna	1	10	1
2515	2	MSMA	Spaghetti Marinara	1	11.5	1
2515	3	GB	Garlic Bread	1	2	1
2516	1	F	FAM	1	18	1
2516	2	VEG	1/2 VEGETARIAN WITH OREGANO	1	0	1
2516	3	VEG	1/2 VEGETARIAN  WITH HAM SALAMI	1	0	1
2516	4	CIGS	Cigarettes MARL SUPER	1	6.9	1
2517	1	PLG	LARGE PICK-UP VEG	1	9.9	1
2517	2	LX	EXTRA SEAFOOD	2	1.4	1
2518	1	MRNA	Ravioli Napolitana	1	9	1
2518	2	COKE	1.25 Ltr Coke	2	6	1
2518	3	ECNA	Entree Ricotta Ravioli Napoletana	1	7	1
2519	1	FVG	Family Vegetarian	1	17	1
2520	1	F	FAM	1	18	1
2520	2	SUP	1/2 SUPREME - ANC	1	0	1
2520	3	SAN	1/2 SAN GIORGIO	1	0	1
2520	4	GB	Garlic Bread	1	2	1
2520	5	COKE	1.25 Ltr Coke	1	3	1
2521	1	FVG	Family Vegetarian - PIN	1	17	1
2521	2	FX	EXTRA FR TOM	1	1	1
2521	3	-- 1	1/2 CHILLI AND PRAWNS	1	0	1
2521	4	FX	EXTRA	1	1	1
2522	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2522	2	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2522	3	BBQ	BBQ Sauce	1	1	1
2522	4	SUP	1/2 SUPREME - ANC	1	0	1
2523	1	CHF	Chicken Fillets	1	14	1
2523	2	GB	Garlic Bread	1	2	1
2523	3	CCOKE	Can of Coke	1	1.7	1
2523	4	DFS	Fruit Salad & Ice Cream	1	4.5	1
2524	1	MRCB	Ravioli Carbonara	1	10	1
2524	2	FCH	Family Chicken Hawiian	1	17.5	1
2524	3	GB	Garlic Bread	2	4	1
2525	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2525	2	MAR	1/2 MARGHERITA	1	0	1
2525	3	VEG	1/2 VEGETARIAN - OLI	1	0	1
2526	1	DBF	Black Forrest Cake	1	3.6	1
2526	2	MFC	Main Fried Calamari	1	12.15	1
2526	3	SSG	Small SanGiorgio	1	8.55	1
2527	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2527	2	SAN	1/2 SAN GIORGIO	1	0	1
2527	3	CHA	1/2 CHICKEN HAWAIIN	1	0	1
2527	4	FX	EXTRA MUSH	1	1	1
2528	1	MFC	Main Fried Calamari WITH LEMON AND SAUCE	1	13.5	1
2528	2	GB	Garlic Bread	1	2	1
2528	3	COKE	1.25 Ltr Coke	1	3	1
2529	1	S	SMALL GOURMET VEG	1	9.5	1
2530	1	FMA	Family Margherita	1	15	1
2530	2	COKE	1.25 Ltr Coke	1	3	1
2531	1	PLG	LARGE PICK-UP	1	9.9	1
2531	2	--	1/2 CHIC FR TOMAT	0	0	1
2531	3	LX	1/2 CHICKEN + VEG	3	2.1	1
2532	1	ELA	Entree Lasagna	1	7.5	1
2532	2	GB	Garlic Bread	1	2	1
2532	3	PSM	SMALL PICK-UP	1	6.9	1
2532	4	SSU	Small Supreme	0	0	1
2533	1	+	LG 1/2 GOURMET VEG	1	14	1
2533	2	MLO	1/2 MEAT LOVERS	1	0	1
2534	1	FSU	Family Supreme	1	18	1
2534	2	COKE	1.25 Ltr Coke	1	3	1
2535	1	SSU	Small Supreme	1	9.5	1
2535	2	NO	No PIN PR ANC	1	0	1
2536	1	MFCB	Fettucini Carbonara	1	10	1
2536	2	ESMA	Entree Spaghetti Marinara	1	9	1
2537	1	LSG	Large SanGiorgio	1	13.5	1
2537	2	LX	EXTRA PEPP	1	0.7	1
2538	1	PLG	LARGE PICK-UP	1	9.9	1
2538	2	LHW	Large Hawiian	0	0	1
2539	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2539	2	LSU	Large Supreme no anch	0	0	1
2539	3	LX	EXTRA pepperoni chicken	2	1.4	1
2540	1	PFM	FAMILY PICK-UP	1	12.9	1
2540	2	HALF	1/2 meatlovers	1	0	1
2540	3	HALF	1/2 lot no anch	1	0	1
2540	4	GB	Garlic Bread	1	2	1
2541	1	2F	2 Family Pizzas	1	25.9	1
2541	2	FVG	Family Vegetarian	0	0	1
2541	3	FSE	Family Seafood	0	0	1
2541	4	GB	Garlic Bread	2	4	1
2541	5	SHW	Small Hawiian	1	9	1
2542	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2542	2	HAW	1/2 HAWAIIN`	1	0	1
2542	3	SAN	1/2 SAN GIORGIO	1	0	1
2542	4	+	+ chili all over light cheese	0	0	1
2543	1	STMS	Scaloppina Mushroom	1	11.5	1
2543	2	FS	French Salad	1	4	1
2544	1	F	FAM	1	18	1
2544	2	SUP	1/2 SUPREME	1	0	1
2544	3	AUS	1/2 AUSTRALIAN	1	0	1
2544	4	GB	Garlic Bread	1	2	1
2545	1	2L	2 Large Pizzas	1	19.9	1
2545	2	LSE	Large Seafood	0	0	1
2545	3	LMX	Large Mexican	0	0	1
2546	1	FSP	Family Special	1	17	1
2547	1	STVP	Veal Parmigiana	1	14	1
2547	2	CHAV	Chicken Avocado	1	14	1
2548	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2548	2	FSU	Family Supreme NO PIN	0	0	1
2548	3	FX	EXTRA CHEESE	1	1	1
2549	1	MTBO	Tortellini Bolognese	2	19	1
2549	2	GB	Garlic Bread	2	4	1
2549	3	COKE	1.25 Ltr Coke	1	3	1
2550	1	PFM	FAMILY PICK-UP	1	12.9	1
2550	2	FHW	Family Hawiian	0	0	1
2551	1	STVP	Veal Parmigiana	1	14	1
2551	2	+	+ CHIPS ONLY	0	0	1
2551	3	CIGS	Cigarettes B& H XTRA MILD	1	7.6	1
2552	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2552	2	LSG	Large SanGiorgio	0	0	1
2553	1	PFM	FAMILY PICK-UP	1	12.9	1
2553	2	FSU	Family Supreme NO OLIVES NO ANCH	0	0	1
2554	1	PLG	LARGE PICK-UP	1	9.9	1
2554	2	LSP	Large Special NO OLIVES	0	0	1
2555	1	FSU	Family Supreme	1	18	1
2555	2	HALF	1/2 NO ANCH	1	0	1
2555	3	GB	Garlic Bread	1	2	1
2556	1	2F	2 Family Pizzas	1	25.9	1
2556	2	FVG	Family Vegetarian	0	0	1
2556	3	HAW	1/2 HAWAIIN	1	0	1
2556	4	SUP	1/2 SUPREME NO ANCH	1	0	1
2557	1	SPC	Small Pizza, 1 Can Coke	1	10	1
2557	2	SSP	Small Special	0	0	1
2557	3	NO	No OLIVES + CHILI	1	0	1
2557	4	GB	Garlic Bread	2	4	1
2558	1	EFNA	Entree Fettucini Napoletana	1	7	1
2558	2	MFPU	Fettucini Putanesca	1	9.5	1
2559	1	STSH	Schnitzel	1	10.5	1
2559	2	+	+ VEGIES NO SALAD	0	0	1
2559	3	SD	Soup of the Day	1	4.5	1
2560	1	PLG	LARGE PICK-UP	1	9.9	1
2560	2	VEG	1/2 VEGETARIAN	1	0	1
2560	3	MLO	1/2 MEAT LOVERS	1	0	1
2561	1	FSU	Family Supreme	1	18	1
2562	1	PSM	SMALL PICK-UP	1	6.9	1
2562	2	SVG	Small Vegetarian NO OLIVES	0	0	1
2563	1	MSBO	Spaghetti Bolognese	1	9.5	1
2563	2	GS	Greek Salad	1	5.5	1
2563	3	CLMND	Can of Lemonade	2	3.4	1
2564	1	PFM	FAMILY PICK-UP	1	12.9	1
2564	2	FSU	Family Supreme	0	0	1
2565	1	CHAS	Chicken Asparagus	1	12.6	1
2565	2	GB	Garlic Bread	1	1.8	1
2566	1	STSZ	Scaloppina Zingara	1	11.5	1
2566	2	SD	Soup of the Day	1	4.5	1
2566	3	CLMND	Can of Lemonade	1	1.7	1
2567	1	CHF	Chicken Fillets	1	14	1
2567	2	MCVG	Ricotta Ravioli Vegetarian	1	9.5	1
2567	3	GB	Garlic Bread	1	2	1
2568	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2568	2	LHW	Large Hawiian	0	0	1
2569	1	L	LARGE	1	13.5	1
2569	2	HALF	1/2 CHICK HAW	1	0	1
2569	3	LX	EXTRA BARBECUE SAUCE CHILLI	1	0.7	1
2569	4	MAR	1/2 MARGHERITA	1	0	1
2569	5	GB	Garlic Bread	1	2	1
2570	1	LHW	Large Hawiian	1	12.5	1
2570	2	LX	EXTRA PEPP	1	0.7	1
2570	3	COKE	1.25 Ltr Coke	1	3	1
2571	1	GB	Garlic Bread	1	2	1
2572	1	2F	2 Family Pizzas	1	25.9	1
2572	2	FSU	Family Supreme NO ANCH	0	0	1
2572	3	FMA	Family Margherita	0	0	1
2573	1	PSM	SMALL PICK-UP	1	6.9	1
2573	2	SAU	Small Australian	0	0	1
2574	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2574	2	FSU	Family Supreme	0	0	1
2574	3	FX	EXTRA OLI	1	1	1
2575	1	STSH	Schnitzel	1	9.45	1
2575	2	DIS	Discount	1	0.0500000000000007	1
2576	1	STSH	Schnitzel SALT+PEPPER	1	9.45	1
2576	2	SPC	Small Pizza, 1 Can Coke	1	10	1
2576	3	SHW	Small Hawiian	0	0	1
2576	4	SX	EXTRA MUSH+HERBS	1	0.45	1
2576	5	DTA	Tartufo	1	3.15	1
2577	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2577	2	LHW	Large Hawiian	0	0	1
2578	1	SSU	Small Supreme NO C/FOOD NO PINE	1	9.5	1
2578	2	SX	EXTRA PEPPERONI	1	0.5	1
2579	1	L	LARGE	1	13.5	1
2579	2	HALF	1/2 CHICK HAW	1	0	1
2579	3	SUP	1/2 SUPREME	1	0	1
2579	4	GB	Garlic Bread	1	2	1
2580	1	2L	2 Large Pizzas	1	19.9	1
2580	2	L	LARGE MUSH+CHEESE	0	0	1
2580	3	LSU	Large Supreme	0	0	1
2581	1	MGP	Main Garlic Prawns	1	16.5	1
2581	2	MINE	Minestrone Soup	1	4.5	1
2582	1	2L	2 Large Pizzas	1	19.9	1
2582	2	LSG	Large SanGiorgio	0	0	1
2582	3	LMA	Large Margherita	0	0	1
2582	4	LX	EXTRA ANCH AND CHILI	1	0.7	1
2583	1	EFAP	Entree Fettucini Alla Panna	1	7.2	1
2583	2	GB	Garlic Bread	2	3.6	1
2584	1	LSG	Large SanGiorgio	1	13.5	1
2584	2	NO	No OLIVES	1	0	1
2584	3	COKE	1.25 Ltr Coke	1	3	1
2584	4	CIGS	Cigarettes LONGBEACH SUPER MD.	0	9.7	1
2585	1	FHW	Family Hawiian	1	16.5	1
2585	2	GB	Garlic Bread	1	2	1
2586	1	L	LARGE	1	13.5	1
2586	2	SUP	1/2 SUPREME NO OLIVES NO ANCH	1	0	1
2586	3	HALF	1/2 CHICK HAW	1	0	1
2586	4	LX	EXTRA CHICK	1	0.7	1
2586	5	DIS	Discount	1	0.800000000000001	1
2587	1	FSU	Family Supreme	1	18	1
2588	1	MFP	Main Fried Prawns	1	16	1
2588	2	MSMA	Spaghetti Marinara	1	11.5	1
2588	3	ETAP	Entree Tortelline Alla Panna	1	8	1
2589	1	FCH	Family Chicken Hawiian	1	17.5	1
2589	2	COKE	1.25 Ltr Coke	1	3	1
2590	1	LSG	Large SanGiorgio	1	13.5	1
2590	2	HALF	1/2 SEA FOOD	1	0	1
2590	3	CCOKE	Can of Coke	2	3.4	1
2590	4	50	*****$50.00 NOTE*****	1	0	1
2591	1	2L	2 Large Pizzas	1	19.9	1
2591	2	LMA	Large Margherit PLAS GARLICa	0	0	1
2591	3	LSU	Large Supreme	0	0	1
2591	4	LX	EXTRA  ANCH	1	0.7	1
2592	1	2L	2 Large Pizzas	1	19.9	1
2592	2	LHW	Large Hawiian	0	0	1
2592	3	LSE	Large Seafood NO ANCH	0	0	1
2592	4	COKE	1.25 Ltr Coke	1	3	1
2592	5	GB	Garlic Bread	1	2	1
2593	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2593	2	LVG	Large Vegetarian	0	0	1
2594	1	F	FAM	1	18	1
2594	2	HAW	1/2 HAWAIIN	1	0	1
2594	3	MEX	1/2 MEXICAM	1	0	1
2594	4	FX	EXTRA PIN	0.5	0.5	1
2594	5	OKD	Dozen Oysters Kilpatrick	1	14.5	1
2595	1	CHGR	Grilled Chicken	1	13	1
2595	2	GB	Garlic Bread	1	2	1
2595	3	CHIPS	Chips	1	3.5	1
2595	4	GS	Greek Salad	1	5.5	1
2595	5	DCM	Chocolate Mousse	1	3.5	1
2596	1	LSU	Large Supreme	1	13.5	1
2596	2	NO	No PIN	1	0	1
2596	3	LX	EXTRA CHEESE	1	0.7	1
2596	4	HALF	1/2 + ANC	1	0	1
2596	5	GB	Garlic Bread	1	2	1
2597	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2597	2	F	MUSH,BAC,,PEP,EGS	0	0	1
2597	3	FX	EXTRA	2	2	1
2597	4	100	****$100.00 NOTE*****	1	0	1
2598	1	LSP	Large Special	1	11.25	1
2598	2	CCOKE	Can of Coke	1	1.7	1
2599	1	F	FAM	1	18	1
2599	2	SUP	1/2 SUPREME NO ANCH	1	0	1
2599	3	HAW	1/2 HAWAIIN	1	0	1
2600	1	PFM	FAMILY PICK-UP	2	25.8	1
2600	2	FCH	Family Chicken Hawiian	0	0	1
2600	3	FSU	Family Supreme	0	0	1
2601	1	EFBO	Entree Fettucini Bolognese	1	6.3	1
2601	2	SX	EXTRA CHEESE	1	0.45	1
2601	3	GB	Garlic Bread	1	1.8	1
2601	4	CR	Calzone Rustico	1	9.45	1
2601	5	--	HAM MUS PIN CAP ON SAL	0	0	1
2601	6	COKE	1.25 Ltr Coke	1	3	1
2602	1	2L	2 Large Pizzas	1	19.9	1
2602	2	LSU	Large Supreme BOTH NO C/FOOD	0	0	1
2603	1	2L	2 Large Pizzas	1	19.9	1
2603	2	LSE	Large Seafood	0	0	1
2603	3	HALF	1/2MEX	1	0	1
2603	4	LX	EXTRA ANCH	1	0.7	1
2603	5	LSU	Large Supreme	0	0	1
2603	6	HALF	1/ 2 HAWAII	1	0	1
2603	7	LX	EXTRA ANCH	1	0.7	1
2603	8	OND	Dozen Oysters Natural	1	13	1
2604	1	2F	2 Family Pizzas	1	25.9	1
2604	2	FSU	Family Supreme	0	0	1
2604	3	FX	EXTRA BOTH FR.TOM	2	2	1
2605	1	PLG	LARGE PICK-UP	1	9.9	1
2605	2	L	LARGE HAM,MUSH,ONION,CHICK,POTATO+FR.TOM	0	0	1
2605	3	LX	EXTRA POTATO	1	0.7	1
2605	4	GB	Garlic Bread	1	2	1
2605	5	CCOKE	Can of Coke	1	1.7	1
2606	1	LAU	Large Australian	1	12	1
2607	1	F	FAM	1	18	1
2607	2	HALF	1/2 CHICK	1	0	1
2607	3	MEX	1/2 MEXICAM	1	0	1
2608	1	CR	Calzone Rustico	1	10.5	1
2608	2	CSQSH	Can of Lemon Squash	1	1.7	1
2609	1	FSP	Family Special	1	17	1
2609	2	HALF	1/2CHI,HAM,CHEES,BAC	1	0	1
2609	3	FX	EXTRABBQ	1	1	1
2609	4	*NN*..	WELL DONE	0	0	1
2610	1	2L	2 Large Pizzas	1	19.9	1
2610	2	LSU	Large Supreme	0	0	1
2610	3	LVG	Large Vegetarian	0	0	1
2610	4	LX	EXTRAHAM,SALA	2	1.4	1
2610	5	NO	NoOLIVES,EASYON CAP	1	0	1
2611	1	PFM	FAMILY PICK-UP	1	12.9	1
2611	2	HALF	1/2 vegetarian	1	0	1
2611	3	HALF	1/2 lot little pepperoni little ham	1	0	1
2612	1	2F	2 Family Pizzas	1	25.9	1
2612	2	SEA	1/2 SEAFOOD	1	0	1
2612	3	SPE	1/2 SPECIAL x garlic	1	0	1
2612	4	SAN	1/2 SAN GIORGIO	1	0	1
2612	5	SUP	1/2 SUPREME	1	0	1
2613	1	STVP	Veal Parmigiana	1	14	1
2613	2	GB	Garlic Bread	1	2	1
2614	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2614	2	FSU	Family Supreme extra garlic	0	0	1
2615	1	2L	2 Large Pizzas	1	19.9	1
2615	2	SEA	1/2 SEAFOOD	1	0	1
2615	3	VEG	1/2 VEGETARIAN	1	0	1
2615	4	+	+ garlic all over	0	0	1
2615	5	LCH	Large Chicken Hawiian	0	0	1
2615	6	+	+ garlic	0	0	1
2616	1	LMA	Large Margherita	1	11.5	1
2616	2	LX	EXTRA olives on half	1	0.7	1
2616	3	FHW	Family Hawiian	1	16.5	1
2616	4	FX	EXTRA olives on one third	1	1	1
2616	5	GB	Garlic Bread	2	4	1
2616	6	GS	Greek Salad	2	11	1
2616	7	FS	French Salad	1	4	1
2617	1	LSE	Large Seafood	1	13.5	1
2617	2	NO	No anch	1	0	1
2617	3	LVG	Large Vegetarian	1	12.5	1
2617	4	GB	Garlic Bread	1	2	1
2618	1	CHAS	Chicken Asparagus	1	14	1
2618	2	DTA	Tartufo	3	10.5	1
2618	3	FMA	Family Margherita	1	15	1
2618	4	FX	EXTRA CHEESE	1	1	1
2620	1	CR	Calzone Rustico	1	10.5	1
2620	2	SCH	Small Chicken Hawiian	1	9.5	1
2621	1	L	LARGE	1	13.5	1
2621	2	HAW	1/2 HAWAIIN	1	0	1
2621	3	SAN	1/2 SAN GIORGIO	1	0	1
2621	4	GB	Garlic Bread	1	2	1
2622	1	2L	2 Large Pizzas	1	19.9	1
2622	2	LMX	Large Mexican	0	0	1
2622	3	LAM	Large American	0	0	1
2622	4	LSP	Large Special- MUS	1	12.5	1
2623	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2623	2	LSU	Large Supreme	0	0	1
2624	1	MFMA	Fettucini Marinara	1	11.5	1
2624	2	MMPU	Macaroni Putanesca	1	9.5	1
2624	3	GB	Garlic Bread	1	2	1
2625	1	MGW	Main Grilled Whiting	2	30	1
2625	2	NO	No DRESSING	1	0	1
2625	3	NO	No FAT AT ALL	1	0	1
2626	1	2L	2 Large Pizzas	1	19.9	1
2626	2	LSG	Large SanGiorgio	0	0	1
2626	3	LMX	Large Mexican	0	0	1
2627	1	2F	2 Family Pizzas	1	25.9	1
2627	2	FSP	Family Special ( BOTH )	0	0	1
2628	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2628	2	FSP	Family Special	0	0	1
2629	1	2L	2 Large Pizzas	1	19.9	1
2629	2	LSG	Large SanGiorgio	0	0	1
2629	3	LMA	Large Margherita	0	0	1
2629	4	LX	EXTRA TOMATO	1	0.7	1
2629	5	GS	Greek Salad	1	5.5	1
2629	6	DIS	Discount	1	-0.0999999999999979	1
2630	1	2L	2 Large Pizzas	1	19.9	1
2630	2	LSG	Large SanGiorgio	0	0	1
2630	3	LSG	Large SanGiorgio	0	0	1
2631	1	MTNA	Tortellini Napolitana	1	9	1
2631	2	GB	Garlic Bread	1	2	1
2632	1	MLA	Main Lasagna	1	9.5	1
2632	2	+	+ BOLOGNESES SAUCE	1	1	1
2632	3	DFS	Fruit Salad & Ice Cream	1	4.5	1
2633	1	2L	2 Large Pizzas	1	19.9	1
2633	2	LMX	Large Mexican	0	0	1
2633	3	L	LARGE CHICKEN+MUSHROOM	0	0	1
2633	4	DCM	Chocolate Mousse	1	3.5	1
2634	1	LHW	Large Hawiian	1	12.5	1
2634	2	MTPU	Tortellini Putanesca	1	9.5	1
2634	3	GB	Garlic Bread	1	2	1
2634	4	COKE	1.25 Ltr Coke	1	3	1
2635	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2635	2	LSG	Large SanGiorgio	0	0	1
2636	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2636	2	LSG	Large SanGiorgio NO SALAMI,NO ONION,NO CAPS	0	0	1
2636	3	LX	EXTRA CHICKEN,MUSH+BASIL	1	0.7	1
2637	1	SD	Soup of the Day	1	4.5	1
2637	2	STRMW	Rump Steak - Md Well Done	2	26	1
2637	3	GB	Garlic Bread	1	2	1
2637	4	CHIPS	Chips	1	3.5	1
2638	1	2L	2 Large Pizzas	1	19.9	1
2638	2	LMA	Large Margherita	0	0	1
2638	3	HALF	1/2 CHICK HAW	1	0	1
2638	4	HALF	1/2 SAN. G	1	0	1
2639	1	CHGR	Grilled Chicken	1	13	1
2639	2	CHIPS	Chips	3	10.5	1
2639	3	LHW	Large Hawiian	1	12.5	1
2639	4	GS	Greek Salad	1	5.5	1
2639	5	CHAV	Chicken Avocado	1	14	1
2639	6	CFANTA	Can of Fanta	3	5.1	1
2639	7	CCOKE	Can of Coke	2	3.4	1
2639	8	DGE	Gelati Cup PIST+COFFEE	1	4	1
2640	1	EMAL	Entree Macaroni Alfredo	1	7	1
2640	2	FS	French Salad NO OLIVES EX ONION	1	4	1
2640	3	CHHW	Chicken Hawiian	1	14	1
2640	4	GB	Garlic Bread	2	4	1
2641	1	2S	2 Small Pizzas	1	16.9	1
2641	2	SHW	Small Hawiian	0	0	1
2641	3	SSG	Small SanGiorgio	0	0	1
2642	1	S	SMALL BACON PEP	1	9.5	1
2643	1	STF	Fillet Mignon WELL DONE NO MUSHROOM SAUCE	2	34	1
2643	2	DIANE	DIANNE SAUCE	2	5.6	1
2643	3	GB	Garlic Bread	2	4	1
2644	1	STSH	Schnitzel	1	10.5	1
2645	1	F	FAM	1	18	1
2645	2	VEG	1/2 VEGETARIAN	1	0	1
2645	3	FX	EXTRA CHILLI	0	0	1
2645	4	MEX	1/2 MEXICAM	1	0	1
2646	1	EFP	Entree Fried Prawns	1	10	1
2646	2	CHAV	Chicken Avocado	1	14	1
2647	1	2L	2 Large Pizzas	1	19.9	1
2647	2	LVG	Large Vegetarian	0	0	1
2647	3	LSG	Large SanGiorgio	0	0	1
2648	1	2L	2 Large Pizzas	1	19.9	1
2648	2	LSP	Large Special NO CAPS	0	0	1
2648	3	LX	EXTRA PINE+CHILLI	0	0	1
2648	4	LSU	Large Supreme	0	0	1
2649	1	LPGC	Large Pizza, 1 Garlic Bread, 1.25 Coke	1	15.9	1
2649	2	LSE	Large Seafood	0	0	1
2649	3	MLA	Main Lasagna	1	9.5	1
2650	1	PC	Prawn Cocktail	1	7.2	1
2650	2	ESBO	Entree Spaghetti Bolognese	1	6.3	1
2650	3	GB	Garlic Bread	1	1.8	1
2650	4	DFS	Fruit Salad & Ice Cream	2	8.1	1
2650	5	DGE	Gelati Cup CHOC COFFEE	1	3.6	1
2650	6	SHW	Small Hawiian	1	8.1	1
2650	7	SX	EXTRA MUSH	1	0.45	1
2650	8	COKE	1.25 Ltr Coke	1	3	1
2650	9	EFC	Entree Fried Calamari	1	7.65	1
2650	10	NO	No SALAD WITH CHIPS INSTEAD AND TARTARE SAUCE	1	0	1
2651	1	MFAP	Fettucini Alla Panna	1	9	1
2651	2	CHAV	Chicken Avocado	1	12.6	1
2652	1	2F	2 Family Pizzas	1	25.9	1
2652	2	FSP	Family Special	0	0	1
2652	3	FSP	Family Special	0	0	1
2653	1	LML	Large Meat Lovers	1	13	1
2653	2	GB	Garlic Bread	1	2	1
2654	1	FCH	Family Chicken Hawiian	1	17.5	1
2655	1	2F	2 Family Pizzas	1	25.9	1
2655	2	FSU	Family Supreme	0	0	1
2655	3	NO	No SEAFOOD ON ONE OF THEM	1	0	1
2656	1	F	FAM	1	18	1
2656	2	HAW	1/2 HAWAIIN	1	0	1
2656	3	SUP	1/2 SUPREME NO ANCH NO OLIVES	1	0	1
2657	1	F	FAM POLLO	1	18	1
2657	2	SX	EXTRA FOR GOURMET	1	0.5	1
2657	3	FX	EXTRA FETTA	1	1	1
2657	4	FX	EXTRA FETTA	1	1	1
2657	5	GB	Garlic Bread	2	4	1
2658	1	L	LARGE	1	13.5	1
2658	2	SAN	1/2 SAN GIORGIO	1	0	1
2658	3	HAW	1/2 HAWAIIN	1	0	1
2659	1	ECNA	Entree Ricotta Ravioli Napoletana	1	7	1
2659	2	MLA	Main Lasagna	1	9.5	1
2659	3	GB	Garlic Bread	1	2	1
2661	1	MFP	Main Fried Prawns	1	16	1
2661	2	L	LARGE OLIVES MUSH AND PEP	1	13.5	1
2662	1	PLG	LARGE PICK-UP SPECIAL	1	9.9	1
2663	1	PLG	LARGE PICK-UP	1	9.9	1
2663	2	HAW	1/2 HAWAIIN	1	0	1
2663	3	MLO	1/2 MEAT LOVERS	1	0	1
2665	1	PLG	LARGE PICK-UP SAN GIORGIO	1	9.9	1
2665	2	NO	No OLIVES BUT WITH CHILLI	1	0	1
2666	1	PFM	FAMILY PICK-UP	1	12.9	1
2666	2	+	+ ONE QUARTER CHICK HAW	0	0	1
2666	3	+	+ THREE QUARTERS SUP	0	0	1
2667	1	MFCB	Fettucini Carbonara	1	10	1
2667	2	FS	French Salad	1	4	1
2667	3	GB	Garlic Bread	1	2	1
2668	1	2L	2 Large Pizzas	1	19.9	1
2668	2	LSU	Large Supreme	0	0	1
2668	3	LHW	Large Hawiian	0	0	1
2669	1	L	LARGE	1	13.5	1
2669	2	AME	1/2 AMERICAN	1	0	1
2669	3	SUP	1/2 SUPREME NO OLIVES	1	0	1
2669	4	HB	Herb Bread	1	2	1
2670	1	2L	2 Large Pizzas	1	19.9	1
2670	2	L	LARGE CHICK+CHEESE	0	0	1
2670	3	LML	Large Meat Lovers	0	0	1
2670	4	COKE	1.25 Ltr Coke	1	3	1
2671	1	PFM	FAMILY PICK-UP	1	12.9	1
2671	2	VEG	1/2 VEGETARIAN	1	0	1
2671	3	SUP	1/2 SUPREME	1	0	1
2672	1	F	FAM	1	18	1
2672	2	VEG	1/2 VEGETARIAN	1	0	1
2672	3	SUP	1/2 SUPREME NO SALAMI	1	0	1
2674	1	PFM	FAMILY PICK-UP	1	12.9	1
2674	2	FML	Family Meat Lovers	0	0	1
2675	1	PSM	SMALL PICK-UP	1	6.9	1
2675	2	SHW	Small Hawiian	0	0	1
2675	3	CCOKE	Can of Coke	1	1.7	1
2678	1	CV	Calzone Vegetarian	2	21	1
2678	2	COKE	1.25 Ltr Coke	1	3	1
2678	3	WATR	1.25 Ltr Water	1	5	1
2678	4	DAPC	Apple Pie with Cream and choc sauce on top	2	7	1
2678	5	DCM	Chocolate Mousse with whipped cream in a sep container	1	3.5	1
2678	6	CIGS	Cigarettes - bh extra mild	1	9.5	1
2678	7	DIS	Discount	1	1	1
2678	8	+	+ extra for choc sauce and whipped cream	1	0	1
2619	1	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20	1
2619	2	FAM	Family American	0	0	1
2619	3	FX	EXTRA	0	0.5	1
2619	4	L	LARGE	1	13.5	1
2619	5	S	SMALL	1	9.5	1
2619	6	F	FAM	1	18	1
2619	7	DIS	Discount	1	-0.5	1
2664	1	L	LARGE	1	13.5	1
2664	2	SUP	1/2 SUPREME	1	0	1
2664	3	MLO	1/2 MEAT LOVERS	1	0	1
2664	4	GB	Garlic Bread	1	2	1
2664	5	DIS	Discount	1	-0.5	1
1564	1	L	LARGE	1	13.5	1
1564	2	MLO	1/2 MEAT LOVERS	1	0	1
1564	3	BBQ	BBQ SauceALL OVER PIZZA	1	1	1
1564	4	SUP	1/2 SUPREME	1	0	1
1564	5	DIS	Discount	1	0.5	1
1145	1	LSU	Large Supreme	1	13.5	1
1145	2	BBQ	BBQ Sauce	1	1	1
1145	3	GB	Garlic Bread	1	2	1
1145	4	DIS	Discount	1	-1.5	1
2660	1	SSG	Small SanGiorgio	1	8.55	1
2660	2	SSE	Small Seafood	1	8.55	1
2660	3	DGE	Gelati Cup BACI WITH CREAM ON TOP	1	3.6	1
2660	4	DTA	Tartufo	1	3.15	1
2660	5	CIGS	Cigarettes ESCORT BLUE	1	8.6	1
2660	6	+	+ BOTTLE OF SOFT DRINK WHITE	1	15.5	1
2660	7	LAM	Large American	1	11.25	1
2660	8	LHW	Large Hawiian	1	11.25	1
2660	9	CAP	1/2 CAPRICIOSA	1	0	1
2660	10	SPE	1/2 SPECIAL	1	0	1
2660	11	MAR	1/2 MARGHERITA	1	0	1
2660	12	SAN	1/2 SAN GIORGIO	1	0	1
2660	13	SUP	1/2 SUPREME	1	0	1
2660	14	AME	1/2 AMERICAN	1	0	1
2660	15	HAW	1/2 HAWAIIN	1	0	1
2660	16	VEG	1/2 VEGETARIAN	1	0	1
2660	17	MEX	1/2 MEXICAM	1	0	1
2660	18	LCH	Large Chicken Hawiian	1	11.7	1
2660	19	L	LARGE	1	12.15	1
2660	20	CAP	1/2 CAPRICIOSA	1	0	1
2660	21	HAW	1/2 HAWAIIN	1	0	1
2660	22	LHW	Large Hawiian 1/2 capriciosa	1	11.25	1
2660	23	BBQ	BBQ Sauce	1	0.9	1
2660	24	DIS	Discount	1	-6.45	1
2677	1	LSG	Large SanGiorgio	1	13.5	1
2677	2	FMX	Family Mexican	1	17.5	1
2677	3	DCC	Cheese Cake	2	7	1
2677	4	COKE	1.25 Ltr Coke	1	3	1
2677	5	DIS	Discount	1	1	1
2677	6	DIS	Discount	1	1.5	1
2673	1	F	FAM	1	18	1
2673	2	SUP	1/2 SUPREME NO ANCH	1	0	1
2673	3	SUP	1/2 SUPREME NO ANCH OR OLIVES	1	0	1
2673	4	S	SMALL	1	9.5	1
2673	5	DCC	Cheese Cake	1	3.5	1
2673	6	DIS	Discount	1	7.5	1
\.
COPY ordhist FROM stdin;
2660	6	1	Fri May 15 01:43:24 1998 CST	+	+ BOTTLE OF SOFT DRINK WHITE	1	15.5
2660	5	1	Fri May 15 01:43:24 1998 CST	CIGS	Cigarettes ESCORT BLUE	1	8.6
2660	4	1	Fri May 15 01:43:24 1998 CST	DTA	Tartufo	1	3.15
2660	3	1	Fri May 15 01:43:24 1998 CST	DGE	Gelati Cup BACI WITH CREAM ON TOP	1	3.6
2660	2	1	Fri May 15 01:43:24 1998 CST	SSE	Small Seafood	1	8.55
2660	1	1	Fri May 15 01:43:24 1998 CST	SSG	Small SanGiorgio	1	8.55
2677	4	1	Fri May 15 02:20:39 1998 CST	DCC	Cheese Cake	1	3.5
2677	3	1	Fri May 15 02:20:39 1998 CST	F	FAM	1	18
2677	2	1	Fri May 15 02:20:39 1998 CST	S	SMALL	1	9.5
2677	1	1	Fri May 15 02:20:39 1998 CST	L	LARGE	1	13.5
2677	5	1	Fri May 15 02:26:09 1998 CST	DIS	Discount	1	1
2677	4	1	Fri May 15 02:26:09 1998 CST	COKE	1.25 Ltr Coke	1	3
2677	3	1	Fri May 15 02:26:09 1998 CST	DCC	Cheese Cake	2	7
2677	2	1	Fri May 15 02:26:09 1998 CST	FMX	Family Mexican	1	17.5
2677	1	1	Fri May 15 02:26:09 1998 CST	LSG	Large SanGiorgio	1	13.5
2677	8	1	Fri May 15 02:32:39 1998 CST	DIS	Discount	1	1.5
2677	7	1	Fri May 15 02:32:39 1998 CST	STP	Pepper Steak	1	15
2677	6	1	Fri May 15 02:32:39 1998 CST	FCH	Family Chicken Hawiian	1	17.5
2677	5	1	Fri May 15 02:32:39 1998 CST	DIS	Discount	1	1
2677	4	1	Fri May 15 02:32:39 1998 CST	COKE	1.25 Ltr Coke	1	3
2677	3	1	Fri May 15 02:32:39 1998 CST	DCC	Cheese Cake	2	7
2677	2	1	Fri May 15 02:32:39 1998 CST	FMX	Family Mexican	1	17.5
2677	1	1	Fri May 15 02:32:39 1998 CST	LSG	Large SanGiorgio	1	13.5
2678	7	1	Fri May 15 02:34:50 1998 CST	DIS	Discount	1	1
2678	6	1	Fri May 15 02:34:50 1998 CST	CIGS	Cigarettes - bh extra mild	1	9.5
2678	5	1	Fri May 15 02:34:50 1998 CST	DCM	Chocolate Mousse	1	3.5
2678	4	1	Fri May 15 02:34:50 1998 CST	DAPC	Apple Pie with Cream	2	7
2678	3	1	Fri May 15 02:34:50 1998 CST	WATR	1.25 Ltr Water	1	5
2678	2	1	Fri May 15 02:34:50 1998 CST	COKE	1.25 Ltr Coke	1	3
2678	1	1	Fri May 15 02:34:50 1998 CST	CV	Calzone Vegetarian	2	21
2678	8	1	Fri May 15 02:39:40 1998 CST	+	+ extra for choc sauce and whipped cream	1	5
2678	7	1	Fri May 15 02:39:40 1998 CST	DIS	Discount	1	1
2678	6	1	Fri May 15 02:39:40 1998 CST	CIGS	Cigarettes - bh extra mild	1	9.5
2678	5	1	Fri May 15 02:39:40 1998 CST	DCM	Chocolate Mousse with whipped cream in a sep container	1	3.5
2678	4	1	Fri May 15 02:39:40 1998 CST	DAPC	Apple Pie with Cream and choc sauce on top	2	7
2678	3	1	Fri May 15 02:39:40 1998 CST	WATR	1.25 Ltr Water	1	5
2678	2	1	Fri May 15 02:39:40 1998 CST	COKE	1.25 Ltr Coke	1	3
2678	1	1	Fri May 15 02:39:40 1998 CST	CV	Calzone Vegetarian	2	21
2619	4	1	Sat May 16 01:49:46 1998 CST	FX	EXTRA	0.5	0.5
2619	3	1	Sat May 16 01:49:46 1998 CST	--	1/2 + MUS	0	0
2619	2	1	Sat May 16 01:49:46 1998 CST	FAM	Family American	0	0
2619	1	1	Sat May 16 01:49:46 1998 CST	FPGC	Family Pizza,  2 Garlic Bread, 1.25 Coke	1	20
2673	3	1	Sat May 16 23:51:50 1998 CST	SUP	1/2 SUPREME NO ANCH OR OLIVES	1	0
2673	2	1	Sat May 16 23:51:50 1998 CST	SUP	1/2 SUPREME NO ANCH	1	0
2673	1	1	Sat May 16 23:51:50 1998 CST	F	FAM	1	18
2664	4	1	Sun May 17 00:46:49 1998 CST	GB	Garlic Bread	1	2
2664	3	1	Sun May 17 00:46:49 1998 CST	MLO	1/2 MEAT LOVERS	1	0
2664	2	1	Sun May 17 00:46:49 1998 CST	SUP	1/2 SUPREME	1	0
2664	1	1	Sun May 17 00:46:49 1998 CST	L	LARGE	1	13.5
1564	4	1	Sun May 17 00:47:00 1998 CST	SUP	1/2 SUPREME	1	0
1564	3	1	Sun May 17 00:47:00 1998 CST	BBQ	BBQ SauceALL OVER PIZZA	1	1
1564	2	1	Sun May 17 00:47:00 1998 CST	MLO	1/2 MEAT LOVERS	1	0
1564	1	1	Sun May 17 00:47:00 1998 CST	L	LARGE	1	13.5
1145	3	1	Sun May 17 00:47:12 1998 CST	GB	Garlic Bread	1	2
1145	2	1	Sun May 17 00:47:12 1998 CST	BBQ	BBQ Sauce	1	1
1145	1	1	Sun May 17 00:47:12 1998 CST	LSU	Large Supreme	1	13.5
2660	6	1	Sun May 17 01:07:15 1998 CST	+	+ BOTTLE OF SOFT DRINK WHITE	1	15.5
2660	5	1	Sun May 17 01:07:15 1998 CST	CIGS	Cigarettes ESCORT BLUE	1	8.6
2660	4	1	Sun May 17 01:07:15 1998 CST	DTA	Tartufo	1	3.15
2660	3	1	Sun May 17 01:07:15 1998 CST	DGE	Gelati Cup BACI WITH CREAM ON TOP	1	3.6
2660	2	1	Sun May 17 01:07:15 1998 CST	SSE	Small Seafood	1	8.55
2660	1	1	Sun May 17 01:07:15 1998 CST	SSG	Small SanGiorgio	1	8.55
2677	8	1	Sun May 17 02:08:58 1998 CST	DIS	Discount	1	1.5
2677	7	1	Sun May 17 02:08:58 1998 CST	STP	Pepper Steak	1	15
2677	6	1	Sun May 17 02:08:58 1998 CST	FCH	Family Chicken Hawiian	1	17.5
2677	5	1	Sun May 17 02:08:58 1998 CST	DIS	Discount	1	1
2677	4	1	Sun May 17 02:08:58 1998 CST	COKE	1.25 Ltr Coke	1	3
2677	3	1	Sun May 17 02:08:58 1998 CST	DCC	Cheese Cake	2	7
2677	2	1	Sun May 17 02:08:58 1998 CST	FMX	Family Mexican	1	17.5
2677	1	1	Sun May 17 02:08:58 1998 CST	LSG	Large SanGiorgio	1	13.5
2673	8	1	Sun May 17 02:10:57 1998 CST	DIS	Discount	1	7.5
2673	7	1	Sun May 17 02:10:57 1998 CST	DCC	Cheese Cake	1	3.5
2673	6	1	Sun May 17 02:10:57 1998 CST	S	SMALL	1	9.5
2673	5	1	Sun May 17 02:10:57 1998 CST	F	FAM	1	18
2673	4	1	Sun May 17 02:10:57 1998 CST	L	LARGE	1	13.5
2673	3	1	Sun May 17 02:10:57 1998 CST	SUP	1/2 SUPREME NO ANCH OR OLIVES	1	0
2673	2	1	Sun May 17 02:10:57 1998 CST	SUP	1/2 SUPREME NO ANCH	1	0
2673	1	1	Sun May 17 02:10:57 1998 CST	F	FAM	1	18
\.
CREATE UNIQUE INDEX stores_id on stores using btree ( id int2_ops );
CREATE UNIQUE INDEX user_name on users using btree ( username text_ops );
CREATE UNIQUE INDEX emp_code on employee using btree ( emp_code text_ops );
CREATE  INDEX emp_time on emp_times using btree ( emp_code text_ops );
CREATE  INDEX emp_pay_emp on emp_pay using btree ( emp_code text_ops );
CREATE UNIQUE INDEX cust_num on customers using btree ( custnum int4_ops );
CREATE UNIQUE INDEX category_code on category using btree ( code char_ops );
CREATE UNIQUE INDEX item_code on items using btree ( code text_ops );
CREATE UNIQUE INDEX suburbs_sub on suburbs using btree ( suburb text_ops );
CREATE  INDEX orders_cust on orders using btree ( custnum int4_ops );
CREATE  INDEX ordet_order on ordet using btree ( ordernum int4_ops );
CREATE  INDEX orders_num on orders using btree ( ordernum int4_ops );
